#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1560723984934899b9bf4496f3b68ced32fab99c";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"errormessages\" as errormessages",
  "",
  "var blankLocation := 0",
  "var lastLine := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var tokens := false",
  "var values := list.empty",
  "var comments := list.empty",
  "var auto_count := 0",
  "def noBlocks = false",
  "def blocksOK = true",
  "var braceIsType := false",
  "var defaultDefVisibility := \"confidential\"",
  "var defaultVarVisibility := \"confidential\"",
  "var defaultMethodVisibility := \"public\"",
  "def emptySequence = sequence.empty",
  "",
  "// sym is a module-level field containing the current token",
  "var sym := object {",
  "    def kind is public = \"start\"",
  "    def line is public = 0",
  "    def linePos is public = 0",
  "    def indent is public = 0",
  "    def value is public = \"\"",
  "    def size is public = 0",
  "}",
  "",
  "var lastToken := sym",
  "var previousCommentToken := lastToken",
  "var statementToken := lastToken",
  "var comment := false",
  "",
  "method noteBlank {",
  "    blankLocation := sym.line - 1",
  "}",
  "",
  "var firstCallOfNext := true",
  "",
  "method next {",
  "    // Advance to the next token in the stream, assigning it to sym.",
  "    // Put the position in the input into util module variables.",
  "",
  "    if (tokens.size > 0) then {",
  "        lastToken := sym",
  "        lastLine := lastToken.line",
  "        lastIndent := lastToken.indent",
  "        sym := tokens.poll",
  "        if (sym.line > (lastLine + 1)) then { noteBlank }",
  "        pushcomments",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } else {",
  "        errormessages.syntaxError(\"Unexpectedly found the end of the input. \" ",
  "            ++ \"This is often caused by a missing '\\}'\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "    }",
  "}",
  "",
  "",
  "method findNextToken(tokenMatcher) {",
  "    // Search for the next token for which the given block returns true.",
  "    // Used for generating suggestions.",
  "",
  "    if (tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }.andAlso { n.indent >= lastToken.indent }} do {",
  "        if(tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if(((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }} do {",
  "        if(((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(*validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = set.with(\"dot\", \"comma\", \"colon\", \"rparen\",",
  "            \"rbrace\", \"rsquare\", \"arrow\", \"bind\");",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if(validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if(!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "// Finds the closing brace for token (that is the beginning of a control",
  "// structure) -- an opening brace. Returns an object with two fields: found",
  "// and tok. If a closing brace is found, found is set to true, and tok is set to",
  "// the closing brace. Otherwise found is set to false, and tok is set to the",
  "// token that the closing brace should appear after.",
  "method findClosingBrace(token, inserted) {",
  "    var n := sym",
  "    var numOpening := if(inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found is public",
  "        var tok is public",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == token.line)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif(n.kind == \"rbrace\") then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > token.indent)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif(n.kind == \"rbrace\") then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    if(n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif((n.prev.kind == \"rbrace\") && (numOpening == numClosing)) then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "// True if the current token (next to be processed) is a t, where",
  "// t is \"num\", \"string\", \"method\", etc.",
  "method accept(t) {",
  "    sym.kind == t",
  "}",
  "",
  "// True if the current token is a t, and it is on the same logical",
  "// line (either because it's on the same physical line, or because",
  "// it's on an indented continuation line).",
  "method acceptSameLine(t) {",
  "    (sym.kind == t) && ((lastLine == sym.line) ||",
  "        (sym.indent > lastIndent))",
  "}",
  "",
  "// True if the current token is a t, and it is on the same logical",
  "// line as a provided token.",
  "method accept(t)onLineOf(other) {",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "// True if the current token is a t, and it is on the same logical",
  "// line as a provided token.",
  "method accept(t)onLineOfLastOr(other) {",
  "    (sym.kind == t) && (((other.line == sym.line) ||",
  "        (sym.indent > other.indent)) || (lastToken.line == sym.line))",
  "}",
  "// True if there is a token on the same logical line",
  "method tokenOnSameLine {",
  "    (lastLine == sym.line) || (sym.indent > lastIndent)",
  "}",
  "// Check if block did consume at least one token.",
  "method didConsume(ablock) {",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    tokens.size != sz",
  "}",
  "// Expect block to consume at least one token, or call fallback code.",
  "method ifConsume(ablock)then(tblock) {",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    if (tokens.size != sz) then {",
  "        tblock.apply",
  "    }",
  "}",
  "",
  "// Push the current token onto the output stack as a number",
  "method pushnum {",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an octet literal",
  "method pushoctets {",
  "    var o := ast.octetsNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as a string",
  "method pushstring {",
  "    var o := ast.stringNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.identifierNode.new(sym.value, false)",
  "    if (o.value == \"_\") then {",
  "        o.value := \"__\" ++ auto_count",
  "        o.wildcard := true",
  "        auto_count := auto_count + 1",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method adjustVisibilityOf(node) withSpecialDefault(sd) overriding(nd) {",
  "    // If a compiler directive has set a special default visibility, then",
  "    // translate this into an annotation.  The normal defaults are dealt with",
  "    // by methods on the ast nodes.",
  "    if (sd == nd) then { return done }",
  "    for (node.annotations) do {a->",
  "        if (a.kind == \"identifier\") then",
  "        {   if (a.value == \"public\") then { return done }",
  "            if (a.value == \"readable\") then { return done }",
  "            if (a.value == \"confidential\") then { return done }",
  "            if (a.value == \"writable\") then { return done }",
  "        }",
  "    }",
  "    def newAnn = ast.identifierNode.new(sd, false)",
  "    node.annotations.push(newAnn)",
  "}",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.with) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\").andAlso {a.dtype != false}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"An argument to an annotation cannot have a type.\")atRange(",
  "                        tok.line, tok.linePos, tok.next.linePos + tok.next.size - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if ((!accept(\"keyword\")).orElse {sym.value != \"is\"}) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = list.empty",
  "    if(didConsume({expression(noBlocks)}).not) then {",
  "        def suggestions = list.empty",
  "        var suggestion := errormessages.suggestion.new",
  "        def nextTok = findNextValidToken(\"bind\")",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "        }",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "        suggestions.push(suggestion)",
  "        errormessages.syntaxError(\"One or more annotations separated by commas must follow 'is'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"bind\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"One or more annotations separated by commas must follow 'is'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "    }",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method blank {",
  "    if (blankLocation == 0) then {",
  "        if ( sym.line <= (lastToken.line + 1) ) then { return }",
  "        if ( sym.line <= (previousCommentToken.line + 1) ) then { return }",
  "    }",
  "    pushcomments",
  "    if ((values.size == 0) || ",
  "            ((values.size > 0).andAlso { values.last.kind != \"blank\" })) then {",
  "        if (blankLocation > 0) then {",
  "            util.setPosition(blankLocation, 0)",
  "            blankLocation := 0",
  "        } else {",
  "            util.setPosition(sym.line - 1, 0)",
  "        }",
  "        values.push(ast.blankNode.new)",
  "    }",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept(\"identifier\")) then {",
  "        pushidentifier",
  "        generic",
  "        dotrest(noBlocks)",
  "    } else {",
  "        if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "            dotypeLiteral",
  "        }",
  "    }",
  "}",
  "",
  "method typeexpression {",
  "    var sz := values.size",
  "    if (accept(\"lparen\")) then {",
  "        def prevStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if(didConsume({typeexpression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«type expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«type expression»\")",
  "            }",
  "            errormessages.syntaxError(\"Parentheses must contain a valid type expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A type expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        statementToken := prevStatementToken",
  "        next",
  "    } else {",
  "        dotypeterm",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(noBlocks)",
  "        typeexpressionrest",
  "    }",
  "    // TODO: check that the expression doesn't contain requests or var references.",
  "    // This has to happen in the identifier resolution phase.",
  "}",
  "",
  "method newIf(cond, thenList, elseList) {",
  "    def thenBlock = ast.blockNode.new(emptySequence, thenList)",
  "    def elseBlock = ast.blockNode.new(emptySequence, elseList)",
  "    ast.ifNode.new(cond, thenBlock, elseBlock)",
  "}",
  "",
  "// Accept a block",
  "method block {",
  "    if (accept(\"lbrace\")) then {",
  "        def btok = sym",
  "        next",
  "        var minInd := statementIndent + 1",
  "        var startIndent := statementIndent",
  "        var expr1",
  "        var s := sym",
  "        var tmp",
  "        var params := list.empty",
  "        var body := list.empty",
  "        var havearrow := true",
  "        var found := false",
  "        var i := 0",
  "        var isMatchingBlock := false",
  "        statementToken := sym",
  "        if (sym.kind == \"lparen\") then {",
  "            isMatchingBlock := true",
  "        }",
  "        // Parsing the expression ‹(a)› will return an identifierNode‹a› .",
  "        // The paren lets us distinguish parameter ‹a› from pattern ‹(a)› .",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (accept(\"comma\") || accept(\"arrow\") || accept(\"colon\")) then {",
  "                // This block has parameters or patterns",
  "                expr1 := values.pop",
  "                if (accept(\"colon\")) then {",
  "                    // We allow an expression here for the case of v : T",
  "                    // patterns, where T may be \"Pair(hd, tl)\" or similar.",
  "                    next",
  "                    braceIsType := true",
  "                    if(didConsume({expression(blocksOK)}).not) then {",
  "                        def suggestions = list.empty",
  "                        var suggestion := errormessages.suggestion.new",
  "                        def nextTok = findNextValidToken(\"arrow\", \"rbrace\")",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                        }",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"A block must have an expression after the ':'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestions(suggestions)",
  "                    }",
  "                    braceIsType := false",
  "                    expr1.dtype := values.pop",
  "                }",
  "                params.push(expr1)",
  "                if (isMatchingBlock.not && expr1.isIdentifier) then {",
  "                    expr1.isBindingOccurrence := true",
  "                } else {",
  "                    isMatchingBlock := true",
  "                }",
  "                if (isMatchingBlock && {accept(\"comma\")}) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion",
  "                    def arrow = findNextToken({ t -> t.kind == \"arrow\" })",
  "                    if(arrow != false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, arrow.prev)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" |\")",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A matching block may only have one parameter.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                while {accept(\"comma\")} do {",
  "                    // Keep doing the above for the rest of the parameters.",
  "                    next",
  "                    pushidentifier",
  "                    expr1 := values.pop",
  "                    expr1.isBindingOccurrence := true",
  "                    expr1.dtype := optionalTypeAnnotation",
  "                    params.push(expr1)",
  "                }",
  "                if ((accept(\"arrow\")).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "                        suggestion.replaceToken(sym)with(\"->\")",
  "                    } else {",
  "                        suggestion.insert(\" ->\")afterToken(lastToken)",
  "                    }",
  "                    errormessages.syntaxError(\"A block must have one or more parameters followed by '->' and an expression.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                next",
  "            } elseif (accept(\"semicolon\")) then {",
  "                body.push(values.pop)",
  "                next",
  "                if (accept(\"semicolon\")) then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } elseif (((values.last.kind == \"member\")",
  "                || (values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var lhs := values.pop",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rbrace\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var rhs := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                body.push(ast.bindNode.new(lhs, rhs))",
  "                if (accept(\"semicolon\")) then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } else {",
  "                checkUnexpectedTokenAfterStatement",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        if (accept(\"arrow\")) then {",
  "            next",
  "        }",
  "        if (sym.line == lastToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := minInd",
  "        }",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // Take the body of the block",
  "            if(didConsume({statement}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"}\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A block must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            tmp := values.pop",
  "            body.push(tmp)",
  "        }",
  "        minIndentLevel := minInd - 1",
  "        statementIndent := startIndent",
  "        next",
  "        util.setPosition(btok.line, btok.linePos)",
  "        var o := ast.blockNode.new(params, body)",
  "        if (isMatchingBlock) then {",
  "            if (params.size > 0) then {",
  "                o.matchingPattern := params.first",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        next",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" («expression») then \\{\")afterToken(btok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif(nextTok.kind == \"lbrace\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" («expression») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if(nextTok == false) then {",
  "                nextTok := findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atRange(",
  "                        sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        // These two are for else/elseif handling. elseif is turned into",
  "        // nested if statements for the AST, so curelse points to the",
  "        // most deeply-nested of those (where any eventual \"else\" block's",
  "        // statements will go). elseblock contains the statements of the",
  "        // top-level \"else\" block - if there are any elseifs, that",
  "        // consists of only one statement, another if.",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 1",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            next",
  "            if(sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"An if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if(didConsume({statement}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"An if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                statementToken := sym",
  "                next",
  "                def opener = if ((sym.kind == \"lparen\").orElse{sym.kind == \"lbrace\"}) ",
  "                                then { sym.value } else { \"-missing-\" }",
  "                def closer = if (opener == \"(\") then { \")\" }",
  "                                else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "                if (opener == \"-missing-\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if(nextTok == false) then {",
  "                        suggestion.insert(\" («expression») then \\{\")afterToken(statementToken)",
  "                    } elseif(nextTok.kind == \"rparen\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                        }",
  "                    } elseif(nextTok.kind == \"lbrace\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" («expression») then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif(nextTok.kind == \"identifier\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        ((t.kind == \"rparen\") || (t.kind == \"rbrace\"))})",
  "                    if(nextTok == false) then {",
  "                        nextTok := findNextValidToken(\"rparen\")",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if(sym.value != closer) then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An expression beginning with a '{opener}' must end with a '{closer}'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if ((accept(\"identifier\") &&",
  "                    (sym.value == \"then\"))) then {",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"An elseif statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := newIf(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                next",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"An else statement must have a '\\{' after the 'else'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"An else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            util.setPosition(btok.line, btok.linePos)",
  "            var o := newIf(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"An if statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\" specially by",
  "// passing it to the method above.",
  "method identifier {",
  "    if (accept(\"identifier\")) then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    if (accept(\"op\")) then {",
  "        var op := sym.value",
  "        var val",
  "        next",
  "        if (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"Parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if(lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"A prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "        val := values.pop",
  "        var mem := ast.memberNode.new(\"prefix\" ++ op, val)",
  "        var call := ast.callNode.new(mem, [ast.callWithPart.new(mem.value)])",
  "        values.push(call)",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept(\"lgeneric\")) then {",
  "        def id = values.pop",
  "        def gens = list.empty",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                def memberNd = ast.memberNode.new(memberName.value, memberIn)",
  "                memberNd.line := memberName.line",
  "                memberNd.linePos := memberName.linePos",
  "                values.push(memberNd)",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept(\"comma\")) then {",
  "                next",
  "            } else {",
  "                if(sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"A type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"A type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept(\"identifier\") && (sym.value == \"try\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    if (accept(\"lbrace\")) then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rbrace\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(catchTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"A try-catch statement starts with a \"",
  "                ++ \"'try' and then zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A try-finally statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    util.setPosition(catchTok.line, catchTok.linePos)",
  "    values.push(ast.catchCaseNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method catchcase { // TODO: This construct is DEPRECATED. Remove it.",
  "    if (!(accept(\"identifier\") && (sym.value == \"catch\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    util.warning(\"The catch-case statement is deprecated and will be \"",
  "        ++ \"removed in a future version of the compiler. Use try-catch \"",
  "        ++ \"instead.\")",
  "    if (accept(\"lbrace\")) then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or case.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rbrace\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    util.setPosition(catchTok.line, catchTok.linePos)",
  "    values.push(ast.catchCaseNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if(sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if(nextTok == false) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif(nextTok.kind == \"rparen\") then {",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif(nextTok.kind == \"identifier\") then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"A match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if(didConsume({expression(blocksOK)}).not) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken(\"rparen\")",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"A match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    var elsecase := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = list.empty",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "//    if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "//        next",
  "//        if (accept(\"lbrace\")) then {",
  "//            block",
  "//        } elseif (accept(\"lparen\")) then {",
  "//            next",
  "//            if(didConsume({expression(blocksOK)}).not) then {",
  "//                def suggestion = errormessages.suggestion.new",
  "//                def nextTok = findNextValidToken(\"rparen\")",
  "//                if(nextTok == sym) then {",
  "//                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "//                } else {",
  "//                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "//                }",
  "//                errormessages.syntaxError(\"A match statement must have either a block or an expression in parentheses after the 'else'.\")atPosition(",
  "//                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "//            }",
  "//            if(sym.kind != \"rparen\") then {",
  "//                checkBadOperators",
  "//                def suggestion = errormessages.suggestion.new",
  "//                suggestion.insert(\")\")afterToken(lastToken)",
  "//                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "//                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "//            }",
  "//            next",
  "//        } else {",
  "//            def suggestions = list.empty",
  "//            def nextTok = findNextTokenIndentedAt(lastToken)",
  "//            var suggestion := errormessages.suggestion.new",
  "//            if(nextTok == false) then {",
  "//                suggestion.insert(\" }\")afterToken(tokens.first)",
  "//                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            } elseif(nextTok == sym) then {",
  "//                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//                suggestion := errormessages.suggestion.new",
  "//                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            } else {",
  "//                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "//                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            }",
  "//            errormessages.syntaxError(\"A match statement must have either a block or an expression in parentheses after the 'else'.\")atPosition(",
  "//                sym.line, sym.linePos)withSuggestions(suggestions)",
  "//        }",
  "//        elsecase := values.pop",
  "//    }",
  "    util.setPosition(matchTok.line, matchTok.linePos)",
  "    values.push(ast.matchCaseNode.new(matchee, cases, elsecase))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept(\"num\")) then {",
  "        pushnum",
  "    } elseif (accept(\"string\")) then {",
  "        pushstring",
  "    } elseif (accept(\"octets\")) then {",
  "        pushoctets",
  "    } elseif(accept(\"identifier\") && (sym.value == \"match\")) then {",
  "        matchcase",
  "    } elseif(accept(\"identifier\") && (sym.value == \"catch\")) then {",
  "        catchcase",
  "    } elseif(accept(\"identifier\") && (sym.value == \"try\")) then {",
  "        trycatch",
  "    } elseif (accept(\"identifier\")) then {",
  "        identifier",
  "    } elseif (accept(\"keyword\") && (sym.value == \"object\")) then {",
  "        doobject",
  "    } elseif (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "        dotypeLiteral",
  "    } elseif (accept(\"lbrace\")) then {",
  "        block",
  "    } elseif (accept(\"lsquare\")) then {",
  "        doarray",
  "    } elseif (accept(\"op\")) then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression(acceptBlocks) {",
  "    var sz := values.size",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept(\"lparen\")) then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        util.setPosition(sym.line, sym.linePos)",
  "        next",
  "        if(didConsume({expression(acceptBlocks)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"Parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        valueexpressionrest",
  "    }",
  "}",
  "",
  "// Accept postcircumfix square brackets (as in x[y]) and replace the",
  "// preceding expression with an index node into itself.",
  "method postfixsquare {",
  "    if (acceptSameLine(\"lsquare\")) then {",
  "        next",
  "        var expr := values.pop",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rsquare\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«index»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«index»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            if(nextTok.kind == \"rsquare\") then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        var index := values.pop",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var o := ast.indexNode.new(expr, index)",
  "        values.push(o)",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif (o == \"/\") then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "",
  "method typeexpressionrest {",
  "    if (acceptSameLine(\"op\")) then {",
  "        expressionrest \"type expression\" recursingWith {typeexpression} blocks (noBlocks)",
  "    }",
  "}",
  "",
  "method valueexpressionrest {",
  "    if (accept(\"op\")) then {",
  "        expressionrest \"expression\" recursingWith {expression(blocksOK)} blocks (blocksOK)",
  "    }",
  "}",
  "",
  "method expressionrest(name) recursingWith (recurse) blocks (acceptBlocks) {",
  "    // Process the rest of an operator expression using the shunting-yard",
  "    // algorithm. This method uses the oprec and toprec methods above to",
  "    // ensure the correct precedence, and treats all operators as",
  "    // left-associative.  It is parametrised so that it",
  "    // can be used for both type- and value- expressions.",
  "    var terms := [] // List of operands yet to be used",
  "    var ops := [] // Operator stack",
  "    var o",
  "    var o2",
  "    var tmp2",
  "    var tmp := values.pop",
  "    terms.push(tmp)",
  "    var prec",
  "    var allarith := true // Consists only of arithmetic operators",
  "    var opcount := 0",
  "    var opdtype := \"\" // The single operator being used in this expression",
  "    while {accept(\"op\")onLineOfLastOr(statementToken).andAlso",
  "            {sym.value != \"=\"}} do {",
  "        opcount := opcount + 1",
  "        o := sym.value",
  "        next",
  "        prec := oprec(o)",
  "        if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "            allarith := false",
  "        }",
  "        if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "            // If: this is not the first operator, it is not the same",
  "            // as the last operator, and the expression has not been",
  "            // entirely arithmetic, raise a syntax error.",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(sym)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken.prev)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"An expression containing both arithmetic and non-arithmetic operators requires parentheses.\")atPosition(",
  "                lastToken.prev.line, lastToken.prev.linePos)withSuggestions(suggestions)",
  "        }",
  "        opdtype := o",
  "        while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "            // Do the shunting: for as long as the current operator",
  "            // has lesser or equal precedence than the one on the",
  "            // top of the stack, take the operator off the stack and",
  "            // replace its two operands with the combined operator node.",
  "            // This corresponds to left-associative operators only.",
  "            o2 := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            util.setPosition(tmp.line, tmp.linePos)",
  "            tmp := ast.opNode.new(o2, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        ops.push(o)",
  "        if (accept(\"lparen\")) then {",
  "            // When a parenthesis is found, take an expression from",
  "            // *within* the parentheses and add it to the stack. Do",
  "            // not delegate entirely to expression, because it will",
  "            // then consume all the following operators and break",
  "            // precedence. Possibly parenthesised expressions could",
  "            // be allowed in term above?",
  "            next",
  "            if(didConsume(recurse).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«{name}»\")",
  "                }",
  "                errormessages.syntaxError(\"Parentheses must contain a valid {name}.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (!tokenOnSameLine) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \" ++ util.lines[sym.line])afterToken(lastToken)",
  "                suggestion.deleteLine(sym.line)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"comma\", \"rparen\", \"rsquare\", \"rbrace\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «{name}»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A valid {name} must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "",
  "        // Regardless of where the last value came from, it may have",
  "        // method invocations, indexes, or method call happening to it,",
  "        // which should be applied and the result put into the operands",
  "        // list.",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        tmp := values.pop",
  "        terms.push(tmp)",
  "    }",
  "    while {ops.size > 0} do {",
  "        // Shunt off any remaining operators at the end",
  "        o := ops.pop",
  "        tmp2 := terms.pop",
  "        tmp := terms.pop",
  "        util.setPosition(tmp.line, tmp.linePos)",
  "        tmp := ast.opNode.new(o, tmp, tmp2)",
  "        terms.push(tmp)",
  "    }",
  "    tmp := terms.pop",
  "    values.push(tmp)",
  "    if (terms.size > 0) then {",
  "        errormessages.syntaxError(\"Values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "// Accept a member lookup with \".\". This consumes the dot and",
  "// a following identifier, and will pass along to further lookups or",
  "// method calls on the result.",
  "method dotrest(acceptBlocks) {",
  "    if (acceptSameLine(\"dot\")) then {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept(\"identifier\")) then {",
  "            util.setPosition(sym.line, sym.linePos)",
  "            var dro := ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept(\"dot\")) then {",
  "                dotrest(acceptBlocks)",
  "            } elseif (accept(\"lparen\") || (acceptBlocks && accept(\"lbrace\"))",
  "                || accept(\"num\") || accept(\"string\") || accept(\"lsquare\")",
  "                || accept(\"lgeneric\")",
  "                ) then {",
  "                callrest(acceptBlocks)",
  "            }",
  "        } else {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Accept a method invocation indicated by parentheses. Unparenthesised",
  "// method calls are left as \"member\" AST nodes and processed correctly at",
  "// a later stage.",
  "method callrest(acceptBlocks) {",
  "    if (values.size == 0) then {",
  "        return 0",
  "    }",
  "    var meth := values.pop",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return 0",
  "        }",
  "    }",
  "    def lnum = meth.line",
  "    def lpos = meth.linePos",
  "    var methn := meth.value",
  "    def btok = sym",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var signature := []",
  "    var part := ast.callWithPart.new",
  "    signature.push(part)",
  "    var hadcall := false",
  "    var tok := lastToken",
  "    var startInd := minIndentLevel",
  "    var genericIdents := false",
  "    if (acceptSameLine \"lgeneric\") then {",
  "        genericIdents := typeArgs",
  "    }",
  "    if (acceptSameLine(\"lparen\")) then {",
  "        part.line := sym.line",
  "        part.linePos := sym.linePos",
  "        part.name := methn",
  "        tok := sym",
  "        hadcall := true",
  "        parenthesizedArg(part)",
  "    } elseif (acceptBlocks.not && {accept(\"lbrace\")onLineOf(tok)}) then {",
  "        values.push(meth)",
  "    } elseif (accept(\"string\")onLineOf(tok) || accept(\"num\")onLineOf(tok)",
  "        || accept(\"lbrace\")onLineOf(tok)",
  "        || (accept(\"identifier\")onLineOf(tok) && ((sym.value == \"true\")",
  "                                   || (sym.value == \"false\")))) then {",
  "        tok := sym",
  "        hadcall := true",
  "        part.name := methn",
  "        term",
  "        var ar := values.pop",
  "        part.args.push(ar)",
  "    } elseif (meth.kind == \"identifier\") then {",
  "        values.push(meth)",
  "    } elseif (meth.kind == \"member\") then {",
  "        var root := meth.in",
  "        var outroot := meth",
  "        while {root.kind == \"member\"} do {",
  "            outroot := root",
  "            root := root.in",
  "        }",
  "        if (root.kind == \"identifier\") then {",
  "            values.push(meth)",
  "        } else {",
  "            meth.generics := genericIdents",
  "            values.push(meth)",
  "        }",
  "    }",
  "    if (hadcall) then {",
  "        if (accept(\"identifier\")onLineOfLastOr(tok)) then {",
  "            // Multi-part method name",
  "            def meth' = ast.identifierNode.new(methn, false)",
  "            meth'.line := lnum",
  "            meth'.linePos := lpos",
  "            methn := callmprest(meth', signature, tok)",
  "            if (meth.kind == \"member\") then {",
  "                // callmprest loses this information, so restore",
  "                // the member lookup (for x.between(3)and(10)-type",
  "                // calls).",
  "                meth := ast.memberNode.new(methn.value, meth.in)",
  "                meth.line := methn.line",
  "                meth.linePos := methn.linePos",
  "            } else {",
  "                meth := methn",
  "            }",
  "        }",
  "        util.setline(lnum)",
  "        def call = ast.callNode.new(meth, signature)",
  "        call.generics := genericIdents",
  "        values.push(call)",
  "    } elseif {genericIdents != false} then {",
  "        meth.generics := genericIdents",
  "    }",
  "    minIndentLevel := startInd",
  "    dotrest(acceptBlocks)",
  "}",
  "",
  "method parenthesizedArg(part) {",
  "    next",
  "    ifConsume {expression(blocksOK)} then {",
  "        // For matching blocks - same as below",
  "        if (accept(\"colon\")) then {",
  "            def expr = values.pop",
  "            if (expr.kind != \"identifier\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                if(sym.next.kind == \"identifier\") then {",
  "                    suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                checkBadTypeLiteral",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            expr.dtype := values.pop",
  "            values.push(expr)",
  "        }",
  "        while {accept(\"comma\")} do {",
  "            part.args.push(values.pop)",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A method request must have an expression after a ','.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            // For matching blocks - same as above",
  "            if (accept(\"colon\")) then {",
  "                def arg = values.pop",
  "                if (arg.kind != \"identifier\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.next.kind == \"identifier\") then {",
  "                        suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    checkBadTypeLiteral",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                arg.dtype := values.pop",
  "                values.push(arg)",
  "            }",
  "        }",
  "        part.args.push(values.pop)",
  "    }",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"A method request beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    if (sym.line == part.line) then {",
  "        part.lineLength := sym.linePos - part.linePos",
  "    }",
  "    next",
  "}",
  "",
  "method typeArgs {",
  "    // Parse one or more type arguments, if present, and answer them as a list.",
  "    def startToken = sym",
  "    def args = list.empty",
  "    if (sym.kind != \"lgeneric\") then { return args }",
  "    next",
  "    while {didConsume{typeArg}} do {",
  "        args.add(values.pop)",
  "        if (sym.kind == \"comma\") then { next }",
  "    }",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        def suggestion2 = errormessages.suggestion.new",
  "        suggestion2.insert(\" \")beforeToken(startToken)",
  "        def suggestions = [suggestion, suggestion2]",
  "        errormessages.syntaxError(\"A method request containing a '<' must have a matching '>'. \"",
  "            ++ \"If '<' is intended as an operator, precede it by a space.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestions(suggestions)",
  "    }",
  "    next",
  "    return args",
  "}",
  "",
  "method typeArg {",
  "    // Parses a single type argument, and leave it on the values stack.",
  "    // TODO: 'identifier' could be a dotted identifier, ",
  "    //        or perhaps a type expression?",
  "    if (accept \"identifier\") then {",
  "        identifier",
  "        if (sym.kind == \"lgeneric\") then {",
  "            values.push(ast.genericNode.new(values.pop, typeArgs))",
  "        } else {",
  "            // values.push(values.pop)",
  "        }",
  "    } elseif {didConsume{dotypeLiteral}} then {",
  "        // values.push(values.pop)",
  "    }",
  "}",
  "",
  "method callmprest(meth, signature, tok) {",
  "    // Parses the rest of a multi-part method name.",
  "    // meth is an identifierNode representing the first part of the name.",
  "    // Returns a new identifierNode, representing the full method name,",
  "    // and updates signature.params with the parsed arguments.",
  "    var methname := meth.value",
  "    var nxt",
  "    var lp := meth.linePos",
  "    var part",
  "    while {accept(\"identifier\")onLineOf(tok)",
  "           || accept(\"identifier\")onLineOf(lastToken)} do {",
  "        // Each word must start on the same line as the preceding parameter",
  "        // ended.",
  "        part := ast.callWithPart.new",
  "        signature.push(part)",
  "        methname := methname ++ \"()\"",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var isTerm := false",
  "        if ((accept(\"lparen\")).not && (accept(\"lbrace\")).not",
  "            && accept(\"string\").not && accept(\"num\").not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"identifier\") then {",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                if(methname == \"while()do\") then {",
  "                    errormessages.syntaxError(\"A while loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif(methname == \"for()do\") then {",
  "                    errormessages.syntaxError(\"A for loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"Each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if(methname == \"while()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A while loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif(methname == \"for()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A for loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.insert(\"()\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A multi-part method request must end with '()'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (accept(\"lbrace\")onLineOfLastOr(tok)",
  "            || accept(\"string\")onLineOfLastOr(tok)",
  "            || accept(\"num\")onLineOfLastOr(tok)",
  "            || (accept(\"identifier\")onLineOfLastOr(tok)",
  "                && ((sym.value == \"true\")",
  "                    || (sym.value == \"false\")))) then {",
  "            isTerm := true",
  "        } else {",
  "            next",
  "        }",
  "        var isEmpty := false",
  "        if (accept \"rparen\") then {",
  "            isEmpty := true",
  "        }",
  "        if (isTerm) then {",
  "            term",
  "        } else {",
  "            if(sym.kind != \"rparen\") then {",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A method request must have an expression or a ')' after a '('.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            while {accept(\"comma\")} do {",
  "                nxt := values.pop",
  "                part.args.push(nxt)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A method request must have an expression after a ','.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (!isEmpty) then {",
  "            nxt := values.pop",
  "            part.args.push(nxt)",
  "        }",
  "        if (isTerm.not) then {",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A part of a multi-part method request beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        if (accept(\"rparen\") && isTerm.not) then {",
  "            next",
  "        }",
  "    }",
  "    def meth' = ast.identifierNode.new(methname, false)",
  "    meth'.line := meth.line",
  "    meth'.linePos := meth.linePos",
  "    meth'",
  "}",
  "",
  "// Accept a const declaration",
  "method defdec {",
  "    if (accept(\"keyword\") && (sym.value == \"def\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "                && (t.value == \"=\") && (t.line == sym.line)})",
  "            if(nextToken == false) then {",
  "                suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "            } elseif(nextToken == sym) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"A definition must have a name, '=', and a value after the 'def'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        var dtype := optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken()",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A definition must have a value after the '='.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            val := values.pop",
  "        } elseif (accept(\"bind\")) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(sym)with(\"=\")",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A definition must use '=' instead of ':='. A variable declaration uses 'var' and ':='.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + 1)withSuggestions(suggestions)",
  "        } else {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A definition must have '=' and a value after the name. \"",
  "                ++ \"A variable declaration does not require a value and uses 'var' instead of 'def'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(defTok.line, defTok.linePos)",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultDefVisibility) overriding(\"confidential\")",
  "        o.startToken := defTok",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a var declaration",
  "method vardec {",
  "    if (accept(\"keyword\") && (sym.value == \"var\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if((nextToken == false).orElse({nextToken == sym})) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"A variable declaration must have a name after the 'var'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept(\"bind\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken()",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        util.setPosition(line, pos)",
  "        def o = ast.varDecNode.new(name, val, dtype)",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultVarVisibility) overriding(\"confidential\")",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a square-bracketed list literal like [1,2,3].",
  "method doarray {",
  "    if (accept(\"lsquare\")) then {",
  "        next",
  "        var tmp",
  "        var params := []",
  "        ifConsume {expression(blocksOK)} then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rsquare\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A list must contain zero or more valid expressions separated by commas.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A list beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        var o := ast.arrayNode.new(params)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"dialect \"X\"\"",
  "method dodialect {",
  "    if (accept(\"keyword\") && (sym.value == \"dialect\")) then {",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"A dialect statement must have the name of the dialect in quotes after the 'dialect'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        values.push(ast.dialectNode.new(sym.value))",
  "        next",
  "    }",
  "}",
  "",
  "method inheritsdec {",
  "    // Accept \"inherits x.new\"",
  "",
  "    if (accept(\"keyword\") && (sym.value == \"inherits\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rsquare\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"The inherits keyword must be followed by an expression that creates the object being inherited.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def inhNode = ast.inheritsNode.new(values.pop)",
  "        values.push(inhNode)",
  "    }",
  "}",
  "",
  "",
  "method doobject {",
  "    // Accept an object literal.",
  "    // this method is called doobject because \"object\" is a keyword",
  "",
  "    if (accept(\"keyword\") && (sym.value == \"object\")) then {",
  "        def btok = sym",
  "        def localMinIndentLevel = minIndentLevel",
  "        next",
  "        if(sym.kind != \"lbrace\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"rbrace\" })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"An object literal must have a '\\{' after the 'object'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        values.push(object {",
  "            def kind is public = \"lbrace\"",
  "            var register is public := \"\"",
  "        })",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        var sz := values.size",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // An object body contains zero or more var declarations,",
  "            // const declarations, and method declarations. If anything",
  "            // else appears before the closing brace, it is a syntax error.",
  "            methoddec",
  "            inheritsdec",
  "            statement",
  "            if (sym.kind == \"eof\") then {",
  "                if(sym.kind != \"rbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\"}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An object literal must end with a '}'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            } elseif ((values.size == sz) && (lastToken.kind != \"semicolon\")) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"An object literal can contain only definitions, variable and method declarations, and statements.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestion(suggestion)",
  "            }",
  "            sz := values.size",
  "        }",
  "        next",
  "        var rbody := []",
  "        var n := values.pop",
  "        while {n.kind != \"lbrace\"} do {",
  "            rbody.push(n)",
  "            n := values.pop",
  "        }",
  "        var body := []",
  "        for (rbody.indices) do { x ->",
  "            // Reorder the list",
  "            var p := rbody.pop",
  "            body.push(p)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.objectNode.new(body, false)",
  "        values.push(o)",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a class declaration",
  "// Class declarations are currently of the form:",
  "//   class classname.methodName (param1, param2) {",
  "//     inherits foo.new(...)",
  "//     var x",
  "//     method y(z) { ... }",
  "//   }",
  "method doclass {",
  "    if (accept(\"keyword\") && (sym.value == \"class\")) then {",
  "        def btok = sym",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestions = list.empty",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A class must have a name after the 'class'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        def cname = if (tokens.first.kind == \"dot\") then {",
  "            pushidentifier // A class must have a name",
  "            def cname' = values.pop",
  "            cname'.isBindingOccurrence := true",
  "            if (!accept(\"dot\")) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.replaceToken(sym) with(\".\")",
  "                errormessages.syntaxError \"A class must have a dot after the object name.\"",
  "                    atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                    withSuggestion(suggestion)",
  "            }",
  "            next",
  "            cname'",
  "        } else {",
  "            false",
  "        }",
  "        var s := methodsignature(false)",
  "        var csig := s.sig",
  "        var methodName := s.m",
  "        methodName.isBindingOccurrence := true",
  "        def dtype = s.rtype",
  "        def anns = doannotation",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A class must have a '\\{' after the method name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        def body = []",
  "        while {(accept(\"rbrace\")).not.andAlso{sym.kind != \"eof\"}} do {",
  "            ifConsume {methoddec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {inheritsdec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {statement} then {",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setline(btok.line)",
  "        def o = if (false == cname) then {",
  "            ast.methodNode.new(methodName, csig,",
  "                [ast.objectNode.new(body, false)], false)",
  "        } else {",
  "            ast.classNode.new(cname, csig, body, false, methodName, dtype)",
  "        }",
  "        o.generics := s.generics",
  "        if (false != anns) then {",
  "            o.annotations.addAll(anns)",
  "        } else {",
  "            if (defaultMethodVisibility == \"confidential\") then {",
  "                o.annotations.push(ast.identifierNode.new(\"confidential\",",
  "                    false))",
  "            }",
  "        }",
  "        values.push(o)",
  "        reconcileComments",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a factory method declaration",
  "method dofactoryMethod {",
  "    if ((accept(\"keyword\") && (sym.value == \"factory\")).andAlso{",
  "            tokens.first.kind == \"keyword\"}.andAlso{",
  "            tokens.first.value == \"method\"}) then {",
  "        def btok = sym",
  "        next",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestions = list.empty",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «method name» \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A factory method must have a name after the 'method'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        var s := methodsignature(false)",
  "        var csig := s.sig",
  "        var methodName := s.m",
  "        methodName.isBindingOccurrence := true",
  "        def dtype = s.rtype",
  "        def anns = doannotation",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A factory method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        def body = []",
  "        while {(accept(\"rbrace\")).not} do {",
  "            ifConsume {methoddec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {inheritsdec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {statement} then {",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setline(btok.line)",
  "        def obj = ast.objectNode.new(body, false)",
  "        def meth = ast.methodNode.new(methodName, csig,",
  "            list.with(obj), dtype)",
  "        meth.generics := s.generics",
  "        if (false != anns) then {",
  "            meth.annotations.addAll(anns)",
  "        } else {",
  "            if (defaultMethodVisibility == \"confidential\") then {",
  "                meth.annotations.push(ast.identifierNode.new(\"confidential\",",
  "                    false))",
  "            }",
  "        }",
  "        values.push(meth)",
  "        reconcileComments",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a method declaration",
  "method methoddec {",
  "    if (accept(\"keyword\") && (sym.value == \"method\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        statementToken := sym",
  "        var stok := sym",
  "        next",
  "        var m := methodsignature(false)",
  "        var meth := m.m",
  "        var signature := m.sig",
  "        def dtype = m.rtype",
  "        var varargs := m.v",
  "        var generics := m.generics",
  "        var body := []",
  "        var localMin",
  "        def anns = doannotation",
  "        if (accept(\"lbrace\")) then {",
  "            next",
  "            localMin := minIndentLevel",
  "            if (sym.line == stok.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := stok.indent + 1",
  "            }",
  "            values.push(object {",
  "                def kind is public = \"lbrace\"",
  "                var register is public := \"\"",
  "            })",
  "            statement",
  "            var s := values.pop",
  "            while {s.kind != \"lbrace\"} do {",
  "                // The body is a sequence of statements, and",
  "                // the method ends when no further statement",
  "                // is found.",
  "                body.push(s)",
  "                statement",
  "                s := values.pop",
  "            }",
  "            if(sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"A method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if(closingBrace.found == false) then {",
  "                if(closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"A method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.methodNode.new(meth, signature, body, dtype)",
  "        if (varargs) then {",
  "            o.varargs := true",
  "        }",
  "        o.generics := generics",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultMethodVisibility) overriding(\"public\")",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Process the declaration of a multi-part method name. These follow",
  "// mostly the same rules as calls, but aren't strictly enforced to be on",
  "// a single line (because they are ended by \"{\" or \"->\"). ",
  "// tm is a methodNode.  This method",
  "// returns a replacement method name identifier and modifies tm.params in",
  "// place.",
  "method parsempmndecrest(tm, sameline) {",
  "    var methname := tm.value.value",
  "    var signature := tm.signature",
  "    var nxt",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        methname := methname ++ \"()\"",
  "        var part := ast.signaturePart.new",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var vararg := false",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A multi-part method must have parentheses around each parameter list.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept(\"op\")) then {",
  "                next",
  "                vararg := true",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"A variable length parameter (a parameter beginning with '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            pushidentifier",
  "            nxt := values.pop",
  "            nxt.isBindingOccurrence := true",
  "            nxt.dtype := optionalTypeAnnotation",
  "            if (vararg) then {",
  "                part.vararg := nxt",
  "                tm.varargs := true",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            } else {",
  "                part.params.push(nxt)",
  "            }",
  "            if (accept(\"comma\")) then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "    def newName = ast.identifierNode.new(methname, false)",
  "    newName.isBindingOccurrence := true",
  "    newName",
  "}",
  "",
  "method optionalTypeAnnotation {",
  "    // Accept a type annotation if present.",
  "    // Returns the type, or false if there is no annotation",
  "    if (accept(\"colon\")) then {",
  "        next",
  "        if (didConsume { typeexpression }) then {",
  "            values.pop",
  "        } else {",
  "            checkBadTypeLiteral",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } else {",
  "        false",
  "    }",
  "}",
  "method methodsignature(sameline) {",
  "    // Accept a method signature",
  "    if((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"A method name must start with an identifier, or be an operator or '[]'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    pushidentifier",
  "    var meth := values.pop",
  "    meth.isBindingOccurrence := true",
  "    var signature := list.empty",
  "    def part = ast.signaturePart.new(meth.value)",
  "    part.line := meth.line",
  "    part.linePos := meth.linePos",
  "    signature.push(part)",
  "    if (meth.value == \"[\") then {",
  "        if(sym.kind != \"rsquare\") then {",
  "            if((sym.kind == \"identifier\") && ((tokens.size == 0).orElse",
  "                {tokens.first.kind == \"rsquare\"})) then {",
  "                def suggestions = list.empty",
  "                def suggestion = errormessages.suggestion.new",
  "                if(tokens.size == 0) then {",
  "                    suggestion.replaceToken(sym)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                } elseif(tokens.first.line == meth.line) then {",
  "                    suggestion.replaceTokenRange(sym, tokens.first)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"A declaration of a method named '[]' must have the parameter name in parentheses after the '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"]\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A method name must start with either an identifier or '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        next",
  "        meth.value := \"[]\"",
  "    }",
  "    if (accept(\"lgeneric\")) then { typeparameters(part) }",
  "    if (accept(\"bind\")) then {",
  "        next",
  "        meth.value := meth.value ++ \":=\"",
  "        part.name := part.name ++ \":=\"",
  "    } elseif (accept(\"op\") && (meth.value == \"prefix\")) then {",
  "        meth.value := meth.value ++ sym.value",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    var dtype := false",
  "    var varargs := false",
  "    var vararg := false",
  "    if (accept(\"lparen\")) then {",
  "        def lparen = sym",
  "        part.linePos := sym.linePos",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept(\"op\")) then {",
  "                next",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "                vararg := true",
  "                varargs := true",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            id.isBindingOccurrence := true",
  "            dtype := optionalTypeAnnotation",
  "            id.dtype := dtype",
  "            if (vararg) then {",
  "                part.vararg := id",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == sym.line) })",
  "                    if((sym.kind == \"comma\") && (rparen != false)) then {",
  "                        suggestion.insert(\",*{id.value}\")beforeToken(rparen)",
  "                        suggestion.deleteTokenRange(lparen.next, sym)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"A variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.\")atRange(",
  "                            lastToken.line, sym.linePos, rparen.linePos - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.insert(\")\")afterToken(lastToken)",
  "                        errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "            } else {",
  "                part.params.push(id)",
  "            }",
  "            if (accept(\"comma\")) then {",
  "                comma := sym",
  "                next",
  "            } elseif (sym.kind != \"rparen\") then {",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if(rparen == false) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            var tm := ast.methodNode.new(meth, signature, [], false)",
  "            meth := parsempmndecrest(tm, sameline)",
  "            varargs := varargs || tm.varargs",
  "        }",
  "    }",
  "    if (accept(\"arrow\")) then {",
  "        // Return dtype",
  "        next",
  "        typeexpression",
  "        dtype := values.pop",
  "    } else {",
  "        dtype := false",
  "    }",
  "    var o := object {",
  "        var m is public := meth",
  "        var sig is public  := signature",
  "        var rtype is public  := dtype",
  "        var v is public := varargs",
  "        var generics is public := part.generics",
  "    }",
  "    o",
  "}",
  "",
  "method typeparameters(node) {",
  "    next",
  "    def typeIds = list.empty",
  "    while {accept(\"identifier\")} do {",
  "        identifier",
  "        def id = values.pop",
  "        id.isBindingOccurrence := true",
  "        typeIds.push(id)",
  "        if (accept(\"comma\")) then {",
  "            next",
  "        }",
  "    }",
  "    typeIds.do { each -> each.isBindingOccurrence := true }",
  "    node.generics := ast.typeParametersNode.new(typeIds)",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"A list of type parameters starting with '<' must end with '>'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "}",
  "",
  "method doimport {",
  "    // Accept an import statement, which has the form",
  "    //      import ‹string› as ‹identifier›:‹type expression› is ‹annotation›",
  "    if (accept(\"keyword\") && (sym.value == \"import\")) then {",
  "        def importline = sym.line",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def name = values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        util.setline(importline)",
  "        def o = ast.importNode.new(p.value, name, dtype)",
  "        def anns = doannotation",
  "        if (anns != false) then { o.annotations.addAll(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultDefVisibility) overriding(\"confidential\")",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method doreturn {",
  "    // Accept a return statement; 'return' is followed by an optional expression.",
  "    if (accept(\"keyword\") && (sym.value == \"return\")) then {",
  "        def retTok = sym",
  "        next",
  "        var retval",
  "        if ((tokenOnSameLine).andAlso{accept(\"rbrace\").not}) then {",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = list.empty",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rbrace\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A return statement must have either an expression or a new-line after 'return'.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestions(suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false)",
  "        }",
  "        util.setPosition(retTok.line, retTok.linePos)",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    // parses a method in a type literal",
  "    def methodTypeTok = sym",
  "    var m := methodsignature(true)",
  "    var meth := m.m",
  "    var signature := m.sig",
  "    var dtype := m.rtype",
  "    var varargs := m.v",
  "    if (dtype == false) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    util.setPosition(methodTypeTok.line, methodTypeTok.linePos)",
  "    var o := ast.methodTypeNode.new(meth.value, signature, dtype)",
  "    o.generics := m.generics",
  "    values.push(o)",
  "    reconcileComments",
  "    if (accept(\"semicolon\")) then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines[sym.line].substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"Methods in a type literal must be on separate lines, or separated by semicolons.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeLiteral {",
  "    // parses a type literal between braces, with optional leading 'type' keyword.",
  "    def typeLiteralTok = sym",
  "    if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"type literals must open with a brace.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            return",
  "        }",
  "    }",
  "    if (accept(\"lbrace\")) then {",
  "        def meths = []",
  "        def types = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "                typedec",
  "                types.push(values.pop)",
  "            } else {",
  "                domethodtype",
  "                meths.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setPosition(typeLiteralTok.line, typeLiteralTok.linePos)",
  "        def t = ast.typeLiteralNode.new(meths, types)",
  "        values.push(t)",
  "    }",
  "}",
  "",
  "method typedec {",
  "    // Accept a declaration: 'type = <type expression>'",
  "    if (accept(\"keyword\") && (sym.value == \"type\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        util.setPosition(line, pos)",
  "        def nt = ast.typeDecNode.new(values.pop, false)",
  "        if (accept(\"lgeneric\")) then { typeparameters(nt) }",
  "        nt.name.isBindingOccurrence := true",
  "        def anns = doannotation",
  "        if((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"lbrace\" })",
  "            if((nextTok == false).orElse({nextTok == sym})) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError(\"A type declaration must have a '=' after the type name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        // Special case for type Literals without leading 'type' keyword.",
  "        if (accept(\"lbrace\")) then {",
  "            dotypeLiteral",
  "        } else {",
  "            expression(noBlocks)",
  "        }",
  "        nt.value := values.pop",
  "        if (false != anns) then {",
  "            nt.annotations.addAll(anns)",
  "        }",
  "        values.push(nt)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif (sym.kind == \"semicolon\") then {",
  "        // pass",
  "    } elseif ((sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "        || (sym.kind == \"rsquare\")) then {",
  "        // pass",
  "    } elseif (sym.kind == \"eof\") then {",
  "    } elseif (sym.indent < minIndentLevel) then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = list.empty",
  "            var suggestion := errormessages.suggestion.new",
  "            for(1..(minIndentLevel - (sym.linePos - 1))) do { _ ->",
  "                suggestion.insert(\" \")atPosition(1)onLine(sym.line)",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { tok := tok.prev }",
  "            var line := \"\"",
  "            for(1..(tok.indent)) do { _ ->",
  "                line := line ++ \" \"",
  "            }",
  "            line := line ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"The indentation for this line must be at least {minIndentLevel}. This is often caused by a missing '}'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif (sym.indent > minIndentLevel) then {",
  "        minIndentLevel := sym.indent",
  "    }",
  "}",
  "",
  "method statement {",
  "    // Accept a statement. A statement is any of the above that may exist",
  "    // at the top level, and includes expressions.",
  "    // A statement may also be a bind statement x := y, which creates a",
  "    // bind AST node out of the expressions on either side (which at this point",
  "    // can be any arbitrary expression).",
  "",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    def btok = sym",
  "    checkIndent",
  "    if (accept(\"keyword\")) then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif (sym.value == \"def\") then {",
  "            defdec",
  "        } elseif (sym.value == \"import\") then {",
  "            doimport",
  "        } elseif (sym.value == \"dialect\") then {",
  "            dodialect",
  "        } elseif (sym.value == \"type\") then {",
  "            typedec",
  "        } elseif (sym.value == \"class\") then {",
  "            doclass",
  "        } elseif (sym.value == \"factory\") then {",
  "            dofactoryMethod",
  "        } elseif (sym.value == \"return\") then {",
  "            doreturn",
  "        } else {",
  "            expression(blocksOK)",
  "        }",
  "    } else {",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = list.empty",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rbrace\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var val := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    reconcileComments",
  "    if (accept(\"eof\")) then {",
  "        return true",
  "    }",
  "    if (accept(\"semicolon\")) then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method pushcomments {",
  "    // Push a comment onto the comments stack as a commentNode. If",
  "    // there are consecutive comments following, deal with them all.",
  "    // Adjacent comments extend the first; a break of a blank line",
  "    // starts a new comment node.",
  "",
  "    if ( ! accept \"comment\" ) then { return }",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.commentNode.new(sym.value)",
  "    if ((lastToken.line == sym.line) && (lastToken.kind != \"comment\")) then {",
  "        o.isPartialLine := true",
  "    } elseif { lastToken.line < (sym.line - 1) } then {",
  "        o.isPreceededByBlankLine := true",
  "    }",
  "    comments.push(o)",
  "    while { ",
  "        previousCommentToken := sym",
  "        sym := tokens.poll",
  "        if (sym.line > (previousCommentToken.line + 1)) then { noteBlank }",
  "        accept \"comment\"",
  "    } do {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        o := ast.commentNode.new(sym.value)",
  "        if ( comments.last.endLine == (sym.line - 1) ) then {",
  "            comments.last.extendCommentUsing(o)",
  "        } else {",
  "            comments.push(o)",
  "            if ( lastToken.line < (sym.line - 1) ) then {",
  "                o.isPreceededByBlankLine := true",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method reconcileComments {",
  "    // Should be requested after a new node that represents a \"syntactic unit\"",
  "    // to which comments can be attached is pushed onto `values`",
  "    // Finds comments associated with that node, remove thems from comments",
  "    // stack, and puts them in that node's comments attribute.",
  "",
  "    pushcomments",
  "    if (values.size == 0 ) then { return }",
  "    def node = values.last",
  "    if (node.kind == \"lbrace\") then {",
  "        // lbrace nodes not AST nodes.  They are used to mark the stack for",
  "        // nested expressions.  Hence, no comments should be attached to them.",
  "        return",
  "    }",
  "    def oLine = node.line",
  "    def preComments = list.empty",
  "    def postComments = list.empty",
  "",
  "    var ix := comments.size",
  "    while { ix > 0 } do {",
  "        def each = comments.at(ix)",
  "        def isPostComment = (each.line == oLine) || (each.line == (oLine+1))",
  "        def isPreComment = each.isPreceededByBlankLine && (each.endLine == (oLine-1))",
  "        if (isPostComment) then {",
  "            postComments.push(comments.removeAt(ix))",
  "        } elseif { isPreComment } then {",
  "            preComments.addFirst(comments.removeAt(ix))",
  "        } elseif { each.endLine < (oLine-1) } then {",
  "            ix := 0     // exit from while",
  "        }",
  "        ix := ix - 1",
  "    }",
  "",
  "    def postSz = postComments.size",
  "    def preSz = preComments.size",
  "",
  "    if ((postSz > 1) && (preSz > 1)) then {",
  "        preComments.last.value := preComments.last.value ++ \"\\n\"",
  "    }",
  "    node.addComments(preComments)",
  "    node.addComments(postComments)",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"Use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "    if (sym.kind == \"rgeneric\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\" \")beforeToken(sym)",
  "        errormessages.syntaxError(\"The '>' operator must be preceded by a space.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadTypeLiteral {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"type literals must start with the keyword 'type'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = list.empty",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"Assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind == \"rgeneric\") then {",
  "            def sugg = errormessages.suggestion.new",
  "            sugg.insert(\" \")atPosition(sym.linePos)onLine(sym.line)",
  "            errormessages.syntaxError(",
  "                    \"The '>' operator must have a space before it.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestion(sugg)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = list.empty",
  "            var suggestion",
  "            if ((values.size > 0).andAlso {",
  "                    (values.last.kind == \"identifier\").orElse {",
  "                        values.last.kind == \"member\"",
  "                    }.andAlso {",
  "                        sym.kind == \"identifier\"",
  "                    }",
  "                }) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken(\"rbrace\")",
  "            if(nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines[lastToken.line].substringFrom(1)to(lastToken.linePos + lastToken.size - 1))",
  "                def newLine = util.lines[sym.line].substringFrom(sym.linePos)to(util.lines[sym.line].size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"Multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "",
  "method parse(toks) {",
  "    // Parse the given list of tokens, returning a list of AST nodes",
  "    // corresponding to it.",
  "",
  "    util.log_verbose \"parsing.\"",
  "",
  "    if (util.extensions.contains(\"DefaultVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultVisibility\")",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVisibility\")",
  "        defaultMethodVisibility := util.extensions.get(\"DefaultVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultDefVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultDefVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultVarVisibility\")) then {",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVarVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultMethodVisibility\")) then {",
  "        defaultMethodVisibility := util.extensions.get(\"DefaultMethodVisibility\")",
  "    }",
  "    if (toks.size == 0) then {",
  "        return list.empty",
  "    }",
  "    tokens := toks",
  "    next",
  "    if (sym.indent > 0) then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.deleteRange(1, sym.indent) onLine(sym.line)",
  "        errormessages.syntaxError(\"The first line must not be indented.\")",
  "            atRange(sym.line, 1, sym.indent)",
  "            withSuggestion(sugg)",
  "    }",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        blank",
  "        methoddec",
  "        blank",
  "        inheritsdec",
  "        blank",
  "        statement",
  "        blank",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError(\"Invalid statement. This is often caused by an extra '}', ')', or ']'.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestion(suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    blank",
  "    statement",
  "    blank",
  "    return values",
  "}",
  NULL
};
Object reader_parser_outer_233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8099(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8100(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_register_8101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8940(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8941(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_register_8942(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8942(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_10057(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_m_10058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_m_10058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_sig_10059(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_sig_10059(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_rtype_10060(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_rtype_10060(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_v_10061(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_v_10061(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_generics_10062(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_generics_10062(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_outer_12237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_12238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_line_12239(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_linePos_12240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_indent_12241(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_value_12242(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_parser_size_12243(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit48;
static Object strlit50;
static Object strlit108;
static Object strlit155;
static Object strlit187;
static Object strlit188;
static Object strlit189;
static Object strlit190;
static Object strlit191;
static Object strlit192;
static Object strlit193;
static Object strlit194;
static Object strlit202;
static ClassData objclass232;
static Object strlit249;
static Object strlit260;
static Object strlit272;
static Object strlit300;
static Object strlit311;
static Object strlit323;
static Object strlit340;
static Object strlit357;
static Object strlit555;
static Object strlit563;
static Object strlit590;
static Object strlit597;
static Object strlit604;
static Object strlit611;
static Object strlit618;
static Object strlit637;
static Object strlit664;
static Object strlit674;
static Object strlit698;
static Object strlit729;
static Object strlit737;
static Object strlit767;
static Object strlit774;
static Object strlit781;
static Object strlit799;
static Object strlit818;
static Object strlit850;
static Object strlit857;
static Object strlit864;
static Object strlit882;
static Object strlit943;
static Object strlit994;
static Object strlit1007;
static Object strlit1014;
static Object strlit1024;
static Object strlit1044;
static Object strlit1051;
static Object strlit1058;
static Object strlit1061;
static Object strlit1069;
static Object strlit1081;
static Object strlit1084;
static Object strlit1126;
static Object strlit1149;
static Object strlit1167;
static Object strlit1172;
static Object strlit1176;
static Object strlit1185;
static Object strlit1210;
static Object strlit1211;
static Object strlit1218;
static Object strlit1225;
static Object strlit1243;
static Object strlit1275;
static Object strlit1288;
static Object strlit1319;
static Object strlit1324;
static Object strlit1336;
static Object strlit1362;
static Object strlit1372;
static Object strlit1379;
static Object strlit1386;
static Object strlit1389;
static Object strlit1392;
static Object strlit1402;
static Object strlit1412;
static Object strlit1429;
static Object strlit1434;
static Object strlit1444;
static Object strlit1453;
static Object strlit1486;
static Object strlit1493;
static Object strlit1500;
static Object strlit1518;
static Object strlit1540;
static Object strlit1564;
static Object strlit1589;
static Object strlit1610;
static Object strlit1613;
static Object strlit1662;
static Object strlit1669;
static Object strlit1676;
static Object strlit1692;
static Object strlit1699;
static Object strlit1708;
static Object strlit1715;
static Object strlit1739;
static Object strlit1743;
static Object strlit1753;
static Object strlit1756;
static Object strlit1760;
static Object strlit1770;
static Object strlit1773;
static Object strlit1776;
static Object strlit1783;
static Object strlit1793;
static Object strlit1796;
static Object strlit1799;
static Object strlit1805;
static Object strlit1832;
static Object strlit1854;
static Object strlit1862;
static Object strlit1869;
static Object strlit1872;
static Object strlit1883;
static Object strlit1886;
static Object strlit1897;
static Object strlit1900;
static Object strlit1914;
static Object strlit1926;
static Object strlit1929;
static Object strlit1953;
static Object strlit1960;
static Object strlit1967;
static Object strlit1995;
static Object strlit2006;
static Object strlit2011;
static Object strlit2016;
static Object strlit2019;
static Object strlit2053;
static Object strlit2090;
static Object strlit2101;
static Object strlit2106;
static Object strlit2126;
static Object strlit2133;
static Object strlit2147;
static Object strlit2154;
static Object strlit2162;
static Object strlit2165;
static Object strlit2168;
static Object strlit2171;
static Object strlit2174;
static Object strlit2175;
static Object strlit2178;
static Object strlit2192;
static Object strlit2199;
static Object strlit2208;
static Object strlit2216;
static Object strlit2223;
static Object strlit2248;
static Object strlit2252;
static Object strlit2262;
static Object strlit2265;
static Object strlit2269;
static Object strlit2279;
static Object strlit2282;
static Object strlit2285;
static Object strlit2292;
static Object strlit2302;
static Object strlit2305;
static Object strlit2308;
static Object strlit2314;
static Object strlit2342;
static Object strlit2349;
static Object strlit2372;
static Object strlit2380;
static Object strlit2387;
static Object strlit2390;
static Object strlit2401;
static Object strlit2404;
static Object strlit2415;
static Object strlit2418;
static Object strlit2443;
static Object strlit2447;
static Object strlit2452;
static Object strlit2456;
static Object strlit2479;
static Object strlit2486;
static Object strlit2499;
static Object strlit2523;
static Object strlit2528;
static Object strlit2539;
static Object strlit2544;
static Object strlit2563;
static Object strlit2566;
static Object strlit2577;
static Object strlit2580;
static Object strlit2583;
static Object strlit2591;
static Object strlit2619;
static Object strlit2630;
static Object strlit2635;
static Object strlit2640;
static Object strlit2643;
static Object strlit2677;
static Object strlit2714;
static Object strlit2725;
static Object strlit2730;
static Object strlit2758;
static Object strlit2765;
static Object strlit2772;
static Object strlit2800;
static Object strlit2811;
static Object strlit2816;
static Object strlit2821;
static Object strlit2824;
static Object strlit2858;
static Object strlit2895;
static Object strlit2906;
static Object strlit2911;
static Object strlit2942;
static Object strlit2966;
static Object strlit2971;
static Object strlit2982;
static Object strlit2987;
static Object strlit3006;
static Object strlit3009;
static Object strlit3020;
static Object strlit3023;
static Object strlit3026;
static Object strlit3037;
static Object strlit3041;
static Object strlit3053;
static Object strlit3061;
static Object strlit3080;
static Object strlit3087;
static Object strlit3094;
static Object strlit3097;
static Object strlit3105;
static Object strlit3117;
static Object strlit3120;
static Object strlit3152;
static Object strlit3159;
static Object strlit3166;
static Object strlit3172;
static Object strlit3199;
static Object strlit3222;
static Object strlit3243;
static Object strlit3257;
static Object strlit3268;
static Object strlit3279;
static Object strlit3293;
static Object strlit3307;
static Object strlit3347;
static Object strlit3353;
static Object strlit3363;
static Object strlit3370;
static Object strlit3374;
static Object strlit3389;
static Object strlit3399;
static Object strlit3406;
static Object strlit3410;
static Object strlit3434;
static Object strlit3441;
static Object strlit3450;
static Object strlit3456;
static Object strlit3471;
static Object strlit3478;
static Object strlit3496;
static Object strlit3504;
static Object strlit3519;
static Object strlit3523;
static Object strlit3529;
static Object strlit3533;
static Object strlit3543;
static Object strlit3547;
static Object strlit3552;
static Object strlit3558;
static Object strlit3561;
static Object strlit3564;
static Object strlit3596;
static Object strlit3603;
static Object strlit3610;
static Object strlit3613;
static Object strlit3621;
static Object strlit3633;
static Object strlit3636;
static Object strlit3658;
static Object strlit3665;
static Object strlit3675;
static Object strlit3681;
static Object strlit3700;
static Object strlit3707;
static Object strlit3714;
static Object strlit3717;
static Object strlit3725;
static Object strlit3737;
static Object strlit3740;
static Object strlit3769;
static Object strlit3774;
static Object strlit3783;
static Object strlit3793;
static Object strlit3798;
static Object strlit3803;
static Object strlit3808;
static Object strlit3823;
static Object strlit3830;
static Object strlit3838;
static Object strlit3842;
static Object strlit3845;
static Object strlit3847;
static Object strlit3864;
static Object strlit3871;
static Object strlit3878;
static Object strlit3884;
static Object strlit3903;
static Object strlit3910;
static Object strlit3917;
static Object strlit3920;
static Object strlit3928;
static Object strlit3940;
static Object strlit3943;
static Object strlit3972;
static Object strlit3977;
static Object strlit3986;
static Object strlit3996;
static Object strlit4001;
static Object strlit4006;
static Object strlit4011;
static Object strlit4038;
static Object strlit4045;
static Object strlit4054;
static Object strlit4057;
static Object strlit4059;
static Object strlit4065;
static Object strlit4071;
static Object strlit4086;
static Object strlit4093;
static Object strlit4111;
static Object strlit4119;
static Object strlit4134;
static Object strlit4138;
static Object strlit4144;
static Object strlit4148;
static Object strlit4158;
static Object strlit4162;
static Object strlit4167;
static Object strlit4173;
static Object strlit4176;
static Object strlit4179;
static Object strlit4211;
static Object strlit4218;
static Object strlit4225;
static Object strlit4228;
static Object strlit4236;
static Object strlit4248;
static Object strlit4251;
static Object strlit4273;
static Object strlit4280;
static Object strlit4290;
static Object strlit4296;
static Object strlit4315;
static Object strlit4322;
static Object strlit4329;
static Object strlit4332;
static Object strlit4340;
static Object strlit4352;
static Object strlit4355;
static Object strlit4384;
static Object strlit4389;
static Object strlit4398;
static Object strlit4408;
static Object strlit4413;
static Object strlit4418;
static Object strlit4423;
static Object strlit4438;
static Object strlit4445;
static Object strlit4452;
static Object strlit4458;
static Object strlit4477;
static Object strlit4484;
static Object strlit4491;
static Object strlit4494;
static Object strlit4502;
static Object strlit4514;
static Object strlit4517;
static Object strlit4546;
static Object strlit4551;
static Object strlit4560;
static Object strlit4570;
static Object strlit4575;
static Object strlit4580;
static Object strlit4585;
static Object strlit4612;
static Object strlit4619;
static Object strlit4628;
static Object strlit4643;
static Object strlit4650;
static Object strlit4667;
static Object strlit4682;
static Object strlit4686;
static Object strlit4696;
static Object strlit4699;
static Object strlit4703;
static Object strlit4709;
static Object strlit4712;
static Object strlit4718;
static Object strlit4746;
static Object strlit4753;
static Object strlit4760;
static Object strlit4763;
static Object strlit4773;
static Object strlit4785;
static Object strlit4788;
static Object strlit4808;
static Object strlit4815;
static Object strlit4825;
static Object strlit4831;
static Object strlit4850;
static Object strlit4857;
static Object strlit4864;
static Object strlit4867;
static Object strlit4875;
static Object strlit4887;
static Object strlit4890;
static Object strlit4919;
static Object strlit4924;
static Object strlit4933;
static Object strlit4943;
static Object strlit4948;
static Object strlit4953;
static Object strlit4958;
static Object strlit4992;
static Object strlit4998;
static Object strlit5004;
static Object strlit5011;
static Object strlit5018;
static Object strlit5026;
static Object strlit5033;
static Object strlit5041;
static Object strlit5048;
static Object strlit5055;
static Object strlit5062;
static Object strlit5069;
static Object strlit5079;
static Object strlit5086;
static Object strlit5093;
static Object strlit5099;
static Object strlit5105;
static Object strlit5120;
static Object strlit5146;
static Object strlit5153;
static Object strlit5160;
static Object strlit5163;
static Object strlit5171;
static Object strlit5183;
static Object strlit5186;
static Object strlit5219;
static Object strlit5244;
static Object strlit5251;
static Object strlit5258;
static Object strlit5264;
static Object strlit5281;
static Object strlit5291;
static Object strlit5301;
static Object strlit5304;
static Object strlit5332;
static Object strlit5338;
static Object strlit5359;
static Object strlit5362;
static Object strlit5372;
static Object strlit5375;
static Object strlit5391;
static Object strlit5399;
static Object strlit5406;
static Object strlit5428;
static Object strlit5434;
static Object strlit5440;
static Object strlit5445;
static Object strlit5464;
static Object strlit5478;
static Object strlit5481;
static Object strlit5493;
static Object strlit5498;
static Object strlit5509;
static Object strlit5568;
static Object strlit5582;
static Object strlit5590;
static Object strlit5594;
static Object strlit5604;
static Object strlit5608;
static Object strlit5614;
static Object strlit5618;
static Object strlit5628;
static Object strlit5640;
static Object strlit5643;
static Object strlit5682;
static Object strlit5686;
static Object strlit5705;
static Object strlit5716;
static Object strlit5722;
static Object strlit5754;
static Object strlit5755;
static Object strlit5756;
static Object strlit5757;
static Object strlit5765;
static Object strlit5769;
static Object strlit5779;
static Object strlit5783;
static Object strlit5804;
static Object strlit5811;
static Object strlit5815;
static Object strlit5892;
static Object strlit5901;
static Object strlit5915;
static Object strlit5935;
static Object strlit5942;
static Object strlit5947;
static Object strlit5952;
static Object strlit5957;
static Object strlit5963;
static Object strlit5969;
static Object strlit5996;
static Object strlit6001;
static Object strlit6020;
static Object strlit6027;
static Object strlit6058;
static Object strlit6065;
static Object strlit6087;
static Object strlit6101;
static Object strlit6108;
static Object strlit6116;
static Object strlit6122;
static Object strlit6127;
static Object strlit6131;
static Object strlit6151;
static Object strlit6160;
static Object strlit6171;
static Object strlit6187;
static Object strlit6201;
static Object strlit6217;
static Object strlit6273;
static Object strlit6279;
static Object strlit6290;
static Object strlit6304;
static Object strlit6330;
static Object strlit6361;
static Object strlit6368;
static Object strlit6375;
static Object strlit6393;
static Object strlit6409;
static Object strlit6441;
static Object strlit6448;
static Object strlit6455;
static Object strlit6473;
static Object strlit6481;
static Object strlit6487;
static Object strlit6498;
static Object strlit6512;
static Object strlit6536;
static Object strlit6567;
static Object strlit6574;
static Object strlit6581;
static Object strlit6599;
static Object strlit6623;
static Object strlit6635;
static Object strlit6638;
static Object strlit6675;
static Object strlit6701;
static Object strlit6712;
static Object strlit6722;
static Object strlit6729;
static Object strlit6734;
static Object strlit6736;
static Object strlit6753;
static Object strlit6759;
static Object strlit6792;
static Object strlit6796;
static Object strlit6810;
static Object strlit6834;
static Object strlit6841;
static Object strlit6848;
static Object strlit6854;
static Object strlit6866;
static Object strlit6875;
static Object strlit6881;
static Object strlit6887;
static Object strlit6891;
static Object strlit6899;
static Object strlit6903;
static Object strlit6910;
static Object strlit6918;
static Object strlit6922;
static Object strlit6925;
static Object strlit6933;
static Object strlit6937;
static Object strlit6940;
static Object strlit6947;
static Object strlit6950;
static Object strlit6961;
static Object strlit6968;
static Object strlit6976;
static Object strlit6982;
static Object strlit6987;
static Object strlit6991;
static Object strlit7003;
static Object strlit7012;
static Object strlit7036;
static Object strlit7043;
static Object strlit7050;
static Object strlit7068;
static Object strlit7078;
static Object strlit7111;
static Object strlit7118;
static Object strlit7125;
static Object strlit7143;
static Object strlit7166;
static Object strlit7178;
static Object strlit7181;
static Object strlit7198;
static Object strlit7222;
static Object strlit7229;
static Object strlit7240;
static Object strlit7263;
static Object strlit7270;
static Object strlit7285;
static Object strlit7292;
static Object strlit7299;
static Object strlit7302;
static Object strlit7323;
static Object strlit7330;
static Object strlit7356;
static Object strlit7363;
static Object strlit7366;
static Object strlit7382;
static Object strlit7393;
static Object strlit7403;
static Object strlit7408;
static Object strlit7429;
static Object strlit7439;
static Object strlit7445;
static Object strlit7447;
static Object strlit7474;
static Object strlit7486;
static Object strlit7493;
static Object strlit7504;
static Object strlit7526;
static Object strlit7548;
static Object strlit7555;
static Object strlit7558;
static Object strlit7578;
static Object strlit7607;
static Object strlit7614;
static Object strlit7633;
static Object strlit7635;
static Object strlit7653;
static Object strlit7660;
static Object strlit7672;
static Object strlit7682;
static Object strlit7687;
static Object strlit7711;
static Object strlit7720;
static Object strlit7737;
static Object strlit7768;
static Object strlit7775;
static Object strlit7782;
static Object strlit7800;
static Object strlit7817;
static Object strlit7827;
static Object strlit7830;
static Object strlit7853;
static Object strlit7860;
static Object strlit7867;
static Object strlit7887;
static Object strlit7895;
static Object strlit7901;
static Object strlit7909;
static Object strlit7924;
static Object strlit7942;
static Object strlit7949;
static Object strlit7975;
static Object strlit7982;
static Object strlit7989;
static Object strlit8007;
static Object strlit8040;
static Object strlit8047;
static Object strlit8054;
static Object strlit8067;
static Object strlit8080;
static Object strlit8083;
static Object strlit8086;
static ClassData objclass8098;
static Object strlit8102;
static Object strlit8103;
static Object strlit8136;
static Object strlit8150;
static Object strlit8157;
static Object strlit8167;
static Object strlit8170;
static Object strlit8184;
static Object strlit8203;
static Object strlit8234;
static Object strlit8277;
static Object strlit8284;
static Object strlit8291;
static Object strlit8302;
static Object strlit8312;
static Object strlit8322;
static Object strlit8331;
static Object strlit8336;
static Object strlit8353;
static Object strlit8370;
static Object strlit8378;
static Object strlit8381;
static Object strlit8416;
static Object strlit8424;
static Object strlit8427;
static Object strlit8474;
static Object strlit8482;
static Object strlit8575;
static Object strlit8580;
static Object strlit8599;
static Object strlit8611;
static Object strlit8621;
static Object strlit8628;
static Object strlit8639;
static Object strlit8650;
static Object strlit8660;
static Object strlit8670;
static Object strlit8679;
static Object strlit8684;
static Object strlit8716;
static Object strlit8724;
static Object strlit8727;
static Object strlit8772;
static Object strlit8856;
static Object strlit8861;
static Object strlit8878;
static Object strlit8885;
static Object strlit8911;
static ClassData objclass8939;
static Object strlit8943;
static Object strlit8944;
static Object strlit8954;
static Object strlit8973;
static Object strlit8999;
static Object strlit9010;
static Object strlit9015;
static Object strlit9045;
static Object strlit9057;
static Object strlit9060;
static Object strlit9064;
static Object strlit9068;
static Object strlit9103;
static Object strlit9121;
static Object strlit9126;
static Object strlit9137;
static Object strlit9164;
static Object strlit9172;
static Object strlit9175;
static Object strlit9190;
static Object strlit9197;
static Object strlit9202;
static Object strlit9210;
static Object strlit9218;
static Object strlit9232;
static Object strlit9260;
static Object strlit9291;
static Object strlit9301;
static Object strlit9304;
static Object strlit9321;
static Object strlit9330;
static Object strlit9340;
static Object strlit9343;
static Object strlit9371;
static Object strlit9396;
static Object strlit9412;
static Object strlit9423;
static Object strlit9431;
static Object strlit9438;
static Object strlit9450;
static Object strlit9453;
static Object strlit9493;
static Object strlit9500;
static Object strlit9511;
static Object strlit9528;
static Object strlit9551;
static Object strlit9557;
static Object strlit9577;
static Object strlit9583;
static Object strlit9590;
static Object strlit9606;
static Object strlit9609;
static Object strlit9623;
static Object strlit9627;
static Object strlit9633;
static Object strlit9639;
static Object strlit9647;
static Object strlit9656;
static Object strlit9663;
static Object strlit9691;
static Object strlit9706;
static Object strlit9713;
static Object strlit9718;
static Object strlit9726;
static Object strlit9732;
static Object strlit9746;
static Object strlit9774;
static Object strlit9807;
static Object strlit9829;
static Object strlit9845;
static Object strlit9853;
static Object strlit9859;
static Object strlit9870;
static Object strlit9883;
static Object strlit9886;
static Object strlit9903;
static Object strlit9910;
static Object strlit9917;
static Object strlit9927;
static Object strlit9930;
static Object strlit9945;
static Object strlit9967;
static Object strlit9981;
static Object strlit9986;
static Object strlit10016;
static Object strlit10021;
static Object strlit10045;
static ClassData objclass10056;
static Object strlit10076;
static Object strlit10092;
static Object strlit10114;
static Object strlit10124;
static Object strlit10127;
static Object strlit10144;
static Object strlit10151;
static Object strlit10160;
static Object strlit10180;
static Object strlit10188;
static Object strlit10194;
static Object strlit10202;
static Object strlit10217;
static Object strlit10228;
static Object strlit10235;
static Object strlit10256;
static Object strlit10263;
static Object strlit10267;
static Object strlit10273;
static Object strlit10278;
static Object strlit10297;
static Object strlit10317;
static Object strlit10325;
static Object strlit10331;
static Object strlit10340;
static Object strlit10346;
static Object strlit10363;
static Object strlit10396;
static Object strlit10406;
static Object strlit10413;
static Object strlit10424;
static Object strlit10450;
static Object strlit10457;
static Object strlit10475;
static Object strlit10493;
static Object strlit10514;
static Object strlit10550;
static Object strlit10578;
static Object strlit10585;
static Object strlit10632;
static Object strlit10644;
static Object strlit10651;
static Object strlit10659;
static Object strlit10667;
static Object strlit10670;
static Object strlit10678;
static Object strlit10694;
static Object strlit10705;
static Object strlit10712;
static Object strlit10747;
static Object strlit10754;
static Object strlit10765;
static Object strlit10775;
static Object strlit10778;
static Object strlit10806;
static Object strlit10820;
static Object strlit10827;
static Object strlit10841;
static Object strlit10862;
static Object strlit10867;
static Object strlit10870;
static Object strlit10889;
static Object strlit10918;
static Object strlit10926;
static Object strlit10934;
static Object strlit10941;
static Object strlit10950;
static Object strlit10996;
static Object strlit11040;
static Object strlit11051;
static Object strlit11058;
static Object strlit11074;
static Object strlit11078;
static Object strlit11104;
static Object strlit11108;
static Object strlit11117;
static Object strlit11126;
static Object strlit11135;
static Object strlit11144;
static Object strlit11153;
static Object strlit11162;
static Object strlit11171;
static Object strlit11191;
static Object strlit11196;
static Object strlit11206;
static Object strlit11215;
static Object strlit11248;
static Object strlit11255;
static Object strlit11262;
static Object strlit11280;
static Object strlit11306;
static Object strlit11311;
static Object strlit11331;
static Object strlit11349;
static Object strlit11405;
static Object strlit11474;
static Object strlit11581;
static Object strlit11598;
static Object strlit11608;
static Object strlit11611;
static Object strlit11621;
static Object strlit11631;
static Object strlit11634;
static Object strlit11645;
static Object strlit11655;
static Object strlit11658;
static Object strlit11678;
static Object strlit11686;
static Object strlit11693;
static Object strlit11711;
static Object strlit11722;
static Object strlit11727;
static Object strlit11737;
static Object strlit11747;
static Object strlit11754;
static Object strlit11764;
static Object strlit11781;
static Object strlit11791;
static Object strlit11800;
static Object strlit11826;
static Object strlit11832;
static Object strlit11864;
static Object strlit11870;
static Object strlit11875;
static Object strlit11883;
static Object strlit11899;
static Object strlit11905;
static Object strlit11912;
static Object strlit11986;
static Object strlit11994;
static Object strlit11998;
static Object strlit12003;
static Object strlit12009;
static Object strlit12015;
static Object strlit12022;
static Object strlit12027;
static Object strlit12034;
static Object strlit12039;
static Object strlit12046;
static Object strlit12051;
static Object strlit12089;
static Object strlit12137;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_errormessages;
Object module_errormessages_init();
static Object strlit12219;
static Object strlit12223;
static Object strlit12227;
static ClassData objclass12236;
static Object strlit12244;
static Object strlit12248;
Object meth_parser_noteBlank0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noteBlank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blankLocation = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for noteBlank (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for noteBlank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2 = alloc_Float64(1);
// compiled num node returning num2 (depth = 4)
  int op_slot_right_1 = gc_frame_newslot(num2);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4);
// compiled call node returning call5 (depth = 5)
// compiled member node returning call5 (depth = 4)
  int op_slot_left_1 = gc_frame_newslot(call5);
  params[0] = num2;
  partcv[0] = 1;
  Object diff6 = callmethod(call5, "-", 1, partcv, params);
// compiled op node returning diff6 (depth = 3)
  *var_blankLocation = diff6;
  if (diff6 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_next8(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_lastLine = getfromclosure(closure, 3);
  Object *var_lastIndent = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11 = alloc_Float64(0);
// compiled num node returning num11 (depth = 4)
  int op_slot_right_10 = gc_frame_newslot(num11);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe13 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call14 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe13);
// compiled call node returning call14 (depth = 5)
// compiled member node returning call14 (depth = 4)
  int op_slot_left_10 = gc_frame_newslot(call14);
  params[0] = num11;
  partcv[0] = 1;
  Object opresult15 = callmethod(call14, ">", 1, partcv, params);
// compiled op node returning opresult15 (depth = 3)
  Object if9 = done;
  if (istrue(opresult15)) {
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe17 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call18 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe17);
// compiled call node returning call18 (depth = 5)
// compiled member node returning call18 (depth = 4)
  *var_lastLine = call18;
  if (call18 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe20 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call21 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe20);
// compiled call node returning call21 (depth = 5)
// compiled member node returning call21 (depth = 4)
  *var_lastIndent = call21;
  if (call21 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe23 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call24 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe23);
// compiled call node returning call24 (depth = 5)
// compiled member node returning call24 (depth = 4)
  *var_sym = call24;
  if (call24 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num29 = alloc_Float64(1);
// compiled num node returning num29 (depth = 6)
  int op_slot_right_28 = gc_frame_newslot(num29);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastLine (depth = 6)
  int op_slot_left_28 = gc_frame_newslot(*var_lastLine);
  params[0] = num29;
  partcv[0] = 1;
  Object sum31 = callmethod(*var_lastLine, "+", 1, partcv, params);
// compiled op node returning sum31 (depth = 5)
  int op_slot_right_27 = gc_frame_newslot(sum31);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe33 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call34 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe33);
// compiled call node returning call34 (depth = 6)
// compiled member node returning call34 (depth = 5)
  int op_slot_left_27 = gc_frame_newslot(call34);
  params[0] = sum31;
  partcv[0] = 1;
  Object opresult35 = callmethod(call34, ">", 1, partcv, params);
// compiled op node returning opresult35 (depth = 4)
  Object if26 = done;
  if (istrue(opresult35)) {
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe36 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call37 = callmethodflags(self, "noteBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe36);
// compiled call node returning call37 (depth = 5)
// compiled member node returning call37 (depth = 4)
    gc_frame_newslot(call37);
    if26 = call37;
  } else {
  }
// compiled if node returning if26 (depth = 3)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe38 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call39 = callmethodflags(self, "pushcomments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe38);
// compiled call node returning call39 (depth = 4)
// compiled member node returning call39 (depth = 3)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe40 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe41 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call42 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe41);
// compiled call node returning call42 (depth = 5)
// compiled member node returning call42 (depth = 4)
  gc_frame_newslot(call42);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe43 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call44 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe43);
// compiled call node returning call44 (depth = 5)
// compiled member node returning call44 (depth = 4)
  gc_frame_newslot(call44);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call42;
  params[1] = call44;
  partcv[0] = 2;
  Object call45 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe40);
// compiled call node returning call45 (depth = 3)
    gc_frame_newslot(call45);
    if9 = call45;
  } else {
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe46 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit48 == NULL) {
    strlit48 = alloc_String("This is often caused by a missing '}'");
    gc_root(strlit48);
  }
// compiled string node returning strlit48 (depth = 5)
  int op_slot_right_47 = gc_frame_newslot(strlit48);
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit50 == NULL) {
    strlit50 = alloc_String("Unexpectedly found the end of the input. ");
    gc_root(strlit50);
  }
// compiled string node returning strlit50 (depth = 5)
  int op_slot_left_47 = gc_frame_newslot(strlit50);
  params[0] = strlit48;
  partcv[0] = 1;
  Object opresult51 = callmethod(strlit50, "++", 1, partcv, params);
// compiled op node returning opresult51 (depth = 4)
  gc_frame_newslot(opresult51);
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe52 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call53 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe52);
// compiled call node returning call53 (depth = 5)
// compiled member node returning call53 (depth = 4)
  gc_frame_newslot(call53);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe54 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call55 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe54);
// compiled call node returning call55 (depth = 5)
// compiled member node returning call55 (depth = 4)
  gc_frame_newslot(call55);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe56 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call57 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe56);
// compiled call node returning call57 (depth = 5)
// compiled member node returning call57 (depth = 4)
  gc_frame_newslot(call57);
// call case 6: other member request
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult51;
  params[1] = call53;
  params[2] = call55;
  params[3] = call57;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call58 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe46);
// compiled call node returning call58 (depth = 3)
    gc_frame_newslot(call58);
    if9 = call58;
  }
// compiled if node returning if9 (depth = 2)
  gc_frame_end(frame);
  return if9;
}
Object meth_parser__apply69(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe71 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call72 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe71);
// compiled call node returning call72 (depth = 8)
// compiled member node returning call72 (depth = 7)
  int op_slot_right_70 = gc_frame_newslot(call72);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe74 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call75 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe74);
// compiled call node returning call75 (depth = 8)
// compiled member node returning call75 (depth = 7)
  int op_slot_left_70 = gc_frame_newslot(call75);
  params[0] = call72;
  partcv[0] = 1;
  Object opresult76 = callmethod(call75, ">=", 1, partcv, params);
// compiled op node returning opresult76 (depth = 6)
  gc_frame_end(frame);
  return opresult76;
}
Object meth_parser__apply80(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool82 = alloc_Boolean(0);
// compiled identifier node returning bool82 (depth = 8)
  int op_slot_right_81 = gc_frame_newslot(bool82);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_81 = gc_frame_newslot(*var_nextTok);
  params[0] = bool82;
  partcv[0] = 1;
  Object opresult84 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult84 (depth = 7)
  gc_frame_end(frame);
  return opresult84;
}
Object meth_parser__apply66(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe67 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block68 = alloc_Block(NULL, NULL, "parser", 74);
  gc_frame_newslot(block68);
// method _apply
  block_savedest(block68);
  Object closure69 = createclosure(3, "_apply");
  setclosureframe(closure69, stackframe);
  addtoclosure(closure69, var_lastToken);
  addtoclosure(closure69, var_n);
  addtoclosure(closure69, selfslot);
  struct UserObject *uo69 = (struct UserObject*)block68;
  uo69->data[0] = (Object)closure69;
  Method *meth_meth_parser__apply69 = addmethod2pos(block68, "_apply", &meth_parser__apply69, 0);
  int argcv_meth_parser__apply69[] = {0};
  meth_meth_parser__apply69->type = alloc_MethodType(1, argcv_meth_parser__apply69);
  meth_meth_parser__apply69->definitionModule = modulename;
  meth_meth_parser__apply69->definitionLine = 60;
// compiled block node returning block68 (depth = 5)
  gc_frame_newslot(block68);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe78 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block79 = alloc_Block(NULL, NULL, "parser", 74);
  gc_frame_newslot(block79);
// method _apply
  block_savedest(block79);
  Object closure80 = createclosure(2, "_apply");
  setclosureframe(closure80, stackframe);
  addtoclosure(closure80, var_nextTok);
  addtoclosure(closure80, selfslot);
  struct UserObject *uo80 = (struct UserObject*)block79;
  uo80->data[0] = (Object)closure80;
  Method *meth_meth_parser__apply80 = addmethod2pos(block79, "_apply", &meth_parser__apply80, 0);
  int argcv_meth_parser__apply80[] = {0};
  meth_meth_parser__apply80->type = alloc_MethodType(1, argcv_meth_parser__apply80);
  meth_meth_parser__apply80->definitionModule = modulename;
  meth_meth_parser__apply80->definitionLine = 74;
// compiled block node returning block79 (depth = 6)
  gc_frame_newslot(block79);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool87 = alloc_Boolean(0);
// compiled identifier node returning bool87 (depth = 7)
  int op_slot_right_86 = gc_frame_newslot(bool87);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_86 = gc_frame_newslot(*var_n);
  params[0] = bool87;
  partcv[0] = 1;
  Object opresult89 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult89 (depth = 6)
  params[0] = block79;
  partcv[0] = 1;
  Object call90 = callmethod(opresult89, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe78);
// compiled call node returning call90 (depth = 5)
  params[0] = block68;
  partcv[0] = 1;
  Object call91 = callmethod(call90, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe67);
// compiled call node returning call91 (depth = 4)
  gc_frame_end(frame);
  return call91;
}
Object meth_parser__apply94(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe96 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokenMatcher (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call97 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe96);
// compiled call node returning call97 (depth = 5)
  Object if95 = done;
  if (istrue(call97)) {
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if95 = done;
  } else {
  }
// compiled if node returning if95 (depth = 4)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe99 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call100 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 6)
// compiled member node returning call100 (depth = 5)
  *var_n = call100;
  if (call100 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextToken59(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findNextToken");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findNextToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe61 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenMatcher (depth = 4)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call62 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe61);
// compiled call node returning call62 (depth = 3)
  Object if60 = done;
  if (istrue(call62)) {
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if60 = undefined;
  } else {
  }
// compiled if node returning if60 (depth = 2)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool63 = alloc_Boolean(0);
// compiled identifier node returning bool63 (depth = 3)
  *var_nextTok = bool63;
  if (bool63 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe64 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block65 = alloc_Block(NULL, NULL, "parser", 74);
  gc_frame_newslot(block65);
// method _apply
  block_savedest(block65);
  Object closure66 = createclosure(4, "_apply");
  setclosureframe(closure66, stackframe);
  addtoclosure(closure66, var_lastToken);
  addtoclosure(closure66, var_n);
  addtoclosure(closure66, var_nextTok);
  addtoclosure(closure66, selfslot);
  struct UserObject *uo66 = (struct UserObject*)block65;
  uo66->data[0] = (Object)closure66;
  Method *meth_meth_parser__apply66 = addmethod2pos(block65, "_apply", &meth_parser__apply66, 0);
  int argcv_meth_parser__apply66[] = {0};
  meth_meth_parser__apply66->type = alloc_MethodType(1, argcv_meth_parser__apply66);
  meth_meth_parser__apply66->definitionModule = modulename;
  meth_meth_parser__apply66->definitionLine = 60;
// compiled block node returning block65 (depth = 3)
  gc_frame_newslot(block65);
// starting to compile block node (depth = 3)
  Object block93 = alloc_Block(NULL, NULL, "parser", 74);
  gc_frame_newslot(block93);
// method _apply
  block_savedest(block93);
  Object closure94 = createclosure(4, "_apply");
  setclosureframe(closure94, stackframe);
  addtoclosure(closure94, var_n);
  addtoclosure(closure94, var_tokenMatcher);
  addtoclosure(closure94, var_nextTok);
  addtoclosure(closure94, selfslot);
  struct UserObject *uo94 = (struct UserObject*)block93;
  uo94->data[0] = (Object)closure94;
  Method *meth_meth_parser__apply94 = addmethod2pos(block93, "_apply", &meth_parser__apply94, 0);
  int argcv_meth_parser__apply94[] = {0};
  meth_meth_parser__apply94->type = alloc_MethodType(1, argcv_meth_parser__apply94);
  meth_meth_parser__apply94->definitionModule = modulename;
  meth_meth_parser__apply94->definitionLine = 74;
// compiled block node returning block93 (depth = 3)
  gc_frame_newslot(block93);
// call case 5: prelude request
  params[0] = block65;
  params[1] = block93;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call103 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe64);
// compiled call node returning call103 (depth = 2)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool140 = alloc_Boolean(0);
// compiled identifier node returning bool140 (depth = 7)
  int op_slot_right_139 = gc_frame_newslot(bool140);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_139 = gc_frame_newslot(*var_nextTok);
  params[0] = bool140;
  partcv[0] = 1;
  Object opresult142 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult142 (depth = 6)
  gc_frame_end(frame);
  return opresult142;
}
Object meth_parser__apply135(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe136 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block137 = alloc_Block(NULL, NULL, "parser", 89);
  gc_frame_newslot(block137);
// method _apply
  block_savedest(block137);
  Object closure138 = createclosure(2, "_apply");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_nextTok);
  addtoclosure(closure138, selfslot);
  struct UserObject *uo138 = (struct UserObject*)block137;
  uo138->data[0] = (Object)closure138;
  Method *meth_meth_parser__apply138 = addmethod2pos(block137, "_apply", &meth_parser__apply138, 0);
  int argcv_meth_parser__apply138[] = {0};
  meth_meth_parser__apply138->type = alloc_MethodType(1, argcv_meth_parser__apply138);
  meth_meth_parser__apply138->definitionModule = modulename;
  meth_meth_parser__apply138->definitionLine = 84;
// compiled block node returning block137 (depth = 5)
  gc_frame_newslot(block137);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool145 = alloc_Boolean(0);
// compiled identifier node returning bool145 (depth = 6)
  int op_slot_right_144 = gc_frame_newslot(bool145);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_144 = gc_frame_newslot(*var_n);
  params[0] = bool145;
  partcv[0] = 1;
  Object opresult147 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult147 (depth = 5)
  params[0] = block137;
  partcv[0] = 1;
  Object call148 = callmethod(opresult147, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe136);
// compiled call node returning call148 (depth = 4)
  gc_frame_end(frame);
  return call148;
}
Object meth_parser__apply151(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit155 == NULL) {
    strlit155 = alloc_String("eof");
    gc_root(strlit155);
  }
// compiled string node returning strlit155 (depth = 7)
  int op_slot_right_154 = gc_frame_newslot(strlit155);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe157 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call158 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe157);
// compiled call node returning call158 (depth = 8)
// compiled member node returning call158 (depth = 7)
  int op_slot_left_154 = gc_frame_newslot(call158);
  params[0] = strlit155;
  partcv[0] = 1;
  Object opresult159 = callmethod(call158, "==", 1, partcv, params);
// compiled op node returning opresult159 (depth = 6)
  int op_slot_right_153 = gc_frame_newslot(opresult159);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe163 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call164 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe163);
// compiled call node returning call164 (depth = 9)
// compiled member node returning call164 (depth = 8)
  int op_slot_right_162 = gc_frame_newslot(call164);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe166 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call167 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe166);
// compiled call node returning call167 (depth = 9)
// compiled member node returning call167 (depth = 8)
  int op_slot_left_162 = gc_frame_newslot(call167);
  params[0] = call164;
  partcv[0] = 1;
  Object opresult168 = callmethod(call167, "<=", 1, partcv, params);
// compiled op node returning opresult168 (depth = 7)
  int op_slot_right_161 = gc_frame_newslot(opresult168);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe171 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call172 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe171);
// compiled call node returning call172 (depth = 9)
// compiled member node returning call172 (depth = 8)
  int op_slot_right_170 = gc_frame_newslot(call172);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call175 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe174);
// compiled call node returning call175 (depth = 9)
// compiled member node returning call175 (depth = 8)
  int op_slot_left_170 = gc_frame_newslot(call175);
  params[0] = call172;
  partcv[0] = 1;
  Object opresult176 = callmethod(call175, ">", 1, partcv, params);
// compiled op node returning opresult176 (depth = 7)
  int op_slot_left_161 = gc_frame_newslot(opresult176);
  params[0] = opresult168;
  partcv[0] = 1;
  Object opresult177 = callmethod(opresult176, "&&", 1, partcv, params);
// compiled op node returning opresult177 (depth = 6)
  int op_slot_left_153 = gc_frame_newslot(opresult177);
  params[0] = opresult159;
  partcv[0] = 1;
  Object opresult178 = callmethod(opresult177, "||", 1, partcv, params);
// compiled op node returning opresult178 (depth = 5)
  Object if152 = done;
  if (istrue(opresult178)) {
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if152 = done;
  } else {
  }
// compiled if node returning if152 (depth = 4)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call181 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe180);
// compiled call node returning call181 (depth = 6)
// compiled member node returning call181 (depth = 5)
  *var_n = call181;
  if (call181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextTokenIndentedAt104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findNextTokenIndentedAt");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextTokenIndentedAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findNextTokenIndentedAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit108 == NULL) {
    strlit108 = alloc_String("eof");
    gc_root(strlit108);
  }
// compiled string node returning strlit108 (depth = 5)
  int op_slot_right_107 = gc_frame_newslot(strlit108);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call111 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe110);
// compiled call node returning call111 (depth = 6)
// compiled member node returning call111 (depth = 5)
  int op_slot_left_107 = gc_frame_newslot(call111);
  params[0] = strlit108;
  partcv[0] = 1;
  Object opresult112 = callmethod(call111, "==", 1, partcv, params);
// compiled op node returning opresult112 (depth = 4)
  int op_slot_right_106 = gc_frame_newslot(opresult112);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call117 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe116);
// compiled call node returning call117 (depth = 7)
// compiled member node returning call117 (depth = 6)
  int op_slot_right_115 = gc_frame_newslot(call117);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call120 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe119);
// compiled call node returning call120 (depth = 7)
// compiled member node returning call120 (depth = 6)
  int op_slot_left_115 = gc_frame_newslot(call120);
  params[0] = call117;
  partcv[0] = 1;
  Object opresult121 = callmethod(call120, "<=", 1, partcv, params);
// compiled op node returning opresult121 (depth = 5)
  int op_slot_right_114 = gc_frame_newslot(opresult121);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call125 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe124);
// compiled call node returning call125 (depth = 7)
// compiled member node returning call125 (depth = 6)
  int op_slot_right_123 = gc_frame_newslot(call125);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call128 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 7)
// compiled member node returning call128 (depth = 6)
  int op_slot_left_123 = gc_frame_newslot(call128);
  params[0] = call125;
  partcv[0] = 1;
  Object opresult129 = callmethod(call128, ">", 1, partcv, params);
// compiled op node returning opresult129 (depth = 5)
  int op_slot_left_114 = gc_frame_newslot(opresult129);
  params[0] = opresult121;
  partcv[0] = 1;
  Object opresult130 = callmethod(opresult129, "&&", 1, partcv, params);
// compiled op node returning opresult130 (depth = 4)
  int op_slot_left_106 = gc_frame_newslot(opresult130);
  params[0] = opresult112;
  partcv[0] = 1;
  Object opresult131 = callmethod(opresult130, "||", 1, partcv, params);
// compiled op node returning opresult131 (depth = 3)
  Object if105 = done;
  if (istrue(opresult131)) {
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if105 = undefined;
  } else {
  }
// compiled if node returning if105 (depth = 2)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool132 = alloc_Boolean(0);
// compiled identifier node returning bool132 (depth = 3)
  *var_nextTok = bool132;
  if (bool132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe133 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block134 = alloc_Block(NULL, NULL, "parser", 89);
  gc_frame_newslot(block134);
// method _apply
  block_savedest(block134);
  Object closure135 = createclosure(3, "_apply");
  setclosureframe(closure135, stackframe);
  addtoclosure(closure135, var_nextTok);
  addtoclosure(closure135, var_n);
  addtoclosure(closure135, selfslot);
  struct UserObject *uo135 = (struct UserObject*)block134;
  uo135->data[0] = (Object)closure135;
  Method *meth_meth_parser__apply135 = addmethod2pos(block134, "_apply", &meth_parser__apply135, 0);
  int argcv_meth_parser__apply135[] = {0};
  meth_meth_parser__apply135->type = alloc_MethodType(1, argcv_meth_parser__apply135);
  meth_meth_parser__apply135->definitionModule = modulename;
  meth_meth_parser__apply135->definitionLine = 84;
// compiled block node returning block134 (depth = 3)
  gc_frame_newslot(block134);
// starting to compile block node (depth = 3)
  Object block150 = alloc_Block(NULL, NULL, "parser", 89);
  gc_frame_newslot(block150);
// method _apply
  block_savedest(block150);
  Object closure151 = createclosure(5, "_apply");
  setclosureframe(closure151, stackframe);
  addtoclosure(closure151, var_sym);
  addtoclosure(closure151, var_tok);
  addtoclosure(closure151, var_n);
  addtoclosure(closure151, var_nextTok);
  addtoclosure(closure151, selfslot);
  struct UserObject *uo151 = (struct UserObject*)block150;
  uo151->data[0] = (Object)closure151;
  Method *meth_meth_parser__apply151 = addmethod2pos(block150, "_apply", &meth_parser__apply151, 0);
  int argcv_meth_parser__apply151[] = {0};
  meth_meth_parser__apply151->type = alloc_MethodType(1, argcv_meth_parser__apply151);
  meth_meth_parser__apply151->definitionModule = modulename;
  meth_meth_parser__apply151->definitionLine = 84;
// compiled block node returning block150 (depth = 3)
  gc_frame_newslot(block150);
// call case 5: prelude request
  params[0] = block134;
  params[1] = block150;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call184 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe133);
// compiled call node returning call184 (depth = 2)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply200(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit202 == NULL) {
    strlit202 = alloc_String("eof");
    gc_root(strlit202);
  }
// compiled string node returning strlit202 (depth = 5)
  int op_slot_right_201 = gc_frame_newslot(strlit202);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call205 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe204);
// compiled call node returning call205 (depth = 6)
// compiled member node returning call205 (depth = 5)
  int op_slot_left_201 = gc_frame_newslot(call205);
  params[0] = strlit202;
  partcv[0] = 1;
  Object opresult206 = callmethod(call205, "!=", 1, partcv, params);
// compiled op node returning opresult206 (depth = 4)
  gc_frame_end(frame);
  return opresult206;
}
Object meth_parser__apply209(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe211 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe212 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_validToken (depth = 8)
  partcv[0] = 0;
  Object call213 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe212);
// compiled call node returning call213 (depth = 7)
// compiled member node returning call213 (depth = 6)
  gc_frame_newslot(call213);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validFollowTokens (depth = 6)
  params[0] = call213;
  partcv[0] = 1;
  Object call214 = callmethod(*var_validFollowTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe211);
// compiled call node returning call214 (depth = 5)
  Object if210 = done;
  if (istrue(call214)) {
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if210 = undefined;
  } else {
  }
// compiled if node returning if210 (depth = 4)
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe216 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe217 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe218 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_validToken (depth = 9)
  partcv[0] = 0;
  Object call219 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe218);
// compiled call node returning call219 (depth = 8)
// compiled member node returning call219 (depth = 7)
  gc_frame_newslot(call219);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_invalidTokens (depth = 7)
  params[0] = call219;
  partcv[0] = 1;
  Object call220 = callmethod(*var_invalidTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe217);
// compiled call node returning call220 (depth = 6)
  partcv[0] = 0;
  Object call221 = callmethod(call220, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe216);
// compiled call node returning call221 (depth = 5)
  Object if215 = done;
  if (istrue(call221)) {
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if215 = undefined;
  } else {
  }
// compiled if node returning if215 (depth = 4)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call223 = callmethod(*var_validToken, "next",
    1, partcv, params);
  gc_frame_end(callframe222);
// compiled call node returning call223 (depth = 6)
// compiled member node returning call223 (depth = 5)
  *var_validToken = call223;
  if (call223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextValidToken185(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[8];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextValidToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_validFollowTokens = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_validFollowTokens, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = var_init_validFollowTokens;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe186 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit187 == NULL) {
    strlit187 = alloc_String("dot");
    gc_root(strlit187);
  }
// compiled string node returning strlit187 (depth = 4)
  gc_frame_newslot(strlit187);
// starting to compile string node (depth = 4)
  if (strlit188 == NULL) {
    strlit188 = alloc_String("comma");
    gc_root(strlit188);
  }
// compiled string node returning strlit188 (depth = 4)
  gc_frame_newslot(strlit188);
// starting to compile string node (depth = 4)
  if (strlit189 == NULL) {
    strlit189 = alloc_String("colon");
    gc_root(strlit189);
  }
// compiled string node returning strlit189 (depth = 4)
  gc_frame_newslot(strlit189);
// starting to compile string node (depth = 4)
  if (strlit190 == NULL) {
    strlit190 = alloc_String("rparen");
    gc_root(strlit190);
  }
// compiled string node returning strlit190 (depth = 4)
  gc_frame_newslot(strlit190);
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit191 == NULL) {
    strlit191 = alloc_String("rbrace");
    gc_root(strlit191);
  }
// compiled string node returning strlit191 (depth = 4)
  gc_frame_newslot(strlit191);
// starting to compile string node (depth = 4)
  if (strlit192 == NULL) {
    strlit192 = alloc_String("rsquare");
    gc_root(strlit192);
  }
// compiled string node returning strlit192 (depth = 4)
  gc_frame_newslot(strlit192);
// starting to compile string node (depth = 4)
  if (strlit193 == NULL) {
    strlit193 = alloc_String("arrow");
    gc_root(strlit193);
  }
// compiled string node returning strlit193 (depth = 4)
  gc_frame_newslot(strlit193);
// starting to compile string node (depth = 4)
  if (strlit194 == NULL) {
    strlit194 = alloc_String("bind");
    gc_root(strlit194);
  }
// compiled string node returning strlit194 (depth = 4)
  gc_frame_newslot(strlit194);
// call case 6: other member request
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe195 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call196 = callmethodflags(prelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe195);
// compiled call node returning call196 (depth = 5)
// compiled member node returning call196 (depth = 4)
  params[0] = strlit187;
  params[1] = strlit188;
  params[2] = strlit189;
  params[3] = strlit190;
  params[4] = strlit191;
  params[5] = strlit192;
  params[6] = strlit193;
  params[7] = strlit194;
  partcv[0] = 8;
  Object call197 = callmethod(call196, "with",
    1, partcv, params);
  gc_frame_end(callframe186);
// compiled call node returning call197 (depth = 3)
  *var_invalidTokens = call197;
  if (call197 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe198 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block199 = alloc_Block(NULL, NULL, "parser", 103);
  gc_frame_newslot(block199);
// method _apply
  block_savedest(block199);
  Object closure200 = createclosure(2, "_apply");
  setclosureframe(closure200, stackframe);
  addtoclosure(closure200, var_validToken);
  addtoclosure(closure200, selfslot);
  struct UserObject *uo200 = (struct UserObject*)block199;
  uo200->data[0] = (Object)closure200;
  Method *meth_meth_parser__apply200 = addmethod2pos(block199, "_apply", &meth_parser__apply200, 0);
  int argcv_meth_parser__apply200[] = {0};
  meth_meth_parser__apply200->type = alloc_MethodType(1, argcv_meth_parser__apply200);
  meth_meth_parser__apply200->definitionModule = modulename;
  meth_meth_parser__apply200->definitionLine = 100;
// compiled block node returning block199 (depth = 3)
  gc_frame_newslot(block199);
// starting to compile block node (depth = 3)
  Object block208 = alloc_Block(NULL, NULL, "parser", 103);
  gc_frame_newslot(block208);
// method _apply
  block_savedest(block208);
  Object closure209 = createclosure(4, "_apply");
  setclosureframe(closure209, stackframe);
  addtoclosure(closure209, var_validToken);
  addtoclosure(closure209, var_validFollowTokens);
  addtoclosure(closure209, var_invalidTokens);
  addtoclosure(closure209, selfslot);
  struct UserObject *uo209 = (struct UserObject*)block208;
  uo209->data[0] = (Object)closure209;
  Method *meth_meth_parser__apply209 = addmethod2pos(block208, "_apply", &meth_parser__apply209, 0);
  int argcv_meth_parser__apply209[] = {0};
  meth_meth_parser__apply209->type = alloc_MethodType(1, argcv_meth_parser__apply209);
  meth_meth_parser__apply209->definitionModule = modulename;
  meth_meth_parser__apply209->definitionLine = 103;
// compiled block node returning block208 (depth = 3)
  gc_frame_newslot(block208);
// call case 5: prelude request
  params[0] = block199;
  params[1] = block208;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call226 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe198);
// compiled call node returning call226 (depth = 2)
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_validToken (depth = 3)
  return *var_validToken;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply238(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe241 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call242 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe241);
// compiled call node returning call242 (depth = 7)
// compiled member node returning call242 (depth = 6)
  int op_slot_right_240 = gc_frame_newslot(call242);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call245 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe244);
// compiled call node returning call245 (depth = 7)
// compiled member node returning call245 (depth = 6)
  int op_slot_left_240 = gc_frame_newslot(call245);
  params[0] = call242;
  partcv[0] = 1;
  Object opresult246 = callmethod(call245, "==", 1, partcv, params);
// compiled op node returning opresult246 (depth = 5)
  int op_slot_right_239 = gc_frame_newslot(opresult246);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit249 == NULL) {
    strlit249 = alloc_String("eof");
    gc_root(strlit249);
  }
// compiled string node returning strlit249 (depth = 6)
  int op_slot_right_248 = gc_frame_newslot(strlit249);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe251 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call252 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe251);
// compiled call node returning call252 (depth = 7)
// compiled member node returning call252 (depth = 6)
  int op_slot_left_248 = gc_frame_newslot(call252);
  params[0] = strlit249;
  partcv[0] = 1;
  Object opresult253 = callmethod(call252, "!=", 1, partcv, params);
// compiled op node returning opresult253 (depth = 5)
  int op_slot_left_239 = gc_frame_newslot(opresult253);
  params[0] = opresult246;
  partcv[0] = 1;
  Object opresult254 = callmethod(opresult253, "&&", 1, partcv, params);
// compiled op node returning opresult254 (depth = 4)
  gc_frame_end(frame);
  return opresult254;
}
Object meth_parser__apply257(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit260 == NULL) {
    strlit260 = alloc_String("lbrace");
    gc_root(strlit260);
  }
// compiled string node returning strlit260 (depth = 6)
  int op_slot_right_259 = gc_frame_newslot(strlit260);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe262 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call263 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe262);
// compiled call node returning call263 (depth = 7)
// compiled member node returning call263 (depth = 6)
  int op_slot_left_259 = gc_frame_newslot(call263);
  params[0] = strlit260;
  partcv[0] = 1;
  Object opresult264 = callmethod(call263, "==", 1, partcv, params);
// compiled op node returning opresult264 (depth = 5)
  Object if258 = done;
  if (istrue(opresult264)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num266 = alloc_Float64(1);
// compiled num node returning num266 (depth = 7)
  int op_slot_right_265 = gc_frame_newslot(num266);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_265 = gc_frame_newslot(*var_numOpening);
  params[0] = num266;
  partcv[0] = 1;
  Object sum268 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum268 (depth = 6)
  *var_numOpening = sum268;
  if (sum268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if258 = done;
  } else {
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit272 == NULL) {
    strlit272 = alloc_String("rbrace");
    gc_root(strlit272);
  }
// compiled string node returning strlit272 (depth = 7)
  int op_slot_right_271 = gc_frame_newslot(strlit272);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe274 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call275 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe274);
// compiled call node returning call275 (depth = 8)
// compiled member node returning call275 (depth = 7)
  int op_slot_left_271 = gc_frame_newslot(call275);
  params[0] = strlit272;
  partcv[0] = 1;
  Object opresult276 = callmethod(call275, "==", 1, partcv, params);
// compiled op node returning opresult276 (depth = 6)
  Object if270 = done;
  if (istrue(opresult276)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num278 = alloc_Float64(1);
// compiled num node returning num278 (depth = 8)
  int op_slot_right_277 = gc_frame_newslot(num278);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_277 = gc_frame_newslot(*var_numClosing);
  params[0] = num278;
  partcv[0] = 1;
  Object sum280 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum280 (depth = 7)
  *var_numClosing = sum280;
  if (sum280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if270 = done;
  } else {
  }
// compiled if node returning if270 (depth = 5)
    gc_frame_newslot(if270);
    if258 = if270;
  }
// compiled if node returning if258 (depth = 4)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe282 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call283 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe282);
// compiled call node returning call283 (depth = 6)
// compiled member node returning call283 (depth = 5)
  *var_n = call283;
  if (call283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply289(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe292 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call293 = callmethod(*var_token, "indent",
    1, partcv, params);
  gc_frame_end(callframe292);
// compiled call node returning call293 (depth = 7)
// compiled member node returning call293 (depth = 6)
  int op_slot_right_291 = gc_frame_newslot(call293);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe295 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call296 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe295);
// compiled call node returning call296 (depth = 7)
// compiled member node returning call296 (depth = 6)
  int op_slot_left_291 = gc_frame_newslot(call296);
  params[0] = call293;
  partcv[0] = 1;
  Object opresult297 = callmethod(call296, ">", 1, partcv, params);
// compiled op node returning opresult297 (depth = 5)
  int op_slot_right_290 = gc_frame_newslot(opresult297);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit300 == NULL) {
    strlit300 = alloc_String("eof");
    gc_root(strlit300);
  }
// compiled string node returning strlit300 (depth = 6)
  int op_slot_right_299 = gc_frame_newslot(strlit300);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call303 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe302);
// compiled call node returning call303 (depth = 7)
// compiled member node returning call303 (depth = 6)
  int op_slot_left_299 = gc_frame_newslot(call303);
  params[0] = strlit300;
  partcv[0] = 1;
  Object opresult304 = callmethod(call303, "!=", 1, partcv, params);
// compiled op node returning opresult304 (depth = 5)
  int op_slot_left_290 = gc_frame_newslot(opresult304);
  params[0] = opresult297;
  partcv[0] = 1;
  Object opresult305 = callmethod(opresult304, "&&", 1, partcv, params);
// compiled op node returning opresult305 (depth = 4)
  gc_frame_end(frame);
  return opresult305;
}
Object meth_parser__apply308(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit311 == NULL) {
    strlit311 = alloc_String("lbrace");
    gc_root(strlit311);
  }
// compiled string node returning strlit311 (depth = 6)
  int op_slot_right_310 = gc_frame_newslot(strlit311);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call314 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe313);
// compiled call node returning call314 (depth = 7)
// compiled member node returning call314 (depth = 6)
  int op_slot_left_310 = gc_frame_newslot(call314);
  params[0] = strlit311;
  partcv[0] = 1;
  Object opresult315 = callmethod(call314, "==", 1, partcv, params);
// compiled op node returning opresult315 (depth = 5)
  Object if309 = done;
  if (istrue(opresult315)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num317 = alloc_Float64(1);
// compiled num node returning num317 (depth = 7)
  int op_slot_right_316 = gc_frame_newslot(num317);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_316 = gc_frame_newslot(*var_numOpening);
  params[0] = num317;
  partcv[0] = 1;
  Object sum319 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum319 (depth = 6)
  *var_numOpening = sum319;
  if (sum319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if309 = done;
  } else {
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit323 == NULL) {
    strlit323 = alloc_String("rbrace");
    gc_root(strlit323);
  }
// compiled string node returning strlit323 (depth = 7)
  int op_slot_right_322 = gc_frame_newslot(strlit323);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call326 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe325);
// compiled call node returning call326 (depth = 8)
// compiled member node returning call326 (depth = 7)
  int op_slot_left_322 = gc_frame_newslot(call326);
  params[0] = strlit323;
  partcv[0] = 1;
  Object opresult327 = callmethod(call326, "==", 1, partcv, params);
// compiled op node returning opresult327 (depth = 6)
  Object if321 = done;
  if (istrue(opresult327)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num329 = alloc_Float64(1);
// compiled num node returning num329 (depth = 8)
  int op_slot_right_328 = gc_frame_newslot(num329);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_328 = gc_frame_newslot(*var_numClosing);
  params[0] = num329;
  partcv[0] = 1;
  Object sum331 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum331 (depth = 7)
  *var_numClosing = sum331;
  if (sum331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if321 = done;
  } else {
  }
// compiled if node returning if321 (depth = 5)
    gc_frame_newslot(if321);
    if309 = if321;
  }
// compiled if node returning if309 (depth = 4)
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call334 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe333);
// compiled call node returning call334 (depth = 6)
// compiled member node returning call334 (depth = 5)
  *var_n = call334;
  if (call334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findClosingBrace227(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method findClosingBrace");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findClosingBrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for findClosingBrace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inserted (depth = 4)
  Object if228 = done;
struct StackFrameObject *iftmpstackframe228 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe228);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num229 = alloc_Float64(1);
// compiled num node returning num229 (depth = 4)
    gc_frame_newslot(num229);
    if228 = num229;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe228);
  gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num230 = alloc_Float64(0);
// compiled num node returning num230 (depth = 4)
    gc_frame_newslot(num230);
    if228 = num230;
  }
stackframe = iftmpstackframe228;
// compiled if node returning if228 (depth = 3)
  *var_numOpening = if228;
  if (if228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num231 = alloc_Float64(0);
// compiled num node returning num231 (depth = 3)
  *var_numClosing = num231;
  if (num231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject232 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj232 = alloc_userobj2(4,4, objclass232);
  gc_frame_newslot(obj232);
// OBJECT OUTER DEC outer
  adddatum2(obj232, self, 0);
  addmethodreal(obj232,"outer", &reader_parser_outer_233);
  Object oldself232 = self;
  struct StackFrameObject *oldstackframe232 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe232);
  gc_frame_newslot((Object)stackframe);
  self = obj232;
  Object *oldselfslot232 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter232 = (*(struct UserObject *)self).data[0], lowerouter232 = thisouter232;
  if (inheritingObject232) {
    struct UserObject *inho232 = (struct UserObject *)inheritingObject232;
    while (inho232->super != GraceDefaultObject) inho232 = (struct UserObject *)inho232->super;
    inho232->super = obj232;
    self = inheritingObject232;
    *selfslot = self;
    lowerouter232 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter232;
  }
if (objclass232 == NULL) {
  Method *reader234 = addmethodrealflags(obj232, "found",&reader_parser_found_234, 0);
  Method *writer234 = addmethodrealflags(obj232, "found:=",&writer_parser_found_234, 0);
  reader234->definitionModule = modulename;
  writer234->definitionModule = modulename;
  reader234->definitionLine = 128;
  writer234->definitionLine = 128;
}
obj232->flags |= OFLAG_MUTABLE;
adddatum2(obj232, alloc_Undefined(), 1);
if (objclass232 == NULL) {
  Method *reader235 = addmethodrealflags(obj232, "tok",&reader_parser_tok_235, 0);
  Method *writer235 = addmethodrealflags(obj232, "tok:=",&writer_parser_tok_235, 0);
  reader235->definitionModule = modulename;
  writer235->definitionModule = modulename;
  reader235->definitionLine = 129;
  writer235->definitionLine = 129;
}
obj232->flags |= OFLAG_MUTABLE;
adddatum2(obj232, alloc_Undefined(), 2);
  sourceObject = obj232;
  adddatum2(obj232, undefined, 1);
  sourceObject = obj232;
  adddatum2(obj232, undefined, 2);
  objclass232 = obj232->class;
  objclass232->definitionModule = modulename;
  objclass232->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter232;
  self = oldself232;
  selfslot = oldselfslot232;
  stackframe = oldstackframe232;
// compiled object node returning obj232 (depth = 3)
  *var_result = obj232;
  if (obj232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe236 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block237 = alloc_Block(NULL, NULL, "parser", 132);
  gc_frame_newslot(block237);
// method _apply
  block_savedest(block237);
  Object closure238 = createclosure(3, "_apply");
  setclosureframe(closure238, stackframe);
  addtoclosure(closure238, var_token);
  addtoclosure(closure238, var_n);
  addtoclosure(closure238, selfslot);
  struct UserObject *uo238 = (struct UserObject*)block237;
  uo238->data[0] = (Object)closure238;
  Method *meth_meth_parser__apply238 = addmethod2pos(block237, "_apply", &meth_parser__apply238, 0);
  int argcv_meth_parser__apply238[] = {0};
  meth_meth_parser__apply238->type = alloc_MethodType(1, argcv_meth_parser__apply238);
  meth_meth_parser__apply238->definitionModule = modulename;
  meth_meth_parser__apply238->definitionLine = 113;
// compiled block node returning block237 (depth = 3)
  gc_frame_newslot(block237);
// starting to compile block node (depth = 3)
  Object block256 = alloc_Block(NULL, NULL, "parser", 132);
  gc_frame_newslot(block256);
// method _apply
  block_savedest(block256);
  Object closure257 = createclosure(4, "_apply");
  setclosureframe(closure257, stackframe);
  addtoclosure(closure257, var_n);
  addtoclosure(closure257, var_numOpening);
  addtoclosure(closure257, var_numClosing);
  addtoclosure(closure257, selfslot);
  struct UserObject *uo257 = (struct UserObject*)block256;
  uo257->data[0] = (Object)closure257;
  Method *meth_meth_parser__apply257 = addmethod2pos(block256, "_apply", &meth_parser__apply257, 0);
  int argcv_meth_parser__apply257[] = {0};
  meth_meth_parser__apply257->type = alloc_MethodType(1, argcv_meth_parser__apply257);
  meth_meth_parser__apply257->definitionModule = modulename;
  meth_meth_parser__apply257->definitionLine = 132;
// compiled block node returning block256 (depth = 3)
  gc_frame_newslot(block256);
// call case 5: prelude request
  params[0] = block237;
  params[1] = block256;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call286 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe236);
// compiled call node returning call286 (depth = 2)
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe287 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block288 = alloc_Block(NULL, NULL, "parser", 138);
  gc_frame_newslot(block288);
// method _apply
  block_savedest(block288);
  Object closure289 = createclosure(3, "_apply");
  setclosureframe(closure289, stackframe);
  addtoclosure(closure289, var_token);
  addtoclosure(closure289, var_n);
  addtoclosure(closure289, selfslot);
  struct UserObject *uo289 = (struct UserObject*)block288;
  uo289->data[0] = (Object)closure289;
  Method *meth_meth_parser__apply289 = addmethod2pos(block288, "_apply", &meth_parser__apply289, 0);
  int argcv_meth_parser__apply289[] = {0};
  meth_meth_parser__apply289->type = alloc_MethodType(1, argcv_meth_parser__apply289);
  meth_meth_parser__apply289->definitionModule = modulename;
  meth_meth_parser__apply289->definitionLine = 135;
// compiled block node returning block288 (depth = 3)
  gc_frame_newslot(block288);
// starting to compile block node (depth = 3)
  Object block307 = alloc_Block(NULL, NULL, "parser", 138);
  gc_frame_newslot(block307);
// method _apply
  block_savedest(block307);
  Object closure308 = createclosure(4, "_apply");
  setclosureframe(closure308, stackframe);
  addtoclosure(closure308, var_n);
  addtoclosure(closure308, var_numOpening);
  addtoclosure(closure308, var_numClosing);
  addtoclosure(closure308, selfslot);
  struct UserObject *uo308 = (struct UserObject*)block307;
  uo308->data[0] = (Object)closure308;
  Method *meth_meth_parser__apply308 = addmethod2pos(block307, "_apply", &meth_parser__apply308, 0);
  int argcv_meth_parser__apply308[] = {0};
  meth_meth_parser__apply308->type = alloc_MethodType(1, argcv_meth_parser__apply308);
  meth_meth_parser__apply308->definitionModule = modulename;
  meth_meth_parser__apply308->definitionLine = 138;
// compiled block node returning block307 (depth = 3)
  gc_frame_newslot(block307);
// call case 5: prelude request
  params[0] = block288;
  params[1] = block307;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call337 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe287);
// compiled call node returning call337 (depth = 2)
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit340 == NULL) {
    strlit340 = alloc_String("rbrace");
    gc_root(strlit340);
  }
// compiled string node returning strlit340 (depth = 4)
  int op_slot_right_339 = gc_frame_newslot(strlit340);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe342 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call343 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe342);
// compiled call node returning call343 (depth = 5)
// compiled member node returning call343 (depth = 4)
  int op_slot_left_339 = gc_frame_newslot(call343);
  params[0] = strlit340;
  partcv[0] = 1;
  Object opresult344 = callmethod(call343, "==", 1, partcv, params);
// compiled op node returning opresult344 (depth = 3)
  Object if338 = done;
  if (istrue(opresult344)) {
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe345 = gc_frame_new();
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool346 = alloc_Boolean(1);
// compiled identifier node returning bool346 (depth = 5)
  gc_frame_newslot(bool346);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool346;
  partcv[0] = 1;
  Object call347 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe345);
// compiled call node returning call347 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe348 = gc_frame_new();
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call349 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe348);
// compiled call node returning call349 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if338 = done;
  } else {
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numClosing (depth = 6)
  int op_slot_right_352 = gc_frame_newslot(*var_numClosing);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numOpening (depth = 6)
  int op_slot_left_352 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult354 = callmethod(*var_numOpening, "==", 1, partcv, params);
// compiled op node returning opresult354 (depth = 5)
  int op_slot_right_351 = gc_frame_newslot(opresult354);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit357 == NULL) {
    strlit357 = alloc_String("rbrace");
    gc_root(strlit357);
  }
// compiled string node returning strlit357 (depth = 6)
  int op_slot_right_356 = gc_frame_newslot(strlit357);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe359 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe360 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call361 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe360);
// compiled call node returning call361 (depth = 9)
// compiled member node returning call361 (depth = 8)
  partcv[0] = 0;
  Object call362 = callmethod(call361, "kind",
    1, partcv, params);
  gc_frame_end(callframe359);
// compiled call node returning call362 (depth = 7)
// compiled member node returning call362 (depth = 6)
  int op_slot_left_356 = gc_frame_newslot(call362);
  params[0] = strlit357;
  partcv[0] = 1;
  Object opresult363 = callmethod(call362, "==", 1, partcv, params);
// compiled op node returning opresult363 (depth = 5)
  int op_slot_left_351 = gc_frame_newslot(opresult363);
  params[0] = opresult354;
  partcv[0] = 1;
  Object opresult364 = callmethod(opresult363, "&&", 1, partcv, params);
// compiled op node returning opresult364 (depth = 4)
  Object if350 = done;
  if (istrue(opresult364)) {
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe365 = gc_frame_new();
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool366 = alloc_Boolean(1);
// compiled identifier node returning bool366 (depth = 6)
  gc_frame_newslot(bool366);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = bool366;
  partcv[0] = 1;
  Object call367 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe365);
// compiled call node returning call367 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe368 = gc_frame_new();
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call370 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call370 (depth = 7)
// compiled member node returning call370 (depth = 6)
  gc_frame_newslot(call370);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = call370;
  partcv[0] = 1;
  Object call371 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe368);
// compiled call node returning call371 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if350 = done;
  } else {
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe372 = gc_frame_new();
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool373 = alloc_Boolean(0);
// compiled identifier node returning bool373 (depth = 6)
  gc_frame_newslot(bool373);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = bool373;
  partcv[0] = 1;
  Object call374 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe372);
// compiled call node returning call374 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe375 = gc_frame_new();
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call377 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe376);
// compiled call node returning call377 (depth = 7)
// compiled member node returning call377 (depth = 6)
  gc_frame_newslot(call377);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = call377;
  partcv[0] = 1;
  Object call378 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe375);
// compiled call node returning call378 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if350 = done;
  }
// compiled if node returning if350 (depth = 3)
    gc_frame_newslot(if350);
    if338 = if350;
  }
// compiled if node returning if338 (depth = 2)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_accept379(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  int op_slot_right_380 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe382 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call383 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe382);
// compiled call node returning call383 (depth = 4)
// compiled member node returning call383 (depth = 3)
  int op_slot_left_380 = gc_frame_newslot(call383);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult384 = callmethod(call383, "==", 1, partcv, params);
// compiled op node returning opresult384 (depth = 2)
  gc_frame_end(frame);
  return opresult384;
}
Object meth_parser_acceptSameLine385(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method acceptSameLine");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for acceptSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for acceptSameLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastIndent (depth = 5)
  int op_slot_right_388 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call391 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe390);
// compiled call node returning call391 (depth = 6)
// compiled member node returning call391 (depth = 5)
  int op_slot_left_388 = gc_frame_newslot(call391);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult392 = callmethod(call391, ">", 1, partcv, params);
// compiled op node returning opresult392 (depth = 4)
  int op_slot_right_387 = gc_frame_newslot(opresult392);
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call396 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe395);
// compiled call node returning call396 (depth = 6)
// compiled member node returning call396 (depth = 5)
  int op_slot_right_394 = gc_frame_newslot(call396);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_394 = gc_frame_newslot(*var_lastLine);
  params[0] = call396;
  partcv[0] = 1;
  Object opresult398 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult398 (depth = 4)
  int op_slot_left_387 = gc_frame_newslot(opresult398);
  params[0] = opresult392;
  partcv[0] = 1;
  Object opresult399 = callmethod(opresult398, "||", 1, partcv, params);
// compiled op node returning opresult399 (depth = 3)
  int op_slot_right_386 = gc_frame_newslot(opresult399);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_401 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe403 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call404 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe403);
// compiled call node returning call404 (depth = 5)
// compiled member node returning call404 (depth = 4)
  int op_slot_left_401 = gc_frame_newslot(call404);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult405 = callmethod(call404, "==", 1, partcv, params);
// compiled op node returning opresult405 (depth = 3)
  int op_slot_left_386 = gc_frame_newslot(opresult405);
  params[0] = opresult399;
  partcv[0] = 1;
  Object opresult406 = callmethod(opresult405, "&&", 1, partcv, params);
// compiled op node returning opresult406 (depth = 2)
  gc_frame_end(frame);
  return opresult406;
}
Object meth_parser_accept_40__41_onLineOf407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()onLineOf");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe411 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call412 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe411);
// compiled call node returning call412 (depth = 6)
// compiled member node returning call412 (depth = 5)
  int op_slot_right_410 = gc_frame_newslot(call412);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call415 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe414);
// compiled call node returning call415 (depth = 6)
// compiled member node returning call415 (depth = 5)
  int op_slot_left_410 = gc_frame_newslot(call415);
  params[0] = call412;
  partcv[0] = 1;
  Object opresult416 = callmethod(call415, ">", 1, partcv, params);
// compiled op node returning opresult416 (depth = 4)
  int op_slot_right_409 = gc_frame_newslot(opresult416);
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call420 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe419);
// compiled call node returning call420 (depth = 6)
// compiled member node returning call420 (depth = 5)
  int op_slot_right_418 = gc_frame_newslot(call420);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe422 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call423 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe422);
// compiled call node returning call423 (depth = 6)
// compiled member node returning call423 (depth = 5)
  int op_slot_left_418 = gc_frame_newslot(call423);
  params[0] = call420;
  partcv[0] = 1;
  Object opresult424 = callmethod(call423, "==", 1, partcv, params);
// compiled op node returning opresult424 (depth = 4)
  int op_slot_left_409 = gc_frame_newslot(opresult424);
  params[0] = opresult416;
  partcv[0] = 1;
  Object opresult425 = callmethod(opresult424, "||", 1, partcv, params);
// compiled op node returning opresult425 (depth = 3)
  int op_slot_right_408 = gc_frame_newslot(opresult425);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_427 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe429 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call430 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe429);
// compiled call node returning call430 (depth = 5)
// compiled member node returning call430 (depth = 4)
  int op_slot_left_427 = gc_frame_newslot(call430);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult431 = callmethod(call430, "==", 1, partcv, params);
// compiled op node returning opresult431 (depth = 3)
  int op_slot_left_408 = gc_frame_newslot(opresult431);
  params[0] = opresult425;
  partcv[0] = 1;
  Object opresult432 = callmethod(opresult431, "&&", 1, partcv, params);
// compiled op node returning opresult432 (depth = 2)
  gc_frame_end(frame);
  return opresult432;
}
Object meth_parser_accept_40__41_onLineOfLastOr433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOfLastOr");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()onLineOfLastOr");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()onLineOfLastOr");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()onLineOfLastOr (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for onLineOfLastOr");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call438 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe437);
// compiled call node returning call438 (depth = 6)
// compiled member node returning call438 (depth = 5)
  int op_slot_right_436 = gc_frame_newslot(call438);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe440 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call441 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe440);
// compiled call node returning call441 (depth = 6)
// compiled member node returning call441 (depth = 5)
  int op_slot_left_436 = gc_frame_newslot(call441);
  params[0] = call438;
  partcv[0] = 1;
  Object opresult442 = callmethod(call441, "==", 1, partcv, params);
// compiled op node returning opresult442 (depth = 4)
  int op_slot_right_435 = gc_frame_newslot(opresult442);
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call447 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe446);
// compiled call node returning call447 (depth = 7)
// compiled member node returning call447 (depth = 6)
  int op_slot_right_445 = gc_frame_newslot(call447);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe449 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call450 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe449);
// compiled call node returning call450 (depth = 7)
// compiled member node returning call450 (depth = 6)
  int op_slot_left_445 = gc_frame_newslot(call450);
  params[0] = call447;
  partcv[0] = 1;
  Object opresult451 = callmethod(call450, ">", 1, partcv, params);
// compiled op node returning opresult451 (depth = 5)
  int op_slot_right_444 = gc_frame_newslot(opresult451);
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe454 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call455 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe454);
// compiled call node returning call455 (depth = 7)
// compiled member node returning call455 (depth = 6)
  int op_slot_right_453 = gc_frame_newslot(call455);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call458 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe457);
// compiled call node returning call458 (depth = 7)
// compiled member node returning call458 (depth = 6)
  int op_slot_left_453 = gc_frame_newslot(call458);
  params[0] = call455;
  partcv[0] = 1;
  Object opresult459 = callmethod(call458, "==", 1, partcv, params);
// compiled op node returning opresult459 (depth = 5)
  int op_slot_left_444 = gc_frame_newslot(opresult459);
  params[0] = opresult451;
  partcv[0] = 1;
  Object opresult460 = callmethod(opresult459, "||", 1, partcv, params);
// compiled op node returning opresult460 (depth = 4)
  int op_slot_left_435 = gc_frame_newslot(opresult460);
  params[0] = opresult442;
  partcv[0] = 1;
  Object opresult461 = callmethod(opresult460, "||", 1, partcv, params);
// compiled op node returning opresult461 (depth = 3)
  int op_slot_right_434 = gc_frame_newslot(opresult461);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_463 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe465 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call466 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe465);
// compiled call node returning call466 (depth = 5)
// compiled member node returning call466 (depth = 4)
  int op_slot_left_463 = gc_frame_newslot(call466);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult467 = callmethod(call466, "==", 1, partcv, params);
// compiled op node returning opresult467 (depth = 3)
  int op_slot_left_434 = gc_frame_newslot(opresult467);
  params[0] = opresult461;
  partcv[0] = 1;
  Object opresult468 = callmethod(opresult467, "&&", 1, partcv, params);
// compiled op node returning opresult468 (depth = 2)
  gc_frame_end(frame);
  return opresult468;
}
Object meth_parser_tokenOnSameLine469(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokenOnSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for tokenOnSameLine");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_471 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call474 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe473);
// compiled call node returning call474 (depth = 5)
// compiled member node returning call474 (depth = 4)
  int op_slot_left_471 = gc_frame_newslot(call474);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult475 = callmethod(call474, ">", 1, partcv, params);
// compiled op node returning opresult475 (depth = 3)
  int op_slot_right_470 = gc_frame_newslot(opresult475);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe478 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call479 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe478);
// compiled call node returning call479 (depth = 5)
// compiled member node returning call479 (depth = 4)
  int op_slot_right_477 = gc_frame_newslot(call479);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_477 = gc_frame_newslot(*var_lastLine);
  params[0] = call479;
  partcv[0] = 1;
  Object opresult481 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult481 (depth = 3)
  int op_slot_left_470 = gc_frame_newslot(opresult481);
  params[0] = opresult475;
  partcv[0] = 1;
  Object opresult482 = callmethod(opresult481, "||", 1, partcv, params);
// compiled op node returning opresult482 (depth = 2)
  gc_frame_end(frame);
  return opresult482;
}
Object meth_parser_didConsume483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method didConsume");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for didConsume (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for didConsume");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe484 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call485 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe484);
// compiled call node returning call485 (depth = 4)
// compiled member node returning call485 (depth = 3)
  *var_sz = call485;
  if (call485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe486 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ablock (depth = 4)
  partcv[0] = 0;
  Object call487 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe486);
// compiled call node returning call487 (depth = 3)
// compiled member node returning call487 (depth = 2)
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_488 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe490 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call491 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe490);
// compiled call node returning call491 (depth = 4)
// compiled member node returning call491 (depth = 3)
  int op_slot_left_488 = gc_frame_newslot(call491);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult492 = callmethod(call491, "!=", 1, partcv, params);
// compiled op node returning opresult492 (depth = 2)
  gc_frame_end(frame);
  return opresult492;
}
Object meth_parser_ifConsume_40__41_then493(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifConsume()then");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ifConsume()then");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method ifConsume()then");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for ifConsume()then (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ifConsume");
  Object *var_tblock = &(stackframe->slots[1]);
  *var_tblock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for then");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sz");
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call495 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe494);
// compiled call node returning call495 (depth = 4)
// compiled member node returning call495 (depth = 3)
  *var_sz = call495;
  if (call495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ablock (depth = 4)
  partcv[0] = 0;
  Object call497 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe496);
// compiled call node returning call497 (depth = 3)
// compiled member node returning call497 (depth = 2)
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_499 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe501 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call502 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe501);
// compiled call node returning call502 (depth = 5)
// compiled member node returning call502 (depth = 4)
  int op_slot_left_499 = gc_frame_newslot(call502);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult503 = callmethod(call502, "!=", 1, partcv, params);
// compiled op node returning opresult503 (depth = 3)
  Object if498 = done;
  if (istrue(opresult503)) {
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe504 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tblock (depth = 5)
  partcv[0] = 0;
  Object call505 = callmethod(*var_tblock, "apply",
    1, partcv, params);
  gc_frame_end(callframe504);
// compiled call node returning call505 (depth = 4)
// compiled member node returning call505 (depth = 3)
    gc_frame_newslot(call505);
    if498 = call505;
  } else {
  }
// compiled if node returning if498 (depth = 2)
  gc_frame_end(frame);
  return if498;
}
Object meth_parser_pushnum506(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushnum (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushnum");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe507 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call509 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe508);
// compiled call node returning call509 (depth = 5)
// compiled member node returning call509 (depth = 4)
  gc_frame_newslot(call509);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call511 = callmethod(*var_ast, "numNode",
    1, partcv, params);
  gc_frame_end(callframe510);
// compiled call node returning call511 (depth = 5)
// compiled member node returning call511 (depth = 4)
  params[0] = call509;
  partcv[0] = 1;
  Object call512 = callmethod(call511, "new",
    1, partcv, params);
  gc_frame_end(callframe507);
// compiled call node returning call512 (depth = 3)
  *var_o = call512;
  if (call512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe513 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call514 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe513);
// compiled call node returning call514 (depth = 2)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call516 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe515);
// compiled call node returning call516 (depth = 3)
// compiled member node returning call516 (depth = 2)
  gc_frame_end(frame);
  return call516;
}
Object meth_parser_pushoctets517(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushoctets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushoctets (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushoctets");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe518 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call520 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe519);
// compiled call node returning call520 (depth = 5)
// compiled member node returning call520 (depth = 4)
  gc_frame_newslot(call520);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call522 = callmethod(*var_ast, "octetsNode",
    1, partcv, params);
  gc_frame_end(callframe521);
// compiled call node returning call522 (depth = 5)
// compiled member node returning call522 (depth = 4)
  params[0] = call520;
  partcv[0] = 1;
  Object call523 = callmethod(call522, "new",
    1, partcv, params);
  gc_frame_end(callframe518);
// compiled call node returning call523 (depth = 3)
  *var_o = call523;
  if (call523 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe524 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call525 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe524);
// compiled call node returning call525 (depth = 2)
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe526 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call527 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe526);
// compiled call node returning call527 (depth = 3)
// compiled member node returning call527 (depth = 2)
  gc_frame_end(frame);
  return call527;
}
Object meth_parser_pushstring528(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushstring (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushstring");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe529 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call531 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe530);
// compiled call node returning call531 (depth = 5)
// compiled member node returning call531 (depth = 4)
  gc_frame_newslot(call531);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call533 = callmethod(*var_ast, "stringNode",
    1, partcv, params);
  gc_frame_end(callframe532);
// compiled call node returning call533 (depth = 5)
// compiled member node returning call533 (depth = 4)
  params[0] = call531;
  partcv[0] = 1;
  Object call534 = callmethod(call533, "new",
    1, partcv, params);
  gc_frame_end(callframe529);
// compiled call node returning call534 (depth = 3)
  *var_o = call534;
  if (call534 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe535 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call536 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe535);
// compiled call node returning call536 (depth = 2)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe537 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call538 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe537);
// compiled call node returning call538 (depth = 3)
// compiled member node returning call538 (depth = 2)
  gc_frame_end(frame);
  return call538;
}
Object meth_parser_pushidentifier539(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushidentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushidentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe540 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe541 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call542 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe541);
// compiled call node returning call542 (depth = 4)
// compiled member node returning call542 (depth = 3)
  gc_frame_newslot(call542);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe543 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call544 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe543);
// compiled call node returning call544 (depth = 4)
// compiled member node returning call544 (depth = 3)
  gc_frame_newslot(call544);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call542;
  params[1] = call544;
  partcv[0] = 2;
  Object call545 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe540);
// compiled call node returning call545 (depth = 2)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe546 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call548 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe547);
// compiled call node returning call548 (depth = 5)
// compiled member node returning call548 (depth = 4)
  gc_frame_newslot(call548);
// starting to compile identifier node (depth = 4)
  Object bool549 = alloc_Boolean(0);
// compiled identifier node returning bool549 (depth = 4)
  gc_frame_newslot(bool549);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call551 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe550);
// compiled call node returning call551 (depth = 5)
// compiled member node returning call551 (depth = 4)
  params[0] = call548;
  params[1] = bool549;
  partcv[0] = 2;
  Object call552 = callmethod(call551, "new",
    1, partcv, params);
  gc_frame_end(callframe546);
// compiled call node returning call552 (depth = 3)
  *var_o = call552;
  if (call552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit555 == NULL) {
    strlit555 = alloc_String("_");
    gc_root(strlit555);
  }
// compiled string node returning strlit555 (depth = 4)
  int op_slot_right_554 = gc_frame_newslot(strlit555);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call558 = callmethod(*var_o, "value",
    1, partcv, params);
  gc_frame_end(callframe557);
// compiled call node returning call558 (depth = 5)
// compiled member node returning call558 (depth = 4)
  int op_slot_left_554 = gc_frame_newslot(call558);
  params[0] = strlit555;
  partcv[0] = 1;
  Object opresult559 = callmethod(call558, "==", 1, partcv, params);
// compiled op node returning opresult559 (depth = 3)
  Object if553 = done;
  if (istrue(opresult559)) {
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe560 = gc_frame_new();
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_auto_count (depth = 6)
  int op_slot_right_561 = gc_frame_newslot(*var_auto_count);
// starting to compile string node (depth = 6)
  if (strlit563 == NULL) {
    strlit563 = alloc_String("__");
    gc_root(strlit563);
  }
// compiled string node returning strlit563 (depth = 6)
  int op_slot_left_561 = gc_frame_newslot(strlit563);
  params[0] = *var_auto_count;
  partcv[0] = 1;
  Object opresult564 = callmethod(strlit563, "++", 1, partcv, params);
// compiled op node returning opresult564 (depth = 5)
  gc_frame_newslot(opresult564);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = opresult564;
  partcv[0] = 1;
  Object call565 = callmethod(*var_o, "value:=",
    1, partcv, params);
  gc_frame_end(callframe560);
// compiled call node returning call565 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe566 = gc_frame_new();
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool567 = alloc_Boolean(1);
// compiled identifier node returning bool567 (depth = 5)
  gc_frame_newslot(bool567);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool567;
  partcv[0] = 1;
  Object call568 = callmethod(*var_o, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe566);
// compiled call node returning call568 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num570 = alloc_Float64(1);
// compiled num node returning num570 (depth = 5)
  int op_slot_right_569 = gc_frame_newslot(num570);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_569 = gc_frame_newslot(*var_auto_count);
  params[0] = num570;
  partcv[0] = 1;
  Object sum572 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum572 (depth = 4)
  *var_auto_count = sum572;
  if (sum572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if553 = done;
  } else {
  }
// compiled if node returning if553 (depth = 2)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe574 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call575 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe574);
// compiled call node returning call575 (depth = 2)
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe576 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call577 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe576);
// compiled call node returning call577 (depth = 3)
// compiled member node returning call577 (depth = 2)
  gc_frame_end(frame);
  return call577;
}
Object meth_parser__apply587(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit590 == NULL) {
    strlit590 = alloc_String("identifier");
    gc_root(strlit590);
  }
// compiled string node returning strlit590 (depth = 6)
  int op_slot_right_589 = gc_frame_newslot(strlit590);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe592 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call593 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe592);
// compiled call node returning call593 (depth = 7)
// compiled member node returning call593 (depth = 6)
  int op_slot_left_589 = gc_frame_newslot(call593);
  params[0] = strlit590;
  partcv[0] = 1;
  Object opresult594 = callmethod(call593, "==", 1, partcv, params);
// compiled op node returning opresult594 (depth = 5)
  Object if588 = done;
  if (istrue(opresult594)) {
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit597 == NULL) {
    strlit597 = alloc_String("public");
    gc_root(strlit597);
  }
// compiled string node returning strlit597 (depth = 7)
  int op_slot_right_596 = gc_frame_newslot(strlit597);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call600 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe599);
// compiled call node returning call600 (depth = 8)
// compiled member node returning call600 (depth = 7)
  int op_slot_left_596 = gc_frame_newslot(call600);
  params[0] = strlit597;
  partcv[0] = 1;
  Object opresult601 = callmethod(call600, "==", 1, partcv, params);
// compiled op node returning opresult601 (depth = 6)
  Object if595 = done;
  if (istrue(opresult601)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if595 = undefined;
  } else {
  }
// compiled if node returning if595 (depth = 5)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit604 == NULL) {
    strlit604 = alloc_String("readable");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 7)
  int op_slot_right_603 = gc_frame_newslot(strlit604);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call607 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe606);
// compiled call node returning call607 (depth = 8)
// compiled member node returning call607 (depth = 7)
  int op_slot_left_603 = gc_frame_newslot(call607);
  params[0] = strlit604;
  partcv[0] = 1;
  Object opresult608 = callmethod(call607, "==", 1, partcv, params);
// compiled op node returning opresult608 (depth = 6)
  Object if602 = done;
  if (istrue(opresult608)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if602 = undefined;
  } else {
  }
// compiled if node returning if602 (depth = 5)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit611 == NULL) {
    strlit611 = alloc_String("confidential");
    gc_root(strlit611);
  }
// compiled string node returning strlit611 (depth = 7)
  int op_slot_right_610 = gc_frame_newslot(strlit611);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call614 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe613);
// compiled call node returning call614 (depth = 8)
// compiled member node returning call614 (depth = 7)
  int op_slot_left_610 = gc_frame_newslot(call614);
  params[0] = strlit611;
  partcv[0] = 1;
  Object opresult615 = callmethod(call614, "==", 1, partcv, params);
// compiled op node returning opresult615 (depth = 6)
  Object if609 = done;
  if (istrue(opresult615)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if609 = undefined;
  } else {
  }
// compiled if node returning if609 (depth = 5)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit618 == NULL) {
    strlit618 = alloc_String("writable");
    gc_root(strlit618);
  }
// compiled string node returning strlit618 (depth = 7)
  int op_slot_right_617 = gc_frame_newslot(strlit618);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe620 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call621 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe620);
// compiled call node returning call621 (depth = 8)
// compiled member node returning call621 (depth = 7)
  int op_slot_left_617 = gc_frame_newslot(call621);
  params[0] = strlit618;
  partcv[0] = 1;
  Object opresult622 = callmethod(call621, "==", 1, partcv, params);
// compiled op node returning opresult622 (depth = 6)
  Object if616 = done;
  if (istrue(opresult622)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if616 = undefined;
  } else {
  }
// compiled if node returning if616 (depth = 5)
    gc_frame_newslot(if616);
    if588 = if616;
  } else {
  }
// compiled if node returning if588 (depth = 4)
  gc_frame_end(frame);
  return if588;
}
Object meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "adjustVisibilityOf()withSpecialDefault()overriding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for adjustVisibilityOf()withSpecialDefault()overriding (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for adjustVisibilityOf");
  Object *var_sd = &(stackframe->slots[1]);
  *var_sd = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for withSpecialDefault");
  Object *var_nd = &(stackframe->slots[2]);
  *var_nd = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for overriding");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newAnn = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newAnn");
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  int op_slot_right_580 = gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sd (depth = 4)
  int op_slot_left_580 = gc_frame_newslot(*var_sd);
  params[0] = *var_nd;
  partcv[0] = 1;
  Object opresult582 = callmethod(*var_sd, "==", 1, partcv, params);
// compiled op node returning opresult582 (depth = 3)
  Object if579 = done;
  if (istrue(opresult582)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if579 = undefined;
  } else {
  }
// compiled if node returning if579 (depth = 2)
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe583 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe584 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call585 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe584);
// compiled call node returning call585 (depth = 4)
// compiled member node returning call585 (depth = 3)
  gc_frame_newslot(call585);
// starting to compile block node (depth = 3)
  Object block586 = alloc_Block(NULL, NULL, "parser", 242);
  gc_frame_newslot(block586);
// method _apply
  block_savedest(block586);
  Object closure587 = createclosure(2, "_apply");
  setclosureframe(closure587, stackframe);
  addtoclosure(closure587, var_done);
  addtoclosure(closure587, selfslot);
  struct UserObject *uo587 = (struct UserObject*)block586;
  uo587->data[0] = (Object)closure587;
  Method *meth_meth_parser__apply587 = addmethod2pos(block586, "_apply", &meth_parser__apply587, 0);
  int argcv_meth_parser__apply587[] = {1};
  meth_meth_parser__apply587->type = alloc_MethodType(1, argcv_meth_parser__apply587);
  meth_meth_parser__apply587->definitionModule = modulename;
  meth_meth_parser__apply587->definitionLine = 242;
// compiled block node returning block586 (depth = 3)
  gc_frame_newslot(block586);
// call case 5: prelude request
  params[0] = call585;
  params[1] = block586;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call624 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe583);
// compiled call node returning call624 (depth = 2)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe625 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sd (depth = 4)
  gc_frame_newslot(*var_sd);
// starting to compile identifier node (depth = 4)
  Object bool626 = alloc_Boolean(0);
// compiled identifier node returning bool626 (depth = 4)
  gc_frame_newslot(bool626);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call628 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe627);
// compiled call node returning call628 (depth = 5)
// compiled member node returning call628 (depth = 4)
  params[0] = *var_sd;
  params[1] = bool626;
  partcv[0] = 2;
  Object call629 = callmethod(call628, "new",
    1, partcv, params);
  gc_frame_end(callframe625);
// compiled call node returning call629 (depth = 3)
  *var_newAnn = call629;
  if (call629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe630 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newAnn (depth = 3)
  gc_frame_newslot(*var_newAnn);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call632 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe631);
// compiled call node returning call632 (depth = 4)
// compiled member node returning call632 (depth = 3)
  params[0] = *var_newAnn;
  partcv[0] = 1;
  Object call633 = callmethod(call632, "push",
    1, partcv, params);
  gc_frame_end(callframe630);
// compiled call node returning call633 (depth = 2)
  gc_frame_end(frame);
  return call633;
}
Object meth_parser__apply655(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool657 = alloc_Boolean(0);
// compiled identifier node returning bool657 (depth = 11)
  int op_slot_right_656 = gc_frame_newslot(bool657);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call660 = callmethod(*var_a, "dtype",
    1, partcv, params);
  gc_frame_end(callframe659);
// compiled call node returning call660 (depth = 12)
// compiled member node returning call660 (depth = 11)
  int op_slot_left_656 = gc_frame_newslot(call660);
  params[0] = bool657;
  partcv[0] = 1;
  Object opresult661 = callmethod(call660, "!=", 1, partcv, params);
// compiled op node returning opresult661 (depth = 10)
  gc_frame_end(frame);
  return opresult661;
}
Object meth_parser__apply672(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit674 == NULL) {
    strlit674 = alloc_String(":");
    gc_root(strlit674);
  }
// compiled string node returning strlit674 (depth = 11)
  int op_slot_right_673 = gc_frame_newslot(strlit674);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe676 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call677 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe676);
// compiled call node returning call677 (depth = 12)
// compiled member node returning call677 (depth = 11)
  int op_slot_left_673 = gc_frame_newslot(call677);
  params[0] = strlit674;
  partcv[0] = 1;
  Object opresult678 = callmethod(call677, "!=", 1, partcv, params);
// compiled op node returning opresult678 (depth = 10)
  gc_frame_end(frame);
  return opresult678;
}
Object meth_parser__apply681(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call683 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe682);
// compiled call node returning call683 (depth = 12)
// compiled member node returning call683 (depth = 11)
  *var_tok = call683;
  if (call683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply651(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe653 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block654 = alloc_Block(NULL, NULL, "parser", 257);
  gc_frame_newslot(block654);
// method _apply
  block_savedest(block654);
  Object closure655 = createclosure(2, "_apply");
  setclosureframe(closure655, stackframe);
  addtoclosure(closure655, var_a);
  addtoclosure(closure655, selfslot);
  struct UserObject *uo655 = (struct UserObject*)block654;
  uo655->data[0] = (Object)closure655;
  Method *meth_meth_parser__apply655 = addmethod2pos(block654, "_apply", &meth_parser__apply655, 0);
  int argcv_meth_parser__apply655[] = {0};
  meth_meth_parser__apply655->type = alloc_MethodType(1, argcv_meth_parser__apply655);
  meth_meth_parser__apply655->definitionModule = modulename;
  meth_meth_parser__apply655->definitionLine = 256;
// compiled block node returning block654 (depth = 9)
  gc_frame_newslot(block654);
// call case 6: other member request
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit664 == NULL) {
    strlit664 = alloc_String("identifier");
    gc_root(strlit664);
  }
// compiled string node returning strlit664 (depth = 10)
  int op_slot_right_663 = gc_frame_newslot(strlit664);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call667 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe666);
// compiled call node returning call667 (depth = 11)
// compiled member node returning call667 (depth = 10)
  int op_slot_left_663 = gc_frame_newslot(call667);
  params[0] = strlit664;
  partcv[0] = 1;
  Object opresult668 = callmethod(call667, "==", 1, partcv, params);
// compiled op node returning opresult668 (depth = 9)
  params[0] = block654;
  partcv[0] = 1;
  Object call669 = callmethod(opresult668, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe653);
// compiled call node returning call669 (depth = 8)
  Object if652 = done;
  if (istrue(call669)) {
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe670 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block671 = alloc_Block(NULL, NULL, "parser", 260);
  gc_frame_newslot(block671);
// method _apply
  block_savedest(block671);
  Object closure672 = createclosure(2, "_apply");
  setclosureframe(closure672, stackframe);
  addtoclosure(closure672, var_tok);
  addtoclosure(closure672, selfslot);
  struct UserObject *uo672 = (struct UserObject*)block671;
  uo672->data[0] = (Object)closure672;
  Method *meth_meth_parser__apply672 = addmethod2pos(block671, "_apply", &meth_parser__apply672, 0);
  int argcv_meth_parser__apply672[] = {0};
  meth_meth_parser__apply672->type = alloc_MethodType(1, argcv_meth_parser__apply672);
  meth_meth_parser__apply672->definitionModule = modulename;
  meth_meth_parser__apply672->definitionLine = 257;
// compiled block node returning block671 (depth = 9)
  gc_frame_newslot(block671);
// starting to compile block node (depth = 9)
  Object block680 = alloc_Block(NULL, NULL, "parser", 260);
  gc_frame_newslot(block680);
// method _apply
  block_savedest(block680);
  Object closure681 = createclosure(2, "_apply");
  setclosureframe(closure681, stackframe);
  addtoclosure(closure681, var_tok);
  addtoclosure(closure681, selfslot);
  struct UserObject *uo681 = (struct UserObject*)block680;
  uo681->data[0] = (Object)closure681;
  Method *meth_meth_parser__apply681 = addmethod2pos(block680, "_apply", &meth_parser__apply681, 0);
  int argcv_meth_parser__apply681[] = {0};
  meth_meth_parser__apply681->type = alloc_MethodType(1, argcv_meth_parser__apply681);
  meth_meth_parser__apply681->definitionModule = modulename;
  meth_meth_parser__apply681->definitionLine = 260;
// compiled block node returning block680 (depth = 9)
  gc_frame_newslot(block680);
// call case 5: prelude request
  params[0] = block671;
  params[1] = block680;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call686 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe670);
// compiled call node returning call686 (depth = 8)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe687 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call689 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe688);
// compiled call node returning call689 (depth = 12)
// compiled member node returning call689 (depth = 11)
  partcv[0] = 0;
  Object call690 = callmethod(call689, "new",
    1, partcv, params);
  gc_frame_end(callframe687);
// compiled call node returning call690 (depth = 10)
// compiled member node returning call690 (depth = 9)
  *var_suggestion = call690;
  if (call690 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe691 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call693 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe692);
// compiled call node returning call693 (depth = 10)
// compiled member node returning call693 (depth = 9)
  gc_frame_newslot(call693);
// starting to compile identifier node (depth = 9)
  Object bool694 = alloc_Boolean(1);
// compiled identifier node returning bool694 (depth = 9)
  gc_frame_newslot(bool694);
// starting to compile identifier node (depth = 9)
  Object bool695 = alloc_Boolean(0);
// compiled identifier node returning bool695 (depth = 9)
  gc_frame_newslot(bool695);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_tok;
  params[1] = call693;
  params[2] = bool694;
  params[3] = bool695;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call696 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe691);
// compiled call node returning call696 (depth = 8)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe697 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit698 == NULL) {
    strlit698 = alloc_String("An argument to an annotation cannot have a type.");
    gc_root(strlit698);
  }
// compiled string node returning strlit698 (depth = 9)
  gc_frame_newslot(strlit698);
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call700 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe699);
// compiled call node returning call700 (depth = 10)
// compiled member node returning call700 (depth = 9)
  gc_frame_newslot(call700);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call702 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe701);
// compiled call node returning call702 (depth = 10)
// compiled member node returning call702 (depth = 9)
  gc_frame_newslot(call702);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num704 = alloc_Float64(1);
// compiled num node returning num704 (depth = 10)
  int op_slot_right_703 = gc_frame_newslot(num704);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe707 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe708 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call709 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe708);
// compiled call node returning call709 (depth = 14)
// compiled member node returning call709 (depth = 13)
  partcv[0] = 0;
  Object call710 = callmethod(call709, "size",
    1, partcv, params);
  gc_frame_end(callframe707);
// compiled call node returning call710 (depth = 12)
// compiled member node returning call710 (depth = 11)
  int op_slot_right_706 = gc_frame_newslot(call710);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe712 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe713 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call714 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe713);
// compiled call node returning call714 (depth = 14)
// compiled member node returning call714 (depth = 13)
  partcv[0] = 0;
  Object call715 = callmethod(call714, "linePos",
    1, partcv, params);
  gc_frame_end(callframe712);
// compiled call node returning call715 (depth = 12)
// compiled member node returning call715 (depth = 11)
  int op_slot_left_706 = gc_frame_newslot(call715);
  params[0] = call710;
  partcv[0] = 1;
  Object sum716 = callmethod(call715, "+", 1, partcv, params);
// compiled op node returning sum716 (depth = 10)
  int op_slot_left_703 = gc_frame_newslot(sum716);
  params[0] = num704;
  partcv[0] = 1;
  Object diff717 = callmethod(sum716, "-", 1, partcv, params);
// compiled op node returning diff717 (depth = 9)
  gc_frame_newslot(diff717);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit698;
  params[1] = call700;
  params[2] = call702;
  params[3] = diff717;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call718 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe697);
// compiled call node returning call718 (depth = 8)
    gc_frame_newslot(call718);
    if652 = call718;
  } else {
  }
// compiled if node returning if652 (depth = 7)
  gc_frame_end(frame);
  return if652;
}
Object meth_parser__apply646(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe647 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe648 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  partcv[0] = 0;
  Object call649 = callmethod(*var_p, "args",
    1, partcv, params);
  gc_frame_end(callframe648);
// compiled call node returning call649 (depth = 7)
// compiled member node returning call649 (depth = 6)
  gc_frame_newslot(call649);
// starting to compile block node (depth = 6)
  Object block650 = alloc_Block(NULL, NULL, "parser", 256);
  gc_frame_newslot(block650);
// method _apply
  block_savedest(block650);
  Object closure651 = createclosure(3, "_apply");
  setclosureframe(closure651, stackframe);
  addtoclosure(closure651, var_sym);
  addtoclosure(closure651, var_errormessages);
  addtoclosure(closure651, selfslot);
  struct UserObject *uo651 = (struct UserObject*)block650;
  uo651->data[0] = (Object)closure651;
  Method *meth_meth_parser__apply651 = addmethod2pos(block650, "_apply", &meth_parser__apply651, 0);
  int argcv_meth_parser__apply651[] = {1};
  meth_meth_parser__apply651->type = alloc_MethodType(1, argcv_meth_parser__apply651);
  meth_meth_parser__apply651->definitionModule = modulename;
  meth_meth_parser__apply651->definitionLine = 256;
// compiled block node returning block650 (depth = 6)
  gc_frame_newslot(block650);
// call case 5: prelude request
  params[0] = call649;
  params[1] = block650;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call720 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe647);
// compiled call node returning call720 (depth = 5)
  gc_frame_end(frame);
  return call720;
}
Object meth_parser_checkAnnotation634(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method checkAnnotation");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for checkAnnotation");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit637 == NULL) {
    strlit637 = alloc_String("call");
    gc_root(strlit637);
  }
// compiled string node returning strlit637 (depth = 4)
  int op_slot_right_636 = gc_frame_newslot(strlit637);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe639 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call640 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe639);
// compiled call node returning call640 (depth = 5)
// compiled member node returning call640 (depth = 4)
  int op_slot_left_636 = gc_frame_newslot(call640);
  params[0] = strlit637;
  partcv[0] = 1;
  Object opresult641 = callmethod(call640, "==", 1, partcv, params);
// compiled op node returning opresult641 (depth = 3)
  Object if635 = done;
  if (istrue(opresult641)) {
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe642 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call644 = callmethod(*var_ann, "with",
    1, partcv, params);
  gc_frame_end(callframe643);
// compiled call node returning call644 (depth = 5)
// compiled member node returning call644 (depth = 4)
  gc_frame_newslot(call644);
// starting to compile block node (depth = 4)
  Object block645 = alloc_Block(NULL, NULL, "parser", 255);
  gc_frame_newslot(block645);
// method _apply
  block_savedest(block645);
  Object closure646 = createclosure(3, "_apply");
  setclosureframe(closure646, stackframe);
  addtoclosure(closure646, var_sym);
  addtoclosure(closure646, var_errormessages);
  addtoclosure(closure646, selfslot);
  struct UserObject *uo646 = (struct UserObject*)block645;
  uo646->data[0] = (Object)closure646;
  Method *meth_meth_parser__apply646 = addmethod2pos(block645, "_apply", &meth_parser__apply646, 0);
  int argcv_meth_parser__apply646[] = {1};
  meth_meth_parser__apply646->type = alloc_MethodType(1, argcv_meth_parser__apply646);
  meth_meth_parser__apply646->definitionModule = modulename;
  meth_meth_parser__apply646->definitionLine = 255;
// compiled block node returning block645 (depth = 4)
  gc_frame_newslot(block645);
// call case 5: prelude request
  params[0] = call644;
  params[1] = block645;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call722 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe642);
// compiled call node returning call722 (depth = 3)
    gc_frame_newslot(call722);
    if635 = call722;
  } else {
  }
// compiled if node returning if635 (depth = 2)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ann (depth = 2)
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser__apply727(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit729 == NULL) {
    strlit729 = alloc_String("is");
    gc_root(strlit729);
  }
// compiled string node returning strlit729 (depth = 6)
  int op_slot_right_728 = gc_frame_newslot(strlit729);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe731 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call732 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe731);
// compiled call node returning call732 (depth = 7)
// compiled member node returning call732 (depth = 6)
  int op_slot_left_728 = gc_frame_newslot(call732);
  params[0] = strlit729;
  partcv[0] = 1;
  Object opresult733 = callmethod(call732, "!=", 1, partcv, params);
// compiled op node returning opresult733 (depth = 5)
  gc_frame_end(frame);
  return opresult733;
}
Object meth_parser__apply752(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe753 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_noBlocks (depth = 8)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call754 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe753);
// compiled call node returning call754 (depth = 7)
  gc_frame_end(frame);
  return call754;
}
Object meth_parser__apply816(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe817 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit818 == NULL) {
    strlit818 = alloc_String("comma");
    gc_root(strlit818);
  }
// compiled string node returning strlit818 (depth = 5)
  gc_frame_newslot(strlit818);
// call case 4: self request
  params[0] = strlit818;
  partcv[0] = 1;
  Object call819 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe817);
// compiled call node returning call819 (depth = 4)
  gc_frame_end(frame);
  return call819;
}
Object meth_parser__apply835(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe836 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_noBlocks (depth = 10)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call837 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe836);
// compiled call node returning call837 (depth = 9)
  gc_frame_end(frame);
  return call837;
}
Object meth_parser__apply822(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe823 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe824 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call826 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe825);
// compiled call node returning call826 (depth = 7)
// compiled member node returning call826 (depth = 6)
  gc_frame_newslot(call826);
// call case 4: self request
  params[0] = call826;
  partcv[0] = 1;
  Object call827 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe824);
// compiled call node returning call827 (depth = 5)
  gc_frame_newslot(call827);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  params[0] = call827;
  partcv[0] = 1;
  Object call828 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe823);
// compiled call node returning call828 (depth = 4)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe829 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call830 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe829);
// compiled call node returning call830 (depth = 5)
// compiled member node returning call830 (depth = 4)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe832 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe833 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block834 = alloc_Block(NULL, NULL, "parser", 296);
  gc_frame_newslot(block834);
// method _apply
  block_savedest(block834);
  Object closure835 = createclosure(2, "_apply");
  setclosureframe(closure835, stackframe);
  addtoclosure(closure835, var_noBlocks);
  addtoclosure(closure835, selfslot);
  struct UserObject *uo835 = (struct UserObject*)block834;
  uo835->data[0] = (Object)closure835;
  Method *meth_meth_parser__apply835 = addmethod2pos(block834, "_apply", &meth_parser__apply835, 0);
  int argcv_meth_parser__apply835[] = {0};
  meth_meth_parser__apply835->type = alloc_MethodType(1, argcv_meth_parser__apply835);
  meth_meth_parser__apply835->definitionModule = modulename;
  meth_meth_parser__apply835->definitionLine = 296;
// compiled block node returning block834 (depth = 8)
  gc_frame_newslot(block834);
// call case 4: self request
  params[0] = block834;
  partcv[0] = 1;
  Object call839 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe833);
// compiled call node returning call839 (depth = 7)
  partcv[0] = 0;
  Object call840 = callmethod(call839, "not",
    1, partcv, params);
  gc_frame_end(callframe832);
// compiled call node returning call840 (depth = 6)
// compiled member node returning call840 (depth = 5)
  Object if831 = done;
  if (istrue(call840)) {
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe841 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe842 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call843 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe842);
// compiled call node returning call843 (depth = 9)
// compiled member node returning call843 (depth = 8)
  partcv[0] = 0;
  Object call844 = callmethod(call843, "empty",
    1, partcv, params);
  gc_frame_end(callframe841);
// compiled call node returning call844 (depth = 7)
// compiled member node returning call844 (depth = 6)
  *var_suggestions = call844;
  if (call844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe845 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe846 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call847 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe846);
// compiled call node returning call847 (depth = 9)
// compiled member node returning call847 (depth = 8)
  partcv[0] = 0;
  Object call848 = callmethod(call847, "new",
    1, partcv, params);
  gc_frame_end(callframe845);
// compiled call node returning call848 (depth = 7)
// compiled member node returning call848 (depth = 6)
  *var_suggestion = call848;
  if (call848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe849 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit850 == NULL) {
    strlit850 = alloc_String("bind");
    gc_root(strlit850);
  }
// compiled string node returning strlit850 (depth = 7)
  gc_frame_newslot(strlit850);
// call case 4: self request
  params[0] = strlit850;
  partcv[0] = 1;
  Object call851 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe849);
// compiled call node returning call851 (depth = 6)
  *var_nextTok = call851;
  if (call851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_853 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_853 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult855 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult855 (depth = 6)
  Object if852 = done;
  if (istrue(opresult855)) {
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe856 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit857 == NULL) {
    strlit857 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit857);
  }
// compiled string node returning strlit857 (depth = 7)
  gc_frame_newslot(strlit857);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit857;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call858 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe856);
// compiled call node returning call858 (depth = 6)
    gc_frame_newslot(call858);
    if852 = call858;
  } else {
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe859 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call861 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe860);
// compiled call node returning call861 (depth = 8)
// compiled member node returning call861 (depth = 7)
  gc_frame_newslot(call861);
// starting to compile identifier node (depth = 7)
  Object bool862 = alloc_Boolean(1);
// compiled identifier node returning bool862 (depth = 7)
  gc_frame_newslot(bool862);
// starting to compile identifier node (depth = 7)
  Object bool863 = alloc_Boolean(0);
// compiled identifier node returning bool863 (depth = 7)
  gc_frame_newslot(bool863);
// starting to compile string node (depth = 7)
  if (strlit864 == NULL) {
    strlit864 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit864);
  }
// compiled string node returning strlit864 (depth = 7)
  gc_frame_newslot(strlit864);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call861;
  params[2] = bool862;
  params[3] = bool863;
  params[4] = strlit864;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call865 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe859);
// compiled call node returning call865 (depth = 6)
    gc_frame_newslot(call865);
    if852 = call865;
  }
// compiled if node returning if852 (depth = 5)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe866 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call867 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe866);
// compiled call node returning call867 (depth = 5)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe868 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe869 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call870 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe869);
// compiled call node returning call870 (depth = 9)
// compiled member node returning call870 (depth = 8)
  partcv[0] = 0;
  Object call871 = callmethod(call870, "new",
    1, partcv, params);
  gc_frame_end(callframe868);
// compiled call node returning call871 (depth = 7)
// compiled member node returning call871 (depth = 6)
  *var_suggestion = call871;
  if (call871 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe873 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe874 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call875 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe874);
// compiled call node returning call875 (depth = 7)
// compiled member node returning call875 (depth = 6)
  gc_frame_newslot(call875);
// starting to compile identifier node (depth = 6)
  Object bool876 = alloc_Boolean(1);
// compiled identifier node returning bool876 (depth = 6)
  gc_frame_newslot(bool876);
// starting to compile identifier node (depth = 6)
  Object bool877 = alloc_Boolean(0);
// compiled identifier node returning bool877 (depth = 6)
  gc_frame_newslot(bool877);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call875;
  params[2] = bool876;
  params[3] = bool877;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call878 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe873);
// compiled call node returning call878 (depth = 5)
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe879 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call880 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe879);
// compiled call node returning call880 (depth = 5)
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe881 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit882 == NULL) {
    strlit882 = alloc_String("One or more annotations separated by commas must follow 'is'.");
    gc_root(strlit882);
  }
// compiled string node returning strlit882 (depth = 6)
  gc_frame_newslot(strlit882);
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe883 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call884 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe883);
// compiled call node returning call884 (depth = 7)
// compiled member node returning call884 (depth = 6)
  gc_frame_newslot(call884);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num886 = alloc_Float64(1);
// compiled num node returning num886 (depth = 7)
  int op_slot_right_885 = gc_frame_newslot(num886);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe889 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call890 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe889);
// compiled call node returning call890 (depth = 9)
// compiled member node returning call890 (depth = 8)
  int op_slot_right_888 = gc_frame_newslot(call890);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe892 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call893 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe892);
// compiled call node returning call893 (depth = 9)
// compiled member node returning call893 (depth = 8)
  int op_slot_left_888 = gc_frame_newslot(call893);
  params[0] = call890;
  partcv[0] = 1;
  Object sum894 = callmethod(call893, "+", 1, partcv, params);
// compiled op node returning sum894 (depth = 7)
  int op_slot_left_885 = gc_frame_newslot(sum894);
  params[0] = num886;
  partcv[0] = 1;
  Object sum895 = callmethod(sum894, "+", 1, partcv, params);
// compiled op node returning sum895 (depth = 6)
  gc_frame_newslot(sum895);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit882;
  params[1] = call884;
  params[2] = sum895;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call896 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe881);
// compiled call node returning call896 (depth = 5)
    gc_frame_newslot(call896);
    if831 = call896;
  } else {
  }
// compiled if node returning if831 (depth = 4)
  gc_frame_end(frame);
  return if831;
}
Object meth_parser_doannotation723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_noBlocks = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doannotation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doannotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe725 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block726 = alloc_Block(NULL, NULL, "parser", 272);
  gc_frame_newslot(block726);
// method _apply
  block_savedest(block726);
  Object closure727 = createclosure(2, "_apply");
  setclosureframe(closure727, stackframe);
  addtoclosure(closure727, var_sym);
  addtoclosure(closure727, selfslot);
  struct UserObject *uo727 = (struct UserObject*)block726;
  uo727->data[0] = (Object)closure727;
  Method *meth_meth_parser__apply727 = addmethod2pos(block726, "_apply", &meth_parser__apply727, 0);
  int argcv_meth_parser__apply727[] = {0};
  meth_meth_parser__apply727->type = alloc_MethodType(1, argcv_meth_parser__apply727);
  meth_meth_parser__apply727->definitionModule = modulename;
  meth_meth_parser__apply727->definitionLine = 264;
// compiled block node returning block726 (depth = 4)
  gc_frame_newslot(block726);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe735 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe736 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit737 == NULL) {
    strlit737 = alloc_String("keyword");
    gc_root(strlit737);
  }
// compiled string node returning strlit737 (depth = 6)
  gc_frame_newslot(strlit737);
// call case 4: self request
  params[0] = strlit737;
  partcv[0] = 1;
  Object call738 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe736);
// compiled call node returning call738 (depth = 5)
  partcv[0] = 0;
  Object call739 = callmethod(call738, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe735);
// compiled call node returning call739 (depth = 4)
  params[0] = block726;
  partcv[0] = 1;
  Object call740 = callmethod(call739, "orElse",
    1, partcv, params);
  gc_frame_end(callframe725);
// compiled call node returning call740 (depth = 3)
  Object if724 = done;
  if (istrue(call740)) {
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool741 = alloc_Boolean(0);
// compiled identifier node returning bool741 (depth = 4)
  return bool741;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if724 = undefined;
  } else {
  }
// compiled if node returning if724 (depth = 2)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call743 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe742);
// compiled call node returning call743 (depth = 3)
// compiled member node returning call743 (depth = 2)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe744 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe745 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call746 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe745);
// compiled call node returning call746 (depth = 6)
// compiled member node returning call746 (depth = 5)
  partcv[0] = 0;
  Object call747 = callmethod(call746, "empty",
    1, partcv, params);
  gc_frame_end(callframe744);
// compiled call node returning call747 (depth = 4)
// compiled member node returning call747 (depth = 3)
  *var_anns = call747;
  if (call747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe749 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe750 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block751 = alloc_Block(NULL, NULL, "parser", 277);
  gc_frame_newslot(block751);
// method _apply
  block_savedest(block751);
  Object closure752 = createclosure(2, "_apply");
  setclosureframe(closure752, stackframe);
  addtoclosure(closure752, var_noBlocks);
  addtoclosure(closure752, selfslot);
  struct UserObject *uo752 = (struct UserObject*)block751;
  uo752->data[0] = (Object)closure752;
  Method *meth_meth_parser__apply752 = addmethod2pos(block751, "_apply", &meth_parser__apply752, 0);
  int argcv_meth_parser__apply752[] = {0};
  meth_meth_parser__apply752->type = alloc_MethodType(1, argcv_meth_parser__apply752);
  meth_meth_parser__apply752->definitionModule = modulename;
  meth_meth_parser__apply752->definitionLine = 277;
// compiled block node returning block751 (depth = 6)
  gc_frame_newslot(block751);
// call case 4: self request
  params[0] = block751;
  partcv[0] = 1;
  Object call756 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe750);
// compiled call node returning call756 (depth = 5)
  partcv[0] = 0;
  Object call757 = callmethod(call756, "not",
    1, partcv, params);
  gc_frame_end(callframe749);
// compiled call node returning call757 (depth = 4)
// compiled member node returning call757 (depth = 3)
  Object if748 = done;
  if (istrue(call757)) {
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe758 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe759 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call760 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe759);
// compiled call node returning call760 (depth = 7)
// compiled member node returning call760 (depth = 6)
  partcv[0] = 0;
  Object call761 = callmethod(call760, "empty",
    1, partcv, params);
  gc_frame_end(callframe758);
// compiled call node returning call761 (depth = 5)
// compiled member node returning call761 (depth = 4)
  *var_suggestions = call761;
  if (call761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe762 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call764 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe763);
// compiled call node returning call764 (depth = 7)
// compiled member node returning call764 (depth = 6)
  partcv[0] = 0;
  Object call765 = callmethod(call764, "new",
    1, partcv, params);
  gc_frame_end(callframe762);
// compiled call node returning call765 (depth = 5)
// compiled member node returning call765 (depth = 4)
  *var_suggestion = call765;
  if (call765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe766 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit767 == NULL) {
    strlit767 = alloc_String("bind");
    gc_root(strlit767);
  }
// compiled string node returning strlit767 (depth = 5)
  gc_frame_newslot(strlit767);
// call case 4: self request
  params[0] = strlit767;
  partcv[0] = 1;
  Object call768 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe766);
// compiled call node returning call768 (depth = 4)
  *var_nextTok = call768;
  if (call768 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_770 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_770 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult772 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult772 (depth = 4)
  Object if769 = done;
  if (istrue(opresult772)) {
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe773 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit774 == NULL) {
    strlit774 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit774);
  }
// compiled string node returning strlit774 (depth = 5)
  gc_frame_newslot(strlit774);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit774;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call775 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe773);
// compiled call node returning call775 (depth = 4)
    gc_frame_newslot(call775);
    if769 = call775;
  } else {
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe776 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe777 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call778 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe777);
// compiled call node returning call778 (depth = 6)
// compiled member node returning call778 (depth = 5)
  gc_frame_newslot(call778);
// starting to compile identifier node (depth = 5)
  Object bool779 = alloc_Boolean(1);
// compiled identifier node returning bool779 (depth = 5)
  gc_frame_newslot(bool779);
// starting to compile identifier node (depth = 5)
  Object bool780 = alloc_Boolean(0);
// compiled identifier node returning bool780 (depth = 5)
  gc_frame_newslot(bool780);
// starting to compile string node (depth = 5)
  if (strlit781 == NULL) {
    strlit781 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit781);
  }
// compiled string node returning strlit781 (depth = 5)
  gc_frame_newslot(strlit781);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call778;
  params[2] = bool779;
  params[3] = bool780;
  params[4] = strlit781;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call782 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe776);
// compiled call node returning call782 (depth = 4)
    gc_frame_newslot(call782);
    if769 = call782;
  }
// compiled if node returning if769 (depth = 3)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe783 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call784 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe783);
// compiled call node returning call784 (depth = 3)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe785 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call787 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe786);
// compiled call node returning call787 (depth = 7)
// compiled member node returning call787 (depth = 6)
  partcv[0] = 0;
  Object call788 = callmethod(call787, "new",
    1, partcv, params);
  gc_frame_end(callframe785);
// compiled call node returning call788 (depth = 5)
// compiled member node returning call788 (depth = 4)
  *var_suggestion = call788;
  if (call788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe790 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe791 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  partcv[0] = 0;
  Object call792 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe791);
// compiled call node returning call792 (depth = 5)
// compiled member node returning call792 (depth = 4)
  gc_frame_newslot(call792);
// starting to compile identifier node (depth = 4)
  Object bool793 = alloc_Boolean(1);
// compiled identifier node returning bool793 (depth = 4)
  gc_frame_newslot(bool793);
// starting to compile identifier node (depth = 4)
  Object bool794 = alloc_Boolean(0);
// compiled identifier node returning bool794 (depth = 4)
  gc_frame_newslot(bool794);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_lastToken;
  params[1] = call792;
  params[2] = bool793;
  params[3] = bool794;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call795 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe790);
// compiled call node returning call795 (depth = 3)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe796 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call797 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe796);
// compiled call node returning call797 (depth = 3)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe798 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit799 == NULL) {
    strlit799 = alloc_String("One or more annotations separated by commas must follow 'is'.");
    gc_root(strlit799);
  }
// compiled string node returning strlit799 (depth = 4)
  gc_frame_newslot(strlit799);
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call801 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe800);
// compiled call node returning call801 (depth = 5)
// compiled member node returning call801 (depth = 4)
  gc_frame_newslot(call801);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num803 = alloc_Float64(1);
// compiled num node returning num803 (depth = 5)
  int op_slot_right_802 = gc_frame_newslot(num803);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe806 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call807 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe806);
// compiled call node returning call807 (depth = 7)
// compiled member node returning call807 (depth = 6)
  int op_slot_right_805 = gc_frame_newslot(call807);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call810 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe809);
// compiled call node returning call810 (depth = 7)
// compiled member node returning call810 (depth = 6)
  int op_slot_left_805 = gc_frame_newslot(call810);
  params[0] = call807;
  partcv[0] = 1;
  Object sum811 = callmethod(call810, "+", 1, partcv, params);
// compiled op node returning sum811 (depth = 5)
  int op_slot_left_802 = gc_frame_newslot(sum811);
  params[0] = num803;
  partcv[0] = 1;
  Object sum812 = callmethod(sum811, "+", 1, partcv, params);
// compiled op node returning sum812 (depth = 4)
  gc_frame_newslot(sum812);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit799;
  params[1] = call801;
  params[2] = sum812;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call813 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe798);
// compiled call node returning call813 (depth = 3)
    gc_frame_newslot(call813);
    if748 = call813;
  } else {
  }
// compiled if node returning if748 (depth = 2)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe814 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block815 = alloc_Block(NULL, NULL, "parser", 293);
  gc_frame_newslot(block815);
// method _apply
  block_savedest(block815);
  Object closure816 = createclosure(1, "_apply");
  setclosureframe(closure816, stackframe);
  addtoclosure(closure816, selfslot);
  struct UserObject *uo816 = (struct UserObject*)block815;
  uo816->data[0] = (Object)closure816;
  Method *meth_meth_parser__apply816 = addmethod2pos(block815, "_apply", &meth_parser__apply816, 0);
  int argcv_meth_parser__apply816[] = {0};
  meth_meth_parser__apply816->type = alloc_MethodType(1, argcv_meth_parser__apply816);
  meth_meth_parser__apply816->definitionModule = modulename;
  meth_meth_parser__apply816->definitionLine = 291;
// compiled block node returning block815 (depth = 3)
  gc_frame_newslot(block815);
// starting to compile block node (depth = 3)
  Object block821 = alloc_Block(NULL, NULL, "parser", 293);
  gc_frame_newslot(block821);
// method _apply
  block_savedest(block821);
  Object closure822 = createclosure(7, "_apply");
  setclosureframe(closure822, stackframe);
  addtoclosure(closure822, var_values);
  addtoclosure(closure822, var_anns);
  addtoclosure(closure822, var_noBlocks);
  addtoclosure(closure822, var_errormessages);
  addtoclosure(closure822, var_sym);
  addtoclosure(closure822, var_lastToken);
  addtoclosure(closure822, selfslot);
  struct UserObject *uo822 = (struct UserObject*)block821;
  uo822->data[0] = (Object)closure822;
  Method *meth_meth_parser__apply822 = addmethod2pos(block821, "_apply", &meth_parser__apply822, 0);
  int argcv_meth_parser__apply822[] = {0};
  meth_meth_parser__apply822->type = alloc_MethodType(1, argcv_meth_parser__apply822);
  meth_meth_parser__apply822->definitionModule = modulename;
  meth_meth_parser__apply822->definitionLine = 291;
// compiled block node returning block821 (depth = 3)
  gc_frame_newslot(block821);
// call case 5: prelude request
  params[0] = block815;
  params[1] = block821;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call898 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe814);
// compiled call node returning call898 (depth = 2)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe899 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe900 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe901 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call902 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe901);
// compiled call node returning call902 (depth = 5)
// compiled member node returning call902 (depth = 4)
  gc_frame_newslot(call902);
// call case 4: self request
  params[0] = call902;
  partcv[0] = 1;
  Object call903 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe900);
// compiled call node returning call903 (depth = 3)
  gc_frame_newslot(call903);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_anns (depth = 3)
  params[0] = call903;
  partcv[0] = 1;
  Object call904 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe899);
// compiled call node returning call904 (depth = 2)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_anns (depth = 2)
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser__apply941(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit943 == NULL) {
    strlit943 = alloc_String("blank");
    gc_root(strlit943);
  }
// compiled string node returning strlit943 (depth = 7)
  int op_slot_right_942 = gc_frame_newslot(strlit943);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe945 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call947 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe946);
// compiled call node returning call947 (depth = 10)
// compiled member node returning call947 (depth = 9)
  partcv[0] = 0;
  Object call948 = callmethod(call947, "kind",
    1, partcv, params);
  gc_frame_end(callframe945);
// compiled call node returning call948 (depth = 8)
// compiled member node returning call948 (depth = 7)
  int op_slot_left_942 = gc_frame_newslot(call948);
  params[0] = strlit943;
  partcv[0] = 1;
  Object opresult949 = callmethod(call948, "!=", 1, partcv, params);
// compiled op node returning opresult949 (depth = 6)
  gc_frame_end(frame);
  return opresult949;
}
Object meth_parser_blank905(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_done = getfromclosure(closure, 3);
  Object *var_previousCommentToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blank (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for blank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num908 = alloc_Float64(0);
// compiled num node returning num908 (depth = 4)
  int op_slot_right_907 = gc_frame_newslot(num908);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blankLocation (depth = 4)
  int op_slot_left_907 = gc_frame_newslot(*var_blankLocation);
  params[0] = num908;
  partcv[0] = 1;
  Object opresult910 = callmethod(*var_blankLocation, "==", 1, partcv, params);
// compiled op node returning opresult910 (depth = 3)
  Object if906 = done;
  if (istrue(opresult910)) {
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num914 = alloc_Float64(1);
// compiled num node returning num914 (depth = 6)
  int op_slot_right_913 = gc_frame_newslot(num914);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe916 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call917 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe916);
// compiled call node returning call917 (depth = 7)
// compiled member node returning call917 (depth = 6)
  int op_slot_left_913 = gc_frame_newslot(call917);
  params[0] = num914;
  partcv[0] = 1;
  Object sum918 = callmethod(call917, "+", 1, partcv, params);
// compiled op node returning sum918 (depth = 5)
  int op_slot_right_912 = gc_frame_newslot(sum918);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe920 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call921 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe920);
// compiled call node returning call921 (depth = 6)
// compiled member node returning call921 (depth = 5)
  int op_slot_left_912 = gc_frame_newslot(call921);
  params[0] = sum918;
  partcv[0] = 1;
  Object opresult922 = callmethod(call921, "<=", 1, partcv, params);
// compiled op node returning opresult922 (depth = 4)
  Object if911 = done;
  if (istrue(opresult922)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if911 = undefined;
  } else {
  }
// compiled if node returning if911 (depth = 3)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num926 = alloc_Float64(1);
// compiled num node returning num926 (depth = 6)
  int op_slot_right_925 = gc_frame_newslot(num926);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_previousCommentToken (depth = 8)
  partcv[0] = 0;
  Object call929 = callmethod(*var_previousCommentToken, "line",
    1, partcv, params);
  gc_frame_end(callframe928);
// compiled call node returning call929 (depth = 7)
// compiled member node returning call929 (depth = 6)
  int op_slot_left_925 = gc_frame_newslot(call929);
  params[0] = num926;
  partcv[0] = 1;
  Object sum930 = callmethod(call929, "+", 1, partcv, params);
// compiled op node returning sum930 (depth = 5)
  int op_slot_right_924 = gc_frame_newslot(sum930);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call933 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe932);
// compiled call node returning call933 (depth = 6)
// compiled member node returning call933 (depth = 5)
  int op_slot_left_924 = gc_frame_newslot(call933);
  params[0] = sum930;
  partcv[0] = 1;
  Object opresult934 = callmethod(call933, "<=", 1, partcv, params);
// compiled op node returning opresult934 (depth = 4)
  Object if923 = done;
  if (istrue(opresult934)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if923 = undefined;
  } else {
  }
// compiled if node returning if923 (depth = 3)
    gc_frame_newslot(if923);
    if906 = if923;
  } else {
  }
// compiled if node returning if906 (depth = 2)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe935 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call936 = callmethodflags(self, "pushcomments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe935);
// compiled call node returning call936 (depth = 3)
// compiled member node returning call936 (depth = 2)
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe939 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block940 = alloc_Block(NULL, NULL, "parser", 324);
  gc_frame_newslot(block940);
// method _apply
  block_savedest(block940);
  Object closure941 = createclosure(2, "_apply");
  setclosureframe(closure941, stackframe);
  addtoclosure(closure941, var_values);
  addtoclosure(closure941, selfslot);
  struct UserObject *uo941 = (struct UserObject*)block940;
  uo941->data[0] = (Object)closure941;
  Method *meth_meth_parser__apply941 = addmethod2pos(block940, "_apply", &meth_parser__apply941, 0);
  int argcv_meth_parser__apply941[] = {0};
  meth_meth_parser__apply941->type = alloc_MethodType(1, argcv_meth_parser__apply941);
  meth_meth_parser__apply941->definitionModule = modulename;
  meth_meth_parser__apply941->definitionLine = 322;
// compiled block node returning block940 (depth = 5)
  gc_frame_newslot(block940);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num952 = alloc_Float64(0);
// compiled num node returning num952 (depth = 6)
  int op_slot_right_951 = gc_frame_newslot(num952);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call955 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe954);
// compiled call node returning call955 (depth = 7)
// compiled member node returning call955 (depth = 6)
  int op_slot_left_951 = gc_frame_newslot(call955);
  params[0] = num952;
  partcv[0] = 1;
  Object opresult956 = callmethod(call955, ">", 1, partcv, params);
// compiled op node returning opresult956 (depth = 5)
  params[0] = block940;
  partcv[0] = 1;
  Object call957 = callmethod(opresult956, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe939);
// compiled call node returning call957 (depth = 4)
  int op_slot_right_938 = gc_frame_newslot(call957);
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num960 = alloc_Float64(0);
// compiled num node returning num960 (depth = 5)
  int op_slot_right_959 = gc_frame_newslot(num960);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call963 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe962);
// compiled call node returning call963 (depth = 6)
// compiled member node returning call963 (depth = 5)
  int op_slot_left_959 = gc_frame_newslot(call963);
  params[0] = num960;
  partcv[0] = 1;
  Object opresult964 = callmethod(call963, "==", 1, partcv, params);
// compiled op node returning opresult964 (depth = 4)
  int op_slot_left_938 = gc_frame_newslot(opresult964);
  params[0] = call957;
  partcv[0] = 1;
  Object opresult965 = callmethod(opresult964, "||", 1, partcv, params);
// compiled op node returning opresult965 (depth = 3)
  Object if937 = done;
  if (istrue(opresult965)) {
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num968 = alloc_Float64(0);
// compiled num node returning num968 (depth = 5)
  int op_slot_right_967 = gc_frame_newslot(num968);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  int op_slot_left_967 = gc_frame_newslot(*var_blankLocation);
  params[0] = num968;
  partcv[0] = 1;
  Object opresult970 = callmethod(*var_blankLocation, ">", 1, partcv, params);
// compiled op node returning opresult970 (depth = 4)
  Object if966 = done;
  if (istrue(opresult970)) {
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe971 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  gc_frame_newslot(*var_blankLocation);
// starting to compile num node (depth = 5)
  Object num972 = alloc_Float64(0);
// compiled num node returning num972 (depth = 5)
  gc_frame_newslot(num972);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_blankLocation;
  params[1] = num972;
  partcv[0] = 2;
  Object call973 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe971);
// compiled call node returning call973 (depth = 4)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile num node (depth = 5)
  Object num974 = alloc_Float64(0);
// compiled num node returning num974 (depth = 5)
  *var_blankLocation = num974;
  if (num974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if966 = done;
  } else {
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe976 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num978 = alloc_Float64(1);
// compiled num node returning num978 (depth = 6)
  int op_slot_right_977 = gc_frame_newslot(num978);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe980 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call981 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe980);
// compiled call node returning call981 (depth = 7)
// compiled member node returning call981 (depth = 6)
  int op_slot_left_977 = gc_frame_newslot(call981);
  params[0] = num978;
  partcv[0] = 1;
  Object diff982 = callmethod(call981, "-", 1, partcv, params);
// compiled op node returning diff982 (depth = 5)
  gc_frame_newslot(diff982);
// starting to compile num node (depth = 5)
  Object num983 = alloc_Float64(0);
// compiled num node returning num983 (depth = 5)
  gc_frame_newslot(num983);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = diff982;
  params[1] = num983;
  partcv[0] = 2;
  Object call984 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe976);
// compiled call node returning call984 (depth = 4)
    gc_frame_newslot(call984);
    if966 = call984;
  }
// compiled if node returning if966 (depth = 3)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe985 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe986 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call988 = callmethod(*var_ast, "blankNode",
    1, partcv, params);
  gc_frame_end(callframe987);
// compiled call node returning call988 (depth = 7)
// compiled member node returning call988 (depth = 6)
  partcv[0] = 0;
  Object call989 = callmethod(call988, "new",
    1, partcv, params);
  gc_frame_end(callframe986);
// compiled call node returning call989 (depth = 5)
// compiled member node returning call989 (depth = 4)
  gc_frame_newslot(call989);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call989;
  partcv[0] = 1;
  Object call990 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe985);
// compiled call node returning call990 (depth = 3)
    gc_frame_newslot(call990);
    if937 = call990;
  } else {
  }
// compiled if node returning if937 (depth = 2)
  gc_frame_end(frame);
  return if937;
}
Object meth_parser__apply1005(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1007 == NULL) {
    strlit1007 = alloc_String("type");
    gc_root(strlit1007);
  }
// compiled string node returning strlit1007 (depth = 7)
  int op_slot_right_1006 = gc_frame_newslot(strlit1007);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1010 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1009);
// compiled call node returning call1010 (depth = 8)
// compiled member node returning call1010 (depth = 7)
  int op_slot_left_1006 = gc_frame_newslot(call1010);
  params[0] = strlit1007;
  partcv[0] = 1;
  Object opresult1011 = callmethod(call1010, "==", 1, partcv, params);
// compiled op node returning opresult1011 (depth = 6)
  gc_frame_end(frame);
  return opresult1011;
}
Object meth_parser_dotypeterm991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotypeterm (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dotypeterm");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe993 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit994 == NULL) {
    strlit994 = alloc_String("identifier");
    gc_root(strlit994);
  }
// compiled string node returning strlit994 (depth = 4)
  gc_frame_newslot(strlit994);
// call case 4: self request
  params[0] = strlit994;
  partcv[0] = 1;
  Object call995 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe993);
// compiled call node returning call995 (depth = 3)
  Object if992 = done;
  if (istrue(call995)) {
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe996 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call997 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe996);
// compiled call node returning call997 (depth = 4)
// compiled member node returning call997 (depth = 3)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call999 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe998);
// compiled call node returning call999 (depth = 4)
// compiled member node returning call999 (depth = 3)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1000 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1001 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1000);
// compiled call node returning call1001 (depth = 3)
    gc_frame_newslot(call1001);
    if992 = call1001;
  } else {
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1003 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1004 = alloc_Block(NULL, NULL, "parser", 341);
  gc_frame_newslot(block1004);
// method _apply
  block_savedest(block1004);
  Object closure1005 = createclosure(2, "_apply");
  setclosureframe(closure1005, stackframe);
  addtoclosure(closure1005, var_sym);
  addtoclosure(closure1005, selfslot);
  struct UserObject *uo1005 = (struct UserObject*)block1004;
  uo1005->data[0] = (Object)closure1005;
  Method *meth_meth_parser__apply1005 = addmethod2pos(block1004, "_apply", &meth_parser__apply1005, 0);
  int argcv_meth_parser__apply1005[] = {0};
  meth_meth_parser__apply1005->type = alloc_MethodType(1, argcv_meth_parser__apply1005);
  meth_meth_parser__apply1005->definitionModule = modulename;
  meth_meth_parser__apply1005->definitionLine = 338;
// compiled block node returning block1004 (depth = 5)
  gc_frame_newslot(block1004);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1013 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1014 == NULL) {
    strlit1014 = alloc_String("keyword");
    gc_root(strlit1014);
  }
// compiled string node returning strlit1014 (depth = 6)
  gc_frame_newslot(strlit1014);
// call case 4: self request
  params[0] = strlit1014;
  partcv[0] = 1;
  Object call1015 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1013);
// compiled call node returning call1015 (depth = 5)
  params[0] = block1004;
  partcv[0] = 1;
  Object call1016 = callmethod(call1015, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe1003);
// compiled call node returning call1016 (depth = 4)
  Object if1002 = done;
  if (istrue(call1016)) {
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1018 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1017);
// compiled call node returning call1018 (depth = 5)
// compiled member node returning call1018 (depth = 4)
    gc_frame_newslot(call1018);
    if1002 = call1018;
  } else {
  }
// compiled if node returning if1002 (depth = 3)
    gc_frame_newslot(if1002);
    if992 = if1002;
  }
// compiled if node returning if992 (depth = 2)
  gc_frame_end(frame);
  return if992;
}
Object meth_parser__apply1033(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1034 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1035 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1034);
// compiled call node returning call1035 (depth = 9)
// compiled member node returning call1035 (depth = 8)
  gc_frame_end(frame);
  return call1035;
}
Object meth_parser_typeexpression1019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_noBlocks = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeexpression (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeexpression");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
  Object *var_prevStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "prevStatementToken");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1020 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call1021 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1020);
// compiled call node returning call1021 (depth = 4)
// compiled member node returning call1021 (depth = 3)
  *var_sz = call1021;
  if (call1021 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1023 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1024 == NULL) {
    strlit1024 = alloc_String("lparen");
    gc_root(strlit1024);
  }
// compiled string node returning strlit1024 (depth = 4)
  gc_frame_newslot(strlit1024);
// call case 4: self request
  params[0] = strlit1024;
  partcv[0] = 1;
  Object call1025 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1023);
// compiled call node returning call1025 (depth = 3)
  Object if1022 = done;
  if (istrue(call1025)) {
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_prevStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1027 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1028 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1027);
// compiled call node returning call1028 (depth = 4)
// compiled member node returning call1028 (depth = 3)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1030 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1031 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1032 = alloc_Block(NULL, NULL, "parser", 353);
  gc_frame_newslot(block1032);
// method _apply
  block_savedest(block1032);
  Object closure1033 = createclosure(1, "_apply");
  setclosureframe(closure1033, stackframe);
  addtoclosure(closure1033, selfslot);
  struct UserObject *uo1033 = (struct UserObject*)block1032;
  uo1033->data[0] = (Object)closure1033;
  Method *meth_meth_parser__apply1033 = addmethod2pos(block1032, "_apply", &meth_parser__apply1033, 0);
  int argcv_meth_parser__apply1033[] = {0};
  meth_meth_parser__apply1033->type = alloc_MethodType(1, argcv_meth_parser__apply1033);
  meth_meth_parser__apply1033->definitionModule = modulename;
  meth_meth_parser__apply1033->definitionLine = 353;
// compiled block node returning block1032 (depth = 7)
  gc_frame_newslot(block1032);
// call case 4: self request
  params[0] = block1032;
  partcv[0] = 1;
  Object call1037 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1031);
// compiled call node returning call1037 (depth = 6)
  partcv[0] = 0;
  Object call1038 = callmethod(call1037, "not",
    1, partcv, params);
  gc_frame_end(callframe1030);
// compiled call node returning call1038 (depth = 5)
// compiled member node returning call1038 (depth = 4)
  Object if1029 = done;
  if (istrue(call1038)) {
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1039 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1040 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1041 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1040);
// compiled call node returning call1041 (depth = 8)
// compiled member node returning call1041 (depth = 7)
  partcv[0] = 0;
  Object call1042 = callmethod(call1041, "new",
    1, partcv, params);
  gc_frame_end(callframe1039);
// compiled call node returning call1042 (depth = 6)
// compiled member node returning call1042 (depth = 5)
  *var_suggestion = call1042;
  if (call1042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1043 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1044 == NULL) {
    strlit1044 = alloc_String("rparen");
    gc_root(strlit1044);
  }
// compiled string node returning strlit1044 (depth = 6)
  gc_frame_newslot(strlit1044);
// call case 4: self request
  params[0] = strlit1044;
  partcv[0] = 1;
  Object call1045 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1043);
// compiled call node returning call1045 (depth = 5)
  *var_nextTok = call1045;
  if (call1045 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_1047 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1047 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1049 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1049 (depth = 5)
  Object if1046 = done;
  if (istrue(opresult1049)) {
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1050 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1051 == NULL) {
    strlit1051 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1051);
  }
// compiled string node returning strlit1051 (depth = 6)
  gc_frame_newslot(strlit1051);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1051;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1052 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1050);
// compiled call node returning call1052 (depth = 5)
    gc_frame_newslot(call1052);
    if1046 = call1052;
  } else {
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1053 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1054 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1055 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1054);
// compiled call node returning call1055 (depth = 7)
// compiled member node returning call1055 (depth = 6)
  gc_frame_newslot(call1055);
// starting to compile identifier node (depth = 6)
  Object bool1056 = alloc_Boolean(1);
// compiled identifier node returning bool1056 (depth = 6)
  gc_frame_newslot(bool1056);
// starting to compile identifier node (depth = 6)
  Object bool1057 = alloc_Boolean(0);
// compiled identifier node returning bool1057 (depth = 6)
  gc_frame_newslot(bool1057);
// starting to compile string node (depth = 6)
  if (strlit1058 == NULL) {
    strlit1058 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1058);
  }
// compiled string node returning strlit1058 (depth = 6)
  gc_frame_newslot(strlit1058);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call1055;
  params[2] = bool1056;
  params[3] = bool1057;
  params[4] = strlit1058;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1059 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1053);
// compiled call node returning call1059 (depth = 5)
    gc_frame_newslot(call1059);
    if1046 = call1059;
  }
// compiled if node returning if1046 (depth = 4)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1060 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1061 == NULL) {
    strlit1061 = alloc_String("Parentheses must contain a valid type expression.");
    gc_root(strlit1061);
  }
// compiled string node returning strlit1061 (depth = 5)
  gc_frame_newslot(strlit1061);
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1062 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1063 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1062);
// compiled call node returning call1063 (depth = 6)
// compiled member node returning call1063 (depth = 5)
  gc_frame_newslot(call1063);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1065 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1064);
// compiled call node returning call1065 (depth = 6)
// compiled member node returning call1065 (depth = 5)
  gc_frame_newslot(call1065);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1061;
  params[1] = call1063;
  params[2] = call1065;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1066 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1060);
// compiled call node returning call1066 (depth = 4)
    gc_frame_newslot(call1066);
    if1029 = call1066;
  } else {
  }
// compiled if node returning if1029 (depth = 3)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1069 == NULL) {
    strlit1069 = alloc_String("rparen");
    gc_root(strlit1069);
  }
// compiled string node returning strlit1069 (depth = 5)
  int op_slot_right_1068 = gc_frame_newslot(strlit1069);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1072 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1071);
// compiled call node returning call1072 (depth = 6)
// compiled member node returning call1072 (depth = 5)
  int op_slot_left_1068 = gc_frame_newslot(call1072);
  params[0] = strlit1069;
  partcv[0] = 1;
  Object opresult1073 = callmethod(call1072, "!=", 1, partcv, params);
// compiled op node returning opresult1073 (depth = 4)
  Object if1067 = done;
  if (istrue(opresult1073)) {
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1074 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1075 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1074);
// compiled call node returning call1075 (depth = 5)
// compiled member node returning call1075 (depth = 4)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1076 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1077 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1078 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1077);
// compiled call node returning call1078 (depth = 8)
// compiled member node returning call1078 (depth = 7)
  partcv[0] = 0;
  Object call1079 = callmethod(call1078, "new",
    1, partcv, params);
  gc_frame_end(callframe1076);
// compiled call node returning call1079 (depth = 6)
// compiled member node returning call1079 (depth = 5)
  *var_suggestion = call1079;
  if (call1079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1080 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1081 == NULL) {
    strlit1081 = alloc_String(")");
    gc_root(strlit1081);
  }
// compiled string node returning strlit1081 (depth = 5)
  gc_frame_newslot(strlit1081);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1081;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1082 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1080);
// compiled call node returning call1082 (depth = 4)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1083 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1084 == NULL) {
    strlit1084 = alloc_String("A type expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1084);
  }
// compiled string node returning strlit1084 (depth = 5)
  gc_frame_newslot(strlit1084);
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1085 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1086 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1085);
// compiled call node returning call1086 (depth = 6)
// compiled member node returning call1086 (depth = 5)
  gc_frame_newslot(call1086);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1088 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1089 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe1088);
// compiled call node returning call1089 (depth = 7)
// compiled member node returning call1089 (depth = 6)
  int op_slot_right_1087 = gc_frame_newslot(call1089);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1092 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1091);
// compiled call node returning call1092 (depth = 7)
// compiled member node returning call1092 (depth = 6)
  int op_slot_left_1087 = gc_frame_newslot(call1092);
  params[0] = call1089;
  partcv[0] = 1;
  Object sum1093 = callmethod(call1092, "+", 1, partcv, params);
// compiled op node returning sum1093 (depth = 5)
  gc_frame_newslot(sum1093);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1084;
  params[1] = call1086;
  params[2] = sum1093;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1094 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1083);
// compiled call node returning call1094 (depth = 4)
    gc_frame_newslot(call1094);
    if1067 = call1094;
  } else {
  }
// compiled if node returning if1067 (depth = 3)
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_prevStatementToken (depth = 4)
  *var_statementToken = *var_prevStatementToken;
  if (*var_prevStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1096 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1097 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1096);
// compiled call node returning call1097 (depth = 4)
// compiled member node returning call1097 (depth = 3)
    gc_frame_newslot(call1097);
    if1022 = call1097;
  } else {
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1098 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1099 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1098);
// compiled call node returning call1099 (depth = 4)
// compiled member node returning call1099 (depth = 3)
    gc_frame_newslot(call1099);
    if1022 = call1099;
  }
// compiled if node returning if1022 (depth = 2)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_1101 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1104 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1103);
// compiled call node returning call1104 (depth = 5)
// compiled member node returning call1104 (depth = 4)
  int op_slot_left_1101 = gc_frame_newslot(call1104);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult1105 = callmethod(call1104, ">", 1, partcv, params);
// compiled op node returning opresult1105 (depth = 3)
  Object if1100 = done;
  if (istrue(opresult1105)) {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1106 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1107 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1106);
// compiled call node returning call1107 (depth = 3)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1109 = callmethodflags(self, "typeexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1108);
// compiled call node returning call1109 (depth = 4)
// compiled member node returning call1109 (depth = 3)
    gc_frame_newslot(call1109);
    if1100 = call1109;
  } else {
  }
// compiled if node returning if1100 (depth = 2)
  gc_frame_end(frame);
  return if1100;
}
Object meth_parser_newIf1110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method newIf");
  Object params[3];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for newIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenList = &(stackframe->slots[1]);
  *var_thenList = args[curarg];
  curarg++;
  Object *var_elseList = &(stackframe->slots[2]);
  *var_elseList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for newIf");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_thenBlock = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "thenBlock");
  Object *var_elseBlock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "elseBlock");
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1111 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  gc_frame_newslot(*var_emptySequence);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenList (depth = 4)
  gc_frame_newslot(*var_thenList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1112 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1113 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1112);
// compiled call node returning call1113 (depth = 5)
// compiled member node returning call1113 (depth = 4)
  params[0] = *var_emptySequence;
  params[1] = *var_thenList;
  partcv[0] = 2;
  Object call1114 = callmethod(call1113, "new",
    1, partcv, params);
  gc_frame_end(callframe1111);
// compiled call node returning call1114 (depth = 3)
  *var_thenBlock = call1114;
  if (call1114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1115 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  gc_frame_newslot(*var_emptySequence);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseList (depth = 4)
  gc_frame_newslot(*var_elseList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1117 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1116);
// compiled call node returning call1117 (depth = 5)
// compiled member node returning call1117 (depth = 4)
  params[0] = *var_emptySequence;
  params[1] = *var_elseList;
  partcv[0] = 2;
  Object call1118 = callmethod(call1117, "new",
    1, partcv, params);
  gc_frame_end(callframe1115);
// compiled call node returning call1118 (depth = 3)
  *var_elseBlock = call1118;
  if (call1118 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1119 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenBlock (depth = 3)
  gc_frame_newslot(*var_thenBlock);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseBlock (depth = 3)
  gc_frame_newslot(*var_elseBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1120 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call1121 = callmethod(*var_ast, "ifNode",
    1, partcv, params);
  gc_frame_end(callframe1120);
// compiled call node returning call1121 (depth = 4)
// compiled member node returning call1121 (depth = 3)
  params[0] = *var_cond;
  params[1] = *var_thenBlock;
  params[2] = *var_elseBlock;
  partcv[0] = 3;
  Object call1122 = callmethod(call1121, "new",
    1, partcv, params);
  gc_frame_end(callframe1119);
// compiled call node returning call1122 (depth = 2)
  gc_frame_end(frame);
  return call1122;
}
Object meth_parser__apply1158(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe1159 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1160 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1159);
// compiled call node returning call1160 (depth = 5)
  gc_frame_end(frame);
  return call1160;
}
Object meth_parser__apply1195(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe1196 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1197 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1196);
// compiled call node returning call1197 (depth = 12)
  gc_frame_end(frame);
  return call1197;
}
Object meth_parser__apply1273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe1274 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1275 == NULL) {
    strlit1275 = alloc_String("comma");
    gc_root(strlit1275);
  }
// compiled string node returning strlit1275 (depth = 10)
  gc_frame_newslot(strlit1275);
// call case 4: self request
  params[0] = strlit1275;
  partcv[0] = 1;
  Object call1276 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1274);
// compiled call node returning call1276 (depth = 9)
  gc_frame_end(frame);
  return call1276;
}
Object meth_parser__apply1286(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1288 == NULL) {
    strlit1288 = alloc_String("arrow");
    gc_root(strlit1288);
  }
// compiled string node returning strlit1288 (depth = 11)
  int op_slot_right_1287 = gc_frame_newslot(strlit1288);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1291 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1290);
// compiled call node returning call1291 (depth = 12)
// compiled member node returning call1291 (depth = 11)
  int op_slot_left_1287 = gc_frame_newslot(call1291);
  params[0] = strlit1288;
  partcv[0] = 1;
  Object opresult1292 = callmethod(call1291, "==", 1, partcv, params);
// compiled op node returning opresult1292 (depth = 10)
  gc_frame_end(frame);
  return opresult1292;
}
Object meth_parser__apply1334(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1335 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1336 == NULL) {
    strlit1336 = alloc_String("comma");
    gc_root(strlit1336);
  }
// compiled string node returning strlit1336 (depth = 9)
  gc_frame_newslot(strlit1336);
// call case 4: self request
  params[0] = strlit1336;
  partcv[0] = 1;
  Object call1337 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1335);
// compiled call node returning call1337 (depth = 8)
  gc_frame_end(frame);
  return call1337;
}
Object meth_parser__apply1340(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1341 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1342 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1341);
// compiled call node returning call1342 (depth = 9)
// compiled member node returning call1342 (depth = 8)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1343 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1344 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1343);
// compiled call node returning call1344 (depth = 9)
// compiled member node returning call1344 (depth = 8)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1345 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1346 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1345);
// compiled call node returning call1346 (depth = 10)
// compiled member node returning call1346 (depth = 9)
  *var_expr1 = call1346;
  if (call1346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1348 = gc_frame_new();
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool1349 = alloc_Boolean(1);
// compiled identifier node returning bool1349 (depth = 10)
  gc_frame_newslot(bool1349);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_expr1 (depth = 10)
  params[0] = bool1349;
  partcv[0] = 1;
  Object call1350 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1348);
// compiled call node returning call1350 (depth = 9)
// compiled bind node returning done (depth = 8)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1351 = gc_frame_new();
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1352 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1353 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1352);
// compiled call node returning call1353 (depth = 11)
// compiled member node returning call1353 (depth = 10)
  gc_frame_newslot(call1353);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_expr1 (depth = 10)
  params[0] = call1353;
  partcv[0] = 1;
  Object call1354 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1351);
// compiled call node returning call1354 (depth = 9)
// compiled bind node returning done (depth = 8)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1355 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_params (depth = 9)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1356 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1355);
// compiled call node returning call1356 (depth = 8)
  gc_frame_end(frame);
  return call1356;
}
Object meth_parser__apply1471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 13)
  int callframe1472 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_blocksOK (depth = 14)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1473 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1472);
// compiled call node returning call1473 (depth = 13)
  gc_frame_end(frame);
  return call1473;
}
Object meth_parser__apply1163(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_braceIsType = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_params = getfromclosure(closure, 7);
  Object *var_isMatchingBlock = getfromclosure(closure, 8);
  Object *var_body = getfromclosure(closure, 9);
  Object *var_indentFreePass = getfromclosure(closure, 10);
  Object *var_btok = getfromclosure(closure, 11);
  Object *var_util = getfromclosure(closure, 12);
  Object *var_ast = getfromclosure(closure, 13);
  Object self = *(getfromclosure(closure, 14));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arrow = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arrow");
  Object *var_lhs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lhs");
  Object *var_rhs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rhs");
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1166 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1167 == NULL) {
    strlit1167 = alloc_String("colon");
    gc_root(strlit1167);
  }
// compiled string node returning strlit1167 (depth = 8)
  gc_frame_newslot(strlit1167);
// call case 4: self request
  params[0] = strlit1167;
  partcv[0] = 1;
  Object call1168 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1166);
// compiled call node returning call1168 (depth = 7)
  int op_slot_right_1165 = gc_frame_newslot(call1168);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1171 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1172 == NULL) {
    strlit1172 = alloc_String("arrow");
    gc_root(strlit1172);
  }
// compiled string node returning strlit1172 (depth = 9)
  gc_frame_newslot(strlit1172);
// call case 4: self request
  params[0] = strlit1172;
  partcv[0] = 1;
  Object call1173 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1171);
// compiled call node returning call1173 (depth = 8)
  int op_slot_right_1170 = gc_frame_newslot(call1173);
// starting to compile call node (depth = 8)
  int callframe1175 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1176 == NULL) {
    strlit1176 = alloc_String("comma");
    gc_root(strlit1176);
  }
// compiled string node returning strlit1176 (depth = 9)
  gc_frame_newslot(strlit1176);
// call case 4: self request
  params[0] = strlit1176;
  partcv[0] = 1;
  Object call1177 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1175);
// compiled call node returning call1177 (depth = 8)
  int op_slot_left_1170 = gc_frame_newslot(call1177);
  params[0] = call1173;
  partcv[0] = 1;
  Object opresult1178 = callmethod(call1177, "||", 1, partcv, params);
// compiled op node returning opresult1178 (depth = 7)
  int op_slot_left_1165 = gc_frame_newslot(opresult1178);
  params[0] = call1168;
  partcv[0] = 1;
  Object opresult1179 = callmethod(opresult1178, "||", 1, partcv, params);
// compiled op node returning opresult1179 (depth = 6)
  Object if1164 = done;
  if (istrue(opresult1179)) {
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call1181 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1180);
// compiled call node returning call1181 (depth = 8)
// compiled member node returning call1181 (depth = 7)
  *var_expr1 = call1181;
  if (call1181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1184 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1185 == NULL) {
    strlit1185 = alloc_String("colon");
    gc_root(strlit1185);
  }
// compiled string node returning strlit1185 (depth = 8)
  gc_frame_newslot(strlit1185);
// call case 4: self request
  params[0] = strlit1185;
  partcv[0] = 1;
  Object call1186 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1184);
// compiled call node returning call1186 (depth = 7)
  Object if1183 = done;
  if (istrue(call1186)) {
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1187 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1188 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1187);
// compiled call node returning call1188 (depth = 8)
// compiled member node returning call1188 (depth = 7)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1189 = alloc_Boolean(1);
// compiled identifier node returning bool1189 (depth = 8)
  *var_braceIsType = bool1189;
  if (bool1189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1192 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe1193 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block1194 = alloc_Block(NULL, NULL, "parser", 421);
  gc_frame_newslot(block1194);
// method _apply
  block_savedest(block1194);
  Object closure1195 = createclosure(2, "_apply");
  setclosureframe(closure1195, stackframe);
  addtoclosure(closure1195, var_blocksOK);
  addtoclosure(closure1195, selfslot);
  struct UserObject *uo1195 = (struct UserObject*)block1194;
  uo1195->data[0] = (Object)closure1195;
  Method *meth_meth_parser__apply1195 = addmethod2pos(block1194, "_apply", &meth_parser__apply1195, 0);
  int argcv_meth_parser__apply1195[] = {0};
  meth_meth_parser__apply1195->type = alloc_MethodType(1, argcv_meth_parser__apply1195);
  meth_meth_parser__apply1195->definitionModule = modulename;
  meth_meth_parser__apply1195->definitionLine = 421;
// compiled block node returning block1194 (depth = 11)
  gc_frame_newslot(block1194);
// call case 4: self request
  params[0] = block1194;
  partcv[0] = 1;
  Object call1199 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1193);
// compiled call node returning call1199 (depth = 10)
  partcv[0] = 0;
  Object call1200 = callmethod(call1199, "not",
    1, partcv, params);
  gc_frame_end(callframe1192);
// compiled call node returning call1200 (depth = 9)
// compiled member node returning call1200 (depth = 8)
  Object if1191 = done;
  if (istrue(call1200)) {
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1201 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1202 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1203 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1202);
// compiled call node returning call1203 (depth = 12)
// compiled member node returning call1203 (depth = 11)
  partcv[0] = 0;
  Object call1204 = callmethod(call1203, "empty",
    1, partcv, params);
  gc_frame_end(callframe1201);
// compiled call node returning call1204 (depth = 10)
// compiled member node returning call1204 (depth = 9)
  *var_suggestions = call1204;
  if (call1204 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1205 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1207 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1206);
// compiled call node returning call1207 (depth = 12)
// compiled member node returning call1207 (depth = 11)
  partcv[0] = 0;
  Object call1208 = callmethod(call1207, "new",
    1, partcv, params);
  gc_frame_end(callframe1205);
// compiled call node returning call1208 (depth = 10)
// compiled member node returning call1208 (depth = 9)
  *var_suggestion = call1208;
  if (call1208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1209 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1210 == NULL) {
    strlit1210 = alloc_String("arrow");
    gc_root(strlit1210);
  }
// compiled string node returning strlit1210 (depth = 10)
  gc_frame_newslot(strlit1210);
// starting to compile string node (depth = 10)
  if (strlit1211 == NULL) {
    strlit1211 = alloc_String("rbrace");
    gc_root(strlit1211);
  }
// compiled string node returning strlit1211 (depth = 10)
  gc_frame_newslot(strlit1211);
// call case 4: self request
  params[0] = strlit1210;
  params[1] = strlit1211;
  partcv[0] = 2;
  Object call1212 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1209);
// compiled call node returning call1212 (depth = 9)
  *var_nextTok = call1212;
  if (call1212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1214 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1214 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1216 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1216 (depth = 9)
  Object if1213 = done;
  if (istrue(opresult1216)) {
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1217 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1218 == NULL) {
    strlit1218 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1218);
  }
// compiled string node returning strlit1218 (depth = 10)
  gc_frame_newslot(strlit1218);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1218;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1219 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1217);
// compiled call node returning call1219 (depth = 9)
    gc_frame_newslot(call1219);
    if1213 = call1219;
  } else {
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1220 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1222 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1221);
// compiled call node returning call1222 (depth = 11)
// compiled member node returning call1222 (depth = 10)
  gc_frame_newslot(call1222);
// starting to compile identifier node (depth = 10)
  Object bool1223 = alloc_Boolean(1);
// compiled identifier node returning bool1223 (depth = 10)
  gc_frame_newslot(bool1223);
// starting to compile identifier node (depth = 10)
  Object bool1224 = alloc_Boolean(0);
// compiled identifier node returning bool1224 (depth = 10)
  gc_frame_newslot(bool1224);
// starting to compile string node (depth = 10)
  if (strlit1225 == NULL) {
    strlit1225 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1225);
  }
// compiled string node returning strlit1225 (depth = 10)
  gc_frame_newslot(strlit1225);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call1222;
  params[2] = bool1223;
  params[3] = bool1224;
  params[4] = strlit1225;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1226 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1220);
// compiled call node returning call1226 (depth = 9)
    gc_frame_newslot(call1226);
    if1213 = call1226;
  }
// compiled if node returning if1213 (depth = 8)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1227 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1228 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1227);
// compiled call node returning call1228 (depth = 8)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1229 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1231 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1230);
// compiled call node returning call1231 (depth = 12)
// compiled member node returning call1231 (depth = 11)
  partcv[0] = 0;
  Object call1232 = callmethod(call1231, "new",
    1, partcv, params);
  gc_frame_end(callframe1229);
// compiled call node returning call1232 (depth = 10)
// compiled member node returning call1232 (depth = 9)
  *var_suggestion = call1232;
  if (call1232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1234 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1236 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1235);
// compiled call node returning call1236 (depth = 10)
// compiled member node returning call1236 (depth = 9)
  gc_frame_newslot(call1236);
// starting to compile identifier node (depth = 9)
  Object bool1237 = alloc_Boolean(1);
// compiled identifier node returning bool1237 (depth = 9)
  gc_frame_newslot(bool1237);
// starting to compile identifier node (depth = 9)
  Object bool1238 = alloc_Boolean(0);
// compiled identifier node returning bool1238 (depth = 9)
  gc_frame_newslot(bool1238);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call1236;
  params[2] = bool1237;
  params[3] = bool1238;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1239 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1234);
// compiled call node returning call1239 (depth = 8)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1240 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1241 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1240);
// compiled call node returning call1241 (depth = 8)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1242 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1243 == NULL) {
    strlit1243 = alloc_String("A block must have an expression after the ':'.");
    gc_root(strlit1243);
  }
// compiled string node returning strlit1243 (depth = 9)
  gc_frame_newslot(strlit1243);
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1245 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1244);
// compiled call node returning call1245 (depth = 10)
// compiled member node returning call1245 (depth = 9)
  gc_frame_newslot(call1245);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1246 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1247 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1246);
// compiled call node returning call1247 (depth = 10)
// compiled member node returning call1247 (depth = 9)
  gc_frame_newslot(call1247);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit1243;
  params[1] = call1245;
  params[2] = call1247;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1248 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1242);
// compiled call node returning call1248 (depth = 8)
    gc_frame_newslot(call1248);
    if1191 = call1248;
  } else {
  }
// compiled if node returning if1191 (depth = 7)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1249 = alloc_Boolean(0);
// compiled identifier node returning bool1249 (depth = 8)
  *var_braceIsType = bool1249;
  if (bool1249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1251 = gc_frame_new();
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1253 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1252);
// compiled call node returning call1253 (depth = 10)
// compiled member node returning call1253 (depth = 9)
  gc_frame_newslot(call1253);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = call1253;
  partcv[0] = 1;
  Object call1254 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1251);
// compiled call node returning call1254 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1183 = done;
  } else {
  }
// compiled if node returning if1183 (depth = 6)
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1255 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_expr1 (depth = 7)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1256 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1255);
// compiled call node returning call1256 (depth = 6)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_expr1 (depth = 10)
  partcv[0] = 0;
  Object call1260 = callmethod(*var_expr1, "isIdentifier",
    1, partcv, params);
  gc_frame_end(callframe1259);
// compiled call node returning call1260 (depth = 9)
// compiled member node returning call1260 (depth = 8)
  int op_slot_right_1258 = gc_frame_newslot(call1260);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1262 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_isMatchingBlock (depth = 10)
  partcv[0] = 0;
  Object call1263 = callmethod(*var_isMatchingBlock, "not",
    1, partcv, params);
  gc_frame_end(callframe1262);
// compiled call node returning call1263 (depth = 9)
// compiled member node returning call1263 (depth = 8)
  int op_slot_left_1258 = gc_frame_newslot(call1263);
  params[0] = call1260;
  partcv[0] = 1;
  Object opresult1264 = callmethod(call1263, "&&", 1, partcv, params);
// compiled op node returning opresult1264 (depth = 7)
  Object if1257 = done;
  if (istrue(opresult1264)) {
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1265 = gc_frame_new();
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool1266 = alloc_Boolean(1);
// compiled identifier node returning bool1266 (depth = 9)
  gc_frame_newslot(bool1266);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = bool1266;
  partcv[0] = 1;
  Object call1267 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1265);
// compiled call node returning call1267 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1257 = done;
  } else {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1268 = alloc_Boolean(1);
// compiled identifier node returning bool1268 (depth = 8)
  *var_isMatchingBlock = bool1268;
  if (bool1268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1257 = done;
  }
// compiled if node returning if1257 (depth = 6)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1272 = alloc_Block(NULL, NULL, "parser", 446);
  gc_frame_newslot(block1272);
// method _apply
  block_savedest(block1272);
  Object closure1273 = createclosure(1, "_apply");
  setclosureframe(closure1273, stackframe);
  addtoclosure(closure1273, selfslot);
  struct UserObject *uo1273 = (struct UserObject*)block1272;
  uo1273->data[0] = (Object)closure1273;
  Method *meth_meth_parser__apply1273 = addmethod2pos(block1272, "_apply", &meth_parser__apply1273, 0);
  int argcv_meth_parser__apply1273[] = {0};
  meth_meth_parser__apply1273->type = alloc_MethodType(1, argcv_meth_parser__apply1273);
  meth_meth_parser__apply1273->definitionModule = modulename;
  meth_meth_parser__apply1273->definitionLine = 441;
// compiled block node returning block1272 (depth = 8)
  int op_slot_right_1271 = gc_frame_newslot(block1272);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isMatchingBlock (depth = 8)
  int op_slot_left_1271 = gc_frame_newslot(*var_isMatchingBlock);
  params[0] = block1272;
  partcv[0] = 1;
  Object opresult1279 = callmethod(*var_isMatchingBlock, "&&", 1, partcv, params);
// compiled op node returning opresult1279 (depth = 7)
  Object if1270 = done;
  if (istrue(opresult1279)) {
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1280 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1281 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1282 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1281);
// compiled call node returning call1282 (depth = 11)
// compiled member node returning call1282 (depth = 10)
  partcv[0] = 0;
  Object call1283 = callmethod(call1282, "empty",
    1, partcv, params);
  gc_frame_end(callframe1280);
// compiled call node returning call1283 (depth = 9)
// compiled member node returning call1283 (depth = 8)
  *var_suggestions = call1283;
  if (call1283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 7)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1284 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1285 = alloc_Block(NULL, NULL, "parser", 449);
  gc_frame_newslot(block1285);
// method _apply
  block_savedest(block1285);
  Object closure1286 = createclosure(1, "_apply");
  setclosureframe(closure1286, stackframe);
  addtoclosure(closure1286, selfslot);
  struct UserObject *uo1286 = (struct UserObject*)block1285;
  uo1286->data[0] = (Object)closure1286;
  Method *meth_meth_parser__apply1286 = addmethod2pos(block1285, "_apply", &meth_parser__apply1286, 0);
  int argcv_meth_parser__apply1286[] = {1};
  meth_meth_parser__apply1286->type = alloc_MethodType(1, argcv_meth_parser__apply1286);
  meth_meth_parser__apply1286->definitionModule = modulename;
  meth_meth_parser__apply1286->definitionLine = 447;
// compiled block node returning block1285 (depth = 9)
  gc_frame_newslot(block1285);
// call case 4: self request
  params[0] = block1285;
  partcv[0] = 1;
  Object call1294 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1284);
// compiled call node returning call1294 (depth = 8)
  *var_arrow = call1294;
  if (call1294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1297 = alloc_Boolean(0);
// compiled identifier node returning bool1297 (depth = 9)
  int op_slot_right_1296 = gc_frame_newslot(bool1297);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arrow (depth = 9)
  int op_slot_left_1296 = gc_frame_newslot(*var_arrow);
  params[0] = bool1297;
  partcv[0] = 1;
  Object opresult1299 = callmethod(*var_arrow, "!=", 1, partcv, params);
// compiled op node returning opresult1299 (depth = 8)
  Object if1295 = done;
  if (istrue(opresult1299)) {
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1300 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1301 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1302 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1301);
// compiled call node returning call1302 (depth = 12)
// compiled member node returning call1302 (depth = 11)
  partcv[0] = 0;
  Object call1303 = callmethod(call1302, "new",
    1, partcv, params);
  gc_frame_end(callframe1300);
// compiled call node returning call1303 (depth = 10)
// compiled member node returning call1303 (depth = 9)
  *var_suggestion = call1303;
  if (call1303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1305 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arrow (depth = 11)
  partcv[0] = 0;
  Object call1307 = callmethod(*var_arrow, "prev",
    1, partcv, params);
  gc_frame_end(callframe1306);
// compiled call node returning call1307 (depth = 10)
// compiled member node returning call1307 (depth = 9)
  gc_frame_newslot(call1307);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call1307;
  partcv[0] = 2;
  Object call1308 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe1305);
// compiled call node returning call1308 (depth = 8)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1309 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1310 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1309);
// compiled call node returning call1310 (depth = 8)
    gc_frame_newslot(call1310);
    if1295 = call1310;
  } else {
  }
// compiled if node returning if1295 (depth = 7)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1311 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1312 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1313 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1312);
// compiled call node returning call1313 (depth = 11)
// compiled member node returning call1313 (depth = 10)
  partcv[0] = 0;
  Object call1314 = callmethod(call1313, "new",
    1, partcv, params);
  gc_frame_end(callframe1311);
// compiled call node returning call1314 (depth = 9)
// compiled member node returning call1314 (depth = 8)
  *var_suggestion = call1314;
  if (call1314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1316 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool1317 = alloc_Boolean(1);
// compiled identifier node returning bool1317 (depth = 8)
  gc_frame_newslot(bool1317);
// starting to compile identifier node (depth = 8)
  Object bool1318 = alloc_Boolean(0);
// compiled identifier node returning bool1318 (depth = 8)
  gc_frame_newslot(bool1318);
// starting to compile string node (depth = 8)
  if (strlit1319 == NULL) {
    strlit1319 = alloc_String(" |");
    gc_root(strlit1319);
  }
// compiled string node returning strlit1319 (depth = 8)
  gc_frame_newslot(strlit1319);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool1317;
  params[2] = bool1318;
  params[3] = strlit1319;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1320 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1316);
// compiled call node returning call1320 (depth = 7)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1321 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1322 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1321);
// compiled call node returning call1322 (depth = 7)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1323 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1324 == NULL) {
    strlit1324 = alloc_String("A matching block may only have one parameter.");
    gc_root(strlit1324);
  }
// compiled string node returning strlit1324 (depth = 8)
  gc_frame_newslot(strlit1324);
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1326 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1325);
// compiled call node returning call1326 (depth = 9)
// compiled member node returning call1326 (depth = 8)
  gc_frame_newslot(call1326);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1328 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1327);
// compiled call node returning call1328 (depth = 9)
// compiled member node returning call1328 (depth = 8)
  gc_frame_newslot(call1328);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1329 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1330 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1329);
// compiled call node returning call1330 (depth = 9)
// compiled member node returning call1330 (depth = 8)
  gc_frame_newslot(call1330);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1324;
  params[1] = call1326;
  params[2] = call1328;
  params[3] = call1330;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1331 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1323);
// compiled call node returning call1331 (depth = 7)
    gc_frame_newslot(call1331);
    if1270 = call1331;
  } else {
  }
// compiled if node returning if1270 (depth = 6)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1332 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1333 = alloc_Block(NULL, NULL, "parser", 461);
  gc_frame_newslot(block1333);
// method _apply
  block_savedest(block1333);
  Object closure1334 = createclosure(1, "_apply");
  setclosureframe(closure1334, stackframe);
  addtoclosure(closure1334, selfslot);
  struct UserObject *uo1334 = (struct UserObject*)block1333;
  uo1334->data[0] = (Object)closure1334;
  Method *meth_meth_parser__apply1334 = addmethod2pos(block1333, "_apply", &meth_parser__apply1334, 0);
  int argcv_meth_parser__apply1334[] = {0};
  meth_meth_parser__apply1334->type = alloc_MethodType(1, argcv_meth_parser__apply1334);
  meth_meth_parser__apply1334->definitionModule = modulename;
  meth_meth_parser__apply1334->definitionLine = 459;
// compiled block node returning block1333 (depth = 7)
  gc_frame_newslot(block1333);
// starting to compile block node (depth = 7)
  Object block1339 = alloc_Block(NULL, NULL, "parser", 461);
  gc_frame_newslot(block1339);
// method _apply
  block_savedest(block1339);
  Object closure1340 = createclosure(4, "_apply");
  setclosureframe(closure1340, stackframe);
  addtoclosure(closure1340, var_values);
  addtoclosure(closure1340, var_expr1);
  addtoclosure(closure1340, var_params);
  addtoclosure(closure1340, selfslot);
  struct UserObject *uo1340 = (struct UserObject*)block1339;
  uo1340->data[0] = (Object)closure1340;
  Method *meth_meth_parser__apply1340 = addmethod2pos(block1339, "_apply", &meth_parser__apply1340, 0);
  int argcv_meth_parser__apply1340[] = {0};
  meth_meth_parser__apply1340->type = alloc_MethodType(1, argcv_meth_parser__apply1340);
  meth_meth_parser__apply1340->definitionModule = modulename;
  meth_meth_parser__apply1340->definitionLine = 459;
// compiled block node returning block1339 (depth = 7)
  gc_frame_newslot(block1339);
// call case 5: prelude request
  params[0] = block1333;
  params[1] = block1339;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1358 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1332);
// compiled call node returning call1358 (depth = 6)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1360 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe1361 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1362 == NULL) {
    strlit1362 = alloc_String("arrow");
    gc_root(strlit1362);
  }
// compiled string node returning strlit1362 (depth = 10)
  gc_frame_newslot(strlit1362);
// call case 4: self request
  params[0] = strlit1362;
  partcv[0] = 1;
  Object call1363 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1361);
// compiled call node returning call1363 (depth = 9)
  partcv[0] = 0;
  Object call1364 = callmethod(call1363, "not",
    1, partcv, params);
  gc_frame_end(callframe1360);
// compiled call node returning call1364 (depth = 8)
// compiled member node returning call1364 (depth = 7)
  Object if1359 = done;
  if (istrue(call1364)) {
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1365 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1367 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1366);
// compiled call node returning call1367 (depth = 11)
// compiled member node returning call1367 (depth = 10)
  partcv[0] = 0;
  Object call1368 = callmethod(call1367, "new",
    1, partcv, params);
  gc_frame_end(callframe1365);
// compiled call node returning call1368 (depth = 9)
// compiled member node returning call1368 (depth = 8)
  *var_suggestion = call1368;
  if (call1368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1372 == NULL) {
    strlit1372 = alloc_String("=");
    gc_root(strlit1372);
  }
// compiled string node returning strlit1372 (depth = 10)
  int op_slot_right_1371 = gc_frame_newslot(strlit1372);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1374 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1375 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1374);
// compiled call node returning call1375 (depth = 11)
// compiled member node returning call1375 (depth = 10)
  int op_slot_left_1371 = gc_frame_newslot(call1375);
  params[0] = strlit1372;
  partcv[0] = 1;
  Object opresult1376 = callmethod(call1375, "==", 1, partcv, params);
// compiled op node returning opresult1376 (depth = 9)
  int op_slot_right_1370 = gc_frame_newslot(opresult1376);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1379 == NULL) {
    strlit1379 = alloc_String("bind");
    gc_root(strlit1379);
  }
// compiled string node returning strlit1379 (depth = 10)
  int op_slot_right_1378 = gc_frame_newslot(strlit1379);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1382 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1381);
// compiled call node returning call1382 (depth = 11)
// compiled member node returning call1382 (depth = 10)
  int op_slot_left_1378 = gc_frame_newslot(call1382);
  params[0] = strlit1379;
  partcv[0] = 1;
  Object opresult1383 = callmethod(call1382, "==", 1, partcv, params);
// compiled op node returning opresult1383 (depth = 9)
  int op_slot_left_1370 = gc_frame_newslot(opresult1383);
  params[0] = opresult1376;
  partcv[0] = 1;
  Object opresult1384 = callmethod(opresult1383, "||", 1, partcv, params);
// compiled op node returning opresult1384 (depth = 8)
  Object if1369 = done;
  if (istrue(opresult1384)) {
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1385 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 9)
  if (strlit1386 == NULL) {
    strlit1386 = alloc_String("->");
    gc_root(strlit1386);
  }
// compiled string node returning strlit1386 (depth = 9)
  gc_frame_newslot(strlit1386);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = strlit1386;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1387 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe1385);
// compiled call node returning call1387 (depth = 8)
    gc_frame_newslot(call1387);
    if1369 = call1387;
  } else {
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1388 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1389 == NULL) {
    strlit1389 = alloc_String(" ->");
    gc_root(strlit1389);
  }
// compiled string node returning strlit1389 (depth = 9)
  gc_frame_newslot(strlit1389);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1389;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1390 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1388);
// compiled call node returning call1390 (depth = 8)
    gc_frame_newslot(call1390);
    if1369 = call1390;
  }
// compiled if node returning if1369 (depth = 7)
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1391 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1392 == NULL) {
    strlit1392 = alloc_String("A block must have one or more parameters followed by '->' and an expression.");
    gc_root(strlit1392);
  }
// compiled string node returning strlit1392 (depth = 8)
  gc_frame_newslot(strlit1392);
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1394 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1393);
// compiled call node returning call1394 (depth = 9)
// compiled member node returning call1394 (depth = 8)
  gc_frame_newslot(call1394);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1396 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1395);
// compiled call node returning call1396 (depth = 9)
// compiled member node returning call1396 (depth = 8)
  gc_frame_newslot(call1396);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1392;
  params[1] = call1394;
  params[2] = call1396;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1397 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1391);
// compiled call node returning call1397 (depth = 7)
    gc_frame_newslot(call1397);
    if1359 = call1397;
  } else {
  }
// compiled if node returning if1359 (depth = 6)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1398 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1399 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1398);
// compiled call node returning call1399 (depth = 7)
// compiled member node returning call1399 (depth = 6)
    gc_frame_newslot(call1399);
    if1164 = call1399;
  } else {
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1401 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1402 == NULL) {
    strlit1402 = alloc_String("semicolon");
    gc_root(strlit1402);
  }
// compiled string node returning strlit1402 (depth = 8)
  gc_frame_newslot(strlit1402);
// call case 4: self request
  params[0] = strlit1402;
  partcv[0] = 1;
  Object call1403 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1401);
// compiled call node returning call1403 (depth = 7)
  Object if1400 = done;
  if (istrue(call1403)) {
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1404 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call1406 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1405);
// compiled call node returning call1406 (depth = 9)
// compiled member node returning call1406 (depth = 8)
  gc_frame_newslot(call1406);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call1406;
  partcv[0] = 1;
  Object call1407 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1404);
// compiled call node returning call1407 (depth = 7)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1408 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1409 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1408);
// compiled call node returning call1409 (depth = 8)
// compiled member node returning call1409 (depth = 7)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1411 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1412 == NULL) {
    strlit1412 = alloc_String("semicolon");
    gc_root(strlit1412);
  }
// compiled string node returning strlit1412 (depth = 9)
  gc_frame_newslot(strlit1412);
// call case 4: self request
  params[0] = strlit1412;
  partcv[0] = 1;
  Object call1413 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1411);
// compiled call node returning call1413 (depth = 8)
  Object if1410 = done;
  if (istrue(call1413)) {
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1415 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1414);
// compiled call node returning call1415 (depth = 9)
// compiled member node returning call1415 (depth = 8)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call1419 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1418);
// compiled call node returning call1419 (depth = 11)
// compiled member node returning call1419 (depth = 10)
  int op_slot_right_1417 = gc_frame_newslot(call1419);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1421 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1422 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1421);
// compiled call node returning call1422 (depth = 11)
// compiled member node returning call1422 (depth = 10)
  int op_slot_left_1417 = gc_frame_newslot(call1422);
  params[0] = call1419;
  partcv[0] = 1;
  Object opresult1423 = callmethod(call1422, "==", 1, partcv, params);
// compiled op node returning opresult1423 (depth = 9)
  Object if1416 = done;
  if (istrue(opresult1423)) {
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1424 = alloc_Boolean(1);
// compiled identifier node returning bool1424 (depth = 10)
  *var_indentFreePass = bool1424;
  if (bool1424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1416 = done;
  } else {
  }
// compiled if node returning if1416 (depth = 8)
    gc_frame_newslot(if1416);
    if1410 = if1416;
  } else {
  }
// compiled if node returning if1410 (depth = 7)
    gc_frame_newslot(if1410);
    if1400 = if1410;
  } else {
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1428 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1429 == NULL) {
    strlit1429 = alloc_String("bind");
    gc_root(strlit1429);
  }
// compiled string node returning strlit1429 (depth = 10)
  gc_frame_newslot(strlit1429);
// call case 4: self request
  params[0] = strlit1429;
  partcv[0] = 1;
  Object call1430 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1428);
// compiled call node returning call1430 (depth = 9)
  int op_slot_right_1427 = gc_frame_newslot(call1430);
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1434 == NULL) {
    strlit1434 = alloc_String("index");
    gc_root(strlit1434);
  }
// compiled string node returning strlit1434 (depth = 11)
  int op_slot_right_1433 = gc_frame_newslot(strlit1434);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1436 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call1438 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1437);
// compiled call node returning call1438 (depth = 14)
// compiled member node returning call1438 (depth = 13)
  partcv[0] = 0;
  Object call1439 = callmethod(call1438, "kind",
    1, partcv, params);
  gc_frame_end(callframe1436);
// compiled call node returning call1439 (depth = 12)
// compiled member node returning call1439 (depth = 11)
  int op_slot_left_1433 = gc_frame_newslot(call1439);
  params[0] = strlit1434;
  partcv[0] = 1;
  Object opresult1440 = callmethod(call1439, "==", 1, partcv, params);
// compiled op node returning opresult1440 (depth = 10)
  int op_slot_right_1432 = gc_frame_newslot(opresult1440);
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1444 == NULL) {
    strlit1444 = alloc_String("identifier");
    gc_root(strlit1444);
  }
// compiled string node returning strlit1444 (depth = 12)
  int op_slot_right_1443 = gc_frame_newslot(strlit1444);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1446 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1448 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1447);
// compiled call node returning call1448 (depth = 15)
// compiled member node returning call1448 (depth = 14)
  partcv[0] = 0;
  Object call1449 = callmethod(call1448, "kind",
    1, partcv, params);
  gc_frame_end(callframe1446);
// compiled call node returning call1449 (depth = 13)
// compiled member node returning call1449 (depth = 12)
  int op_slot_left_1443 = gc_frame_newslot(call1449);
  params[0] = strlit1444;
  partcv[0] = 1;
  Object opresult1450 = callmethod(call1449, "==", 1, partcv, params);
// compiled op node returning opresult1450 (depth = 11)
  int op_slot_right_1442 = gc_frame_newslot(opresult1450);
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1453 == NULL) {
    strlit1453 = alloc_String("member");
    gc_root(strlit1453);
  }
// compiled string node returning strlit1453 (depth = 12)
  int op_slot_right_1452 = gc_frame_newslot(strlit1453);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1455 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1456 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1457 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1456);
// compiled call node returning call1457 (depth = 15)
// compiled member node returning call1457 (depth = 14)
  partcv[0] = 0;
  Object call1458 = callmethod(call1457, "kind",
    1, partcv, params);
  gc_frame_end(callframe1455);
// compiled call node returning call1458 (depth = 13)
// compiled member node returning call1458 (depth = 12)
  int op_slot_left_1452 = gc_frame_newslot(call1458);
  params[0] = strlit1453;
  partcv[0] = 1;
  Object opresult1459 = callmethod(call1458, "==", 1, partcv, params);
// compiled op node returning opresult1459 (depth = 11)
  int op_slot_left_1442 = gc_frame_newslot(opresult1459);
  params[0] = opresult1450;
  partcv[0] = 1;
  Object opresult1460 = callmethod(opresult1459, "||", 1, partcv, params);
// compiled op node returning opresult1460 (depth = 10)
  int op_slot_left_1432 = gc_frame_newslot(opresult1460);
  params[0] = opresult1440;
  partcv[0] = 1;
  Object opresult1461 = callmethod(opresult1460, "||", 1, partcv, params);
// compiled op node returning opresult1461 (depth = 9)
  int op_slot_left_1427 = gc_frame_newslot(opresult1461);
  params[0] = call1430;
  partcv[0] = 1;
  Object opresult1462 = callmethod(opresult1461, "&&", 1, partcv, params);
// compiled op node returning opresult1462 (depth = 8)
  Object if1426 = done;
  if (istrue(opresult1462)) {
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1463 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1464 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1463);
// compiled call node returning call1464 (depth = 10)
// compiled member node returning call1464 (depth = 9)
  *var_lhs = call1464;
  if (call1464 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1465 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1466 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1465);
// compiled call node returning call1466 (depth = 9)
// compiled member node returning call1466 (depth = 8)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1468 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe1469 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block1470 = alloc_Block(NULL, NULL, "parser", 496);
  gc_frame_newslot(block1470);
// method _apply
  block_savedest(block1470);
  Object closure1471 = createclosure(2, "_apply");
  setclosureframe(closure1471, stackframe);
  addtoclosure(closure1471, var_blocksOK);
  addtoclosure(closure1471, selfslot);
  struct UserObject *uo1471 = (struct UserObject*)block1470;
  uo1471->data[0] = (Object)closure1471;
  Method *meth_meth_parser__apply1471 = addmethod2pos(block1470, "_apply", &meth_parser__apply1471, 0);
  int argcv_meth_parser__apply1471[] = {0};
  meth_meth_parser__apply1471->type = alloc_MethodType(1, argcv_meth_parser__apply1471);
  meth_meth_parser__apply1471->definitionModule = modulename;
  meth_meth_parser__apply1471->definitionLine = 496;
// compiled block node returning block1470 (depth = 12)
  gc_frame_newslot(block1470);
// call case 4: self request
  params[0] = block1470;
  partcv[0] = 1;
  Object call1475 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1469);
// compiled call node returning call1475 (depth = 11)
  partcv[0] = 0;
  Object call1476 = callmethod(call1475, "not",
    1, partcv, params);
  gc_frame_end(callframe1468);
// compiled call node returning call1476 (depth = 10)
// compiled member node returning call1476 (depth = 9)
  Object if1467 = done;
  if (istrue(call1476)) {
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1477 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1478 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1479 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1478);
// compiled call node returning call1479 (depth = 13)
// compiled member node returning call1479 (depth = 12)
  partcv[0] = 0;
  Object call1480 = callmethod(call1479, "empty",
    1, partcv, params);
  gc_frame_end(callframe1477);
// compiled call node returning call1480 (depth = 11)
// compiled member node returning call1480 (depth = 10)
  *var_suggestions = call1480;
  if (call1480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1481 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1482 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1483 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1482);
// compiled call node returning call1483 (depth = 13)
// compiled member node returning call1483 (depth = 12)
  partcv[0] = 0;
  Object call1484 = callmethod(call1483, "new",
    1, partcv, params);
  gc_frame_end(callframe1481);
// compiled call node returning call1484 (depth = 11)
// compiled member node returning call1484 (depth = 10)
  *var_suggestion = call1484;
  if (call1484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1485 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit1486 == NULL) {
    strlit1486 = alloc_String("rbrace");
    gc_root(strlit1486);
  }
// compiled string node returning strlit1486 (depth = 11)
  gc_frame_newslot(strlit1486);
// call case 4: self request
  params[0] = strlit1486;
  partcv[0] = 1;
  Object call1487 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1485);
// compiled call node returning call1487 (depth = 10)
  *var_nextTok = call1487;
  if (call1487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_1489 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_1489 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1491 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1491 (depth = 10)
  Object if1488 = done;
  if (istrue(opresult1491)) {
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1492 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit1493 == NULL) {
    strlit1493 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1493);
  }
// compiled string node returning strlit1493 (depth = 11)
  gc_frame_newslot(strlit1493);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit1493;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1494 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1492);
// compiled call node returning call1494 (depth = 10)
    gc_frame_newslot(call1494);
    if1488 = call1494;
  } else {
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1495 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call1497 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1496);
// compiled call node returning call1497 (depth = 12)
// compiled member node returning call1497 (depth = 11)
  gc_frame_newslot(call1497);
// starting to compile identifier node (depth = 11)
  Object bool1498 = alloc_Boolean(1);
// compiled identifier node returning bool1498 (depth = 11)
  gc_frame_newslot(bool1498);
// starting to compile identifier node (depth = 11)
  Object bool1499 = alloc_Boolean(0);
// compiled identifier node returning bool1499 (depth = 11)
  gc_frame_newslot(bool1499);
// starting to compile string node (depth = 11)
  if (strlit1500 == NULL) {
    strlit1500 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1500);
  }
// compiled string node returning strlit1500 (depth = 11)
  gc_frame_newslot(strlit1500);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = call1497;
  params[2] = bool1498;
  params[3] = bool1499;
  params[4] = strlit1500;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1501 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1495);
// compiled call node returning call1501 (depth = 10)
    gc_frame_newslot(call1501);
    if1488 = call1501;
  }
// compiled if node returning if1488 (depth = 9)
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1502 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1503 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1502);
// compiled call node returning call1503 (depth = 9)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1504 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1506 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1505);
// compiled call node returning call1506 (depth = 13)
// compiled member node returning call1506 (depth = 12)
  partcv[0] = 0;
  Object call1507 = callmethod(call1506, "new",
    1, partcv, params);
  gc_frame_end(callframe1504);
// compiled call node returning call1507 (depth = 11)
// compiled member node returning call1507 (depth = 10)
  *var_suggestion = call1507;
  if (call1507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1509 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1511 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1510);
// compiled call node returning call1511 (depth = 11)
// compiled member node returning call1511 (depth = 10)
  gc_frame_newslot(call1511);
// starting to compile identifier node (depth = 10)
  Object bool1512 = alloc_Boolean(1);
// compiled identifier node returning bool1512 (depth = 10)
  gc_frame_newslot(bool1512);
// starting to compile identifier node (depth = 10)
  Object bool1513 = alloc_Boolean(0);
// compiled identifier node returning bool1513 (depth = 10)
  gc_frame_newslot(bool1513);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = call1511;
  params[2] = bool1512;
  params[3] = bool1513;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1514 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1509);
// compiled call node returning call1514 (depth = 9)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1515 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1516 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1515);
// compiled call node returning call1516 (depth = 9)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1517 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1518 == NULL) {
    strlit1518 = alloc_String("A valid expression must follow ':='.");
    gc_root(strlit1518);
  }
// compiled string node returning strlit1518 (depth = 10)
  gc_frame_newslot(strlit1518);
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1520 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1519);
// compiled call node returning call1520 (depth = 11)
// compiled member node returning call1520 (depth = 10)
  gc_frame_newslot(call1520);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1522 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1521);
// compiled call node returning call1522 (depth = 11)
// compiled member node returning call1522 (depth = 10)
  gc_frame_newslot(call1522);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit1518;
  params[1] = call1520;
  params[2] = call1522;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1523 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1517);
// compiled call node returning call1523 (depth = 9)
    gc_frame_newslot(call1523);
    if1467 = call1523;
  } else {
  }
// compiled if node returning if1467 (depth = 8)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1525 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1524);
// compiled call node returning call1525 (depth = 10)
// compiled member node returning call1525 (depth = 9)
  *var_rhs = call1525;
  if (call1525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1526 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1528 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1527);
// compiled call node returning call1528 (depth = 10)
// compiled member node returning call1528 (depth = 9)
  gc_frame_newslot(call1528);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1529 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1530 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1529);
// compiled call node returning call1530 (depth = 10)
// compiled member node returning call1530 (depth = 9)
  gc_frame_newslot(call1530);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  params[0] = call1528;
  params[1] = call1530;
  partcv[0] = 2;
  Object call1531 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1526);
// compiled call node returning call1531 (depth = 8)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1532 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1533 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lhs (depth = 10)
  gc_frame_newslot(*var_lhs);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rhs (depth = 10)
  gc_frame_newslot(*var_rhs);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ast (depth = 12)
  partcv[0] = 0;
  Object call1535 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe1534);
// compiled call node returning call1535 (depth = 11)
// compiled member node returning call1535 (depth = 10)
  params[0] = *var_lhs;
  params[1] = *var_rhs;
  partcv[0] = 2;
  Object call1536 = callmethod(call1535, "new",
    1, partcv, params);
  gc_frame_end(callframe1533);
// compiled call node returning call1536 (depth = 9)
  gc_frame_newslot(call1536);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1536;
  partcv[0] = 1;
  Object call1537 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1532);
// compiled call node returning call1537 (depth = 8)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1539 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1540 == NULL) {
    strlit1540 = alloc_String("semicolon");
    gc_root(strlit1540);
  }
// compiled string node returning strlit1540 (depth = 10)
  gc_frame_newslot(strlit1540);
// call case 4: self request
  params[0] = strlit1540;
  partcv[0] = 1;
  Object call1541 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1539);
// compiled call node returning call1541 (depth = 9)
  Object if1538 = done;
  if (istrue(call1541)) {
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1542 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1543 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1542);
// compiled call node returning call1543 (depth = 10)
// compiled member node returning call1543 (depth = 9)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1546 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastToken (depth = 13)
  partcv[0] = 0;
  Object call1547 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1546);
// compiled call node returning call1547 (depth = 12)
// compiled member node returning call1547 (depth = 11)
  int op_slot_right_1545 = gc_frame_newslot(call1547);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call1550 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1549);
// compiled call node returning call1550 (depth = 12)
// compiled member node returning call1550 (depth = 11)
  int op_slot_left_1545 = gc_frame_newslot(call1550);
  params[0] = call1547;
  partcv[0] = 1;
  Object opresult1551 = callmethod(call1550, "==", 1, partcv, params);
// compiled op node returning opresult1551 (depth = 10)
  Object if1544 = done;
  if (istrue(opresult1551)) {
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool1552 = alloc_Boolean(1);
// compiled identifier node returning bool1552 (depth = 11)
  *var_indentFreePass = bool1552;
  if (bool1552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1544 = done;
  } else {
  }
// compiled if node returning if1544 (depth = 9)
    gc_frame_newslot(if1544);
    if1538 = if1544;
  } else {
  }
// compiled if node returning if1538 (depth = 8)
    gc_frame_newslot(if1538);
    if1426 = if1538;
  } else {
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1554 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1555 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1554);
// compiled call node returning call1555 (depth = 9)
// compiled member node returning call1555 (depth = 8)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1556 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1558 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1557);
// compiled call node returning call1558 (depth = 10)
// compiled member node returning call1558 (depth = 9)
  gc_frame_newslot(call1558);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1558;
  partcv[0] = 1;
  Object call1559 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1556);
// compiled call node returning call1559 (depth = 8)
    gc_frame_newslot(call1559);
    if1426 = call1559;
  }
// compiled if node returning if1426 (depth = 7)
    gc_frame_newslot(if1426);
    if1400 = if1426;
  }
// compiled if node returning if1400 (depth = 6)
    gc_frame_newslot(if1400);
    if1164 = if1400;
  }
// compiled if node returning if1164 (depth = 5)
  gc_frame_end(frame);
  return if1164;
}
Object meth_parser__apply1586(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1587 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe1588 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1589 == NULL) {
    strlit1589 = alloc_String("rbrace");
    gc_root(strlit1589);
  }
// compiled string node returning strlit1589 (depth = 8)
  gc_frame_newslot(strlit1589);
// call case 4: self request
  params[0] = strlit1589;
  partcv[0] = 1;
  Object call1590 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compiled call node returning call1590 (depth = 7)
  partcv[0] = 0;
  Object call1591 = callmethod(call1590, "not",
    1, partcv, params);
  gc_frame_end(callframe1587);
// compiled call node returning call1591 (depth = 6)
// compiled member node returning call1591 (depth = 5)
  gc_frame_end(frame);
  return call1591;
}
Object meth_parser__apply1599(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1600 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1601 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1600);
// compiled call node returning call1601 (depth = 11)
// compiled member node returning call1601 (depth = 10)
  gc_frame_end(frame);
  return call1601;
}
Object meth_parser__apply1594(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_body = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1596 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe1597 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1598 = alloc_Block(NULL, NULL, "parser", 536);
  gc_frame_newslot(block1598);
// method _apply
  block_savedest(block1598);
  Object closure1599 = createclosure(1, "_apply");
  setclosureframe(closure1599, stackframe);
  addtoclosure(closure1599, selfslot);
  struct UserObject *uo1599 = (struct UserObject*)block1598;
  uo1599->data[0] = (Object)closure1599;
  Method *meth_meth_parser__apply1599 = addmethod2pos(block1598, "_apply", &meth_parser__apply1599, 0);
  int argcv_meth_parser__apply1599[] = {0};
  meth_meth_parser__apply1599->type = alloc_MethodType(1, argcv_meth_parser__apply1599);
  meth_meth_parser__apply1599->definitionModule = modulename;
  meth_meth_parser__apply1599->definitionLine = 536;
// compiled block node returning block1598 (depth = 9)
  gc_frame_newslot(block1598);
// call case 4: self request
  params[0] = block1598;
  partcv[0] = 1;
  Object call1603 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1597);
// compiled call node returning call1603 (depth = 8)
  partcv[0] = 0;
  Object call1604 = callmethod(call1603, "not",
    1, partcv, params);
  gc_frame_end(callframe1596);
// compiled call node returning call1604 (depth = 7)
// compiled member node returning call1604 (depth = 6)
  Object if1595 = done;
  if (istrue(call1604)) {
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1605 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1607 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1606);
// compiled call node returning call1607 (depth = 10)
// compiled member node returning call1607 (depth = 9)
  partcv[0] = 0;
  Object call1608 = callmethod(call1607, "new",
    1, partcv, params);
  gc_frame_end(callframe1605);
// compiled call node returning call1608 (depth = 8)
// compiled member node returning call1608 (depth = 7)
  *var_suggestion = call1608;
  if (call1608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1609 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1610 == NULL) {
    strlit1610 = alloc_String("}");
    gc_root(strlit1610);
  }
// compiled string node returning strlit1610 (depth = 7)
  gc_frame_newslot(strlit1610);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1610;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1611 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1609);
// compiled call node returning call1611 (depth = 6)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1612 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1613 == NULL) {
    strlit1613 = alloc_String("A block must end with a '}'.");
    gc_root(strlit1613);
  }
// compiled string node returning strlit1613 (depth = 7)
  gc_frame_newslot(strlit1613);
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1615 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1614);
// compiled call node returning call1615 (depth = 8)
// compiled member node returning call1615 (depth = 7)
  gc_frame_newslot(call1615);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1617 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1616);
// compiled call node returning call1617 (depth = 8)
// compiled member node returning call1617 (depth = 7)
  gc_frame_newslot(call1617);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1613;
  params[1] = call1615;
  params[2] = call1617;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1618 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1612);
// compiled call node returning call1618 (depth = 6)
    gc_frame_newslot(call1618);
    if1595 = call1618;
  } else {
  }
// compiled if node returning if1595 (depth = 5)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1619 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call1620 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1619);
// compiled call node returning call1620 (depth = 7)
// compiled member node returning call1620 (depth = 6)
  *var_tmp = call1620;
  if (call1620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1622 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call1623 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1622);
// compiled call node returning call1623 (depth = 5)
  gc_frame_end(frame);
  return call1623;
}
Object meth_parser_block1123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_braceIsType = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_indentFreePass = getfromclosure(closure, 8);
  Object *var_util = getfromclosure(closure, 9);
  Object *var_ast = getfromclosure(closure, 10);
  Object *var_minIndentLevel = getfromclosure(closure, 11);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for block (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for block");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_minInd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "minInd");
  Object *var_startIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startIndent");
  Object *var_expr1 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "expr1");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_params = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "params");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_havearrow = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "havearrow");
  Object *var_found = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "found");
  Object *var_i = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "i");
  Object *var_isMatchingBlock = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "isMatchingBlock");
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1125 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1126 == NULL) {
    strlit1126 = alloc_String("lbrace");
    gc_root(strlit1126);
  }
// compiled string node returning strlit1126 (depth = 4)
  gc_frame_newslot(strlit1126);
// call case 4: self request
  params[0] = strlit1126;
  partcv[0] = 1;
  Object call1127 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1125);
// compiled call node returning call1127 (depth = 3)
  Object if1124 = done;
  if (istrue(call1127)) {
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1128 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1129 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1128);
// compiled call node returning call1129 (depth = 4)
// compiled member node returning call1129 (depth = 3)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1131 = alloc_Float64(1);
// compiled num node returning num1131 (depth = 5)
  int op_slot_right_1130 = gc_frame_newslot(num1131);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1130 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1131;
  partcv[0] = 1;
  Object sum1133 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum1133 (depth = 4)
  *var_minInd = sum1133;
  if (sum1133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_startIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_expr1 = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_s = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1134 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1135 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1136 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1135);
// compiled call node returning call1136 (depth = 7)
// compiled member node returning call1136 (depth = 6)
  partcv[0] = 0;
  Object call1137 = callmethod(call1136, "empty",
    1, partcv, params);
  gc_frame_end(callframe1134);
// compiled call node returning call1137 (depth = 5)
// compiled member node returning call1137 (depth = 4)
  *var_params = call1137;
  if (call1137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1138 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1139 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1140 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1139);
// compiled call node returning call1140 (depth = 7)
// compiled member node returning call1140 (depth = 6)
  partcv[0] = 0;
  Object call1141 = callmethod(call1140, "empty",
    1, partcv, params);
  gc_frame_end(callframe1138);
// compiled call node returning call1141 (depth = 5)
// compiled member node returning call1141 (depth = 4)
  *var_body = call1141;
  if (call1141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1142 = alloc_Boolean(1);
// compiled identifier node returning bool1142 (depth = 4)
  *var_havearrow = bool1142;
  if (bool1142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1143 = alloc_Boolean(0);
// compiled identifier node returning bool1143 (depth = 4)
  *var_found = bool1143;
  if (bool1143 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1144 = alloc_Float64(0);
// compiled num node returning num1144 (depth = 4)
  *var_i = num1144;
  if (num1144 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1145 = alloc_Boolean(0);
// compiled identifier node returning bool1145 (depth = 4)
  *var_isMatchingBlock = bool1145;
  if (bool1145 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1149 == NULL) {
    strlit1149 = alloc_String("lparen");
    gc_root(strlit1149);
  }
// compiled string node returning strlit1149 (depth = 5)
  int op_slot_right_1148 = gc_frame_newslot(strlit1149);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1151 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1152 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1151);
// compiled call node returning call1152 (depth = 6)
// compiled member node returning call1152 (depth = 5)
  int op_slot_left_1148 = gc_frame_newslot(call1152);
  params[0] = strlit1149;
  partcv[0] = 1;
  Object opresult1153 = callmethod(call1152, "==", 1, partcv, params);
// compiled op node returning opresult1153 (depth = 4)
  Object if1147 = done;
  if (istrue(opresult1153)) {
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1154 = alloc_Boolean(1);
// compiled identifier node returning bool1154 (depth = 5)
  *var_isMatchingBlock = bool1154;
  if (bool1154 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1147 = done;
  } else {
  }
// compiled if node returning if1147 (depth = 3)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1156 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1157 = alloc_Block(NULL, NULL, "parser", 412);
  gc_frame_newslot(block1157);
// method _apply
  block_savedest(block1157);
  Object closure1158 = createclosure(2, "_apply");
  setclosureframe(closure1158, stackframe);
  addtoclosure(closure1158, var_blocksOK);
  addtoclosure(closure1158, selfslot);
  struct UserObject *uo1158 = (struct UserObject*)block1157;
  uo1158->data[0] = (Object)closure1158;
  Method *meth_meth_parser__apply1158 = addmethod2pos(block1157, "_apply", &meth_parser__apply1158, 0);
  int argcv_meth_parser__apply1158[] = {0};
  meth_meth_parser__apply1158->type = alloc_MethodType(1, argcv_meth_parser__apply1158);
  meth_meth_parser__apply1158->definitionModule = modulename;
  meth_meth_parser__apply1158->definitionLine = 407;
// compiled block node returning block1157 (depth = 4)
  gc_frame_newslot(block1157);
// starting to compile block node (depth = 4)
  Object block1162 = alloc_Block(NULL, NULL, "parser", 412);
  gc_frame_newslot(block1162);
// method _apply
  block_savedest(block1162);
  Object closure1163 = createclosure(15, "_apply");
  setclosureframe(closure1163, stackframe);
  addtoclosure(closure1163, var_values);
  addtoclosure(closure1163, var_expr1);
  addtoclosure(closure1163, var_braceIsType);
  addtoclosure(closure1163, var_blocksOK);
  addtoclosure(closure1163, var_errormessages);
  addtoclosure(closure1163, var_sym);
  addtoclosure(closure1163, var_lastToken);
  addtoclosure(closure1163, var_params);
  addtoclosure(closure1163, var_isMatchingBlock);
  addtoclosure(closure1163, var_body);
  addtoclosure(closure1163, var_indentFreePass);
  addtoclosure(closure1163, var_btok);
  addtoclosure(closure1163, var_util);
  addtoclosure(closure1163, var_ast);
  addtoclosure(closure1163, selfslot);
  struct UserObject *uo1163 = (struct UserObject*)block1162;
  uo1163->data[0] = (Object)closure1163;
  Method *meth_meth_parser__apply1163 = addmethod2pos(block1162, "_apply", &meth_parser__apply1163, 0);
  int argcv_meth_parser__apply1163[] = {0};
  meth_meth_parser__apply1163->type = alloc_MethodType(1, argcv_meth_parser__apply1163);
  meth_meth_parser__apply1163->definitionModule = modulename;
  meth_meth_parser__apply1163->definitionLine = 407;
// compiled block node returning block1162 (depth = 4)
  gc_frame_newslot(block1162);
// call case 4: self request
  params[0] = block1157;
  params[1] = block1162;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1561 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1156);
// compiled call node returning call1561 (depth = 3)
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1563 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1564 == NULL) {
    strlit1564 = alloc_String("arrow");
    gc_root(strlit1564);
  }
// compiled string node returning strlit1564 (depth = 5)
  gc_frame_newslot(strlit1564);
// call case 4: self request
  params[0] = strlit1564;
  partcv[0] = 1;
  Object call1565 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1563);
// compiled call node returning call1565 (depth = 4)
  Object if1562 = done;
  if (istrue(call1565)) {
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1567 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1566);
// compiled call node returning call1567 (depth = 5)
// compiled member node returning call1567 (depth = 4)
    gc_frame_newslot(call1567);
    if1562 = call1567;
  } else {
  }
// compiled if node returning if1562 (depth = 3)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1571 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1570);
// compiled call node returning call1571 (depth = 6)
// compiled member node returning call1571 (depth = 5)
  int op_slot_right_1569 = gc_frame_newslot(call1571);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1573 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1574 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1573);
// compiled call node returning call1574 (depth = 6)
// compiled member node returning call1574 (depth = 5)
  int op_slot_left_1569 = gc_frame_newslot(call1574);
  params[0] = call1571;
  partcv[0] = 1;
  Object opresult1575 = callmethod(call1574, "==", 1, partcv, params);
// compiled op node returning opresult1575 (depth = 4)
  Object if1568 = done;
  if (istrue(opresult1575)) {
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1577 = alloc_Float64(1);
// compiled num node returning num1577 (depth = 6)
  int op_slot_right_1576 = gc_frame_newslot(num1577);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1579 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1580 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1579);
// compiled call node returning call1580 (depth = 7)
// compiled member node returning call1580 (depth = 6)
  int op_slot_left_1576 = gc_frame_newslot(call1580);
  params[0] = num1577;
  partcv[0] = 1;
  Object diff1581 = callmethod(call1580, "-", 1, partcv, params);
// compiled op node returning diff1581 (depth = 5)
  *var_minIndentLevel = diff1581;
  if (diff1581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1568 = done;
  } else {
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1568 = done;
  }
// compiled if node returning if1568 (depth = 3)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1584 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1585 = alloc_Block(NULL, NULL, "parser", 534);
  gc_frame_newslot(block1585);
// method _apply
  block_savedest(block1585);
  Object closure1586 = createclosure(1, "_apply");
  setclosureframe(closure1586, stackframe);
  addtoclosure(closure1586, selfslot);
  struct UserObject *uo1586 = (struct UserObject*)block1585;
  uo1586->data[0] = (Object)closure1586;
  Method *meth_meth_parser__apply1586 = addmethod2pos(block1585, "_apply", &meth_parser__apply1586, 0);
  int argcv_meth_parser__apply1586[] = {0};
  meth_meth_parser__apply1586->type = alloc_MethodType(1, argcv_meth_parser__apply1586);
  meth_meth_parser__apply1586->definitionModule = modulename;
  meth_meth_parser__apply1586->definitionLine = 530;
// compiled block node returning block1585 (depth = 4)
  gc_frame_newslot(block1585);
// starting to compile block node (depth = 4)
  Object block1593 = alloc_Block(NULL, NULL, "parser", 534);
  gc_frame_newslot(block1593);
// method _apply
  block_savedest(block1593);
  Object closure1594 = createclosure(7, "_apply");
  setclosureframe(closure1594, stackframe);
  addtoclosure(closure1594, var_errormessages);
  addtoclosure(closure1594, var_lastToken);
  addtoclosure(closure1594, var_sym);
  addtoclosure(closure1594, var_values);
  addtoclosure(closure1594, var_tmp);
  addtoclosure(closure1594, var_body);
  addtoclosure(closure1594, selfslot);
  struct UserObject *uo1594 = (struct UserObject*)block1593;
  uo1594->data[0] = (Object)closure1594;
  Method *meth_meth_parser__apply1594 = addmethod2pos(block1593, "_apply", &meth_parser__apply1594, 0);
  int argcv_meth_parser__apply1594[] = {0};
  meth_meth_parser__apply1594->type = alloc_MethodType(1, argcv_meth_parser__apply1594);
  meth_meth_parser__apply1594->definitionModule = modulename;
  meth_meth_parser__apply1594->definitionLine = 534;
// compiled block node returning block1593 (depth = 4)
  gc_frame_newslot(block1593);
// call case 5: prelude request
  params[0] = block1585;
  params[1] = block1593;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1625 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1584);
// compiled call node returning call1625 (depth = 3)
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1627 = alloc_Float64(1);
// compiled num node returning num1627 (depth = 5)
  int op_slot_right_1626 = gc_frame_newslot(num1627);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  int op_slot_left_1626 = gc_frame_newslot(*var_minInd);
  params[0] = num1627;
  partcv[0] = 1;
  Object diff1629 = callmethod(*var_minInd, "-", 1, partcv, params);
// compiled op node returning diff1629 (depth = 4)
  *var_minIndentLevel = diff1629;
  if (diff1629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_statementIndent = *var_startIndent;
  if (*var_startIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1632 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1633 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1632);
// compiled call node returning call1633 (depth = 4)
// compiled member node returning call1633 (depth = 3)
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1634 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call1636 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1635);
// compiled call node returning call1636 (depth = 5)
// compiled member node returning call1636 (depth = 4)
  gc_frame_newslot(call1636);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call1638 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1637);
// compiled call node returning call1638 (depth = 5)
// compiled member node returning call1638 (depth = 4)
  gc_frame_newslot(call1638);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call1636;
  params[1] = call1638;
  partcv[0] = 2;
  Object call1639 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1634);
// compiled call node returning call1639 (depth = 3)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1640 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call1642 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1641);
// compiled call node returning call1642 (depth = 6)
// compiled member node returning call1642 (depth = 5)
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1643 = callmethod(call1642, "new",
    1, partcv, params);
  gc_frame_end(callframe1640);
// compiled call node returning call1643 (depth = 4)
  *var_o = call1643;
  if (call1643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_isMatchingBlock (depth = 4)
  Object if1644 = done;
  if (istrue(*var_isMatchingBlock)) {
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1647 = alloc_Float64(0);
// compiled num node returning num1647 (depth = 6)
  int op_slot_right_1646 = gc_frame_newslot(num1647);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  partcv[0] = 0;
  Object call1650 = callmethod(*var_params, "size",
    1, partcv, params);
  gc_frame_end(callframe1649);
// compiled call node returning call1650 (depth = 7)
// compiled member node returning call1650 (depth = 6)
  int op_slot_left_1646 = gc_frame_newslot(call1650);
  params[0] = num1647;
  partcv[0] = 1;
  Object opresult1651 = callmethod(call1650, ">", 1, partcv, params);
// compiled op node returning opresult1651 (depth = 5)
  Object if1645 = done;
  if (istrue(opresult1651)) {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1652 = gc_frame_new();
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1653 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_params (depth = 9)
  partcv[0] = 0;
  Object call1654 = callmethod(*var_params, "first",
    1, partcv, params);
  gc_frame_end(callframe1653);
// compiled call node returning call1654 (depth = 8)
// compiled member node returning call1654 (depth = 7)
  gc_frame_newslot(call1654);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  params[0] = call1654;
  partcv[0] = 1;
  Object call1655 = callmethod(*var_o, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1652);
// compiled call node returning call1655 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1645 = done;
  } else {
  }
// compiled if node returning if1645 (depth = 4)
    gc_frame_newslot(if1645);
    if1644 = if1645;
  } else {
  }
// compiled if node returning if1644 (depth = 3)
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1656 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1657 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1656);
// compiled call node returning call1657 (depth = 3)
    gc_frame_newslot(call1657);
    if1124 = call1657;
  } else {
  }
// compiled if node returning if1124 (depth = 2)
  gc_frame_end(frame);
  return if1124;
}
Object meth_parser__apply1687(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1692 == NULL) {
    strlit1692 = alloc_String("then");
    gc_root(strlit1692);
  }
// compiled string node returning strlit1692 (depth = 11)
  int op_slot_right_1691 = gc_frame_newslot(strlit1692);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1694 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1695 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe1694);
// compiled call node returning call1695 (depth = 12)
// compiled member node returning call1695 (depth = 11)
  int op_slot_left_1691 = gc_frame_newslot(call1695);
  params[0] = strlit1692;
  partcv[0] = 1;
  Object opresult1696 = callmethod(call1695, "==", 1, partcv, params);
// compiled op node returning opresult1696 (depth = 10)
  int op_slot_right_1690 = gc_frame_newslot(opresult1696);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1699 == NULL) {
    strlit1699 = alloc_String("identifier");
    gc_root(strlit1699);
  }
// compiled string node returning strlit1699 (depth = 11)
  int op_slot_right_1698 = gc_frame_newslot(strlit1699);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1702 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1701);
// compiled call node returning call1702 (depth = 12)
// compiled member node returning call1702 (depth = 11)
  int op_slot_left_1698 = gc_frame_newslot(call1702);
  params[0] = strlit1699;
  partcv[0] = 1;
  Object opresult1703 = callmethod(call1702, "==", 1, partcv, params);
// compiled op node returning opresult1703 (depth = 10)
  int op_slot_left_1690 = gc_frame_newslot(opresult1703);
  params[0] = opresult1696;
  partcv[0] = 1;
  Object opresult1704 = callmethod(opresult1703, "&&", 1, partcv, params);
// compiled op node returning opresult1704 (depth = 9)
  int op_slot_right_1689 = gc_frame_newslot(opresult1704);
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1708 == NULL) {
    strlit1708 = alloc_String("lbrace");
    gc_root(strlit1708);
  }
// compiled string node returning strlit1708 (depth = 11)
  int op_slot_right_1707 = gc_frame_newslot(strlit1708);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1711 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1710);
// compiled call node returning call1711 (depth = 12)
// compiled member node returning call1711 (depth = 11)
  int op_slot_left_1707 = gc_frame_newslot(call1711);
  params[0] = strlit1708;
  partcv[0] = 1;
  Object opresult1712 = callmethod(call1711, "==", 1, partcv, params);
// compiled op node returning opresult1712 (depth = 10)
  int op_slot_right_1706 = gc_frame_newslot(opresult1712);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1715 == NULL) {
    strlit1715 = alloc_String("rparen");
    gc_root(strlit1715);
  }
// compiled string node returning strlit1715 (depth = 11)
  int op_slot_right_1714 = gc_frame_newslot(strlit1715);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1717 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1718 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1717);
// compiled call node returning call1718 (depth = 12)
// compiled member node returning call1718 (depth = 11)
  int op_slot_left_1714 = gc_frame_newslot(call1718);
  params[0] = strlit1715;
  partcv[0] = 1;
  Object opresult1719 = callmethod(call1718, "==", 1, partcv, params);
// compiled op node returning opresult1719 (depth = 10)
  int op_slot_left_1706 = gc_frame_newslot(opresult1719);
  params[0] = opresult1712;
  partcv[0] = 1;
  Object opresult1720 = callmethod(opresult1719, "||", 1, partcv, params);
// compiled op node returning opresult1720 (depth = 9)
  int op_slot_left_1689 = gc_frame_newslot(opresult1720);
  params[0] = opresult1704;
  partcv[0] = 1;
  Object opresult1721 = callmethod(opresult1720, "||", 1, partcv, params);
// compiled op node returning opresult1721 (depth = 8)
  int op_slot_right_1688 = gc_frame_newslot(opresult1721);
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1725 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1724);
// compiled call node returning call1725 (depth = 10)
// compiled member node returning call1725 (depth = 9)
  int op_slot_right_1723 = gc_frame_newslot(call1725);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1728 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1727);
// compiled call node returning call1728 (depth = 10)
// compiled member node returning call1728 (depth = 9)
  int op_slot_left_1723 = gc_frame_newslot(call1728);
  params[0] = call1725;
  partcv[0] = 1;
  Object opresult1729 = callmethod(call1728, "==", 1, partcv, params);
// compiled op node returning opresult1729 (depth = 8)
  int op_slot_left_1688 = gc_frame_newslot(opresult1729);
  params[0] = opresult1721;
  partcv[0] = 1;
  Object opresult1730 = callmethod(opresult1729, "&&", 1, partcv, params);
// compiled op node returning opresult1730 (depth = 7)
  gc_frame_end(frame);
  return opresult1730;
}
Object meth_parser__apply1817(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1818 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1819 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1818);
// compiled call node returning call1819 (depth = 8)
  gc_frame_end(frame);
  return call1819;
}
Object meth_parser__apply1829(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1832 == NULL) {
    strlit1832 = alloc_String("rparen");
    gc_root(strlit1832);
  }
// compiled string node returning strlit1832 (depth = 9)
  int op_slot_right_1831 = gc_frame_newslot(strlit1832);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1835 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1834);
// compiled call node returning call1835 (depth = 10)
// compiled member node returning call1835 (depth = 9)
  int op_slot_left_1831 = gc_frame_newslot(call1835);
  params[0] = strlit1832;
  partcv[0] = 1;
  Object opresult1836 = callmethod(call1835, "==", 1, partcv, params);
// compiled op node returning opresult1836 (depth = 8)
  int op_slot_right_1830 = gc_frame_newslot(opresult1836);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call1840 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1839);
// compiled call node returning call1840 (depth = 10)
// compiled member node returning call1840 (depth = 9)
  int op_slot_right_1838 = gc_frame_newslot(call1840);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1843 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1842);
// compiled call node returning call1843 (depth = 10)
// compiled member node returning call1843 (depth = 9)
  int op_slot_left_1838 = gc_frame_newslot(call1843);
  params[0] = call1840;
  partcv[0] = 1;
  Object opresult1844 = callmethod(call1843, "==", 1, partcv, params);
// compiled op node returning opresult1844 (depth = 8)
  int op_slot_left_1830 = gc_frame_newslot(opresult1844);
  params[0] = opresult1836;
  partcv[0] = 1;
  Object opresult1845 = callmethod(opresult1844, "&&", 1, partcv, params);
// compiled op node returning opresult1845 (depth = 7)
  gc_frame_end(frame);
  return opresult1845;
}
Object meth_parser__apply2050(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2051 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe2052 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2053 == NULL) {
    strlit2053 = alloc_String("rbrace");
    gc_root(strlit2053);
  }
// compiled string node returning strlit2053 (depth = 9)
  gc_frame_newslot(strlit2053);
// call case 4: self request
  params[0] = strlit2053;
  partcv[0] = 1;
  Object call2054 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2052);
// compiled call node returning call2054 (depth = 8)
  partcv[0] = 0;
  Object call2055 = callmethod(call2054, "not",
    1, partcv, params);
  gc_frame_end(callframe2051);
// compiled call node returning call2055 (depth = 7)
// compiled member node returning call2055 (depth = 6)
  gc_frame_end(frame);
  return call2055;
}
Object meth_parser__apply2063(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2064 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2065 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2064);
// compiled call node returning call2065 (depth = 12)
// compiled member node returning call2065 (depth = 11)
  gc_frame_end(frame);
  return call2065;
}
Object meth_parser__apply2058(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2060 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2061 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2062 = alloc_Block(NULL, NULL, "parser", 672);
  gc_frame_newslot(block2062);
// method _apply
  block_savedest(block2062);
  Object closure2063 = createclosure(1, "_apply");
  setclosureframe(closure2063, stackframe);
  addtoclosure(closure2063, selfslot);
  struct UserObject *uo2063 = (struct UserObject*)block2062;
  uo2063->data[0] = (Object)closure2063;
  Method *meth_meth_parser__apply2063 = addmethod2pos(block2062, "_apply", &meth_parser__apply2063, 0);
  int argcv_meth_parser__apply2063[] = {0};
  meth_meth_parser__apply2063->type = alloc_MethodType(1, argcv_meth_parser__apply2063);
  meth_meth_parser__apply2063->definitionModule = modulename;
  meth_meth_parser__apply2063->definitionLine = 672;
// compiled block node returning block2062 (depth = 10)
  gc_frame_newslot(block2062);
// call case 4: self request
  params[0] = block2062;
  partcv[0] = 1;
  Object call2067 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2061);
// compiled call node returning call2067 (depth = 9)
  partcv[0] = 0;
  Object call2068 = callmethod(call2067, "not",
    1, partcv, params);
  gc_frame_end(callframe2060);
// compiled call node returning call2068 (depth = 8)
// compiled member node returning call2068 (depth = 7)
  Object if2059 = done;
  if (istrue(call2068)) {
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2069 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2071 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2070);
// compiled call node returning call2071 (depth = 11)
// compiled member node returning call2071 (depth = 10)
  partcv[0] = 0;
  Object call2072 = callmethod(call2071, "new",
    1, partcv, params);
  gc_frame_end(callframe2069);
// compiled call node returning call2072 (depth = 9)
// compiled member node returning call2072 (depth = 8)
  *var_suggestion = call2072;
  if (call2072 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2073 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2074 = alloc_Boolean(0);
// compiled identifier node returning bool2074 (depth = 9)
  gc_frame_newslot(bool2074);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2074;
  partcv[0] = 2;
  Object call2075 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2073);
// compiled call node returning call2075 (depth = 8)
  *var_closingBrace = call2075;
  if (call2075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2078 = alloc_Boolean(0);
// compiled identifier node returning bool2078 (depth = 9)
  int op_slot_right_2077 = gc_frame_newslot(bool2078);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2081 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2080);
// compiled call node returning call2081 (depth = 10)
// compiled member node returning call2081 (depth = 9)
  int op_slot_left_2077 = gc_frame_newslot(call2081);
  params[0] = bool2078;
  partcv[0] = 1;
  Object opresult2082 = callmethod(call2081, "==", 1, partcv, params);
// compiled op node returning opresult2082 (depth = 8)
  Object if2076 = done;
  if (istrue(opresult2082)) {
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2084 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2087 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2086);
// compiled call node returning call2087 (depth = 11)
// compiled member node returning call2087 (depth = 10)
  int op_slot_left_2084 = gc_frame_newslot(call2087);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2088 = callmethod(call2087, "==", 1, partcv, params);
// compiled op node returning opresult2088 (depth = 9)
  Object if2083 = done;
  if (istrue(opresult2088)) {
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2089 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2090 == NULL) {
    strlit2090 = alloc_String("}");
    gc_root(strlit2090);
  }
// compiled string node returning strlit2090 (depth = 10)
  gc_frame_newslot(strlit2090);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2090;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2091 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2089);
// compiled call node returning call2091 (depth = 9)
    gc_frame_newslot(call2091);
    if2083 = call2091;
  } else {
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2092 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2094 = alloc_Float64(0.1);
// compiled num node returning num2094 (depth = 11)
  int op_slot_right_2093 = gc_frame_newslot(num2094);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2096 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2097 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2098 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2097);
// compiled call node returning call2098 (depth = 14)
// compiled member node returning call2098 (depth = 13)
  partcv[0] = 0;
  Object call2099 = callmethod(call2098, "line",
    1, partcv, params);
  gc_frame_end(callframe2096);
// compiled call node returning call2099 (depth = 12)
// compiled member node returning call2099 (depth = 11)
  int op_slot_left_2093 = gc_frame_newslot(call2099);
  params[0] = num2094;
  partcv[0] = 1;
  Object sum2100 = callmethod(call2099, "+", 1, partcv, params);
// compiled op node returning sum2100 (depth = 10)
  gc_frame_newslot(sum2100);
// starting to compile string node (depth = 10)
  if (strlit2101 == NULL) {
    strlit2101 = alloc_String("}");
    gc_root(strlit2101);
  }
// compiled string node returning strlit2101 (depth = 10)
  gc_frame_newslot(strlit2101);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2100;
  params[1] = strlit2101;
  partcv[0] = 2;
  Object call2102 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2092);
// compiled call node returning call2102 (depth = 9)
    gc_frame_newslot(call2102);
    if2083 = call2102;
  }
// compiled if node returning if2083 (depth = 8)
    gc_frame_newslot(if2083);
    if2076 = if2083;
  } else {
  }
// compiled if node returning if2076 (depth = 7)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2103 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2104 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2103);
// compiled call node returning call2104 (depth = 7)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2105 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2106 == NULL) {
    strlit2106 = alloc_String("An if statement must end with a '}'.");
    gc_root(strlit2106);
  }
// compiled string node returning strlit2106 (depth = 8)
  gc_frame_newslot(strlit2106);
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2108 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2107);
// compiled call node returning call2108 (depth = 9)
// compiled member node returning call2108 (depth = 8)
  gc_frame_newslot(call2108);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2110 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2109);
// compiled call node returning call2110 (depth = 9)
// compiled member node returning call2110 (depth = 8)
  gc_frame_newslot(call2110);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2106;
  params[1] = call2108;
  params[2] = call2110;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2111 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2105);
// compiled call node returning call2111 (depth = 7)
    gc_frame_newslot(call2111);
    if2059 = call2111;
  } else {
  }
// compiled if node returning if2059 (depth = 6)
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2112 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2113 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2112);
// compiled call node returning call2113 (depth = 8)
// compiled member node returning call2113 (depth = 7)
  *var_v = call2113;
  if (call2113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2115 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2116 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe2115);
// compiled call node returning call2116 (depth = 6)
  gc_frame_end(frame);
  return call2116;
}
Object meth_parser__apply2123(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2126 == NULL) {
    strlit2126 = alloc_String("elseif");
    gc_root(strlit2126);
  }
// compiled string node returning strlit2126 (depth = 8)
  int op_slot_right_2125 = gc_frame_newslot(strlit2126);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2129 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2128);
// compiled call node returning call2129 (depth = 9)
// compiled member node returning call2129 (depth = 8)
  int op_slot_left_2125 = gc_frame_newslot(call2129);
  params[0] = strlit2126;
  partcv[0] = 1;
  Object opresult2130 = callmethod(call2129, "==", 1, partcv, params);
// compiled op node returning opresult2130 (depth = 7)
  int op_slot_right_2124 = gc_frame_newslot(opresult2130);
// starting to compile call node (depth = 7)
  int callframe2132 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2133 == NULL) {
    strlit2133 = alloc_String("identifier");
    gc_root(strlit2133);
  }
// compiled string node returning strlit2133 (depth = 8)
  gc_frame_newslot(strlit2133);
// call case 4: self request
  params[0] = strlit2133;
  partcv[0] = 1;
  Object call2134 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2132);
// compiled call node returning call2134 (depth = 7)
  int op_slot_left_2124 = gc_frame_newslot(call2134);
  params[0] = opresult2130;
  partcv[0] = 1;
  Object opresult2135 = callmethod(call2134, "&&", 1, partcv, params);
// compiled op node returning opresult2135 (depth = 6)
  gc_frame_end(frame);
  return opresult2135;
}
Object meth_parser__apply2145(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2147 == NULL) {
    strlit2147 = alloc_String("lbrace");
    gc_root(strlit2147);
  }
// compiled string node returning strlit2147 (depth = 11)
  int op_slot_right_2146 = gc_frame_newslot(strlit2147);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call2150 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2149);
// compiled call node returning call2150 (depth = 12)
// compiled member node returning call2150 (depth = 11)
  int op_slot_left_2146 = gc_frame_newslot(call2150);
  params[0] = strlit2147;
  partcv[0] = 1;
  Object opresult2151 = callmethod(call2150, "==", 1, partcv, params);
// compiled op node returning opresult2151 (depth = 10)
  gc_frame_end(frame);
  return opresult2151;
}
Object meth_parser__apply2187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2192 == NULL) {
    strlit2192 = alloc_String("then");
    gc_root(strlit2192);
  }
// compiled string node returning strlit2192 (depth = 14)
  int op_slot_right_2191 = gc_frame_newslot(strlit2192);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2194 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2195 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe2194);
// compiled call node returning call2195 (depth = 15)
// compiled member node returning call2195 (depth = 14)
  int op_slot_left_2191 = gc_frame_newslot(call2195);
  params[0] = strlit2192;
  partcv[0] = 1;
  Object opresult2196 = callmethod(call2195, "==", 1, partcv, params);
// compiled op node returning opresult2196 (depth = 13)
  int op_slot_right_2190 = gc_frame_newslot(opresult2196);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2199 == NULL) {
    strlit2199 = alloc_String("identifier");
    gc_root(strlit2199);
  }
// compiled string node returning strlit2199 (depth = 14)
  int op_slot_right_2198 = gc_frame_newslot(strlit2199);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2201 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2202 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2201);
// compiled call node returning call2202 (depth = 15)
// compiled member node returning call2202 (depth = 14)
  int op_slot_left_2198 = gc_frame_newslot(call2202);
  params[0] = strlit2199;
  partcv[0] = 1;
  Object opresult2203 = callmethod(call2202, "==", 1, partcv, params);
// compiled op node returning opresult2203 (depth = 13)
  int op_slot_left_2190 = gc_frame_newslot(opresult2203);
  params[0] = opresult2196;
  partcv[0] = 1;
  Object opresult2204 = callmethod(opresult2203, "&&", 1, partcv, params);
// compiled op node returning opresult2204 (depth = 12)
  int op_slot_right_2189 = gc_frame_newslot(opresult2204);
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2208 == NULL) {
    strlit2208 = alloc_String("lbrace");
    gc_root(strlit2208);
  }
// compiled string node returning strlit2208 (depth = 14)
  int op_slot_right_2207 = gc_frame_newslot(strlit2208);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2211 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2210);
// compiled call node returning call2211 (depth = 15)
// compiled member node returning call2211 (depth = 14)
  int op_slot_left_2207 = gc_frame_newslot(call2211);
  params[0] = strlit2208;
  partcv[0] = 1;
  Object opresult2212 = callmethod(call2211, "==", 1, partcv, params);
// compiled op node returning opresult2212 (depth = 13)
  int op_slot_right_2206 = gc_frame_newslot(opresult2212);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2216 == NULL) {
    strlit2216 = alloc_String("rbrace");
    gc_root(strlit2216);
  }
// compiled string node returning strlit2216 (depth = 15)
  int op_slot_right_2215 = gc_frame_newslot(strlit2216);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2218 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2219 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2218);
// compiled call node returning call2219 (depth = 16)
// compiled member node returning call2219 (depth = 15)
  int op_slot_left_2215 = gc_frame_newslot(call2219);
  params[0] = strlit2216;
  partcv[0] = 1;
  Object opresult2220 = callmethod(call2219, "==", 1, partcv, params);
// compiled op node returning opresult2220 (depth = 14)
  int op_slot_right_2214 = gc_frame_newslot(opresult2220);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2223 == NULL) {
    strlit2223 = alloc_String("rparen");
    gc_root(strlit2223);
  }
// compiled string node returning strlit2223 (depth = 15)
  int op_slot_right_2222 = gc_frame_newslot(strlit2223);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2226 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2225);
// compiled call node returning call2226 (depth = 16)
// compiled member node returning call2226 (depth = 15)
  int op_slot_left_2222 = gc_frame_newslot(call2226);
  params[0] = strlit2223;
  partcv[0] = 1;
  Object opresult2227 = callmethod(call2226, "==", 1, partcv, params);
// compiled op node returning opresult2227 (depth = 14)
  int op_slot_left_2214 = gc_frame_newslot(opresult2227);
  params[0] = opresult2220;
  partcv[0] = 1;
  Object opresult2228 = callmethod(opresult2227, "||", 1, partcv, params);
// compiled op node returning opresult2228 (depth = 13)
  int op_slot_left_2206 = gc_frame_newslot(opresult2228);
  params[0] = opresult2212;
  partcv[0] = 1;
  Object opresult2229 = callmethod(opresult2228, "||", 1, partcv, params);
// compiled op node returning opresult2229 (depth = 12)
  int op_slot_left_2189 = gc_frame_newslot(opresult2229);
  params[0] = opresult2204;
  partcv[0] = 1;
  Object opresult2230 = callmethod(opresult2229, "||", 1, partcv, params);
// compiled op node returning opresult2230 (depth = 11)
  int op_slot_right_2188 = gc_frame_newslot(opresult2230);
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2233 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_statementToken (depth = 14)
  partcv[0] = 0;
  Object call2234 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2233);
// compiled call node returning call2234 (depth = 13)
// compiled member node returning call2234 (depth = 12)
  int op_slot_right_2232 = gc_frame_newslot(call2234);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2236 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2237 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2236);
// compiled call node returning call2237 (depth = 13)
// compiled member node returning call2237 (depth = 12)
  int op_slot_left_2232 = gc_frame_newslot(call2237);
  params[0] = call2234;
  partcv[0] = 1;
  Object opresult2238 = callmethod(call2237, "==", 1, partcv, params);
// compiled op node returning opresult2238 (depth = 11)
  int op_slot_left_2188 = gc_frame_newslot(opresult2238);
  params[0] = opresult2230;
  partcv[0] = 1;
  Object opresult2239 = callmethod(opresult2238, "&&", 1, partcv, params);
// compiled op node returning opresult2239 (depth = 10)
  gc_frame_end(frame);
  return opresult2239;
}
Object meth_parser__apply2326(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe2327 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2328 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2327);
// compiled call node returning call2328 (depth = 11)
  gc_frame_end(frame);
  return call2328;
}
Object meth_parser__apply2338(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2342 == NULL) {
    strlit2342 = alloc_String("rbrace");
    gc_root(strlit2342);
  }
// compiled string node returning strlit2342 (depth = 13)
  int op_slot_right_2341 = gc_frame_newslot(strlit2342);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2344 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2345 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2344);
// compiled call node returning call2345 (depth = 14)
// compiled member node returning call2345 (depth = 13)
  int op_slot_left_2341 = gc_frame_newslot(call2345);
  params[0] = strlit2342;
  partcv[0] = 1;
  Object opresult2346 = callmethod(call2345, "==", 1, partcv, params);
// compiled op node returning opresult2346 (depth = 12)
  int op_slot_right_2340 = gc_frame_newslot(opresult2346);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2349 == NULL) {
    strlit2349 = alloc_String("rparen");
    gc_root(strlit2349);
  }
// compiled string node returning strlit2349 (depth = 13)
  int op_slot_right_2348 = gc_frame_newslot(strlit2349);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2351 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2352 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2351);
// compiled call node returning call2352 (depth = 14)
// compiled member node returning call2352 (depth = 13)
  int op_slot_left_2348 = gc_frame_newslot(call2352);
  params[0] = strlit2349;
  partcv[0] = 1;
  Object opresult2353 = callmethod(call2352, "==", 1, partcv, params);
// compiled op node returning opresult2353 (depth = 12)
  int op_slot_left_2340 = gc_frame_newslot(opresult2353);
  params[0] = opresult2346;
  partcv[0] = 1;
  Object opresult2354 = callmethod(opresult2353, "||", 1, partcv, params);
// compiled op node returning opresult2354 (depth = 11)
  int op_slot_right_2339 = gc_frame_newslot(opresult2354);
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lastToken (depth = 14)
  partcv[0] = 0;
  Object call2358 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2357);
// compiled call node returning call2358 (depth = 13)
// compiled member node returning call2358 (depth = 12)
  int op_slot_right_2356 = gc_frame_newslot(call2358);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2360 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2361 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2360);
// compiled call node returning call2361 (depth = 13)
// compiled member node returning call2361 (depth = 12)
  int op_slot_left_2356 = gc_frame_newslot(call2361);
  params[0] = call2358;
  partcv[0] = 1;
  Object opresult2362 = callmethod(call2361, "==", 1, partcv, params);
// compiled op node returning opresult2362 (depth = 11)
  int op_slot_left_2339 = gc_frame_newslot(opresult2362);
  params[0] = opresult2354;
  partcv[0] = 1;
  Object opresult2363 = callmethod(opresult2362, "&&", 1, partcv, params);
// compiled op node returning opresult2363 (depth = 10)
  gc_frame_end(frame);
  return opresult2363;
}
Object meth_parser__apply2674(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2675 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe2676 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2677 == NULL) {
    strlit2677 = alloc_String("rbrace");
    gc_root(strlit2677);
  }
// compiled string node returning strlit2677 (depth = 11)
  gc_frame_newslot(strlit2677);
// call case 4: self request
  params[0] = strlit2677;
  partcv[0] = 1;
  Object call2678 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2676);
// compiled call node returning call2678 (depth = 10)
  partcv[0] = 0;
  Object call2679 = callmethod(call2678, "not",
    1, partcv, params);
  gc_frame_end(callframe2675);
// compiled call node returning call2679 (depth = 9)
// compiled member node returning call2679 (depth = 8)
  gc_frame_end(frame);
  return call2679;
}
Object meth_parser__apply2687(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2688 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2689 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2688);
// compiled call node returning call2689 (depth = 14)
// compiled member node returning call2689 (depth = 13)
  gc_frame_end(frame);
  return call2689;
}
Object meth_parser__apply2682(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2684 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe2685 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block2686 = alloc_Block(NULL, NULL, "parser", 830);
  gc_frame_newslot(block2686);
// method _apply
  block_savedest(block2686);
  Object closure2687 = createclosure(1, "_apply");
  setclosureframe(closure2687, stackframe);
  addtoclosure(closure2687, selfslot);
  struct UserObject *uo2687 = (struct UserObject*)block2686;
  uo2687->data[0] = (Object)closure2687;
  Method *meth_meth_parser__apply2687 = addmethod2pos(block2686, "_apply", &meth_parser__apply2687, 0);
  int argcv_meth_parser__apply2687[] = {0};
  meth_meth_parser__apply2687->type = alloc_MethodType(1, argcv_meth_parser__apply2687);
  meth_meth_parser__apply2687->definitionModule = modulename;
  meth_meth_parser__apply2687->definitionLine = 830;
// compiled block node returning block2686 (depth = 12)
  gc_frame_newslot(block2686);
// call case 4: self request
  params[0] = block2686;
  partcv[0] = 1;
  Object call2691 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2685);
// compiled call node returning call2691 (depth = 11)
  partcv[0] = 0;
  Object call2692 = callmethod(call2691, "not",
    1, partcv, params);
  gc_frame_end(callframe2684);
// compiled call node returning call2692 (depth = 10)
// compiled member node returning call2692 (depth = 9)
  Object if2683 = done;
  if (istrue(call2692)) {
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2693 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2694 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2695 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2694);
// compiled call node returning call2695 (depth = 13)
// compiled member node returning call2695 (depth = 12)
  partcv[0] = 0;
  Object call2696 = callmethod(call2695, "new",
    1, partcv, params);
  gc_frame_end(callframe2693);
// compiled call node returning call2696 (depth = 11)
// compiled member node returning call2696 (depth = 10)
  *var_suggestion = call2696;
  if (call2696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2697 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 11)
  Object bool2698 = alloc_Boolean(0);
// compiled identifier node returning bool2698 (depth = 11)
  gc_frame_newslot(bool2698);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2698;
  partcv[0] = 2;
  Object call2699 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2697);
// compiled call node returning call2699 (depth = 10)
  *var_closingBrace = call2699;
  if (call2699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool2702 = alloc_Boolean(0);
// compiled identifier node returning bool2702 (depth = 11)
  int op_slot_right_2701 = gc_frame_newslot(bool2702);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2704 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2705 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2704);
// compiled call node returning call2705 (depth = 12)
// compiled member node returning call2705 (depth = 11)
  int op_slot_left_2701 = gc_frame_newslot(call2705);
  params[0] = bool2702;
  partcv[0] = 1;
  Object opresult2706 = callmethod(call2705, "==", 1, partcv, params);
// compiled op node returning opresult2706 (depth = 10)
  Object if2700 = done;
  if (istrue(opresult2706)) {
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  int op_slot_right_2708 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2711 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2710);
// compiled call node returning call2711 (depth = 13)
// compiled member node returning call2711 (depth = 12)
  int op_slot_left_2708 = gc_frame_newslot(call2711);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2712 = callmethod(call2711, "==", 1, partcv, params);
// compiled op node returning opresult2712 (depth = 11)
  Object if2707 = done;
  if (istrue(opresult2712)) {
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2713 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2714 == NULL) {
    strlit2714 = alloc_String("}");
    gc_root(strlit2714);
  }
// compiled string node returning strlit2714 (depth = 12)
  gc_frame_newslot(strlit2714);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2714;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2715 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2713);
// compiled call node returning call2715 (depth = 11)
    gc_frame_newslot(call2715);
    if2707 = call2715;
  } else {
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2716 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2718 = alloc_Float64(0.1);
// compiled num node returning num2718 (depth = 13)
  int op_slot_right_2717 = gc_frame_newslot(num2718);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2720 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2721 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_closingBrace (depth = 17)
  partcv[0] = 0;
  Object call2722 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2721);
// compiled call node returning call2722 (depth = 16)
// compiled member node returning call2722 (depth = 15)
  partcv[0] = 0;
  Object call2723 = callmethod(call2722, "line",
    1, partcv, params);
  gc_frame_end(callframe2720);
// compiled call node returning call2723 (depth = 14)
// compiled member node returning call2723 (depth = 13)
  int op_slot_left_2717 = gc_frame_newslot(call2723);
  params[0] = num2718;
  partcv[0] = 1;
  Object sum2724 = callmethod(call2723, "+", 1, partcv, params);
// compiled op node returning sum2724 (depth = 12)
  gc_frame_newslot(sum2724);
// starting to compile string node (depth = 12)
  if (strlit2725 == NULL) {
    strlit2725 = alloc_String("}");
    gc_root(strlit2725);
  }
// compiled string node returning strlit2725 (depth = 12)
  gc_frame_newslot(strlit2725);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = sum2724;
  params[1] = strlit2725;
  partcv[0] = 2;
  Object call2726 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2716);
// compiled call node returning call2726 (depth = 11)
    gc_frame_newslot(call2726);
    if2707 = call2726;
  }
// compiled if node returning if2707 (depth = 10)
    gc_frame_newslot(if2707);
    if2700 = if2707;
  } else {
  }
// compiled if node returning if2700 (depth = 9)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2727 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2728 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2727);
// compiled call node returning call2728 (depth = 9)
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2729 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2730 == NULL) {
    strlit2730 = alloc_String("An elseif statement must end with a '}'.");
    gc_root(strlit2730);
  }
// compiled string node returning strlit2730 (depth = 10)
  gc_frame_newslot(strlit2730);
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2731 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2732 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2731);
// compiled call node returning call2732 (depth = 11)
// compiled member node returning call2732 (depth = 10)
  gc_frame_newslot(call2732);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2734 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2733);
// compiled call node returning call2734 (depth = 11)
// compiled member node returning call2734 (depth = 10)
  gc_frame_newslot(call2734);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2730;
  params[1] = call2732;
  params[2] = call2734;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2735 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2729);
// compiled call node returning call2735 (depth = 9)
    gc_frame_newslot(call2735);
    if2683 = call2735;
  } else {
  }
// compiled if node returning if2683 (depth = 8)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2736 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call2737 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2736);
// compiled call node returning call2737 (depth = 10)
// compiled member node returning call2737 (depth = 9)
  *var_v = call2737;
  if (call2737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2739 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ebody (depth = 9)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2740 = callmethod(*var_ebody, "push",
    1, partcv, params);
  gc_frame_end(callframe2739);
// compiled call node returning call2740 (depth = 8)
  gc_frame_end(frame);
  return call2740;
}
Object meth_parser__apply2138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_econd = getfromclosure(closure, 6);
  Object *var_ebody = getfromclosure(closure, 7);
  Object *var_btok = getfromclosure(closure, 8);
  Object *var_minIndentLevel = getfromclosure(closure, 9);
  Object *var_minInd = getfromclosure(closure, 10);
  Object *var_v = getfromclosure(closure, 11);
  Object *var_newelse = getfromclosure(closure, 12);
  Object *var_eif = getfromclosure(closure, 13);
  Object *var_curelse = getfromclosure(closure, 14);
  Object self = *(getfromclosure(closure, 15));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_opener = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "opener");
  Object *var_closer = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closer");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_closingBrace = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "closingBrace");
// starting to compile bind node (depth = 6)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2140 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2141 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2140);
// compiled call node returning call2141 (depth = 7)
// compiled member node returning call2141 (depth = 6)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2143 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2144 = alloc_Block(NULL, NULL, "parser", 700);
  gc_frame_newslot(block2144);
// method _apply
  block_savedest(block2144);
  Object closure2145 = createclosure(2, "_apply");
  setclosureframe(closure2145, stackframe);
  addtoclosure(closure2145, var_sym);
  addtoclosure(closure2145, selfslot);
  struct UserObject *uo2145 = (struct UserObject*)block2144;
  uo2145->data[0] = (Object)closure2145;
  Method *meth_meth_parser__apply2145 = addmethod2pos(block2144, "_apply", &meth_parser__apply2145, 0);
  int argcv_meth_parser__apply2145[] = {0};
  meth_meth_parser__apply2145->type = alloc_MethodType(1, argcv_meth_parser__apply2145);
  meth_meth_parser__apply2145->definitionModule = modulename;
  meth_meth_parser__apply2145->definitionLine = 699;
// compiled block node returning block2144 (depth = 9)
  gc_frame_newslot(block2144);
// call case 6: other member request
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2154 == NULL) {
    strlit2154 = alloc_String("lparen");
    gc_root(strlit2154);
  }
// compiled string node returning strlit2154 (depth = 10)
  int op_slot_right_2153 = gc_frame_newslot(strlit2154);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2157 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2156);
// compiled call node returning call2157 (depth = 11)
// compiled member node returning call2157 (depth = 10)
  int op_slot_left_2153 = gc_frame_newslot(call2157);
  params[0] = strlit2154;
  partcv[0] = 1;
  Object opresult2158 = callmethod(call2157, "==", 1, partcv, params);
// compiled op node returning opresult2158 (depth = 9)
  params[0] = block2144;
  partcv[0] = 1;
  Object call2159 = callmethod(opresult2158, "orElse",
    1, partcv, params);
  gc_frame_end(callframe2143);
// compiled call node returning call2159 (depth = 8)
  Object if2142 = done;
struct StackFrameObject *iftmpstackframe2142 = stackframe;
  if (istrue(call2159)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2142);
gc_frame_newslot((Object)stackframe);
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2161 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2160);
// compiled call node returning call2161 (depth = 9)
// compiled member node returning call2161 (depth = 8)
    gc_frame_newslot(call2161);
    if2142 = call2161;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2142);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2162 == NULL) {
    strlit2162 = alloc_String("-missing-");
    gc_root(strlit2162);
  }
// compiled string node returning strlit2162 (depth = 8)
    gc_frame_newslot(strlit2162);
    if2142 = strlit2162;
  }
stackframe = iftmpstackframe2142;
// compiled if node returning if2142 (depth = 7)
  *var_opener = if2142;
  if (if2142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2165 == NULL) {
    strlit2165 = alloc_String("(");
    gc_root(strlit2165);
  }
// compiled string node returning strlit2165 (depth = 9)
  int op_slot_right_2164 = gc_frame_newslot(strlit2165);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_opener (depth = 9)
  int op_slot_left_2164 = gc_frame_newslot(*var_opener);
  params[0] = strlit2165;
  partcv[0] = 1;
  Object opresult2167 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult2167 (depth = 8)
  Object if2163 = done;
struct StackFrameObject *iftmpstackframe2163 = stackframe;
  if (istrue(opresult2167)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2163);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2168 == NULL) {
    strlit2168 = alloc_String(")");
    gc_root(strlit2168);
  }
// compiled string node returning strlit2168 (depth = 8)
    gc_frame_newslot(strlit2168);
    if2163 = strlit2168;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2163);
  gc_frame_newslot((Object)stackframe);
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2171 == NULL) {
    strlit2171 = alloc_String("{");
    gc_root(strlit2171);
  }
// compiled string node returning strlit2171 (depth = 10)
  int op_slot_right_2170 = gc_frame_newslot(strlit2171);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_opener (depth = 10)
  int op_slot_left_2170 = gc_frame_newslot(*var_opener);
  params[0] = strlit2171;
  partcv[0] = 1;
  Object opresult2173 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult2173 (depth = 9)
  Object if2169 = done;
  if (istrue(opresult2173)) {
// starting to compile string node (depth = 9)
  if (strlit2174 == NULL) {
    strlit2174 = alloc_String("}");
    gc_root(strlit2174);
  }
// compiled string node returning strlit2174 (depth = 9)
    gc_frame_newslot(strlit2174);
    if2169 = strlit2174;
  } else {
// starting to compile string node (depth = 9)
  if (strlit2175 == NULL) {
    strlit2175 = alloc_String("-nothing-");
    gc_root(strlit2175);
  }
// compiled string node returning strlit2175 (depth = 9)
    gc_frame_newslot(strlit2175);
    if2169 = strlit2175;
  }
// compiled if node returning if2169 (depth = 8)
    gc_frame_newslot(if2169);
    if2163 = if2169;
  }
stackframe = iftmpstackframe2163;
// compiled if node returning if2163 (depth = 7)
  *var_closer = if2163;
  if (if2163 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2178 == NULL) {
    strlit2178 = alloc_String("-missing-");
    gc_root(strlit2178);
  }
// compiled string node returning strlit2178 (depth = 8)
  int op_slot_right_2177 = gc_frame_newslot(strlit2178);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opener (depth = 8)
  int op_slot_left_2177 = gc_frame_newslot(*var_opener);
  params[0] = strlit2178;
  partcv[0] = 1;
  Object opresult2180 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult2180 (depth = 7)
  Object if2176 = done;
  if (istrue(opresult2180)) {
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2181 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2183 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2182);
// compiled call node returning call2183 (depth = 11)
// compiled member node returning call2183 (depth = 10)
  partcv[0] = 0;
  Object call2184 = callmethod(call2183, "new",
    1, partcv, params);
  gc_frame_end(callframe2181);
// compiled call node returning call2184 (depth = 9)
// compiled member node returning call2184 (depth = 8)
  *var_suggestion = call2184;
  if (call2184 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2185 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2186 = alloc_Block(NULL, NULL, "parser", 707);
  gc_frame_newslot(block2186);
// method _apply
  block_savedest(block2186);
  Object closure2187 = createclosure(2, "_apply");
  setclosureframe(closure2187, stackframe);
  addtoclosure(closure2187, var_statementToken);
  addtoclosure(closure2187, selfslot);
  struct UserObject *uo2187 = (struct UserObject*)block2186;
  uo2187->data[0] = (Object)closure2187;
  Method *meth_meth_parser__apply2187 = addmethod2pos(block2186, "_apply", &meth_parser__apply2187, 0);
  int argcv_meth_parser__apply2187[] = {1};
  meth_meth_parser__apply2187->type = alloc_MethodType(1, argcv_meth_parser__apply2187);
  meth_meth_parser__apply2187->definitionModule = modulename;
  meth_meth_parser__apply2187->definitionLine = 705;
// compiled block node returning block2186 (depth = 9)
  gc_frame_newslot(block2186);
// call case 4: self request
  params[0] = block2186;
  partcv[0] = 1;
  Object call2241 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2185);
// compiled call node returning call2241 (depth = 8)
  *var_nextTok = call2241;
  if (call2241 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2244 = alloc_Boolean(0);
// compiled identifier node returning bool2244 (depth = 9)
  int op_slot_right_2243 = gc_frame_newslot(bool2244);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_2243 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2244;
  partcv[0] = 1;
  Object opresult2246 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2246 (depth = 8)
  Object if2242 = done;
  if (istrue(opresult2246)) {
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2247 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2248 == NULL) {
    strlit2248 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2248);
  }
// compiled string node returning strlit2248 (depth = 9)
  gc_frame_newslot(strlit2248);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_statementToken (depth = 9)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit2248;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2249 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2247);
// compiled call node returning call2249 (depth = 8)
    gc_frame_newslot(call2249);
    if2242 = call2249;
  } else {
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2252 == NULL) {
    strlit2252 = alloc_String("rparen");
    gc_root(strlit2252);
  }
// compiled string node returning strlit2252 (depth = 10)
  int op_slot_right_2251 = gc_frame_newslot(strlit2252);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2255 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2254);
// compiled call node returning call2255 (depth = 11)
// compiled member node returning call2255 (depth = 10)
  int op_slot_left_2251 = gc_frame_newslot(call2255);
  params[0] = strlit2252;
  partcv[0] = 1;
  Object opresult2256 = callmethod(call2255, "==", 1, partcv, params);
// compiled op node returning opresult2256 (depth = 9)
  Object if2250 = done;
  if (istrue(opresult2256)) {
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2258 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_2258 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2260 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2260 (depth = 10)
  Object if2257 = done;
  if (istrue(opresult2260)) {
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2261 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2262 == NULL) {
    strlit2262 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2262);
  }
// compiled string node returning strlit2262 (depth = 11)
  gc_frame_newslot(strlit2262);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2262;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2263 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2261);
// compiled call node returning call2263 (depth = 10)
    gc_frame_newslot(call2263);
    if2257 = call2263;
  } else {
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2264 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2265 == NULL) {
    strlit2265 = alloc_String("(");
    gc_root(strlit2265);
  }
// compiled string node returning strlit2265 (depth = 11)
  gc_frame_newslot(strlit2265);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2265;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2266 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2264);
// compiled call node returning call2266 (depth = 10)
    gc_frame_newslot(call2266);
    if2257 = call2266;
  }
// compiled if node returning if2257 (depth = 9)
    gc_frame_newslot(if2257);
    if2250 = if2257;
  } else {
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2269 == NULL) {
    strlit2269 = alloc_String("lbrace");
    gc_root(strlit2269);
  }
// compiled string node returning strlit2269 (depth = 11)
  int op_slot_right_2268 = gc_frame_newslot(strlit2269);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2271 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2272 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2271);
// compiled call node returning call2272 (depth = 12)
// compiled member node returning call2272 (depth = 11)
  int op_slot_left_2268 = gc_frame_newslot(call2272);
  params[0] = strlit2269;
  partcv[0] = 1;
  Object opresult2273 = callmethod(call2272, "==", 1, partcv, params);
// compiled op node returning opresult2273 (depth = 10)
  Object if2267 = done;
  if (istrue(opresult2273)) {
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_2275 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  int op_slot_left_2275 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2277 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2277 (depth = 11)
  Object if2274 = done;
  if (istrue(opresult2277)) {
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2278 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2279 == NULL) {
    strlit2279 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit2279);
  }
// compiled string node returning strlit2279 (depth = 12)
  gc_frame_newslot(strlit2279);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_statementToken (depth = 12)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2279;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2280 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2278);
// compiled call node returning call2280 (depth = 11)
    gc_frame_newslot(call2280);
    if2274 = call2280;
  } else {
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2281 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2282 == NULL) {
    strlit2282 = alloc_String("(");
    gc_root(strlit2282);
  }
// compiled string node returning strlit2282 (depth = 12)
  gc_frame_newslot(strlit2282);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2282;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2283 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2281);
// compiled call node returning call2283 (depth = 11)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2284 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2285 == NULL) {
    strlit2285 = alloc_String(") then");
    gc_root(strlit2285);
  }
// compiled string node returning strlit2285 (depth = 12)
  gc_frame_newslot(strlit2285);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2286 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2287 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2286);
// compiled call node returning call2287 (depth = 13)
// compiled member node returning call2287 (depth = 12)
  gc_frame_newslot(call2287);
// starting to compile identifier node (depth = 12)
  Object bool2288 = alloc_Boolean(1);
// compiled identifier node returning bool2288 (depth = 12)
  gc_frame_newslot(bool2288);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2285;
  params[1] = call2287;
  params[2] = bool2288;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2289 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2284);
// compiled call node returning call2289 (depth = 11)
    gc_frame_newslot(call2289);
    if2274 = call2289;
  }
// compiled if node returning if2274 (depth = 10)
    gc_frame_newslot(if2274);
    if2267 = if2274;
  } else {
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2292 == NULL) {
    strlit2292 = alloc_String("identifier");
    gc_root(strlit2292);
  }
// compiled string node returning strlit2292 (depth = 12)
  int op_slot_right_2291 = gc_frame_newslot(strlit2292);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2294 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2295 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2294);
// compiled call node returning call2295 (depth = 13)
// compiled member node returning call2295 (depth = 12)
  int op_slot_left_2291 = gc_frame_newslot(call2295);
  params[0] = strlit2292;
  partcv[0] = 1;
  Object opresult2296 = callmethod(call2295, "==", 1, partcv, params);
// compiled op node returning opresult2296 (depth = 11)
  Object if2290 = done;
  if (istrue(opresult2296)) {
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  int op_slot_right_2298 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  int op_slot_left_2298 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2300 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2300 (depth = 12)
  Object if2297 = done;
  if (istrue(opresult2300)) {
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2301 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2302 == NULL) {
    strlit2302 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit2302);
  }
// compiled string node returning strlit2302 (depth = 13)
  gc_frame_newslot(strlit2302);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2302;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2303 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2301);
// compiled call node returning call2303 (depth = 12)
    gc_frame_newslot(call2303);
    if2297 = call2303;
  } else {
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2304 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2305 == NULL) {
    strlit2305 = alloc_String("(");
    gc_root(strlit2305);
  }
// compiled string node returning strlit2305 (depth = 13)
  gc_frame_newslot(strlit2305);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2305;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2306 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2304);
// compiled call node returning call2306 (depth = 12)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2307 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2308 == NULL) {
    strlit2308 = alloc_String(")");
    gc_root(strlit2308);
  }
// compiled string node returning strlit2308 (depth = 13)
  gc_frame_newslot(strlit2308);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2309 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_nextTok (depth = 15)
  partcv[0] = 0;
  Object call2310 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2309);
// compiled call node returning call2310 (depth = 14)
// compiled member node returning call2310 (depth = 13)
  gc_frame_newslot(call2310);
// starting to compile identifier node (depth = 13)
  Object bool2311 = alloc_Boolean(1);
// compiled identifier node returning bool2311 (depth = 13)
  gc_frame_newslot(bool2311);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2308;
  params[1] = call2310;
  params[2] = bool2311;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2312 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2307);
// compiled call node returning call2312 (depth = 12)
    gc_frame_newslot(call2312);
    if2297 = call2312;
  }
// compiled if node returning if2297 (depth = 11)
    gc_frame_newslot(if2297);
    if2290 = if2297;
  } else {
  }
// compiled if node returning if2290 (depth = 10)
    gc_frame_newslot(if2290);
    if2267 = if2290;
  }
// compiled if node returning if2267 (depth = 9)
    gc_frame_newslot(if2267);
    if2250 = if2267;
  }
// compiled if node returning if2250 (depth = 8)
    gc_frame_newslot(if2250);
    if2242 = if2250;
  }
// compiled if node returning if2242 (depth = 7)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2313 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2314 == NULL) {
    strlit2314 = alloc_String("An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2314);
  }
// compiled string node returning strlit2314 (depth = 8)
  gc_frame_newslot(strlit2314);
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2315 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2316 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2315);
// compiled call node returning call2316 (depth = 9)
// compiled member node returning call2316 (depth = 8)
  gc_frame_newslot(call2316);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2317 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2318 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2317);
// compiled call node returning call2318 (depth = 9)
// compiled member node returning call2318 (depth = 8)
  gc_frame_newslot(call2318);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2314;
  params[1] = call2316;
  params[2] = call2318;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2319 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2313);
// compiled call node returning call2319 (depth = 7)
    gc_frame_newslot(call2319);
    if2176 = call2319;
  } else {
  }
// compiled if node returning if2176 (depth = 6)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2320 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2321 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2320);
// compiled call node returning call2321 (depth = 7)
// compiled member node returning call2321 (depth = 6)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2323 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2324 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2325 = alloc_Block(NULL, NULL, "parser", 737);
  gc_frame_newslot(block2325);
// method _apply
  block_savedest(block2325);
  Object closure2326 = createclosure(2, "_apply");
  setclosureframe(closure2326, stackframe);
  addtoclosure(closure2326, var_blocksOK);
  addtoclosure(closure2326, selfslot);
  struct UserObject *uo2326 = (struct UserObject*)block2325;
  uo2326->data[0] = (Object)closure2326;
  Method *meth_meth_parser__apply2326 = addmethod2pos(block2325, "_apply", &meth_parser__apply2326, 0);
  int argcv_meth_parser__apply2326[] = {0};
  meth_meth_parser__apply2326->type = alloc_MethodType(1, argcv_meth_parser__apply2326);
  meth_meth_parser__apply2326->definitionModule = modulename;
  meth_meth_parser__apply2326->definitionLine = 737;
// compiled block node returning block2325 (depth = 10)
  gc_frame_newslot(block2325);
// call case 4: self request
  params[0] = block2325;
  partcv[0] = 1;
  Object call2330 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2324);
// compiled call node returning call2330 (depth = 9)
  partcv[0] = 0;
  Object call2331 = callmethod(call2330, "not",
    1, partcv, params);
  gc_frame_end(callframe2323);
// compiled call node returning call2331 (depth = 8)
// compiled member node returning call2331 (depth = 7)
  Object if2322 = done;
  if (istrue(call2331)) {
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2332 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2334 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2333);
// compiled call node returning call2334 (depth = 11)
// compiled member node returning call2334 (depth = 10)
  partcv[0] = 0;
  Object call2335 = callmethod(call2334, "new",
    1, partcv, params);
  gc_frame_end(callframe2332);
// compiled call node returning call2335 (depth = 9)
// compiled member node returning call2335 (depth = 8)
  *var_suggestion = call2335;
  if (call2335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2336 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2337 = alloc_Block(NULL, NULL, "parser", 740);
  gc_frame_newslot(block2337);
// method _apply
  block_savedest(block2337);
  Object closure2338 = createclosure(2, "_apply");
  setclosureframe(closure2338, stackframe);
  addtoclosure(closure2338, var_lastToken);
  addtoclosure(closure2338, selfslot);
  struct UserObject *uo2338 = (struct UserObject*)block2337;
  uo2338->data[0] = (Object)closure2338;
  Method *meth_meth_parser__apply2338 = addmethod2pos(block2337, "_apply", &meth_parser__apply2338, 0);
  int argcv_meth_parser__apply2338[] = {1};
  meth_meth_parser__apply2338->type = alloc_MethodType(1, argcv_meth_parser__apply2338);
  meth_meth_parser__apply2338->definitionModule = modulename;
  meth_meth_parser__apply2338->definitionLine = 738;
// compiled block node returning block2337 (depth = 9)
  gc_frame_newslot(block2337);
// call case 4: self request
  params[0] = block2337;
  partcv[0] = 1;
  Object call2365 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2336);
// compiled call node returning call2365 (depth = 8)
  *var_nextTok = call2365;
  if (call2365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2368 = alloc_Boolean(0);
// compiled identifier node returning bool2368 (depth = 9)
  int op_slot_right_2367 = gc_frame_newslot(bool2368);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_2367 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2368;
  partcv[0] = 1;
  Object opresult2370 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2370 (depth = 8)
  Object if2366 = done;
  if (istrue(opresult2370)) {
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2371 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2372 == NULL) {
    strlit2372 = alloc_String("rparen");
    gc_root(strlit2372);
  }
// compiled string node returning strlit2372 (depth = 10)
  gc_frame_newslot(strlit2372);
// call case 4: self request
  params[0] = strlit2372;
  partcv[0] = 1;
  Object call2373 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2371);
// compiled call node returning call2373 (depth = 9)
  *var_nextTok = call2373;
  if (call2373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2376 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2376 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2378 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2378 (depth = 9)
  Object if2375 = done;
  if (istrue(opresult2378)) {
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2379 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2380 == NULL) {
    strlit2380 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2380);
  }
// compiled string node returning strlit2380 (depth = 10)
  gc_frame_newslot(strlit2380);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2380;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2381 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2379);
// compiled call node returning call2381 (depth = 9)
    gc_frame_newslot(call2381);
    if2375 = call2381;
  } else {
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2382 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2384 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2383);
// compiled call node returning call2384 (depth = 11)
// compiled member node returning call2384 (depth = 10)
  gc_frame_newslot(call2384);
// starting to compile identifier node (depth = 10)
  Object bool2385 = alloc_Boolean(1);
// compiled identifier node returning bool2385 (depth = 10)
  gc_frame_newslot(bool2385);
// starting to compile identifier node (depth = 10)
  Object bool2386 = alloc_Boolean(0);
// compiled identifier node returning bool2386 (depth = 10)
  gc_frame_newslot(bool2386);
// starting to compile string node (depth = 10)
  if (strlit2387 == NULL) {
    strlit2387 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2387);
  }
// compiled string node returning strlit2387 (depth = 10)
  gc_frame_newslot(strlit2387);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2384;
  params[2] = bool2385;
  params[3] = bool2386;
  params[4] = strlit2387;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2388 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2382);
// compiled call node returning call2388 (depth = 9)
    gc_frame_newslot(call2388);
    if2375 = call2388;
  }
// compiled if node returning if2375 (depth = 8)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2389 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2390 == NULL) {
    strlit2390 = alloc_String("An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2390);
  }
// compiled string node returning strlit2390 (depth = 9)
  gc_frame_newslot(strlit2390);
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2391 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2392 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2391);
// compiled call node returning call2392 (depth = 10)
// compiled member node returning call2392 (depth = 9)
  gc_frame_newslot(call2392);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2394 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2393);
// compiled call node returning call2394 (depth = 10)
// compiled member node returning call2394 (depth = 9)
  gc_frame_newslot(call2394);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2390;
  params[1] = call2392;
  params[2] = call2394;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2395 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2389);
// compiled call node returning call2395 (depth = 8)
    gc_frame_newslot(call2395);
    if2366 = call2395;
  } else {
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2397 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2397 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2399 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2399 (depth = 9)
  Object if2396 = done;
  if (istrue(opresult2399)) {
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2400 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2401 == NULL) {
    strlit2401 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2401);
  }
// compiled string node returning strlit2401 (depth = 10)
  gc_frame_newslot(strlit2401);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2401;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2402 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2400);
// compiled call node returning call2402 (depth = 9)
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2403 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2404 == NULL) {
    strlit2404 = alloc_String("An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2404);
  }
// compiled string node returning strlit2404 (depth = 10)
  gc_frame_newslot(strlit2404);
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2406 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2405);
// compiled call node returning call2406 (depth = 11)
// compiled member node returning call2406 (depth = 10)
  gc_frame_newslot(call2406);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2407 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2408 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2407);
// compiled call node returning call2408 (depth = 11)
// compiled member node returning call2408 (depth = 10)
  gc_frame_newslot(call2408);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2404;
  params[1] = call2406;
  params[2] = call2408;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2409 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2403);
// compiled call node returning call2409 (depth = 9)
    gc_frame_newslot(call2409);
    if2396 = call2409;
  } else {
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2410 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2411 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2412 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2411);
// compiled call node returning call2412 (depth = 11)
// compiled member node returning call2412 (depth = 10)
  gc_frame_newslot(call2412);
// starting to compile identifier node (depth = 10)
  Object bool2413 = alloc_Boolean(0);
// compiled identifier node returning bool2413 (depth = 10)
  gc_frame_newslot(bool2413);
// starting to compile identifier node (depth = 10)
  Object bool2414 = alloc_Boolean(1);
// compiled identifier node returning bool2414 (depth = 10)
  gc_frame_newslot(bool2414);
// starting to compile string node (depth = 10)
  if (strlit2415 == NULL) {
    strlit2415 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2415);
  }
// compiled string node returning strlit2415 (depth = 10)
  gc_frame_newslot(strlit2415);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2412;
  params[2] = bool2413;
  params[3] = bool2414;
  params[4] = strlit2415;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2416 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2410);
// compiled call node returning call2416 (depth = 9)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2417 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2418 == NULL) {
    strlit2418 = alloc_String("4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2418);
  }
// compiled string node returning strlit2418 (depth = 10)
  gc_frame_newslot(strlit2418);
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2420 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2419);
// compiled call node returning call2420 (depth = 11)
// compiled member node returning call2420 (depth = 10)
  gc_frame_newslot(call2420);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2421 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2422 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2421);
// compiled call node returning call2422 (depth = 11)
// compiled member node returning call2422 (depth = 10)
  gc_frame_newslot(call2422);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2424 = alloc_Float64(1);
// compiled num node returning num2424 (depth = 11)
  int op_slot_right_2423 = gc_frame_newslot(num2424);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2426 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2427 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2426);
// compiled call node returning call2427 (depth = 12)
// compiled member node returning call2427 (depth = 11)
  int op_slot_left_2423 = gc_frame_newslot(call2427);
  params[0] = num2424;
  partcv[0] = 1;
  Object diff2428 = callmethod(call2427, "-", 1, partcv, params);
// compiled op node returning diff2428 (depth = 10)
  gc_frame_newslot(diff2428);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2418;
  params[1] = call2420;
  params[2] = call2422;
  params[3] = diff2428;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2429 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2417);
// compiled call node returning call2429 (depth = 9)
    gc_frame_newslot(call2429);
    if2396 = call2429;
  }
// compiled if node returning if2396 (depth = 8)
    gc_frame_newslot(if2396);
    if2366 = if2396;
  }
// compiled if node returning if2366 (depth = 7)
    gc_frame_newslot(if2366);
    if2322 = if2366;
  } else {
  }
// compiled if node returning if2322 (depth = 6)
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closer (depth = 8)
  int op_slot_right_2431 = gc_frame_newslot(*var_closer);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2434 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2433);
// compiled call node returning call2434 (depth = 9)
// compiled member node returning call2434 (depth = 8)
  int op_slot_left_2431 = gc_frame_newslot(call2434);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2435 = callmethod(call2434, "!=", 1, partcv, params);
// compiled op node returning opresult2435 (depth = 7)
  Object if2430 = done;
  if (istrue(opresult2435)) {
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2436 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2437 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2436);
// compiled call node returning call2437 (depth = 8)
// compiled member node returning call2437 (depth = 7)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2438 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2439 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2440 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2439);
// compiled call node returning call2440 (depth = 11)
// compiled member node returning call2440 (depth = 10)
  partcv[0] = 0;
  Object call2441 = callmethod(call2440, "new",
    1, partcv, params);
  gc_frame_end(callframe2438);
// compiled call node returning call2441 (depth = 9)
// compiled member node returning call2441 (depth = 8)
  *var_suggestion = call2441;
  if (call2441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2442 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2443 == NULL) {
    strlit2443 = alloc_String(")");
    gc_root(strlit2443);
  }
// compiled string node returning strlit2443 (depth = 8)
  gc_frame_newslot(strlit2443);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2443;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2444 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2442);
// compiled call node returning call2444 (depth = 7)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2445 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2447 == NULL) {
    strlit2447 = alloc_String("'.");
    gc_root(strlit2447);
  }
// compiled string node returning strlit2447 (depth = 9)
  int op_slot_right_2446 = gc_frame_newslot(strlit2447);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closer (depth = 10)
  int op_slot_right_2449 = gc_frame_newslot(*var_closer);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2452 == NULL) {
    strlit2452 = alloc_String("' must end with a '");
    gc_root(strlit2452);
  }
// compiled string node returning strlit2452 (depth = 11)
  int op_slot_right_2451 = gc_frame_newslot(strlit2452);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_opener (depth = 12)
  int op_slot_right_2454 = gc_frame_newslot(*var_opener);
// starting to compile string node (depth = 12)
  if (strlit2456 == NULL) {
    strlit2456 = alloc_String("An expression beginning with a '");
    gc_root(strlit2456);
  }
// compiled string node returning strlit2456 (depth = 12)
  int op_slot_left_2454 = gc_frame_newslot(strlit2456);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult2457 = callmethod(strlit2456, "++", 1, partcv, params);
// compiled op node returning opresult2457 (depth = 11)
  int op_slot_left_2451 = gc_frame_newslot(opresult2457);
  params[0] = strlit2452;
  partcv[0] = 1;
  Object opresult2458 = callmethod(opresult2457, "++", 1, partcv, params);
// compiled op node returning opresult2458 (depth = 10)
  int op_slot_left_2449 = gc_frame_newslot(opresult2458);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2459 = callmethod(opresult2458, "++", 1, partcv, params);
// compiled op node returning opresult2459 (depth = 9)
  int op_slot_left_2446 = gc_frame_newslot(opresult2459);
  params[0] = strlit2447;
  partcv[0] = 1;
  Object opresult2460 = callmethod(opresult2459, "++", 1, partcv, params);
// compiled op node returning opresult2460 (depth = 8)
  gc_frame_newslot(opresult2460);
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2462 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2461);
// compiled call node returning call2462 (depth = 9)
// compiled member node returning call2462 (depth = 8)
  gc_frame_newslot(call2462);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2464 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2465 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2464);
// compiled call node returning call2465 (depth = 10)
// compiled member node returning call2465 (depth = 9)
  int op_slot_right_2463 = gc_frame_newslot(call2465);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2468 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2467);
// compiled call node returning call2468 (depth = 10)
// compiled member node returning call2468 (depth = 9)
  int op_slot_left_2463 = gc_frame_newslot(call2468);
  params[0] = call2465;
  partcv[0] = 1;
  Object sum2469 = callmethod(call2468, "+", 1, partcv, params);
// compiled op node returning sum2469 (depth = 8)
  gc_frame_newslot(sum2469);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2460;
  params[1] = call2462;
  params[2] = sum2469;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2470 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2445);
// compiled call node returning call2470 (depth = 7)
    gc_frame_newslot(call2470);
    if2430 = call2470;
  } else {
  }
// compiled if node returning if2430 (depth = 6)
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2471 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2472 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2471);
// compiled call node returning call2472 (depth = 7)
// compiled member node returning call2472 (depth = 6)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2474 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2473);
// compiled call node returning call2474 (depth = 8)
// compiled member node returning call2474 (depth = 7)
  *var_econd = call2474;
  if (call2474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2479 == NULL) {
    strlit2479 = alloc_String("then");
    gc_root(strlit2479);
  }
// compiled string node returning strlit2479 (depth = 9)
  int op_slot_right_2478 = gc_frame_newslot(strlit2479);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2482 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2481);
// compiled call node returning call2482 (depth = 10)
// compiled member node returning call2482 (depth = 9)
  int op_slot_left_2478 = gc_frame_newslot(call2482);
  params[0] = strlit2479;
  partcv[0] = 1;
  Object opresult2483 = callmethod(call2482, "==", 1, partcv, params);
// compiled op node returning opresult2483 (depth = 8)
  int op_slot_right_2477 = gc_frame_newslot(opresult2483);
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2485 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2486 == NULL) {
    strlit2486 = alloc_String("identifier");
    gc_root(strlit2486);
  }
// compiled string node returning strlit2486 (depth = 9)
  gc_frame_newslot(strlit2486);
// call case 4: self request
  params[0] = strlit2486;
  partcv[0] = 1;
  Object call2487 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2485);
// compiled call node returning call2487 (depth = 8)
  int op_slot_left_2477 = gc_frame_newslot(call2487);
  params[0] = opresult2483;
  partcv[0] = 1;
  Object opresult2488 = callmethod(call2487, "&&", 1, partcv, params);
// compiled op node returning opresult2488 (depth = 7)
  Object if2476 = done;
  if (istrue(opresult2488)) {
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2489 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2490 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2489);
// compiled call node returning call2490 (depth = 8)
// compiled member node returning call2490 (depth = 7)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile array node (depth = 8)
  Object array2491 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2491 (depth = 8)
  *var_ebody = array2491;
  if (array2491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2476 = done;
  } else {
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2493 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2495 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2494);
// compiled call node returning call2495 (depth = 11)
// compiled member node returning call2495 (depth = 10)
  partcv[0] = 0;
  Object call2496 = callmethod(call2495, "new",
    1, partcv, params);
  gc_frame_end(callframe2493);
// compiled call node returning call2496 (depth = 9)
// compiled member node returning call2496 (depth = 8)
  *var_suggestion = call2496;
  if (call2496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2499 == NULL) {
    strlit2499 = alloc_String("lbrace");
    gc_root(strlit2499);
  }
// compiled string node returning strlit2499 (depth = 9)
  int op_slot_right_2498 = gc_frame_newslot(strlit2499);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2501 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2502 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2501);
// compiled call node returning call2502 (depth = 10)
// compiled member node returning call2502 (depth = 9)
  int op_slot_left_2498 = gc_frame_newslot(call2502);
  params[0] = strlit2499;
  partcv[0] = 1;
  Object opresult2503 = callmethod(call2502, "==", 1, partcv, params);
// compiled op node returning opresult2503 (depth = 8)
  Object if2497 = done;
  if (istrue(opresult2503)) {
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2504 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2505 = alloc_Boolean(0);
// compiled identifier node returning bool2505 (depth = 10)
  gc_frame_newslot(bool2505);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2505;
  partcv[0] = 2;
  Object call2506 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2504);
// compiled call node returning call2506 (depth = 9)
  *var_closingBrace = call2506;
  if (call2506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2509 = alloc_Boolean(0);
// compiled identifier node returning bool2509 (depth = 10)
  int op_slot_right_2508 = gc_frame_newslot(bool2509);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2512 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2511);
// compiled call node returning call2512 (depth = 11)
// compiled member node returning call2512 (depth = 10)
  int op_slot_left_2508 = gc_frame_newslot(call2512);
  params[0] = bool2509;
  partcv[0] = 1;
  Object opresult2513 = callmethod(call2512, "==", 1, partcv, params);
// compiled op node returning opresult2513 (depth = 9)
  Object if2507 = done;
  if (istrue(opresult2513)) {
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2515 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2517 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2518 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2517);
// compiled call node returning call2518 (depth = 12)
// compiled member node returning call2518 (depth = 11)
  int op_slot_left_2515 = gc_frame_newslot(call2518);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2519 = callmethod(call2518, "==", 1, partcv, params);
// compiled op node returning opresult2519 (depth = 10)
  Object if2514 = done;
  if (istrue(opresult2519)) {
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2520 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2521 = alloc_Boolean(1);
// compiled identifier node returning bool2521 (depth = 11)
  gc_frame_newslot(bool2521);
// starting to compile identifier node (depth = 11)
  Object bool2522 = alloc_Boolean(0);
// compiled identifier node returning bool2522 (depth = 11)
  gc_frame_newslot(bool2522);
// starting to compile string node (depth = 11)
  if (strlit2523 == NULL) {
    strlit2523 = alloc_String(" then {}");
    gc_root(strlit2523);
  }
// compiled string node returning strlit2523 (depth = 11)
  gc_frame_newslot(strlit2523);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2521;
  params[2] = bool2522;
  params[3] = strlit2523;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2524 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2520);
// compiled call node returning call2524 (depth = 10)
    gc_frame_newslot(call2524);
    if2514 = call2524;
  } else {
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2525 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2526 = alloc_Boolean(1);
// compiled identifier node returning bool2526 (depth = 11)
  gc_frame_newslot(bool2526);
// starting to compile identifier node (depth = 11)
  Object bool2527 = alloc_Boolean(0);
// compiled identifier node returning bool2527 (depth = 11)
  gc_frame_newslot(bool2527);
// starting to compile string node (depth = 11)
  if (strlit2528 == NULL) {
    strlit2528 = alloc_String(" then {");
    gc_root(strlit2528);
  }
// compiled string node returning strlit2528 (depth = 11)
  gc_frame_newslot(strlit2528);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2526;
  params[2] = bool2527;
  params[3] = strlit2528;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2529 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2525);
// compiled call node returning call2529 (depth = 10)
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2530 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2532 = alloc_Float64(0.1);
// compiled num node returning num2532 (depth = 12)
  int op_slot_right_2531 = gc_frame_newslot(num2532);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2534 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2536 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2535);
// compiled call node returning call2536 (depth = 15)
// compiled member node returning call2536 (depth = 14)
  partcv[0] = 0;
  Object call2537 = callmethod(call2536, "line",
    1, partcv, params);
  gc_frame_end(callframe2534);
// compiled call node returning call2537 (depth = 13)
// compiled member node returning call2537 (depth = 12)
  int op_slot_left_2531 = gc_frame_newslot(call2537);
  params[0] = num2532;
  partcv[0] = 1;
  Object sum2538 = callmethod(call2537, "+", 1, partcv, params);
// compiled op node returning sum2538 (depth = 11)
  gc_frame_newslot(sum2538);
// starting to compile string node (depth = 11)
  if (strlit2539 == NULL) {
    strlit2539 = alloc_String("}");
    gc_root(strlit2539);
  }
// compiled string node returning strlit2539 (depth = 11)
  gc_frame_newslot(strlit2539);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2538;
  params[1] = strlit2539;
  partcv[0] = 2;
  Object call2540 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2530);
// compiled call node returning call2540 (depth = 10)
    gc_frame_newslot(call2540);
    if2514 = call2540;
  }
// compiled if node returning if2514 (depth = 9)
    gc_frame_newslot(if2514);
    if2507 = if2514;
  } else {
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2541 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
  Object bool2542 = alloc_Boolean(1);
// compiled identifier node returning bool2542 (depth = 10)
  gc_frame_newslot(bool2542);
// starting to compile identifier node (depth = 10)
  Object bool2543 = alloc_Boolean(0);
// compiled identifier node returning bool2543 (depth = 10)
  gc_frame_newslot(bool2543);
// starting to compile string node (depth = 10)
  if (strlit2544 == NULL) {
    strlit2544 = alloc_String(" then {");
    gc_root(strlit2544);
  }
// compiled string node returning strlit2544 (depth = 10)
  gc_frame_newslot(strlit2544);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = bool2542;
  params[2] = bool2543;
  params[3] = strlit2544;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2545 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2541);
// compiled call node returning call2545 (depth = 9)
    gc_frame_newslot(call2545);
    if2507 = call2545;
  }
// compiled if node returning if2507 (depth = 8)
    gc_frame_newslot(if2507);
    if2497 = if2507;
  } else {
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2546 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2547 = alloc_Boolean(1);
// compiled identifier node returning bool2547 (depth = 10)
  gc_frame_newslot(bool2547);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2547;
  partcv[0] = 2;
  Object call2548 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2546);
// compiled call node returning call2548 (depth = 9)
  *var_closingBrace = call2548;
  if (call2548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2551 = alloc_Boolean(0);
// compiled identifier node returning bool2551 (depth = 10)
  int op_slot_right_2550 = gc_frame_newslot(bool2551);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2553 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2554 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2553);
// compiled call node returning call2554 (depth = 11)
// compiled member node returning call2554 (depth = 10)
  int op_slot_left_2550 = gc_frame_newslot(call2554);
  params[0] = bool2551;
  partcv[0] = 1;
  Object opresult2555 = callmethod(call2554, "==", 1, partcv, params);
// compiled op node returning opresult2555 (depth = 9)
  Object if2549 = done;
  if (istrue(opresult2555)) {
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2557 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2560 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2559);
// compiled call node returning call2560 (depth = 12)
// compiled member node returning call2560 (depth = 11)
  int op_slot_left_2557 = gc_frame_newslot(call2560);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2561 = callmethod(call2560, "==", 1, partcv, params);
// compiled op node returning opresult2561 (depth = 10)
  Object if2556 = done;
  if (istrue(opresult2561)) {
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2562 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2563 == NULL) {
    strlit2563 = alloc_String(" then {}");
    gc_root(strlit2563);
  }
// compiled string node returning strlit2563 (depth = 11)
  gc_frame_newslot(strlit2563);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2563;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2564 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2562);
// compiled call node returning call2564 (depth = 10)
    gc_frame_newslot(call2564);
    if2556 = call2564;
  } else {
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2565 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2566 == NULL) {
    strlit2566 = alloc_String(" then {");
    gc_root(strlit2566);
  }
// compiled string node returning strlit2566 (depth = 11)
  gc_frame_newslot(strlit2566);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2566;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2567 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2565);
// compiled call node returning call2567 (depth = 10)
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2568 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2570 = alloc_Float64(0.1);
// compiled num node returning num2570 (depth = 12)
  int op_slot_right_2569 = gc_frame_newslot(num2570);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2572 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2573 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2574 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2573);
// compiled call node returning call2574 (depth = 15)
// compiled member node returning call2574 (depth = 14)
  partcv[0] = 0;
  Object call2575 = callmethod(call2574, "line",
    1, partcv, params);
  gc_frame_end(callframe2572);
// compiled call node returning call2575 (depth = 13)
// compiled member node returning call2575 (depth = 12)
  int op_slot_left_2569 = gc_frame_newslot(call2575);
  params[0] = num2570;
  partcv[0] = 1;
  Object sum2576 = callmethod(call2575, "+", 1, partcv, params);
// compiled op node returning sum2576 (depth = 11)
  gc_frame_newslot(sum2576);
// starting to compile string node (depth = 11)
  if (strlit2577 == NULL) {
    strlit2577 = alloc_String("}");
    gc_root(strlit2577);
  }
// compiled string node returning strlit2577 (depth = 11)
  gc_frame_newslot(strlit2577);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2576;
  params[1] = strlit2577;
  partcv[0] = 2;
  Object call2578 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2568);
// compiled call node returning call2578 (depth = 10)
    gc_frame_newslot(call2578);
    if2556 = call2578;
  }
// compiled if node returning if2556 (depth = 9)
    gc_frame_newslot(if2556);
    if2549 = if2556;
  } else {
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2579 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2580 == NULL) {
    strlit2580 = alloc_String(" then {");
    gc_root(strlit2580);
  }
// compiled string node returning strlit2580 (depth = 10)
  gc_frame_newslot(strlit2580);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2580;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2581 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2579);
// compiled call node returning call2581 (depth = 9)
    gc_frame_newslot(call2581);
    if2549 = call2581;
  }
// compiled if node returning if2549 (depth = 8)
    gc_frame_newslot(if2549);
    if2497 = if2549;
  }
// compiled if node returning if2497 (depth = 7)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2582 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2583 == NULL) {
    strlit2583 = alloc_String("An elseif statement must have 'then' after the expression in parentheses.");
    gc_root(strlit2583);
  }
// compiled string node returning strlit2583 (depth = 8)
  gc_frame_newslot(strlit2583);
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2584 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2585 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2584);
// compiled call node returning call2585 (depth = 9)
// compiled member node returning call2585 (depth = 8)
  gc_frame_newslot(call2585);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2586 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2587 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2586);
// compiled call node returning call2587 (depth = 9)
// compiled member node returning call2587 (depth = 8)
  gc_frame_newslot(call2587);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2583;
  params[1] = call2585;
  params[2] = call2587;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2588 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2582);
// compiled call node returning call2588 (depth = 7)
    gc_frame_newslot(call2588);
    if2476 = call2588;
  }
// compiled if node returning if2476 (depth = 6)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2591 == NULL) {
    strlit2591 = alloc_String("lbrace");
    gc_root(strlit2591);
  }
// compiled string node returning strlit2591 (depth = 8)
  int op_slot_right_2590 = gc_frame_newslot(strlit2591);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2593 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2594 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2593);
// compiled call node returning call2594 (depth = 9)
// compiled member node returning call2594 (depth = 8)
  int op_slot_left_2590 = gc_frame_newslot(call2594);
  params[0] = strlit2591;
  partcv[0] = 1;
  Object opresult2595 = callmethod(call2594, "!=", 1, partcv, params);
// compiled op node returning opresult2595 (depth = 7)
  Object if2589 = done;
  if (istrue(opresult2595)) {
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2596 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2598 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2597);
// compiled call node returning call2598 (depth = 11)
// compiled member node returning call2598 (depth = 10)
  partcv[0] = 0;
  Object call2599 = callmethod(call2598, "new",
    1, partcv, params);
  gc_frame_end(callframe2596);
// compiled call node returning call2599 (depth = 9)
// compiled member node returning call2599 (depth = 8)
  *var_suggestion = call2599;
  if (call2599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2600 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2601 = alloc_Boolean(1);
// compiled identifier node returning bool2601 (depth = 9)
  gc_frame_newslot(bool2601);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2601;
  partcv[0] = 2;
  Object call2602 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2600);
// compiled call node returning call2602 (depth = 8)
  *var_closingBrace = call2602;
  if (call2602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2605 = alloc_Boolean(0);
// compiled identifier node returning bool2605 (depth = 9)
  int op_slot_right_2604 = gc_frame_newslot(bool2605);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2607 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2608 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2607);
// compiled call node returning call2608 (depth = 10)
// compiled member node returning call2608 (depth = 9)
  int op_slot_left_2604 = gc_frame_newslot(call2608);
  params[0] = bool2605;
  partcv[0] = 1;
  Object opresult2609 = callmethod(call2608, "==", 1, partcv, params);
// compiled op node returning opresult2609 (depth = 8)
  Object if2603 = done;
  if (istrue(opresult2609)) {
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2611 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2614 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2613);
// compiled call node returning call2614 (depth = 11)
// compiled member node returning call2614 (depth = 10)
  int op_slot_left_2611 = gc_frame_newslot(call2614);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2615 = callmethod(call2614, "==", 1, partcv, params);
// compiled op node returning opresult2615 (depth = 9)
  Object if2610 = done;
  if (istrue(opresult2615)) {
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2616 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2617 = alloc_Boolean(0);
// compiled identifier node returning bool2617 (depth = 10)
  gc_frame_newslot(bool2617);
// starting to compile identifier node (depth = 10)
  Object bool2618 = alloc_Boolean(1);
// compiled identifier node returning bool2618 (depth = 10)
  gc_frame_newslot(bool2618);
// starting to compile string node (depth = 10)
  if (strlit2619 == NULL) {
    strlit2619 = alloc_String("then {}");
    gc_root(strlit2619);
  }
// compiled string node returning strlit2619 (depth = 10)
  gc_frame_newslot(strlit2619);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2617;
  params[2] = bool2618;
  params[3] = strlit2619;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2620 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2616);
// compiled call node returning call2620 (depth = 9)
    gc_frame_newslot(call2620);
    if2610 = call2620;
  } else {
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2621 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2623 = alloc_Float64(0.1);
// compiled num node returning num2623 (depth = 11)
  int op_slot_right_2622 = gc_frame_newslot(num2623);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2625 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2626 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2627 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2626);
// compiled call node returning call2627 (depth = 14)
// compiled member node returning call2627 (depth = 13)
  partcv[0] = 0;
  Object call2628 = callmethod(call2627, "line",
    1, partcv, params);
  gc_frame_end(callframe2625);
// compiled call node returning call2628 (depth = 12)
// compiled member node returning call2628 (depth = 11)
  int op_slot_left_2622 = gc_frame_newslot(call2628);
  params[0] = num2623;
  partcv[0] = 1;
  Object sum2629 = callmethod(call2628, "+", 1, partcv, params);
// compiled op node returning sum2629 (depth = 10)
  gc_frame_newslot(sum2629);
// starting to compile string node (depth = 10)
  if (strlit2630 == NULL) {
    strlit2630 = alloc_String("}");
    gc_root(strlit2630);
  }
// compiled string node returning strlit2630 (depth = 10)
  gc_frame_newslot(strlit2630);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2629;
  params[1] = strlit2630;
  partcv[0] = 2;
  Object call2631 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2621);
// compiled call node returning call2631 (depth = 9)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2632 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2633 = alloc_Boolean(0);
// compiled identifier node returning bool2633 (depth = 10)
  gc_frame_newslot(bool2633);
// starting to compile identifier node (depth = 10)
  Object bool2634 = alloc_Boolean(1);
// compiled identifier node returning bool2634 (depth = 10)
  gc_frame_newslot(bool2634);
// starting to compile string node (depth = 10)
  if (strlit2635 == NULL) {
    strlit2635 = alloc_String("then {");
    gc_root(strlit2635);
  }
// compiled string node returning strlit2635 (depth = 10)
  gc_frame_newslot(strlit2635);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2633;
  params[2] = bool2634;
  params[3] = strlit2635;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2636 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2632);
// compiled call node returning call2636 (depth = 9)
    gc_frame_newslot(call2636);
    if2610 = call2636;
  }
// compiled if node returning if2610 (depth = 8)
    gc_frame_newslot(if2610);
    if2603 = if2610;
  } else {
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2637 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2638 = alloc_Boolean(0);
// compiled identifier node returning bool2638 (depth = 9)
  gc_frame_newslot(bool2638);
// starting to compile identifier node (depth = 9)
  Object bool2639 = alloc_Boolean(1);
// compiled identifier node returning bool2639 (depth = 9)
  gc_frame_newslot(bool2639);
// starting to compile string node (depth = 9)
  if (strlit2640 == NULL) {
    strlit2640 = alloc_String("then {");
    gc_root(strlit2640);
  }
// compiled string node returning strlit2640 (depth = 9)
  gc_frame_newslot(strlit2640);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2638;
  params[2] = bool2639;
  params[3] = strlit2640;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2641 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2637);
// compiled call node returning call2641 (depth = 8)
    gc_frame_newslot(call2641);
    if2603 = call2641;
  }
// compiled if node returning if2603 (depth = 7)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2642 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2643 == NULL) {
    strlit2643 = alloc_String("An elseif statement must have a '{' after the 'then'.");
    gc_root(strlit2643);
  }
// compiled string node returning strlit2643 (depth = 8)
  gc_frame_newslot(strlit2643);
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2645 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2644);
// compiled call node returning call2645 (depth = 9)
// compiled member node returning call2645 (depth = 8)
  gc_frame_newslot(call2645);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2648 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2647);
// compiled call node returning call2648 (depth = 10)
// compiled member node returning call2648 (depth = 9)
  int op_slot_right_2646 = gc_frame_newslot(call2648);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2651 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2650);
// compiled call node returning call2651 (depth = 10)
// compiled member node returning call2651 (depth = 9)
  int op_slot_left_2646 = gc_frame_newslot(call2651);
  params[0] = call2648;
  partcv[0] = 1;
  Object sum2652 = callmethod(call2651, "+", 1, partcv, params);
// compiled op node returning sum2652 (depth = 8)
  gc_frame_newslot(sum2652);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2643;
  params[1] = call2645;
  params[2] = sum2652;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2653 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2642);
// compiled call node returning call2653 (depth = 7)
    gc_frame_newslot(call2653);
    if2589 = call2653;
  } else {
  }
// compiled if node returning if2589 (depth = 6)
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2655 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2654);
// compiled call node returning call2655 (depth = 7)
// compiled member node returning call2655 (depth = 6)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2658 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2659 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2658);
// compiled call node returning call2659 (depth = 9)
// compiled member node returning call2659 (depth = 8)
  int op_slot_right_2657 = gc_frame_newslot(call2659);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2662 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2661);
// compiled call node returning call2662 (depth = 9)
// compiled member node returning call2662 (depth = 8)
  int op_slot_left_2657 = gc_frame_newslot(call2662);
  params[0] = call2659;
  partcv[0] = 1;
  Object opresult2663 = callmethod(call2662, "==", 1, partcv, params);
// compiled op node returning opresult2663 (depth = 7)
  Object if2656 = done;
  if (istrue(opresult2663)) {
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2665 = alloc_Float64(1);
// compiled num node returning num2665 (depth = 9)
  int op_slot_right_2664 = gc_frame_newslot(num2665);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2667 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2668 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2667);
// compiled call node returning call2668 (depth = 10)
// compiled member node returning call2668 (depth = 9)
  int op_slot_left_2664 = gc_frame_newslot(call2668);
  params[0] = num2665;
  partcv[0] = 1;
  Object diff2669 = callmethod(call2668, "-", 1, partcv, params);
// compiled op node returning diff2669 (depth = 8)
  *var_minIndentLevel = diff2669;
  if (diff2669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2656 = done;
  } else {
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minInd (depth = 8)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2656 = done;
  }
// compiled if node returning if2656 (depth = 6)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2672 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2673 = alloc_Block(NULL, NULL, "parser", 829);
  gc_frame_newslot(block2673);
// method _apply
  block_savedest(block2673);
  Object closure2674 = createclosure(1, "_apply");
  setclosureframe(closure2674, stackframe);
  addtoclosure(closure2674, selfslot);
  struct UserObject *uo2674 = (struct UserObject*)block2673;
  uo2674->data[0] = (Object)closure2674;
  Method *meth_meth_parser__apply2674 = addmethod2pos(block2673, "_apply", &meth_parser__apply2674, 0);
  int argcv_meth_parser__apply2674[] = {0};
  meth_meth_parser__apply2674->type = alloc_MethodType(1, argcv_meth_parser__apply2674);
  meth_meth_parser__apply2674->definitionModule = modulename;
  meth_meth_parser__apply2674->definitionLine = 825;
// compiled block node returning block2673 (depth = 7)
  gc_frame_newslot(block2673);
// starting to compile block node (depth = 7)
  Object block2681 = alloc_Block(NULL, NULL, "parser", 829);
  gc_frame_newslot(block2681);
// method _apply
  block_savedest(block2681);
  Object closure2682 = createclosure(8, "_apply");
  setclosureframe(closure2682, stackframe);
  addtoclosure(closure2682, var_errormessages);
  addtoclosure(closure2682, var_btok);
  addtoclosure(closure2682, var_lastToken);
  addtoclosure(closure2682, var_sym);
  addtoclosure(closure2682, var_values);
  addtoclosure(closure2682, var_v);
  addtoclosure(closure2682, var_ebody);
  addtoclosure(closure2682, selfslot);
  struct UserObject *uo2682 = (struct UserObject*)block2681;
  uo2682->data[0] = (Object)closure2682;
  Method *meth_meth_parser__apply2682 = addmethod2pos(block2681, "_apply", &meth_parser__apply2682, 0);
  int argcv_meth_parser__apply2682[] = {0};
  meth_meth_parser__apply2682->type = alloc_MethodType(1, argcv_meth_parser__apply2682);
  meth_meth_parser__apply2682->definitionModule = modulename;
  meth_meth_parser__apply2682->definitionLine = 829;
// compiled block node returning block2681 (depth = 7)
  gc_frame_newslot(block2681);
// call case 5: prelude request
  params[0] = block2673;
  params[1] = block2681;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2742 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2672);
// compiled call node returning call2742 (depth = 6)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2744 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2743);
// compiled call node returning call2744 (depth = 7)
// compiled member node returning call2744 (depth = 6)
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile array node (depth = 7)
  Object array2745 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2745 (depth = 7)
  *var_newelse = array2745;
  if (array2745 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2747 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_econd (depth = 8)
  gc_frame_newslot(*var_econd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ebody (depth = 8)
  gc_frame_newslot(*var_ebody);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newelse (depth = 8)
  gc_frame_newslot(*var_newelse);
// call case 4: self request
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2748 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2747);
// compiled call node returning call2748 (depth = 7)
  *var_eif = call2748;
  if (call2748 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2750 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_eif (depth = 7)
  gc_frame_newslot(*var_eif);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curelse (depth = 7)
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2751 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe2750);
// compiled call node returning call2751 (depth = 6)
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newelse (depth = 7)
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply2855(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2856 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2857 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2858 == NULL) {
    strlit2858 = alloc_String("rbrace");
    gc_root(strlit2858);
  }
// compiled string node returning strlit2858 (depth = 10)
  gc_frame_newslot(strlit2858);
// call case 4: self request
  params[0] = strlit2858;
  partcv[0] = 1;
  Object call2859 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2857);
// compiled call node returning call2859 (depth = 9)
  partcv[0] = 0;
  Object call2860 = callmethod(call2859, "not",
    1, partcv, params);
  gc_frame_end(callframe2856);
// compiled call node returning call2860 (depth = 8)
// compiled member node returning call2860 (depth = 7)
  gc_frame_end(frame);
  return call2860;
}
Object meth_parser__apply2868(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2869 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2870 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2869);
// compiled call node returning call2870 (depth = 13)
// compiled member node returning call2870 (depth = 12)
  gc_frame_end(frame);
  return call2870;
}
Object meth_parser__apply2863(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2865 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe2866 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block2867 = alloc_Block(NULL, NULL, "parser", 884);
  gc_frame_newslot(block2867);
// method _apply
  block_savedest(block2867);
  Object closure2868 = createclosure(1, "_apply");
  setclosureframe(closure2868, stackframe);
  addtoclosure(closure2868, selfslot);
  struct UserObject *uo2868 = (struct UserObject*)block2867;
  uo2868->data[0] = (Object)closure2868;
  Method *meth_meth_parser__apply2868 = addmethod2pos(block2867, "_apply", &meth_parser__apply2868, 0);
  int argcv_meth_parser__apply2868[] = {0};
  meth_meth_parser__apply2868->type = alloc_MethodType(1, argcv_meth_parser__apply2868);
  meth_meth_parser__apply2868->definitionModule = modulename;
  meth_meth_parser__apply2868->definitionLine = 884;
// compiled block node returning block2867 (depth = 11)
  gc_frame_newslot(block2867);
// call case 4: self request
  params[0] = block2867;
  partcv[0] = 1;
  Object call2872 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2866);
// compiled call node returning call2872 (depth = 10)
  partcv[0] = 0;
  Object call2873 = callmethod(call2872, "not",
    1, partcv, params);
  gc_frame_end(callframe2865);
// compiled call node returning call2873 (depth = 9)
// compiled member node returning call2873 (depth = 8)
  Object if2864 = done;
  if (istrue(call2873)) {
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2874 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2875 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call2876 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2875);
// compiled call node returning call2876 (depth = 12)
// compiled member node returning call2876 (depth = 11)
  partcv[0] = 0;
  Object call2877 = callmethod(call2876, "new",
    1, partcv, params);
  gc_frame_end(callframe2874);
// compiled call node returning call2877 (depth = 10)
// compiled member node returning call2877 (depth = 9)
  *var_suggestion = call2877;
  if (call2877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2878 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 10)
  Object bool2879 = alloc_Boolean(0);
// compiled identifier node returning bool2879 (depth = 10)
  gc_frame_newslot(bool2879);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2879;
  partcv[0] = 2;
  Object call2880 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2878);
// compiled call node returning call2880 (depth = 9)
  *var_closingBrace = call2880;
  if (call2880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2883 = alloc_Boolean(0);
// compiled identifier node returning bool2883 (depth = 10)
  int op_slot_right_2882 = gc_frame_newslot(bool2883);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2885 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2886 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2885);
// compiled call node returning call2886 (depth = 11)
// compiled member node returning call2886 (depth = 10)
  int op_slot_left_2882 = gc_frame_newslot(call2886);
  params[0] = bool2883;
  partcv[0] = 1;
  Object opresult2887 = callmethod(call2886, "==", 1, partcv, params);
// compiled op node returning opresult2887 (depth = 9)
  Object if2881 = done;
  if (istrue(opresult2887)) {
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2889 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2892 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2891);
// compiled call node returning call2892 (depth = 12)
// compiled member node returning call2892 (depth = 11)
  int op_slot_left_2889 = gc_frame_newslot(call2892);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2893 = callmethod(call2892, "==", 1, partcv, params);
// compiled op node returning opresult2893 (depth = 10)
  Object if2888 = done;
  if (istrue(opresult2893)) {
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2894 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2895 == NULL) {
    strlit2895 = alloc_String("}");
    gc_root(strlit2895);
  }
// compiled string node returning strlit2895 (depth = 11)
  gc_frame_newslot(strlit2895);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2895;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2896 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2894);
// compiled call node returning call2896 (depth = 10)
    gc_frame_newslot(call2896);
    if2888 = call2896;
  } else {
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2897 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2899 = alloc_Float64(0.1);
// compiled num node returning num2899 (depth = 12)
  int op_slot_right_2898 = gc_frame_newslot(num2899);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2901 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2902 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2903 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2902);
// compiled call node returning call2903 (depth = 15)
// compiled member node returning call2903 (depth = 14)
  partcv[0] = 0;
  Object call2904 = callmethod(call2903, "line",
    1, partcv, params);
  gc_frame_end(callframe2901);
// compiled call node returning call2904 (depth = 13)
// compiled member node returning call2904 (depth = 12)
  int op_slot_left_2898 = gc_frame_newslot(call2904);
  params[0] = num2899;
  partcv[0] = 1;
  Object sum2905 = callmethod(call2904, "+", 1, partcv, params);
// compiled op node returning sum2905 (depth = 11)
  gc_frame_newslot(sum2905);
// starting to compile string node (depth = 11)
  if (strlit2906 == NULL) {
    strlit2906 = alloc_String("}");
    gc_root(strlit2906);
  }
// compiled string node returning strlit2906 (depth = 11)
  gc_frame_newslot(strlit2906);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2905;
  params[1] = strlit2906;
  partcv[0] = 2;
  Object call2907 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2897);
// compiled call node returning call2907 (depth = 10)
    gc_frame_newslot(call2907);
    if2888 = call2907;
  }
// compiled if node returning if2888 (depth = 9)
    gc_frame_newslot(if2888);
    if2881 = if2888;
  } else {
  }
// compiled if node returning if2881 (depth = 8)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2908 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2909 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2908);
// compiled call node returning call2909 (depth = 8)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2910 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2911 == NULL) {
    strlit2911 = alloc_String("An else statement must end with a '}'.");
    gc_root(strlit2911);
  }
// compiled string node returning strlit2911 (depth = 9)
  gc_frame_newslot(strlit2911);
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2913 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2912);
// compiled call node returning call2913 (depth = 10)
// compiled member node returning call2913 (depth = 9)
  gc_frame_newslot(call2913);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2914 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2915 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2914);
// compiled call node returning call2915 (depth = 10)
// compiled member node returning call2915 (depth = 9)
  gc_frame_newslot(call2915);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2911;
  params[1] = call2913;
  params[2] = call2915;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2916 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2910);
// compiled call node returning call2916 (depth = 8)
    gc_frame_newslot(call2916);
    if2864 = call2916;
  } else {
  }
// compiled if node returning if2864 (depth = 7)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2917 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call2918 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2917);
// compiled call node returning call2918 (depth = 9)
// compiled member node returning call2918 (depth = 8)
  *var_v = call2918;
  if (call2918 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2920 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curelse (depth = 8)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2921 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe2920);
// compiled call node returning call2921 (depth = 7)
  gc_frame_end(frame);
  return call2921;
}
Object meth_parser_doif1658(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(27, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_statementIndent = getfromclosure(closure, 6);
  Object *var_statementToken = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doif (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doif");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_cond = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "cond");
  Object *var_body = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "body");
  Object *var_elseblock = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "elseblock");
  Object *var_curelse = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "curelse");
  Object *var_v = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "v");
  Object *var_localMin = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "minInd");
  Object *var_closingBrace = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "closingBrace");
  Object *var_econd = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "econd");
  Object *var_eif = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "eif");
  Object *var_newelse = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "newelse");
  Object *var_ebody = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "ebody");
  Object *var_o = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "o");
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1662 == NULL) {
    strlit1662 = alloc_String("if");
    gc_root(strlit1662);
  }
// compiled string node returning strlit1662 (depth = 5)
  int op_slot_right_1661 = gc_frame_newslot(strlit1662);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1664 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1665 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1664);
// compiled call node returning call1665 (depth = 6)
// compiled member node returning call1665 (depth = 5)
  int op_slot_left_1661 = gc_frame_newslot(call1665);
  params[0] = strlit1662;
  partcv[0] = 1;
  Object opresult1666 = callmethod(call1665, "==", 1, partcv, params);
// compiled op node returning opresult1666 (depth = 4)
  int op_slot_right_1660 = gc_frame_newslot(opresult1666);
// starting to compile call node (depth = 4)
  int callframe1668 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1669 == NULL) {
    strlit1669 = alloc_String("identifier");
    gc_root(strlit1669);
  }
// compiled string node returning strlit1669 (depth = 5)
  gc_frame_newslot(strlit1669);
// call case 4: self request
  params[0] = strlit1669;
  partcv[0] = 1;
  Object call1670 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1668);
// compiled call node returning call1670 (depth = 4)
  int op_slot_left_1660 = gc_frame_newslot(call1670);
  params[0] = opresult1666;
  partcv[0] = 1;
  Object opresult1671 = callmethod(call1670, "&&", 1, partcv, params);
// compiled op node returning opresult1671 (depth = 3)
  Object if1659 = done;
  if (istrue(opresult1671)) {
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1672 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1673 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1672);
// compiled call node returning call1673 (depth = 4)
// compiled member node returning call1673 (depth = 3)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1676 == NULL) {
    strlit1676 = alloc_String("lparen");
    gc_root(strlit1676);
  }
// compiled string node returning strlit1676 (depth = 5)
  int op_slot_right_1675 = gc_frame_newslot(strlit1676);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1678 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1679 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1678);
// compiled call node returning call1679 (depth = 6)
// compiled member node returning call1679 (depth = 5)
  int op_slot_left_1675 = gc_frame_newslot(call1679);
  params[0] = strlit1676;
  partcv[0] = 1;
  Object opresult1680 = callmethod(call1679, "!=", 1, partcv, params);
// compiled op node returning opresult1680 (depth = 4)
  Object if1674 = done;
  if (istrue(opresult1680)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1681 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1683 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1682);
// compiled call node returning call1683 (depth = 8)
// compiled member node returning call1683 (depth = 7)
  partcv[0] = 0;
  Object call1684 = callmethod(call1683, "new",
    1, partcv, params);
  gc_frame_end(callframe1681);
// compiled call node returning call1684 (depth = 6)
// compiled member node returning call1684 (depth = 5)
  *var_suggestion = call1684;
  if (call1684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1685 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1686 = alloc_Block(NULL, NULL, "parser", 569);
  gc_frame_newslot(block1686);
// method _apply
  block_savedest(block1686);
  Object closure1687 = createclosure(2, "_apply");
  setclosureframe(closure1687, stackframe);
  addtoclosure(closure1687, var_btok);
  addtoclosure(closure1687, selfslot);
  struct UserObject *uo1687 = (struct UserObject*)block1686;
  uo1687->data[0] = (Object)closure1687;
  Method *meth_meth_parser__apply1687 = addmethod2pos(block1686, "_apply", &meth_parser__apply1687, 0);
  int argcv_meth_parser__apply1687[] = {1};
  meth_meth_parser__apply1687->type = alloc_MethodType(1, argcv_meth_parser__apply1687);
  meth_meth_parser__apply1687->definitionModule = modulename;
  meth_meth_parser__apply1687->definitionLine = 567;
// compiled block node returning block1686 (depth = 6)
  gc_frame_newslot(block1686);
// call case 4: self request
  params[0] = block1686;
  partcv[0] = 1;
  Object call1732 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1685);
// compiled call node returning call1732 (depth = 5)
  *var_nextTok = call1732;
  if (call1732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1735 = alloc_Boolean(0);
// compiled identifier node returning bool1735 (depth = 6)
  int op_slot_right_1734 = gc_frame_newslot(bool1735);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1734 = gc_frame_newslot(*var_nextTok);
  params[0] = bool1735;
  partcv[0] = 1;
  Object opresult1737 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1737 (depth = 5)
  Object if1733 = done;
  if (istrue(opresult1737)) {
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1738 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1739 == NULL) {
    strlit1739 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1739);
  }
// compiled string node returning strlit1739 (depth = 6)
  gc_frame_newslot(strlit1739);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1739;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1740 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1738);
// compiled call node returning call1740 (depth = 5)
    gc_frame_newslot(call1740);
    if1733 = call1740;
  } else {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1743 == NULL) {
    strlit1743 = alloc_String("rparen");
    gc_root(strlit1743);
  }
// compiled string node returning strlit1743 (depth = 7)
  int op_slot_right_1742 = gc_frame_newslot(strlit1743);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1746 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1745);
// compiled call node returning call1746 (depth = 8)
// compiled member node returning call1746 (depth = 7)
  int op_slot_left_1742 = gc_frame_newslot(call1746);
  params[0] = strlit1743;
  partcv[0] = 1;
  Object opresult1747 = callmethod(call1746, "==", 1, partcv, params);
// compiled op node returning opresult1747 (depth = 6)
  Object if1741 = done;
  if (istrue(opresult1747)) {
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_1749 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_1749 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1751 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1751 (depth = 7)
  Object if1748 = done;
  if (istrue(opresult1751)) {
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1752 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1753 == NULL) {
    strlit1753 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1753);
  }
// compiled string node returning strlit1753 (depth = 8)
  gc_frame_newslot(strlit1753);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1753;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1754 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1752);
// compiled call node returning call1754 (depth = 7)
    gc_frame_newslot(call1754);
    if1748 = call1754;
  } else {
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1755 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1756 == NULL) {
    strlit1756 = alloc_String("(");
    gc_root(strlit1756);
  }
// compiled string node returning strlit1756 (depth = 8)
  gc_frame_newslot(strlit1756);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1756;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1757 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1755);
// compiled call node returning call1757 (depth = 7)
    gc_frame_newslot(call1757);
    if1748 = call1757;
  }
// compiled if node returning if1748 (depth = 6)
    gc_frame_newslot(if1748);
    if1741 = if1748;
  } else {
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1760 == NULL) {
    strlit1760 = alloc_String("lbrace");
    gc_root(strlit1760);
  }
// compiled string node returning strlit1760 (depth = 8)
  int op_slot_right_1759 = gc_frame_newslot(strlit1760);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1763 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1762);
// compiled call node returning call1763 (depth = 9)
// compiled member node returning call1763 (depth = 8)
  int op_slot_left_1759 = gc_frame_newslot(call1763);
  params[0] = strlit1760;
  partcv[0] = 1;
  Object opresult1764 = callmethod(call1763, "==", 1, partcv, params);
// compiled op node returning opresult1764 (depth = 7)
  Object if1758 = done;
  if (istrue(opresult1764)) {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_1766 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_1766 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1768 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1768 (depth = 8)
  Object if1765 = done;
  if (istrue(opresult1768)) {
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1769 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1770 == NULL) {
    strlit1770 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit1770);
  }
// compiled string node returning strlit1770 (depth = 9)
  gc_frame_newslot(strlit1770);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1770;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1771 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1769);
// compiled call node returning call1771 (depth = 8)
    gc_frame_newslot(call1771);
    if1765 = call1771;
  } else {
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1772 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1773 == NULL) {
    strlit1773 = alloc_String("(");
    gc_root(strlit1773);
  }
// compiled string node returning strlit1773 (depth = 9)
  gc_frame_newslot(strlit1773);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1773;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1774 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1772);
// compiled call node returning call1774 (depth = 8)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1775 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1776 == NULL) {
    strlit1776 = alloc_String(") then");
    gc_root(strlit1776);
  }
// compiled string node returning strlit1776 (depth = 9)
  gc_frame_newslot(strlit1776);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1777 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1778 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1777);
// compiled call node returning call1778 (depth = 10)
// compiled member node returning call1778 (depth = 9)
  gc_frame_newslot(call1778);
// starting to compile identifier node (depth = 9)
  Object bool1779 = alloc_Boolean(1);
// compiled identifier node returning bool1779 (depth = 9)
  gc_frame_newslot(bool1779);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1776;
  params[1] = call1778;
  params[2] = bool1779;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1780 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1775);
// compiled call node returning call1780 (depth = 8)
    gc_frame_newslot(call1780);
    if1765 = call1780;
  }
// compiled if node returning if1765 (depth = 7)
    gc_frame_newslot(if1765);
    if1758 = if1765;
  } else {
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1783 == NULL) {
    strlit1783 = alloc_String("identifier");
    gc_root(strlit1783);
  }
// compiled string node returning strlit1783 (depth = 9)
  int op_slot_right_1782 = gc_frame_newslot(strlit1783);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1786 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1785);
// compiled call node returning call1786 (depth = 10)
// compiled member node returning call1786 (depth = 9)
  int op_slot_left_1782 = gc_frame_newslot(call1786);
  params[0] = strlit1783;
  partcv[0] = 1;
  Object opresult1787 = callmethod(call1786, "==", 1, partcv, params);
// compiled op node returning opresult1787 (depth = 8)
  Object if1781 = done;
  if (istrue(opresult1787)) {
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1789 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1789 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1791 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1791 (depth = 9)
  Object if1788 = done;
  if (istrue(opresult1791)) {
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1792 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1793 == NULL) {
    strlit1793 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit1793);
  }
// compiled string node returning strlit1793 (depth = 10)
  gc_frame_newslot(strlit1793);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1793;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1794 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1792);
// compiled call node returning call1794 (depth = 9)
    gc_frame_newslot(call1794);
    if1788 = call1794;
  } else {
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1795 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1796 == NULL) {
    strlit1796 = alloc_String("(");
    gc_root(strlit1796);
  }
// compiled string node returning strlit1796 (depth = 10)
  gc_frame_newslot(strlit1796);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1796;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1797 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1795);
// compiled call node returning call1797 (depth = 9)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1798 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1799 == NULL) {
    strlit1799 = alloc_String(")");
    gc_root(strlit1799);
  }
// compiled string node returning strlit1799 (depth = 10)
  gc_frame_newslot(strlit1799);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1801 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1800);
// compiled call node returning call1801 (depth = 11)
// compiled member node returning call1801 (depth = 10)
  gc_frame_newslot(call1801);
// starting to compile identifier node (depth = 10)
  Object bool1802 = alloc_Boolean(1);
// compiled identifier node returning bool1802 (depth = 10)
  gc_frame_newslot(bool1802);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1799;
  params[1] = call1801;
  params[2] = bool1802;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1803 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1798);
// compiled call node returning call1803 (depth = 9)
    gc_frame_newslot(call1803);
    if1788 = call1803;
  }
// compiled if node returning if1788 (depth = 8)
    gc_frame_newslot(if1788);
    if1781 = if1788;
  } else {
  }
// compiled if node returning if1781 (depth = 7)
    gc_frame_newslot(if1781);
    if1758 = if1781;
  }
// compiled if node returning if1758 (depth = 6)
    gc_frame_newslot(if1758);
    if1741 = if1758;
  }
// compiled if node returning if1741 (depth = 5)
    gc_frame_newslot(if1741);
    if1733 = if1741;
  }
// compiled if node returning if1733 (depth = 4)
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1804 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1805 == NULL) {
    strlit1805 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1805);
  }
// compiled string node returning strlit1805 (depth = 5)
  gc_frame_newslot(strlit1805);
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1806 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1807 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1806);
// compiled call node returning call1807 (depth = 6)
// compiled member node returning call1807 (depth = 5)
  gc_frame_newslot(call1807);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1809 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1808);
// compiled call node returning call1809 (depth = 6)
// compiled member node returning call1809 (depth = 5)
  gc_frame_newslot(call1809);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1805;
  params[1] = call1807;
  params[2] = call1809;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1810 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1804);
// compiled call node returning call1810 (depth = 4)
    gc_frame_newslot(call1810);
    if1674 = call1810;
  } else {
  }
// compiled if node returning if1674 (depth = 3)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1811 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1812 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1811);
// compiled call node returning call1812 (depth = 4)
// compiled member node returning call1812 (depth = 3)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1814 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1815 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1816 = alloc_Block(NULL, NULL, "parser", 599);
  gc_frame_newslot(block1816);
// method _apply
  block_savedest(block1816);
  Object closure1817 = createclosure(2, "_apply");
  setclosureframe(closure1817, stackframe);
  addtoclosure(closure1817, var_blocksOK);
  addtoclosure(closure1817, selfslot);
  struct UserObject *uo1817 = (struct UserObject*)block1816;
  uo1817->data[0] = (Object)closure1817;
  Method *meth_meth_parser__apply1817 = addmethod2pos(block1816, "_apply", &meth_parser__apply1817, 0);
  int argcv_meth_parser__apply1817[] = {0};
  meth_meth_parser__apply1817->type = alloc_MethodType(1, argcv_meth_parser__apply1817);
  meth_meth_parser__apply1817->definitionModule = modulename;
  meth_meth_parser__apply1817->definitionLine = 599;
// compiled block node returning block1816 (depth = 7)
  gc_frame_newslot(block1816);
// call case 4: self request
  params[0] = block1816;
  partcv[0] = 1;
  Object call1821 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1815);
// compiled call node returning call1821 (depth = 6)
  partcv[0] = 0;
  Object call1822 = callmethod(call1821, "not",
    1, partcv, params);
  gc_frame_end(callframe1814);
// compiled call node returning call1822 (depth = 5)
// compiled member node returning call1822 (depth = 4)
  Object if1813 = done;
  if (istrue(call1822)) {
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1823 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1825 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1824);
// compiled call node returning call1825 (depth = 8)
// compiled member node returning call1825 (depth = 7)
  partcv[0] = 0;
  Object call1826 = callmethod(call1825, "new",
    1, partcv, params);
  gc_frame_end(callframe1823);
// compiled call node returning call1826 (depth = 6)
// compiled member node returning call1826 (depth = 5)
  *var_suggestion = call1826;
  if (call1826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1827 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1828 = alloc_Block(NULL, NULL, "parser", 602);
  gc_frame_newslot(block1828);
// method _apply
  block_savedest(block1828);
  Object closure1829 = createclosure(2, "_apply");
  setclosureframe(closure1829, stackframe);
  addtoclosure(closure1829, var_lastToken);
  addtoclosure(closure1829, selfslot);
  struct UserObject *uo1829 = (struct UserObject*)block1828;
  uo1829->data[0] = (Object)closure1829;
  Method *meth_meth_parser__apply1829 = addmethod2pos(block1828, "_apply", &meth_parser__apply1829, 0);
  int argcv_meth_parser__apply1829[] = {1};
  meth_meth_parser__apply1829->type = alloc_MethodType(1, argcv_meth_parser__apply1829);
  meth_meth_parser__apply1829->definitionModule = modulename;
  meth_meth_parser__apply1829->definitionLine = 600;
// compiled block node returning block1828 (depth = 6)
  gc_frame_newslot(block1828);
// call case 4: self request
  params[0] = block1828;
  partcv[0] = 1;
  Object call1847 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1827);
// compiled call node returning call1847 (depth = 5)
  *var_nextTok = call1847;
  if (call1847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1850 = alloc_Boolean(0);
// compiled identifier node returning bool1850 (depth = 6)
  int op_slot_right_1849 = gc_frame_newslot(bool1850);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1849 = gc_frame_newslot(*var_nextTok);
  params[0] = bool1850;
  partcv[0] = 1;
  Object opresult1852 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1852 (depth = 5)
  Object if1848 = done;
  if (istrue(opresult1852)) {
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1853 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1854 == NULL) {
    strlit1854 = alloc_String("rparen");
    gc_root(strlit1854);
  }
// compiled string node returning strlit1854 (depth = 7)
  gc_frame_newslot(strlit1854);
// call case 4: self request
  params[0] = strlit1854;
  partcv[0] = 1;
  Object call1855 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1853);
// compiled call node returning call1855 (depth = 6)
  *var_nextTok = call1855;
  if (call1855 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1858 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1858 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1860 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1860 (depth = 6)
  Object if1857 = done;
  if (istrue(opresult1860)) {
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1861 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1862 == NULL) {
    strlit1862 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1862);
  }
// compiled string node returning strlit1862 (depth = 7)
  gc_frame_newslot(strlit1862);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1862;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1863 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1861);
// compiled call node returning call1863 (depth = 6)
    gc_frame_newslot(call1863);
    if1857 = call1863;
  } else {
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1864 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1866 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1865);
// compiled call node returning call1866 (depth = 8)
// compiled member node returning call1866 (depth = 7)
  gc_frame_newslot(call1866);
// starting to compile identifier node (depth = 7)
  Object bool1867 = alloc_Boolean(1);
// compiled identifier node returning bool1867 (depth = 7)
  gc_frame_newslot(bool1867);
// starting to compile identifier node (depth = 7)
  Object bool1868 = alloc_Boolean(0);
// compiled identifier node returning bool1868 (depth = 7)
  gc_frame_newslot(bool1868);
// starting to compile string node (depth = 7)
  if (strlit1869 == NULL) {
    strlit1869 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1869);
  }
// compiled string node returning strlit1869 (depth = 7)
  gc_frame_newslot(strlit1869);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1866;
  params[2] = bool1867;
  params[3] = bool1868;
  params[4] = strlit1869;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1870 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1864);
// compiled call node returning call1870 (depth = 6)
    gc_frame_newslot(call1870);
    if1857 = call1870;
  }
// compiled if node returning if1857 (depth = 5)
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1871 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1872 == NULL) {
    strlit1872 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1872);
  }
// compiled string node returning strlit1872 (depth = 6)
  gc_frame_newslot(strlit1872);
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1873 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1874 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1873);
// compiled call node returning call1874 (depth = 7)
// compiled member node returning call1874 (depth = 6)
  gc_frame_newslot(call1874);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1875 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1876 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1875);
// compiled call node returning call1876 (depth = 7)
// compiled member node returning call1876 (depth = 6)
  gc_frame_newslot(call1876);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit1872;
  params[1] = call1874;
  params[2] = call1876;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1877 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1871);
// compiled call node returning call1877 (depth = 5)
    gc_frame_newslot(call1877);
    if1848 = call1877;
  } else {
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1879 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1879 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1881 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1881 (depth = 6)
  Object if1878 = done;
  if (istrue(opresult1881)) {
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1882 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1883 == NULL) {
    strlit1883 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1883);
  }
// compiled string node returning strlit1883 (depth = 7)
  gc_frame_newslot(strlit1883);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1883;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1884 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1882);
// compiled call node returning call1884 (depth = 6)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1885 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1886 == NULL) {
    strlit1886 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1886);
  }
// compiled string node returning strlit1886 (depth = 7)
  gc_frame_newslot(strlit1886);
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1888 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1887);
// compiled call node returning call1888 (depth = 8)
// compiled member node returning call1888 (depth = 7)
  gc_frame_newslot(call1888);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1889 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1890 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1889);
// compiled call node returning call1890 (depth = 8)
// compiled member node returning call1890 (depth = 7)
  gc_frame_newslot(call1890);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1886;
  params[1] = call1888;
  params[2] = call1890;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1891 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1885);
// compiled call node returning call1891 (depth = 6)
    gc_frame_newslot(call1891);
    if1878 = call1891;
  } else {
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1892 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1893 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1894 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1893);
// compiled call node returning call1894 (depth = 8)
// compiled member node returning call1894 (depth = 7)
  gc_frame_newslot(call1894);
// starting to compile identifier node (depth = 7)
  Object bool1895 = alloc_Boolean(0);
// compiled identifier node returning bool1895 (depth = 7)
  gc_frame_newslot(bool1895);
// starting to compile identifier node (depth = 7)
  Object bool1896 = alloc_Boolean(1);
// compiled identifier node returning bool1896 (depth = 7)
  gc_frame_newslot(bool1896);
// starting to compile string node (depth = 7)
  if (strlit1897 == NULL) {
    strlit1897 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1897);
  }
// compiled string node returning strlit1897 (depth = 7)
  gc_frame_newslot(strlit1897);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1894;
  params[2] = bool1895;
  params[3] = bool1896;
  params[4] = strlit1897;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1898 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1892);
// compiled call node returning call1898 (depth = 6)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1899 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1900 == NULL) {
    strlit1900 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1900);
  }
// compiled string node returning strlit1900 (depth = 7)
  gc_frame_newslot(strlit1900);
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1901 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1902 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1901);
// compiled call node returning call1902 (depth = 8)
// compiled member node returning call1902 (depth = 7)
  gc_frame_newslot(call1902);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1903 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1904 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1903);
// compiled call node returning call1904 (depth = 8)
// compiled member node returning call1904 (depth = 7)
  gc_frame_newslot(call1904);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1906 = alloc_Float64(1);
// compiled num node returning num1906 (depth = 8)
  int op_slot_right_1905 = gc_frame_newslot(num1906);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1908 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1909 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1908);
// compiled call node returning call1909 (depth = 9)
// compiled member node returning call1909 (depth = 8)
  int op_slot_left_1905 = gc_frame_newslot(call1909);
  params[0] = num1906;
  partcv[0] = 1;
  Object diff1910 = callmethod(call1909, "-", 1, partcv, params);
// compiled op node returning diff1910 (depth = 7)
  gc_frame_newslot(diff1910);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1900;
  params[1] = call1902;
  params[2] = call1904;
  params[3] = diff1910;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1911 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1899);
// compiled call node returning call1911 (depth = 6)
    gc_frame_newslot(call1911);
    if1878 = call1911;
  }
// compiled if node returning if1878 (depth = 5)
    gc_frame_newslot(if1878);
    if1848 = if1878;
  }
// compiled if node returning if1848 (depth = 4)
    gc_frame_newslot(if1848);
    if1813 = if1848;
  } else {
  }
// compiled if node returning if1813 (depth = 3)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1914 == NULL) {
    strlit1914 = alloc_String("rparen");
    gc_root(strlit1914);
  }
// compiled string node returning strlit1914 (depth = 5)
  int op_slot_right_1913 = gc_frame_newslot(strlit1914);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1916 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1917 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1916);
// compiled call node returning call1917 (depth = 6)
// compiled member node returning call1917 (depth = 5)
  int op_slot_left_1913 = gc_frame_newslot(call1917);
  params[0] = strlit1914;
  partcv[0] = 1;
  Object opresult1918 = callmethod(call1917, "!=", 1, partcv, params);
// compiled op node returning opresult1918 (depth = 4)
  Object if1912 = done;
  if (istrue(opresult1918)) {
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1920 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1919);
// compiled call node returning call1920 (depth = 5)
// compiled member node returning call1920 (depth = 4)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1921 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1922 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1923 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1922);
// compiled call node returning call1923 (depth = 8)
// compiled member node returning call1923 (depth = 7)
  partcv[0] = 0;
  Object call1924 = callmethod(call1923, "new",
    1, partcv, params);
  gc_frame_end(callframe1921);
// compiled call node returning call1924 (depth = 6)
// compiled member node returning call1924 (depth = 5)
  *var_suggestion = call1924;
  if (call1924 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1925 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1926 == NULL) {
    strlit1926 = alloc_String(")");
    gc_root(strlit1926);
  }
// compiled string node returning strlit1926 (depth = 5)
  gc_frame_newslot(strlit1926);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1926;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1927 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1925);
// compiled call node returning call1927 (depth = 4)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1928 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1929 == NULL) {
    strlit1929 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1929);
  }
// compiled string node returning strlit1929 (depth = 5)
  gc_frame_newslot(strlit1929);
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1931 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1930);
// compiled call node returning call1931 (depth = 6)
// compiled member node returning call1931 (depth = 5)
  gc_frame_newslot(call1931);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1934 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe1933);
// compiled call node returning call1934 (depth = 7)
// compiled member node returning call1934 (depth = 6)
  int op_slot_right_1932 = gc_frame_newslot(call1934);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1937 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1936);
// compiled call node returning call1937 (depth = 7)
// compiled member node returning call1937 (depth = 6)
  int op_slot_left_1932 = gc_frame_newslot(call1937);
  params[0] = call1934;
  partcv[0] = 1;
  Object sum1938 = callmethod(call1937, "+", 1, partcv, params);
// compiled op node returning sum1938 (depth = 5)
  gc_frame_newslot(sum1938);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1929;
  params[1] = call1931;
  params[2] = sum1938;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1939 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1928);
// compiled call node returning call1939 (depth = 4)
    gc_frame_newslot(call1939);
    if1912 = call1939;
  } else {
  }
// compiled if node returning if1912 (depth = 3)
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1940 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1941 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1940);
// compiled call node returning call1941 (depth = 4)
// compiled member node returning call1941 (depth = 3)
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1942 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1943 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1942);
// compiled call node returning call1943 (depth = 5)
// compiled member node returning call1943 (depth = 4)
  *var_cond = call1943;
  if (call1943 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1944 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1944 (depth = 4)
  *var_body = array1944;
  if (array1944 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1945 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1945 (depth = 4)
  *var_elseblock = array1945;
  if (array1945 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock (depth = 4)
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_v = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1947 = alloc_Float64(1);
// compiled num node returning num1947 (depth = 5)
  int op_slot_right_1946 = gc_frame_newslot(num1947);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1946 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1947;
  partcv[0] = 1;
  Object sum1949 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum1949 (depth = 4)
  *var_minInd = sum1949;
  if (sum1949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1953 == NULL) {
    strlit1953 = alloc_String("then");
    gc_root(strlit1953);
  }
// compiled string node returning strlit1953 (depth = 6)
  int op_slot_right_1952 = gc_frame_newslot(strlit1953);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1956 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1955);
// compiled call node returning call1956 (depth = 7)
// compiled member node returning call1956 (depth = 6)
  int op_slot_left_1952 = gc_frame_newslot(call1956);
  params[0] = strlit1953;
  partcv[0] = 1;
  Object opresult1957 = callmethod(call1956, "==", 1, partcv, params);
// compiled op node returning opresult1957 (depth = 5)
  int op_slot_right_1951 = gc_frame_newslot(opresult1957);
// starting to compile call node (depth = 5)
  int callframe1959 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1960 == NULL) {
    strlit1960 = alloc_String("identifier");
    gc_root(strlit1960);
  }
// compiled string node returning strlit1960 (depth = 6)
  gc_frame_newslot(strlit1960);
// call case 4: self request
  params[0] = strlit1960;
  partcv[0] = 1;
  Object call1961 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1959);
// compiled call node returning call1961 (depth = 5)
  int op_slot_left_1951 = gc_frame_newslot(call1961);
  params[0] = opresult1957;
  partcv[0] = 1;
  Object opresult1962 = callmethod(call1961, "&&", 1, partcv, params);
// compiled op node returning opresult1962 (depth = 4)
  Object if1950 = done;
  if (istrue(opresult1962)) {
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1964 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1963);
// compiled call node returning call1964 (depth = 5)
// compiled member node returning call1964 (depth = 4)
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1967 == NULL) {
    strlit1967 = alloc_String("lbrace");
    gc_root(strlit1967);
  }
// compiled string node returning strlit1967 (depth = 6)
  int op_slot_right_1966 = gc_frame_newslot(strlit1967);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1969 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1970 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1969);
// compiled call node returning call1970 (depth = 7)
// compiled member node returning call1970 (depth = 6)
  int op_slot_left_1966 = gc_frame_newslot(call1970);
  params[0] = strlit1967;
  partcv[0] = 1;
  Object opresult1971 = callmethod(call1970, "!=", 1, partcv, params);
// compiled op node returning opresult1971 (depth = 5)
  Object if1965 = done;
  if (istrue(opresult1971)) {
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1972 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1973 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call1974 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1973);
// compiled call node returning call1974 (depth = 9)
// compiled member node returning call1974 (depth = 8)
  partcv[0] = 0;
  Object call1975 = callmethod(call1974, "new",
    1, partcv, params);
  gc_frame_end(callframe1972);
// compiled call node returning call1975 (depth = 7)
// compiled member node returning call1975 (depth = 6)
  *var_suggestion = call1975;
  if (call1975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1976 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool1977 = alloc_Boolean(1);
// compiled identifier node returning bool1977 (depth = 7)
  gc_frame_newslot(bool1977);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool1977;
  partcv[0] = 2;
  Object call1978 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1976);
// compiled call node returning call1978 (depth = 6)
  *var_closingBrace = call1978;
  if (call1978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1981 = alloc_Boolean(0);
// compiled identifier node returning bool1981 (depth = 7)
  int op_slot_right_1980 = gc_frame_newslot(bool1981);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call1984 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe1983);
// compiled call node returning call1984 (depth = 8)
// compiled member node returning call1984 (depth = 7)
  int op_slot_left_1980 = gc_frame_newslot(call1984);
  params[0] = bool1981;
  partcv[0] = 1;
  Object opresult1985 = callmethod(call1984, "==", 1, partcv, params);
// compiled op node returning opresult1985 (depth = 6)
  Object if1979 = done;
  if (istrue(opresult1985)) {
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_1987 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call1990 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe1989);
// compiled call node returning call1990 (depth = 9)
// compiled member node returning call1990 (depth = 8)
  int op_slot_left_1987 = gc_frame_newslot(call1990);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult1991 = callmethod(call1990, "==", 1, partcv, params);
// compiled op node returning opresult1991 (depth = 7)
  Object if1986 = done;
  if (istrue(opresult1991)) {
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1992 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool1993 = alloc_Boolean(0);
// compiled identifier node returning bool1993 (depth = 8)
  gc_frame_newslot(bool1993);
// starting to compile identifier node (depth = 8)
  Object bool1994 = alloc_Boolean(1);
// compiled identifier node returning bool1994 (depth = 8)
  gc_frame_newslot(bool1994);
// starting to compile string node (depth = 8)
  if (strlit1995 == NULL) {
    strlit1995 = alloc_String("then {}");
    gc_root(strlit1995);
  }
// compiled string node returning strlit1995 (depth = 8)
  gc_frame_newslot(strlit1995);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool1993;
  params[2] = bool1994;
  params[3] = strlit1995;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1996 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1992);
// compiled call node returning call1996 (depth = 7)
    gc_frame_newslot(call1996);
    if1986 = call1996;
  } else {
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1997 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1999 = alloc_Float64(0.1);
// compiled num node returning num1999 (depth = 9)
  int op_slot_right_1998 = gc_frame_newslot(num1999);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2001 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2003 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2002);
// compiled call node returning call2003 (depth = 12)
// compiled member node returning call2003 (depth = 11)
  partcv[0] = 0;
  Object call2004 = callmethod(call2003, "line",
    1, partcv, params);
  gc_frame_end(callframe2001);
// compiled call node returning call2004 (depth = 10)
// compiled member node returning call2004 (depth = 9)
  int op_slot_left_1998 = gc_frame_newslot(call2004);
  params[0] = num1999;
  partcv[0] = 1;
  Object sum2005 = callmethod(call2004, "+", 1, partcv, params);
// compiled op node returning sum2005 (depth = 8)
  gc_frame_newslot(sum2005);
// starting to compile string node (depth = 8)
  if (strlit2006 == NULL) {
    strlit2006 = alloc_String("}");
    gc_root(strlit2006);
  }
// compiled string node returning strlit2006 (depth = 8)
  gc_frame_newslot(strlit2006);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2005;
  params[1] = strlit2006;
  partcv[0] = 2;
  Object call2007 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe1997);
// compiled call node returning call2007 (depth = 7)
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2008 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2009 = alloc_Boolean(0);
// compiled identifier node returning bool2009 (depth = 8)
  gc_frame_newslot(bool2009);
// starting to compile identifier node (depth = 8)
  Object bool2010 = alloc_Boolean(1);
// compiled identifier node returning bool2010 (depth = 8)
  gc_frame_newslot(bool2010);
// starting to compile string node (depth = 8)
  if (strlit2011 == NULL) {
    strlit2011 = alloc_String("then {");
    gc_root(strlit2011);
  }
// compiled string node returning strlit2011 (depth = 8)
  gc_frame_newslot(strlit2011);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2009;
  params[2] = bool2010;
  params[3] = strlit2011;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2012 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2008);
// compiled call node returning call2012 (depth = 7)
    gc_frame_newslot(call2012);
    if1986 = call2012;
  }
// compiled if node returning if1986 (depth = 6)
    gc_frame_newslot(if1986);
    if1979 = if1986;
  } else {
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2013 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool2014 = alloc_Boolean(0);
// compiled identifier node returning bool2014 (depth = 7)
  gc_frame_newslot(bool2014);
// starting to compile identifier node (depth = 7)
  Object bool2015 = alloc_Boolean(1);
// compiled identifier node returning bool2015 (depth = 7)
  gc_frame_newslot(bool2015);
// starting to compile string node (depth = 7)
  if (strlit2016 == NULL) {
    strlit2016 = alloc_String("then {");
    gc_root(strlit2016);
  }
// compiled string node returning strlit2016 (depth = 7)
  gc_frame_newslot(strlit2016);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool2014;
  params[2] = bool2015;
  params[3] = strlit2016;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2017 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2013);
// compiled call node returning call2017 (depth = 6)
    gc_frame_newslot(call2017);
    if1979 = call2017;
  }
// compiled if node returning if1979 (depth = 5)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2018 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2019 == NULL) {
    strlit2019 = alloc_String("An if statement must have a '{' after the 'then'.");
    gc_root(strlit2019);
  }
// compiled string node returning strlit2019 (depth = 6)
  gc_frame_newslot(strlit2019);
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2020 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2021 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2020);
// compiled call node returning call2021 (depth = 7)
// compiled member node returning call2021 (depth = 6)
  gc_frame_newslot(call2021);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2024 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2023);
// compiled call node returning call2024 (depth = 8)
// compiled member node returning call2024 (depth = 7)
  int op_slot_right_2022 = gc_frame_newslot(call2024);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2027 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2026);
// compiled call node returning call2027 (depth = 8)
// compiled member node returning call2027 (depth = 7)
  int op_slot_left_2022 = gc_frame_newslot(call2027);
  params[0] = call2024;
  partcv[0] = 1;
  Object sum2028 = callmethod(call2027, "+", 1, partcv, params);
// compiled op node returning sum2028 (depth = 6)
  gc_frame_newslot(sum2028);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2019;
  params[1] = call2021;
  params[2] = sum2028;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2029 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2018);
// compiled call node returning call2029 (depth = 5)
    gc_frame_newslot(call2029);
    if1965 = call2029;
  } else {
  }
// compiled if node returning if1965 (depth = 4)
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2030 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2031 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2030);
// compiled call node returning call2031 (depth = 5)
// compiled member node returning call2031 (depth = 4)
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2034 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2035 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2034);
// compiled call node returning call2035 (depth = 7)
// compiled member node returning call2035 (depth = 6)
  int op_slot_right_2033 = gc_frame_newslot(call2035);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2037 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2038 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2037);
// compiled call node returning call2038 (depth = 7)
// compiled member node returning call2038 (depth = 6)
  int op_slot_left_2033 = gc_frame_newslot(call2038);
  params[0] = call2035;
  partcv[0] = 1;
  Object opresult2039 = callmethod(call2038, "==", 1, partcv, params);
// compiled op node returning opresult2039 (depth = 5)
  Object if2032 = done;
  if (istrue(opresult2039)) {
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2041 = alloc_Float64(1);
// compiled num node returning num2041 (depth = 7)
  int op_slot_right_2040 = gc_frame_newslot(num2041);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2043 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2044 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2043);
// compiled call node returning call2044 (depth = 8)
// compiled member node returning call2044 (depth = 7)
  int op_slot_left_2040 = gc_frame_newslot(call2044);
  params[0] = num2041;
  partcv[0] = 1;
  Object diff2045 = callmethod(call2044, "-", 1, partcv, params);
// compiled op node returning diff2045 (depth = 6)
  *var_minIndentLevel = diff2045;
  if (diff2045 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2032 = done;
  } else {
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minInd (depth = 6)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2032 = done;
  }
// compiled if node returning if2032 (depth = 4)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2048 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2049 = alloc_Block(NULL, NULL, "parser", 671);
  gc_frame_newslot(block2049);
// method _apply
  block_savedest(block2049);
  Object closure2050 = createclosure(1, "_apply");
  setclosureframe(closure2050, stackframe);
  addtoclosure(closure2050, selfslot);
  struct UserObject *uo2050 = (struct UserObject*)block2049;
  uo2050->data[0] = (Object)closure2050;
  Method *meth_meth_parser__apply2050 = addmethod2pos(block2049, "_apply", &meth_parser__apply2050, 0);
  int argcv_meth_parser__apply2050[] = {0};
  meth_meth_parser__apply2050->type = alloc_MethodType(1, argcv_meth_parser__apply2050);
  meth_meth_parser__apply2050->definitionModule = modulename;
  meth_meth_parser__apply2050->definitionLine = 667;
// compiled block node returning block2049 (depth = 5)
  gc_frame_newslot(block2049);
// starting to compile block node (depth = 5)
  Object block2057 = alloc_Block(NULL, NULL, "parser", 671);
  gc_frame_newslot(block2057);
// method _apply
  block_savedest(block2057);
  Object closure2058 = createclosure(8, "_apply");
  setclosureframe(closure2058, stackframe);
  addtoclosure(closure2058, var_errormessages);
  addtoclosure(closure2058, var_btok);
  addtoclosure(closure2058, var_lastToken);
  addtoclosure(closure2058, var_sym);
  addtoclosure(closure2058, var_values);
  addtoclosure(closure2058, var_v);
  addtoclosure(closure2058, var_body);
  addtoclosure(closure2058, selfslot);
  struct UserObject *uo2058 = (struct UserObject*)block2057;
  uo2058->data[0] = (Object)closure2058;
  Method *meth_meth_parser__apply2058 = addmethod2pos(block2057, "_apply", &meth_parser__apply2058, 0);
  int argcv_meth_parser__apply2058[] = {0};
  meth_meth_parser__apply2058->type = alloc_MethodType(1, argcv_meth_parser__apply2058);
  meth_meth_parser__apply2058->definitionModule = modulename;
  meth_meth_parser__apply2058->definitionLine = 671;
// compiled block node returning block2057 (depth = 5)
  gc_frame_newslot(block2057);
// call case 5: prelude request
  params[0] = block2049;
  params[1] = block2057;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2118 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2048);
// compiled call node returning call2118 (depth = 4)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2119 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2120 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2119);
// compiled call node returning call2120 (depth = 5)
// compiled member node returning call2120 (depth = 4)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_econd = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_eif = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_newelse = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_ebody = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2121 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2122 = alloc_Block(NULL, NULL, "parser", 694);
  gc_frame_newslot(block2122);
// method _apply
  block_savedest(block2122);
  Object closure2123 = createclosure(2, "_apply");
  setclosureframe(closure2123, stackframe);
  addtoclosure(closure2123, var_sym);
  addtoclosure(closure2123, selfslot);
  struct UserObject *uo2123 = (struct UserObject*)block2122;
  uo2123->data[0] = (Object)closure2123;
  Method *meth_meth_parser__apply2123 = addmethod2pos(block2122, "_apply", &meth_parser__apply2123, 0);
  int argcv_meth_parser__apply2123[] = {0};
  meth_meth_parser__apply2123->type = alloc_MethodType(1, argcv_meth_parser__apply2123);
  meth_meth_parser__apply2123->definitionModule = modulename;
  meth_meth_parser__apply2123->definitionLine = 689;
// compiled block node returning block2122 (depth = 5)
  gc_frame_newslot(block2122);
// starting to compile block node (depth = 5)
  Object block2137 = alloc_Block(NULL, NULL, "parser", 694);
  gc_frame_newslot(block2137);
// method _apply
  block_savedest(block2137);
  Object closure2138 = createclosure(16, "_apply");
  setclosureframe(closure2138, stackframe);
  addtoclosure(closure2138, var_sym);
  addtoclosure(closure2138, var_statementToken);
  addtoclosure(closure2138, var_errormessages);
  addtoclosure(closure2138, var_blocksOK);
  addtoclosure(closure2138, var_lastToken);
  addtoclosure(closure2138, var_values);
  addtoclosure(closure2138, var_econd);
  addtoclosure(closure2138, var_ebody);
  addtoclosure(closure2138, var_btok);
  addtoclosure(closure2138, var_minIndentLevel);
  addtoclosure(closure2138, var_minInd);
  addtoclosure(closure2138, var_v);
  addtoclosure(closure2138, var_newelse);
  addtoclosure(closure2138, var_eif);
  addtoclosure(closure2138, var_curelse);
  addtoclosure(closure2138, selfslot);
  struct UserObject *uo2138 = (struct UserObject*)block2137;
  uo2138->data[0] = (Object)closure2138;
  Method *meth_meth_parser__apply2138 = addmethod2pos(block2137, "_apply", &meth_parser__apply2138, 0);
  int argcv_meth_parser__apply2138[] = {0};
  meth_meth_parser__apply2138->type = alloc_MethodType(1, argcv_meth_parser__apply2138);
  meth_meth_parser__apply2138->definitionModule = modulename;
  meth_meth_parser__apply2138->definitionLine = 694;
// compiled block node returning block2137 (depth = 5)
  gc_frame_newslot(block2137);
// call case 5: prelude request
  params[0] = block2122;
  params[1] = block2137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2754 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2121);
// compiled call node returning call2754 (depth = 4)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2758 == NULL) {
    strlit2758 = alloc_String("else");
    gc_root(strlit2758);
  }
// compiled string node returning strlit2758 (depth = 7)
  int op_slot_right_2757 = gc_frame_newslot(strlit2758);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2761 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2760);
// compiled call node returning call2761 (depth = 8)
// compiled member node returning call2761 (depth = 7)
  int op_slot_left_2757 = gc_frame_newslot(call2761);
  params[0] = strlit2758;
  partcv[0] = 1;
  Object opresult2762 = callmethod(call2761, "==", 1, partcv, params);
// compiled op node returning opresult2762 (depth = 6)
  int op_slot_right_2756 = gc_frame_newslot(opresult2762);
// starting to compile call node (depth = 6)
  int callframe2764 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2765 == NULL) {
    strlit2765 = alloc_String("identifier");
    gc_root(strlit2765);
  }
// compiled string node returning strlit2765 (depth = 7)
  gc_frame_newslot(strlit2765);
// call case 4: self request
  params[0] = strlit2765;
  partcv[0] = 1;
  Object call2766 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2764);
// compiled call node returning call2766 (depth = 6)
  int op_slot_left_2756 = gc_frame_newslot(call2766);
  params[0] = opresult2762;
  partcv[0] = 1;
  Object opresult2767 = callmethod(call2766, "&&", 1, partcv, params);
// compiled op node returning opresult2767 (depth = 5)
  Object if2755 = done;
  if (istrue(opresult2767)) {
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2768 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2769 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2768);
// compiled call node returning call2769 (depth = 6)
// compiled member node returning call2769 (depth = 5)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String("lbrace");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 7)
  int op_slot_right_2771 = gc_frame_newslot(strlit2772);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2774 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2775 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2774);
// compiled call node returning call2775 (depth = 8)
// compiled member node returning call2775 (depth = 7)
  int op_slot_left_2771 = gc_frame_newslot(call2775);
  params[0] = strlit2772;
  partcv[0] = 1;
  Object opresult2776 = callmethod(call2775, "!=", 1, partcv, params);
// compiled op node returning opresult2776 (depth = 6)
  Object if2770 = done;
  if (istrue(opresult2776)) {
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2777 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2778 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2779 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2778);
// compiled call node returning call2779 (depth = 10)
// compiled member node returning call2779 (depth = 9)
  partcv[0] = 0;
  Object call2780 = callmethod(call2779, "new",
    1, partcv, params);
  gc_frame_end(callframe2777);
// compiled call node returning call2780 (depth = 8)
// compiled member node returning call2780 (depth = 7)
  *var_suggestion = call2780;
  if (call2780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2781 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 8)
  Object bool2782 = alloc_Boolean(1);
// compiled identifier node returning bool2782 (depth = 8)
  gc_frame_newslot(bool2782);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2782;
  partcv[0] = 2;
  Object call2783 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2781);
// compiled call node returning call2783 (depth = 7)
  *var_closingBrace = call2783;
  if (call2783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2786 = alloc_Boolean(0);
// compiled identifier node returning bool2786 (depth = 8)
  int op_slot_right_2785 = gc_frame_newslot(bool2786);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2789 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2788);
// compiled call node returning call2789 (depth = 9)
// compiled member node returning call2789 (depth = 8)
  int op_slot_left_2785 = gc_frame_newslot(call2789);
  params[0] = bool2786;
  partcv[0] = 1;
  Object opresult2790 = callmethod(call2789, "==", 1, partcv, params);
// compiled op node returning opresult2790 (depth = 7)
  Object if2784 = done;
  if (istrue(opresult2790)) {
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  int op_slot_right_2792 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2794 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2795 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2794);
// compiled call node returning call2795 (depth = 10)
// compiled member node returning call2795 (depth = 9)
  int op_slot_left_2792 = gc_frame_newslot(call2795);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2796 = callmethod(call2795, "==", 1, partcv, params);
// compiled op node returning opresult2796 (depth = 8)
  Object if2791 = done;
  if (istrue(opresult2796)) {
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2797 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2798 = alloc_Boolean(0);
// compiled identifier node returning bool2798 (depth = 9)
  gc_frame_newslot(bool2798);
// starting to compile identifier node (depth = 9)
  Object bool2799 = alloc_Boolean(1);
// compiled identifier node returning bool2799 (depth = 9)
  gc_frame_newslot(bool2799);
// starting to compile string node (depth = 9)
  if (strlit2800 == NULL) {
    strlit2800 = alloc_String("else {}");
    gc_root(strlit2800);
  }
// compiled string node returning strlit2800 (depth = 9)
  gc_frame_newslot(strlit2800);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2798;
  params[2] = bool2799;
  params[3] = strlit2800;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2801 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2797);
// compiled call node returning call2801 (depth = 8)
    gc_frame_newslot(call2801);
    if2791 = call2801;
  } else {
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2802 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2804 = alloc_Float64(0.1);
// compiled num node returning num2804 (depth = 10)
  int op_slot_right_2803 = gc_frame_newslot(num2804);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2806 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2808 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2807);
// compiled call node returning call2808 (depth = 13)
// compiled member node returning call2808 (depth = 12)
  partcv[0] = 0;
  Object call2809 = callmethod(call2808, "line",
    1, partcv, params);
  gc_frame_end(callframe2806);
// compiled call node returning call2809 (depth = 11)
// compiled member node returning call2809 (depth = 10)
  int op_slot_left_2803 = gc_frame_newslot(call2809);
  params[0] = num2804;
  partcv[0] = 1;
  Object sum2810 = callmethod(call2809, "+", 1, partcv, params);
// compiled op node returning sum2810 (depth = 9)
  gc_frame_newslot(sum2810);
// starting to compile string node (depth = 9)
  if (strlit2811 == NULL) {
    strlit2811 = alloc_String("}");
    gc_root(strlit2811);
  }
// compiled string node returning strlit2811 (depth = 9)
  gc_frame_newslot(strlit2811);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum2810;
  params[1] = strlit2811;
  partcv[0] = 2;
  Object call2812 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2802);
// compiled call node returning call2812 (depth = 8)
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2813 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2814 = alloc_Boolean(0);
// compiled identifier node returning bool2814 (depth = 9)
  gc_frame_newslot(bool2814);
// starting to compile identifier node (depth = 9)
  Object bool2815 = alloc_Boolean(1);
// compiled identifier node returning bool2815 (depth = 9)
  gc_frame_newslot(bool2815);
// starting to compile string node (depth = 9)
  if (strlit2816 == NULL) {
    strlit2816 = alloc_String("else {");
    gc_root(strlit2816);
  }
// compiled string node returning strlit2816 (depth = 9)
  gc_frame_newslot(strlit2816);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2814;
  params[2] = bool2815;
  params[3] = strlit2816;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2817 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2813);
// compiled call node returning call2817 (depth = 8)
    gc_frame_newslot(call2817);
    if2791 = call2817;
  }
// compiled if node returning if2791 (depth = 7)
    gc_frame_newslot(if2791);
    if2784 = if2791;
  } else {
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2818 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2819 = alloc_Boolean(0);
// compiled identifier node returning bool2819 (depth = 8)
  gc_frame_newslot(bool2819);
// starting to compile identifier node (depth = 8)
  Object bool2820 = alloc_Boolean(1);
// compiled identifier node returning bool2820 (depth = 8)
  gc_frame_newslot(bool2820);
// starting to compile string node (depth = 8)
  if (strlit2821 == NULL) {
    strlit2821 = alloc_String("else {");
    gc_root(strlit2821);
  }
// compiled string node returning strlit2821 (depth = 8)
  gc_frame_newslot(strlit2821);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2819;
  params[2] = bool2820;
  params[3] = strlit2821;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2822 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2818);
// compiled call node returning call2822 (depth = 7)
    gc_frame_newslot(call2822);
    if2784 = call2822;
  }
// compiled if node returning if2784 (depth = 6)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2823 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2824 == NULL) {
    strlit2824 = alloc_String("An else statement must have a '{' after the 'else'.");
    gc_root(strlit2824);
  }
// compiled string node returning strlit2824 (depth = 7)
  gc_frame_newslot(strlit2824);
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2826 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2825);
// compiled call node returning call2826 (depth = 8)
// compiled member node returning call2826 (depth = 7)
  gc_frame_newslot(call2826);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2828 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2829 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2828);
// compiled call node returning call2829 (depth = 9)
// compiled member node returning call2829 (depth = 8)
  int op_slot_right_2827 = gc_frame_newslot(call2829);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2832 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2831);
// compiled call node returning call2832 (depth = 9)
// compiled member node returning call2832 (depth = 8)
  int op_slot_left_2827 = gc_frame_newslot(call2832);
  params[0] = call2829;
  partcv[0] = 1;
  Object sum2833 = callmethod(call2832, "+", 1, partcv, params);
// compiled op node returning sum2833 (depth = 7)
  gc_frame_newslot(sum2833);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit2824;
  params[1] = call2826;
  params[2] = sum2833;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2834 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2823);
// compiled call node returning call2834 (depth = 6)
    gc_frame_newslot(call2834);
    if2770 = call2834;
  } else {
  }
// compiled if node returning if2770 (depth = 5)
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2835 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2836 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2835);
// compiled call node returning call2836 (depth = 6)
// compiled member node returning call2836 (depth = 5)
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2840 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2839);
// compiled call node returning call2840 (depth = 8)
// compiled member node returning call2840 (depth = 7)
  int op_slot_right_2838 = gc_frame_newslot(call2840);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2843 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2842);
// compiled call node returning call2843 (depth = 8)
// compiled member node returning call2843 (depth = 7)
  int op_slot_left_2838 = gc_frame_newslot(call2843);
  params[0] = call2840;
  partcv[0] = 1;
  Object opresult2844 = callmethod(call2843, "==", 1, partcv, params);
// compiled op node returning opresult2844 (depth = 6)
  Object if2837 = done;
  if (istrue(opresult2844)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2846 = alloc_Float64(1);
// compiled num node returning num2846 (depth = 8)
  int op_slot_right_2845 = gc_frame_newslot(num2846);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2848 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2849 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2848);
// compiled call node returning call2849 (depth = 9)
// compiled member node returning call2849 (depth = 8)
  int op_slot_left_2845 = gc_frame_newslot(call2849);
  params[0] = num2846;
  partcv[0] = 1;
  Object diff2850 = callmethod(call2849, "-", 1, partcv, params);
// compiled op node returning diff2850 (depth = 7)
  *var_minIndentLevel = diff2850;
  if (diff2850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2837 = done;
  } else {
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minInd (depth = 7)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2837 = done;
  }
// compiled if node returning if2837 (depth = 5)
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2853 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2854 = alloc_Block(NULL, NULL, "parser", 883);
  gc_frame_newslot(block2854);
// method _apply
  block_savedest(block2854);
  Object closure2855 = createclosure(1, "_apply");
  setclosureframe(closure2855, stackframe);
  addtoclosure(closure2855, selfslot);
  struct UserObject *uo2855 = (struct UserObject*)block2854;
  uo2855->data[0] = (Object)closure2855;
  Method *meth_meth_parser__apply2855 = addmethod2pos(block2854, "_apply", &meth_parser__apply2855, 0);
  int argcv_meth_parser__apply2855[] = {0};
  meth_meth_parser__apply2855->type = alloc_MethodType(1, argcv_meth_parser__apply2855);
  meth_meth_parser__apply2855->definitionModule = modulename;
  meth_meth_parser__apply2855->definitionLine = 879;
// compiled block node returning block2854 (depth = 6)
  gc_frame_newslot(block2854);
// starting to compile block node (depth = 6)
  Object block2862 = alloc_Block(NULL, NULL, "parser", 883);
  gc_frame_newslot(block2862);
// method _apply
  block_savedest(block2862);
  Object closure2863 = createclosure(8, "_apply");
  setclosureframe(closure2863, stackframe);
  addtoclosure(closure2863, var_errormessages);
  addtoclosure(closure2863, var_btok);
  addtoclosure(closure2863, var_lastToken);
  addtoclosure(closure2863, var_sym);
  addtoclosure(closure2863, var_values);
  addtoclosure(closure2863, var_v);
  addtoclosure(closure2863, var_curelse);
  addtoclosure(closure2863, selfslot);
  struct UserObject *uo2863 = (struct UserObject*)block2862;
  uo2863->data[0] = (Object)closure2863;
  Method *meth_meth_parser__apply2863 = addmethod2pos(block2862, "_apply", &meth_parser__apply2863, 0);
  int argcv_meth_parser__apply2863[] = {0};
  meth_meth_parser__apply2863->type = alloc_MethodType(1, argcv_meth_parser__apply2863);
  meth_meth_parser__apply2863->definitionModule = modulename;
  meth_meth_parser__apply2863->definitionLine = 883;
// compiled block node returning block2862 (depth = 6)
  gc_frame_newslot(block2862);
// call case 5: prelude request
  params[0] = block2854;
  params[1] = block2862;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2923 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2853);
// compiled call node returning call2923 (depth = 5)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2924 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2925 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2924);
// compiled call node returning call2925 (depth = 6)
// compiled member node returning call2925 (depth = 5)
    gc_frame_newslot(call2925);
    if2755 = call2925;
  } else {
  }
// compiled if node returning if2755 (depth = 4)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2926 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2927 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call2928 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe2927);
// compiled call node returning call2928 (depth = 6)
// compiled member node returning call2928 (depth = 5)
  gc_frame_newslot(call2928);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2929 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call2930 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2929);
// compiled call node returning call2930 (depth = 6)
// compiled member node returning call2930 (depth = 5)
  gc_frame_newslot(call2930);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call2928;
  params[1] = call2930;
  partcv[0] = 2;
  Object call2931 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe2926);
// compiled call node returning call2931 (depth = 4)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2932 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cond (depth = 6)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elseblock (depth = 6)
  gc_frame_newslot(*var_elseblock);
// call case 4: self request
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call2933 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2932);
// compiled call node returning call2933 (depth = 5)
  *var_o = call2933;
  if (call2933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2934 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call2935 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe2934);
// compiled call node returning call2935 (depth = 4)
    gc_frame_newslot(call2935);
    if1950 = call2935;
  } else {
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2936 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call2938 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2937);
// compiled call node returning call2938 (depth = 8)
// compiled member node returning call2938 (depth = 7)
  partcv[0] = 0;
  Object call2939 = callmethod(call2938, "new",
    1, partcv, params);
  gc_frame_end(callframe2936);
// compiled call node returning call2939 (depth = 6)
// compiled member node returning call2939 (depth = 5)
  *var_suggestion = call2939;
  if (call2939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2942 == NULL) {
    strlit2942 = alloc_String("lbrace");
    gc_root(strlit2942);
  }
// compiled string node returning strlit2942 (depth = 6)
  int op_slot_right_2941 = gc_frame_newslot(strlit2942);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2945 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2944);
// compiled call node returning call2945 (depth = 7)
// compiled member node returning call2945 (depth = 6)
  int op_slot_left_2941 = gc_frame_newslot(call2945);
  params[0] = strlit2942;
  partcv[0] = 1;
  Object opresult2946 = callmethod(call2945, "==", 1, partcv, params);
// compiled op node returning opresult2946 (depth = 5)
  Object if2940 = done;
  if (istrue(opresult2946)) {
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2947 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2948 = alloc_Boolean(0);
// compiled identifier node returning bool2948 (depth = 7)
  gc_frame_newslot(bool2948);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2948;
  partcv[0] = 2;
  Object call2949 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2947);
// compiled call node returning call2949 (depth = 6)
  *var_closingBrace = call2949;
  if (call2949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2952 = alloc_Boolean(0);
// compiled identifier node returning bool2952 (depth = 7)
  int op_slot_right_2951 = gc_frame_newslot(bool2952);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2955 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2954);
// compiled call node returning call2955 (depth = 8)
// compiled member node returning call2955 (depth = 7)
  int op_slot_left_2951 = gc_frame_newslot(call2955);
  params[0] = bool2952;
  partcv[0] = 1;
  Object opresult2956 = callmethod(call2955, "==", 1, partcv, params);
// compiled op node returning opresult2956 (depth = 6)
  Object if2950 = done;
  if (istrue(opresult2956)) {
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_2958 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2960 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2961 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2960);
// compiled call node returning call2961 (depth = 9)
// compiled member node returning call2961 (depth = 8)
  int op_slot_left_2958 = gc_frame_newslot(call2961);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2962 = callmethod(call2961, "==", 1, partcv, params);
// compiled op node returning opresult2962 (depth = 7)
  Object if2957 = done;
  if (istrue(opresult2962)) {
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2963 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2964 = alloc_Boolean(1);
// compiled identifier node returning bool2964 (depth = 8)
  gc_frame_newslot(bool2964);
// starting to compile identifier node (depth = 8)
  Object bool2965 = alloc_Boolean(0);
// compiled identifier node returning bool2965 (depth = 8)
  gc_frame_newslot(bool2965);
// starting to compile string node (depth = 8)
  if (strlit2966 == NULL) {
    strlit2966 = alloc_String(" then {}");
    gc_root(strlit2966);
  }
// compiled string node returning strlit2966 (depth = 8)
  gc_frame_newslot(strlit2966);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2964;
  params[2] = bool2965;
  params[3] = strlit2966;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2967 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2963);
// compiled call node returning call2967 (depth = 7)
    gc_frame_newslot(call2967);
    if2957 = call2967;
  } else {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2968 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2969 = alloc_Boolean(1);
// compiled identifier node returning bool2969 (depth = 8)
  gc_frame_newslot(bool2969);
// starting to compile identifier node (depth = 8)
  Object bool2970 = alloc_Boolean(0);
// compiled identifier node returning bool2970 (depth = 8)
  gc_frame_newslot(bool2970);
// starting to compile string node (depth = 8)
  if (strlit2971 == NULL) {
    strlit2971 = alloc_String(" then {");
    gc_root(strlit2971);
  }
// compiled string node returning strlit2971 (depth = 8)
  gc_frame_newslot(strlit2971);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2969;
  params[2] = bool2970;
  params[3] = strlit2971;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2972 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2968);
// compiled call node returning call2972 (depth = 7)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2973 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2975 = alloc_Float64(0.1);
// compiled num node returning num2975 (depth = 9)
  int op_slot_right_2974 = gc_frame_newslot(num2975);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2977 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2979 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2978);
// compiled call node returning call2979 (depth = 12)
// compiled member node returning call2979 (depth = 11)
  partcv[0] = 0;
  Object call2980 = callmethod(call2979, "line",
    1, partcv, params);
  gc_frame_end(callframe2977);
// compiled call node returning call2980 (depth = 10)
// compiled member node returning call2980 (depth = 9)
  int op_slot_left_2974 = gc_frame_newslot(call2980);
  params[0] = num2975;
  partcv[0] = 1;
  Object sum2981 = callmethod(call2980, "+", 1, partcv, params);
// compiled op node returning sum2981 (depth = 8)
  gc_frame_newslot(sum2981);
// starting to compile string node (depth = 8)
  if (strlit2982 == NULL) {
    strlit2982 = alloc_String("}");
    gc_root(strlit2982);
  }
// compiled string node returning strlit2982 (depth = 8)
  gc_frame_newslot(strlit2982);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2981;
  params[1] = strlit2982;
  partcv[0] = 2;
  Object call2983 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2973);
// compiled call node returning call2983 (depth = 7)
    gc_frame_newslot(call2983);
    if2957 = call2983;
  }
// compiled if node returning if2957 (depth = 6)
    gc_frame_newslot(if2957);
    if2950 = if2957;
  } else {
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2984 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool2985 = alloc_Boolean(1);
// compiled identifier node returning bool2985 (depth = 7)
  gc_frame_newslot(bool2985);
// starting to compile identifier node (depth = 7)
  Object bool2986 = alloc_Boolean(0);
// compiled identifier node returning bool2986 (depth = 7)
  gc_frame_newslot(bool2986);
// starting to compile string node (depth = 7)
  if (strlit2987 == NULL) {
    strlit2987 = alloc_String(" then {");
    gc_root(strlit2987);
  }
// compiled string node returning strlit2987 (depth = 7)
  gc_frame_newslot(strlit2987);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool2985;
  params[2] = bool2986;
  params[3] = strlit2987;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2988 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2984);
// compiled call node returning call2988 (depth = 6)
    gc_frame_newslot(call2988);
    if2950 = call2988;
  }
// compiled if node returning if2950 (depth = 5)
    gc_frame_newslot(if2950);
    if2940 = if2950;
  } else {
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2989 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2990 = alloc_Boolean(1);
// compiled identifier node returning bool2990 (depth = 7)
  gc_frame_newslot(bool2990);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2990;
  partcv[0] = 2;
  Object call2991 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2989);
// compiled call node returning call2991 (depth = 6)
  *var_closingBrace = call2991;
  if (call2991 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2994 = alloc_Boolean(0);
// compiled identifier node returning bool2994 (depth = 7)
  int op_slot_right_2993 = gc_frame_newslot(bool2994);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2996 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2997 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2996);
// compiled call node returning call2997 (depth = 8)
// compiled member node returning call2997 (depth = 7)
  int op_slot_left_2993 = gc_frame_newslot(call2997);
  params[0] = bool2994;
  partcv[0] = 1;
  Object opresult2998 = callmethod(call2997, "==", 1, partcv, params);
// compiled op node returning opresult2998 (depth = 6)
  Object if2992 = done;
  if (istrue(opresult2998)) {
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_3000 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3003 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3002);
// compiled call node returning call3003 (depth = 9)
// compiled member node returning call3003 (depth = 8)
  int op_slot_left_3000 = gc_frame_newslot(call3003);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3004 = callmethod(call3003, "==", 1, partcv, params);
// compiled op node returning opresult3004 (depth = 7)
  Object if2999 = done;
  if (istrue(opresult3004)) {
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3005 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3006 == NULL) {
    strlit3006 = alloc_String(" then {}");
    gc_root(strlit3006);
  }
// compiled string node returning strlit3006 (depth = 8)
  gc_frame_newslot(strlit3006);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3006;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3007 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3005);
// compiled call node returning call3007 (depth = 7)
    gc_frame_newslot(call3007);
    if2999 = call3007;
  } else {
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3008 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3009 == NULL) {
    strlit3009 = alloc_String(" then {");
    gc_root(strlit3009);
  }
// compiled string node returning strlit3009 (depth = 8)
  gc_frame_newslot(strlit3009);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3009;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3010 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3008);
// compiled call node returning call3010 (depth = 7)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3011 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3013 = alloc_Float64(0.1);
// compiled num node returning num3013 (depth = 9)
  int op_slot_right_3012 = gc_frame_newslot(num3013);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3015 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3017 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3016);
// compiled call node returning call3017 (depth = 12)
// compiled member node returning call3017 (depth = 11)
  partcv[0] = 0;
  Object call3018 = callmethod(call3017, "line",
    1, partcv, params);
  gc_frame_end(callframe3015);
// compiled call node returning call3018 (depth = 10)
// compiled member node returning call3018 (depth = 9)
  int op_slot_left_3012 = gc_frame_newslot(call3018);
  params[0] = num3013;
  partcv[0] = 1;
  Object sum3019 = callmethod(call3018, "+", 1, partcv, params);
// compiled op node returning sum3019 (depth = 8)
  gc_frame_newslot(sum3019);
// starting to compile string node (depth = 8)
  if (strlit3020 == NULL) {
    strlit3020 = alloc_String("}");
    gc_root(strlit3020);
  }
// compiled string node returning strlit3020 (depth = 8)
  gc_frame_newslot(strlit3020);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3019;
  params[1] = strlit3020;
  partcv[0] = 2;
  Object call3021 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3011);
// compiled call node returning call3021 (depth = 7)
    gc_frame_newslot(call3021);
    if2999 = call3021;
  }
// compiled if node returning if2999 (depth = 6)
    gc_frame_newslot(if2999);
    if2992 = if2999;
  } else {
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3022 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3023 == NULL) {
    strlit3023 = alloc_String(" then {");
    gc_root(strlit3023);
  }
// compiled string node returning strlit3023 (depth = 7)
  gc_frame_newslot(strlit3023);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3023;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3024 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3022);
// compiled call node returning call3024 (depth = 6)
    gc_frame_newslot(call3024);
    if2992 = call3024;
  }
// compiled if node returning if2992 (depth = 5)
    gc_frame_newslot(if2992);
    if2940 = if2992;
  }
// compiled if node returning if2940 (depth = 4)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3025 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3026 == NULL) {
    strlit3026 = alloc_String("An if statement must have 'then' after the expression in parentheses.");
    gc_root(strlit3026);
  }
// compiled string node returning strlit3026 (depth = 5)
  gc_frame_newslot(strlit3026);
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3027 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3028 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3027);
// compiled call node returning call3028 (depth = 6)
// compiled member node returning call3028 (depth = 5)
  gc_frame_newslot(call3028);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3029 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3030 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3029);
// compiled call node returning call3030 (depth = 6)
// compiled member node returning call3030 (depth = 5)
  gc_frame_newslot(call3030);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3026;
  params[1] = call3028;
  params[2] = call3030;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3031 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3025);
// compiled call node returning call3031 (depth = 4)
    gc_frame_newslot(call3031);
    if1950 = call3031;
  }
// compiled if node returning if1950 (depth = 3)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMin (depth = 4)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localStatementIndent (depth = 4)
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1659 = done;
  } else {
  }
// compiled if node returning if1659 (depth = 2)
  gc_frame_end(frame);
  return if1659;
}
Object meth_parser_identifier3034(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for identifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3036 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3037 == NULL) {
    strlit3037 = alloc_String("identifier");
    gc_root(strlit3037);
  }
// compiled string node returning strlit3037 (depth = 4)
  gc_frame_newslot(strlit3037);
// call case 4: self request
  params[0] = strlit3037;
  partcv[0] = 1;
  Object call3038 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3036);
// compiled call node returning call3038 (depth = 3)
  Object if3035 = done;
  if (istrue(call3038)) {
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3041 == NULL) {
    strlit3041 = alloc_String("if");
    gc_root(strlit3041);
  }
// compiled string node returning strlit3041 (depth = 5)
  int op_slot_right_3040 = gc_frame_newslot(strlit3041);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3043 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3044 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3043);
// compiled call node returning call3044 (depth = 6)
// compiled member node returning call3044 (depth = 5)
  int op_slot_left_3040 = gc_frame_newslot(call3044);
  params[0] = strlit3041;
  partcv[0] = 1;
  Object opresult3045 = callmethod(call3044, "==", 1, partcv, params);
// compiled op node returning opresult3045 (depth = 4)
  Object if3039 = done;
  if (istrue(opresult3045)) {
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3046 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3047 = callmethodflags(self, "doif", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3046);
// compiled call node returning call3047 (depth = 5)
// compiled member node returning call3047 (depth = 4)
    gc_frame_newslot(call3047);
    if3039 = call3047;
  } else {
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3048 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3049 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3048);
// compiled call node returning call3049 (depth = 5)
// compiled member node returning call3049 (depth = 4)
    gc_frame_newslot(call3049);
    if3039 = call3049;
  }
// compiled if node returning if3039 (depth = 3)
    gc_frame_newslot(if3039);
    if3035 = if3039;
  } else {
  }
// compiled if node returning if3035 (depth = 2)
  gc_frame_end(frame);
  return if3035;
}
Object meth_parser__apply3069(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe3070 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3071 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3070);
// compiled call node returning call3071 (depth = 9)
  gc_frame_end(frame);
  return call3071;
}
Object meth_parser__apply3137(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3139 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3138);
// compiled call node returning call3139 (depth = 10)
// compiled member node returning call3139 (depth = 9)
  gc_frame_end(frame);
  return call3139;
}
Object meth_parser_prefixop3050(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for prefixop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for prefixop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_op = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "op");
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_mem = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "mem");
  Object *var_call = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "call");
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3052 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3053 == NULL) {
    strlit3053 = alloc_String("op");
    gc_root(strlit3053);
  }
// compiled string node returning strlit3053 (depth = 4)
  gc_frame_newslot(strlit3053);
// call case 4: self request
  params[0] = strlit3053;
  partcv[0] = 1;
  Object call3054 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3052);
// compiled call node returning call3054 (depth = 3)
  Object if3051 = done;
  if (istrue(call3054)) {
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3056 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3055);
// compiled call node returning call3056 (depth = 5)
// compiled member node returning call3056 (depth = 4)
  *var_op = call3056;
  if (call3056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_val = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3058 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3057);
// compiled call node returning call3058 (depth = 4)
// compiled member node returning call3058 (depth = 3)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3060 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3061 == NULL) {
    strlit3061 = alloc_String("lparen");
    gc_root(strlit3061);
  }
// compiled string node returning strlit3061 (depth = 5)
  gc_frame_newslot(strlit3061);
// call case 4: self request
  params[0] = strlit3061;
  partcv[0] = 1;
  Object call3062 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3060);
// compiled call node returning call3062 (depth = 4)
  Object if3059 = done;
  if (istrue(call3062)) {
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3064 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compiled call node returning call3064 (depth = 5)
// compiled member node returning call3064 (depth = 4)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3066 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3067 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3068 = alloc_Block(NULL, NULL, "parser", 961);
  gc_frame_newslot(block3068);
// method _apply
  block_savedest(block3068);
  Object closure3069 = createclosure(2, "_apply");
  setclosureframe(closure3069, stackframe);
  addtoclosure(closure3069, var_blocksOK);
  addtoclosure(closure3069, selfslot);
  struct UserObject *uo3069 = (struct UserObject*)block3068;
  uo3069->data[0] = (Object)closure3069;
  Method *meth_meth_parser__apply3069 = addmethod2pos(block3068, "_apply", &meth_parser__apply3069, 0);
  int argcv_meth_parser__apply3069[] = {0};
  meth_meth_parser__apply3069->type = alloc_MethodType(1, argcv_meth_parser__apply3069);
  meth_meth_parser__apply3069->definitionModule = modulename;
  meth_meth_parser__apply3069->definitionLine = 961;
// compiled block node returning block3068 (depth = 8)
  gc_frame_newslot(block3068);
// call case 4: self request
  params[0] = block3068;
  partcv[0] = 1;
  Object call3073 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3067);
// compiled call node returning call3073 (depth = 7)
  partcv[0] = 0;
  Object call3074 = callmethod(call3073, "not",
    1, partcv, params);
  gc_frame_end(callframe3066);
// compiled call node returning call3074 (depth = 6)
// compiled member node returning call3074 (depth = 5)
  Object if3065 = done;
  if (istrue(call3074)) {
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3075 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3076 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3077 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3076);
// compiled call node returning call3077 (depth = 9)
// compiled member node returning call3077 (depth = 8)
  partcv[0] = 0;
  Object call3078 = callmethod(call3077, "new",
    1, partcv, params);
  gc_frame_end(callframe3075);
// compiled call node returning call3078 (depth = 7)
// compiled member node returning call3078 (depth = 6)
  *var_suggestion = call3078;
  if (call3078 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3079 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3080 == NULL) {
    strlit3080 = alloc_String("rparen");
    gc_root(strlit3080);
  }
// compiled string node returning strlit3080 (depth = 7)
  gc_frame_newslot(strlit3080);
// call case 4: self request
  params[0] = strlit3080;
  partcv[0] = 1;
  Object call3081 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3079);
// compiled call node returning call3081 (depth = 6)
  *var_nextTok = call3081;
  if (call3081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3083 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3083 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3085 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3085 (depth = 6)
  Object if3082 = done;
  if (istrue(opresult3085)) {
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3086 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3087 == NULL) {
    strlit3087 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3087);
  }
// compiled string node returning strlit3087 (depth = 7)
  gc_frame_newslot(strlit3087);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3087;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3088 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3086);
// compiled call node returning call3088 (depth = 6)
    gc_frame_newslot(call3088);
    if3082 = call3088;
  } else {
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3089 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3091 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3090);
// compiled call node returning call3091 (depth = 8)
// compiled member node returning call3091 (depth = 7)
  gc_frame_newslot(call3091);
// starting to compile identifier node (depth = 7)
  Object bool3092 = alloc_Boolean(1);
// compiled identifier node returning bool3092 (depth = 7)
  gc_frame_newslot(bool3092);
// starting to compile identifier node (depth = 7)
  Object bool3093 = alloc_Boolean(0);
// compiled identifier node returning bool3093 (depth = 7)
  gc_frame_newslot(bool3093);
// starting to compile string node (depth = 7)
  if (strlit3094 == NULL) {
    strlit3094 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3094);
  }
// compiled string node returning strlit3094 (depth = 7)
  gc_frame_newslot(strlit3094);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3091;
  params[2] = bool3092;
  params[3] = bool3093;
  params[4] = strlit3094;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3095 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3089);
// compiled call node returning call3095 (depth = 6)
    gc_frame_newslot(call3095);
    if3082 = call3095;
  }
// compiled if node returning if3082 (depth = 5)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3096 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3097 == NULL) {
    strlit3097 = alloc_String("Parentheses must contain a valid expression.");
    gc_root(strlit3097);
  }
// compiled string node returning strlit3097 (depth = 6)
  gc_frame_newslot(strlit3097);
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3098 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3099 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3098);
// compiled call node returning call3099 (depth = 7)
// compiled member node returning call3099 (depth = 6)
  gc_frame_newslot(call3099);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3100 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3101 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3100);
// compiled call node returning call3101 (depth = 7)
// compiled member node returning call3101 (depth = 6)
  gc_frame_newslot(call3101);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3097;
  params[1] = call3099;
  params[2] = call3101;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3102 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3096);
// compiled call node returning call3102 (depth = 5)
    gc_frame_newslot(call3102);
    if3065 = call3102;
  } else {
  }
// compiled if node returning if3065 (depth = 4)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3105 == NULL) {
    strlit3105 = alloc_String("rparen");
    gc_root(strlit3105);
  }
// compiled string node returning strlit3105 (depth = 6)
  int op_slot_right_3104 = gc_frame_newslot(strlit3105);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3108 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3107);
// compiled call node returning call3108 (depth = 7)
// compiled member node returning call3108 (depth = 6)
  int op_slot_left_3104 = gc_frame_newslot(call3108);
  params[0] = strlit3105;
  partcv[0] = 1;
  Object opresult3109 = callmethod(call3108, "!=", 1, partcv, params);
// compiled op node returning opresult3109 (depth = 5)
  Object if3103 = done;
  if (istrue(opresult3109)) {
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3111 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3110);
// compiled call node returning call3111 (depth = 6)
// compiled member node returning call3111 (depth = 5)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3112 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3114 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3113);
// compiled call node returning call3114 (depth = 9)
// compiled member node returning call3114 (depth = 8)
  partcv[0] = 0;
  Object call3115 = callmethod(call3114, "new",
    1, partcv, params);
  gc_frame_end(callframe3112);
// compiled call node returning call3115 (depth = 7)
// compiled member node returning call3115 (depth = 6)
  *var_suggestion = call3115;
  if (call3115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3116 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3117 == NULL) {
    strlit3117 = alloc_String(")");
    gc_root(strlit3117);
  }
// compiled string node returning strlit3117 (depth = 6)
  gc_frame_newslot(strlit3117);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3117;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3118 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3116);
// compiled call node returning call3118 (depth = 5)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3119 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3120 == NULL) {
    strlit3120 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3120);
  }
// compiled string node returning strlit3120 (depth = 6)
  gc_frame_newslot(strlit3120);
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3121 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3122 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3121);
// compiled call node returning call3122 (depth = 7)
// compiled member node returning call3122 (depth = 6)
  gc_frame_newslot(call3122);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3125 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3124);
// compiled call node returning call3125 (depth = 8)
// compiled member node returning call3125 (depth = 7)
  int op_slot_right_3123 = gc_frame_newslot(call3125);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3128 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3127);
// compiled call node returning call3128 (depth = 8)
// compiled member node returning call3128 (depth = 7)
  int op_slot_left_3123 = gc_frame_newslot(call3128);
  params[0] = call3125;
  partcv[0] = 1;
  Object sum3129 = callmethod(call3128, "+", 1, partcv, params);
// compiled op node returning sum3129 (depth = 6)
  gc_frame_newslot(sum3129);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3120;
  params[1] = call3122;
  params[2] = sum3129;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3130 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3119);
// compiled call node returning call3130 (depth = 5)
    gc_frame_newslot(call3130);
    if3103 = call3130;
  } else {
  }
// compiled if node returning if3103 (depth = 4)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3131 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3132 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3131);
// compiled call node returning call3132 (depth = 5)
// compiled member node returning call3132 (depth = 4)
    gc_frame_newslot(call3132);
    if3059 = call3132;
  } else {
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3134 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3135 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3136 = alloc_Block(NULL, NULL, "parser", 981);
  gc_frame_newslot(block3136);
// method _apply
  block_savedest(block3136);
  Object closure3137 = createclosure(1, "_apply");
  setclosureframe(closure3137, stackframe);
  addtoclosure(closure3137, selfslot);
  struct UserObject *uo3137 = (struct UserObject*)block3136;
  uo3137->data[0] = (Object)closure3137;
  Method *meth_meth_parser__apply3137 = addmethod2pos(block3136, "_apply", &meth_parser__apply3137, 0);
  int argcv_meth_parser__apply3137[] = {0};
  meth_meth_parser__apply3137->type = alloc_MethodType(1, argcv_meth_parser__apply3137);
  meth_meth_parser__apply3137->definitionModule = modulename;
  meth_meth_parser__apply3137->definitionLine = 981;
// compiled block node returning block3136 (depth = 8)
  gc_frame_newslot(block3136);
// call case 4: self request
  params[0] = block3136;
  partcv[0] = 1;
  Object call3141 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3135);
// compiled call node returning call3141 (depth = 7)
  partcv[0] = 0;
  Object call3142 = callmethod(call3141, "not",
    1, partcv, params);
  gc_frame_end(callframe3134);
// compiled call node returning call3142 (depth = 6)
// compiled member node returning call3142 (depth = 5)
  Object if3133 = done;
  if (istrue(call3142)) {
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3143 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3144 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3145 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3144);
// compiled call node returning call3145 (depth = 9)
// compiled member node returning call3145 (depth = 8)
  partcv[0] = 0;
  Object call3146 = callmethod(call3145, "empty",
    1, partcv, params);
  gc_frame_end(callframe3143);
// compiled call node returning call3146 (depth = 7)
// compiled member node returning call3146 (depth = 6)
  *var_suggestions = call3146;
  if (call3146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3147 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3148 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3149 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3148);
// compiled call node returning call3149 (depth = 9)
// compiled member node returning call3149 (depth = 8)
  partcv[0] = 0;
  Object call3150 = callmethod(call3149, "new",
    1, partcv, params);
  gc_frame_end(callframe3147);
// compiled call node returning call3150 (depth = 7)
// compiled member node returning call3150 (depth = 6)
  *var_suggestion = call3150;
  if (call3150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3151 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3152 == NULL) {
    strlit3152 = alloc_String("rparen");
    gc_root(strlit3152);
  }
// compiled string node returning strlit3152 (depth = 7)
  gc_frame_newslot(strlit3152);
// call case 4: self request
  params[0] = strlit3152;
  partcv[0] = 1;
  Object call3153 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3151);
// compiled call node returning call3153 (depth = 6)
  *var_nextTok = call3153;
  if (call3153 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3155 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3155 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3157 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3157 (depth = 6)
  Object if3154 = done;
  if (istrue(opresult3157)) {
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3158 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3159 == NULL) {
    strlit3159 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3159);
  }
// compiled string node returning strlit3159 (depth = 7)
  gc_frame_newslot(strlit3159);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3159;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3160 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3158);
// compiled call node returning call3160 (depth = 6)
    gc_frame_newslot(call3160);
    if3154 = call3160;
  } else {
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3161 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3162 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3163 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3162);
// compiled call node returning call3163 (depth = 8)
// compiled member node returning call3163 (depth = 7)
  gc_frame_newslot(call3163);
// starting to compile identifier node (depth = 7)
  Object bool3164 = alloc_Boolean(1);
// compiled identifier node returning bool3164 (depth = 7)
  gc_frame_newslot(bool3164);
// starting to compile identifier node (depth = 7)
  Object bool3165 = alloc_Boolean(0);
// compiled identifier node returning bool3165 (depth = 7)
  gc_frame_newslot(bool3165);
// starting to compile string node (depth = 7)
  if (strlit3166 == NULL) {
    strlit3166 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3166);
  }
// compiled string node returning strlit3166 (depth = 7)
  gc_frame_newslot(strlit3166);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3163;
  params[2] = bool3164;
  params[3] = bool3165;
  params[4] = strlit3166;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3167 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3161);
// compiled call node returning call3167 (depth = 6)
    gc_frame_newslot(call3167);
    if3154 = call3167;
  }
// compiled if node returning if3154 (depth = 5)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3168 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3169 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3168);
// compiled call node returning call3169 (depth = 5)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3172 == NULL) {
    strlit3172 = alloc_String("bind");
    gc_root(strlit3172);
  }
// compiled string node returning strlit3172 (depth = 7)
  int op_slot_right_3171 = gc_frame_newslot(strlit3172);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3174 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3176 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3175);
// compiled call node returning call3176 (depth = 10)
// compiled member node returning call3176 (depth = 9)
  partcv[0] = 0;
  Object call3177 = callmethod(call3176, "kind",
    1, partcv, params);
  gc_frame_end(callframe3174);
// compiled call node returning call3177 (depth = 8)
// compiled member node returning call3177 (depth = 7)
  int op_slot_left_3171 = gc_frame_newslot(call3177);
  params[0] = strlit3172;
  partcv[0] = 1;
  Object opresult3178 = callmethod(call3177, "==", 1, partcv, params);
// compiled op node returning opresult3178 (depth = 6)
  Object if3170 = done;
  if (istrue(opresult3178)) {
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3179 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3181 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3180);
// compiled call node returning call3181 (depth = 10)
// compiled member node returning call3181 (depth = 9)
  partcv[0] = 0;
  Object call3182 = callmethod(call3181, "new",
    1, partcv, params);
  gc_frame_end(callframe3179);
// compiled call node returning call3182 (depth = 8)
// compiled member node returning call3182 (depth = 7)
  *var_suggestion = call3182;
  if (call3182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3184 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3186 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3185);
// compiled call node returning call3186 (depth = 8)
// compiled member node returning call3186 (depth = 7)
  gc_frame_newslot(call3186);
// starting to compile identifier node (depth = 7)
  Object bool3187 = alloc_Boolean(1);
// compiled identifier node returning bool3187 (depth = 7)
  gc_frame_newslot(bool3187);
// starting to compile identifier node (depth = 7)
  Object bool3188 = alloc_Boolean(0);
// compiled identifier node returning bool3188 (depth = 7)
  gc_frame_newslot(bool3188);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call3186;
  params[2] = bool3187;
  params[3] = bool3188;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3189 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3184);
// compiled call node returning call3189 (depth = 6)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3190 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3191 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3192 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3191);
// compiled call node returning call3192 (depth = 8)
// compiled member node returning call3192 (depth = 7)
  gc_frame_newslot(call3192);
// starting to compile identifier node (depth = 7)
  Object bool3193 = alloc_Boolean(1);
// compiled identifier node returning bool3193 (depth = 7)
  gc_frame_newslot(bool3193);
// starting to compile identifier node (depth = 7)
  Object bool3194 = alloc_Boolean(0);
// compiled identifier node returning bool3194 (depth = 7)
  gc_frame_newslot(bool3194);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call3192;
  params[1] = bool3193;
  params[2] = bool3194;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3195 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3190);
// compiled call node returning call3195 (depth = 6)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3196 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3197 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3196);
// compiled call node returning call3197 (depth = 6)
    gc_frame_newslot(call3197);
    if3170 = call3197;
  } else {
  }
// compiled if node returning if3170 (depth = 5)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3198 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3199 == NULL) {
    strlit3199 = alloc_String("A prefix operator must be followed by an expression.");
    gc_root(strlit3199);
  }
// compiled string node returning strlit3199 (depth = 6)
  gc_frame_newslot(strlit3199);
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3201 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3200);
// compiled call node returning call3201 (depth = 7)
// compiled member node returning call3201 (depth = 6)
  gc_frame_newslot(call3201);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3203 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3204 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3203);
// compiled call node returning call3204 (depth = 8)
// compiled member node returning call3204 (depth = 7)
  int op_slot_right_3202 = gc_frame_newslot(call3204);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3207 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3206);
// compiled call node returning call3207 (depth = 8)
// compiled member node returning call3207 (depth = 7)
  int op_slot_left_3202 = gc_frame_newslot(call3207);
  params[0] = call3204;
  partcv[0] = 1;
  Object sum3208 = callmethod(call3207, "+", 1, partcv, params);
// compiled op node returning sum3208 (depth = 6)
  gc_frame_newslot(sum3208);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3199;
  params[1] = call3201;
  params[2] = sum3208;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3209 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3198);
// compiled call node returning call3209 (depth = 5)
    gc_frame_newslot(call3209);
    if3133 = call3209;
  } else {
  }
// compiled if node returning if3133 (depth = 4)
    gc_frame_newslot(if3133);
    if3059 = if3133;
  }
// compiled if node returning if3059 (depth = 3)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3210 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3211 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3210);
// compiled call node returning call3211 (depth = 3)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3212 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3213 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3212);
// compiled call node returning call3213 (depth = 3)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3214 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3215 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3214);
// compiled call node returning call3215 (depth = 4)
// compiled member node returning call3215 (depth = 3)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3216 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3217 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3216);
// compiled call node returning call3217 (depth = 5)
// compiled member node returning call3217 (depth = 4)
  *var_val = call3217;
  if (call3217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3219 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_op (depth = 6)
  int op_slot_right_3220 = gc_frame_newslot(*var_op);
// starting to compile string node (depth = 6)
  if (strlit3222 == NULL) {
    strlit3222 = alloc_String("prefix");
    gc_root(strlit3222);
  }
// compiled string node returning strlit3222 (depth = 6)
  int op_slot_left_3220 = gc_frame_newslot(strlit3222);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult3223 = callmethod(strlit3222, "++", 1, partcv, params);
// compiled op node returning opresult3223 (depth = 5)
  gc_frame_newslot(opresult3223);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3224 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3225 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3224);
// compiled call node returning call3225 (depth = 6)
// compiled member node returning call3225 (depth = 5)
  params[0] = opresult3223;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call3226 = callmethod(call3225, "new",
    1, partcv, params);
  gc_frame_end(callframe3219);
// compiled call node returning call3226 (depth = 4)
  *var_mem = call3226;
  if (call3226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3227 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mem (depth = 5)
  gc_frame_newslot(*var_mem);
// starting to compile array node (depth = 5)
  Object array3228 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 6)
  int callframe3229 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mem (depth = 9)
  partcv[0] = 0;
  Object call3231 = callmethod(*var_mem, "value",
    1, partcv, params);
  gc_frame_end(callframe3230);
// compiled call node returning call3231 (depth = 8)
// compiled member node returning call3231 (depth = 7)
  gc_frame_newslot(call3231);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call3233 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe3232);
// compiled call node returning call3233 (depth = 8)
// compiled member node returning call3233 (depth = 7)
  params[0] = call3231;
  partcv[0] = 1;
  Object call3234 = callmethod(call3233, "new",
    1, partcv, params);
  gc_frame_end(callframe3229);
// compiled call node returning call3234 (depth = 6)
  params[0] = call3234;
  partcv[0] = 1;
  callmethod(array3228, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3228 (depth = 5)
  gc_frame_newslot(array3228);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3236 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe3235);
// compiled call node returning call3236 (depth = 6)
// compiled member node returning call3236 (depth = 5)
  params[0] = *var_mem;
  params[1] = array3228;
  partcv[0] = 2;
  Object call3237 = callmethod(call3236, "new",
    1, partcv, params);
  gc_frame_end(callframe3227);
// compiled call node returning call3237 (depth = 4)
  *var_call = call3237;
  if (call3237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3238 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call3239 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3238);
// compiled call node returning call3239 (depth = 3)
    gc_frame_newslot(call3239);
    if3051 = call3239;
  } else {
  }
// compiled if node returning if3051 (depth = 2)
  gc_frame_end(frame);
  return if3051;
}
Object meth_parser__apply3255(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe3256 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3257 == NULL) {
    strlit3257 = alloc_String("identifier");
    gc_root(strlit3257);
  }
// compiled string node returning strlit3257 (depth = 6)
  gc_frame_newslot(strlit3257);
// call case 4: self request
  params[0] = strlit3257;
  partcv[0] = 1;
  Object call3258 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3256);
// compiled call node returning call3258 (depth = 5)
  gc_frame_end(frame);
  return call3258;
}
Object meth_parser__apply3266(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3267 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3268 == NULL) {
    strlit3268 = alloc_String("dot");
    gc_root(strlit3268);
  }
// compiled string node returning strlit3268 (depth = 8)
  gc_frame_newslot(strlit3268);
// call case 4: self request
  params[0] = strlit3268;
  partcv[0] = 1;
  Object call3269 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3267);
// compiled call node returning call3269 (depth = 7)
  gc_frame_end(frame);
  return call3269;
}
Object meth_parser__apply3272(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
  Object *var_memberNd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "memberNd");
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3273 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3274 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3273);
// compiled call node returning call3274 (depth = 8)
// compiled member node returning call3274 (depth = 7)
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3276 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3275);
// compiled call node returning call3276 (depth = 9)
// compiled member node returning call3276 (depth = 8)
  *var_memberIn = call3276;
  if (call3276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3279 == NULL) {
    strlit3279 = alloc_String("identifier");
    gc_root(strlit3279);
  }
// compiled string node returning strlit3279 (depth = 9)
  int op_slot_right_3278 = gc_frame_newslot(strlit3279);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3282 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3281);
// compiled call node returning call3282 (depth = 10)
// compiled member node returning call3282 (depth = 9)
  int op_slot_left_3278 = gc_frame_newslot(call3282);
  params[0] = strlit3279;
  partcv[0] = 1;
  Object opresult3283 = callmethod(call3282, "!=", 1, partcv, params);
// compiled op node returning opresult3283 (depth = 8)
  Object if3277 = done;
  if (istrue(opresult3283)) {
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3284 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3285 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3286 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3285);
// compiled call node returning call3286 (depth = 12)
// compiled member node returning call3286 (depth = 11)
  partcv[0] = 0;
  Object call3287 = callmethod(call3286, "empty",
    1, partcv, params);
  gc_frame_end(callframe3284);
// compiled call node returning call3287 (depth = 10)
// compiled member node returning call3287 (depth = 9)
  *var_suggestions = call3287;
  if (call3287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3288 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3289 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3290 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3289);
// compiled call node returning call3290 (depth = 12)
// compiled member node returning call3290 (depth = 11)
  partcv[0] = 0;
  Object call3291 = callmethod(call3290, "new",
    1, partcv, params);
  gc_frame_end(callframe3288);
// compiled call node returning call3291 (depth = 10)
// compiled member node returning call3291 (depth = 9)
  *var_suggestion = call3291;
  if (call3291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3292 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3293 == NULL) {
    strlit3293 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3293);
  }
// compiled string node returning strlit3293 (depth = 9)
  gc_frame_newslot(strlit3293);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3293;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3294 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3292);
// compiled call node returning call3294 (depth = 8)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3295 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3296 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3295);
// compiled call node returning call3296 (depth = 8)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3297 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3299 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3298);
// compiled call node returning call3299 (depth = 12)
// compiled member node returning call3299 (depth = 11)
  partcv[0] = 0;
  Object call3300 = callmethod(call3299, "new",
    1, partcv, params);
  gc_frame_end(callframe3297);
// compiled call node returning call3300 (depth = 10)
// compiled member node returning call3300 (depth = 9)
  *var_suggestion = call3300;
  if (call3300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3302 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3303 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3302);
// compiled call node returning call3303 (depth = 8)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3304 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3305 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3304);
// compiled call node returning call3305 (depth = 8)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3306 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3307 == NULL) {
    strlit3307 = alloc_String("A type name must follow the '.'.");
    gc_root(strlit3307);
  }
// compiled string node returning strlit3307 (depth = 9)
  gc_frame_newslot(strlit3307);
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3309 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3308);
// compiled call node returning call3309 (depth = 10)
// compiled member node returning call3309 (depth = 9)
  gc_frame_newslot(call3309);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3311 = alloc_Float64(1);
// compiled num node returning num3311 (depth = 10)
  int op_slot_right_3310 = gc_frame_newslot(num3311);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call3314 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3313);
// compiled call node returning call3314 (depth = 11)
// compiled member node returning call3314 (depth = 10)
  int op_slot_left_3310 = gc_frame_newslot(call3314);
  params[0] = num3311;
  partcv[0] = 1;
  Object sum3315 = callmethod(call3314, "+", 1, partcv, params);
// compiled op node returning sum3315 (depth = 9)
  gc_frame_newslot(sum3315);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3307;
  params[1] = call3309;
  params[2] = sum3315;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3316 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3306);
// compiled call node returning call3316 (depth = 8)
    gc_frame_newslot(call3316);
    if3277 = call3316;
  } else {
  }
// compiled if node returning if3277 (depth = 7)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3317 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3318 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3317);
// compiled call node returning call3318 (depth = 8)
// compiled member node returning call3318 (depth = 7)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3320 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3319);
// compiled call node returning call3320 (depth = 9)
// compiled member node returning call3320 (depth = 8)
  *var_memberName = call3320;
  if (call3320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3321 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3322 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3323 = callmethod(*var_memberName, "value",
    1, partcv, params);
  gc_frame_end(callframe3322);
// compiled call node returning call3323 (depth = 10)
// compiled member node returning call3323 (depth = 9)
  gc_frame_newslot(call3323);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberIn (depth = 9)
  gc_frame_newslot(*var_memberIn);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ast (depth = 11)
  partcv[0] = 0;
  Object call3325 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3324);
// compiled call node returning call3325 (depth = 10)
// compiled member node returning call3325 (depth = 9)
  params[0] = call3323;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3326 = callmethod(call3325, "new",
    1, partcv, params);
  gc_frame_end(callframe3321);
// compiled call node returning call3326 (depth = 8)
  *var_memberNd = call3326;
  if (call3326 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3327 = gc_frame_new();
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3329 = callmethod(*var_memberName, "line",
    1, partcv, params);
  gc_frame_end(callframe3328);
// compiled call node returning call3329 (depth = 10)
// compiled member node returning call3329 (depth = 9)
  gc_frame_newslot(call3329);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberNd (depth = 9)
  params[0] = call3329;
  partcv[0] = 1;
  Object call3330 = callmethod(*var_memberNd, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3327);
// compiled call node returning call3330 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3331 = gc_frame_new();
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3333 = callmethod(*var_memberName, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3332);
// compiled call node returning call3333 (depth = 10)
// compiled member node returning call3333 (depth = 9)
  gc_frame_newslot(call3333);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberNd (depth = 9)
  params[0] = call3333;
  partcv[0] = 1;
  Object call3334 = callmethod(*var_memberNd, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe3331);
// compiled call node returning call3334 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3335 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  gc_frame_newslot(*var_memberNd);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_memberNd;
  partcv[0] = 1;
  Object call3336 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3335);
// compiled call node returning call3336 (depth = 7)
  gc_frame_end(frame);
  return call3336;
}
Object meth_parser__apply3261(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3262 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3263 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3262);
// compiled call node returning call3263 (depth = 6)
// compiled member node returning call3263 (depth = 5)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3264 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3265 = alloc_Block(NULL, NULL, "parser", 1019);
  gc_frame_newslot(block3265);
// method _apply
  block_savedest(block3265);
  Object closure3266 = createclosure(1, "_apply");
  setclosureframe(closure3266, stackframe);
  addtoclosure(closure3266, selfslot);
  struct UserObject *uo3266 = (struct UserObject*)block3265;
  uo3266->data[0] = (Object)closure3266;
  Method *meth_meth_parser__apply3266 = addmethod2pos(block3265, "_apply", &meth_parser__apply3266, 0);
  int argcv_meth_parser__apply3266[] = {0};
  meth_meth_parser__apply3266->type = alloc_MethodType(1, argcv_meth_parser__apply3266);
  meth_meth_parser__apply3266->definitionModule = modulename;
  meth_meth_parser__apply3266->definitionLine = 1018;
// compiled block node returning block3265 (depth = 6)
  gc_frame_newslot(block3265);
// starting to compile block node (depth = 6)
  Object block3271 = alloc_Block(NULL, NULL, "parser", 1019);
  gc_frame_newslot(block3271);
// method _apply
  block_savedest(block3271);
  Object closure3272 = createclosure(6, "_apply");
  setclosureframe(closure3272, stackframe);
  addtoclosure(closure3272, var_values);
  addtoclosure(closure3272, var_sym);
  addtoclosure(closure3272, var_errormessages);
  addtoclosure(closure3272, var_lastToken);
  addtoclosure(closure3272, var_ast);
  addtoclosure(closure3272, selfslot);
  struct UserObject *uo3272 = (struct UserObject*)block3271;
  uo3272->data[0] = (Object)closure3272;
  Method *meth_meth_parser__apply3272 = addmethod2pos(block3271, "_apply", &meth_parser__apply3272, 0);
  int argcv_meth_parser__apply3272[] = {0};
  meth_meth_parser__apply3272->type = alloc_MethodType(1, argcv_meth_parser__apply3272);
  meth_meth_parser__apply3272->definitionModule = modulename;
  meth_meth_parser__apply3272->definitionLine = 1018;
// compiled block node returning block3271 (depth = 6)
  gc_frame_newslot(block3271);
// call case 5: prelude request
  params[0] = block3265;
  params[1] = block3271;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3338 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3264);
// compiled call node returning call3338 (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3339 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3340 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3339);
// compiled call node returning call3340 (depth = 6)
// compiled member node returning call3340 (depth = 5)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3341 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3342 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call3343 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3342);
// compiled call node returning call3343 (depth = 7)
// compiled member node returning call3343 (depth = 6)
  gc_frame_newslot(call3343);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_gens (depth = 6)
  params[0] = call3343;
  partcv[0] = 1;
  Object call3344 = callmethod(*var_gens, "push",
    1, partcv, params);
  gc_frame_end(callframe3341);
// compiled call node returning call3344 (depth = 5)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3346 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3347 == NULL) {
    strlit3347 = alloc_String("comma");
    gc_root(strlit3347);
  }
// compiled string node returning strlit3347 (depth = 7)
  gc_frame_newslot(strlit3347);
// call case 4: self request
  params[0] = strlit3347;
  partcv[0] = 1;
  Object call3348 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3346);
// compiled call node returning call3348 (depth = 6)
  Object if3345 = done;
  if (istrue(call3348)) {
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3350 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3349);
// compiled call node returning call3350 (depth = 7)
// compiled member node returning call3350 (depth = 6)
    gc_frame_newslot(call3350);
    if3345 = call3350;
  } else {
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3353 == NULL) {
    strlit3353 = alloc_String("rgeneric");
    gc_root(strlit3353);
  }
// compiled string node returning strlit3353 (depth = 8)
  int op_slot_right_3352 = gc_frame_newslot(strlit3353);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3356 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3355);
// compiled call node returning call3356 (depth = 9)
// compiled member node returning call3356 (depth = 8)
  int op_slot_left_3352 = gc_frame_newslot(call3356);
  params[0] = strlit3353;
  partcv[0] = 1;
  Object opresult3357 = callmethod(call3356, "!=", 1, partcv, params);
// compiled op node returning opresult3357 (depth = 7)
  Object if3351 = done;
  if (istrue(opresult3357)) {
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3358 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3360 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3359);
// compiled call node returning call3360 (depth = 11)
// compiled member node returning call3360 (depth = 10)
  partcv[0] = 0;
  Object call3361 = callmethod(call3360, "new",
    1, partcv, params);
  gc_frame_end(callframe3358);
// compiled call node returning call3361 (depth = 9)
// compiled member node returning call3361 (depth = 8)
  *var_suggestion = call3361;
  if (call3361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3362 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3363 == NULL) {
    strlit3363 = alloc_String(">");
    gc_root(strlit3363);
  }
// compiled string node returning strlit3363 (depth = 8)
  gc_frame_newslot(strlit3363);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3363;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3364 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3362);
// compiled call node returning call3364 (depth = 7)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3365 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3367 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3366);
// compiled call node returning call3367 (depth = 11)
// compiled member node returning call3367 (depth = 10)
  partcv[0] = 0;
  Object call3368 = callmethod(call3367, "new",
    1, partcv, params);
  gc_frame_end(callframe3365);
// compiled call node returning call3368 (depth = 9)
// compiled member node returning call3368 (depth = 8)
  *var_suggestion2 = call3368;
  if (call3368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3369 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3370 == NULL) {
    strlit3370 = alloc_String(" ");
    gc_root(strlit3370);
  }
// compiled string node returning strlit3370 (depth = 8)
  gc_frame_newslot(strlit3370);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startToken (depth = 8)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion2 (depth = 8)
  params[0] = strlit3370;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3371 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3369);
// compiled call node returning call3371 (depth = 7)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array3372 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3372, "push", 1, partcv, params);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion2 (depth = 9)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3372, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3372 (depth = 8)
  *var_suggestions = array3372;
  if (array3372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3373 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3374 == NULL) {
    strlit3374 = alloc_String("A type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3374);
  }
// compiled string node returning strlit3374 (depth = 8)
  gc_frame_newslot(strlit3374);
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3376 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3375);
// compiled call node returning call3376 (depth = 9)
// compiled member node returning call3376 (depth = 8)
  gc_frame_newslot(call3376);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3378 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3379 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3378);
// compiled call node returning call3379 (depth = 10)
// compiled member node returning call3379 (depth = 9)
  int op_slot_right_3377 = gc_frame_newslot(call3379);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3382 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3381);
// compiled call node returning call3382 (depth = 10)
// compiled member node returning call3382 (depth = 9)
  int op_slot_left_3377 = gc_frame_newslot(call3382);
  params[0] = call3379;
  partcv[0] = 1;
  Object sum3383 = callmethod(call3382, "+", 1, partcv, params);
// compiled op node returning sum3383 (depth = 8)
  gc_frame_newslot(sum3383);
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3374;
  params[1] = call3376;
  params[2] = sum3383;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3384 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3373);
// compiled call node returning call3384 (depth = 7)
    gc_frame_newslot(call3384);
    if3351 = call3384;
  } else {
  }
// compiled if node returning if3351 (depth = 6)
    gc_frame_newslot(if3351);
    if3345 = if3351;
  }
// compiled if node returning if3345 (depth = 5)
  gc_frame_end(frame);
  return if3345;
}
Object meth_parser_generic3240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for generic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for generic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3242 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3243 == NULL) {
    strlit3243 = alloc_String("lgeneric");
    gc_root(strlit3243);
  }
// compiled string node returning strlit3243 (depth = 4)
  gc_frame_newslot(strlit3243);
// call case 4: self request
  params[0] = strlit3243;
  partcv[0] = 1;
  Object call3244 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3242);
// compiled call node returning call3244 (depth = 3)
  Object if3241 = done;
  if (istrue(call3244)) {
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3246 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3245);
// compiled call node returning call3246 (depth = 5)
// compiled member node returning call3246 (depth = 4)
  *var_id = call3246;
  if (call3246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3247 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3248 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3249 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3248);
// compiled call node returning call3249 (depth = 7)
// compiled member node returning call3249 (depth = 6)
  partcv[0] = 0;
  Object call3250 = callmethod(call3249, "empty",
    1, partcv, params);
  gc_frame_end(callframe3247);
// compiled call node returning call3250 (depth = 5)
// compiled member node returning call3250 (depth = 4)
  *var_gens = call3250;
  if (call3250 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3251 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3252 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3251);
// compiled call node returning call3252 (depth = 4)
// compiled member node returning call3252 (depth = 3)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3253 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3254 = alloc_Block(NULL, NULL, "parser", 1017);
  gc_frame_newslot(block3254);
// method _apply
  block_savedest(block3254);
  Object closure3255 = createclosure(1, "_apply");
  setclosureframe(closure3255, stackframe);
  addtoclosure(closure3255, selfslot);
  struct UserObject *uo3255 = (struct UserObject*)block3254;
  uo3255->data[0] = (Object)closure3255;
  Method *meth_meth_parser__apply3255 = addmethod2pos(block3254, "_apply", &meth_parser__apply3255, 0);
  int argcv_meth_parser__apply3255[] = {0};
  meth_meth_parser__apply3255->type = alloc_MethodType(1, argcv_meth_parser__apply3255);
  meth_meth_parser__apply3255->definitionModule = modulename;
  meth_meth_parser__apply3255->definitionLine = 1016;
// compiled block node returning block3254 (depth = 4)
  gc_frame_newslot(block3254);
// starting to compile block node (depth = 4)
  Object block3260 = alloc_Block(NULL, NULL, "parser", 1017);
  gc_frame_newslot(block3260);
// method _apply
  block_savedest(block3260);
  Object closure3261 = createclosure(8, "_apply");
  setclosureframe(closure3261, stackframe);
  addtoclosure(closure3261, var_values);
  addtoclosure(closure3261, var_sym);
  addtoclosure(closure3261, var_errormessages);
  addtoclosure(closure3261, var_lastToken);
  addtoclosure(closure3261, var_ast);
  addtoclosure(closure3261, var_gens);
  addtoclosure(closure3261, var_startToken);
  addtoclosure(closure3261, selfslot);
  struct UserObject *uo3261 = (struct UserObject*)block3260;
  uo3261->data[0] = (Object)closure3261;
  Method *meth_meth_parser__apply3261 = addmethod2pos(block3260, "_apply", &meth_parser__apply3261, 0);
  int argcv_meth_parser__apply3261[] = {0};
  meth_meth_parser__apply3261->type = alloc_MethodType(1, argcv_meth_parser__apply3261);
  meth_meth_parser__apply3261->definitionModule = modulename;
  meth_meth_parser__apply3261->definitionLine = 1016;
// compiled block node returning block3260 (depth = 4)
  gc_frame_newslot(block3260);
// call case 5: prelude request
  params[0] = block3254;
  params[1] = block3260;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3386 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3253);
// compiled call node returning call3386 (depth = 3)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3389 == NULL) {
    strlit3389 = alloc_String("rgeneric");
    gc_root(strlit3389);
  }
// compiled string node returning strlit3389 (depth = 5)
  int op_slot_right_3388 = gc_frame_newslot(strlit3389);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3391 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3392 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3391);
// compiled call node returning call3392 (depth = 6)
// compiled member node returning call3392 (depth = 5)
  int op_slot_left_3388 = gc_frame_newslot(call3392);
  params[0] = strlit3389;
  partcv[0] = 1;
  Object opresult3393 = callmethod(call3392, "!=", 1, partcv, params);
// compiled op node returning opresult3393 (depth = 4)
  Object if3387 = done;
  if (istrue(opresult3393)) {
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3394 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3396 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3395);
// compiled call node returning call3396 (depth = 8)
// compiled member node returning call3396 (depth = 7)
  partcv[0] = 0;
  Object call3397 = callmethod(call3396, "new",
    1, partcv, params);
  gc_frame_end(callframe3394);
// compiled call node returning call3397 (depth = 6)
// compiled member node returning call3397 (depth = 5)
  *var_suggestion = call3397;
  if (call3397 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3398 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3399 == NULL) {
    strlit3399 = alloc_String(">");
    gc_root(strlit3399);
  }
// compiled string node returning strlit3399 (depth = 5)
  gc_frame_newslot(strlit3399);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3399;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3400 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3398);
// compiled call node returning call3400 (depth = 4)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3401 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3403 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3402);
// compiled call node returning call3403 (depth = 8)
// compiled member node returning call3403 (depth = 7)
  partcv[0] = 0;
  Object call3404 = callmethod(call3403, "new",
    1, partcv, params);
  gc_frame_end(callframe3401);
// compiled call node returning call3404 (depth = 6)
// compiled member node returning call3404 (depth = 5)
  *var_suggestion2 = call3404;
  if (call3404 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3405 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3406 == NULL) {
    strlit3406 = alloc_String(" ");
    gc_root(strlit3406);
  }
// compiled string node returning strlit3406 (depth = 5)
  gc_frame_newslot(strlit3406);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3406;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3407 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3405);
// compiled call node returning call3407 (depth = 4)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array3408 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3408, "push", 1, partcv, params);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3408, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3408 (depth = 5)
  *var_suggestions = array3408;
  if (array3408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3409 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3410 == NULL) {
    strlit3410 = alloc_String("A type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3410);
  }
// compiled string node returning strlit3410 (depth = 5)
  gc_frame_newslot(strlit3410);
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3411 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3412 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3411);
// compiled call node returning call3412 (depth = 6)
// compiled member node returning call3412 (depth = 5)
  gc_frame_newslot(call3412);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3415 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3414);
// compiled call node returning call3415 (depth = 7)
// compiled member node returning call3415 (depth = 6)
  int op_slot_right_3413 = gc_frame_newslot(call3415);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3418 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3417);
// compiled call node returning call3418 (depth = 7)
// compiled member node returning call3418 (depth = 6)
  int op_slot_left_3413 = gc_frame_newslot(call3418);
  params[0] = call3415;
  partcv[0] = 1;
  Object sum3419 = callmethod(call3418, "+", 1, partcv, params);
// compiled op node returning sum3419 (depth = 5)
  gc_frame_newslot(sum3419);
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3410;
  params[1] = call3412;
  params[2] = sum3419;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3420 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3409);
// compiled call node returning call3420 (depth = 4)
    gc_frame_newslot(call3420);
    if3387 = call3420;
  } else {
  }
// compiled if node returning if3387 (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3422 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3421);
// compiled call node returning call3422 (depth = 4)
// compiled member node returning call3422 (depth = 3)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3423 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3424 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3425 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3426 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe3425);
// compiled call node returning call3426 (depth = 6)
// compiled member node returning call3426 (depth = 5)
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3427 = callmethod(call3426, "new",
    1, partcv, params);
  gc_frame_end(callframe3424);
// compiled call node returning call3427 (depth = 4)
  gc_frame_newslot(call3427);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call3427;
  partcv[0] = 1;
  Object call3428 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3423);
// compiled call node returning call3428 (depth = 3)
    gc_frame_newslot(call3428);
    if3241 = call3428;
  } else {
  }
// compiled if node returning if3241 (depth = 2)
  gc_frame_end(frame);
  return if3241;
}
Object meth_parser__apply3467(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3471 == NULL) {
    strlit3471 = alloc_String("catch");
    gc_root(strlit3471);
  }
// compiled string node returning strlit3471 (depth = 10)
  int op_slot_right_3470 = gc_frame_newslot(strlit3471);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3474 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe3473);
// compiled call node returning call3474 (depth = 11)
// compiled member node returning call3474 (depth = 10)
  int op_slot_left_3470 = gc_frame_newslot(call3474);
  params[0] = strlit3471;
  partcv[0] = 1;
  Object opresult3475 = callmethod(call3474, "==", 1, partcv, params);
// compiled op node returning opresult3475 (depth = 9)
  int op_slot_right_3469 = gc_frame_newslot(opresult3475);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("identifier");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 10)
  int op_slot_right_3477 = gc_frame_newslot(strlit3478);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3481 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 11)
// compiled member node returning call3481 (depth = 10)
  int op_slot_left_3477 = gc_frame_newslot(call3481);
  params[0] = strlit3478;
  partcv[0] = 1;
  Object opresult3482 = callmethod(call3481, "==", 1, partcv, params);
// compiled op node returning opresult3482 (depth = 9)
  int op_slot_left_3469 = gc_frame_newslot(opresult3482);
  params[0] = opresult3475;
  partcv[0] = 1;
  Object opresult3483 = callmethod(opresult3482, "&&", 1, partcv, params);
// compiled op node returning opresult3483 (depth = 8)
  int op_slot_right_3468 = gc_frame_newslot(opresult3483);
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_catchTok (depth = 13)
  partcv[0] = 0;
  Object call3489 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3488);
// compiled call node returning call3489 (depth = 12)
// compiled member node returning call3489 (depth = 11)
  int op_slot_right_3487 = gc_frame_newslot(call3489);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3491 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3492 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe3491);
// compiled call node returning call3492 (depth = 12)
// compiled member node returning call3492 (depth = 11)
  int op_slot_left_3487 = gc_frame_newslot(call3492);
  params[0] = call3489;
  partcv[0] = 1;
  Object opresult3493 = callmethod(call3492, "==", 1, partcv, params);
// compiled op node returning opresult3493 (depth = 10)
  int op_slot_right_3486 = gc_frame_newslot(opresult3493);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3496 == NULL) {
    strlit3496 = alloc_String("rparen");
    gc_root(strlit3496);
  }
// compiled string node returning strlit3496 (depth = 11)
  int op_slot_right_3495 = gc_frame_newslot(strlit3496);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3499 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3498);
// compiled call node returning call3499 (depth = 12)
// compiled member node returning call3499 (depth = 11)
  int op_slot_left_3495 = gc_frame_newslot(call3499);
  params[0] = strlit3496;
  partcv[0] = 1;
  Object opresult3500 = callmethod(call3499, "==", 1, partcv, params);
// compiled op node returning opresult3500 (depth = 10)
  int op_slot_left_3486 = gc_frame_newslot(opresult3500);
  params[0] = opresult3493;
  partcv[0] = 1;
  Object opresult3501 = callmethod(opresult3500, "&&", 1, partcv, params);
// compiled op node returning opresult3501 (depth = 9)
  int op_slot_right_3485 = gc_frame_newslot(opresult3501);
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3504 == NULL) {
    strlit3504 = alloc_String("rbrace");
    gc_root(strlit3504);
  }
// compiled string node returning strlit3504 (depth = 10)
  int op_slot_right_3503 = gc_frame_newslot(strlit3504);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3507 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3506);
// compiled call node returning call3507 (depth = 11)
// compiled member node returning call3507 (depth = 10)
  int op_slot_left_3503 = gc_frame_newslot(call3507);
  params[0] = strlit3504;
  partcv[0] = 1;
  Object opresult3508 = callmethod(call3507, "==", 1, partcv, params);
// compiled op node returning opresult3508 (depth = 9)
  int op_slot_left_3485 = gc_frame_newslot(opresult3508);
  params[0] = opresult3501;
  partcv[0] = 1;
  Object opresult3509 = callmethod(opresult3508, "||", 1, partcv, params);
// compiled op node returning opresult3509 (depth = 8)
  int op_slot_left_3468 = gc_frame_newslot(opresult3509);
  params[0] = opresult3483;
  partcv[0] = 1;
  Object opresult3510 = callmethod(opresult3509, "||", 1, partcv, params);
// compiled op node returning opresult3510 (depth = 7)
  gc_frame_end(frame);
  return opresult3510;
}
Object meth_parser__apply3585(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe3586 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3587 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3586);
// compiled call node returning call3587 (depth = 8)
  gc_frame_end(frame);
  return call3587;
}
Object meth_parser__apply3655(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3658 == NULL) {
    strlit3658 = alloc_String("catch");
    gc_root(strlit3658);
  }
// compiled string node returning strlit3658 (depth = 6)
  int op_slot_right_3657 = gc_frame_newslot(strlit3658);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3661 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3660);
// compiled call node returning call3661 (depth = 7)
// compiled member node returning call3661 (depth = 6)
  int op_slot_left_3657 = gc_frame_newslot(call3661);
  params[0] = strlit3658;
  partcv[0] = 1;
  Object opresult3662 = callmethod(call3661, "==", 1, partcv, params);
// compiled op node returning opresult3662 (depth = 5)
  int op_slot_right_3656 = gc_frame_newslot(opresult3662);
// starting to compile call node (depth = 5)
  int callframe3664 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3665 == NULL) {
    strlit3665 = alloc_String("identifier");
    gc_root(strlit3665);
  }
// compiled string node returning strlit3665 (depth = 6)
  gc_frame_newslot(strlit3665);
// call case 4: self request
  params[0] = strlit3665;
  partcv[0] = 1;
  Object call3666 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3664);
// compiled call node returning call3666 (depth = 5)
  int op_slot_left_3656 = gc_frame_newslot(call3666);
  params[0] = opresult3662;
  partcv[0] = 1;
  Object opresult3667 = callmethod(call3666, "&&", 1, partcv, params);
// compiled op node returning opresult3667 (depth = 4)
  gc_frame_end(frame);
  return opresult3667;
}
Object meth_parser__apply3689(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe3690 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3691 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3690);
// compiled call node returning call3691 (depth = 11)
  gc_frame_end(frame);
  return call3691;
}
Object meth_parser__apply3670(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3671 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3672 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3671);
// compiled call node returning call3672 (depth = 5)
// compiled member node returning call3672 (depth = 4)
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3674 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3675 == NULL) {
    strlit3675 = alloc_String("lbrace");
    gc_root(strlit3675);
  }
// compiled string node returning strlit3675 (depth = 6)
  gc_frame_newslot(strlit3675);
// call case 4: self request
  params[0] = strlit3675;
  partcv[0] = 1;
  Object call3676 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3674);
// compiled call node returning call3676 (depth = 5)
  Object if3673 = done;
  if (istrue(call3676)) {
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3677 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3678 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3677);
// compiled call node returning call3678 (depth = 6)
// compiled member node returning call3678 (depth = 5)
    gc_frame_newslot(call3678);
    if3673 = call3678;
  } else {
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3680 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3681 == NULL) {
    strlit3681 = alloc_String("lparen");
    gc_root(strlit3681);
  }
// compiled string node returning strlit3681 (depth = 7)
  gc_frame_newslot(strlit3681);
// call case 4: self request
  params[0] = strlit3681;
  partcv[0] = 1;
  Object call3682 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3680);
// compiled call node returning call3682 (depth = 6)
  Object if3679 = done;
  if (istrue(call3682)) {
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3683 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3684 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3683);
// compiled call node returning call3684 (depth = 7)
// compiled member node returning call3684 (depth = 6)
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3686 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe3687 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block3688 = alloc_Block(NULL, NULL, "parser", 1134);
  gc_frame_newslot(block3688);
// method _apply
  block_savedest(block3688);
  Object closure3689 = createclosure(2, "_apply");
  setclosureframe(closure3689, stackframe);
  addtoclosure(closure3689, var_blocksOK);
  addtoclosure(closure3689, selfslot);
  struct UserObject *uo3689 = (struct UserObject*)block3688;
  uo3689->data[0] = (Object)closure3689;
  Method *meth_meth_parser__apply3689 = addmethod2pos(block3688, "_apply", &meth_parser__apply3689, 0);
  int argcv_meth_parser__apply3689[] = {0};
  meth_meth_parser__apply3689->type = alloc_MethodType(1, argcv_meth_parser__apply3689);
  meth_meth_parser__apply3689->definitionModule = modulename;
  meth_meth_parser__apply3689->definitionLine = 1134;
// compiled block node returning block3688 (depth = 10)
  gc_frame_newslot(block3688);
// call case 4: self request
  params[0] = block3688;
  partcv[0] = 1;
  Object call3693 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3687);
// compiled call node returning call3693 (depth = 9)
  partcv[0] = 0;
  Object call3694 = callmethod(call3693, "not",
    1, partcv, params);
  gc_frame_end(callframe3686);
// compiled call node returning call3694 (depth = 8)
// compiled member node returning call3694 (depth = 7)
  Object if3685 = done;
  if (istrue(call3694)) {
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3695 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3697 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3696);
// compiled call node returning call3697 (depth = 11)
// compiled member node returning call3697 (depth = 10)
  partcv[0] = 0;
  Object call3698 = callmethod(call3697, "new",
    1, partcv, params);
  gc_frame_end(callframe3695);
// compiled call node returning call3698 (depth = 9)
// compiled member node returning call3698 (depth = 8)
  *var_suggestion = call3698;
  if (call3698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3699 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3700 == NULL) {
    strlit3700 = alloc_String("rparen");
    gc_root(strlit3700);
  }
// compiled string node returning strlit3700 (depth = 9)
  gc_frame_newslot(strlit3700);
// call case 4: self request
  params[0] = strlit3700;
  partcv[0] = 1;
  Object call3701 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3699);
// compiled call node returning call3701 (depth = 8)
  *var_nextTok = call3701;
  if (call3701 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3703 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3703 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3705 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3705 (depth = 8)
  Object if3702 = done;
  if (istrue(opresult3705)) {
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3706 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3707 == NULL) {
    strlit3707 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3707);
  }
// compiled string node returning strlit3707 (depth = 9)
  gc_frame_newslot(strlit3707);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3707;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3708 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3706);
// compiled call node returning call3708 (depth = 8)
    gc_frame_newslot(call3708);
    if3702 = call3708;
  } else {
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3709 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3711 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3710);
// compiled call node returning call3711 (depth = 10)
// compiled member node returning call3711 (depth = 9)
  gc_frame_newslot(call3711);
// starting to compile identifier node (depth = 9)
  Object bool3712 = alloc_Boolean(1);
// compiled identifier node returning bool3712 (depth = 9)
  gc_frame_newslot(bool3712);
// starting to compile identifier node (depth = 9)
  Object bool3713 = alloc_Boolean(0);
// compiled identifier node returning bool3713 (depth = 9)
  gc_frame_newslot(bool3713);
// starting to compile string node (depth = 9)
  if (strlit3714 == NULL) {
    strlit3714 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3714);
  }
// compiled string node returning strlit3714 (depth = 9)
  gc_frame_newslot(strlit3714);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call3711;
  params[2] = bool3712;
  params[3] = bool3713;
  params[4] = strlit3714;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3715 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3709);
// compiled call node returning call3715 (depth = 8)
    gc_frame_newslot(call3715);
    if3702 = call3715;
  }
// compiled if node returning if3702 (depth = 7)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3716 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3717 == NULL) {
    strlit3717 = alloc_String("A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3717);
  }
// compiled string node returning strlit3717 (depth = 8)
  gc_frame_newslot(strlit3717);
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3719 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3718);
// compiled call node returning call3719 (depth = 9)
// compiled member node returning call3719 (depth = 8)
  gc_frame_newslot(call3719);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3720 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3721 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3720);
// compiled call node returning call3721 (depth = 9)
// compiled member node returning call3721 (depth = 8)
  gc_frame_newslot(call3721);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3717;
  params[1] = call3719;
  params[2] = call3721;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3722 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3716);
// compiled call node returning call3722 (depth = 7)
    gc_frame_newslot(call3722);
    if3685 = call3722;
  } else {
  }
// compiled if node returning if3685 (depth = 6)
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3725 == NULL) {
    strlit3725 = alloc_String("rparen");
    gc_root(strlit3725);
  }
// compiled string node returning strlit3725 (depth = 8)
  int op_slot_right_3724 = gc_frame_newslot(strlit3725);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3728 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3727);
// compiled call node returning call3728 (depth = 9)
// compiled member node returning call3728 (depth = 8)
  int op_slot_left_3724 = gc_frame_newslot(call3728);
  params[0] = strlit3725;
  partcv[0] = 1;
  Object opresult3729 = callmethod(call3728, "!=", 1, partcv, params);
// compiled op node returning opresult3729 (depth = 7)
  Object if3723 = done;
  if (istrue(opresult3729)) {
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3730 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3731 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3730);
// compiled call node returning call3731 (depth = 8)
// compiled member node returning call3731 (depth = 7)
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3732 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3734 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3733);
// compiled call node returning call3734 (depth = 11)
// compiled member node returning call3734 (depth = 10)
  partcv[0] = 0;
  Object call3735 = callmethod(call3734, "new",
    1, partcv, params);
  gc_frame_end(callframe3732);
// compiled call node returning call3735 (depth = 9)
// compiled member node returning call3735 (depth = 8)
  *var_suggestion = call3735;
  if (call3735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3736 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3737 == NULL) {
    strlit3737 = alloc_String(")");
    gc_root(strlit3737);
  }
// compiled string node returning strlit3737 (depth = 8)
  gc_frame_newslot(strlit3737);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3737;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3738 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3736);
// compiled call node returning call3738 (depth = 7)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3739 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3740 == NULL) {
    strlit3740 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3740);
  }
// compiled string node returning strlit3740 (depth = 8)
  gc_frame_newslot(strlit3740);
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3741 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3742 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3741);
// compiled call node returning call3742 (depth = 9)
// compiled member node returning call3742 (depth = 8)
  gc_frame_newslot(call3742);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3745 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3744);
// compiled call node returning call3745 (depth = 10)
// compiled member node returning call3745 (depth = 9)
  int op_slot_right_3743 = gc_frame_newslot(call3745);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3747 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3748 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3747);
// compiled call node returning call3748 (depth = 10)
// compiled member node returning call3748 (depth = 9)
  int op_slot_left_3743 = gc_frame_newslot(call3748);
  params[0] = call3745;
  partcv[0] = 1;
  Object sum3749 = callmethod(call3748, "+", 1, partcv, params);
// compiled op node returning sum3749 (depth = 8)
  gc_frame_newslot(sum3749);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3740;
  params[1] = call3742;
  params[2] = sum3749;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3750 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3739);
// compiled call node returning call3750 (depth = 7)
    gc_frame_newslot(call3750);
    if3723 = call3750;
  } else {
  }
// compiled if node returning if3723 (depth = 6)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3751 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3752 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3751);
// compiled call node returning call3752 (depth = 7)
// compiled member node returning call3752 (depth = 6)
    gc_frame_newslot(call3752);
    if3679 = call3752;
  } else {
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3753 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3754 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3755 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3754);
// compiled call node returning call3755 (depth = 10)
// compiled member node returning call3755 (depth = 9)
  partcv[0] = 0;
  Object call3756 = callmethod(call3755, "empty",
    1, partcv, params);
  gc_frame_end(callframe3753);
// compiled call node returning call3756 (depth = 8)
// compiled member node returning call3756 (depth = 7)
  *var_suggestions = call3756;
  if (call3756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3757 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3758 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3757);
// compiled call node returning call3758 (depth = 7)
  *var_nextTok = call3758;
  if (call3758 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3759 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3760 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3761 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3760);
// compiled call node returning call3761 (depth = 10)
// compiled member node returning call3761 (depth = 9)
  partcv[0] = 0;
  Object call3762 = callmethod(call3761, "new",
    1, partcv, params);
  gc_frame_end(callframe3759);
// compiled call node returning call3762 (depth = 8)
// compiled member node returning call3762 (depth = 7)
  *var_suggestion = call3762;
  if (call3762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3765 = alloc_Boolean(0);
// compiled identifier node returning bool3765 (depth = 8)
  int op_slot_right_3764 = gc_frame_newslot(bool3765);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3764 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3765;
  partcv[0] = 1;
  Object opresult3767 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3767 (depth = 7)
  Object if3763 = done;
  if (istrue(opresult3767)) {
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3768 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3769 == NULL) {
    strlit3769 = alloc_String(" }");
    gc_root(strlit3769);
  }
// compiled string node returning strlit3769 (depth = 8)
  gc_frame_newslot(strlit3769);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3770 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call3771 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe3770);
// compiled call node returning call3771 (depth = 9)
// compiled member node returning call3771 (depth = 8)
  gc_frame_newslot(call3771);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3769;
  params[1] = call3771;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3772 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3768);
// compiled call node returning call3772 (depth = 7)
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3773 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3774 == NULL) {
    strlit3774 = alloc_String(" {");
    gc_root(strlit3774);
  }
// compiled string node returning strlit3774 (depth = 8)
  gc_frame_newslot(strlit3774);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3774;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3775 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3773);
// compiled call node returning call3775 (depth = 7)
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3776 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3777 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3776);
// compiled call node returning call3777 (depth = 7)
    gc_frame_newslot(call3777);
    if3763 = call3777;
  } else {
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3779 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3779 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3781 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3781 (depth = 8)
  Object if3778 = done;
  if (istrue(opresult3781)) {
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3782 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3783 == NULL) {
    strlit3783 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3783);
  }
// compiled string node returning strlit3783 (depth = 9)
  gc_frame_newslot(strlit3783);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3783;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3784 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3782);
// compiled call node returning call3784 (depth = 8)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3785 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3786 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3785);
// compiled call node returning call3786 (depth = 8)
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3787 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3789 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3788);
// compiled call node returning call3789 (depth = 12)
// compiled member node returning call3789 (depth = 11)
  partcv[0] = 0;
  Object call3790 = callmethod(call3789, "new",
    1, partcv, params);
  gc_frame_end(callframe3787);
// compiled call node returning call3790 (depth = 10)
// compiled member node returning call3790 (depth = 9)
  *var_suggestion = call3790;
  if (call3790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3792 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3793 == NULL) {
    strlit3793 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit3793);
  }
// compiled string node returning strlit3793 (depth = 9)
  gc_frame_newslot(strlit3793);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3793;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3794 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3792);
// compiled call node returning call3794 (depth = 8)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3795 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3796 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3795);
// compiled call node returning call3796 (depth = 8)
    gc_frame_newslot(call3796);
    if3778 = call3796;
  } else {
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3797 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3798 == NULL) {
    strlit3798 = alloc_String(" }");
    gc_root(strlit3798);
  }
// compiled string node returning strlit3798 (depth = 9)
  gc_frame_newslot(strlit3798);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3799 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3800 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3799);
// compiled call node returning call3800 (depth = 10)
// compiled member node returning call3800 (depth = 9)
  gc_frame_newslot(call3800);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3798;
  params[1] = call3800;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3801 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3797);
// compiled call node returning call3801 (depth = 8)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3802 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3803 == NULL) {
    strlit3803 = alloc_String(" {");
    gc_root(strlit3803);
  }
// compiled string node returning strlit3803 (depth = 9)
  gc_frame_newslot(strlit3803);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3803;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3804 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3802);
// compiled call node returning call3804 (depth = 8)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3805 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3806 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3805);
// compiled call node returning call3806 (depth = 8)
    gc_frame_newslot(call3806);
    if3778 = call3806;
  }
// compiled if node returning if3778 (depth = 7)
    gc_frame_newslot(if3778);
    if3763 = if3778;
  }
// compiled if node returning if3763 (depth = 6)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3807 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3808 == NULL) {
    strlit3808 = alloc_String("A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3808);
  }
// compiled string node returning strlit3808 (depth = 7)
  gc_frame_newslot(strlit3808);
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3810 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3809);
// compiled call node returning call3810 (depth = 8)
// compiled member node returning call3810 (depth = 7)
  gc_frame_newslot(call3810);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3811 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3812 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3811);
// compiled call node returning call3812 (depth = 8)
// compiled member node returning call3812 (depth = 7)
  gc_frame_newslot(call3812);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3808;
  params[1] = call3810;
  params[2] = call3812;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3813 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3807);
// compiled call node returning call3813 (depth = 6)
    gc_frame_newslot(call3813);
    if3679 = call3813;
  }
// compiled if node returning if3679 (depth = 5)
    gc_frame_newslot(if3679);
    if3673 = if3679;
  }
// compiled if node returning if3673 (depth = 4)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3814 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3815 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call3816 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3815);
// compiled call node returning call3816 (depth = 6)
// compiled member node returning call3816 (depth = 5)
  gc_frame_newslot(call3816);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call3816;
  partcv[0] = 1;
  Object call3817 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe3814);
// compiled call node returning call3817 (depth = 4)
  gc_frame_end(frame);
  return call3817;
}
Object meth_parser__apply3892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe3893 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3894 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3893);
// compiled call node returning call3894 (depth = 10)
  gc_frame_end(frame);
  return call3894;
}
Object meth_parser_trycatch3429(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trycatch (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trycatch");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3431 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3434 == NULL) {
    strlit3434 = alloc_String("try");
    gc_root(strlit3434);
  }
// compiled string node returning strlit3434 (depth = 6)
  int op_slot_right_3433 = gc_frame_newslot(strlit3434);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3436 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3437 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3436);
// compiled call node returning call3437 (depth = 7)
// compiled member node returning call3437 (depth = 6)
  int op_slot_left_3433 = gc_frame_newslot(call3437);
  params[0] = strlit3434;
  partcv[0] = 1;
  Object opresult3438 = callmethod(call3437, "==", 1, partcv, params);
// compiled op node returning opresult3438 (depth = 5)
  int op_slot_right_3432 = gc_frame_newslot(opresult3438);
// starting to compile call node (depth = 5)
  int callframe3440 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3441 == NULL) {
    strlit3441 = alloc_String("identifier");
    gc_root(strlit3441);
  }
// compiled string node returning strlit3441 (depth = 6)
  gc_frame_newslot(strlit3441);
// call case 4: self request
  params[0] = strlit3441;
  partcv[0] = 1;
  Object call3442 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3440);
// compiled call node returning call3442 (depth = 5)
  int op_slot_left_3432 = gc_frame_newslot(call3442);
  params[0] = opresult3438;
  partcv[0] = 1;
  Object opresult3443 = callmethod(call3442, "&&", 1, partcv, params);
// compiled op node returning opresult3443 (depth = 4)
  partcv[0] = 0;
  Object call3444 = callmethod(opresult3443, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3431);
// compiled call node returning call3444 (depth = 3)
  Object if3430 = done;
  if (istrue(call3444)) {
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3445 = alloc_Float64(0);
// compiled num node returning num3445 (depth = 4)
  return num3445;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3430 = undefined;
  } else {
  }
// compiled if node returning if3430 (depth = 2)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3446 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3447 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compiled call node returning call3447 (depth = 3)
// compiled member node returning call3447 (depth = 2)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3449 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3450 == NULL) {
    strlit3450 = alloc_String("lbrace");
    gc_root(strlit3450);
  }
// compiled string node returning strlit3450 (depth = 4)
  gc_frame_newslot(strlit3450);
// call case 4: self request
  params[0] = strlit3450;
  partcv[0] = 1;
  Object call3451 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3449);
// compiled call node returning call3451 (depth = 3)
  Object if3448 = done;
  if (istrue(call3451)) {
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3452 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3453 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3452);
// compiled call node returning call3453 (depth = 4)
// compiled member node returning call3453 (depth = 3)
    gc_frame_newslot(call3453);
    if3448 = call3453;
  } else {
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3456 == NULL) {
    strlit3456 = alloc_String("lparen");
    gc_root(strlit3456);
  }
// compiled string node returning strlit3456 (depth = 5)
  int op_slot_right_3455 = gc_frame_newslot(strlit3456);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3459 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3458);
// compiled call node returning call3459 (depth = 6)
// compiled member node returning call3459 (depth = 5)
  int op_slot_left_3455 = gc_frame_newslot(call3459);
  params[0] = strlit3456;
  partcv[0] = 1;
  Object opresult3460 = callmethod(call3459, "!=", 1, partcv, params);
// compiled op node returning opresult3460 (depth = 4)
  Object if3454 = done;
  if (istrue(opresult3460)) {
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3461 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3462 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3463 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3462);
// compiled call node returning call3463 (depth = 8)
// compiled member node returning call3463 (depth = 7)
  partcv[0] = 0;
  Object call3464 = callmethod(call3463, "new",
    1, partcv, params);
  gc_frame_end(callframe3461);
// compiled call node returning call3464 (depth = 6)
// compiled member node returning call3464 (depth = 5)
  *var_suggestion = call3464;
  if (call3464 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3465 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3466 = alloc_Block(NULL, NULL, "parser", 1084);
  gc_frame_newslot(block3466);
// method _apply
  block_savedest(block3466);
  Object closure3467 = createclosure(2, "_apply");
  setclosureframe(closure3467, stackframe);
  addtoclosure(closure3467, var_catchTok);
  addtoclosure(closure3467, selfslot);
  struct UserObject *uo3467 = (struct UserObject*)block3466;
  uo3467->data[0] = (Object)closure3467;
  Method *meth_meth_parser__apply3467 = addmethod2pos(block3466, "_apply", &meth_parser__apply3467, 0);
  int argcv_meth_parser__apply3467[] = {1};
  meth_meth_parser__apply3467->type = alloc_MethodType(1, argcv_meth_parser__apply3467);
  meth_meth_parser__apply3467->definitionModule = modulename;
  meth_meth_parser__apply3467->definitionLine = 1082;
// compiled block node returning block3466 (depth = 6)
  gc_frame_newslot(block3466);
// call case 4: self request
  params[0] = block3466;
  partcv[0] = 1;
  Object call3512 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3465);
// compiled call node returning call3512 (depth = 5)
  *var_nextTok = call3512;
  if (call3512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3515 = alloc_Boolean(0);
// compiled identifier node returning bool3515 (depth = 6)
  int op_slot_right_3514 = gc_frame_newslot(bool3515);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3514 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3515;
  partcv[0] = 1;
  Object opresult3517 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3517 (depth = 5)
  Object if3513 = done;
  if (istrue(opresult3517)) {
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3518 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3519 == NULL) {
    strlit3519 = alloc_String(" {}");
    gc_root(strlit3519);
  }
// compiled string node returning strlit3519 (depth = 6)
  gc_frame_newslot(strlit3519);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3519;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3520 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3518);
// compiled call node returning call3520 (depth = 5)
    gc_frame_newslot(call3520);
    if3513 = call3520;
  } else {
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3523 == NULL) {
    strlit3523 = alloc_String("rbrace");
    gc_root(strlit3523);
  }
// compiled string node returning strlit3523 (depth = 7)
  int op_slot_right_3522 = gc_frame_newslot(strlit3523);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3526 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3525);
// compiled call node returning call3526 (depth = 8)
// compiled member node returning call3526 (depth = 7)
  int op_slot_left_3522 = gc_frame_newslot(call3526);
  params[0] = strlit3523;
  partcv[0] = 1;
  Object opresult3527 = callmethod(call3526, "==", 1, partcv, params);
// compiled op node returning opresult3527 (depth = 6)
  Object if3521 = done;
  if (istrue(opresult3527)) {
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3528 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3529 == NULL) {
    strlit3529 = alloc_String(" {");
    gc_root(strlit3529);
  }
// compiled string node returning strlit3529 (depth = 7)
  gc_frame_newslot(strlit3529);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3529;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3530 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3528);
// compiled call node returning call3530 (depth = 6)
    gc_frame_newslot(call3530);
    if3521 = call3530;
  } else {
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3533 == NULL) {
    strlit3533 = alloc_String("rparen");
    gc_root(strlit3533);
  }
// compiled string node returning strlit3533 (depth = 8)
  int op_slot_right_3532 = gc_frame_newslot(strlit3533);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3536 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3535);
// compiled call node returning call3536 (depth = 9)
// compiled member node returning call3536 (depth = 8)
  int op_slot_left_3532 = gc_frame_newslot(call3536);
  params[0] = strlit3533;
  partcv[0] = 1;
  Object opresult3537 = callmethod(call3536, "==", 1, partcv, params);
// compiled op node returning opresult3537 (depth = 7)
  Object if3531 = done;
  if (istrue(opresult3537)) {
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3539 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3539 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3541 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3541 (depth = 8)
  Object if3538 = done;
  if (istrue(opresult3541)) {
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3542 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3543 == NULL) {
    strlit3543 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3543);
  }
// compiled string node returning strlit3543 (depth = 9)
  gc_frame_newslot(strlit3543);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3544 = alloc_Boolean(1);
// compiled identifier node returning bool3544 (depth = 9)
  gc_frame_newslot(bool3544);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3543;
  params[1] = *var_lastToken;
  params[2] = bool3544;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3545 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3542);
// compiled call node returning call3545 (depth = 8)
    gc_frame_newslot(call3545);
    if3538 = call3545;
  } else {
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3546 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3547 == NULL) {
    strlit3547 = alloc_String("(");
    gc_root(strlit3547);
  }
// compiled string node returning strlit3547 (depth = 9)
  gc_frame_newslot(strlit3547);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3548 = alloc_Boolean(1);
// compiled identifier node returning bool3548 (depth = 9)
  gc_frame_newslot(bool3548);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3547;
  params[1] = *var_lastToken;
  params[2] = bool3548;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3549 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3546);
// compiled call node returning call3549 (depth = 8)
    gc_frame_newslot(call3549);
    if3538 = call3549;
  }
// compiled if node returning if3538 (depth = 7)
    gc_frame_newslot(if3538);
    if3531 = if3538;
  } else {
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3552 == NULL) {
    strlit3552 = alloc_String("identifier");
    gc_root(strlit3552);
  }
// compiled string node returning strlit3552 (depth = 9)
  int op_slot_right_3551 = gc_frame_newslot(strlit3552);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3555 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3554);
// compiled call node returning call3555 (depth = 10)
// compiled member node returning call3555 (depth = 9)
  int op_slot_left_3551 = gc_frame_newslot(call3555);
  params[0] = strlit3552;
  partcv[0] = 1;
  Object opresult3556 = callmethod(call3555, "==", 1, partcv, params);
// compiled op node returning opresult3556 (depth = 8)
  Object if3550 = done;
  if (istrue(opresult3556)) {
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3557 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3558 == NULL) {
    strlit3558 = alloc_String(" {");
    gc_root(strlit3558);
  }
// compiled string node returning strlit3558 (depth = 9)
  gc_frame_newslot(strlit3558);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3558;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3559 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3557);
// compiled call node returning call3559 (depth = 8)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3560 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3561 == NULL) {
    strlit3561 = alloc_String("} ");
    gc_root(strlit3561);
  }
// compiled string node returning strlit3561 (depth = 9)
  gc_frame_newslot(strlit3561);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3561;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3562 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3560);
// compiled call node returning call3562 (depth = 8)
    gc_frame_newslot(call3562);
    if3550 = call3562;
  } else {
  }
// compiled if node returning if3550 (depth = 7)
    gc_frame_newslot(if3550);
    if3531 = if3550;
  }
// compiled if node returning if3531 (depth = 6)
    gc_frame_newslot(if3531);
    if3521 = if3531;
  }
// compiled if node returning if3521 (depth = 5)
    gc_frame_newslot(if3521);
    if3513 = if3521;
  }
// compiled if node returning if3513 (depth = 4)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3563 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3564 == NULL) {
    strlit3564 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3564);
  }
// compiled string node returning strlit3564 (depth = 5)
  gc_frame_newslot(strlit3564);
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  partcv[0] = 0;
  Object call3566 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3565);
// compiled call node returning call3566 (depth = 6)
// compiled member node returning call3566 (depth = 5)
  gc_frame_newslot(call3566);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3568 = alloc_Float64(1);
// compiled num node returning num3568 (depth = 6)
  int op_slot_right_3567 = gc_frame_newslot(num3568);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3572 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe3571);
// compiled call node returning call3572 (depth = 8)
// compiled member node returning call3572 (depth = 7)
  int op_slot_right_3570 = gc_frame_newslot(call3572);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3574 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3575 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3574);
// compiled call node returning call3575 (depth = 8)
// compiled member node returning call3575 (depth = 7)
  int op_slot_left_3570 = gc_frame_newslot(call3575);
  params[0] = call3572;
  partcv[0] = 1;
  Object sum3576 = callmethod(call3575, "+", 1, partcv, params);
// compiled op node returning sum3576 (depth = 6)
  int op_slot_left_3567 = gc_frame_newslot(sum3576);
  params[0] = num3568;
  partcv[0] = 1;
  Object sum3577 = callmethod(sum3576, "+", 1, partcv, params);
// compiled op node returning sum3577 (depth = 5)
  gc_frame_newslot(sum3577);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3564;
  params[1] = call3566;
  params[2] = sum3577;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3578 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3563);
// compiled call node returning call3578 (depth = 4)
    gc_frame_newslot(call3578);
    if3454 = call3578;
  } else {
  }
// compiled if node returning if3454 (depth = 3)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3579 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3580 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3579);
// compiled call node returning call3580 (depth = 4)
// compiled member node returning call3580 (depth = 3)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3582 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3583 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3584 = alloc_Block(NULL, NULL, "parser", 1105);
  gc_frame_newslot(block3584);
// method _apply
  block_savedest(block3584);
  Object closure3585 = createclosure(2, "_apply");
  setclosureframe(closure3585, stackframe);
  addtoclosure(closure3585, var_blocksOK);
  addtoclosure(closure3585, selfslot);
  struct UserObject *uo3585 = (struct UserObject*)block3584;
  uo3585->data[0] = (Object)closure3585;
  Method *meth_meth_parser__apply3585 = addmethod2pos(block3584, "_apply", &meth_parser__apply3585, 0);
  int argcv_meth_parser__apply3585[] = {0};
  meth_meth_parser__apply3585->type = alloc_MethodType(1, argcv_meth_parser__apply3585);
  meth_meth_parser__apply3585->definitionModule = modulename;
  meth_meth_parser__apply3585->definitionLine = 1105;
// compiled block node returning block3584 (depth = 7)
  gc_frame_newslot(block3584);
// call case 4: self request
  params[0] = block3584;
  partcv[0] = 1;
  Object call3589 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3583);
// compiled call node returning call3589 (depth = 6)
  partcv[0] = 0;
  Object call3590 = callmethod(call3589, "not",
    1, partcv, params);
  gc_frame_end(callframe3582);
// compiled call node returning call3590 (depth = 5)
// compiled member node returning call3590 (depth = 4)
  Object if3581 = done;
  if (istrue(call3590)) {
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3591 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3592 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3593 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3592);
// compiled call node returning call3593 (depth = 8)
// compiled member node returning call3593 (depth = 7)
  partcv[0] = 0;
  Object call3594 = callmethod(call3593, "new",
    1, partcv, params);
  gc_frame_end(callframe3591);
// compiled call node returning call3594 (depth = 6)
// compiled member node returning call3594 (depth = 5)
  *var_suggestion = call3594;
  if (call3594 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3595 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3596 == NULL) {
    strlit3596 = alloc_String("rparen");
    gc_root(strlit3596);
  }
// compiled string node returning strlit3596 (depth = 6)
  gc_frame_newslot(strlit3596);
// call case 4: self request
  params[0] = strlit3596;
  partcv[0] = 1;
  Object call3597 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3595);
// compiled call node returning call3597 (depth = 5)
  *var_nextTok = call3597;
  if (call3597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_3599 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3599 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3601 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3601 (depth = 5)
  Object if3598 = done;
  if (istrue(opresult3601)) {
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3602 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3603 == NULL) {
    strlit3603 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3603);
  }
// compiled string node returning strlit3603 (depth = 6)
  gc_frame_newslot(strlit3603);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3603;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3604 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3602);
// compiled call node returning call3604 (depth = 5)
    gc_frame_newslot(call3604);
    if3598 = call3604;
  } else {
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3605 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call3607 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3606);
// compiled call node returning call3607 (depth = 7)
// compiled member node returning call3607 (depth = 6)
  gc_frame_newslot(call3607);
// starting to compile identifier node (depth = 6)
  Object bool3608 = alloc_Boolean(1);
// compiled identifier node returning bool3608 (depth = 6)
  gc_frame_newslot(bool3608);
// starting to compile identifier node (depth = 6)
  Object bool3609 = alloc_Boolean(0);
// compiled identifier node returning bool3609 (depth = 6)
  gc_frame_newslot(bool3609);
// starting to compile string node (depth = 6)
  if (strlit3610 == NULL) {
    strlit3610 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3610);
  }
// compiled string node returning strlit3610 (depth = 6)
  gc_frame_newslot(strlit3610);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call3607;
  params[2] = bool3608;
  params[3] = bool3609;
  params[4] = strlit3610;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3611 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3605);
// compiled call node returning call3611 (depth = 5)
    gc_frame_newslot(call3611);
    if3598 = call3611;
  }
// compiled if node returning if3598 (depth = 4)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3612 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3613 == NULL) {
    strlit3613 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3613);
  }
// compiled string node returning strlit3613 (depth = 5)
  gc_frame_newslot(strlit3613);
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3615 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3614);
// compiled call node returning call3615 (depth = 6)
// compiled member node returning call3615 (depth = 5)
  gc_frame_newslot(call3615);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3617 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3616);
// compiled call node returning call3617 (depth = 6)
// compiled member node returning call3617 (depth = 5)
  gc_frame_newslot(call3617);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3613;
  params[1] = call3615;
  params[2] = call3617;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3618 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3612);
// compiled call node returning call3618 (depth = 4)
    gc_frame_newslot(call3618);
    if3581 = call3618;
  } else {
  }
// compiled if node returning if3581 (depth = 3)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3621 == NULL) {
    strlit3621 = alloc_String("rparen");
    gc_root(strlit3621);
  }
// compiled string node returning strlit3621 (depth = 5)
  int op_slot_right_3620 = gc_frame_newslot(strlit3621);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3624 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3623);
// compiled call node returning call3624 (depth = 6)
// compiled member node returning call3624 (depth = 5)
  int op_slot_left_3620 = gc_frame_newslot(call3624);
  params[0] = strlit3621;
  partcv[0] = 1;
  Object opresult3625 = callmethod(call3624, "!=", 1, partcv, params);
// compiled op node returning opresult3625 (depth = 4)
  Object if3619 = done;
  if (istrue(opresult3625)) {
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3626 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3627 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3626);
// compiled call node returning call3627 (depth = 5)
// compiled member node returning call3627 (depth = 4)
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3628 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3629 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3630 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3629);
// compiled call node returning call3630 (depth = 8)
// compiled member node returning call3630 (depth = 7)
  partcv[0] = 0;
  Object call3631 = callmethod(call3630, "new",
    1, partcv, params);
  gc_frame_end(callframe3628);
// compiled call node returning call3631 (depth = 6)
// compiled member node returning call3631 (depth = 5)
  *var_suggestion = call3631;
  if (call3631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3632 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3633 == NULL) {
    strlit3633 = alloc_String(")");
    gc_root(strlit3633);
  }
// compiled string node returning strlit3633 (depth = 5)
  gc_frame_newslot(strlit3633);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3633;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3634 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3632);
// compiled call node returning call3634 (depth = 4)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3635 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3636 == NULL) {
    strlit3636 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3636);
  }
// compiled string node returning strlit3636 (depth = 5)
  gc_frame_newslot(strlit3636);
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3638 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3637);
// compiled call node returning call3638 (depth = 6)
// compiled member node returning call3638 (depth = 5)
  gc_frame_newslot(call3638);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3640 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3641 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3640);
// compiled call node returning call3641 (depth = 7)
// compiled member node returning call3641 (depth = 6)
  int op_slot_right_3639 = gc_frame_newslot(call3641);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3644 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3643);
// compiled call node returning call3644 (depth = 7)
// compiled member node returning call3644 (depth = 6)
  int op_slot_left_3639 = gc_frame_newslot(call3644);
  params[0] = call3641;
  partcv[0] = 1;
  Object sum3645 = callmethod(call3644, "+", 1, partcv, params);
// compiled op node returning sum3645 (depth = 5)
  gc_frame_newslot(sum3645);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3636;
  params[1] = call3638;
  params[2] = sum3645;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3646 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3635);
// compiled call node returning call3646 (depth = 4)
    gc_frame_newslot(call3646);
    if3619 = call3646;
  } else {
  }
// compiled if node returning if3619 (depth = 3)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3647 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3648 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3647);
// compiled call node returning call3648 (depth = 4)
// compiled member node returning call3648 (depth = 3)
    gc_frame_newslot(call3648);
    if3448 = call3648;
  }
// compiled if node returning if3448 (depth = 2)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call3650 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3649);
// compiled call node returning call3650 (depth = 4)
// compiled member node returning call3650 (depth = 3)
  *var_mainblock = call3650;
  if (call3650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array3651 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3651 (depth = 3)
  *var_cases = array3651;
  if (array3651 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3652 = alloc_Boolean(0);
// compiled identifier node returning bool3652 (depth = 3)
  *var_finally = bool3652;
  if (bool3652 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3653 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3654 = alloc_Block(NULL, NULL, "parser", 1128);
  gc_frame_newslot(block3654);
// method _apply
  block_savedest(block3654);
  Object closure3655 = createclosure(2, "_apply");
  setclosureframe(closure3655, stackframe);
  addtoclosure(closure3655, var_sym);
  addtoclosure(closure3655, selfslot);
  struct UserObject *uo3655 = (struct UserObject*)block3654;
  uo3655->data[0] = (Object)closure3655;
  Method *meth_meth_parser__apply3655 = addmethod2pos(block3654, "_apply", &meth_parser__apply3655, 0);
  int argcv_meth_parser__apply3655[] = {0};
  meth_meth_parser__apply3655->type = alloc_MethodType(1, argcv_meth_parser__apply3655);
  meth_meth_parser__apply3655->definitionModule = modulename;
  meth_meth_parser__apply3655->definitionLine = 1125;
// compiled block node returning block3654 (depth = 3)
  gc_frame_newslot(block3654);
// starting to compile block node (depth = 3)
  Object block3669 = alloc_Block(NULL, NULL, "parser", 1128);
  gc_frame_newslot(block3669);
// method _apply
  block_savedest(block3669);
  Object closure3670 = createclosure(8, "_apply");
  setclosureframe(closure3670, stackframe);
  addtoclosure(closure3670, var_blocksOK);
  addtoclosure(closure3670, var_errormessages);
  addtoclosure(closure3670, var_sym);
  addtoclosure(closure3670, var_lastToken);
  addtoclosure(closure3670, var_tokens);
  addtoclosure(closure3670, var_values);
  addtoclosure(closure3670, var_cases);
  addtoclosure(closure3670, selfslot);
  struct UserObject *uo3670 = (struct UserObject*)block3669;
  uo3670->data[0] = (Object)closure3670;
  Method *meth_meth_parser__apply3670 = addmethod2pos(block3669, "_apply", &meth_parser__apply3670, 0);
  int argcv_meth_parser__apply3670[] = {0};
  meth_meth_parser__apply3670->type = alloc_MethodType(1, argcv_meth_parser__apply3670);
  meth_meth_parser__apply3670->definitionModule = modulename;
  meth_meth_parser__apply3670->definitionLine = 1128;
// compiled block node returning block3669 (depth = 3)
  gc_frame_newslot(block3669);
// call case 5: prelude request
  params[0] = block3654;
  params[1] = block3669;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3819 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3653);
// compiled call node returning call3819 (depth = 2)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3823 == NULL) {
    strlit3823 = alloc_String("case");
    gc_root(strlit3823);
  }
// compiled string node returning strlit3823 (depth = 5)
  int op_slot_right_3822 = gc_frame_newslot(strlit3823);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3826 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3825);
// compiled call node returning call3826 (depth = 6)
// compiled member node returning call3826 (depth = 5)
  int op_slot_left_3822 = gc_frame_newslot(call3826);
  params[0] = strlit3823;
  partcv[0] = 1;
  Object opresult3827 = callmethod(call3826, "==", 1, partcv, params);
// compiled op node returning opresult3827 (depth = 4)
  int op_slot_right_3821 = gc_frame_newslot(opresult3827);
// starting to compile call node (depth = 4)
  int callframe3829 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3830 == NULL) {
    strlit3830 = alloc_String("identifier");
    gc_root(strlit3830);
  }
// compiled string node returning strlit3830 (depth = 5)
  gc_frame_newslot(strlit3830);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  gc_frame_newslot(*var_catchTok);
// call case 4: self request
  params[0] = strlit3830;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3831 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3829);
// compiled call node returning call3831 (depth = 4)
  int op_slot_left_3821 = gc_frame_newslot(call3831);
  params[0] = opresult3827;
  partcv[0] = 1;
  Object opresult3832 = callmethod(call3831, "&&", 1, partcv, params);
// compiled op node returning opresult3832 (depth = 3)
  Object if3820 = done;
  if (istrue(opresult3832)) {
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3833 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call3835 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3834);
// compiled call node returning call3835 (depth = 7)
// compiled member node returning call3835 (depth = 6)
  partcv[0] = 0;
  Object call3836 = callmethod(call3835, "new",
    1, partcv, params);
  gc_frame_end(callframe3833);
// compiled call node returning call3836 (depth = 5)
// compiled member node returning call3836 (depth = 4)
  *var_suggestion = call3836;
  if (call3836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3837 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit3838 == NULL) {
    strlit3838 = alloc_String("catch");
    gc_root(strlit3838);
  }
// compiled string node returning strlit3838 (depth = 4)
  gc_frame_newslot(strlit3838);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit3838;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3839 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe3837);
// compiled call node returning call3839 (depth = 3)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3840 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3842 == NULL) {
    strlit3842 = alloc_String("are no 'case' blocks.");
    gc_root(strlit3842);
  }
// compiled string node returning strlit3842 (depth = 5)
  int op_slot_right_3841 = gc_frame_newslot(strlit3842);
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3845 == NULL) {
    strlit3845 = alloc_String("'try' and then zero or more 'catch' blocks; there ");
    gc_root(strlit3845);
  }
// compiled string node returning strlit3845 (depth = 6)
  int op_slot_right_3844 = gc_frame_newslot(strlit3845);
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3847 == NULL) {
    strlit3847 = alloc_String("A try-catch statement starts with a ");
    gc_root(strlit3847);
  }
// compiled string node returning strlit3847 (depth = 6)
  int op_slot_left_3844 = gc_frame_newslot(strlit3847);
  params[0] = strlit3845;
  partcv[0] = 1;
  Object opresult3848 = callmethod(strlit3847, "++", 1, partcv, params);
// compiled op node returning opresult3848 (depth = 5)
  int op_slot_left_3841 = gc_frame_newslot(opresult3848);
  params[0] = strlit3842;
  partcv[0] = 1;
  Object opresult3849 = callmethod(opresult3848, "++", 1, partcv, params);
// compiled op node returning opresult3849 (depth = 4)
  gc_frame_newslot(opresult3849);
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3851 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3850);
// compiled call node returning call3851 (depth = 5)
// compiled member node returning call3851 (depth = 4)
  gc_frame_newslot(call3851);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3852 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3853 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3852);
// compiled call node returning call3853 (depth = 5)
// compiled member node returning call3853 (depth = 4)
  gc_frame_newslot(call3853);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3855 = alloc_Float64(3);
// compiled num node returning num3855 (depth = 5)
  int op_slot_right_3854 = gc_frame_newslot(num3855);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3857 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3858 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3857);
// compiled call node returning call3858 (depth = 6)
// compiled member node returning call3858 (depth = 5)
  int op_slot_left_3854 = gc_frame_newslot(call3858);
  params[0] = num3855;
  partcv[0] = 1;
  Object sum3859 = callmethod(call3858, "+", 1, partcv, params);
// compiled op node returning sum3859 (depth = 4)
  gc_frame_newslot(sum3859);
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult3849;
  params[1] = call3851;
  params[2] = call3853;
  params[3] = sum3859;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3860 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3840);
// compiled call node returning call3860 (depth = 3)
    gc_frame_newslot(call3860);
    if3820 = call3860;
  } else {
  }
// compiled if node returning if3820 (depth = 2)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3864 == NULL) {
    strlit3864 = alloc_String("finally");
    gc_root(strlit3864);
  }
// compiled string node returning strlit3864 (depth = 5)
  int op_slot_right_3863 = gc_frame_newslot(strlit3864);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3866 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3867 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3866);
// compiled call node returning call3867 (depth = 6)
// compiled member node returning call3867 (depth = 5)
  int op_slot_left_3863 = gc_frame_newslot(call3867);
  params[0] = strlit3864;
  partcv[0] = 1;
  Object opresult3868 = callmethod(call3867, "==", 1, partcv, params);
// compiled op node returning opresult3868 (depth = 4)
  int op_slot_right_3862 = gc_frame_newslot(opresult3868);
// starting to compile call node (depth = 4)
  int callframe3870 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3871 == NULL) {
    strlit3871 = alloc_String("identifier");
    gc_root(strlit3871);
  }
// compiled string node returning strlit3871 (depth = 5)
  gc_frame_newslot(strlit3871);
// call case 4: self request
  params[0] = strlit3871;
  partcv[0] = 1;
  Object call3872 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3870);
// compiled call node returning call3872 (depth = 4)
  int op_slot_left_3862 = gc_frame_newslot(call3872);
  params[0] = opresult3868;
  partcv[0] = 1;
  Object opresult3873 = callmethod(call3872, "&&", 1, partcv, params);
// compiled op node returning opresult3873 (depth = 3)
  Object if3861 = done;
  if (istrue(opresult3873)) {
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3874 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3875 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3874);
// compiled call node returning call3875 (depth = 4)
// compiled member node returning call3875 (depth = 3)
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3877 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3878 == NULL) {
    strlit3878 = alloc_String("lbrace");
    gc_root(strlit3878);
  }
// compiled string node returning strlit3878 (depth = 5)
  gc_frame_newslot(strlit3878);
// call case 4: self request
  params[0] = strlit3878;
  partcv[0] = 1;
  Object call3879 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3877);
// compiled call node returning call3879 (depth = 4)
  Object if3876 = done;
  if (istrue(call3879)) {
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3881 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3880);
// compiled call node returning call3881 (depth = 5)
// compiled member node returning call3881 (depth = 4)
    gc_frame_newslot(call3881);
    if3876 = call3881;
  } else {
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3883 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3884 == NULL) {
    strlit3884 = alloc_String("lparen");
    gc_root(strlit3884);
  }
// compiled string node returning strlit3884 (depth = 6)
  gc_frame_newslot(strlit3884);
// call case 4: self request
  params[0] = strlit3884;
  partcv[0] = 1;
  Object call3885 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3883);
// compiled call node returning call3885 (depth = 5)
  Object if3882 = done;
  if (istrue(call3885)) {
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3886 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3887 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3886);
// compiled call node returning call3887 (depth = 6)
// compiled member node returning call3887 (depth = 5)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3889 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3890 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block3891 = alloc_Block(NULL, NULL, "parser", 1192);
  gc_frame_newslot(block3891);
// method _apply
  block_savedest(block3891);
  Object closure3892 = createclosure(2, "_apply");
  setclosureframe(closure3892, stackframe);
  addtoclosure(closure3892, var_blocksOK);
  addtoclosure(closure3892, selfslot);
  struct UserObject *uo3892 = (struct UserObject*)block3891;
  uo3892->data[0] = (Object)closure3892;
  Method *meth_meth_parser__apply3892 = addmethod2pos(block3891, "_apply", &meth_parser__apply3892, 0);
  int argcv_meth_parser__apply3892[] = {0};
  meth_meth_parser__apply3892->type = alloc_MethodType(1, argcv_meth_parser__apply3892);
  meth_meth_parser__apply3892->definitionModule = modulename;
  meth_meth_parser__apply3892->definitionLine = 1192;
// compiled block node returning block3891 (depth = 9)
  gc_frame_newslot(block3891);
// call case 4: self request
  params[0] = block3891;
  partcv[0] = 1;
  Object call3896 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3890);
// compiled call node returning call3896 (depth = 8)
  partcv[0] = 0;
  Object call3897 = callmethod(call3896, "not",
    1, partcv, params);
  gc_frame_end(callframe3889);
// compiled call node returning call3897 (depth = 7)
// compiled member node returning call3897 (depth = 6)
  Object if3888 = done;
  if (istrue(call3897)) {
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3898 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3899 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3900 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3899);
// compiled call node returning call3900 (depth = 10)
// compiled member node returning call3900 (depth = 9)
  partcv[0] = 0;
  Object call3901 = callmethod(call3900, "new",
    1, partcv, params);
  gc_frame_end(callframe3898);
// compiled call node returning call3901 (depth = 8)
// compiled member node returning call3901 (depth = 7)
  *var_suggestion = call3901;
  if (call3901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3902 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3903 == NULL) {
    strlit3903 = alloc_String("rparen");
    gc_root(strlit3903);
  }
// compiled string node returning strlit3903 (depth = 8)
  gc_frame_newslot(strlit3903);
// call case 4: self request
  params[0] = strlit3903;
  partcv[0] = 1;
  Object call3904 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3902);
// compiled call node returning call3904 (depth = 7)
  *var_nextTok = call3904;
  if (call3904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3906 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3906 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3908 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3908 (depth = 7)
  Object if3905 = done;
  if (istrue(opresult3908)) {
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3909 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3910 == NULL) {
    strlit3910 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3910);
  }
// compiled string node returning strlit3910 (depth = 8)
  gc_frame_newslot(strlit3910);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3910;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3911 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3909);
// compiled call node returning call3911 (depth = 7)
    gc_frame_newslot(call3911);
    if3905 = call3911;
  } else {
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3912 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3914 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3913);
// compiled call node returning call3914 (depth = 9)
// compiled member node returning call3914 (depth = 8)
  gc_frame_newslot(call3914);
// starting to compile identifier node (depth = 8)
  Object bool3915 = alloc_Boolean(1);
// compiled identifier node returning bool3915 (depth = 8)
  gc_frame_newslot(bool3915);
// starting to compile identifier node (depth = 8)
  Object bool3916 = alloc_Boolean(0);
// compiled identifier node returning bool3916 (depth = 8)
  gc_frame_newslot(bool3916);
// starting to compile string node (depth = 8)
  if (strlit3917 == NULL) {
    strlit3917 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3917);
  }
// compiled string node returning strlit3917 (depth = 8)
  gc_frame_newslot(strlit3917);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call3914;
  params[2] = bool3915;
  params[3] = bool3916;
  params[4] = strlit3917;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3918 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3912);
// compiled call node returning call3918 (depth = 7)
    gc_frame_newslot(call3918);
    if3905 = call3918;
  }
// compiled if node returning if3905 (depth = 6)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3919 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3920 == NULL) {
    strlit3920 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit3920);
  }
// compiled string node returning strlit3920 (depth = 7)
  gc_frame_newslot(strlit3920);
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3922 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3921);
// compiled call node returning call3922 (depth = 8)
// compiled member node returning call3922 (depth = 7)
  gc_frame_newslot(call3922);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3923 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3924 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3923);
// compiled call node returning call3924 (depth = 8)
// compiled member node returning call3924 (depth = 7)
  gc_frame_newslot(call3924);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3920;
  params[1] = call3922;
  params[2] = call3924;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3925 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3919);
// compiled call node returning call3925 (depth = 6)
    gc_frame_newslot(call3925);
    if3888 = call3925;
  } else {
  }
// compiled if node returning if3888 (depth = 5)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3928 == NULL) {
    strlit3928 = alloc_String("rparen");
    gc_root(strlit3928);
  }
// compiled string node returning strlit3928 (depth = 7)
  int op_slot_right_3927 = gc_frame_newslot(strlit3928);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3931 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3930);
// compiled call node returning call3931 (depth = 8)
// compiled member node returning call3931 (depth = 7)
  int op_slot_left_3927 = gc_frame_newslot(call3931);
  params[0] = strlit3928;
  partcv[0] = 1;
  Object opresult3932 = callmethod(call3931, "!=", 1, partcv, params);
// compiled op node returning opresult3932 (depth = 6)
  Object if3926 = done;
  if (istrue(opresult3932)) {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3933 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3934 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3933);
// compiled call node returning call3934 (depth = 7)
// compiled member node returning call3934 (depth = 6)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3935 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3937 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3936);
// compiled call node returning call3937 (depth = 10)
// compiled member node returning call3937 (depth = 9)
  partcv[0] = 0;
  Object call3938 = callmethod(call3937, "new",
    1, partcv, params);
  gc_frame_end(callframe3935);
// compiled call node returning call3938 (depth = 8)
// compiled member node returning call3938 (depth = 7)
  *var_suggestion = call3938;
  if (call3938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3939 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3940 == NULL) {
    strlit3940 = alloc_String(")");
    gc_root(strlit3940);
  }
// compiled string node returning strlit3940 (depth = 7)
  gc_frame_newslot(strlit3940);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3940;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3941 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3939);
// compiled call node returning call3941 (depth = 6)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3942 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3943 == NULL) {
    strlit3943 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3943);
  }
// compiled string node returning strlit3943 (depth = 7)
  gc_frame_newslot(strlit3943);
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3945 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3944);
// compiled call node returning call3945 (depth = 8)
// compiled member node returning call3945 (depth = 7)
  gc_frame_newslot(call3945);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3948 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3947);
// compiled call node returning call3948 (depth = 9)
// compiled member node returning call3948 (depth = 8)
  int op_slot_right_3946 = gc_frame_newslot(call3948);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3950 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3951 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3950);
// compiled call node returning call3951 (depth = 9)
// compiled member node returning call3951 (depth = 8)
  int op_slot_left_3946 = gc_frame_newslot(call3951);
  params[0] = call3948;
  partcv[0] = 1;
  Object sum3952 = callmethod(call3951, "+", 1, partcv, params);
// compiled op node returning sum3952 (depth = 7)
  gc_frame_newslot(sum3952);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3943;
  params[1] = call3945;
  params[2] = sum3952;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3953 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3942);
// compiled call node returning call3953 (depth = 6)
    gc_frame_newslot(call3953);
    if3926 = call3953;
  } else {
  }
// compiled if node returning if3926 (depth = 5)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3954 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3955 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3954);
// compiled call node returning call3955 (depth = 6)
// compiled member node returning call3955 (depth = 5)
    gc_frame_newslot(call3955);
    if3882 = call3955;
  } else {
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3956 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3957 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3958 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3957);
// compiled call node returning call3958 (depth = 9)
// compiled member node returning call3958 (depth = 8)
  partcv[0] = 0;
  Object call3959 = callmethod(call3958, "empty",
    1, partcv, params);
  gc_frame_end(callframe3956);
// compiled call node returning call3959 (depth = 7)
// compiled member node returning call3959 (depth = 6)
  *var_suggestions = call3959;
  if (call3959 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3960 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3961 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3960);
// compiled call node returning call3961 (depth = 6)
  *var_nextTok = call3961;
  if (call3961 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3962 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3964 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3963);
// compiled call node returning call3964 (depth = 9)
// compiled member node returning call3964 (depth = 8)
  partcv[0] = 0;
  Object call3965 = callmethod(call3964, "new",
    1, partcv, params);
  gc_frame_end(callframe3962);
// compiled call node returning call3965 (depth = 7)
// compiled member node returning call3965 (depth = 6)
  *var_suggestion = call3965;
  if (call3965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3968 = alloc_Boolean(0);
// compiled identifier node returning bool3968 (depth = 7)
  int op_slot_right_3967 = gc_frame_newslot(bool3968);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3967 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3968;
  partcv[0] = 1;
  Object opresult3970 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3970 (depth = 6)
  Object if3966 = done;
  if (istrue(opresult3970)) {
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3971 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3972 == NULL) {
    strlit3972 = alloc_String(" }");
    gc_root(strlit3972);
  }
// compiled string node returning strlit3972 (depth = 7)
  gc_frame_newslot(strlit3972);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3973 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call3974 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe3973);
// compiled call node returning call3974 (depth = 8)
// compiled member node returning call3974 (depth = 7)
  gc_frame_newslot(call3974);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3972;
  params[1] = call3974;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3975 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3971);
// compiled call node returning call3975 (depth = 6)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3976 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3977 == NULL) {
    strlit3977 = alloc_String(" {");
    gc_root(strlit3977);
  }
// compiled string node returning strlit3977 (depth = 7)
  gc_frame_newslot(strlit3977);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3977;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3978 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3976);
// compiled call node returning call3978 (depth = 6)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3979 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3980 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3979);
// compiled call node returning call3980 (depth = 6)
    gc_frame_newslot(call3980);
    if3966 = call3980;
  } else {
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3982 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3982 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3984 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3984 (depth = 7)
  Object if3981 = done;
  if (istrue(opresult3984)) {
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3985 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3986 == NULL) {
    strlit3986 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3986);
  }
// compiled string node returning strlit3986 (depth = 8)
  gc_frame_newslot(strlit3986);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3986;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3987 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3985);
// compiled call node returning call3987 (depth = 7)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3988 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3989 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3988);
// compiled call node returning call3989 (depth = 7)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3990 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3991 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3992 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3991);
// compiled call node returning call3992 (depth = 11)
// compiled member node returning call3992 (depth = 10)
  partcv[0] = 0;
  Object call3993 = callmethod(call3992, "new",
    1, partcv, params);
  gc_frame_end(callframe3990);
// compiled call node returning call3993 (depth = 9)
// compiled member node returning call3993 (depth = 8)
  *var_suggestion = call3993;
  if (call3993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3995 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3996 == NULL) {
    strlit3996 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit3996);
  }
// compiled string node returning strlit3996 (depth = 8)
  gc_frame_newslot(strlit3996);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3996;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3997 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3995);
// compiled call node returning call3997 (depth = 7)
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3998 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3999 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3998);
// compiled call node returning call3999 (depth = 7)
    gc_frame_newslot(call3999);
    if3981 = call3999;
  } else {
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4000 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4001 == NULL) {
    strlit4001 = alloc_String(" }");
    gc_root(strlit4001);
  }
// compiled string node returning strlit4001 (depth = 8)
  gc_frame_newslot(strlit4001);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4003 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4002);
// compiled call node returning call4003 (depth = 9)
// compiled member node returning call4003 (depth = 8)
  gc_frame_newslot(call4003);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4001;
  params[1] = call4003;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4004 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4000);
// compiled call node returning call4004 (depth = 7)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4005 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4006 == NULL) {
    strlit4006 = alloc_String(" {");
    gc_root(strlit4006);
  }
// compiled string node returning strlit4006 (depth = 8)
  gc_frame_newslot(strlit4006);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4006;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4007 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4005);
// compiled call node returning call4007 (depth = 7)
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4008 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4009 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4008);
// compiled call node returning call4009 (depth = 7)
    gc_frame_newslot(call4009);
    if3981 = call4009;
  }
// compiled if node returning if3981 (depth = 6)
    gc_frame_newslot(if3981);
    if3966 = if3981;
  }
// compiled if node returning if3966 (depth = 5)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4010 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4011 == NULL) {
    strlit4011 = alloc_String("A try-finally statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4011);
  }
// compiled string node returning strlit4011 (depth = 6)
  gc_frame_newslot(strlit4011);
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4013 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4012);
// compiled call node returning call4013 (depth = 7)
// compiled member node returning call4013 (depth = 6)
  gc_frame_newslot(call4013);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4014 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4015 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4014);
// compiled call node returning call4015 (depth = 7)
// compiled member node returning call4015 (depth = 6)
  gc_frame_newslot(call4015);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4011;
  params[1] = call4013;
  params[2] = call4015;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4016 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4010);
// compiled call node returning call4016 (depth = 5)
    gc_frame_newslot(call4016);
    if3882 = call4016;
  }
// compiled if node returning if3882 (depth = 4)
    gc_frame_newslot(if3882);
    if3876 = if3882;
  }
// compiled if node returning if3876 (depth = 3)
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4017 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4018 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4017);
// compiled call node returning call4018 (depth = 5)
// compiled member node returning call4018 (depth = 4)
  *var_finally = call4018;
  if (call4018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if3861 = done;
  } else {
  }
// compiled if node returning if3861 (depth = 2)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4020 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4021 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4022 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4021);
// compiled call node returning call4022 (depth = 4)
// compiled member node returning call4022 (depth = 3)
  gc_frame_newslot(call4022);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4024 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4023);
// compiled call node returning call4024 (depth = 4)
// compiled member node returning call4024 (depth = 3)
  gc_frame_newslot(call4024);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4022;
  params[1] = call4024;
  partcv[0] = 2;
  Object call4025 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4020);
// compiled call node returning call4025 (depth = 2)
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4026 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4027 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4029 = callmethod(*var_ast, "catchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4028);
// compiled call node returning call4029 (depth = 5)
// compiled member node returning call4029 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4030 = callmethod(call4029, "new",
    1, partcv, params);
  gc_frame_end(callframe4027);
// compiled call node returning call4030 (depth = 3)
  gc_frame_newslot(call4030);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4030;
  partcv[0] = 1;
  Object call4031 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4026);
// compiled call node returning call4031 (depth = 2)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4082(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4086 == NULL) {
    strlit4086 = alloc_String("case");
    gc_root(strlit4086);
  }
// compiled string node returning strlit4086 (depth = 10)
  int op_slot_right_4085 = gc_frame_newslot(strlit4086);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4088 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call4089 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4088);
// compiled call node returning call4089 (depth = 11)
// compiled member node returning call4089 (depth = 10)
  int op_slot_left_4085 = gc_frame_newslot(call4089);
  params[0] = strlit4086;
  partcv[0] = 1;
  Object opresult4090 = callmethod(call4089, "==", 1, partcv, params);
// compiled op node returning opresult4090 (depth = 9)
  int op_slot_right_4084 = gc_frame_newslot(opresult4090);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4093 == NULL) {
    strlit4093 = alloc_String("identifier");
    gc_root(strlit4093);
  }
// compiled string node returning strlit4093 (depth = 10)
  int op_slot_right_4092 = gc_frame_newslot(strlit4093);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4095 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call4096 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4095);
// compiled call node returning call4096 (depth = 11)
// compiled member node returning call4096 (depth = 10)
  int op_slot_left_4092 = gc_frame_newslot(call4096);
  params[0] = strlit4093;
  partcv[0] = 1;
  Object opresult4097 = callmethod(call4096, "==", 1, partcv, params);
// compiled op node returning opresult4097 (depth = 9)
  int op_slot_left_4084 = gc_frame_newslot(opresult4097);
  params[0] = opresult4090;
  partcv[0] = 1;
  Object opresult4098 = callmethod(opresult4097, "&&", 1, partcv, params);
// compiled op node returning opresult4098 (depth = 8)
  int op_slot_right_4083 = gc_frame_newslot(opresult4098);
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_catchTok (depth = 13)
  partcv[0] = 0;
  Object call4104 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4103);
// compiled call node returning call4104 (depth = 12)
// compiled member node returning call4104 (depth = 11)
  int op_slot_right_4102 = gc_frame_newslot(call4104);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4106 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call4107 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4106);
// compiled call node returning call4107 (depth = 12)
// compiled member node returning call4107 (depth = 11)
  int op_slot_left_4102 = gc_frame_newslot(call4107);
  params[0] = call4104;
  partcv[0] = 1;
  Object opresult4108 = callmethod(call4107, "==", 1, partcv, params);
// compiled op node returning opresult4108 (depth = 10)
  int op_slot_right_4101 = gc_frame_newslot(opresult4108);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4111 == NULL) {
    strlit4111 = alloc_String("rparen");
    gc_root(strlit4111);
  }
// compiled string node returning strlit4111 (depth = 11)
  int op_slot_right_4110 = gc_frame_newslot(strlit4111);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call4114 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4113);
// compiled call node returning call4114 (depth = 12)
// compiled member node returning call4114 (depth = 11)
  int op_slot_left_4110 = gc_frame_newslot(call4114);
  params[0] = strlit4111;
  partcv[0] = 1;
  Object opresult4115 = callmethod(call4114, "==", 1, partcv, params);
// compiled op node returning opresult4115 (depth = 10)
  int op_slot_left_4101 = gc_frame_newslot(opresult4115);
  params[0] = opresult4108;
  partcv[0] = 1;
  Object opresult4116 = callmethod(opresult4115, "&&", 1, partcv, params);
// compiled op node returning opresult4116 (depth = 9)
  int op_slot_right_4100 = gc_frame_newslot(opresult4116);
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4119 == NULL) {
    strlit4119 = alloc_String("rbrace");
    gc_root(strlit4119);
  }
// compiled string node returning strlit4119 (depth = 10)
  int op_slot_right_4118 = gc_frame_newslot(strlit4119);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4121 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call4122 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4121);
// compiled call node returning call4122 (depth = 11)
// compiled member node returning call4122 (depth = 10)
  int op_slot_left_4118 = gc_frame_newslot(call4122);
  params[0] = strlit4119;
  partcv[0] = 1;
  Object opresult4123 = callmethod(call4122, "==", 1, partcv, params);
// compiled op node returning opresult4123 (depth = 9)
  int op_slot_left_4100 = gc_frame_newslot(opresult4123);
  params[0] = opresult4116;
  partcv[0] = 1;
  Object opresult4124 = callmethod(opresult4123, "||", 1, partcv, params);
// compiled op node returning opresult4124 (depth = 8)
  int op_slot_left_4083 = gc_frame_newslot(opresult4124);
  params[0] = opresult4098;
  partcv[0] = 1;
  Object opresult4125 = callmethod(opresult4124, "||", 1, partcv, params);
// compiled op node returning opresult4125 (depth = 7)
  gc_frame_end(frame);
  return opresult4125;
}
Object meth_parser__apply4200(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe4201 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4202 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4201);
// compiled call node returning call4202 (depth = 8)
  gc_frame_end(frame);
  return call4202;
}
Object meth_parser__apply4270(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4273 == NULL) {
    strlit4273 = alloc_String("case");
    gc_root(strlit4273);
  }
// compiled string node returning strlit4273 (depth = 6)
  int op_slot_right_4272 = gc_frame_newslot(strlit4273);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4276 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4275);
// compiled call node returning call4276 (depth = 7)
// compiled member node returning call4276 (depth = 6)
  int op_slot_left_4272 = gc_frame_newslot(call4276);
  params[0] = strlit4273;
  partcv[0] = 1;
  Object opresult4277 = callmethod(call4276, "==", 1, partcv, params);
// compiled op node returning opresult4277 (depth = 5)
  int op_slot_right_4271 = gc_frame_newslot(opresult4277);
// starting to compile call node (depth = 5)
  int callframe4279 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4280 == NULL) {
    strlit4280 = alloc_String("identifier");
    gc_root(strlit4280);
  }
// compiled string node returning strlit4280 (depth = 6)
  gc_frame_newslot(strlit4280);
// call case 4: self request
  params[0] = strlit4280;
  partcv[0] = 1;
  Object call4281 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4279);
// compiled call node returning call4281 (depth = 5)
  int op_slot_left_4271 = gc_frame_newslot(call4281);
  params[0] = opresult4277;
  partcv[0] = 1;
  Object opresult4282 = callmethod(call4281, "&&", 1, partcv, params);
// compiled op node returning opresult4282 (depth = 4)
  gc_frame_end(frame);
  return opresult4282;
}
Object meth_parser__apply4304(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe4305 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4306 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4305);
// compiled call node returning call4306 (depth = 11)
  gc_frame_end(frame);
  return call4306;
}
Object meth_parser__apply4285(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4287 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4286);
// compiled call node returning call4287 (depth = 5)
// compiled member node returning call4287 (depth = 4)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4289 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4290 == NULL) {
    strlit4290 = alloc_String("lbrace");
    gc_root(strlit4290);
  }
// compiled string node returning strlit4290 (depth = 6)
  gc_frame_newslot(strlit4290);
// call case 4: self request
  params[0] = strlit4290;
  partcv[0] = 1;
  Object call4291 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4289);
// compiled call node returning call4291 (depth = 5)
  Object if4288 = done;
  if (istrue(call4291)) {
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4292 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4293 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4292);
// compiled call node returning call4293 (depth = 6)
// compiled member node returning call4293 (depth = 5)
    gc_frame_newslot(call4293);
    if4288 = call4293;
  } else {
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4295 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4296 == NULL) {
    strlit4296 = alloc_String("lparen");
    gc_root(strlit4296);
  }
// compiled string node returning strlit4296 (depth = 7)
  gc_frame_newslot(strlit4296);
// call case 4: self request
  params[0] = strlit4296;
  partcv[0] = 1;
  Object call4297 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4295);
// compiled call node returning call4297 (depth = 6)
  Object if4294 = done;
  if (istrue(call4297)) {
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4298 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4299 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4298);
// compiled call node returning call4299 (depth = 7)
// compiled member node returning call4299 (depth = 6)
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4301 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe4302 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block4303 = alloc_Block(NULL, NULL, "parser", 1305);
  gc_frame_newslot(block4303);
// method _apply
  block_savedest(block4303);
  Object closure4304 = createclosure(2, "_apply");
  setclosureframe(closure4304, stackframe);
  addtoclosure(closure4304, var_blocksOK);
  addtoclosure(closure4304, selfslot);
  struct UserObject *uo4304 = (struct UserObject*)block4303;
  uo4304->data[0] = (Object)closure4304;
  Method *meth_meth_parser__apply4304 = addmethod2pos(block4303, "_apply", &meth_parser__apply4304, 0);
  int argcv_meth_parser__apply4304[] = {0};
  meth_meth_parser__apply4304->type = alloc_MethodType(1, argcv_meth_parser__apply4304);
  meth_meth_parser__apply4304->definitionModule = modulename;
  meth_meth_parser__apply4304->definitionLine = 1305;
// compiled block node returning block4303 (depth = 10)
  gc_frame_newslot(block4303);
// call case 4: self request
  params[0] = block4303;
  partcv[0] = 1;
  Object call4308 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4302);
// compiled call node returning call4308 (depth = 9)
  partcv[0] = 0;
  Object call4309 = callmethod(call4308, "not",
    1, partcv, params);
  gc_frame_end(callframe4301);
// compiled call node returning call4309 (depth = 8)
// compiled member node returning call4309 (depth = 7)
  Object if4300 = done;
  if (istrue(call4309)) {
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4310 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4311 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4312 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4311);
// compiled call node returning call4312 (depth = 11)
// compiled member node returning call4312 (depth = 10)
  partcv[0] = 0;
  Object call4313 = callmethod(call4312, "new",
    1, partcv, params);
  gc_frame_end(callframe4310);
// compiled call node returning call4313 (depth = 9)
// compiled member node returning call4313 (depth = 8)
  *var_suggestion = call4313;
  if (call4313 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4314 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4315 == NULL) {
    strlit4315 = alloc_String("rparen");
    gc_root(strlit4315);
  }
// compiled string node returning strlit4315 (depth = 9)
  gc_frame_newslot(strlit4315);
// call case 4: self request
  params[0] = strlit4315;
  partcv[0] = 1;
  Object call4316 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4314);
// compiled call node returning call4316 (depth = 8)
  *var_nextTok = call4316;
  if (call4316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4318 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4318 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4320 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4320 (depth = 8)
  Object if4317 = done;
  if (istrue(opresult4320)) {
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4321 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4322 == NULL) {
    strlit4322 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4322);
  }
// compiled string node returning strlit4322 (depth = 9)
  gc_frame_newslot(strlit4322);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4322;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4323 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4321);
// compiled call node returning call4323 (depth = 8)
    gc_frame_newslot(call4323);
    if4317 = call4323;
  } else {
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4324 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4326 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4325);
// compiled call node returning call4326 (depth = 10)
// compiled member node returning call4326 (depth = 9)
  gc_frame_newslot(call4326);
// starting to compile identifier node (depth = 9)
  Object bool4327 = alloc_Boolean(1);
// compiled identifier node returning bool4327 (depth = 9)
  gc_frame_newslot(bool4327);
// starting to compile identifier node (depth = 9)
  Object bool4328 = alloc_Boolean(0);
// compiled identifier node returning bool4328 (depth = 9)
  gc_frame_newslot(bool4328);
// starting to compile string node (depth = 9)
  if (strlit4329 == NULL) {
    strlit4329 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4329);
  }
// compiled string node returning strlit4329 (depth = 9)
  gc_frame_newslot(strlit4329);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4326;
  params[2] = bool4327;
  params[3] = bool4328;
  params[4] = strlit4329;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4330 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4324);
// compiled call node returning call4330 (depth = 8)
    gc_frame_newslot(call4330);
    if4317 = call4330;
  }
// compiled if node returning if4317 (depth = 7)
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4331 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4332 == NULL) {
    strlit4332 = alloc_String("A catch statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4332);
  }
// compiled string node returning strlit4332 (depth = 8)
  gc_frame_newslot(strlit4332);
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4334 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4333);
// compiled call node returning call4334 (depth = 9)
// compiled member node returning call4334 (depth = 8)
  gc_frame_newslot(call4334);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4336 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4335);
// compiled call node returning call4336 (depth = 9)
// compiled member node returning call4336 (depth = 8)
  gc_frame_newslot(call4336);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4332;
  params[1] = call4334;
  params[2] = call4336;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4337 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4331);
// compiled call node returning call4337 (depth = 7)
    gc_frame_newslot(call4337);
    if4300 = call4337;
  } else {
  }
// compiled if node returning if4300 (depth = 6)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4340 == NULL) {
    strlit4340 = alloc_String("rparen");
    gc_root(strlit4340);
  }
// compiled string node returning strlit4340 (depth = 8)
  int op_slot_right_4339 = gc_frame_newslot(strlit4340);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4342 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4343 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4342);
// compiled call node returning call4343 (depth = 9)
// compiled member node returning call4343 (depth = 8)
  int op_slot_left_4339 = gc_frame_newslot(call4343);
  params[0] = strlit4340;
  partcv[0] = 1;
  Object opresult4344 = callmethod(call4343, "!=", 1, partcv, params);
// compiled op node returning opresult4344 (depth = 7)
  Object if4338 = done;
  if (istrue(opresult4344)) {
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4346 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4345);
// compiled call node returning call4346 (depth = 8)
// compiled member node returning call4346 (depth = 7)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4347 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4349 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4348);
// compiled call node returning call4349 (depth = 11)
// compiled member node returning call4349 (depth = 10)
  partcv[0] = 0;
  Object call4350 = callmethod(call4349, "new",
    1, partcv, params);
  gc_frame_end(callframe4347);
// compiled call node returning call4350 (depth = 9)
// compiled member node returning call4350 (depth = 8)
  *var_suggestion = call4350;
  if (call4350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4351 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4352 == NULL) {
    strlit4352 = alloc_String(")");
    gc_root(strlit4352);
  }
// compiled string node returning strlit4352 (depth = 8)
  gc_frame_newslot(strlit4352);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4352;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4353 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4351);
// compiled call node returning call4353 (depth = 7)
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4354 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4355 == NULL) {
    strlit4355 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4355);
  }
// compiled string node returning strlit4355 (depth = 8)
  gc_frame_newslot(strlit4355);
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4356 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4357 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4356);
// compiled call node returning call4357 (depth = 9)
// compiled member node returning call4357 (depth = 8)
  gc_frame_newslot(call4357);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4360 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4359);
// compiled call node returning call4360 (depth = 10)
// compiled member node returning call4360 (depth = 9)
  int op_slot_right_4358 = gc_frame_newslot(call4360);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4363 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4362);
// compiled call node returning call4363 (depth = 10)
// compiled member node returning call4363 (depth = 9)
  int op_slot_left_4358 = gc_frame_newslot(call4363);
  params[0] = call4360;
  partcv[0] = 1;
  Object sum4364 = callmethod(call4363, "+", 1, partcv, params);
// compiled op node returning sum4364 (depth = 8)
  gc_frame_newslot(sum4364);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4355;
  params[1] = call4357;
  params[2] = sum4364;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4365 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4354);
// compiled call node returning call4365 (depth = 7)
    gc_frame_newslot(call4365);
    if4338 = call4365;
  } else {
  }
// compiled if node returning if4338 (depth = 6)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4366 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4367 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4366);
// compiled call node returning call4367 (depth = 7)
// compiled member node returning call4367 (depth = 6)
    gc_frame_newslot(call4367);
    if4294 = call4367;
  } else {
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4368 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4369 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4370 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4369);
// compiled call node returning call4370 (depth = 10)
// compiled member node returning call4370 (depth = 9)
  partcv[0] = 0;
  Object call4371 = callmethod(call4370, "empty",
    1, partcv, params);
  gc_frame_end(callframe4368);
// compiled call node returning call4371 (depth = 8)
// compiled member node returning call4371 (depth = 7)
  *var_suggestions = call4371;
  if (call4371 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4372 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4373 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4372);
// compiled call node returning call4373 (depth = 7)
  *var_nextTok = call4373;
  if (call4373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4374 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4376 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4375);
// compiled call node returning call4376 (depth = 10)
// compiled member node returning call4376 (depth = 9)
  partcv[0] = 0;
  Object call4377 = callmethod(call4376, "new",
    1, partcv, params);
  gc_frame_end(callframe4374);
// compiled call node returning call4377 (depth = 8)
// compiled member node returning call4377 (depth = 7)
  *var_suggestion = call4377;
  if (call4377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4380 = alloc_Boolean(0);
// compiled identifier node returning bool4380 (depth = 8)
  int op_slot_right_4379 = gc_frame_newslot(bool4380);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4379 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4380;
  partcv[0] = 1;
  Object opresult4382 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4382 (depth = 7)
  Object if4378 = done;
  if (istrue(opresult4382)) {
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4383 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4384 == NULL) {
    strlit4384 = alloc_String(" }");
    gc_root(strlit4384);
  }
// compiled string node returning strlit4384 (depth = 8)
  gc_frame_newslot(strlit4384);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call4386 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4385);
// compiled call node returning call4386 (depth = 9)
// compiled member node returning call4386 (depth = 8)
  gc_frame_newslot(call4386);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4384;
  params[1] = call4386;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4387 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4383);
// compiled call node returning call4387 (depth = 7)
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4388 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4389 == NULL) {
    strlit4389 = alloc_String(" {");
    gc_root(strlit4389);
  }
// compiled string node returning strlit4389 (depth = 8)
  gc_frame_newslot(strlit4389);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4389;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4390 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4388);
// compiled call node returning call4390 (depth = 7)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4391 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4392 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4391);
// compiled call node returning call4392 (depth = 7)
    gc_frame_newslot(call4392);
    if4378 = call4392;
  } else {
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4394 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4394 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4396 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4396 (depth = 8)
  Object if4393 = done;
  if (istrue(opresult4396)) {
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4397 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4398 == NULL) {
    strlit4398 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4398);
  }
// compiled string node returning strlit4398 (depth = 9)
  gc_frame_newslot(strlit4398);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4398;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4399 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4397);
// compiled call node returning call4399 (depth = 8)
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4400 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4401 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4400);
// compiled call node returning call4401 (depth = 8)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4402 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4403 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call4404 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4403);
// compiled call node returning call4404 (depth = 12)
// compiled member node returning call4404 (depth = 11)
  partcv[0] = 0;
  Object call4405 = callmethod(call4404, "new",
    1, partcv, params);
  gc_frame_end(callframe4402);
// compiled call node returning call4405 (depth = 10)
// compiled member node returning call4405 (depth = 9)
  *var_suggestion = call4405;
  if (call4405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4407 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4408 == NULL) {
    strlit4408 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4408);
  }
// compiled string node returning strlit4408 (depth = 9)
  gc_frame_newslot(strlit4408);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4408;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4409 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4407);
// compiled call node returning call4409 (depth = 8)
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4410 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4411 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4410);
// compiled call node returning call4411 (depth = 8)
    gc_frame_newslot(call4411);
    if4393 = call4411;
  } else {
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4412 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4413 == NULL) {
    strlit4413 = alloc_String(" }");
    gc_root(strlit4413);
  }
// compiled string node returning strlit4413 (depth = 9)
  gc_frame_newslot(strlit4413);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4415 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4414);
// compiled call node returning call4415 (depth = 10)
// compiled member node returning call4415 (depth = 9)
  gc_frame_newslot(call4415);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4413;
  params[1] = call4415;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4416 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4412);
// compiled call node returning call4416 (depth = 8)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4417 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4418 == NULL) {
    strlit4418 = alloc_String(" {");
    gc_root(strlit4418);
  }
// compiled string node returning strlit4418 (depth = 9)
  gc_frame_newslot(strlit4418);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4418;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4419 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4417);
// compiled call node returning call4419 (depth = 8)
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4420 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4421 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4420);
// compiled call node returning call4421 (depth = 8)
    gc_frame_newslot(call4421);
    if4393 = call4421;
  }
// compiled if node returning if4393 (depth = 7)
    gc_frame_newslot(if4393);
    if4378 = if4393;
  }
// compiled if node returning if4378 (depth = 6)
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4422 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4423 == NULL) {
    strlit4423 = alloc_String("A catch statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4423);
  }
// compiled string node returning strlit4423 (depth = 7)
  gc_frame_newslot(strlit4423);
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4424 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4425 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4424);
// compiled call node returning call4425 (depth = 8)
// compiled member node returning call4425 (depth = 7)
  gc_frame_newslot(call4425);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4426 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4427 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4426);
// compiled call node returning call4427 (depth = 8)
// compiled member node returning call4427 (depth = 7)
  gc_frame_newslot(call4427);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4423;
  params[1] = call4425;
  params[2] = call4427;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4428 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4422);
// compiled call node returning call4428 (depth = 6)
    gc_frame_newslot(call4428);
    if4294 = call4428;
  }
// compiled if node returning if4294 (depth = 5)
    gc_frame_newslot(if4294);
    if4288 = if4294;
  }
// compiled if node returning if4288 (depth = 4)
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4429 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call4431 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4430);
// compiled call node returning call4431 (depth = 6)
// compiled member node returning call4431 (depth = 5)
  gc_frame_newslot(call4431);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4431;
  partcv[0] = 1;
  Object call4432 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4429);
// compiled call node returning call4432 (depth = 4)
  gc_frame_end(frame);
  return call4432;
}
Object meth_parser__apply4466(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe4467 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4468 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4467);
// compiled call node returning call4468 (depth = 10)
  gc_frame_end(frame);
  return call4468;
}
Object meth_parser_catchcase4033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "catchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for catchcase (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for catchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4035 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4038 == NULL) {
    strlit4038 = alloc_String("catch");
    gc_root(strlit4038);
  }
// compiled string node returning strlit4038 (depth = 6)
  int op_slot_right_4037 = gc_frame_newslot(strlit4038);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4040 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4041 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4040);
// compiled call node returning call4041 (depth = 7)
// compiled member node returning call4041 (depth = 6)
  int op_slot_left_4037 = gc_frame_newslot(call4041);
  params[0] = strlit4038;
  partcv[0] = 1;
  Object opresult4042 = callmethod(call4041, "==", 1, partcv, params);
// compiled op node returning opresult4042 (depth = 5)
  int op_slot_right_4036 = gc_frame_newslot(opresult4042);
// starting to compile call node (depth = 5)
  int callframe4044 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4045 == NULL) {
    strlit4045 = alloc_String("identifier");
    gc_root(strlit4045);
  }
// compiled string node returning strlit4045 (depth = 6)
  gc_frame_newslot(strlit4045);
// call case 4: self request
  params[0] = strlit4045;
  partcv[0] = 1;
  Object call4046 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4044);
// compiled call node returning call4046 (depth = 5)
  int op_slot_left_4036 = gc_frame_newslot(call4046);
  params[0] = opresult4042;
  partcv[0] = 1;
  Object opresult4047 = callmethod(call4046, "&&", 1, partcv, params);
// compiled op node returning opresult4047 (depth = 4)
  partcv[0] = 0;
  Object call4048 = callmethod(opresult4047, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4035);
// compiled call node returning call4048 (depth = 3)
  Object if4034 = done;
  if (istrue(call4048)) {
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4049 = alloc_Float64(0);
// compiled num node returning num4049 (depth = 4)
  return num4049;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4034 = undefined;
  } else {
  }
// compiled if node returning if4034 (depth = 2)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4050 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4051 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4050);
// compiled call node returning call4051 (depth = 3)
// compiled member node returning call4051 (depth = 2)
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4052 = gc_frame_new();
// starting to compile op node (depth = 3)
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4054 == NULL) {
    strlit4054 = alloc_String("instead.");
    gc_root(strlit4054);
  }
// compiled string node returning strlit4054 (depth = 4)
  int op_slot_right_4053 = gc_frame_newslot(strlit4054);
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4057 == NULL) {
    strlit4057 = alloc_String("removed in a future version of the compiler. Use try-catch ");
    gc_root(strlit4057);
  }
// compiled string node returning strlit4057 (depth = 5)
  int op_slot_right_4056 = gc_frame_newslot(strlit4057);
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4059 == NULL) {
    strlit4059 = alloc_String("The catch-case statement is deprecated and will be ");
    gc_root(strlit4059);
  }
// compiled string node returning strlit4059 (depth = 5)
  int op_slot_left_4056 = gc_frame_newslot(strlit4059);
  params[0] = strlit4057;
  partcv[0] = 1;
  Object opresult4060 = callmethod(strlit4059, "++", 1, partcv, params);
// compiled op node returning opresult4060 (depth = 4)
  int op_slot_left_4053 = gc_frame_newslot(opresult4060);
  params[0] = strlit4054;
  partcv[0] = 1;
  Object opresult4061 = callmethod(opresult4060, "++", 1, partcv, params);
// compiled op node returning opresult4061 (depth = 3)
  gc_frame_newslot(opresult4061);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = opresult4061;
  partcv[0] = 1;
  Object call4062 = callmethod(*var_util, "warning",
    1, partcv, params);
  gc_frame_end(callframe4052);
// compiled call node returning call4062 (depth = 2)
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4064 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4065 == NULL) {
    strlit4065 = alloc_String("lbrace");
    gc_root(strlit4065);
  }
// compiled string node returning strlit4065 (depth = 4)
  gc_frame_newslot(strlit4065);
// call case 4: self request
  params[0] = strlit4065;
  partcv[0] = 1;
  Object call4066 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4064);
// compiled call node returning call4066 (depth = 3)
  Object if4063 = done;
  if (istrue(call4066)) {
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4067 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4068 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4067);
// compiled call node returning call4068 (depth = 4)
// compiled member node returning call4068 (depth = 3)
    gc_frame_newslot(call4068);
    if4063 = call4068;
  } else {
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4071 == NULL) {
    strlit4071 = alloc_String("lparen");
    gc_root(strlit4071);
  }
// compiled string node returning strlit4071 (depth = 5)
  int op_slot_right_4070 = gc_frame_newslot(strlit4071);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4073 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4074 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4073);
// compiled call node returning call4074 (depth = 6)
// compiled member node returning call4074 (depth = 5)
  int op_slot_left_4070 = gc_frame_newslot(call4074);
  params[0] = strlit4071;
  partcv[0] = 1;
  Object opresult4075 = callmethod(call4074, "!=", 1, partcv, params);
// compiled op node returning opresult4075 (depth = 4)
  Object if4069 = done;
  if (istrue(opresult4075)) {
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4076 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4077 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4078 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4077);
// compiled call node returning call4078 (depth = 8)
// compiled member node returning call4078 (depth = 7)
  partcv[0] = 0;
  Object call4079 = callmethod(call4078, "new",
    1, partcv, params);
  gc_frame_end(callframe4076);
// compiled call node returning call4079 (depth = 6)
// compiled member node returning call4079 (depth = 5)
  *var_suggestion = call4079;
  if (call4079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4080 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4081 = alloc_Block(NULL, NULL, "parser", 1255);
  gc_frame_newslot(block4081);
// method _apply
  block_savedest(block4081);
  Object closure4082 = createclosure(2, "_apply");
  setclosureframe(closure4082, stackframe);
  addtoclosure(closure4082, var_catchTok);
  addtoclosure(closure4082, selfslot);
  struct UserObject *uo4082 = (struct UserObject*)block4081;
  uo4082->data[0] = (Object)closure4082;
  Method *meth_meth_parser__apply4082 = addmethod2pos(block4081, "_apply", &meth_parser__apply4082, 0);
  int argcv_meth_parser__apply4082[] = {1};
  meth_meth_parser__apply4082->type = alloc_MethodType(1, argcv_meth_parser__apply4082);
  meth_meth_parser__apply4082->definitionModule = modulename;
  meth_meth_parser__apply4082->definitionLine = 1253;
// compiled block node returning block4081 (depth = 6)
  gc_frame_newslot(block4081);
// call case 4: self request
  params[0] = block4081;
  partcv[0] = 1;
  Object call4127 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4080);
// compiled call node returning call4127 (depth = 5)
  *var_nextTok = call4127;
  if (call4127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4130 = alloc_Boolean(0);
// compiled identifier node returning bool4130 (depth = 6)
  int op_slot_right_4129 = gc_frame_newslot(bool4130);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4129 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4130;
  partcv[0] = 1;
  Object opresult4132 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4132 (depth = 5)
  Object if4128 = done;
  if (istrue(opresult4132)) {
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4133 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4134 == NULL) {
    strlit4134 = alloc_String(" {}");
    gc_root(strlit4134);
  }
// compiled string node returning strlit4134 (depth = 6)
  gc_frame_newslot(strlit4134);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4134;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4135 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4133);
// compiled call node returning call4135 (depth = 5)
    gc_frame_newslot(call4135);
    if4128 = call4135;
  } else {
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4138 == NULL) {
    strlit4138 = alloc_String("rbrace");
    gc_root(strlit4138);
  }
// compiled string node returning strlit4138 (depth = 7)
  int op_slot_right_4137 = gc_frame_newslot(strlit4138);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4141 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4140);
// compiled call node returning call4141 (depth = 8)
// compiled member node returning call4141 (depth = 7)
  int op_slot_left_4137 = gc_frame_newslot(call4141);
  params[0] = strlit4138;
  partcv[0] = 1;
  Object opresult4142 = callmethod(call4141, "==", 1, partcv, params);
// compiled op node returning opresult4142 (depth = 6)
  Object if4136 = done;
  if (istrue(opresult4142)) {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4143 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4144 == NULL) {
    strlit4144 = alloc_String(" {");
    gc_root(strlit4144);
  }
// compiled string node returning strlit4144 (depth = 7)
  gc_frame_newslot(strlit4144);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4144;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4145 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4143);
// compiled call node returning call4145 (depth = 6)
    gc_frame_newslot(call4145);
    if4136 = call4145;
  } else {
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4148 == NULL) {
    strlit4148 = alloc_String("rparen");
    gc_root(strlit4148);
  }
// compiled string node returning strlit4148 (depth = 8)
  int op_slot_right_4147 = gc_frame_newslot(strlit4148);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4151 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4150);
// compiled call node returning call4151 (depth = 9)
// compiled member node returning call4151 (depth = 8)
  int op_slot_left_4147 = gc_frame_newslot(call4151);
  params[0] = strlit4148;
  partcv[0] = 1;
  Object opresult4152 = callmethod(call4151, "==", 1, partcv, params);
// compiled op node returning opresult4152 (depth = 7)
  Object if4146 = done;
  if (istrue(opresult4152)) {
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4154 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4154 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4156 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4156 (depth = 8)
  Object if4153 = done;
  if (istrue(opresult4156)) {
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4157 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4158 == NULL) {
    strlit4158 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4158);
  }
// compiled string node returning strlit4158 (depth = 9)
  gc_frame_newslot(strlit4158);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool4159 = alloc_Boolean(1);
// compiled identifier node returning bool4159 (depth = 9)
  gc_frame_newslot(bool4159);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4158;
  params[1] = *var_lastToken;
  params[2] = bool4159;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4160 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4157);
// compiled call node returning call4160 (depth = 8)
    gc_frame_newslot(call4160);
    if4153 = call4160;
  } else {
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4161 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4162 == NULL) {
    strlit4162 = alloc_String("(");
    gc_root(strlit4162);
  }
// compiled string node returning strlit4162 (depth = 9)
  gc_frame_newslot(strlit4162);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool4163 = alloc_Boolean(1);
// compiled identifier node returning bool4163 (depth = 9)
  gc_frame_newslot(bool4163);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4162;
  params[1] = *var_lastToken;
  params[2] = bool4163;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4164 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4161);
// compiled call node returning call4164 (depth = 8)
    gc_frame_newslot(call4164);
    if4153 = call4164;
  }
// compiled if node returning if4153 (depth = 7)
    gc_frame_newslot(if4153);
    if4146 = if4153;
  } else {
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4167 == NULL) {
    strlit4167 = alloc_String("identifier");
    gc_root(strlit4167);
  }
// compiled string node returning strlit4167 (depth = 9)
  int op_slot_right_4166 = gc_frame_newslot(strlit4167);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4169 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4170 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4169);
// compiled call node returning call4170 (depth = 10)
// compiled member node returning call4170 (depth = 9)
  int op_slot_left_4166 = gc_frame_newslot(call4170);
  params[0] = strlit4167;
  partcv[0] = 1;
  Object opresult4171 = callmethod(call4170, "==", 1, partcv, params);
// compiled op node returning opresult4171 (depth = 8)
  Object if4165 = done;
  if (istrue(opresult4171)) {
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4172 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4173 == NULL) {
    strlit4173 = alloc_String(" {");
    gc_root(strlit4173);
  }
// compiled string node returning strlit4173 (depth = 9)
  gc_frame_newslot(strlit4173);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4173;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4174 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4172);
// compiled call node returning call4174 (depth = 8)
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4175 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4176 == NULL) {
    strlit4176 = alloc_String("} ");
    gc_root(strlit4176);
  }
// compiled string node returning strlit4176 (depth = 9)
  gc_frame_newslot(strlit4176);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4176;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4177 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4175);
// compiled call node returning call4177 (depth = 8)
    gc_frame_newslot(call4177);
    if4165 = call4177;
  } else {
  }
// compiled if node returning if4165 (depth = 7)
    gc_frame_newslot(if4165);
    if4146 = if4165;
  }
// compiled if node returning if4146 (depth = 6)
    gc_frame_newslot(if4146);
    if4136 = if4146;
  }
// compiled if node returning if4136 (depth = 5)
    gc_frame_newslot(if4136);
    if4128 = if4136;
  }
// compiled if node returning if4128 (depth = 4)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4178 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4179 == NULL) {
    strlit4179 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit4179);
  }
// compiled string node returning strlit4179 (depth = 5)
  gc_frame_newslot(strlit4179);
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  partcv[0] = 0;
  Object call4181 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4180);
// compiled call node returning call4181 (depth = 6)
// compiled member node returning call4181 (depth = 5)
  gc_frame_newslot(call4181);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4183 = alloc_Float64(1);
// compiled num node returning num4183 (depth = 6)
  int op_slot_right_4182 = gc_frame_newslot(num4183);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call4187 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4186);
// compiled call node returning call4187 (depth = 8)
// compiled member node returning call4187 (depth = 7)
  int op_slot_right_4185 = gc_frame_newslot(call4187);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4189 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call4190 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4189);
// compiled call node returning call4190 (depth = 8)
// compiled member node returning call4190 (depth = 7)
  int op_slot_left_4185 = gc_frame_newslot(call4190);
  params[0] = call4187;
  partcv[0] = 1;
  Object sum4191 = callmethod(call4190, "+", 1, partcv, params);
// compiled op node returning sum4191 (depth = 6)
  int op_slot_left_4182 = gc_frame_newslot(sum4191);
  params[0] = num4183;
  partcv[0] = 1;
  Object sum4192 = callmethod(sum4191, "+", 1, partcv, params);
// compiled op node returning sum4192 (depth = 5)
  gc_frame_newslot(sum4192);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4179;
  params[1] = call4181;
  params[2] = sum4192;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4193 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4178);
// compiled call node returning call4193 (depth = 4)
    gc_frame_newslot(call4193);
    if4069 = call4193;
  } else {
  }
// compiled if node returning if4069 (depth = 3)
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4195 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4194);
// compiled call node returning call4195 (depth = 4)
// compiled member node returning call4195 (depth = 3)
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4197 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4198 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4199 = alloc_Block(NULL, NULL, "parser", 1276);
  gc_frame_newslot(block4199);
// method _apply
  block_savedest(block4199);
  Object closure4200 = createclosure(2, "_apply");
  setclosureframe(closure4200, stackframe);
  addtoclosure(closure4200, var_blocksOK);
  addtoclosure(closure4200, selfslot);
  struct UserObject *uo4200 = (struct UserObject*)block4199;
  uo4200->data[0] = (Object)closure4200;
  Method *meth_meth_parser__apply4200 = addmethod2pos(block4199, "_apply", &meth_parser__apply4200, 0);
  int argcv_meth_parser__apply4200[] = {0};
  meth_meth_parser__apply4200->type = alloc_MethodType(1, argcv_meth_parser__apply4200);
  meth_meth_parser__apply4200->definitionModule = modulename;
  meth_meth_parser__apply4200->definitionLine = 1276;
// compiled block node returning block4199 (depth = 7)
  gc_frame_newslot(block4199);
// call case 4: self request
  params[0] = block4199;
  partcv[0] = 1;
  Object call4204 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4198);
// compiled call node returning call4204 (depth = 6)
  partcv[0] = 0;
  Object call4205 = callmethod(call4204, "not",
    1, partcv, params);
  gc_frame_end(callframe4197);
// compiled call node returning call4205 (depth = 5)
// compiled member node returning call4205 (depth = 4)
  Object if4196 = done;
  if (istrue(call4205)) {
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4206 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4208 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4207);
// compiled call node returning call4208 (depth = 8)
// compiled member node returning call4208 (depth = 7)
  partcv[0] = 0;
  Object call4209 = callmethod(call4208, "new",
    1, partcv, params);
  gc_frame_end(callframe4206);
// compiled call node returning call4209 (depth = 6)
// compiled member node returning call4209 (depth = 5)
  *var_suggestion = call4209;
  if (call4209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4210 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4211 == NULL) {
    strlit4211 = alloc_String("rparen");
    gc_root(strlit4211);
  }
// compiled string node returning strlit4211 (depth = 6)
  gc_frame_newslot(strlit4211);
// call case 4: self request
  params[0] = strlit4211;
  partcv[0] = 1;
  Object call4212 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4210);
// compiled call node returning call4212 (depth = 5)
  *var_nextTok = call4212;
  if (call4212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4214 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4214 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4216 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4216 (depth = 5)
  Object if4213 = done;
  if (istrue(opresult4216)) {
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4217 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4218 == NULL) {
    strlit4218 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4218);
  }
// compiled string node returning strlit4218 (depth = 6)
  gc_frame_newslot(strlit4218);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4218;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4219 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4217);
// compiled call node returning call4219 (depth = 5)
    gc_frame_newslot(call4219);
    if4213 = call4219;
  } else {
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4220 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4222 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4221);
// compiled call node returning call4222 (depth = 7)
// compiled member node returning call4222 (depth = 6)
  gc_frame_newslot(call4222);
// starting to compile identifier node (depth = 6)
  Object bool4223 = alloc_Boolean(1);
// compiled identifier node returning bool4223 (depth = 6)
  gc_frame_newslot(bool4223);
// starting to compile identifier node (depth = 6)
  Object bool4224 = alloc_Boolean(0);
// compiled identifier node returning bool4224 (depth = 6)
  gc_frame_newslot(bool4224);
// starting to compile string node (depth = 6)
  if (strlit4225 == NULL) {
    strlit4225 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4225);
  }
// compiled string node returning strlit4225 (depth = 6)
  gc_frame_newslot(strlit4225);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4222;
  params[2] = bool4223;
  params[3] = bool4224;
  params[4] = strlit4225;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4226 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4220);
// compiled call node returning call4226 (depth = 5)
    gc_frame_newslot(call4226);
    if4213 = call4226;
  }
// compiled if node returning if4213 (depth = 4)
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4227 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4228 == NULL) {
    strlit4228 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit4228);
  }
// compiled string node returning strlit4228 (depth = 5)
  gc_frame_newslot(strlit4228);
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4229 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4230 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4229);
// compiled call node returning call4230 (depth = 6)
// compiled member node returning call4230 (depth = 5)
  gc_frame_newslot(call4230);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4232 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4231);
// compiled call node returning call4232 (depth = 6)
// compiled member node returning call4232 (depth = 5)
  gc_frame_newslot(call4232);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4228;
  params[1] = call4230;
  params[2] = call4232;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4233 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4227);
// compiled call node returning call4233 (depth = 4)
    gc_frame_newslot(call4233);
    if4196 = call4233;
  } else {
  }
// compiled if node returning if4196 (depth = 3)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4236 == NULL) {
    strlit4236 = alloc_String("rparen");
    gc_root(strlit4236);
  }
// compiled string node returning strlit4236 (depth = 5)
  int op_slot_right_4235 = gc_frame_newslot(strlit4236);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4238 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4239 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4238);
// compiled call node returning call4239 (depth = 6)
// compiled member node returning call4239 (depth = 5)
  int op_slot_left_4235 = gc_frame_newslot(call4239);
  params[0] = strlit4236;
  partcv[0] = 1;
  Object opresult4240 = callmethod(call4239, "!=", 1, partcv, params);
// compiled op node returning opresult4240 (depth = 4)
  Object if4234 = done;
  if (istrue(opresult4240)) {
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4242 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4241);
// compiled call node returning call4242 (depth = 5)
// compiled member node returning call4242 (depth = 4)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4243 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4245 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4244);
// compiled call node returning call4245 (depth = 8)
// compiled member node returning call4245 (depth = 7)
  partcv[0] = 0;
  Object call4246 = callmethod(call4245, "new",
    1, partcv, params);
  gc_frame_end(callframe4243);
// compiled call node returning call4246 (depth = 6)
// compiled member node returning call4246 (depth = 5)
  *var_suggestion = call4246;
  if (call4246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4247 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4248 == NULL) {
    strlit4248 = alloc_String(")");
    gc_root(strlit4248);
  }
// compiled string node returning strlit4248 (depth = 5)
  gc_frame_newslot(strlit4248);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4248;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4249 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4247);
// compiled call node returning call4249 (depth = 4)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4250 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4251 == NULL) {
    strlit4251 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4251);
  }
// compiled string node returning strlit4251 (depth = 5)
  gc_frame_newslot(strlit4251);
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4253 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4252);
// compiled call node returning call4253 (depth = 6)
// compiled member node returning call4253 (depth = 5)
  gc_frame_newslot(call4253);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4255 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4256 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4255);
// compiled call node returning call4256 (depth = 7)
// compiled member node returning call4256 (depth = 6)
  int op_slot_right_4254 = gc_frame_newslot(call4256);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4258 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4259 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4258);
// compiled call node returning call4259 (depth = 7)
// compiled member node returning call4259 (depth = 6)
  int op_slot_left_4254 = gc_frame_newslot(call4259);
  params[0] = call4256;
  partcv[0] = 1;
  Object sum4260 = callmethod(call4259, "+", 1, partcv, params);
// compiled op node returning sum4260 (depth = 5)
  gc_frame_newslot(sum4260);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4251;
  params[1] = call4253;
  params[2] = sum4260;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4261 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4250);
// compiled call node returning call4261 (depth = 4)
    gc_frame_newslot(call4261);
    if4234 = call4261;
  } else {
  }
// compiled if node returning if4234 (depth = 3)
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4262 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4263 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4262);
// compiled call node returning call4263 (depth = 4)
// compiled member node returning call4263 (depth = 3)
    gc_frame_newslot(call4263);
    if4063 = call4263;
  }
// compiled if node returning if4063 (depth = 2)
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4264 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4265 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4264);
// compiled call node returning call4265 (depth = 4)
// compiled member node returning call4265 (depth = 3)
  *var_mainblock = call4265;
  if (call4265 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4266 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4266 (depth = 3)
  *var_cases = array4266;
  if (array4266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4267 = alloc_Boolean(0);
// compiled identifier node returning bool4267 (depth = 3)
  *var_finally = bool4267;
  if (bool4267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4268 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4269 = alloc_Block(NULL, NULL, "parser", 1299);
  gc_frame_newslot(block4269);
// method _apply
  block_savedest(block4269);
  Object closure4270 = createclosure(2, "_apply");
  setclosureframe(closure4270, stackframe);
  addtoclosure(closure4270, var_sym);
  addtoclosure(closure4270, selfslot);
  struct UserObject *uo4270 = (struct UserObject*)block4269;
  uo4270->data[0] = (Object)closure4270;
  Method *meth_meth_parser__apply4270 = addmethod2pos(block4269, "_apply", &meth_parser__apply4270, 0);
  int argcv_meth_parser__apply4270[] = {0};
  meth_meth_parser__apply4270->type = alloc_MethodType(1, argcv_meth_parser__apply4270);
  meth_meth_parser__apply4270->definitionModule = modulename;
  meth_meth_parser__apply4270->definitionLine = 1296;
// compiled block node returning block4269 (depth = 3)
  gc_frame_newslot(block4269);
// starting to compile block node (depth = 3)
  Object block4284 = alloc_Block(NULL, NULL, "parser", 1299);
  gc_frame_newslot(block4284);
// method _apply
  block_savedest(block4284);
  Object closure4285 = createclosure(8, "_apply");
  setclosureframe(closure4285, stackframe);
  addtoclosure(closure4285, var_blocksOK);
  addtoclosure(closure4285, var_errormessages);
  addtoclosure(closure4285, var_sym);
  addtoclosure(closure4285, var_lastToken);
  addtoclosure(closure4285, var_tokens);
  addtoclosure(closure4285, var_values);
  addtoclosure(closure4285, var_cases);
  addtoclosure(closure4285, selfslot);
  struct UserObject *uo4285 = (struct UserObject*)block4284;
  uo4285->data[0] = (Object)closure4285;
  Method *meth_meth_parser__apply4285 = addmethod2pos(block4284, "_apply", &meth_parser__apply4285, 0);
  int argcv_meth_parser__apply4285[] = {0};
  meth_meth_parser__apply4285->type = alloc_MethodType(1, argcv_meth_parser__apply4285);
  meth_meth_parser__apply4285->definitionModule = modulename;
  meth_meth_parser__apply4285->definitionLine = 1299;
// compiled block node returning block4284 (depth = 3)
  gc_frame_newslot(block4284);
// call case 5: prelude request
  params[0] = block4269;
  params[1] = block4284;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4434 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4268);
// compiled call node returning call4434 (depth = 2)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4438 == NULL) {
    strlit4438 = alloc_String("finally");
    gc_root(strlit4438);
  }
// compiled string node returning strlit4438 (depth = 5)
  int op_slot_right_4437 = gc_frame_newslot(strlit4438);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4440 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4441 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4440);
// compiled call node returning call4441 (depth = 6)
// compiled member node returning call4441 (depth = 5)
  int op_slot_left_4437 = gc_frame_newslot(call4441);
  params[0] = strlit4438;
  partcv[0] = 1;
  Object opresult4442 = callmethod(call4441, "==", 1, partcv, params);
// compiled op node returning opresult4442 (depth = 4)
  int op_slot_right_4436 = gc_frame_newslot(opresult4442);
// starting to compile call node (depth = 4)
  int callframe4444 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4445 == NULL) {
    strlit4445 = alloc_String("identifier");
    gc_root(strlit4445);
  }
// compiled string node returning strlit4445 (depth = 5)
  gc_frame_newslot(strlit4445);
// call case 4: self request
  params[0] = strlit4445;
  partcv[0] = 1;
  Object call4446 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4444);
// compiled call node returning call4446 (depth = 4)
  int op_slot_left_4436 = gc_frame_newslot(call4446);
  params[0] = opresult4442;
  partcv[0] = 1;
  Object opresult4447 = callmethod(call4446, "&&", 1, partcv, params);
// compiled op node returning opresult4447 (depth = 3)
  Object if4435 = done;
  if (istrue(opresult4447)) {
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4448 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4449 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4448);
// compiled call node returning call4449 (depth = 4)
// compiled member node returning call4449 (depth = 3)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4451 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4452 == NULL) {
    strlit4452 = alloc_String("lbrace");
    gc_root(strlit4452);
  }
// compiled string node returning strlit4452 (depth = 5)
  gc_frame_newslot(strlit4452);
// call case 4: self request
  params[0] = strlit4452;
  partcv[0] = 1;
  Object call4453 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4451);
// compiled call node returning call4453 (depth = 4)
  Object if4450 = done;
  if (istrue(call4453)) {
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4454 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4455 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4454);
// compiled call node returning call4455 (depth = 5)
// compiled member node returning call4455 (depth = 4)
    gc_frame_newslot(call4455);
    if4450 = call4455;
  } else {
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4457 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4458 == NULL) {
    strlit4458 = alloc_String("lparen");
    gc_root(strlit4458);
  }
// compiled string node returning strlit4458 (depth = 6)
  gc_frame_newslot(strlit4458);
// call case 4: self request
  params[0] = strlit4458;
  partcv[0] = 1;
  Object call4459 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4457);
// compiled call node returning call4459 (depth = 5)
  Object if4456 = done;
  if (istrue(call4459)) {
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4461 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4460);
// compiled call node returning call4461 (depth = 6)
// compiled member node returning call4461 (depth = 5)
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4463 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe4464 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block4465 = alloc_Block(NULL, NULL, "parser", 1354);
  gc_frame_newslot(block4465);
// method _apply
  block_savedest(block4465);
  Object closure4466 = createclosure(2, "_apply");
  setclosureframe(closure4466, stackframe);
  addtoclosure(closure4466, var_blocksOK);
  addtoclosure(closure4466, selfslot);
  struct UserObject *uo4466 = (struct UserObject*)block4465;
  uo4466->data[0] = (Object)closure4466;
  Method *meth_meth_parser__apply4466 = addmethod2pos(block4465, "_apply", &meth_parser__apply4466, 0);
  int argcv_meth_parser__apply4466[] = {0};
  meth_meth_parser__apply4466->type = alloc_MethodType(1, argcv_meth_parser__apply4466);
  meth_meth_parser__apply4466->definitionModule = modulename;
  meth_meth_parser__apply4466->definitionLine = 1354;
// compiled block node returning block4465 (depth = 9)
  gc_frame_newslot(block4465);
// call case 4: self request
  params[0] = block4465;
  partcv[0] = 1;
  Object call4470 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4464);
// compiled call node returning call4470 (depth = 8)
  partcv[0] = 0;
  Object call4471 = callmethod(call4470, "not",
    1, partcv, params);
  gc_frame_end(callframe4463);
// compiled call node returning call4471 (depth = 7)
// compiled member node returning call4471 (depth = 6)
  Object if4462 = done;
  if (istrue(call4471)) {
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4472 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4474 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4473);
// compiled call node returning call4474 (depth = 10)
// compiled member node returning call4474 (depth = 9)
  partcv[0] = 0;
  Object call4475 = callmethod(call4474, "new",
    1, partcv, params);
  gc_frame_end(callframe4472);
// compiled call node returning call4475 (depth = 8)
// compiled member node returning call4475 (depth = 7)
  *var_suggestion = call4475;
  if (call4475 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4476 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4477 == NULL) {
    strlit4477 = alloc_String("rparen");
    gc_root(strlit4477);
  }
// compiled string node returning strlit4477 (depth = 8)
  gc_frame_newslot(strlit4477);
// call case 4: self request
  params[0] = strlit4477;
  partcv[0] = 1;
  Object call4478 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4476);
// compiled call node returning call4478 (depth = 7)
  *var_nextTok = call4478;
  if (call4478 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4480 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4480 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4482 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4482 (depth = 7)
  Object if4479 = done;
  if (istrue(opresult4482)) {
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4483 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4484 == NULL) {
    strlit4484 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4484);
  }
// compiled string node returning strlit4484 (depth = 8)
  gc_frame_newslot(strlit4484);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4484;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4485 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4483);
// compiled call node returning call4485 (depth = 7)
    gc_frame_newslot(call4485);
    if4479 = call4485;
  } else {
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4486 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4487 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4488 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4487);
// compiled call node returning call4488 (depth = 9)
// compiled member node returning call4488 (depth = 8)
  gc_frame_newslot(call4488);
// starting to compile identifier node (depth = 8)
  Object bool4489 = alloc_Boolean(1);
// compiled identifier node returning bool4489 (depth = 8)
  gc_frame_newslot(bool4489);
// starting to compile identifier node (depth = 8)
  Object bool4490 = alloc_Boolean(0);
// compiled identifier node returning bool4490 (depth = 8)
  gc_frame_newslot(bool4490);
// starting to compile string node (depth = 8)
  if (strlit4491 == NULL) {
    strlit4491 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4491);
  }
// compiled string node returning strlit4491 (depth = 8)
  gc_frame_newslot(strlit4491);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4488;
  params[2] = bool4489;
  params[3] = bool4490;
  params[4] = strlit4491;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4492 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4486);
// compiled call node returning call4492 (depth = 7)
    gc_frame_newslot(call4492);
    if4479 = call4492;
  }
// compiled if node returning if4479 (depth = 6)
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4493 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4494 == NULL) {
    strlit4494 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4494);
  }
// compiled string node returning strlit4494 (depth = 7)
  gc_frame_newslot(strlit4494);
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4496 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4495);
// compiled call node returning call4496 (depth = 8)
// compiled member node returning call4496 (depth = 7)
  gc_frame_newslot(call4496);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4497 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4498 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4497);
// compiled call node returning call4498 (depth = 8)
// compiled member node returning call4498 (depth = 7)
  gc_frame_newslot(call4498);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4494;
  params[1] = call4496;
  params[2] = call4498;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4499 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4493);
// compiled call node returning call4499 (depth = 6)
    gc_frame_newslot(call4499);
    if4462 = call4499;
  } else {
  }
// compiled if node returning if4462 (depth = 5)
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4502 == NULL) {
    strlit4502 = alloc_String("rparen");
    gc_root(strlit4502);
  }
// compiled string node returning strlit4502 (depth = 7)
  int op_slot_right_4501 = gc_frame_newslot(strlit4502);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4504 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4505 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4504);
// compiled call node returning call4505 (depth = 8)
// compiled member node returning call4505 (depth = 7)
  int op_slot_left_4501 = gc_frame_newslot(call4505);
  params[0] = strlit4502;
  partcv[0] = 1;
  Object opresult4506 = callmethod(call4505, "!=", 1, partcv, params);
// compiled op node returning opresult4506 (depth = 6)
  Object if4500 = done;
  if (istrue(opresult4506)) {
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4507 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4508 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4507);
// compiled call node returning call4508 (depth = 7)
// compiled member node returning call4508 (depth = 6)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4509 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4511 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4510);
// compiled call node returning call4511 (depth = 10)
// compiled member node returning call4511 (depth = 9)
  partcv[0] = 0;
  Object call4512 = callmethod(call4511, "new",
    1, partcv, params);
  gc_frame_end(callframe4509);
// compiled call node returning call4512 (depth = 8)
// compiled member node returning call4512 (depth = 7)
  *var_suggestion = call4512;
  if (call4512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4513 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4514 == NULL) {
    strlit4514 = alloc_String(")");
    gc_root(strlit4514);
  }
// compiled string node returning strlit4514 (depth = 7)
  gc_frame_newslot(strlit4514);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4514;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4515 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4513);
// compiled call node returning call4515 (depth = 6)
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4516 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4517 == NULL) {
    strlit4517 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4517);
  }
// compiled string node returning strlit4517 (depth = 7)
  gc_frame_newslot(strlit4517);
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4519 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4518);
// compiled call node returning call4519 (depth = 8)
// compiled member node returning call4519 (depth = 7)
  gc_frame_newslot(call4519);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4522 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4521);
// compiled call node returning call4522 (depth = 9)
// compiled member node returning call4522 (depth = 8)
  int op_slot_right_4520 = gc_frame_newslot(call4522);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4525 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4524);
// compiled call node returning call4525 (depth = 9)
// compiled member node returning call4525 (depth = 8)
  int op_slot_left_4520 = gc_frame_newslot(call4525);
  params[0] = call4522;
  partcv[0] = 1;
  Object sum4526 = callmethod(call4525, "+", 1, partcv, params);
// compiled op node returning sum4526 (depth = 7)
  gc_frame_newslot(sum4526);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4517;
  params[1] = call4519;
  params[2] = sum4526;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4527 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4516);
// compiled call node returning call4527 (depth = 6)
    gc_frame_newslot(call4527);
    if4500 = call4527;
  } else {
  }
// compiled if node returning if4500 (depth = 5)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4528 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4529 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4528);
// compiled call node returning call4529 (depth = 6)
// compiled member node returning call4529 (depth = 5)
    gc_frame_newslot(call4529);
    if4456 = call4529;
  } else {
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4530 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4531 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4532 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4531);
// compiled call node returning call4532 (depth = 9)
// compiled member node returning call4532 (depth = 8)
  partcv[0] = 0;
  Object call4533 = callmethod(call4532, "empty",
    1, partcv, params);
  gc_frame_end(callframe4530);
// compiled call node returning call4533 (depth = 7)
// compiled member node returning call4533 (depth = 6)
  *var_suggestions = call4533;
  if (call4533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4534 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4535 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4534);
// compiled call node returning call4535 (depth = 6)
  *var_nextTok = call4535;
  if (call4535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4536 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4538 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4537);
// compiled call node returning call4538 (depth = 9)
// compiled member node returning call4538 (depth = 8)
  partcv[0] = 0;
  Object call4539 = callmethod(call4538, "new",
    1, partcv, params);
  gc_frame_end(callframe4536);
// compiled call node returning call4539 (depth = 7)
// compiled member node returning call4539 (depth = 6)
  *var_suggestion = call4539;
  if (call4539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool4542 = alloc_Boolean(0);
// compiled identifier node returning bool4542 (depth = 7)
  int op_slot_right_4541 = gc_frame_newslot(bool4542);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4541 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4542;
  partcv[0] = 1;
  Object opresult4544 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4544 (depth = 6)
  Object if4540 = done;
  if (istrue(opresult4544)) {
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4545 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4546 == NULL) {
    strlit4546 = alloc_String(" }");
    gc_root(strlit4546);
  }
// compiled string node returning strlit4546 (depth = 7)
  gc_frame_newslot(strlit4546);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call4548 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 8)
// compiled member node returning call4548 (depth = 7)
  gc_frame_newslot(call4548);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4546;
  params[1] = call4548;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4549 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4545);
// compiled call node returning call4549 (depth = 6)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4550 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4551 == NULL) {
    strlit4551 = alloc_String(" {");
    gc_root(strlit4551);
  }
// compiled string node returning strlit4551 (depth = 7)
  gc_frame_newslot(strlit4551);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4551;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4552 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4550);
// compiled call node returning call4552 (depth = 6)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4553 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4554 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4553);
// compiled call node returning call4554 (depth = 6)
    gc_frame_newslot(call4554);
    if4540 = call4554;
  } else {
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4556 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4556 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4558 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4558 (depth = 7)
  Object if4555 = done;
  if (istrue(opresult4558)) {
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4559 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4560 == NULL) {
    strlit4560 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4560);
  }
// compiled string node returning strlit4560 (depth = 8)
  gc_frame_newslot(strlit4560);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4560;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4561 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4559);
// compiled call node returning call4561 (depth = 7)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4562 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4563 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4562);
// compiled call node returning call4563 (depth = 7)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4564 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4566 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4565);
// compiled call node returning call4566 (depth = 11)
// compiled member node returning call4566 (depth = 10)
  partcv[0] = 0;
  Object call4567 = callmethod(call4566, "new",
    1, partcv, params);
  gc_frame_end(callframe4564);
// compiled call node returning call4567 (depth = 9)
// compiled member node returning call4567 (depth = 8)
  *var_suggestion = call4567;
  if (call4567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4569 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4570 == NULL) {
    strlit4570 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit4570);
  }
// compiled string node returning strlit4570 (depth = 8)
  gc_frame_newslot(strlit4570);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4570;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4571 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4569);
// compiled call node returning call4571 (depth = 7)
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4572 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4573 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4572);
// compiled call node returning call4573 (depth = 7)
    gc_frame_newslot(call4573);
    if4555 = call4573;
  } else {
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4574 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4575 == NULL) {
    strlit4575 = alloc_String(" }");
    gc_root(strlit4575);
  }
// compiled string node returning strlit4575 (depth = 8)
  gc_frame_newslot(strlit4575);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4577 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4576);
// compiled call node returning call4577 (depth = 9)
// compiled member node returning call4577 (depth = 8)
  gc_frame_newslot(call4577);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4575;
  params[1] = call4577;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4578 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4574);
// compiled call node returning call4578 (depth = 7)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4579 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4580 == NULL) {
    strlit4580 = alloc_String(" {");
    gc_root(strlit4580);
  }
// compiled string node returning strlit4580 (depth = 8)
  gc_frame_newslot(strlit4580);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4580;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4581 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4579);
// compiled call node returning call4581 (depth = 7)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4582 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4583 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4582);
// compiled call node returning call4583 (depth = 7)
    gc_frame_newslot(call4583);
    if4555 = call4583;
  }
// compiled if node returning if4555 (depth = 6)
    gc_frame_newslot(if4555);
    if4540 = if4555;
  }
// compiled if node returning if4540 (depth = 5)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4584 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4585 == NULL) {
    strlit4585 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4585);
  }
// compiled string node returning strlit4585 (depth = 6)
  gc_frame_newslot(strlit4585);
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4586 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4587 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4586);
// compiled call node returning call4587 (depth = 7)
// compiled member node returning call4587 (depth = 6)
  gc_frame_newslot(call4587);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4588 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4589 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4588);
// compiled call node returning call4589 (depth = 7)
// compiled member node returning call4589 (depth = 6)
  gc_frame_newslot(call4589);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4585;
  params[1] = call4587;
  params[2] = call4589;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4590 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4584);
// compiled call node returning call4590 (depth = 5)
    gc_frame_newslot(call4590);
    if4456 = call4590;
  }
// compiled if node returning if4456 (depth = 4)
    gc_frame_newslot(if4456);
    if4450 = if4456;
  }
// compiled if node returning if4450 (depth = 3)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4591 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4592 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4591);
// compiled call node returning call4592 (depth = 5)
// compiled member node returning call4592 (depth = 4)
  *var_finally = call4592;
  if (call4592 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if4435 = done;
  } else {
  }
// compiled if node returning if4435 (depth = 2)
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4594 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4595 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4596 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4595);
// compiled call node returning call4596 (depth = 4)
// compiled member node returning call4596 (depth = 3)
  gc_frame_newslot(call4596);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4598 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4597);
// compiled call node returning call4598 (depth = 4)
// compiled member node returning call4598 (depth = 3)
  gc_frame_newslot(call4598);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4596;
  params[1] = call4598;
  partcv[0] = 2;
  Object call4599 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4594);
// compiled call node returning call4599 (depth = 2)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4600 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4601 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4602 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4603 = callmethod(*var_ast, "catchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4602);
// compiled call node returning call4603 (depth = 5)
// compiled member node returning call4603 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4604 = callmethod(call4603, "new",
    1, partcv, params);
  gc_frame_end(callframe4601);
// compiled call node returning call4604 (depth = 3)
  gc_frame_newslot(call4604);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4604;
  partcv[0] = 1;
  Object call4605 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4600);
// compiled call node returning call4605 (depth = 2)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4639(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4643 == NULL) {
    strlit4643 = alloc_String("case");
    gc_root(strlit4643);
  }
// compiled string node returning strlit4643 (depth = 9)
  int op_slot_right_4642 = gc_frame_newslot(strlit4643);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4645 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4646 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4645);
// compiled call node returning call4646 (depth = 10)
// compiled member node returning call4646 (depth = 9)
  int op_slot_left_4642 = gc_frame_newslot(call4646);
  params[0] = strlit4643;
  partcv[0] = 1;
  Object opresult4647 = callmethod(call4646, "==", 1, partcv, params);
// compiled op node returning opresult4647 (depth = 8)
  int op_slot_right_4641 = gc_frame_newslot(opresult4647);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4650 == NULL) {
    strlit4650 = alloc_String("identifier");
    gc_root(strlit4650);
  }
// compiled string node returning strlit4650 (depth = 9)
  int op_slot_right_4649 = gc_frame_newslot(strlit4650);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4652 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4653 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4652);
// compiled call node returning call4653 (depth = 10)
// compiled member node returning call4653 (depth = 9)
  int op_slot_left_4649 = gc_frame_newslot(call4653);
  params[0] = strlit4650;
  partcv[0] = 1;
  Object opresult4654 = callmethod(call4653, "==", 1, partcv, params);
// compiled op node returning opresult4654 (depth = 8)
  int op_slot_left_4641 = gc_frame_newslot(opresult4654);
  params[0] = opresult4647;
  partcv[0] = 1;
  Object opresult4655 = callmethod(opresult4654, "&&", 1, partcv, params);
// compiled op node returning opresult4655 (depth = 7)
  int op_slot_right_4640 = gc_frame_newslot(opresult4655);
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_matchTok (depth = 11)
  partcv[0] = 0;
  Object call4660 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4659);
// compiled call node returning call4660 (depth = 10)
// compiled member node returning call4660 (depth = 9)
  int op_slot_right_4658 = gc_frame_newslot(call4660);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4663 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4662);
// compiled call node returning call4663 (depth = 10)
// compiled member node returning call4663 (depth = 9)
  int op_slot_left_4658 = gc_frame_newslot(call4663);
  params[0] = call4660;
  partcv[0] = 1;
  Object opresult4664 = callmethod(call4663, "==", 1, partcv, params);
// compiled op node returning opresult4664 (depth = 8)
  int op_slot_right_4657 = gc_frame_newslot(opresult4664);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4667 == NULL) {
    strlit4667 = alloc_String("rparen");
    gc_root(strlit4667);
  }
// compiled string node returning strlit4667 (depth = 9)
  int op_slot_right_4666 = gc_frame_newslot(strlit4667);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4669 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4670 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4669);
// compiled call node returning call4670 (depth = 10)
// compiled member node returning call4670 (depth = 9)
  int op_slot_left_4666 = gc_frame_newslot(call4670);
  params[0] = strlit4667;
  partcv[0] = 1;
  Object opresult4671 = callmethod(call4670, "==", 1, partcv, params);
// compiled op node returning opresult4671 (depth = 8)
  int op_slot_left_4657 = gc_frame_newslot(opresult4671);
  params[0] = opresult4664;
  partcv[0] = 1;
  Object opresult4672 = callmethod(opresult4671, "&&", 1, partcv, params);
// compiled op node returning opresult4672 (depth = 7)
  int op_slot_left_4640 = gc_frame_newslot(opresult4672);
  params[0] = opresult4655;
  partcv[0] = 1;
  Object opresult4673 = callmethod(opresult4672, "||", 1, partcv, params);
// compiled op node returning opresult4673 (depth = 6)
  gc_frame_end(frame);
  return opresult4673;
}
Object meth_parser__apply4735(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4736 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4737 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4736);
// compiled call node returning call4737 (depth = 7)
  gc_frame_end(frame);
  return call4737;
}
Object meth_parser__apply4805(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4808 == NULL) {
    strlit4808 = alloc_String("case");
    gc_root(strlit4808);
  }
// compiled string node returning strlit4808 (depth = 6)
  int op_slot_right_4807 = gc_frame_newslot(strlit4808);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4811 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4810);
// compiled call node returning call4811 (depth = 7)
// compiled member node returning call4811 (depth = 6)
  int op_slot_left_4807 = gc_frame_newslot(call4811);
  params[0] = strlit4808;
  partcv[0] = 1;
  Object opresult4812 = callmethod(call4811, "==", 1, partcv, params);
// compiled op node returning opresult4812 (depth = 5)
  int op_slot_right_4806 = gc_frame_newslot(opresult4812);
// starting to compile call node (depth = 5)
  int callframe4814 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4815 == NULL) {
    strlit4815 = alloc_String("identifier");
    gc_root(strlit4815);
  }
// compiled string node returning strlit4815 (depth = 6)
  gc_frame_newslot(strlit4815);
// call case 4: self request
  params[0] = strlit4815;
  partcv[0] = 1;
  Object call4816 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4814);
// compiled call node returning call4816 (depth = 5)
  int op_slot_left_4806 = gc_frame_newslot(call4816);
  params[0] = opresult4812;
  partcv[0] = 1;
  Object opresult4817 = callmethod(call4816, "&&", 1, partcv, params);
// compiled op node returning opresult4817 (depth = 4)
  gc_frame_end(frame);
  return opresult4817;
}
Object meth_parser__apply4839(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe4840 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4841 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4840);
// compiled call node returning call4841 (depth = 11)
  gc_frame_end(frame);
  return call4841;
}
Object meth_parser__apply4820(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4821 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4822 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4821);
// compiled call node returning call4822 (depth = 5)
// compiled member node returning call4822 (depth = 4)
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4824 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4825 == NULL) {
    strlit4825 = alloc_String("lbrace");
    gc_root(strlit4825);
  }
// compiled string node returning strlit4825 (depth = 6)
  gc_frame_newslot(strlit4825);
// call case 4: self request
  params[0] = strlit4825;
  partcv[0] = 1;
  Object call4826 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4824);
// compiled call node returning call4826 (depth = 5)
  Object if4823 = done;
  if (istrue(call4826)) {
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4828 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4827);
// compiled call node returning call4828 (depth = 6)
// compiled member node returning call4828 (depth = 5)
    gc_frame_newslot(call4828);
    if4823 = call4828;
  } else {
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4830 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4831 == NULL) {
    strlit4831 = alloc_String("lparen");
    gc_root(strlit4831);
  }
// compiled string node returning strlit4831 (depth = 7)
  gc_frame_newslot(strlit4831);
// call case 4: self request
  params[0] = strlit4831;
  partcv[0] = 1;
  Object call4832 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4830);
// compiled call node returning call4832 (depth = 6)
  Object if4829 = done;
  if (istrue(call4832)) {
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4833 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4834 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4833);
// compiled call node returning call4834 (depth = 7)
// compiled member node returning call4834 (depth = 6)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4836 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe4837 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block4838 = alloc_Block(NULL, NULL, "parser", 1457);
  gc_frame_newslot(block4838);
// method _apply
  block_savedest(block4838);
  Object closure4839 = createclosure(2, "_apply");
  setclosureframe(closure4839, stackframe);
  addtoclosure(closure4839, var_blocksOK);
  addtoclosure(closure4839, selfslot);
  struct UserObject *uo4839 = (struct UserObject*)block4838;
  uo4839->data[0] = (Object)closure4839;
  Method *meth_meth_parser__apply4839 = addmethod2pos(block4838, "_apply", &meth_parser__apply4839, 0);
  int argcv_meth_parser__apply4839[] = {0};
  meth_meth_parser__apply4839->type = alloc_MethodType(1, argcv_meth_parser__apply4839);
  meth_meth_parser__apply4839->definitionModule = modulename;
  meth_meth_parser__apply4839->definitionLine = 1457;
// compiled block node returning block4838 (depth = 10)
  gc_frame_newslot(block4838);
// call case 4: self request
  params[0] = block4838;
  partcv[0] = 1;
  Object call4843 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4837);
// compiled call node returning call4843 (depth = 9)
  partcv[0] = 0;
  Object call4844 = callmethod(call4843, "not",
    1, partcv, params);
  gc_frame_end(callframe4836);
// compiled call node returning call4844 (depth = 8)
// compiled member node returning call4844 (depth = 7)
  Object if4835 = done;
  if (istrue(call4844)) {
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4845 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4846 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4847 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4846);
// compiled call node returning call4847 (depth = 11)
// compiled member node returning call4847 (depth = 10)
  partcv[0] = 0;
  Object call4848 = callmethod(call4847, "new",
    1, partcv, params);
  gc_frame_end(callframe4845);
// compiled call node returning call4848 (depth = 9)
// compiled member node returning call4848 (depth = 8)
  *var_suggestion = call4848;
  if (call4848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4849 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4850 == NULL) {
    strlit4850 = alloc_String("rparen");
    gc_root(strlit4850);
  }
// compiled string node returning strlit4850 (depth = 9)
  gc_frame_newslot(strlit4850);
// call case 4: self request
  params[0] = strlit4850;
  partcv[0] = 1;
  Object call4851 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4849);
// compiled call node returning call4851 (depth = 8)
  *var_nextTok = call4851;
  if (call4851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4853 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4853 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4855 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4855 (depth = 8)
  Object if4852 = done;
  if (istrue(opresult4855)) {
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4856 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4857 == NULL) {
    strlit4857 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4857);
  }
// compiled string node returning strlit4857 (depth = 9)
  gc_frame_newslot(strlit4857);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4857;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4858 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4856);
// compiled call node returning call4858 (depth = 8)
    gc_frame_newslot(call4858);
    if4852 = call4858;
  } else {
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4859 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4861 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4860);
// compiled call node returning call4861 (depth = 10)
// compiled member node returning call4861 (depth = 9)
  gc_frame_newslot(call4861);
// starting to compile identifier node (depth = 9)
  Object bool4862 = alloc_Boolean(1);
// compiled identifier node returning bool4862 (depth = 9)
  gc_frame_newslot(bool4862);
// starting to compile identifier node (depth = 9)
  Object bool4863 = alloc_Boolean(0);
// compiled identifier node returning bool4863 (depth = 9)
  gc_frame_newslot(bool4863);
// starting to compile string node (depth = 9)
  if (strlit4864 == NULL) {
    strlit4864 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4864);
  }
// compiled string node returning strlit4864 (depth = 9)
  gc_frame_newslot(strlit4864);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4861;
  params[2] = bool4862;
  params[3] = bool4863;
  params[4] = strlit4864;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4865 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4859);
// compiled call node returning call4865 (depth = 8)
    gc_frame_newslot(call4865);
    if4852 = call4865;
  }
// compiled if node returning if4852 (depth = 7)
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4866 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4867 == NULL) {
    strlit4867 = alloc_String("A match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4867);
  }
// compiled string node returning strlit4867 (depth = 8)
  gc_frame_newslot(strlit4867);
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4869 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4868);
// compiled call node returning call4869 (depth = 9)
// compiled member node returning call4869 (depth = 8)
  gc_frame_newslot(call4869);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4870 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4871 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4870);
// compiled call node returning call4871 (depth = 9)
// compiled member node returning call4871 (depth = 8)
  gc_frame_newslot(call4871);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4867;
  params[1] = call4869;
  params[2] = call4871;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4872 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4866);
// compiled call node returning call4872 (depth = 7)
    gc_frame_newslot(call4872);
    if4835 = call4872;
  } else {
  }
// compiled if node returning if4835 (depth = 6)
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4875 == NULL) {
    strlit4875 = alloc_String("rparen");
    gc_root(strlit4875);
  }
// compiled string node returning strlit4875 (depth = 8)
  int op_slot_right_4874 = gc_frame_newslot(strlit4875);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4877 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4878 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4877);
// compiled call node returning call4878 (depth = 9)
// compiled member node returning call4878 (depth = 8)
  int op_slot_left_4874 = gc_frame_newslot(call4878);
  params[0] = strlit4875;
  partcv[0] = 1;
  Object opresult4879 = callmethod(call4878, "!=", 1, partcv, params);
// compiled op node returning opresult4879 (depth = 7)
  Object if4873 = done;
  if (istrue(opresult4879)) {
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4881 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4880);
// compiled call node returning call4881 (depth = 8)
// compiled member node returning call4881 (depth = 7)
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4882 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4883 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4884 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4883);
// compiled call node returning call4884 (depth = 11)
// compiled member node returning call4884 (depth = 10)
  partcv[0] = 0;
  Object call4885 = callmethod(call4884, "new",
    1, partcv, params);
  gc_frame_end(callframe4882);
// compiled call node returning call4885 (depth = 9)
// compiled member node returning call4885 (depth = 8)
  *var_suggestion = call4885;
  if (call4885 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4886 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4887 == NULL) {
    strlit4887 = alloc_String(")");
    gc_root(strlit4887);
  }
// compiled string node returning strlit4887 (depth = 8)
  gc_frame_newslot(strlit4887);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4887;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4888 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4886);
// compiled call node returning call4888 (depth = 7)
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4889 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4890 == NULL) {
    strlit4890 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4890);
  }
// compiled string node returning strlit4890 (depth = 8)
  gc_frame_newslot(strlit4890);
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4892 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4891);
// compiled call node returning call4892 (depth = 9)
// compiled member node returning call4892 (depth = 8)
  gc_frame_newslot(call4892);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4895 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4894);
// compiled call node returning call4895 (depth = 10)
// compiled member node returning call4895 (depth = 9)
  int op_slot_right_4893 = gc_frame_newslot(call4895);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4897 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4898 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4897);
// compiled call node returning call4898 (depth = 10)
// compiled member node returning call4898 (depth = 9)
  int op_slot_left_4893 = gc_frame_newslot(call4898);
  params[0] = call4895;
  partcv[0] = 1;
  Object sum4899 = callmethod(call4898, "+", 1, partcv, params);
// compiled op node returning sum4899 (depth = 8)
  gc_frame_newslot(sum4899);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4890;
  params[1] = call4892;
  params[2] = sum4899;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4900 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4889);
// compiled call node returning call4900 (depth = 7)
    gc_frame_newslot(call4900);
    if4873 = call4900;
  } else {
  }
// compiled if node returning if4873 (depth = 6)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4901 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4902 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4901);
// compiled call node returning call4902 (depth = 7)
// compiled member node returning call4902 (depth = 6)
    gc_frame_newslot(call4902);
    if4829 = call4902;
  } else {
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4903 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4904 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4905 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4904);
// compiled call node returning call4905 (depth = 10)
// compiled member node returning call4905 (depth = 9)
  partcv[0] = 0;
  Object call4906 = callmethod(call4905, "empty",
    1, partcv, params);
  gc_frame_end(callframe4903);
// compiled call node returning call4906 (depth = 8)
// compiled member node returning call4906 (depth = 7)
  *var_suggestions = call4906;
  if (call4906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4907 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4908 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4907);
// compiled call node returning call4908 (depth = 7)
  *var_nextTok = call4908;
  if (call4908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4909 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4910 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4911 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4910);
// compiled call node returning call4911 (depth = 10)
// compiled member node returning call4911 (depth = 9)
  partcv[0] = 0;
  Object call4912 = callmethod(call4911, "new",
    1, partcv, params);
  gc_frame_end(callframe4909);
// compiled call node returning call4912 (depth = 8)
// compiled member node returning call4912 (depth = 7)
  *var_suggestion = call4912;
  if (call4912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4915 = alloc_Boolean(0);
// compiled identifier node returning bool4915 (depth = 8)
  int op_slot_right_4914 = gc_frame_newslot(bool4915);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4914 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4915;
  partcv[0] = 1;
  Object opresult4917 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4917 (depth = 7)
  Object if4913 = done;
  if (istrue(opresult4917)) {
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4918 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4919 == NULL) {
    strlit4919 = alloc_String(" }");
    gc_root(strlit4919);
  }
// compiled string node returning strlit4919 (depth = 8)
  gc_frame_newslot(strlit4919);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4920 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call4921 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4920);
// compiled call node returning call4921 (depth = 9)
// compiled member node returning call4921 (depth = 8)
  gc_frame_newslot(call4921);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4919;
  params[1] = call4921;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4922 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4918);
// compiled call node returning call4922 (depth = 7)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4923 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4924 == NULL) {
    strlit4924 = alloc_String(" {");
    gc_root(strlit4924);
  }
// compiled string node returning strlit4924 (depth = 8)
  gc_frame_newslot(strlit4924);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4924;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4925 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4923);
// compiled call node returning call4925 (depth = 7)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4926 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4927 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4926);
// compiled call node returning call4927 (depth = 7)
    gc_frame_newslot(call4927);
    if4913 = call4927;
  } else {
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4929 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4929 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4931 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4931 (depth = 8)
  Object if4928 = done;
  if (istrue(opresult4931)) {
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4932 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4933 == NULL) {
    strlit4933 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4933);
  }
// compiled string node returning strlit4933 (depth = 9)
  gc_frame_newslot(strlit4933);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4933;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4934 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4932);
// compiled call node returning call4934 (depth = 8)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4935 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4936 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4935);
// compiled call node returning call4936 (depth = 8)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4937 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4938 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call4939 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4938);
// compiled call node returning call4939 (depth = 12)
// compiled member node returning call4939 (depth = 11)
  partcv[0] = 0;
  Object call4940 = callmethod(call4939, "new",
    1, partcv, params);
  gc_frame_end(callframe4937);
// compiled call node returning call4940 (depth = 10)
// compiled member node returning call4940 (depth = 9)
  *var_suggestion = call4940;
  if (call4940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4942 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4943 == NULL) {
    strlit4943 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4943);
  }
// compiled string node returning strlit4943 (depth = 9)
  gc_frame_newslot(strlit4943);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4943;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4944 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4942);
// compiled call node returning call4944 (depth = 8)
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4945 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4946 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4945);
// compiled call node returning call4946 (depth = 8)
    gc_frame_newslot(call4946);
    if4928 = call4946;
  } else {
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4947 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4948 == NULL) {
    strlit4948 = alloc_String(" }");
    gc_root(strlit4948);
  }
// compiled string node returning strlit4948 (depth = 9)
  gc_frame_newslot(strlit4948);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4950 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4949);
// compiled call node returning call4950 (depth = 10)
// compiled member node returning call4950 (depth = 9)
  gc_frame_newslot(call4950);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4948;
  params[1] = call4950;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4951 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4947);
// compiled call node returning call4951 (depth = 8)
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4952 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4953 == NULL) {
    strlit4953 = alloc_String(" {");
    gc_root(strlit4953);
  }
// compiled string node returning strlit4953 (depth = 9)
  gc_frame_newslot(strlit4953);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4953;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4954 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4952);
// compiled call node returning call4954 (depth = 8)
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4955 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4956 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4955);
// compiled call node returning call4956 (depth = 8)
    gc_frame_newslot(call4956);
    if4928 = call4956;
  }
// compiled if node returning if4928 (depth = 7)
    gc_frame_newslot(if4928);
    if4913 = if4928;
  }
// compiled if node returning if4913 (depth = 6)
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4957 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4958 == NULL) {
    strlit4958 = alloc_String("A match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4958);
  }
// compiled string node returning strlit4958 (depth = 7)
  gc_frame_newslot(strlit4958);
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4960 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4959);
// compiled call node returning call4960 (depth = 8)
// compiled member node returning call4960 (depth = 7)
  gc_frame_newslot(call4960);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4962 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4961);
// compiled call node returning call4962 (depth = 8)
// compiled member node returning call4962 (depth = 7)
  gc_frame_newslot(call4962);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4958;
  params[1] = call4960;
  params[2] = call4962;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4963 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4957);
// compiled call node returning call4963 (depth = 6)
    gc_frame_newslot(call4963);
    if4829 = call4963;
  }
// compiled if node returning if4829 (depth = 5)
    gc_frame_newslot(if4829);
    if4823 = if4829;
  }
// compiled if node returning if4823 (depth = 4)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4964 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4965 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call4966 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4965);
// compiled call node returning call4966 (depth = 6)
// compiled member node returning call4966 (depth = 5)
  gc_frame_newslot(call4966);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4966;
  partcv[0] = 1;
  Object call4967 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4964);
// compiled call node returning call4967 (depth = 4)
  gc_frame_end(frame);
  return call4967;
}
Object meth_parser_matchcase4607(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchcase (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for matchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_elsecase = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "elsecase");
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4609 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4612 == NULL) {
    strlit4612 = alloc_String("match");
    gc_root(strlit4612);
  }
// compiled string node returning strlit4612 (depth = 6)
  int op_slot_right_4611 = gc_frame_newslot(strlit4612);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4615 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4614);
// compiled call node returning call4615 (depth = 7)
// compiled member node returning call4615 (depth = 6)
  int op_slot_left_4611 = gc_frame_newslot(call4615);
  params[0] = strlit4612;
  partcv[0] = 1;
  Object opresult4616 = callmethod(call4615, "==", 1, partcv, params);
// compiled op node returning opresult4616 (depth = 5)
  int op_slot_right_4610 = gc_frame_newslot(opresult4616);
// starting to compile call node (depth = 5)
  int callframe4618 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4619 == NULL) {
    strlit4619 = alloc_String("identifier");
    gc_root(strlit4619);
  }
// compiled string node returning strlit4619 (depth = 6)
  gc_frame_newslot(strlit4619);
// call case 4: self request
  params[0] = strlit4619;
  partcv[0] = 1;
  Object call4620 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4618);
// compiled call node returning call4620 (depth = 5)
  int op_slot_left_4610 = gc_frame_newslot(call4620);
  params[0] = opresult4616;
  partcv[0] = 1;
  Object opresult4621 = callmethod(call4620, "&&", 1, partcv, params);
// compiled op node returning opresult4621 (depth = 4)
  partcv[0] = 0;
  Object call4622 = callmethod(opresult4621, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4609);
// compiled call node returning call4622 (depth = 3)
  Object if4608 = done;
  if (istrue(call4622)) {
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4623 = alloc_Float64(0);
// compiled num node returning num4623 (depth = 4)
  return num4623;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4608 = undefined;
  } else {
  }
// compiled if node returning if4608 (depth = 2)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4625 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4624);
// compiled call node returning call4625 (depth = 3)
// compiled member node returning call4625 (depth = 2)
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4628 == NULL) {
    strlit4628 = alloc_String("lparen");
    gc_root(strlit4628);
  }
// compiled string node returning strlit4628 (depth = 4)
  int op_slot_right_4627 = gc_frame_newslot(strlit4628);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4631 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4630);
// compiled call node returning call4631 (depth = 5)
// compiled member node returning call4631 (depth = 4)
  int op_slot_left_4627 = gc_frame_newslot(call4631);
  params[0] = strlit4628;
  partcv[0] = 1;
  Object opresult4632 = callmethod(call4631, "!=", 1, partcv, params);
// compiled op node returning opresult4632 (depth = 3)
  Object if4626 = done;
  if (istrue(opresult4632)) {
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4633 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4634 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4635 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4634);
// compiled call node returning call4635 (depth = 7)
// compiled member node returning call4635 (depth = 6)
  partcv[0] = 0;
  Object call4636 = callmethod(call4635, "new",
    1, partcv, params);
  gc_frame_end(callframe4633);
// compiled call node returning call4636 (depth = 5)
// compiled member node returning call4636 (depth = 4)
  *var_suggestion = call4636;
  if (call4636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4637 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4638 = alloc_Block(NULL, NULL, "parser", 1411);
  gc_frame_newslot(block4638);
// method _apply
  block_savedest(block4638);
  Object closure4639 = createclosure(2, "_apply");
  setclosureframe(closure4639, stackframe);
  addtoclosure(closure4639, var_matchTok);
  addtoclosure(closure4639, selfslot);
  struct UserObject *uo4639 = (struct UserObject*)block4638;
  uo4639->data[0] = (Object)closure4639;
  Method *meth_meth_parser__apply4639 = addmethod2pos(block4638, "_apply", &meth_parser__apply4639, 0);
  int argcv_meth_parser__apply4639[] = {1};
  meth_meth_parser__apply4639->type = alloc_MethodType(1, argcv_meth_parser__apply4639);
  meth_meth_parser__apply4639->definitionModule = modulename;
  meth_meth_parser__apply4639->definitionLine = 1409;
// compiled block node returning block4638 (depth = 5)
  gc_frame_newslot(block4638);
// call case 4: self request
  params[0] = block4638;
  partcv[0] = 1;
  Object call4675 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4637);
// compiled call node returning call4675 (depth = 4)
  *var_nextTok = call4675;
  if (call4675 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4678 = alloc_Boolean(0);
// compiled identifier node returning bool4678 (depth = 5)
  int op_slot_right_4677 = gc_frame_newslot(bool4678);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4677 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4678;
  partcv[0] = 1;
  Object opresult4680 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4680 (depth = 4)
  Object if4676 = done;
  if (istrue(opresult4680)) {
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4681 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4682 == NULL) {
    strlit4682 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4682);
  }
// compiled string node returning strlit4682 (depth = 5)
  gc_frame_newslot(strlit4682);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  gc_frame_newslot(*var_matchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4682;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4683 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4681);
// compiled call node returning call4683 (depth = 4)
    gc_frame_newslot(call4683);
    if4676 = call4683;
  } else {
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4686 == NULL) {
    strlit4686 = alloc_String("rparen");
    gc_root(strlit4686);
  }
// compiled string node returning strlit4686 (depth = 6)
  int op_slot_right_4685 = gc_frame_newslot(strlit4686);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4689 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4688);
// compiled call node returning call4689 (depth = 7)
// compiled member node returning call4689 (depth = 6)
  int op_slot_left_4685 = gc_frame_newslot(call4689);
  params[0] = strlit4686;
  partcv[0] = 1;
  Object opresult4690 = callmethod(call4689, "==", 1, partcv, params);
// compiled op node returning opresult4690 (depth = 5)
  Object if4684 = done;
  if (istrue(opresult4690)) {
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_4692 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4692 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4694 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4694 (depth = 6)
  Object if4691 = done;
  if (istrue(opresult4694)) {
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4695 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4696 == NULL) {
    strlit4696 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4696);
  }
// compiled string node returning strlit4696 (depth = 7)
  gc_frame_newslot(strlit4696);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4696;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4697 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4695);
// compiled call node returning call4697 (depth = 6)
    gc_frame_newslot(call4697);
    if4691 = call4697;
  } else {
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4698 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4699 == NULL) {
    strlit4699 = alloc_String("(");
    gc_root(strlit4699);
  }
// compiled string node returning strlit4699 (depth = 7)
  gc_frame_newslot(strlit4699);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4699;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4700 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4698);
// compiled call node returning call4700 (depth = 6)
    gc_frame_newslot(call4700);
    if4691 = call4700;
  }
// compiled if node returning if4691 (depth = 5)
    gc_frame_newslot(if4691);
    if4684 = if4691;
  } else {
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4703 == NULL) {
    strlit4703 = alloc_String("identifier");
    gc_root(strlit4703);
  }
// compiled string node returning strlit4703 (depth = 7)
  int op_slot_right_4702 = gc_frame_newslot(strlit4703);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4705 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4706 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4705);
// compiled call node returning call4706 (depth = 8)
// compiled member node returning call4706 (depth = 7)
  int op_slot_left_4702 = gc_frame_newslot(call4706);
  params[0] = strlit4703;
  partcv[0] = 1;
  Object opresult4707 = callmethod(call4706, "==", 1, partcv, params);
// compiled op node returning opresult4707 (depth = 6)
  Object if4701 = done;
  if (istrue(opresult4707)) {
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4708 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4709 == NULL) {
    strlit4709 = alloc_String("(");
    gc_root(strlit4709);
  }
// compiled string node returning strlit4709 (depth = 7)
  gc_frame_newslot(strlit4709);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4709;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4710 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4708);
// compiled call node returning call4710 (depth = 6)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4711 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4712 == NULL) {
    strlit4712 = alloc_String(")");
    gc_root(strlit4712);
  }
// compiled string node returning strlit4712 (depth = 7)
  gc_frame_newslot(strlit4712);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4713 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4714 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4713);
// compiled call node returning call4714 (depth = 8)
// compiled member node returning call4714 (depth = 7)
  gc_frame_newslot(call4714);
// starting to compile identifier node (depth = 7)
  Object bool4715 = alloc_Boolean(1);
// compiled identifier node returning bool4715 (depth = 7)
  gc_frame_newslot(bool4715);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4712;
  params[1] = call4714;
  params[2] = bool4715;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4716 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4711);
// compiled call node returning call4716 (depth = 6)
    gc_frame_newslot(call4716);
    if4701 = call4716;
  } else {
  }
// compiled if node returning if4701 (depth = 5)
    gc_frame_newslot(if4701);
    if4684 = if4701;
  }
// compiled if node returning if4684 (depth = 4)
    gc_frame_newslot(if4684);
    if4676 = if4684;
  }
// compiled if node returning if4676 (depth = 3)
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4717 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4718 == NULL) {
    strlit4718 = alloc_String("A match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4718);
  }
// compiled string node returning strlit4718 (depth = 4)
  gc_frame_newslot(strlit4718);
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  partcv[0] = 0;
  Object call4720 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4719);
// compiled call node returning call4720 (depth = 5)
// compiled member node returning call4720 (depth = 4)
  gc_frame_newslot(call4720);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4722 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4723 = callmethod(*var_matchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4722);
// compiled call node returning call4723 (depth = 6)
// compiled member node returning call4723 (depth = 5)
  int op_slot_right_4721 = gc_frame_newslot(call4723);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4726 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4725);
// compiled call node returning call4726 (depth = 6)
// compiled member node returning call4726 (depth = 5)
  int op_slot_left_4721 = gc_frame_newslot(call4726);
  params[0] = call4723;
  partcv[0] = 1;
  Object sum4727 = callmethod(call4726, "+", 1, partcv, params);
// compiled op node returning sum4727 (depth = 4)
  gc_frame_newslot(sum4727);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4718;
  params[1] = call4720;
  params[2] = sum4727;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4728 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4717);
// compiled call node returning call4728 (depth = 3)
    gc_frame_newslot(call4728);
    if4626 = call4728;
  } else {
  }
// compiled if node returning if4626 (depth = 2)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4729 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4730 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4729);
// compiled call node returning call4730 (depth = 3)
// compiled member node returning call4730 (depth = 2)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4732 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe4733 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4734 = alloc_Block(NULL, NULL, "parser", 1429);
  gc_frame_newslot(block4734);
// method _apply
  block_savedest(block4734);
  Object closure4735 = createclosure(2, "_apply");
  setclosureframe(closure4735, stackframe);
  addtoclosure(closure4735, var_blocksOK);
  addtoclosure(closure4735, selfslot);
  struct UserObject *uo4735 = (struct UserObject*)block4734;
  uo4735->data[0] = (Object)closure4735;
  Method *meth_meth_parser__apply4735 = addmethod2pos(block4734, "_apply", &meth_parser__apply4735, 0);
  int argcv_meth_parser__apply4735[] = {0};
  meth_meth_parser__apply4735->type = alloc_MethodType(1, argcv_meth_parser__apply4735);
  meth_meth_parser__apply4735->definitionModule = modulename;
  meth_meth_parser__apply4735->definitionLine = 1429;
// compiled block node returning block4734 (depth = 6)
  gc_frame_newslot(block4734);
// call case 4: self request
  params[0] = block4734;
  partcv[0] = 1;
  Object call4739 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4733);
// compiled call node returning call4739 (depth = 5)
  partcv[0] = 0;
  Object call4740 = callmethod(call4739, "not",
    1, partcv, params);
  gc_frame_end(callframe4732);
// compiled call node returning call4740 (depth = 4)
// compiled member node returning call4740 (depth = 3)
  Object if4731 = done;
  if (istrue(call4740)) {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4741 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4743 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4742);
// compiled call node returning call4743 (depth = 7)
// compiled member node returning call4743 (depth = 6)
  partcv[0] = 0;
  Object call4744 = callmethod(call4743, "new",
    1, partcv, params);
  gc_frame_end(callframe4741);
// compiled call node returning call4744 (depth = 5)
// compiled member node returning call4744 (depth = 4)
  *var_suggestion = call4744;
  if (call4744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4745 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4746 == NULL) {
    strlit4746 = alloc_String("rparen");
    gc_root(strlit4746);
  }
// compiled string node returning strlit4746 (depth = 5)
  gc_frame_newslot(strlit4746);
// call case 4: self request
  params[0] = strlit4746;
  partcv[0] = 1;
  Object call4747 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4745);
// compiled call node returning call4747 (depth = 4)
  *var_nextTok = call4747;
  if (call4747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_4749 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4749 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4751 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4751 (depth = 4)
  Object if4748 = done;
  if (istrue(opresult4751)) {
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4752 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4753 == NULL) {
    strlit4753 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4753);
  }
// compiled string node returning strlit4753 (depth = 5)
  gc_frame_newslot(strlit4753);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4753;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4754 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4752);
// compiled call node returning call4754 (depth = 4)
    gc_frame_newslot(call4754);
    if4748 = call4754;
  } else {
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4755 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call4757 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4756);
// compiled call node returning call4757 (depth = 6)
// compiled member node returning call4757 (depth = 5)
  gc_frame_newslot(call4757);
// starting to compile identifier node (depth = 5)
  Object bool4758 = alloc_Boolean(1);
// compiled identifier node returning bool4758 (depth = 5)
  gc_frame_newslot(bool4758);
// starting to compile identifier node (depth = 5)
  Object bool4759 = alloc_Boolean(0);
// compiled identifier node returning bool4759 (depth = 5)
  gc_frame_newslot(bool4759);
// starting to compile string node (depth = 5)
  if (strlit4760 == NULL) {
    strlit4760 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4760);
  }
// compiled string node returning strlit4760 (depth = 5)
  gc_frame_newslot(strlit4760);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call4757;
  params[2] = bool4758;
  params[3] = bool4759;
  params[4] = strlit4760;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4761 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4755);
// compiled call node returning call4761 (depth = 4)
    gc_frame_newslot(call4761);
    if4748 = call4761;
  }
// compiled if node returning if4748 (depth = 3)
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4762 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4763 == NULL) {
    strlit4763 = alloc_String("A match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4763);
  }
// compiled string node returning strlit4763 (depth = 4)
  gc_frame_newslot(strlit4763);
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4764 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4765 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4764);
// compiled call node returning call4765 (depth = 5)
// compiled member node returning call4765 (depth = 4)
  gc_frame_newslot(call4765);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4767 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4766);
// compiled call node returning call4767 (depth = 5)
// compiled member node returning call4767 (depth = 4)
  gc_frame_newslot(call4767);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4763;
  params[1] = call4765;
  params[2] = call4767;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4768 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4762);
// compiled call node returning call4768 (depth = 3)
    gc_frame_newslot(call4768);
    if4731 = call4768;
  } else {
  }
// compiled if node returning if4731 (depth = 2)
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4769 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4770 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4769);
// compiled call node returning call4770 (depth = 4)
// compiled member node returning call4770 (depth = 3)
  *var_matchee = call4770;
  if (call4770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4773 == NULL) {
    strlit4773 = alloc_String("rparen");
    gc_root(strlit4773);
  }
// compiled string node returning strlit4773 (depth = 4)
  int op_slot_right_4772 = gc_frame_newslot(strlit4773);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4776 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4775);
// compiled call node returning call4776 (depth = 5)
// compiled member node returning call4776 (depth = 4)
  int op_slot_left_4772 = gc_frame_newslot(call4776);
  params[0] = strlit4773;
  partcv[0] = 1;
  Object opresult4777 = callmethod(call4776, "!=", 1, partcv, params);
// compiled op node returning opresult4777 (depth = 3)
  Object if4771 = done;
  if (istrue(opresult4777)) {
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4778 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4779 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4778);
// compiled call node returning call4779 (depth = 4)
// compiled member node returning call4779 (depth = 3)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4780 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4782 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4781);
// compiled call node returning call4782 (depth = 7)
// compiled member node returning call4782 (depth = 6)
  partcv[0] = 0;
  Object call4783 = callmethod(call4782, "new",
    1, partcv, params);
  gc_frame_end(callframe4780);
// compiled call node returning call4783 (depth = 5)
// compiled member node returning call4783 (depth = 4)
  *var_suggestion = call4783;
  if (call4783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4784 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4785 == NULL) {
    strlit4785 = alloc_String(")");
    gc_root(strlit4785);
  }
// compiled string node returning strlit4785 (depth = 4)
  gc_frame_newslot(strlit4785);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit4785;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4786 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4784);
// compiled call node returning call4786 (depth = 3)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4787 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4788 == NULL) {
    strlit4788 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4788);
  }
// compiled string node returning strlit4788 (depth = 4)
  gc_frame_newslot(strlit4788);
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call4790 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4789);
// compiled call node returning call4790 (depth = 5)
// compiled member node returning call4790 (depth = 4)
  gc_frame_newslot(call4790);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4792 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4793 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4792);
// compiled call node returning call4793 (depth = 6)
// compiled member node returning call4793 (depth = 5)
  int op_slot_right_4791 = gc_frame_newslot(call4793);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4796 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4795);
// compiled call node returning call4796 (depth = 6)
// compiled member node returning call4796 (depth = 5)
  int op_slot_left_4791 = gc_frame_newslot(call4796);
  params[0] = call4793;
  partcv[0] = 1;
  Object sum4797 = callmethod(call4796, "+", 1, partcv, params);
// compiled op node returning sum4797 (depth = 4)
  gc_frame_newslot(sum4797);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4788;
  params[1] = call4790;
  params[2] = sum4797;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4798 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4787);
// compiled call node returning call4798 (depth = 3)
    gc_frame_newslot(call4798);
    if4771 = call4798;
  } else {
  }
// compiled if node returning if4771 (depth = 2)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4799 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4800 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4799);
// compiled call node returning call4800 (depth = 3)
// compiled member node returning call4800 (depth = 2)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4801 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4801 (depth = 3)
  *var_cases = array4801;
  if (array4801 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4802 = alloc_Boolean(0);
// compiled identifier node returning bool4802 (depth = 3)
  *var_elsecase = bool4802;
  if (bool4802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4803 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4804 = alloc_Block(NULL, NULL, "parser", 1451);
  gc_frame_newslot(block4804);
// method _apply
  block_savedest(block4804);
  Object closure4805 = createclosure(2, "_apply");
  setclosureframe(closure4805, stackframe);
  addtoclosure(closure4805, var_sym);
  addtoclosure(closure4805, selfslot);
  struct UserObject *uo4805 = (struct UserObject*)block4804;
  uo4805->data[0] = (Object)closure4805;
  Method *meth_meth_parser__apply4805 = addmethod2pos(block4804, "_apply", &meth_parser__apply4805, 0);
  int argcv_meth_parser__apply4805[] = {0};
  meth_meth_parser__apply4805->type = alloc_MethodType(1, argcv_meth_parser__apply4805);
  meth_meth_parser__apply4805->definitionModule = modulename;
  meth_meth_parser__apply4805->definitionLine = 1448;
// compiled block node returning block4804 (depth = 3)
  gc_frame_newslot(block4804);
// starting to compile block node (depth = 3)
  Object block4819 = alloc_Block(NULL, NULL, "parser", 1451);
  gc_frame_newslot(block4819);
// method _apply
  block_savedest(block4819);
  Object closure4820 = createclosure(8, "_apply");
  setclosureframe(closure4820, stackframe);
  addtoclosure(closure4820, var_blocksOK);
  addtoclosure(closure4820, var_errormessages);
  addtoclosure(closure4820, var_sym);
  addtoclosure(closure4820, var_lastToken);
  addtoclosure(closure4820, var_tokens);
  addtoclosure(closure4820, var_values);
  addtoclosure(closure4820, var_cases);
  addtoclosure(closure4820, selfslot);
  struct UserObject *uo4820 = (struct UserObject*)block4819;
  uo4820->data[0] = (Object)closure4820;
  Method *meth_meth_parser__apply4820 = addmethod2pos(block4819, "_apply", &meth_parser__apply4820, 0);
  int argcv_meth_parser__apply4820[] = {0};
  meth_meth_parser__apply4820->type = alloc_MethodType(1, argcv_meth_parser__apply4820);
  meth_meth_parser__apply4820->definitionModule = modulename;
  meth_meth_parser__apply4820->definitionLine = 1451;
// compiled block node returning block4819 (depth = 3)
  gc_frame_newslot(block4819);
// call case 5: prelude request
  params[0] = block4804;
  params[1] = block4819;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4969 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4803);
// compiled call node returning call4969 (depth = 2)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4970 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4971 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  partcv[0] = 0;
  Object call4972 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4971);
// compiled call node returning call4972 (depth = 4)
// compiled member node returning call4972 (depth = 3)
  gc_frame_newslot(call4972);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4973 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  partcv[0] = 0;
  Object call4974 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4973);
// compiled call node returning call4974 (depth = 4)
// compiled member node returning call4974 (depth = 3)
  gc_frame_newslot(call4974);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4972;
  params[1] = call4974;
  partcv[0] = 2;
  Object call4975 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4970);
// compiled call node returning call4975 (depth = 2)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4976 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4977 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee (depth = 4)
  gc_frame_newslot(*var_matchee);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase (depth = 4)
  gc_frame_newslot(*var_elsecase);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4979 = callmethod(*var_ast, "matchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4978);
// compiled call node returning call4979 (depth = 5)
// compiled member node returning call4979 (depth = 4)
  params[0] = *var_matchee;
  params[1] = *var_cases;
  params[2] = *var_elsecase;
  partcv[0] = 3;
  Object call4980 = callmethod(call4979, "new",
    1, partcv, params);
  gc_frame_end(callframe4977);
// compiled call node returning call4980 (depth = 3)
  gc_frame_newslot(call4980);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4980;
  partcv[0] = 1;
  Object call4981 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4976);
// compiled call node returning call4981 (depth = 2)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply5077(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit5079 == NULL) {
    strlit5079 = alloc_String("type");
    gc_root(strlit5079);
  }
// compiled string node returning strlit5079 (depth = 14)
  int op_slot_right_5078 = gc_frame_newslot(strlit5079);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe5081 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call5082 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5081);
// compiled call node returning call5082 (depth = 15)
// compiled member node returning call5082 (depth = 14)
  int op_slot_left_5078 = gc_frame_newslot(call5082);
  params[0] = strlit5079;
  partcv[0] = 1;
  Object opresult5083 = callmethod(call5082, "==", 1, partcv, params);
// compiled op node returning opresult5083 (depth = 13)
  gc_frame_end(frame);
  return opresult5083;
}
Object meth_parser_term4983(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for term (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for term");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4984 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4986 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4985);
// compiled call node returning call4986 (depth = 4)
// compiled member node returning call4986 (depth = 3)
  gc_frame_newslot(call4986);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4988 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4987);
// compiled call node returning call4988 (depth = 4)
// compiled member node returning call4988 (depth = 3)
  gc_frame_newslot(call4988);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4986;
  params[1] = call4988;
  partcv[0] = 2;
  Object call4989 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4984);
// compiled call node returning call4989 (depth = 2)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4991 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4992 == NULL) {
    strlit4992 = alloc_String("num");
    gc_root(strlit4992);
  }
// compiled string node returning strlit4992 (depth = 4)
  gc_frame_newslot(strlit4992);
// call case 4: self request
  params[0] = strlit4992;
  partcv[0] = 1;
  Object call4993 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4991);
// compiled call node returning call4993 (depth = 3)
  Object if4990 = done;
  if (istrue(call4993)) {
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4995 = callmethodflags(self, "pushnum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4994);
// compiled call node returning call4995 (depth = 4)
// compiled member node returning call4995 (depth = 3)
    gc_frame_newslot(call4995);
    if4990 = call4995;
  } else {
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4997 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4998 == NULL) {
    strlit4998 = alloc_String("string");
    gc_root(strlit4998);
  }
// compiled string node returning strlit4998 (depth = 5)
  gc_frame_newslot(strlit4998);
// call case 4: self request
  params[0] = strlit4998;
  partcv[0] = 1;
  Object call4999 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4997);
// compiled call node returning call4999 (depth = 4)
  Object if4996 = done;
  if (istrue(call4999)) {
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5001 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5000);
// compiled call node returning call5001 (depth = 5)
// compiled member node returning call5001 (depth = 4)
    gc_frame_newslot(call5001);
    if4996 = call5001;
  } else {
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5003 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5004 == NULL) {
    strlit5004 = alloc_String("octets");
    gc_root(strlit5004);
  }
// compiled string node returning strlit5004 (depth = 6)
  gc_frame_newslot(strlit5004);
// call case 4: self request
  params[0] = strlit5004;
  partcv[0] = 1;
  Object call5005 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5003);
// compiled call node returning call5005 (depth = 5)
  Object if5002 = done;
  if (istrue(call5005)) {
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5007 = callmethodflags(self, "pushoctets", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5006);
// compiled call node returning call5007 (depth = 6)
// compiled member node returning call5007 (depth = 5)
    gc_frame_newslot(call5007);
    if5002 = call5007;
  } else {
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5011 == NULL) {
    strlit5011 = alloc_String("match");
    gc_root(strlit5011);
  }
// compiled string node returning strlit5011 (depth = 8)
  int op_slot_right_5010 = gc_frame_newslot(strlit5011);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5013 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5014 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5013);
// compiled call node returning call5014 (depth = 9)
// compiled member node returning call5014 (depth = 8)
  int op_slot_left_5010 = gc_frame_newslot(call5014);
  params[0] = strlit5011;
  partcv[0] = 1;
  Object opresult5015 = callmethod(call5014, "==", 1, partcv, params);
// compiled op node returning opresult5015 (depth = 7)
  int op_slot_right_5009 = gc_frame_newslot(opresult5015);
// starting to compile call node (depth = 7)
  int callframe5017 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5018 == NULL) {
    strlit5018 = alloc_String("identifier");
    gc_root(strlit5018);
  }
// compiled string node returning strlit5018 (depth = 8)
  gc_frame_newslot(strlit5018);
// call case 4: self request
  params[0] = strlit5018;
  partcv[0] = 1;
  Object call5019 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5017);
// compiled call node returning call5019 (depth = 7)
  int op_slot_left_5009 = gc_frame_newslot(call5019);
  params[0] = opresult5015;
  partcv[0] = 1;
  Object opresult5020 = callmethod(call5019, "&&", 1, partcv, params);
// compiled op node returning opresult5020 (depth = 6)
  Object if5008 = done;
  if (istrue(opresult5020)) {
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5022 = callmethodflags(self, "matchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5021);
// compiled call node returning call5022 (depth = 7)
// compiled member node returning call5022 (depth = 6)
    gc_frame_newslot(call5022);
    if5008 = call5022;
  } else {
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5026 == NULL) {
    strlit5026 = alloc_String("catch");
    gc_root(strlit5026);
  }
// compiled string node returning strlit5026 (depth = 9)
  int op_slot_right_5025 = gc_frame_newslot(strlit5026);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call5029 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5028);
// compiled call node returning call5029 (depth = 10)
// compiled member node returning call5029 (depth = 9)
  int op_slot_left_5025 = gc_frame_newslot(call5029);
  params[0] = strlit5026;
  partcv[0] = 1;
  Object opresult5030 = callmethod(call5029, "==", 1, partcv, params);
// compiled op node returning opresult5030 (depth = 8)
  int op_slot_right_5024 = gc_frame_newslot(opresult5030);
// starting to compile call node (depth = 8)
  int callframe5032 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5033 == NULL) {
    strlit5033 = alloc_String("identifier");
    gc_root(strlit5033);
  }
// compiled string node returning strlit5033 (depth = 9)
  gc_frame_newslot(strlit5033);
// call case 4: self request
  params[0] = strlit5033;
  partcv[0] = 1;
  Object call5034 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5032);
// compiled call node returning call5034 (depth = 8)
  int op_slot_left_5024 = gc_frame_newslot(call5034);
  params[0] = opresult5030;
  partcv[0] = 1;
  Object opresult5035 = callmethod(call5034, "&&", 1, partcv, params);
// compiled op node returning opresult5035 (depth = 7)
  Object if5023 = done;
  if (istrue(opresult5035)) {
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5037 = callmethodflags(self, "catchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5036);
// compiled call node returning call5037 (depth = 8)
// compiled member node returning call5037 (depth = 7)
    gc_frame_newslot(call5037);
    if5023 = call5037;
  } else {
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5041 == NULL) {
    strlit5041 = alloc_String("try");
    gc_root(strlit5041);
  }
// compiled string node returning strlit5041 (depth = 10)
  int op_slot_right_5040 = gc_frame_newslot(strlit5041);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5043 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call5044 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5043);
// compiled call node returning call5044 (depth = 11)
// compiled member node returning call5044 (depth = 10)
  int op_slot_left_5040 = gc_frame_newslot(call5044);
  params[0] = strlit5041;
  partcv[0] = 1;
  Object opresult5045 = callmethod(call5044, "==", 1, partcv, params);
// compiled op node returning opresult5045 (depth = 9)
  int op_slot_right_5039 = gc_frame_newslot(opresult5045);
// starting to compile call node (depth = 9)
  int callframe5047 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5048 == NULL) {
    strlit5048 = alloc_String("identifier");
    gc_root(strlit5048);
  }
// compiled string node returning strlit5048 (depth = 10)
  gc_frame_newslot(strlit5048);
// call case 4: self request
  params[0] = strlit5048;
  partcv[0] = 1;
  Object call5049 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5047);
// compiled call node returning call5049 (depth = 9)
  int op_slot_left_5039 = gc_frame_newslot(call5049);
  params[0] = opresult5045;
  partcv[0] = 1;
  Object opresult5050 = callmethod(call5049, "&&", 1, partcv, params);
// compiled op node returning opresult5050 (depth = 8)
  Object if5038 = done;
  if (istrue(opresult5050)) {
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5052 = callmethodflags(self, "trycatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5051);
// compiled call node returning call5052 (depth = 9)
// compiled member node returning call5052 (depth = 8)
    gc_frame_newslot(call5052);
    if5038 = call5052;
  } else {
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5054 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5055 == NULL) {
    strlit5055 = alloc_String("identifier");
    gc_root(strlit5055);
  }
// compiled string node returning strlit5055 (depth = 10)
  gc_frame_newslot(strlit5055);
// call case 4: self request
  params[0] = strlit5055;
  partcv[0] = 1;
  Object call5056 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5054);
// compiled call node returning call5056 (depth = 9)
  Object if5053 = done;
  if (istrue(call5056)) {
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5058 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5057);
// compiled call node returning call5058 (depth = 10)
// compiled member node returning call5058 (depth = 9)
    gc_frame_newslot(call5058);
    if5053 = call5058;
  } else {
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5062 == NULL) {
    strlit5062 = alloc_String("object");
    gc_root(strlit5062);
  }
// compiled string node returning strlit5062 (depth = 12)
  int op_slot_right_5061 = gc_frame_newslot(strlit5062);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call5065 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5064);
// compiled call node returning call5065 (depth = 13)
// compiled member node returning call5065 (depth = 12)
  int op_slot_left_5061 = gc_frame_newslot(call5065);
  params[0] = strlit5062;
  partcv[0] = 1;
  Object opresult5066 = callmethod(call5065, "==", 1, partcv, params);
// compiled op node returning opresult5066 (depth = 11)
  int op_slot_right_5060 = gc_frame_newslot(opresult5066);
// starting to compile call node (depth = 11)
  int callframe5068 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit5069 == NULL) {
    strlit5069 = alloc_String("keyword");
    gc_root(strlit5069);
  }
// compiled string node returning strlit5069 (depth = 12)
  gc_frame_newslot(strlit5069);
// call case 4: self request
  params[0] = strlit5069;
  partcv[0] = 1;
  Object call5070 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5068);
// compiled call node returning call5070 (depth = 11)
  int op_slot_left_5060 = gc_frame_newslot(call5070);
  params[0] = opresult5066;
  partcv[0] = 1;
  Object opresult5071 = callmethod(call5070, "&&", 1, partcv, params);
// compiled op node returning opresult5071 (depth = 10)
  Object if5059 = done;
  if (istrue(opresult5071)) {
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5072 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5073 = callmethodflags(self, "doobject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5072);
// compiled call node returning call5073 (depth = 11)
// compiled member node returning call5073 (depth = 10)
    gc_frame_newslot(call5073);
    if5059 = call5073;
  } else {
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe5075 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block5076 = alloc_Block(NULL, NULL, "parser", 1573);
  gc_frame_newslot(block5076);
// method _apply
  block_savedest(block5076);
  Object closure5077 = createclosure(2, "_apply");
  setclosureframe(closure5077, stackframe);
  addtoclosure(closure5077, var_sym);
  addtoclosure(closure5077, selfslot);
  struct UserObject *uo5077 = (struct UserObject*)block5076;
  uo5077->data[0] = (Object)closure5077;
  Method *meth_meth_parser__apply5077 = addmethod2pos(block5076, "_apply", &meth_parser__apply5077, 0);
  int argcv_meth_parser__apply5077[] = {0};
  meth_meth_parser__apply5077->type = alloc_MethodType(1, argcv_meth_parser__apply5077);
  meth_meth_parser__apply5077->definitionModule = modulename;
  meth_meth_parser__apply5077->definitionLine = 1572;
// compiled block node returning block5076 (depth = 12)
  gc_frame_newslot(block5076);
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe5085 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5086 == NULL) {
    strlit5086 = alloc_String("keyword");
    gc_root(strlit5086);
  }
// compiled string node returning strlit5086 (depth = 13)
  gc_frame_newslot(strlit5086);
// call case 4: self request
  params[0] = strlit5086;
  partcv[0] = 1;
  Object call5087 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5085);
// compiled call node returning call5087 (depth = 12)
  params[0] = block5076;
  partcv[0] = 1;
  Object call5088 = callmethod(call5087, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5075);
// compiled call node returning call5088 (depth = 11)
  Object if5074 = done;
  if (istrue(call5088)) {
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5089 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5090 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5089);
// compiled call node returning call5090 (depth = 12)
// compiled member node returning call5090 (depth = 11)
    gc_frame_newslot(call5090);
    if5074 = call5090;
  } else {
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe5092 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5093 == NULL) {
    strlit5093 = alloc_String("lbrace");
    gc_root(strlit5093);
  }
// compiled string node returning strlit5093 (depth = 13)
  gc_frame_newslot(strlit5093);
// call case 4: self request
  params[0] = strlit5093;
  partcv[0] = 1;
  Object call5094 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5092);
// compiled call node returning call5094 (depth = 12)
  Object if5091 = done;
  if (istrue(call5094)) {
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5096 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5095);
// compiled call node returning call5096 (depth = 13)
// compiled member node returning call5096 (depth = 12)
    gc_frame_newslot(call5096);
    if5091 = call5096;
  } else {
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe5098 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit5099 == NULL) {
    strlit5099 = alloc_String("lsquare");
    gc_root(strlit5099);
  }
// compiled string node returning strlit5099 (depth = 14)
  gc_frame_newslot(strlit5099);
// call case 4: self request
  params[0] = strlit5099;
  partcv[0] = 1;
  Object call5100 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5098);
// compiled call node returning call5100 (depth = 13)
  Object if5097 = done;
  if (istrue(call5100)) {
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5101 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5102 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5101);
// compiled call node returning call5102 (depth = 14)
// compiled member node returning call5102 (depth = 13)
    gc_frame_newslot(call5102);
    if5097 = call5102;
  } else {
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe5104 = gc_frame_new();
// starting to compile string node (depth = 15)
  if (strlit5105 == NULL) {
    strlit5105 = alloc_String("op");
    gc_root(strlit5105);
  }
// compiled string node returning strlit5105 (depth = 15)
  gc_frame_newslot(strlit5105);
// call case 4: self request
  params[0] = strlit5105;
  partcv[0] = 1;
  Object call5106 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5104);
// compiled call node returning call5106 (depth = 14)
  Object if5103 = done;
  if (istrue(call5106)) {
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe5107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5108 = callmethodflags(self, "prefixop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5107);
// compiled call node returning call5108 (depth = 15)
// compiled member node returning call5108 (depth = 14)
    gc_frame_newslot(call5108);
    if5103 = call5108;
  } else {
  }
// compiled if node returning if5103 (depth = 13)
    gc_frame_newslot(if5103);
    if5097 = if5103;
  }
// compiled if node returning if5097 (depth = 12)
    gc_frame_newslot(if5097);
    if5091 = if5097;
  }
// compiled if node returning if5091 (depth = 11)
    gc_frame_newslot(if5091);
    if5074 = if5091;
  }
// compiled if node returning if5074 (depth = 10)
    gc_frame_newslot(if5074);
    if5059 = if5074;
  }
// compiled if node returning if5059 (depth = 9)
    gc_frame_newslot(if5059);
    if5053 = if5059;
  }
// compiled if node returning if5053 (depth = 8)
    gc_frame_newslot(if5053);
    if5038 = if5053;
  }
// compiled if node returning if5038 (depth = 7)
    gc_frame_newslot(if5038);
    if5023 = if5038;
  }
// compiled if node returning if5023 (depth = 6)
    gc_frame_newslot(if5023);
    if5008 = if5023;
  }
// compiled if node returning if5008 (depth = 5)
    gc_frame_newslot(if5008);
    if5002 = if5008;
  }
// compiled if node returning if5002 (depth = 4)
    gc_frame_newslot(if5002);
    if4996 = if5002;
  }
// compiled if node returning if4996 (depth = 3)
    gc_frame_newslot(if4996);
    if4990 = if4996;
  }
// compiled if node returning if4990 (depth = 2)
  gc_frame_end(frame);
  return if4990;
}
Object meth_parser__apply5135(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_acceptBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe5136 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_acceptBlocks (depth = 9)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5137 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5136);
// compiled call node returning call5137 (depth = 8)
  gc_frame_end(frame);
  return call5137;
}
Object meth_parser_expression5109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method expression");
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for expression (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for expression");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
  Object *var_tmpStatementToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tmpStatementToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5111 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5110);
// compiled call node returning call5111 (depth = 4)
// compiled member node returning call5111 (depth = 3)
  *var_sz = call5111;
  if (call5111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5112 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5114 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5113);
// compiled call node returning call5114 (depth = 4)
// compiled member node returning call5114 (depth = 3)
  gc_frame_newslot(call5114);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5116 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5115);
// compiled call node returning call5116 (depth = 4)
// compiled member node returning call5116 (depth = 3)
  gc_frame_newslot(call5116);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call5114;
  params[1] = call5116;
  partcv[0] = 2;
  Object call5117 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5112);
// compiled call node returning call5117 (depth = 2)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5119 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5120 == NULL) {
    strlit5120 = alloc_String("lparen");
    gc_root(strlit5120);
  }
// compiled string node returning strlit5120 (depth = 4)
  gc_frame_newslot(strlit5120);
// call case 4: self request
  params[0] = strlit5120;
  partcv[0] = 1;
  Object call5121 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5119);
// compiled call node returning call5121 (depth = 3)
  Object if5118 = done;
  if (istrue(call5121)) {
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5123 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5125 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5124);
// compiled call node returning call5125 (depth = 5)
// compiled member node returning call5125 (depth = 4)
  gc_frame_newslot(call5125);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5126 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5127 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5126);
// compiled call node returning call5127 (depth = 5)
// compiled member node returning call5127 (depth = 4)
  gc_frame_newslot(call5127);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5125;
  params[1] = call5127;
  partcv[0] = 2;
  Object call5128 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5123);
// compiled call node returning call5128 (depth = 3)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5130 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5129);
// compiled call node returning call5130 (depth = 4)
// compiled member node returning call5130 (depth = 3)
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5132 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe5133 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5134 = alloc_Block(NULL, NULL, "parser", 1597);
  gc_frame_newslot(block5134);
// method _apply
  block_savedest(block5134);
  Object closure5135 = createclosure(2, "_apply");
  setclosureframe(closure5135, stackframe);
  addtoclosure(closure5135, var_acceptBlocks);
  addtoclosure(closure5135, selfslot);
  struct UserObject *uo5135 = (struct UserObject*)block5134;
  uo5135->data[0] = (Object)closure5135;
  Method *meth_meth_parser__apply5135 = addmethod2pos(block5134, "_apply", &meth_parser__apply5135, 0);
  int argcv_meth_parser__apply5135[] = {0};
  meth_meth_parser__apply5135->type = alloc_MethodType(1, argcv_meth_parser__apply5135);
  meth_meth_parser__apply5135->definitionModule = modulename;
  meth_meth_parser__apply5135->definitionLine = 1597;
// compiled block node returning block5134 (depth = 7)
  gc_frame_newslot(block5134);
// call case 4: self request
  params[0] = block5134;
  partcv[0] = 1;
  Object call5139 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5133);
// compiled call node returning call5139 (depth = 6)
  partcv[0] = 0;
  Object call5140 = callmethod(call5139, "not",
    1, partcv, params);
  gc_frame_end(callframe5132);
// compiled call node returning call5140 (depth = 5)
// compiled member node returning call5140 (depth = 4)
  Object if5131 = done;
  if (istrue(call5140)) {
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5141 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5143 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5142);
// compiled call node returning call5143 (depth = 8)
// compiled member node returning call5143 (depth = 7)
  partcv[0] = 0;
  Object call5144 = callmethod(call5143, "new",
    1, partcv, params);
  gc_frame_end(callframe5141);
// compiled call node returning call5144 (depth = 6)
// compiled member node returning call5144 (depth = 5)
  *var_suggestion = call5144;
  if (call5144 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5145 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5146 == NULL) {
    strlit5146 = alloc_String("rparen");
    gc_root(strlit5146);
  }
// compiled string node returning strlit5146 (depth = 6)
  gc_frame_newslot(strlit5146);
// call case 4: self request
  params[0] = strlit5146;
  partcv[0] = 1;
  Object call5147 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5145);
// compiled call node returning call5147 (depth = 5)
  *var_nextTok = call5147;
  if (call5147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_5149 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_5149 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5151 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5151 (depth = 5)
  Object if5148 = done;
  if (istrue(opresult5151)) {
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5152 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5153 == NULL) {
    strlit5153 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5153);
  }
// compiled string node returning strlit5153 (depth = 6)
  gc_frame_newslot(strlit5153);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5153;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5154 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5152);
// compiled call node returning call5154 (depth = 5)
    gc_frame_newslot(call5154);
    if5148 = call5154;
  } else {
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5155 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5157 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5156);
// compiled call node returning call5157 (depth = 7)
// compiled member node returning call5157 (depth = 6)
  gc_frame_newslot(call5157);
// starting to compile identifier node (depth = 6)
  Object bool5158 = alloc_Boolean(1);
// compiled identifier node returning bool5158 (depth = 6)
  gc_frame_newslot(bool5158);
// starting to compile identifier node (depth = 6)
  Object bool5159 = alloc_Boolean(0);
// compiled identifier node returning bool5159 (depth = 6)
  gc_frame_newslot(bool5159);
// starting to compile string node (depth = 6)
  if (strlit5160 == NULL) {
    strlit5160 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5160);
  }
// compiled string node returning strlit5160 (depth = 6)
  gc_frame_newslot(strlit5160);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call5157;
  params[2] = bool5158;
  params[3] = bool5159;
  params[4] = strlit5160;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5161 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5155);
// compiled call node returning call5161 (depth = 5)
    gc_frame_newslot(call5161);
    if5148 = call5161;
  }
// compiled if node returning if5148 (depth = 4)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5162 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5163 == NULL) {
    strlit5163 = alloc_String("Parentheses must contain a valid expression.");
    gc_root(strlit5163);
  }
// compiled string node returning strlit5163 (depth = 5)
  gc_frame_newslot(strlit5163);
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5165 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5164);
// compiled call node returning call5165 (depth = 6)
// compiled member node returning call5165 (depth = 5)
  gc_frame_newslot(call5165);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5166 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5167 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5166);
// compiled call node returning call5167 (depth = 6)
// compiled member node returning call5167 (depth = 5)
  gc_frame_newslot(call5167);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5163;
  params[1] = call5165;
  params[2] = call5167;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5168 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5162);
// compiled call node returning call5168 (depth = 4)
    gc_frame_newslot(call5168);
    if5131 = call5168;
  } else {
  }
// compiled if node returning if5131 (depth = 3)
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5171 == NULL) {
    strlit5171 = alloc_String("rparen");
    gc_root(strlit5171);
  }
// compiled string node returning strlit5171 (depth = 5)
  int op_slot_right_5170 = gc_frame_newslot(strlit5171);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5174 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5173);
// compiled call node returning call5174 (depth = 6)
// compiled member node returning call5174 (depth = 5)
  int op_slot_left_5170 = gc_frame_newslot(call5174);
  params[0] = strlit5171;
  partcv[0] = 1;
  Object opresult5175 = callmethod(call5174, "!=", 1, partcv, params);
// compiled op node returning opresult5175 (depth = 4)
  Object if5169 = done;
  if (istrue(opresult5175)) {
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5176 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5177 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5176);
// compiled call node returning call5177 (depth = 5)
// compiled member node returning call5177 (depth = 4)
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5178 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5179 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5180 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5179);
// compiled call node returning call5180 (depth = 8)
// compiled member node returning call5180 (depth = 7)
  partcv[0] = 0;
  Object call5181 = callmethod(call5180, "new",
    1, partcv, params);
  gc_frame_end(callframe5178);
// compiled call node returning call5181 (depth = 6)
// compiled member node returning call5181 (depth = 5)
  *var_suggestion = call5181;
  if (call5181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5182 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5183 == NULL) {
    strlit5183 = alloc_String(")");
    gc_root(strlit5183);
  }
// compiled string node returning strlit5183 (depth = 5)
  gc_frame_newslot(strlit5183);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5183;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5184 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5182);
// compiled call node returning call5184 (depth = 4)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5185 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5186 == NULL) {
    strlit5186 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5186);
  }
// compiled string node returning strlit5186 (depth = 5)
  gc_frame_newslot(strlit5186);
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call5188 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5187);
// compiled call node returning call5188 (depth = 6)
// compiled member node returning call5188 (depth = 5)
  gc_frame_newslot(call5188);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5190 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5191 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5190);
// compiled call node returning call5191 (depth = 7)
// compiled member node returning call5191 (depth = 6)
  int op_slot_right_5189 = gc_frame_newslot(call5191);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5193 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5194 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5193);
// compiled call node returning call5194 (depth = 7)
// compiled member node returning call5194 (depth = 6)
  int op_slot_left_5189 = gc_frame_newslot(call5194);
  params[0] = call5191;
  partcv[0] = 1;
  Object sum5195 = callmethod(call5194, "+", 1, partcv, params);
// compiled op node returning sum5195 (depth = 5)
  gc_frame_newslot(sum5195);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5186;
  params[1] = call5188;
  params[2] = sum5195;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5196 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5185);
// compiled call node returning call5196 (depth = 4)
    gc_frame_newslot(call5196);
    if5169 = call5196;
  } else {
  }
// compiled if node returning if5169 (depth = 3)
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tmpStatementToken (depth = 4)
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5198 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5199 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5198);
// compiled call node returning call5199 (depth = 4)
// compiled member node returning call5199 (depth = 3)
    gc_frame_newslot(call5199);
    if5118 = call5199;
  } else {
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5200 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5201 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5200);
// compiled call node returning call5201 (depth = 4)
// compiled member node returning call5201 (depth = 3)
    gc_frame_newslot(call5201);
    if5118 = call5201;
  }
// compiled if node returning if5118 (depth = 2)
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_5203 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5206 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5205);
// compiled call node returning call5206 (depth = 5)
// compiled member node returning call5206 (depth = 4)
  int op_slot_left_5203 = gc_frame_newslot(call5206);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult5207 = callmethod(call5206, ">", 1, partcv, params);
// compiled op node returning opresult5207 (depth = 3)
  Object if5202 = done;
  if (istrue(opresult5207)) {
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5208 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5209 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5208);
// compiled call node returning call5209 (depth = 3)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5210 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5211 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5210);
// compiled call node returning call5211 (depth = 3)
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5213 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5212);
// compiled call node returning call5213 (depth = 4)
// compiled member node returning call5213 (depth = 3)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5214 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5215 = callmethodflags(self, "valueexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5214);
// compiled call node returning call5215 (depth = 4)
// compiled member node returning call5215 (depth = 3)
    gc_frame_newslot(call5215);
    if5202 = call5215;
  } else {
  }
// compiled if node returning if5202 (depth = 2)
  gc_frame_end(frame);
  return if5202;
}
Object meth_parser__apply5229(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe5230 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5231 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5230);
// compiled call node returning call5231 (depth = 8)
  gc_frame_end(frame);
  return call5231;
}
Object meth_parser_postfixsquare5216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "postfixsquare");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for postfixsquare (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for postfixsquare");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_index = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "index");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5218 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5219 == NULL) {
    strlit5219 = alloc_String("lsquare");
    gc_root(strlit5219);
  }
// compiled string node returning strlit5219 (depth = 4)
  gc_frame_newslot(strlit5219);
// call case 4: self request
  params[0] = strlit5219;
  partcv[0] = 1;
  Object call5220 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5218);
// compiled call node returning call5220 (depth = 3)
  Object if5217 = done;
  if (istrue(call5220)) {
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5221 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5222 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5221);
// compiled call node returning call5222 (depth = 4)
// compiled member node returning call5222 (depth = 3)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5224 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5223);
// compiled call node returning call5224 (depth = 5)
// compiled member node returning call5224 (depth = 4)
  *var_expr = call5224;
  if (call5224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5226 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe5227 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5228 = alloc_Block(NULL, NULL, "parser", 1634);
  gc_frame_newslot(block5228);
// method _apply
  block_savedest(block5228);
  Object closure5229 = createclosure(2, "_apply");
  setclosureframe(closure5229, stackframe);
  addtoclosure(closure5229, var_blocksOK);
  addtoclosure(closure5229, selfslot);
  struct UserObject *uo5229 = (struct UserObject*)block5228;
  uo5229->data[0] = (Object)closure5229;
  Method *meth_meth_parser__apply5229 = addmethod2pos(block5228, "_apply", &meth_parser__apply5229, 0);
  int argcv_meth_parser__apply5229[] = {0};
  meth_meth_parser__apply5229->type = alloc_MethodType(1, argcv_meth_parser__apply5229);
  meth_meth_parser__apply5229->definitionModule = modulename;
  meth_meth_parser__apply5229->definitionLine = 1634;
// compiled block node returning block5228 (depth = 7)
  gc_frame_newslot(block5228);
// call case 4: self request
  params[0] = block5228;
  partcv[0] = 1;
  Object call5233 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5227);
// compiled call node returning call5233 (depth = 6)
  partcv[0] = 0;
  Object call5234 = callmethod(call5233, "not",
    1, partcv, params);
  gc_frame_end(callframe5226);
// compiled call node returning call5234 (depth = 5)
// compiled member node returning call5234 (depth = 4)
  Object if5225 = done;
  if (istrue(call5234)) {
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5235 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5236 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5237 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5236);
// compiled call node returning call5237 (depth = 8)
// compiled member node returning call5237 (depth = 7)
  partcv[0] = 0;
  Object call5238 = callmethod(call5237, "empty",
    1, partcv, params);
  gc_frame_end(callframe5235);
// compiled call node returning call5238 (depth = 6)
// compiled member node returning call5238 (depth = 5)
  *var_suggestions = call5238;
  if (call5238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5239 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5240 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5241 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5240);
// compiled call node returning call5241 (depth = 8)
// compiled member node returning call5241 (depth = 7)
  partcv[0] = 0;
  Object call5242 = callmethod(call5241, "new",
    1, partcv, params);
  gc_frame_end(callframe5239);
// compiled call node returning call5242 (depth = 6)
// compiled member node returning call5242 (depth = 5)
  *var_suggestion = call5242;
  if (call5242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5243 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5244 == NULL) {
    strlit5244 = alloc_String("rsquare");
    gc_root(strlit5244);
  }
// compiled string node returning strlit5244 (depth = 6)
  gc_frame_newslot(strlit5244);
// call case 4: self request
  params[0] = strlit5244;
  partcv[0] = 1;
  Object call5245 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5243);
// compiled call node returning call5245 (depth = 5)
  *var_nextTok = call5245;
  if (call5245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_5247 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_5247 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5249 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5249 (depth = 5)
  Object if5246 = done;
  if (istrue(opresult5249)) {
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5250 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5251 == NULL) {
    strlit5251 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit5251);
  }
// compiled string node returning strlit5251 (depth = 6)
  gc_frame_newslot(strlit5251);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5251;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5252 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5250);
// compiled call node returning call5252 (depth = 5)
    gc_frame_newslot(call5252);
    if5246 = call5252;
  } else {
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5253 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5255 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5254);
// compiled call node returning call5255 (depth = 7)
// compiled member node returning call5255 (depth = 6)
  gc_frame_newslot(call5255);
// starting to compile identifier node (depth = 6)
  Object bool5256 = alloc_Boolean(1);
// compiled identifier node returning bool5256 (depth = 6)
  gc_frame_newslot(bool5256);
// starting to compile identifier node (depth = 6)
  Object bool5257 = alloc_Boolean(0);
// compiled identifier node returning bool5257 (depth = 6)
  gc_frame_newslot(bool5257);
// starting to compile string node (depth = 6)
  if (strlit5258 == NULL) {
    strlit5258 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit5258);
  }
// compiled string node returning strlit5258 (depth = 6)
  gc_frame_newslot(strlit5258);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call5255;
  params[2] = bool5256;
  params[3] = bool5257;
  params[4] = strlit5258;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5259 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5253);
// compiled call node returning call5259 (depth = 5)
    gc_frame_newslot(call5259);
    if5246 = call5259;
  }
// compiled if node returning if5246 (depth = 4)
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5260 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5261 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5260);
// compiled call node returning call5261 (depth = 4)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5264 == NULL) {
    strlit5264 = alloc_String("rsquare");
    gc_root(strlit5264);
  }
// compiled string node returning strlit5264 (depth = 6)
  int op_slot_right_5263 = gc_frame_newslot(strlit5264);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5266 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5267 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe5266);
// compiled call node returning call5267 (depth = 7)
// compiled member node returning call5267 (depth = 6)
  int op_slot_left_5263 = gc_frame_newslot(call5267);
  params[0] = strlit5264;
  partcv[0] = 1;
  Object opresult5268 = callmethod(call5267, "==", 1, partcv, params);
// compiled op node returning opresult5268 (depth = 5)
  Object if5262 = done;
  if (istrue(opresult5268)) {
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5269 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5270 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5271 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5270);
// compiled call node returning call5271 (depth = 9)
// compiled member node returning call5271 (depth = 8)
  partcv[0] = 0;
  Object call5272 = callmethod(call5271, "new",
    1, partcv, params);
  gc_frame_end(callframe5269);
// compiled call node returning call5272 (depth = 7)
// compiled member node returning call5272 (depth = 6)
  *var_suggestion = call5272;
  if (call5272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5274 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool5275 = alloc_Boolean(1);
// compiled identifier node returning bool5275 (depth = 6)
  gc_frame_newslot(bool5275);
// starting to compile identifier node (depth = 6)
  Object bool5276 = alloc_Boolean(0);
// compiled identifier node returning bool5276 (depth = 6)
  gc_frame_newslot(bool5276);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = *var_nextTok;
  params[2] = bool5275;
  params[3] = bool5276;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5277 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5274);
// compiled call node returning call5277 (depth = 5)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5278 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5279 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5278);
// compiled call node returning call5279 (depth = 5)
    gc_frame_newslot(call5279);
    if5262 = call5279;
  } else {
  }
// compiled if node returning if5262 (depth = 4)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5280 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5281 == NULL) {
    strlit5281 = alloc_String("A '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit5281);
  }
// compiled string node returning strlit5281 (depth = 5)
  gc_frame_newslot(strlit5281);
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5282 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5283 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5282);
// compiled call node returning call5283 (depth = 6)
// compiled member node returning call5283 (depth = 5)
  gc_frame_newslot(call5283);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5284 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5285 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5284);
// compiled call node returning call5285 (depth = 6)
// compiled member node returning call5285 (depth = 5)
  gc_frame_newslot(call5285);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5281;
  params[1] = call5283;
  params[2] = call5285;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5286 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5280);
// compiled call node returning call5286 (depth = 4)
    gc_frame_newslot(call5286);
    if5225 = call5286;
  } else {
  }
// compiled if node returning if5225 (depth = 3)
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5288 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5287);
// compiled call node returning call5288 (depth = 5)
// compiled member node returning call5288 (depth = 4)
  *var_index = call5288;
  if (call5288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5291 == NULL) {
    strlit5291 = alloc_String("rsquare");
    gc_root(strlit5291);
  }
// compiled string node returning strlit5291 (depth = 5)
  int op_slot_right_5290 = gc_frame_newslot(strlit5291);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5294 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5293);
// compiled call node returning call5294 (depth = 6)
// compiled member node returning call5294 (depth = 5)
  int op_slot_left_5290 = gc_frame_newslot(call5294);
  params[0] = strlit5291;
  partcv[0] = 1;
  Object opresult5295 = callmethod(call5294, "!=", 1, partcv, params);
// compiled op node returning opresult5295 (depth = 4)
  Object if5289 = done;
  if (istrue(opresult5295)) {
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5296 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5297 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5298 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5297);
// compiled call node returning call5298 (depth = 8)
// compiled member node returning call5298 (depth = 7)
  partcv[0] = 0;
  Object call5299 = callmethod(call5298, "new",
    1, partcv, params);
  gc_frame_end(callframe5296);
// compiled call node returning call5299 (depth = 6)
// compiled member node returning call5299 (depth = 5)
  *var_suggestion = call5299;
  if (call5299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5300 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5301 == NULL) {
    strlit5301 = alloc_String("]");
    gc_root(strlit5301);
  }
// compiled string node returning strlit5301 (depth = 5)
  gc_frame_newslot(strlit5301);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5301;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5302 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5300);
// compiled call node returning call5302 (depth = 4)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5303 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5304 == NULL) {
    strlit5304 = alloc_String("A '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit5304);
  }
// compiled string node returning strlit5304 (depth = 5)
  gc_frame_newslot(strlit5304);
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call5306 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5305);
// compiled call node returning call5306 (depth = 6)
// compiled member node returning call5306 (depth = 5)
  gc_frame_newslot(call5306);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5309 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5308);
// compiled call node returning call5309 (depth = 7)
// compiled member node returning call5309 (depth = 6)
  int op_slot_right_5307 = gc_frame_newslot(call5309);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5311 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5312 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5311);
// compiled call node returning call5312 (depth = 7)
// compiled member node returning call5312 (depth = 6)
  int op_slot_left_5307 = gc_frame_newslot(call5312);
  params[0] = call5309;
  partcv[0] = 1;
  Object sum5313 = callmethod(call5312, "+", 1, partcv, params);
// compiled op node returning sum5313 (depth = 5)
  gc_frame_newslot(sum5313);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5304;
  params[1] = call5306;
  params[2] = sum5313;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5314 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5303);
// compiled call node returning call5314 (depth = 4)
    gc_frame_newslot(call5314);
    if5289 = call5314;
  } else {
  }
// compiled if node returning if5289 (depth = 3)
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5316 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5315);
// compiled call node returning call5316 (depth = 4)
// compiled member node returning call5316 (depth = 3)
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5317 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_index (depth = 5)
  gc_frame_newslot(*var_index);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5318 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5319 = callmethod(*var_ast, "indexNode",
    1, partcv, params);
  gc_frame_end(callframe5318);
// compiled call node returning call5319 (depth = 6)
// compiled member node returning call5319 (depth = 5)
  params[0] = *var_expr;
  params[1] = *var_index;
  partcv[0] = 2;
  Object call5320 = callmethod(call5319, "new",
    1, partcv, params);
  gc_frame_end(callframe5317);
// compiled call node returning call5320 (depth = 4)
  *var_o = call5320;
  if (call5320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5321 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5322 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5321);
// compiled call node returning call5322 (depth = 3)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5323 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5324 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5323);
// compiled call node returning call5324 (depth = 3)
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5325 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5326 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5325);
// compiled call node returning call5326 (depth = 3)
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5328 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5327);
// compiled call node returning call5328 (depth = 4)
// compiled member node returning call5328 (depth = 3)
    gc_frame_newslot(call5328);
    if5217 = call5328;
  } else {
  }
// compiled if node returning if5217 (depth = 2)
  gc_frame_end(frame);
  return if5217;
}
Object meth_parser_oprec5329(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method oprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for oprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for oprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5332 == NULL) {
    strlit5332 = alloc_String("*");
    gc_root(strlit5332);
  }
// compiled string node returning strlit5332 (depth = 4)
  int op_slot_right_5331 = gc_frame_newslot(strlit5332);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  int op_slot_left_5331 = gc_frame_newslot(*var_o);
  params[0] = strlit5332;
  partcv[0] = 1;
  Object opresult5334 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult5334 (depth = 3)
  Object if5330 = done;
  if (istrue(opresult5334)) {
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5335 = alloc_Float64(10);
// compiled num node returning num5335 (depth = 4)
  return num5335;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5330 = undefined;
  } else {
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5338 == NULL) {
    strlit5338 = alloc_String("/");
    gc_root(strlit5338);
  }
// compiled string node returning strlit5338 (depth = 5)
  int op_slot_right_5337 = gc_frame_newslot(strlit5338);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  int op_slot_left_5337 = gc_frame_newslot(*var_o);
  params[0] = strlit5338;
  partcv[0] = 1;
  Object opresult5340 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult5340 (depth = 4)
  Object if5336 = done;
  if (istrue(opresult5340)) {
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5341 = alloc_Float64(10);
// compiled num node returning num5341 (depth = 5)
  return num5341;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5336 = undefined;
  } else {
  }
// compiled if node returning if5336 (depth = 3)
    gc_frame_newslot(if5336);
    if5330 = if5336;
  }
// compiled if node returning if5330 (depth = 2)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num5342 = alloc_Float64(5);
// compiled num node returning num5342 (depth = 3)
  return num5342;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_toprec5343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5346 = alloc_Float64(0);
// compiled num node returning num5346 (depth = 4)
  int op_slot_right_5345 = gc_frame_newslot(num5346);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call5349 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5348);
// compiled call node returning call5349 (depth = 5)
// compiled member node returning call5349 (depth = 4)
  int op_slot_left_5345 = gc_frame_newslot(call5349);
  params[0] = num5346;
  partcv[0] = 1;
  Object opresult5350 = callmethod(call5349, ">", 1, partcv, params);
// compiled op node returning opresult5350 (depth = 3)
  Object if5344 = done;
  if (istrue(opresult5350)) {
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5351 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call5352 = callmethod(*var_ops, "last",
    1, partcv, params);
  gc_frame_end(callframe5351);
// compiled call node returning call5352 (depth = 5)
// compiled member node returning call5352 (depth = 4)
  *var_o = call5352;
  if (call5352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5353 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5354 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5353);
// compiled call node returning call5354 (depth = 4)
  return call5354;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5344 = undefined;
  } else {
  }
// compiled if node returning if5344 (depth = 2)
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num5355 = alloc_Float64(0);
// compiled num node returning num5355 (depth = 2)
  gc_frame_end(frame);
  return num5355;
}
Object meth_parser__apply5364(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5366 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5365);
// compiled call node returning call5366 (depth = 6)
// compiled member node returning call5366 (depth = 5)
  gc_frame_end(frame);
  return call5366;
}
Object meth_parser_typeexpressionrest5356(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5358 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5359 == NULL) {
    strlit5359 = alloc_String("op");
    gc_root(strlit5359);
  }
// compiled string node returning strlit5359 (depth = 4)
  gc_frame_newslot(strlit5359);
// call case 4: self request
  params[0] = strlit5359;
  partcv[0] = 1;
  Object call5360 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5358);
// compiled call node returning call5360 (depth = 3)
  Object if5357 = done;
  if (istrue(call5360)) {
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5361 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5362 == NULL) {
    strlit5362 = alloc_String("type expression");
    gc_root(strlit5362);
  }
// compiled string node returning strlit5362 (depth = 4)
  gc_frame_newslot(strlit5362);
// starting to compile block node (depth = 4)
  Object block5363 = alloc_Block(NULL, NULL, "parser", 1692);
  gc_frame_newslot(block5363);
// method _apply
  block_savedest(block5363);
  Object closure5364 = createclosure(1, "_apply");
  setclosureframe(closure5364, stackframe);
  addtoclosure(closure5364, selfslot);
  struct UserObject *uo5364 = (struct UserObject*)block5363;
  uo5364->data[0] = (Object)closure5364;
  Method *meth_meth_parser__apply5364 = addmethod2pos(block5363, "_apply", &meth_parser__apply5364, 0);
  int argcv_meth_parser__apply5364[] = {0};
  meth_meth_parser__apply5364->type = alloc_MethodType(1, argcv_meth_parser__apply5364);
  meth_meth_parser__apply5364->definitionModule = modulename;
  meth_meth_parser__apply5364->definitionLine = 1683;
// compiled block node returning block5363 (depth = 4)
  gc_frame_newslot(block5363);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = strlit5362;
  params[1] = block5363;
  params[2] = *var_noBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5368 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5361);
// compiled call node returning call5368 (depth = 3)
    gc_frame_newslot(call5368);
    if5357 = call5368;
  } else {
  }
// compiled if node returning if5357 (depth = 2)
  gc_frame_end(frame);
  return if5357;
}
Object meth_parser__apply5377(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5378 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5379 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5378);
// compiled call node returning call5379 (depth = 5)
  gc_frame_end(frame);
  return call5379;
}
Object meth_parser_valueexpressionrest5369(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valueexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for valueexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for valueexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5371 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5372 == NULL) {
    strlit5372 = alloc_String("op");
    gc_root(strlit5372);
  }
// compiled string node returning strlit5372 (depth = 4)
  gc_frame_newslot(strlit5372);
// call case 4: self request
  params[0] = strlit5372;
  partcv[0] = 1;
  Object call5373 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5371);
// compiled call node returning call5373 (depth = 3)
  Object if5370 = done;
  if (istrue(call5373)) {
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5374 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5375 == NULL) {
    strlit5375 = alloc_String("expression");
    gc_root(strlit5375);
  }
// compiled string node returning strlit5375 (depth = 4)
  gc_frame_newslot(strlit5375);
// starting to compile block node (depth = 4)
  Object block5376 = alloc_Block(NULL, NULL, "parser", 1698);
  gc_frame_newslot(block5376);
// method _apply
  block_savedest(block5376);
  Object closure5377 = createclosure(2, "_apply");
  setclosureframe(closure5377, stackframe);
  addtoclosure(closure5377, var_blocksOK);
  addtoclosure(closure5377, selfslot);
  struct UserObject *uo5377 = (struct UserObject*)block5376;
  uo5377->data[0] = (Object)closure5377;
  Method *meth_meth_parser__apply5377 = addmethod2pos(block5376, "_apply", &meth_parser__apply5377, 0);
  int argcv_meth_parser__apply5377[] = {0};
  meth_meth_parser__apply5377->type = alloc_MethodType(1, argcv_meth_parser__apply5377);
  meth_meth_parser__apply5377->definitionModule = modulename;
  meth_meth_parser__apply5377->definitionLine = 1692;
// compiled block node returning block5376 (depth = 4)
  gc_frame_newslot(block5376);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = strlit5375;
  params[1] = block5376;
  params[2] = *var_blocksOK;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5381 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5374);
// compiled call node returning call5381 (depth = 3)
    gc_frame_newslot(call5381);
    if5370 = call5381;
  } else {
  }
// compiled if node returning if5370 (depth = 2)
  gc_frame_end(frame);
  return if5370;
}
Object meth_parser__apply5397(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5399 == NULL) {
    strlit5399 = alloc_String("=");
    gc_root(strlit5399);
  }
// compiled string node returning strlit5399 (depth = 7)
  int op_slot_right_5398 = gc_frame_newslot(strlit5399);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5402 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5401);
// compiled call node returning call5402 (depth = 8)
// compiled member node returning call5402 (depth = 7)
  int op_slot_left_5398 = gc_frame_newslot(call5402);
  params[0] = strlit5399;
  partcv[0] = 1;
  Object opresult5403 = callmethod(call5402, "!=", 1, partcv, params);
// compiled op node returning opresult5403 (depth = 6)
  gc_frame_end(frame);
  return opresult5403;
}
Object meth_parser__apply5394(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5395 = gc_frame_new();
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5396 = alloc_Block(NULL, NULL, "parser", 1720);
  gc_frame_newslot(block5396);
// method _apply
  block_savedest(block5396);
  Object closure5397 = createclosure(2, "_apply");
  setclosureframe(closure5397, stackframe);
  addtoclosure(closure5397, var_sym);
  addtoclosure(closure5397, selfslot);
  struct UserObject *uo5397 = (struct UserObject*)block5396;
  uo5397->data[0] = (Object)closure5397;
  Method *meth_meth_parser__apply5397 = addmethod2pos(block5396, "_apply", &meth_parser__apply5397, 0);
  int argcv_meth_parser__apply5397[] = {0};
  meth_meth_parser__apply5397->type = alloc_MethodType(1, argcv_meth_parser__apply5397);
  meth_meth_parser__apply5397->definitionModule = modulename;
  meth_meth_parser__apply5397->definitionLine = 1713;
// compiled block node returning block5396 (depth = 5)
  gc_frame_newslot(block5396);
// call case 6: other member request
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5405 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5406 == NULL) {
    strlit5406 = alloc_String("op");
    gc_root(strlit5406);
  }
// compiled string node returning strlit5406 (depth = 6)
  gc_frame_newslot(strlit5406);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 4: self request
  params[0] = strlit5406;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5407 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5405);
// compiled call node returning call5407 (depth = 5)
  params[0] = block5396;
  partcv[0] = 1;
  Object call5408 = callmethod(call5407, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5395);
// compiled call node returning call5408 (depth = 4)
  gc_frame_end(frame);
  return call5408;
}
Object meth_parser__apply5522(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5525 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  gc_frame_newslot(*var_ops);
// call case 4: self request
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call5526 = callmethodflags(self, "toprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5525);
// compiled call node returning call5526 (depth = 8)
  int op_slot_right_5524 = gc_frame_newslot(call5526);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_prec (depth = 8)
  int op_slot_left_5524 = gc_frame_newslot(*var_prec);
  params[0] = call5526;
  partcv[0] = 1;
  Object opresult5528 = callmethod(*var_prec, "<=", 1, partcv, params);
// compiled op node returning opresult5528 (depth = 7)
  int op_slot_right_5523 = gc_frame_newslot(opresult5528);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5531 = alloc_Float64(0);
// compiled num node returning num5531 (depth = 8)
  int op_slot_right_5530 = gc_frame_newslot(num5531);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5533 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ops (depth = 10)
  partcv[0] = 0;
  Object call5534 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5533);
// compiled call node returning call5534 (depth = 9)
// compiled member node returning call5534 (depth = 8)
  int op_slot_left_5530 = gc_frame_newslot(call5534);
  params[0] = num5531;
  partcv[0] = 1;
  Object opresult5535 = callmethod(call5534, ">", 1, partcv, params);
// compiled op node returning opresult5535 (depth = 7)
  int op_slot_left_5523 = gc_frame_newslot(opresult5535);
  params[0] = opresult5528;
  partcv[0] = 1;
  Object opresult5536 = callmethod(opresult5535, "&&", 1, partcv, params);
// compiled op node returning opresult5536 (depth = 6)
  gc_frame_end(frame);
  return opresult5536;
}
Object meth_parser__apply5539(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5540 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  partcv[0] = 0;
  Object call5541 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5540);
// compiled call node returning call5541 (depth = 8)
// compiled member node returning call5541 (depth = 7)
  *var_o2 = call5541;
  if (call5541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5543 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5544 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5543);
// compiled call node returning call5544 (depth = 8)
// compiled member node returning call5544 (depth = 7)
  *var_tmp2 = call5544;
  if (call5544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5546 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5547 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5546);
// compiled call node returning call5547 (depth = 8)
// compiled member node returning call5547 (depth = 7)
  *var_tmp = call5547;
  if (call5547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5549 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tmp (depth = 9)
  partcv[0] = 0;
  Object call5551 = callmethod(*var_tmp, "line",
    1, partcv, params);
  gc_frame_end(callframe5550);
// compiled call node returning call5551 (depth = 8)
// compiled member node returning call5551 (depth = 7)
  gc_frame_newslot(call5551);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tmp (depth = 9)
  partcv[0] = 0;
  Object call5553 = callmethod(*var_tmp, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5552);
// compiled call node returning call5553 (depth = 8)
// compiled member node returning call5553 (depth = 7)
  gc_frame_newslot(call5553);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call5551;
  params[1] = call5553;
  partcv[0] = 2;
  Object call5554 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5549);
// compiled call node returning call5554 (depth = 6)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5555 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o2 (depth = 8)
  gc_frame_newslot(*var_o2);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp2 (depth = 8)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5556 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call5557 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5556);
// compiled call node returning call5557 (depth = 9)
// compiled member node returning call5557 (depth = 8)
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5558 = callmethod(call5557, "new",
    1, partcv, params);
  gc_frame_end(callframe5555);
// compiled call node returning call5558 (depth = 7)
  *var_tmp = call5558;
  if (call5558 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5560 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5561 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5560);
// compiled call node returning call5561 (depth = 6)
  gc_frame_end(frame);
  return call5561;
}
Object meth_parser__apply5739(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5740 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5741 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5740);
// compiled call node returning call5741 (depth = 11)
// compiled member node returning call5741 (depth = 10)
  gc_frame_end(frame);
  return call5741;
}
Object meth_parser__apply5411(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_util = getfromclosure(closure, 13);
  Object *var_ast = getfromclosure(closure, 14);
  Object *var_recurse = getfromclosure(closure, 15);
  Object *var_name = getfromclosure(closure, 16);
  Object *var_acceptBlocks = getfromclosure(closure, 17);
  Object *var_values = getfromclosure(closure, 18);
  Object self = *(getfromclosure(closure, 19));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5413 = alloc_Float64(1);
// compiled num node returning num5413 (depth = 6)
  int op_slot_right_5412 = gc_frame_newslot(num5413);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opcount (depth = 6)
  int op_slot_left_5412 = gc_frame_newslot(*var_opcount);
  params[0] = num5413;
  partcv[0] = 1;
  Object sum5415 = callmethod(*var_opcount, "+", 1, partcv, params);
// compiled op node returning sum5415 (depth = 5)
  *var_opcount = sum5415;
  if (sum5415 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5418 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5417);
// compiled call node returning call5418 (depth = 6)
// compiled member node returning call5418 (depth = 5)
  *var_o = call5418;
  if (call5418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5421 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5420);
// compiled call node returning call5421 (depth = 5)
// compiled member node returning call5421 (depth = 4)
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5422 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5423 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5422);
// compiled call node returning call5423 (depth = 5)
  *var_prec = call5423;
  if (call5423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5428 == NULL) {
    strlit5428 = alloc_String("-");
    gc_root(strlit5428);
  }
// compiled string node returning strlit5428 (depth = 7)
  int op_slot_right_5427 = gc_frame_newslot(strlit5428);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  int op_slot_left_5427 = gc_frame_newslot(*var_o);
  params[0] = strlit5428;
  partcv[0] = 1;
  Object opresult5430 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5430 (depth = 6)
  int op_slot_right_5426 = gc_frame_newslot(opresult5430);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5434 == NULL) {
    strlit5434 = alloc_String("+");
    gc_root(strlit5434);
  }
// compiled string node returning strlit5434 (depth = 8)
  int op_slot_right_5433 = gc_frame_newslot(strlit5434);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_left_5433 = gc_frame_newslot(*var_o);
  params[0] = strlit5434;
  partcv[0] = 1;
  Object opresult5436 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5436 (depth = 7)
  int op_slot_right_5432 = gc_frame_newslot(opresult5436);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5440 == NULL) {
    strlit5440 = alloc_String("/");
    gc_root(strlit5440);
  }
// compiled string node returning strlit5440 (depth = 9)
  int op_slot_right_5439 = gc_frame_newslot(strlit5440);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_5439 = gc_frame_newslot(*var_o);
  params[0] = strlit5440;
  partcv[0] = 1;
  Object opresult5442 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5442 (depth = 8)
  int op_slot_right_5438 = gc_frame_newslot(opresult5442);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5445 == NULL) {
    strlit5445 = alloc_String("*");
    gc_root(strlit5445);
  }
// compiled string node returning strlit5445 (depth = 9)
  int op_slot_right_5444 = gc_frame_newslot(strlit5445);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_5444 = gc_frame_newslot(*var_o);
  params[0] = strlit5445;
  partcv[0] = 1;
  Object opresult5447 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5447 (depth = 8)
  int op_slot_left_5438 = gc_frame_newslot(opresult5447);
  params[0] = opresult5442;
  partcv[0] = 1;
  Object opresult5448 = callmethod(opresult5447, "&&", 1, partcv, params);
// compiled op node returning opresult5448 (depth = 7)
  int op_slot_left_5432 = gc_frame_newslot(opresult5448);
  params[0] = opresult5436;
  partcv[0] = 1;
  Object opresult5449 = callmethod(opresult5448, "&&", 1, partcv, params);
// compiled op node returning opresult5449 (depth = 6)
  int op_slot_left_5426 = gc_frame_newslot(opresult5449);
  params[0] = opresult5430;
  partcv[0] = 1;
  Object opresult5450 = callmethod(opresult5449, "&&", 1, partcv, params);
// compiled op node returning opresult5450 (depth = 5)
  Object if5425 = done;
  if (istrue(opresult5450)) {
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5451 = alloc_Boolean(0);
// compiled identifier node returning bool5451 (depth = 6)
  *var_allarith = bool5451;
  if (bool5451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5425 = done;
  } else {
  }
// compiled if node returning if5425 (depth = 4)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_allarith (depth = 8)
  partcv[0] = 0;
  Object call5456 = callmethod(*var_allarith, "not",
    1, partcv, params);
  gc_frame_end(callframe5455);
// compiled call node returning call5456 (depth = 7)
// compiled member node returning call5456 (depth = 6)
  int op_slot_right_5454 = gc_frame_newslot(call5456);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_right_5459 = gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_5459 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult5461 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compiled op node returning opresult5461 (depth = 7)
  int op_slot_right_5458 = gc_frame_newslot(opresult5461);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5464 == NULL) {
    strlit5464 = alloc_String("");
    gc_root(strlit5464);
  }
// compiled string node returning strlit5464 (depth = 8)
  int op_slot_right_5463 = gc_frame_newslot(strlit5464);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_5463 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit5464;
  partcv[0] = 1;
  Object opresult5466 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compiled op node returning opresult5466 (depth = 7)
  int op_slot_left_5458 = gc_frame_newslot(opresult5466);
  params[0] = opresult5461;
  partcv[0] = 1;
  Object opresult5467 = callmethod(opresult5466, "&&", 1, partcv, params);
// compiled op node returning opresult5467 (depth = 6)
  int op_slot_left_5454 = gc_frame_newslot(opresult5467);
  params[0] = call5456;
  partcv[0] = 1;
  Object opresult5468 = callmethod(opresult5467, "&&", 1, partcv, params);
// compiled op node returning opresult5468 (depth = 5)
  Object if5453 = done;
  if (istrue(opresult5468)) {
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5469 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5470 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5471 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5470);
// compiled call node returning call5471 (depth = 9)
// compiled member node returning call5471 (depth = 8)
  partcv[0] = 0;
  Object call5472 = callmethod(call5471, "empty",
    1, partcv, params);
  gc_frame_end(callframe5469);
// compiled call node returning call5472 (depth = 7)
// compiled member node returning call5472 (depth = 6)
  *var_suggestions = call5472;
  if (call5472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5473 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5474 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5475 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5474);
// compiled call node returning call5475 (depth = 9)
// compiled member node returning call5475 (depth = 8)
  partcv[0] = 0;
  Object call5476 = callmethod(call5475, "new",
    1, partcv, params);
  gc_frame_end(callframe5473);
// compiled call node returning call5476 (depth = 7)
// compiled member node returning call5476 (depth = 6)
  *var_suggestion = call5476;
  if (call5476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5477 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5478 == NULL) {
    strlit5478 = alloc_String(")");
    gc_root(strlit5478);
  }
// compiled string node returning strlit5478 (depth = 6)
  gc_frame_newslot(strlit5478);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5478;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5479 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5477);
// compiled call node returning call5479 (depth = 5)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5480 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5481 == NULL) {
    strlit5481 = alloc_String("(");
    gc_root(strlit5481);
  }
// compiled string node returning strlit5481 (depth = 6)
  gc_frame_newslot(strlit5481);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5482 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5483 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5482);
// compiled call node returning call5483 (depth = 7)
// compiled member node returning call5483 (depth = 6)
  gc_frame_newslot(call5483);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5481;
  params[1] = call5483;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5484 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5480);
// compiled call node returning call5484 (depth = 5)
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5485 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5486 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5485);
// compiled call node returning call5486 (depth = 5)
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5487 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5489 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5488);
// compiled call node returning call5489 (depth = 9)
// compiled member node returning call5489 (depth = 8)
  partcv[0] = 0;
  Object call5490 = callmethod(call5489, "new",
    1, partcv, params);
  gc_frame_end(callframe5487);
// compiled call node returning call5490 (depth = 7)
// compiled member node returning call5490 (depth = 6)
  *var_suggestion = call5490;
  if (call5490 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5492 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5493 == NULL) {
    strlit5493 = alloc_String(")");
    gc_root(strlit5493);
  }
// compiled string node returning strlit5493 (depth = 6)
  gc_frame_newslot(strlit5493);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5495 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5494);
// compiled call node returning call5495 (depth = 7)
// compiled member node returning call5495 (depth = 6)
  gc_frame_newslot(call5495);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5493;
  params[1] = call5495;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5496 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5492);
// compiled call node returning call5496 (depth = 5)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5497 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5498 == NULL) {
    strlit5498 = alloc_String("(");
    gc_root(strlit5498);
  }
// compiled string node returning strlit5498 (depth = 6)
  gc_frame_newslot(strlit5498);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5499 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5500 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5501 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call5502 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5501);
// compiled call node returning call5502 (depth = 11)
// compiled member node returning call5502 (depth = 10)
  partcv[0] = 0;
  Object call5503 = callmethod(call5502, "prev",
    1, partcv, params);
  gc_frame_end(callframe5500);
// compiled call node returning call5503 (depth = 9)
// compiled member node returning call5503 (depth = 8)
  partcv[0] = 0;
  Object call5504 = callmethod(call5503, "prev",
    1, partcv, params);
  gc_frame_end(callframe5499);
// compiled call node returning call5504 (depth = 7)
// compiled member node returning call5504 (depth = 6)
  gc_frame_newslot(call5504);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5498;
  params[1] = call5504;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5505 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5497);
// compiled call node returning call5505 (depth = 5)
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5506 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5507 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5506);
// compiled call node returning call5507 (depth = 5)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5508 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5509 == NULL) {
    strlit5509 = alloc_String("An expression containing both arithmetic and non-arithmetic operators requires parentheses.");
    gc_root(strlit5509);
  }
// compiled string node returning strlit5509 (depth = 6)
  gc_frame_newslot(strlit5509);
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5510 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5512 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5511);
// compiled call node returning call5512 (depth = 9)
// compiled member node returning call5512 (depth = 8)
  partcv[0] = 0;
  Object call5513 = callmethod(call5512, "line",
    1, partcv, params);
  gc_frame_end(callframe5510);
// compiled call node returning call5513 (depth = 7)
// compiled member node returning call5513 (depth = 6)
  gc_frame_newslot(call5513);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5514 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5515 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5516 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5515);
// compiled call node returning call5516 (depth = 9)
// compiled member node returning call5516 (depth = 8)
  partcv[0] = 0;
  Object call5517 = callmethod(call5516, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5514);
// compiled call node returning call5517 (depth = 7)
// compiled member node returning call5517 (depth = 6)
  gc_frame_newslot(call5517);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit5509;
  params[1] = call5513;
  params[2] = call5517;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5518 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5508);
// compiled call node returning call5518 (depth = 5)
    gc_frame_newslot(call5518);
    if5453 = call5518;
  } else {
  }
// compiled if node returning if5453 (depth = 4)
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5520 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5521 = alloc_Block(NULL, NULL, "parser", 1745);
  gc_frame_newslot(block5521);
// method _apply
  block_savedest(block5521);
  Object closure5522 = createclosure(3, "_apply");
  setclosureframe(closure5522, stackframe);
  addtoclosure(closure5522, var_ops);
  addtoclosure(closure5522, var_prec);
  addtoclosure(closure5522, selfslot);
  struct UserObject *uo5522 = (struct UserObject*)block5521;
  uo5522->data[0] = (Object)closure5522;
  Method *meth_meth_parser__apply5522 = addmethod2pos(block5521, "_apply", &meth_parser__apply5522, 0);
  int argcv_meth_parser__apply5522[] = {0};
  meth_meth_parser__apply5522->type = alloc_MethodType(1, argcv_meth_parser__apply5522);
  meth_meth_parser__apply5522->definitionModule = modulename;
  meth_meth_parser__apply5522->definitionLine = 1742;
// compiled block node returning block5521 (depth = 5)
  gc_frame_newslot(block5521);
// starting to compile block node (depth = 5)
  Object block5538 = alloc_Block(NULL, NULL, "parser", 1745);
  gc_frame_newslot(block5538);
// method _apply
  block_savedest(block5538);
  Object closure5539 = createclosure(8, "_apply");
  setclosureframe(closure5539, stackframe);
  addtoclosure(closure5539, var_ops);
  addtoclosure(closure5539, var_o2);
  addtoclosure(closure5539, var_terms);
  addtoclosure(closure5539, var_tmp2);
  addtoclosure(closure5539, var_tmp);
  addtoclosure(closure5539, var_util);
  addtoclosure(closure5539, var_ast);
  addtoclosure(closure5539, selfslot);
  struct UserObject *uo5539 = (struct UserObject*)block5538;
  uo5539->data[0] = (Object)closure5539;
  Method *meth_meth_parser__apply5539 = addmethod2pos(block5538, "_apply", &meth_parser__apply5539, 0);
  int argcv_meth_parser__apply5539[] = {0};
  meth_meth_parser__apply5539->type = alloc_MethodType(1, argcv_meth_parser__apply5539);
  meth_meth_parser__apply5539->definitionModule = modulename;
  meth_meth_parser__apply5539->definitionLine = 1745;
// compiled block node returning block5538 (depth = 5)
  gc_frame_newslot(block5538);
// call case 5: prelude request
  params[0] = block5521;
  params[1] = block5538;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5563 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5520);
// compiled call node returning call5563 (depth = 4)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5564 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5565 = callmethod(*var_ops, "push",
    1, partcv, params);
  gc_frame_end(callframe5564);
// compiled call node returning call5565 (depth = 4)
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5567 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5568 == NULL) {
    strlit5568 = alloc_String("lparen");
    gc_root(strlit5568);
  }
// compiled string node returning strlit5568 (depth = 6)
  gc_frame_newslot(strlit5568);
// call case 4: self request
  params[0] = strlit5568;
  partcv[0] = 1;
  Object call5569 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5567);
// compiled call node returning call5569 (depth = 5)
  Object if5566 = done;
  if (istrue(call5569)) {
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5570 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5571 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5570);
// compiled call node returning call5571 (depth = 6)
// compiled member node returning call5571 (depth = 5)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5573 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5574 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_recurse (depth = 9)
  gc_frame_newslot(*var_recurse);
// call case 4: self request
  params[0] = *var_recurse;
  partcv[0] = 1;
  Object call5575 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5574);
// compiled call node returning call5575 (depth = 8)
  partcv[0] = 0;
  Object call5576 = callmethod(call5575, "not",
    1, partcv, params);
  gc_frame_end(callframe5573);
// compiled call node returning call5576 (depth = 7)
// compiled member node returning call5576 (depth = 6)
  Object if5572 = done;
  if (istrue(call5576)) {
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5577 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5578 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5579 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5578);
// compiled call node returning call5579 (depth = 10)
// compiled member node returning call5579 (depth = 9)
  partcv[0] = 0;
  Object call5580 = callmethod(call5579, "new",
    1, partcv, params);
  gc_frame_end(callframe5577);
// compiled call node returning call5580 (depth = 8)
// compiled member node returning call5580 (depth = 7)
  *var_suggestion = call5580;
  if (call5580 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5581 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5582 == NULL) {
    strlit5582 = alloc_String("rparen");
    gc_root(strlit5582);
  }
// compiled string node returning strlit5582 (depth = 8)
  gc_frame_newslot(strlit5582);
// call case 4: self request
  params[0] = strlit5582;
  partcv[0] = 1;
  Object call5583 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5581);
// compiled call node returning call5583 (depth = 7)
  *var_nextTok = call5583;
  if (call5583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5585 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5585 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5587 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5587 (depth = 7)
  Object if5584 = done;
  if (istrue(opresult5587)) {
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5588 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5590 == NULL) {
    strlit5590 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5590);
  }
// compiled string node returning strlit5590 (depth = 9)
  int op_slot_right_5589 = gc_frame_newslot(strlit5590);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5592 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5594 == NULL) {
    strlit5594 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5594);
  }
// compiled string node returning strlit5594 (depth = 10)
  int op_slot_left_5592 = gc_frame_newslot(strlit5594);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5595 = callmethod(strlit5594, "++", 1, partcv, params);
// compiled op node returning opresult5595 (depth = 9)
  int op_slot_left_5589 = gc_frame_newslot(opresult5595);
  params[0] = strlit5590;
  partcv[0] = 1;
  Object opresult5596 = callmethod(opresult5595, "++", 1, partcv, params);
// compiled op node returning opresult5596 (depth = 8)
  gc_frame_newslot(opresult5596);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5596;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5597 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5588);
// compiled call node returning call5597 (depth = 7)
    gc_frame_newslot(call5597);
    if5584 = call5597;
  } else {
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5598 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5600 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5599);
// compiled call node returning call5600 (depth = 9)
// compiled member node returning call5600 (depth = 8)
  gc_frame_newslot(call5600);
// starting to compile identifier node (depth = 8)
  Object bool5601 = alloc_Boolean(1);
// compiled identifier node returning bool5601 (depth = 8)
  gc_frame_newslot(bool5601);
// starting to compile identifier node (depth = 8)
  Object bool5602 = alloc_Boolean(0);
// compiled identifier node returning bool5602 (depth = 8)
  gc_frame_newslot(bool5602);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5604 == NULL) {
    strlit5604 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5604);
  }
// compiled string node returning strlit5604 (depth = 9)
  int op_slot_right_5603 = gc_frame_newslot(strlit5604);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5606 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5608 == NULL) {
    strlit5608 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5608);
  }
// compiled string node returning strlit5608 (depth = 10)
  int op_slot_left_5606 = gc_frame_newslot(strlit5608);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5609 = callmethod(strlit5608, "++", 1, partcv, params);
// compiled op node returning opresult5609 (depth = 9)
  int op_slot_left_5603 = gc_frame_newslot(opresult5609);
  params[0] = strlit5604;
  partcv[0] = 1;
  Object opresult5610 = callmethod(opresult5609, "++", 1, partcv, params);
// compiled op node returning opresult5610 (depth = 8)
  gc_frame_newslot(opresult5610);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5600;
  params[2] = bool5601;
  params[3] = bool5602;
  params[4] = opresult5610;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5611 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5598);
// compiled call node returning call5611 (depth = 7)
    gc_frame_newslot(call5611);
    if5584 = call5611;
  }
// compiled if node returning if5584 (depth = 6)
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5612 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5614 == NULL) {
    strlit5614 = alloc_String(".");
    gc_root(strlit5614);
  }
// compiled string node returning strlit5614 (depth = 8)
  int op_slot_right_5613 = gc_frame_newslot(strlit5614);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5616 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5618 == NULL) {
    strlit5618 = alloc_String("Parentheses must contain a valid ");
    gc_root(strlit5618);
  }
// compiled string node returning strlit5618 (depth = 9)
  int op_slot_left_5616 = gc_frame_newslot(strlit5618);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5619 = callmethod(strlit5618, "++", 1, partcv, params);
// compiled op node returning opresult5619 (depth = 8)
  int op_slot_left_5613 = gc_frame_newslot(opresult5619);
  params[0] = strlit5614;
  partcv[0] = 1;
  Object opresult5620 = callmethod(opresult5619, "++", 1, partcv, params);
// compiled op node returning opresult5620 (depth = 7)
  gc_frame_newslot(opresult5620);
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5621 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5622 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5621);
// compiled call node returning call5622 (depth = 8)
// compiled member node returning call5622 (depth = 7)
  gc_frame_newslot(call5622);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5624 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5623);
// compiled call node returning call5624 (depth = 8)
// compiled member node returning call5624 (depth = 7)
  gc_frame_newslot(call5624);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5620;
  params[1] = call5622;
  params[2] = call5624;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5625 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5612);
// compiled call node returning call5625 (depth = 6)
    gc_frame_newslot(call5625);
    if5572 = call5625;
  } else {
  }
// compiled if node returning if5572 (depth = 5)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5628 == NULL) {
    strlit5628 = alloc_String("rparen");
    gc_root(strlit5628);
  }
// compiled string node returning strlit5628 (depth = 7)
  int op_slot_right_5627 = gc_frame_newslot(strlit5628);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5631 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5630);
// compiled call node returning call5631 (depth = 8)
// compiled member node returning call5631 (depth = 7)
  int op_slot_left_5627 = gc_frame_newslot(call5631);
  params[0] = strlit5628;
  partcv[0] = 1;
  Object opresult5632 = callmethod(call5631, "!=", 1, partcv, params);
// compiled op node returning opresult5632 (depth = 6)
  Object if5626 = done;
  if (istrue(opresult5632)) {
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5634 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5633);
// compiled call node returning call5634 (depth = 7)
// compiled member node returning call5634 (depth = 6)
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5635 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5636 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5637 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5636);
// compiled call node returning call5637 (depth = 10)
// compiled member node returning call5637 (depth = 9)
  partcv[0] = 0;
  Object call5638 = callmethod(call5637, "new",
    1, partcv, params);
  gc_frame_end(callframe5635);
// compiled call node returning call5638 (depth = 8)
// compiled member node returning call5638 (depth = 7)
  *var_suggestion = call5638;
  if (call5638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5639 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5640 == NULL) {
    strlit5640 = alloc_String(")");
    gc_root(strlit5640);
  }
// compiled string node returning strlit5640 (depth = 7)
  gc_frame_newslot(strlit5640);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5640;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5641 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5639);
// compiled call node returning call5641 (depth = 6)
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5642 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5643 == NULL) {
    strlit5643 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5643);
  }
// compiled string node returning strlit5643 (depth = 7)
  gc_frame_newslot(strlit5643);
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5645 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5644);
// compiled call node returning call5645 (depth = 8)
// compiled member node returning call5645 (depth = 7)
  gc_frame_newslot(call5645);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5648 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5647);
// compiled call node returning call5648 (depth = 9)
// compiled member node returning call5648 (depth = 8)
  int op_slot_right_5646 = gc_frame_newslot(call5648);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5651 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5650);
// compiled call node returning call5651 (depth = 9)
// compiled member node returning call5651 (depth = 8)
  int op_slot_left_5646 = gc_frame_newslot(call5651);
  params[0] = call5648;
  partcv[0] = 1;
  Object sum5652 = callmethod(call5651, "+", 1, partcv, params);
// compiled op node returning sum5652 (depth = 7)
  gc_frame_newslot(sum5652);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5643;
  params[1] = call5645;
  params[2] = sum5652;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5653 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5642);
// compiled call node returning call5653 (depth = 6)
    gc_frame_newslot(call5653);
    if5626 = call5653;
  } else {
  }
// compiled if node returning if5626 (depth = 5)
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5655 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5654);
// compiled call node returning call5655 (depth = 6)
// compiled member node returning call5655 (depth = 5)
    gc_frame_newslot(call5655);
    if5566 = call5655;
  } else {
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5657 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5658 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5659 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5658);
// compiled call node returning call5659 (depth = 8)
// compiled member node returning call5659 (depth = 7)
  partcv[0] = 0;
  Object call5660 = callmethod(call5659, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe5657);
// compiled call node returning call5660 (depth = 6)
  Object if5656 = done;
  if (istrue(call5660)) {
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5661 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5662 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5663 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5662);
// compiled call node returning call5663 (depth = 10)
// compiled member node returning call5663 (depth = 9)
  partcv[0] = 0;
  Object call5664 = callmethod(call5663, "empty",
    1, partcv, params);
  gc_frame_end(callframe5661);
// compiled call node returning call5664 (depth = 8)
// compiled member node returning call5664 (depth = 7)
  *var_suggestions = call5664;
  if (call5664 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5665 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5667 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5666);
// compiled call node returning call5667 (depth = 10)
// compiled member node returning call5667 (depth = 9)
  partcv[0] = 0;
  Object call5668 = callmethod(call5667, "new",
    1, partcv, params);
  gc_frame_end(callframe5665);
// compiled call node returning call5668 (depth = 8)
// compiled member node returning call5668 (depth = 7)
  *var_suggestion = call5668;
  if (call5668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5669 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool5670 = alloc_Boolean(1);
// compiled identifier node returning bool5670 (depth = 7)
  gc_frame_newslot(bool5670);
// starting to compile identifier node (depth = 7)
  Object bool5671 = alloc_Boolean(0);
// compiled identifier node returning bool5671 (depth = 7)
  gc_frame_newslot(bool5671);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool5670;
  params[2] = bool5671;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5672 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5669);
// compiled call node returning call5672 (depth = 6)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5673 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5674 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5673);
// compiled call node returning call5674 (depth = 6)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5675 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5676 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5677 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5676);
// compiled call node returning call5677 (depth = 10)
// compiled member node returning call5677 (depth = 9)
  partcv[0] = 0;
  Object call5678 = callmethod(call5677, "new",
    1, partcv, params);
  gc_frame_end(callframe5675);
// compiled call node returning call5678 (depth = 8)
// compiled member node returning call5678 (depth = 7)
  *var_suggestion = call5678;
  if (call5678 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5680 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5682 == NULL) {
    strlit5682 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5682);
  }
// compiled string node returning strlit5682 (depth = 8)
  int op_slot_right_5681 = gc_frame_newslot(strlit5682);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5684 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5686 == NULL) {
    strlit5686 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5686);
  }
// compiled string node returning strlit5686 (depth = 9)
  int op_slot_left_5684 = gc_frame_newslot(strlit5686);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5687 = callmethod(strlit5686, "++", 1, partcv, params);
// compiled op node returning opresult5687 (depth = 8)
  int op_slot_left_5681 = gc_frame_newslot(opresult5687);
  params[0] = strlit5682;
  partcv[0] = 1;
  Object opresult5688 = callmethod(opresult5687, "++", 1, partcv, params);
// compiled op node returning opresult5688 (depth = 7)
  gc_frame_newslot(opresult5688);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5688;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5689 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5680);
// compiled call node returning call5689 (depth = 6)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5690 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5691 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5690);
// compiled call node returning call5691 (depth = 6)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5692 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5694 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5693);
// compiled call node returning call5694 (depth = 10)
// compiled member node returning call5694 (depth = 9)
  partcv[0] = 0;
  Object call5695 = callmethod(call5694, "new",
    1, partcv, params);
  gc_frame_end(callframe5692);
// compiled call node returning call5695 (depth = 8)
// compiled member node returning call5695 (depth = 7)
  *var_suggestion = call5695;
  if (call5695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5697 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile index node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call5700 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe5699);
// compiled call node returning call5700 (depth = 10)
// compiled member node returning call5700 (depth = 9)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call5702 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5701);
// compiled call node returning call5702 (depth = 10)
// compiled member node returning call5702 (depth = 9)
  params[0] = call5702;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5703 = callmethod(call5700, "[]", 1, partcv, params);
// compiled index node returning idxres5703 (depth = 8)
  int op_slot_right_5698 = gc_frame_newslot(idxres5703);
// starting to compile string node (depth = 8)
  if (strlit5705 == NULL) {
    strlit5705 = alloc_String(" ");
    gc_root(strlit5705);
  }
// compiled string node returning strlit5705 (depth = 8)
  int op_slot_left_5698 = gc_frame_newslot(strlit5705);
  params[0] = idxres5703;
  partcv[0] = 1;
  Object opresult5706 = callmethod(strlit5705, "++", 1, partcv, params);
// compiled op node returning opresult5706 (depth = 7)
  gc_frame_newslot(opresult5706);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5706;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5707 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5697);
// compiled call node returning call5707 (depth = 6)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5708 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5710 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5709);
// compiled call node returning call5710 (depth = 8)
// compiled member node returning call5710 (depth = 7)
  gc_frame_newslot(call5710);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call5710;
  partcv[0] = 1;
  Object call5711 = callmethod(*var_suggestion, "deleteLine",
    1, partcv, params);
  gc_frame_end(callframe5708);
// compiled call node returning call5711 (depth = 6)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5712 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5713 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5712);
// compiled call node returning call5713 (depth = 6)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5714 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5716 == NULL) {
    strlit5716 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5716);
  }
// compiled string node returning strlit5716 (depth = 8)
  int op_slot_right_5715 = gc_frame_newslot(strlit5716);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5720 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5719);
// compiled call node returning call5720 (depth = 10)
// compiled member node returning call5720 (depth = 9)
  int op_slot_right_5718 = gc_frame_newslot(call5720);
// starting to compile string node (depth = 9)
  if (strlit5722 == NULL) {
    strlit5722 = alloc_String("A valid expression must follow '");
    gc_root(strlit5722);
  }
// compiled string node returning strlit5722 (depth = 9)
  int op_slot_left_5718 = gc_frame_newslot(strlit5722);
  params[0] = call5720;
  partcv[0] = 1;
  Object opresult5723 = callmethod(strlit5722, "++", 1, partcv, params);
// compiled op node returning opresult5723 (depth = 8)
  int op_slot_left_5715 = gc_frame_newslot(opresult5723);
  params[0] = strlit5716;
  partcv[0] = 1;
  Object opresult5724 = callmethod(opresult5723, "++", 1, partcv, params);
// compiled op node returning opresult5724 (depth = 7)
  gc_frame_newslot(opresult5724);
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5726 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5725);
// compiled call node returning call5726 (depth = 8)
// compiled member node returning call5726 (depth = 7)
  gc_frame_newslot(call5726);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5729 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5728);
// compiled call node returning call5729 (depth = 9)
// compiled member node returning call5729 (depth = 8)
  int op_slot_right_5727 = gc_frame_newslot(call5729);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5731 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5732 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5731);
// compiled call node returning call5732 (depth = 9)
// compiled member node returning call5732 (depth = 8)
  int op_slot_left_5727 = gc_frame_newslot(call5732);
  params[0] = call5729;
  partcv[0] = 1;
  Object sum5733 = callmethod(call5732, "+", 1, partcv, params);
// compiled op node returning sum5733 (depth = 7)
  gc_frame_newslot(sum5733);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5724;
  params[1] = call5726;
  params[2] = sum5733;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5734 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5714);
// compiled call node returning call5734 (depth = 6)
    gc_frame_newslot(call5734);
    if5656 = call5734;
  } else {
  }
// compiled if node returning if5656 (depth = 5)
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5736 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5737 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block5738 = alloc_Block(NULL, NULL, "parser", 1802);
  gc_frame_newslot(block5738);
// method _apply
  block_savedest(block5738);
  Object closure5739 = createclosure(1, "_apply");
  setclosureframe(closure5739, stackframe);
  addtoclosure(closure5739, selfslot);
  struct UserObject *uo5739 = (struct UserObject*)block5738;
  uo5739->data[0] = (Object)closure5739;
  Method *meth_meth_parser__apply5739 = addmethod2pos(block5738, "_apply", &meth_parser__apply5739, 0);
  int argcv_meth_parser__apply5739[] = {0};
  meth_meth_parser__apply5739->type = alloc_MethodType(1, argcv_meth_parser__apply5739);
  meth_meth_parser__apply5739->definitionModule = modulename;
  meth_meth_parser__apply5739->definitionLine = 1802;
// compiled block node returning block5738 (depth = 9)
  gc_frame_newslot(block5738);
// call case 4: self request
  params[0] = block5738;
  partcv[0] = 1;
  Object call5743 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5737);
// compiled call node returning call5743 (depth = 8)
  partcv[0] = 0;
  Object call5744 = callmethod(call5743, "not",
    1, partcv, params);
  gc_frame_end(callframe5736);
// compiled call node returning call5744 (depth = 7)
// compiled member node returning call5744 (depth = 6)
  Object if5735 = done;
  if (istrue(call5744)) {
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5745 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5746 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5747 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5746);
// compiled call node returning call5747 (depth = 10)
// compiled member node returning call5747 (depth = 9)
  partcv[0] = 0;
  Object call5748 = callmethod(call5747, "empty",
    1, partcv, params);
  gc_frame_end(callframe5745);
// compiled call node returning call5748 (depth = 8)
// compiled member node returning call5748 (depth = 7)
  *var_suggestions = call5748;
  if (call5748 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5749 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5751 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5750);
// compiled call node returning call5751 (depth = 10)
// compiled member node returning call5751 (depth = 9)
  partcv[0] = 0;
  Object call5752 = callmethod(call5751, "new",
    1, partcv, params);
  gc_frame_end(callframe5749);
// compiled call node returning call5752 (depth = 8)
// compiled member node returning call5752 (depth = 7)
  *var_suggestion = call5752;
  if (call5752 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5753 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5754 == NULL) {
    strlit5754 = alloc_String("comma");
    gc_root(strlit5754);
  }
// compiled string node returning strlit5754 (depth = 8)
  gc_frame_newslot(strlit5754);
// starting to compile string node (depth = 8)
  if (strlit5755 == NULL) {
    strlit5755 = alloc_String("rparen");
    gc_root(strlit5755);
  }
// compiled string node returning strlit5755 (depth = 8)
  gc_frame_newslot(strlit5755);
// starting to compile string node (depth = 8)
  if (strlit5756 == NULL) {
    strlit5756 = alloc_String("rsquare");
    gc_root(strlit5756);
  }
// compiled string node returning strlit5756 (depth = 8)
  gc_frame_newslot(strlit5756);
// starting to compile string node (depth = 8)
  if (strlit5757 == NULL) {
    strlit5757 = alloc_String("rbrace");
    gc_root(strlit5757);
  }
// compiled string node returning strlit5757 (depth = 8)
  gc_frame_newslot(strlit5757);
// call case 4: self request
  params[0] = strlit5754;
  params[1] = strlit5755;
  params[2] = strlit5756;
  params[3] = strlit5757;
  partcv[0] = 4;
  Object call5758 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5753);
// compiled call node returning call5758 (depth = 7)
  *var_nextTok = call5758;
  if (call5758 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5760 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5760 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5762 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5762 (depth = 7)
  Object if5759 = done;
  if (istrue(opresult5762)) {
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5763 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5765 == NULL) {
    strlit5765 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5765);
  }
// compiled string node returning strlit5765 (depth = 9)
  int op_slot_right_5764 = gc_frame_newslot(strlit5765);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5767 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5769 == NULL) {
    strlit5769 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5769);
  }
// compiled string node returning strlit5769 (depth = 10)
  int op_slot_left_5767 = gc_frame_newslot(strlit5769);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5770 = callmethod(strlit5769, "++", 1, partcv, params);
// compiled op node returning opresult5770 (depth = 9)
  int op_slot_left_5764 = gc_frame_newslot(opresult5770);
  params[0] = strlit5765;
  partcv[0] = 1;
  Object opresult5771 = callmethod(opresult5770, "++", 1, partcv, params);
// compiled op node returning opresult5771 (depth = 8)
  gc_frame_newslot(opresult5771);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5771;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5772 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5763);
// compiled call node returning call5772 (depth = 7)
    gc_frame_newslot(call5772);
    if5759 = call5772;
  } else {
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5773 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5774 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5775 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5774);
// compiled call node returning call5775 (depth = 9)
// compiled member node returning call5775 (depth = 8)
  gc_frame_newslot(call5775);
// starting to compile identifier node (depth = 8)
  Object bool5776 = alloc_Boolean(1);
// compiled identifier node returning bool5776 (depth = 8)
  gc_frame_newslot(bool5776);
// starting to compile identifier node (depth = 8)
  Object bool5777 = alloc_Boolean(0);
// compiled identifier node returning bool5777 (depth = 8)
  gc_frame_newslot(bool5777);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5779 == NULL) {
    strlit5779 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5779);
  }
// compiled string node returning strlit5779 (depth = 9)
  int op_slot_right_5778 = gc_frame_newslot(strlit5779);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5781 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5783 == NULL) {
    strlit5783 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5783);
  }
// compiled string node returning strlit5783 (depth = 10)
  int op_slot_left_5781 = gc_frame_newslot(strlit5783);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5784 = callmethod(strlit5783, "++", 1, partcv, params);
// compiled op node returning opresult5784 (depth = 9)
  int op_slot_left_5778 = gc_frame_newslot(opresult5784);
  params[0] = strlit5779;
  partcv[0] = 1;
  Object opresult5785 = callmethod(opresult5784, "++", 1, partcv, params);
// compiled op node returning opresult5785 (depth = 8)
  gc_frame_newslot(opresult5785);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5775;
  params[2] = bool5776;
  params[3] = bool5777;
  params[4] = opresult5785;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5786 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5773);
// compiled call node returning call5786 (depth = 7)
    gc_frame_newslot(call5786);
    if5759 = call5786;
  }
// compiled if node returning if5759 (depth = 6)
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5787 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5788 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5787);
// compiled call node returning call5788 (depth = 6)
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5789 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5790 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5791 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5790);
// compiled call node returning call5791 (depth = 10)
// compiled member node returning call5791 (depth = 9)
  partcv[0] = 0;
  Object call5792 = callmethod(call5791, "new",
    1, partcv, params);
  gc_frame_end(callframe5789);
// compiled call node returning call5792 (depth = 8)
// compiled member node returning call5792 (depth = 7)
  *var_suggestion = call5792;
  if (call5792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5794 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call5796 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5795);
// compiled call node returning call5796 (depth = 8)
// compiled member node returning call5796 (depth = 7)
  gc_frame_newslot(call5796);
// starting to compile identifier node (depth = 7)
  Object bool5797 = alloc_Boolean(1);
// compiled identifier node returning bool5797 (depth = 7)
  gc_frame_newslot(bool5797);
// starting to compile identifier node (depth = 7)
  Object bool5798 = alloc_Boolean(0);
// compiled identifier node returning bool5798 (depth = 7)
  gc_frame_newslot(bool5798);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5796;
  params[2] = bool5797;
  params[3] = bool5798;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5799 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5794);
// compiled call node returning call5799 (depth = 6)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5800 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5801 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5800);
// compiled call node returning call5801 (depth = 6)
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5802 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5804 == NULL) {
    strlit5804 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5804);
  }
// compiled string node returning strlit5804 (depth = 8)
  int op_slot_right_5803 = gc_frame_newslot(strlit5804);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5808 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5807);
// compiled call node returning call5808 (depth = 10)
// compiled member node returning call5808 (depth = 9)
  int op_slot_right_5806 = gc_frame_newslot(call5808);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5811 == NULL) {
    strlit5811 = alloc_String(" must follow '");
    gc_root(strlit5811);
  }
// compiled string node returning strlit5811 (depth = 10)
  int op_slot_right_5810 = gc_frame_newslot(strlit5811);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_name (depth = 11)
  int op_slot_right_5813 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 11)
  if (strlit5815 == NULL) {
    strlit5815 = alloc_String("A valid ");
    gc_root(strlit5815);
  }
// compiled string node returning strlit5815 (depth = 11)
  int op_slot_left_5813 = gc_frame_newslot(strlit5815);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5816 = callmethod(strlit5815, "++", 1, partcv, params);
// compiled op node returning opresult5816 (depth = 10)
  int op_slot_left_5810 = gc_frame_newslot(opresult5816);
  params[0] = strlit5811;
  partcv[0] = 1;
  Object opresult5817 = callmethod(opresult5816, "++", 1, partcv, params);
// compiled op node returning opresult5817 (depth = 9)
  int op_slot_left_5806 = gc_frame_newslot(opresult5817);
  params[0] = call5808;
  partcv[0] = 1;
  Object opresult5818 = callmethod(opresult5817, "++", 1, partcv, params);
// compiled op node returning opresult5818 (depth = 8)
  int op_slot_left_5803 = gc_frame_newslot(opresult5818);
  params[0] = strlit5804;
  partcv[0] = 1;
  Object opresult5819 = callmethod(opresult5818, "++", 1, partcv, params);
// compiled op node returning opresult5819 (depth = 7)
  gc_frame_newslot(opresult5819);
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5821 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5820);
// compiled call node returning call5821 (depth = 8)
// compiled member node returning call5821 (depth = 7)
  gc_frame_newslot(call5821);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5824 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5823);
// compiled call node returning call5824 (depth = 9)
// compiled member node returning call5824 (depth = 8)
  int op_slot_right_5822 = gc_frame_newslot(call5824);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5827 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5826);
// compiled call node returning call5827 (depth = 9)
// compiled member node returning call5827 (depth = 8)
  int op_slot_left_5822 = gc_frame_newslot(call5827);
  params[0] = call5824;
  partcv[0] = 1;
  Object sum5828 = callmethod(call5827, "+", 1, partcv, params);
// compiled op node returning sum5828 (depth = 7)
  gc_frame_newslot(sum5828);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5819;
  params[1] = call5821;
  params[2] = sum5828;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5829 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5802);
// compiled call node returning call5829 (depth = 6)
    gc_frame_newslot(call5829);
    if5735 = call5829;
  } else {
  }
// compiled if node returning if5735 (depth = 5)
    gc_frame_newslot(if5735);
    if5566 = if5735;
  }
// compiled if node returning if5566 (depth = 4)
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5830 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5831 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5830);
// compiled call node returning call5831 (depth = 4)
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5832 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5833 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5832);
// compiled call node returning call5833 (depth = 4)
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5834 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5835 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5834);
// compiled call node returning call5835 (depth = 5)
// compiled member node returning call5835 (depth = 4)
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5836 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call5837 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5836);
// compiled call node returning call5837 (depth = 6)
// compiled member node returning call5837 (depth = 5)
  *var_tmp = call5837;
  if (call5837 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5839 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5840 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5839);
// compiled call node returning call5840 (depth = 4)
  gc_frame_end(frame);
  return call5840;
}
Object meth_parser__apply5845(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5847 = alloc_Float64(0);
// compiled num node returning num5847 (depth = 5)
  int op_slot_right_5846 = gc_frame_newslot(num5847);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5849 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5850 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5849);
// compiled call node returning call5850 (depth = 6)
// compiled member node returning call5850 (depth = 5)
  int op_slot_left_5846 = gc_frame_newslot(call5850);
  params[0] = num5847;
  partcv[0] = 1;
  Object opresult5851 = callmethod(call5850, ">", 1, partcv, params);
// compiled op node returning opresult5851 (depth = 4)
  gc_frame_end(frame);
  return opresult5851;
}
Object meth_parser__apply5854(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5855 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5856 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5855);
// compiled call node returning call5856 (depth = 6)
// compiled member node returning call5856 (depth = 5)
  *var_o = call5856;
  if (call5856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5858 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5859 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5858);
// compiled call node returning call5859 (depth = 6)
// compiled member node returning call5859 (depth = 5)
  *var_tmp2 = call5859;
  if (call5859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5862 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5861);
// compiled call node returning call5862 (depth = 6)
// compiled member node returning call5862 (depth = 5)
  *var_tmp = call5862;
  if (call5862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5864 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  partcv[0] = 0;
  Object call5866 = callmethod(*var_tmp, "line",
    1, partcv, params);
  gc_frame_end(callframe5865);
// compiled call node returning call5866 (depth = 6)
// compiled member node returning call5866 (depth = 5)
  gc_frame_newslot(call5866);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5867 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  partcv[0] = 0;
  Object call5868 = callmethod(*var_tmp, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5867);
// compiled call node returning call5868 (depth = 6)
// compiled member node returning call5868 (depth = 5)
  gc_frame_newslot(call5868);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5866;
  params[1] = call5868;
  partcv[0] = 2;
  Object call5869 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5864);
// compiled call node returning call5869 (depth = 4)
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5870 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp2 (depth = 6)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5872 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5871);
// compiled call node returning call5872 (depth = 7)
// compiled member node returning call5872 (depth = 6)
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5873 = callmethod(call5872, "new",
    1, partcv, params);
  gc_frame_end(callframe5870);
// compiled call node returning call5873 (depth = 5)
  *var_tmp = call5873;
  if (call5873 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5875 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5876 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5875);
// compiled call node returning call5876 (depth = 4)
  gc_frame_end(frame);
  return call5876;
}
Object meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest()recursingWith()blocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method expressionrest()recursingWith()blocks");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for expressionrest()recursingWith()blocks (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for expressionrest");
  Object *var_recurse = &(stackframe->slots[1]);
  *var_recurse = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for recursingWith");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for blocks");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_terms = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "terms");
  Object *var_ops = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ops");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_o2 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o2");
  Object *var_tmp2 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tmp2");
  Object *var_tmp = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tmp");
  Object *var_prec = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "prec");
  Object *var_allarith = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "allarith");
  Object *var_opcount = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "opcount");
  Object *var_opdtype = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "opdtype");
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5383 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5383 (depth = 3)
  *var_terms = array5383;
  if (array5383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5384 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5384 (depth = 3)
  *var_ops = array5384;
  if (array5384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_tmp2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5386 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5385);
// compiled call node returning call5386 (depth = 4)
// compiled member node returning call5386 (depth = 3)
  *var_tmp = call5386;
  if (call5386 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5387 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_terms (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5388 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5387);
// compiled call node returning call5388 (depth = 2)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_prec = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5389 = alloc_Boolean(1);
// compiled identifier node returning bool5389 (depth = 3)
  *var_allarith = bool5389;
  if (bool5389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num5390 = alloc_Float64(0);
// compiled num node returning num5390 (depth = 3)
  *var_opcount = num5390;
  if (num5390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5391 == NULL) {
    strlit5391 = alloc_String("");
    gc_root(strlit5391);
  }
// compiled string node returning strlit5391 (depth = 3)
  *var_opdtype = strlit5391;
  if (strlit5391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5392 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5393 = alloc_Block(NULL, NULL, "parser", 1719);
  gc_frame_newslot(block5393);
// method _apply
  block_savedest(block5393);
  Object closure5394 = createclosure(3, "_apply");
  setclosureframe(closure5394, stackframe);
  addtoclosure(closure5394, var_sym);
  addtoclosure(closure5394, var_statementToken);
  addtoclosure(closure5394, selfslot);
  struct UserObject *uo5394 = (struct UserObject*)block5393;
  uo5394->data[0] = (Object)closure5394;
  Method *meth_meth_parser__apply5394 = addmethod2pos(block5393, "_apply", &meth_parser__apply5394, 0);
  int argcv_meth_parser__apply5394[] = {0};
  meth_meth_parser__apply5394->type = alloc_MethodType(1, argcv_meth_parser__apply5394);
  meth_meth_parser__apply5394->definitionModule = modulename;
  meth_meth_parser__apply5394->definitionLine = 1713;
// compiled block node returning block5393 (depth = 3)
  gc_frame_newslot(block5393);
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5410 = alloc_Block(NULL, NULL, "parser", 1720);
  gc_frame_newslot(block5410);
// method _apply
  block_savedest(block5410);
  Object closure5411 = createclosure(20, "_apply");
  setclosureframe(closure5411, stackframe);
  addtoclosure(closure5411, var_opcount);
  addtoclosure(closure5411, var_sym);
  addtoclosure(closure5411, var_o);
  addtoclosure(closure5411, var_prec);
  addtoclosure(closure5411, var_allarith);
  addtoclosure(closure5411, var_opdtype);
  addtoclosure(closure5411, var_errormessages);
  addtoclosure(closure5411, var_lastToken);
  addtoclosure(closure5411, var_ops);
  addtoclosure(closure5411, var_o2);
  addtoclosure(closure5411, var_terms);
  addtoclosure(closure5411, var_tmp2);
  addtoclosure(closure5411, var_tmp);
  addtoclosure(closure5411, var_util);
  addtoclosure(closure5411, var_ast);
  addtoclosure(closure5411, var_recurse);
  addtoclosure(closure5411, var_name);
  addtoclosure(closure5411, var_acceptBlocks);
  addtoclosure(closure5411, var_values);
  addtoclosure(closure5411, selfslot);
  struct UserObject *uo5411 = (struct UserObject*)block5410;
  uo5411->data[0] = (Object)closure5411;
  Method *meth_meth_parser__apply5411 = addmethod2pos(block5410, "_apply", &meth_parser__apply5411, 0);
  int argcv_meth_parser__apply5411[] = {0};
  meth_meth_parser__apply5411->type = alloc_MethodType(1, argcv_meth_parser__apply5411);
  meth_meth_parser__apply5411->definitionModule = modulename;
  meth_meth_parser__apply5411->definitionLine = 1720;
// compiled block node returning block5410 (depth = 3)
  gc_frame_newslot(block5410);
// call case 5: prelude request
  params[0] = block5393;
  params[1] = block5410;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5842 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5392);
// compiled call node returning call5842 (depth = 2)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5843 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5844 = alloc_Block(NULL, NULL, "parser", 1830);
  gc_frame_newslot(block5844);
// method _apply
  block_savedest(block5844);
  Object closure5845 = createclosure(2, "_apply");
  setclosureframe(closure5845, stackframe);
  addtoclosure(closure5845, var_ops);
  addtoclosure(closure5845, selfslot);
  struct UserObject *uo5845 = (struct UserObject*)block5844;
  uo5845->data[0] = (Object)closure5845;
  Method *meth_meth_parser__apply5845 = addmethod2pos(block5844, "_apply", &meth_parser__apply5845, 0);
  int argcv_meth_parser__apply5845[] = {0};
  meth_meth_parser__apply5845->type = alloc_MethodType(1, argcv_meth_parser__apply5845);
  meth_meth_parser__apply5845->definitionModule = modulename;
  meth_meth_parser__apply5845->definitionLine = 1827;
// compiled block node returning block5844 (depth = 3)
  gc_frame_newslot(block5844);
// starting to compile block node (depth = 3)
  Object block5853 = alloc_Block(NULL, NULL, "parser", 1830);
  gc_frame_newslot(block5853);
// method _apply
  block_savedest(block5853);
  Object closure5854 = createclosure(8, "_apply");
  setclosureframe(closure5854, stackframe);
  addtoclosure(closure5854, var_ops);
  addtoclosure(closure5854, var_o);
  addtoclosure(closure5854, var_terms);
  addtoclosure(closure5854, var_tmp2);
  addtoclosure(closure5854, var_tmp);
  addtoclosure(closure5854, var_util);
  addtoclosure(closure5854, var_ast);
  addtoclosure(closure5854, selfslot);
  struct UserObject *uo5854 = (struct UserObject*)block5853;
  uo5854->data[0] = (Object)closure5854;
  Method *meth_meth_parser__apply5854 = addmethod2pos(block5853, "_apply", &meth_parser__apply5854, 0);
  int argcv_meth_parser__apply5854[] = {0};
  meth_meth_parser__apply5854->type = alloc_MethodType(1, argcv_meth_parser__apply5854);
  meth_meth_parser__apply5854->definitionModule = modulename;
  meth_meth_parser__apply5854->definitionLine = 1830;
// compiled block node returning block5853 (depth = 3)
  gc_frame_newslot(block5853);
// call case 5: prelude request
  params[0] = block5844;
  params[1] = block5853;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5878 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5843);
// compiled call node returning call5878 (depth = 2)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  partcv[0] = 0;
  Object call5880 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5879);
// compiled call node returning call5880 (depth = 4)
// compiled member node returning call5880 (depth = 3)
  *var_tmp = call5880;
  if (call5880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5882 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5883 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5882);
// compiled call node returning call5883 (depth = 2)
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5886 = alloc_Float64(0);
// compiled num node returning num5886 (depth = 4)
  int op_slot_right_5885 = gc_frame_newslot(num5886);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  partcv[0] = 0;
  Object call5889 = callmethod(*var_terms, "size",
    1, partcv, params);
  gc_frame_end(callframe5888);
// compiled call node returning call5889 (depth = 5)
// compiled member node returning call5889 (depth = 4)
  int op_slot_left_5885 = gc_frame_newslot(call5889);
  params[0] = num5886;
  partcv[0] = 1;
  Object opresult5890 = callmethod(call5889, ">", 1, partcv, params);
// compiled op node returning opresult5890 (depth = 3)
  Object if5884 = done;
  if (istrue(opresult5890)) {
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5891 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5892 == NULL) {
    strlit5892 = alloc_String("Values left on term stack.");
    gc_root(strlit5892);
  }
// compiled string node returning strlit5892 (depth = 4)
  gc_frame_newslot(strlit5892);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5893 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5894 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5893);
// compiled call node returning call5894 (depth = 5)
// compiled member node returning call5894 (depth = 4)
  gc_frame_newslot(call5894);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5895 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5896 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5895);
// compiled call node returning call5896 (depth = 5)
// compiled member node returning call5896 (depth = 4)
  gc_frame_newslot(call5896);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5892;
  params[1] = call5894;
  params[2] = call5896;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call5897 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe5891);
// compiled call node returning call5897 (depth = 3)
    gc_frame_newslot(call5897);
    if5884 = call5897;
  } else {
  }
// compiled if node returning if5884 (depth = 2)
  gc_frame_end(frame);
  return if5884;
}
Object meth_parser_dotrest5898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method dotrest");
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for dotrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lookuptarget = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lookuptarget");
  Object *var_dro = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dro");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5900 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5901 == NULL) {
    strlit5901 = alloc_String("dot");
    gc_root(strlit5901);
  }
// compiled string node returning strlit5901 (depth = 4)
  gc_frame_newslot(strlit5901);
// call case 4: self request
  params[0] = strlit5901;
  partcv[0] = 1;
  Object call5902 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5900);
// compiled call node returning call5902 (depth = 3)
  Object if5899 = done;
  if (istrue(call5902)) {
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5903 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5904 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5905 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5904);
// compiled call node returning call5905 (depth = 5)
// compiled member node returning call5905 (depth = 4)
  gc_frame_newslot(call5905);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5906 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5907 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5906);
// compiled call node returning call5907 (depth = 5)
// compiled member node returning call5907 (depth = 4)
  gc_frame_newslot(call5907);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5905;
  params[1] = call5907;
  partcv[0] = 2;
  Object call5908 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5903);
// compiled call node returning call5908 (depth = 3)
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5910 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5909);
// compiled call node returning call5910 (depth = 5)
// compiled member node returning call5910 (depth = 4)
  *var_lookuptarget = call5910;
  if (call5910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5911 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5912 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5911);
// compiled call node returning call5912 (depth = 4)
// compiled member node returning call5912 (depth = 3)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5914 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5915 == NULL) {
    strlit5915 = alloc_String("identifier");
    gc_root(strlit5915);
  }
// compiled string node returning strlit5915 (depth = 5)
  gc_frame_newslot(strlit5915);
// call case 4: self request
  params[0] = strlit5915;
  partcv[0] = 1;
  Object call5916 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5914);
// compiled call node returning call5916 (depth = 4)
  Object if5913 = done;
  if (istrue(call5916)) {
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5917 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5919 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5918);
// compiled call node returning call5919 (depth = 6)
// compiled member node returning call5919 (depth = 5)
  gc_frame_newslot(call5919);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5920 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5921 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5920);
// compiled call node returning call5921 (depth = 6)
// compiled member node returning call5921 (depth = 5)
  gc_frame_newslot(call5921);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5919;
  params[1] = call5921;
  partcv[0] = 2;
  Object call5922 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5917);
// compiled call node returning call5922 (depth = 4)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5923 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call5925 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5924);
// compiled call node returning call5925 (depth = 7)
// compiled member node returning call5925 (depth = 6)
  gc_frame_newslot(call5925);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lookuptarget (depth = 6)
  gc_frame_newslot(*var_lookuptarget);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5926 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5927 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe5926);
// compiled call node returning call5927 (depth = 7)
// compiled member node returning call5927 (depth = 6)
  params[0] = call5925;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call5928 = callmethod(call5927, "new",
    1, partcv, params);
  gc_frame_end(callframe5923);
// compiled call node returning call5928 (depth = 5)
  *var_dro = call5928;
  if (call5928 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5929 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dro (depth = 5)
  gc_frame_newslot(*var_dro);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call5930 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5929);
// compiled call node returning call5930 (depth = 4)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5931 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5932 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5931);
// compiled call node returning call5932 (depth = 5)
// compiled member node returning call5932 (depth = 4)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5934 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5935 == NULL) {
    strlit5935 = alloc_String("dot");
    gc_root(strlit5935);
  }
// compiled string node returning strlit5935 (depth = 6)
  gc_frame_newslot(strlit5935);
// call case 4: self request
  params[0] = strlit5935;
  partcv[0] = 1;
  Object call5936 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5934);
// compiled call node returning call5936 (depth = 5)
  Object if5933 = done;
  if (istrue(call5936)) {
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5937 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5938 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5937);
// compiled call node returning call5938 (depth = 5)
    gc_frame_newslot(call5938);
    if5933 = call5938;
  } else {
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5941 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5942 == NULL) {
    strlit5942 = alloc_String("lgeneric");
    gc_root(strlit5942);
  }
// compiled string node returning strlit5942 (depth = 8)
  gc_frame_newslot(strlit5942);
// call case 4: self request
  params[0] = strlit5942;
  partcv[0] = 1;
  Object call5943 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5941);
// compiled call node returning call5943 (depth = 7)
  int op_slot_right_5940 = gc_frame_newslot(call5943);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5946 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5947 == NULL) {
    strlit5947 = alloc_String("lsquare");
    gc_root(strlit5947);
  }
// compiled string node returning strlit5947 (depth = 9)
  gc_frame_newslot(strlit5947);
// call case 4: self request
  params[0] = strlit5947;
  partcv[0] = 1;
  Object call5948 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5946);
// compiled call node returning call5948 (depth = 8)
  int op_slot_right_5945 = gc_frame_newslot(call5948);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5951 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5952 == NULL) {
    strlit5952 = alloc_String("string");
    gc_root(strlit5952);
  }
// compiled string node returning strlit5952 (depth = 10)
  gc_frame_newslot(strlit5952);
// call case 4: self request
  params[0] = strlit5952;
  partcv[0] = 1;
  Object call5953 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5951);
// compiled call node returning call5953 (depth = 9)
  int op_slot_right_5950 = gc_frame_newslot(call5953);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe5956 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit5957 == NULL) {
    strlit5957 = alloc_String("num");
    gc_root(strlit5957);
  }
// compiled string node returning strlit5957 (depth = 11)
  gc_frame_newslot(strlit5957);
// call case 4: self request
  params[0] = strlit5957;
  partcv[0] = 1;
  Object call5958 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5956);
// compiled call node returning call5958 (depth = 10)
  int op_slot_right_5955 = gc_frame_newslot(call5958);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5962 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5963 == NULL) {
    strlit5963 = alloc_String("lbrace");
    gc_root(strlit5963);
  }
// compiled string node returning strlit5963 (depth = 13)
  gc_frame_newslot(strlit5963);
// call case 4: self request
  params[0] = strlit5963;
  partcv[0] = 1;
  Object call5964 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5962);
// compiled call node returning call5964 (depth = 12)
  int op_slot_right_5961 = gc_frame_newslot(call5964);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_acceptBlocks (depth = 12)
  int op_slot_left_5961 = gc_frame_newslot(*var_acceptBlocks);
  params[0] = call5964;
  partcv[0] = 1;
  Object opresult5966 = callmethod(*var_acceptBlocks, "&&", 1, partcv, params);
// compiled op node returning opresult5966 (depth = 11)
  int op_slot_right_5960 = gc_frame_newslot(opresult5966);
// starting to compile call node (depth = 11)
  int callframe5968 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit5969 == NULL) {
    strlit5969 = alloc_String("lparen");
    gc_root(strlit5969);
  }
// compiled string node returning strlit5969 (depth = 12)
  gc_frame_newslot(strlit5969);
// call case 4: self request
  params[0] = strlit5969;
  partcv[0] = 1;
  Object call5970 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5968);
// compiled call node returning call5970 (depth = 11)
  int op_slot_left_5960 = gc_frame_newslot(call5970);
  params[0] = opresult5966;
  partcv[0] = 1;
  Object opresult5971 = callmethod(call5970, "||", 1, partcv, params);
// compiled op node returning opresult5971 (depth = 10)
  int op_slot_left_5955 = gc_frame_newslot(opresult5971);
  params[0] = call5958;
  partcv[0] = 1;
  Object opresult5972 = callmethod(opresult5971, "||", 1, partcv, params);
// compiled op node returning opresult5972 (depth = 9)
  int op_slot_left_5950 = gc_frame_newslot(opresult5972);
  params[0] = call5953;
  partcv[0] = 1;
  Object opresult5973 = callmethod(opresult5972, "||", 1, partcv, params);
// compiled op node returning opresult5973 (depth = 8)
  int op_slot_left_5945 = gc_frame_newslot(opresult5973);
  params[0] = call5948;
  partcv[0] = 1;
  Object opresult5974 = callmethod(opresult5973, "||", 1, partcv, params);
// compiled op node returning opresult5974 (depth = 7)
  int op_slot_left_5940 = gc_frame_newslot(opresult5974);
  params[0] = call5943;
  partcv[0] = 1;
  Object opresult5975 = callmethod(opresult5974, "||", 1, partcv, params);
// compiled op node returning opresult5975 (depth = 6)
  Object if5939 = done;
  if (istrue(opresult5975)) {
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5976 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5977 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5976);
// compiled call node returning call5977 (depth = 6)
    gc_frame_newslot(call5977);
    if5939 = call5977;
  } else {
  }
// compiled if node returning if5939 (depth = 5)
    gc_frame_newslot(if5939);
    if5933 = if5939;
  }
// compiled if node returning if5933 (depth = 4)
    gc_frame_newslot(if5933);
    if5913 = if5933;
  } else {
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5978 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5979 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5980 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5979);
// compiled call node returning call5980 (depth = 8)
// compiled member node returning call5980 (depth = 7)
  partcv[0] = 0;
  Object call5981 = callmethod(call5980, "empty",
    1, partcv, params);
  gc_frame_end(callframe5978);
// compiled call node returning call5981 (depth = 6)
// compiled member node returning call5981 (depth = 5)
  *var_suggestions = call5981;
  if (call5981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5982 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5984 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5983);
// compiled call node returning call5984 (depth = 8)
// compiled member node returning call5984 (depth = 7)
  partcv[0] = 0;
  Object call5985 = callmethod(call5984, "new",
    1, partcv, params);
  gc_frame_end(callframe5982);
// compiled call node returning call5985 (depth = 6)
// compiled member node returning call5985 (depth = 5)
  *var_suggestion = call5985;
  if (call5985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5986 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call5987 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe5986);
// compiled call node returning call5987 (depth = 4)
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5988 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5989 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5988);
// compiled call node returning call5989 (depth = 4)
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5990 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5991 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5992 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5991);
// compiled call node returning call5992 (depth = 8)
// compiled member node returning call5992 (depth = 7)
  partcv[0] = 0;
  Object call5993 = callmethod(call5992, "new",
    1, partcv, params);
  gc_frame_end(callframe5990);
// compiled call node returning call5993 (depth = 6)
// compiled member node returning call5993 (depth = 5)
  *var_suggestion = call5993;
  if (call5993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5995 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5996 == NULL) {
    strlit5996 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5996);
  }
// compiled string node returning strlit5996 (depth = 5)
  gc_frame_newslot(strlit5996);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5996;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5997 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5995);
// compiled call node returning call5997 (depth = 4)
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5998 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5999 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5998);
// compiled call node returning call5999 (depth = 4)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6000 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6001 == NULL) {
    strlit6001 = alloc_String("A field or method name must follow a '.'.");
    gc_root(strlit6001);
  }
// compiled string node returning strlit6001 (depth = 5)
  gc_frame_newslot(strlit6001);
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6003 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6002);
// compiled call node returning call6003 (depth = 6)
// compiled member node returning call6003 (depth = 5)
  gc_frame_newslot(call6003);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6005 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6004);
// compiled call node returning call6005 (depth = 6)
// compiled member node returning call6005 (depth = 5)
  gc_frame_newslot(call6005);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6001;
  params[1] = call6003;
  params[2] = call6005;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6006 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6000);
// compiled call node returning call6006 (depth = 4)
    gc_frame_newslot(call6006);
    if5913 = call6006;
  }
// compiled if node returning if5913 (depth = 3)
    gc_frame_newslot(if5913);
    if5899 = if5913;
  } else {
  }
// compiled if node returning if5899 (depth = 2)
  gc_frame_end(frame);
  return if5899;
}
Object meth_parser__apply6085(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe6086 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6087 == NULL) {
    strlit6087 = alloc_String("lbrace");
    gc_root(strlit6087);
  }
// compiled string node returning strlit6087 (depth = 7)
  gc_frame_newslot(strlit6087);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6087;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6088 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6086);
// compiled call node returning call6088 (depth = 6)
  gc_frame_end(frame);
  return call6088;
}
Object meth_parser__apply6169(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6171 == NULL) {
    strlit6171 = alloc_String("member");
    gc_root(strlit6171);
  }
// compiled string node returning strlit6171 (depth = 10)
  int op_slot_right_6170 = gc_frame_newslot(strlit6171);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call6174 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe6173);
// compiled call node returning call6174 (depth = 11)
// compiled member node returning call6174 (depth = 10)
  int op_slot_left_6170 = gc_frame_newslot(call6174);
  params[0] = strlit6171;
  partcv[0] = 1;
  Object opresult6175 = callmethod(call6174, "==", 1, partcv, params);
// compiled op node returning opresult6175 (depth = 9)
  gc_frame_end(frame);
  return opresult6175;
}
Object meth_parser__apply6178(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object *var_outroot = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 9)
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_root (depth = 10)
  *var_outroot = *var_root;
  if (*var_root == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call6181 = callmethod(*var_root, "in",
    1, partcv, params);
  gc_frame_end(callframe6180);
// compiled call node returning call6181 (depth = 11)
// compiled member node returning call6181 (depth = 10)
  *var_root = call6181;
  if (call6181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_callrest6007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method callrest");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for callrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
  Object *var_lnum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lnum");
  Object *var_lpos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lpos");
  Object *var_methn = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "methn");
  Object *var_btok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "btok");
  Object *var_signature = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "signature");
  Object *var_part = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "part");
  Object *var_hadcall = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "hadcall");
  Object *var_tok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tok");
  Object *var_startInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "startInd");
  Object *var_genericIdents = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "genericIdents");
  Object *var_ar = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "ar");
  Object *var_root = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "root");
  Object *var_outroot = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "outroot");
  Object *var_meth_39_ = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "meth'");
  Object *var_call = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "call");
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num6010 = alloc_Float64(0);
// compiled num node returning num6010 (depth = 4)
  int op_slot_right_6009 = gc_frame_newslot(num6010);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call6013 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe6012);
// compiled call node returning call6013 (depth = 5)
// compiled member node returning call6013 (depth = 4)
  int op_slot_left_6009 = gc_frame_newslot(call6013);
  params[0] = num6010;
  partcv[0] = 1;
  Object opresult6014 = callmethod(call6013, "==", 1, partcv, params);
// compiled op node returning opresult6014 (depth = 3)
  Object if6008 = done;
  if (istrue(opresult6014)) {
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num6015 = alloc_Float64(0);
// compiled num node returning num6015 (depth = 4)
  return num6015;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6008 = undefined;
  } else {
  }
// compiled if node returning if6008 (depth = 2)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call6017 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6016);
// compiled call node returning call6017 (depth = 4)
// compiled member node returning call6017 (depth = 3)
  *var_meth = call6017;
  if (call6017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6020 == NULL) {
    strlit6020 = alloc_String("identifier");
    gc_root(strlit6020);
  }
// compiled string node returning strlit6020 (depth = 4)
  int op_slot_right_6019 = gc_frame_newslot(strlit6020);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6022 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call6023 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6022);
// compiled call node returning call6023 (depth = 5)
// compiled member node returning call6023 (depth = 4)
  int op_slot_left_6019 = gc_frame_newslot(call6023);
  params[0] = strlit6020;
  partcv[0] = 1;
  Object opresult6024 = callmethod(call6023, "!=", 1, partcv, params);
// compiled op node returning opresult6024 (depth = 3)
  Object if6018 = done;
  if (istrue(opresult6024)) {
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6027 == NULL) {
    strlit6027 = alloc_String("member");
    gc_root(strlit6027);
  }
// compiled string node returning strlit6027 (depth = 5)
  int op_slot_right_6026 = gc_frame_newslot(strlit6027);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6029 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call6030 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6029);
// compiled call node returning call6030 (depth = 6)
// compiled member node returning call6030 (depth = 5)
  int op_slot_left_6026 = gc_frame_newslot(call6030);
  params[0] = strlit6027;
  partcv[0] = 1;
  Object opresult6031 = callmethod(call6030, "!=", 1, partcv, params);
// compiled op node returning opresult6031 (depth = 4)
  Object if6025 = done;
  if (istrue(opresult6031)) {
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6032 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6033 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6032);
// compiled call node returning call6033 (depth = 4)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6034 = alloc_Float64(0);
// compiled num node returning num6034 (depth = 5)
  return num6034;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6025 = undefined;
  } else {
  }
// compiled if node returning if6025 (depth = 3)
    gc_frame_newslot(if6025);
    if6018 = if6025;
  } else {
  }
// compiled if node returning if6018 (depth = 2)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6036 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe6035);
// compiled call node returning call6036 (depth = 4)
// compiled member node returning call6036 (depth = 3)
  *var_lnum = call6036;
  if (call6036 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6037 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6038 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6037);
// compiled call node returning call6038 (depth = 4)
// compiled member node returning call6038 (depth = 3)
  *var_lpos = call6038;
  if (call6038 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6040 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6039);
// compiled call node returning call6040 (depth = 4)
// compiled member node returning call6040 (depth = 3)
  *var_methn = call6040;
  if (call6040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6041 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call6043 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6042);
// compiled call node returning call6043 (depth = 4)
// compiled member node returning call6043 (depth = 3)
  gc_frame_newslot(call6043);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6044 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call6045 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6044);
// compiled call node returning call6045 (depth = 4)
// compiled member node returning call6045 (depth = 3)
  gc_frame_newslot(call6045);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call6043;
  params[1] = call6045;
  partcv[0] = 2;
  Object call6046 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe6041);
// compiled call node returning call6046 (depth = 2)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array6047 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6047 (depth = 3)
  *var_signature = array6047;
  if (array6047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6048 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6049 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call6050 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe6049);
// compiled call node returning call6050 (depth = 6)
// compiled member node returning call6050 (depth = 5)
  partcv[0] = 0;
  Object call6051 = callmethod(call6050, "new",
    1, partcv, params);
  gc_frame_end(callframe6048);
// compiled call node returning call6051 (depth = 4)
// compiled member node returning call6051 (depth = 3)
  *var_part = call6051;
  if (call6051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6052 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6053 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe6052);
// compiled call node returning call6053 (depth = 2)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6054 = alloc_Boolean(0);
// compiled identifier node returning bool6054 (depth = 3)
  *var_hadcall = bool6054;
  if (bool6054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startInd = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool6055 = alloc_Boolean(0);
// compiled identifier node returning bool6055 (depth = 3)
  *var_genericIdents = bool6055;
  if (bool6055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6057 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6058 == NULL) {
    strlit6058 = alloc_String("lgeneric");
    gc_root(strlit6058);
  }
// compiled string node returning strlit6058 (depth = 4)
  gc_frame_newslot(strlit6058);
// call case 4: self request
  params[0] = strlit6058;
  partcv[0] = 1;
  Object call6059 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6057);
// compiled call node returning call6059 (depth = 3)
  Object if6056 = done;
  if (istrue(call6059)) {
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6060 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6061 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6060);
// compiled call node returning call6061 (depth = 5)
// compiled member node returning call6061 (depth = 4)
  *var_genericIdents = call6061;
  if (call6061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6056 = done;
  } else {
  }
// compiled if node returning if6056 (depth = 2)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6064 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6065 == NULL) {
    strlit6065 = alloc_String("lparen");
    gc_root(strlit6065);
  }
// compiled string node returning strlit6065 (depth = 4)
  gc_frame_newslot(strlit6065);
// call case 4: self request
  params[0] = strlit6065;
  partcv[0] = 1;
  Object call6066 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6064);
// compiled call node returning call6066 (depth = 3)
  Object if6063 = done;
  if (istrue(call6066)) {
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6067 = gc_frame_new();
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6069 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6068);
// compiled call node returning call6069 (depth = 6)
// compiled member node returning call6069 (depth = 5)
  gc_frame_newslot(call6069);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call6069;
  partcv[0] = 1;
  Object call6070 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6067);
// compiled call node returning call6070 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6071 = gc_frame_new();
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6072 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6073 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6072);
// compiled call node returning call6073 (depth = 6)
// compiled member node returning call6073 (depth = 5)
  gc_frame_newslot(call6073);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call6073;
  partcv[0] = 1;
  Object call6074 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6071);
// compiled call node returning call6074 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6075 = gc_frame_new();
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methn (depth = 5)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call6076 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6075);
// compiled call node returning call6076 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6078 = alloc_Boolean(1);
// compiled identifier node returning bool6078 (depth = 4)
  *var_hadcall = bool6078;
  if (bool6078 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6080 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// call case 4: self request
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6081 = callmethodflags(self, "parenthesizedArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6080);
// compiled call node returning call6081 (depth = 3)
    gc_frame_newslot(call6081);
    if6063 = call6081;
  } else {
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block6084 = alloc_Block(NULL, NULL, "parser", 1917);
  gc_frame_newslot(block6084);
// method _apply
  block_savedest(block6084);
  Object closure6085 = createclosure(2, "_apply");
  setclosureframe(closure6085, stackframe);
  addtoclosure(closure6085, var_tok);
  addtoclosure(closure6085, selfslot);
  struct UserObject *uo6085 = (struct UserObject*)block6084;
  uo6085->data[0] = (Object)closure6085;
  Method *meth_meth_parser__apply6085 = addmethod2pos(block6084, "_apply", &meth_parser__apply6085, 0);
  int argcv_meth_parser__apply6085[] = {0};
  meth_meth_parser__apply6085->type = alloc_MethodType(1, argcv_meth_parser__apply6085);
  meth_meth_parser__apply6085->definitionModule = modulename;
  meth_meth_parser__apply6085->definitionLine = 1912;
// compiled block node returning block6084 (depth = 5)
  int op_slot_right_6083 = gc_frame_newslot(block6084);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  partcv[0] = 0;
  Object call6092 = callmethod(*var_acceptBlocks, "not",
    1, partcv, params);
  gc_frame_end(callframe6091);
// compiled call node returning call6092 (depth = 6)
// compiled member node returning call6092 (depth = 5)
  int op_slot_left_6083 = gc_frame_newslot(call6092);
  params[0] = block6084;
  partcv[0] = 1;
  Object opresult6093 = callmethod(call6092, "&&", 1, partcv, params);
// compiled op node returning opresult6093 (depth = 4)
  Object if6082 = done;
  if (istrue(opresult6093)) {
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6094 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6095 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6094);
// compiled call node returning call6095 (depth = 4)
    gc_frame_newslot(call6095);
    if6082 = call6095;
  } else {
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6101 == NULL) {
    strlit6101 = alloc_String("false");
    gc_root(strlit6101);
  }
// compiled string node returning strlit6101 (depth = 9)
  int op_slot_right_6100 = gc_frame_newslot(strlit6101);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6104 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6103);
// compiled call node returning call6104 (depth = 10)
// compiled member node returning call6104 (depth = 9)
  int op_slot_left_6100 = gc_frame_newslot(call6104);
  params[0] = strlit6101;
  partcv[0] = 1;
  Object opresult6105 = callmethod(call6104, "==", 1, partcv, params);
// compiled op node returning opresult6105 (depth = 8)
  int op_slot_right_6099 = gc_frame_newslot(opresult6105);
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6108 == NULL) {
    strlit6108 = alloc_String("true");
    gc_root(strlit6108);
  }
// compiled string node returning strlit6108 (depth = 9)
  int op_slot_right_6107 = gc_frame_newslot(strlit6108);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6111 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6110);
// compiled call node returning call6111 (depth = 10)
// compiled member node returning call6111 (depth = 9)
  int op_slot_left_6107 = gc_frame_newslot(call6111);
  params[0] = strlit6108;
  partcv[0] = 1;
  Object opresult6112 = callmethod(call6111, "==", 1, partcv, params);
// compiled op node returning opresult6112 (depth = 8)
  int op_slot_left_6099 = gc_frame_newslot(opresult6112);
  params[0] = opresult6105;
  partcv[0] = 1;
  Object opresult6113 = callmethod(opresult6112, "||", 1, partcv, params);
// compiled op node returning opresult6113 (depth = 7)
  int op_slot_right_6098 = gc_frame_newslot(opresult6113);
// starting to compile call node (depth = 7)
  int callframe6115 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6116 == NULL) {
    strlit6116 = alloc_String("identifier");
    gc_root(strlit6116);
  }
// compiled string node returning strlit6116 (depth = 8)
  gc_frame_newslot(strlit6116);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6116;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6117 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6115);
// compiled call node returning call6117 (depth = 7)
  int op_slot_left_6098 = gc_frame_newslot(call6117);
  params[0] = opresult6113;
  partcv[0] = 1;
  Object opresult6118 = callmethod(call6117, "&&", 1, partcv, params);
// compiled op node returning opresult6118 (depth = 6)
  int op_slot_right_6097 = gc_frame_newslot(opresult6118);
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6121 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6122 == NULL) {
    strlit6122 = alloc_String("lbrace");
    gc_root(strlit6122);
  }
// compiled string node returning strlit6122 (depth = 8)
  gc_frame_newslot(strlit6122);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6122;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6123 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6121);
// compiled call node returning call6123 (depth = 7)
  int op_slot_right_6120 = gc_frame_newslot(call6123);
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6126 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6127 == NULL) {
    strlit6127 = alloc_String("num");
    gc_root(strlit6127);
  }
// compiled string node returning strlit6127 (depth = 9)
  gc_frame_newslot(strlit6127);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6127;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6128 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6126);
// compiled call node returning call6128 (depth = 8)
  int op_slot_right_6125 = gc_frame_newslot(call6128);
// starting to compile call node (depth = 8)
  int callframe6130 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6131 == NULL) {
    strlit6131 = alloc_String("string");
    gc_root(strlit6131);
  }
// compiled string node returning strlit6131 (depth = 9)
  gc_frame_newslot(strlit6131);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6131;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6132 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6130);
// compiled call node returning call6132 (depth = 8)
  int op_slot_left_6125 = gc_frame_newslot(call6132);
  params[0] = call6128;
  partcv[0] = 1;
  Object opresult6133 = callmethod(call6132, "||", 1, partcv, params);
// compiled op node returning opresult6133 (depth = 7)
  int op_slot_left_6120 = gc_frame_newslot(opresult6133);
  params[0] = call6123;
  partcv[0] = 1;
  Object opresult6134 = callmethod(opresult6133, "||", 1, partcv, params);
// compiled op node returning opresult6134 (depth = 6)
  int op_slot_left_6097 = gc_frame_newslot(opresult6134);
  params[0] = opresult6118;
  partcv[0] = 1;
  Object opresult6135 = callmethod(opresult6134, "||", 1, partcv, params);
// compiled op node returning opresult6135 (depth = 5)
  Object if6096 = done;
  if (istrue(opresult6135)) {
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6137 = alloc_Boolean(1);
// compiled identifier node returning bool6137 (depth = 6)
  *var_hadcall = bool6137;
  if (bool6137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6139 = gc_frame_new();
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_methn (depth = 7)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call6140 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6139);
// compiled call node returning call6140 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6141 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6142 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6141);
// compiled call node returning call6142 (depth = 6)
// compiled member node returning call6142 (depth = 5)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6143 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6144 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6143);
// compiled call node returning call6144 (depth = 7)
// compiled member node returning call6144 (depth = 6)
  *var_ar = call6144;
  if (call6144 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6145 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ar (depth = 6)
  gc_frame_newslot(*var_ar);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call6147 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6146);
// compiled call node returning call6147 (depth = 7)
// compiled member node returning call6147 (depth = 6)
  params[0] = *var_ar;
  partcv[0] = 1;
  Object call6148 = callmethod(call6147, "push",
    1, partcv, params);
  gc_frame_end(callframe6145);
// compiled call node returning call6148 (depth = 5)
    gc_frame_newslot(call6148);
    if6096 = call6148;
  } else {
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6151 == NULL) {
    strlit6151 = alloc_String("identifier");
    gc_root(strlit6151);
  }
// compiled string node returning strlit6151 (depth = 7)
  int op_slot_right_6150 = gc_frame_newslot(strlit6151);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6153 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call6154 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6153);
// compiled call node returning call6154 (depth = 8)
// compiled member node returning call6154 (depth = 7)
  int op_slot_left_6150 = gc_frame_newslot(call6154);
  params[0] = strlit6151;
  partcv[0] = 1;
  Object opresult6155 = callmethod(call6154, "==", 1, partcv, params);
// compiled op node returning opresult6155 (depth = 6)
  Object if6149 = done;
  if (istrue(opresult6155)) {
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6156 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6157 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6156);
// compiled call node returning call6157 (depth = 6)
    gc_frame_newslot(call6157);
    if6149 = call6157;
  } else {
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6160 == NULL) {
    strlit6160 = alloc_String("member");
    gc_root(strlit6160);
  }
// compiled string node returning strlit6160 (depth = 8)
  int op_slot_right_6159 = gc_frame_newslot(strlit6160);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6162 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call6163 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6162);
// compiled call node returning call6163 (depth = 9)
// compiled member node returning call6163 (depth = 8)
  int op_slot_left_6159 = gc_frame_newslot(call6163);
  params[0] = strlit6160;
  partcv[0] = 1;
  Object opresult6164 = callmethod(call6163, "==", 1, partcv, params);
// compiled op node returning opresult6164 (depth = 7)
  Object if6158 = done;
  if (istrue(opresult6164)) {
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6165 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call6166 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe6165);
// compiled call node returning call6166 (depth = 9)
// compiled member node returning call6166 (depth = 8)
  *var_root = call6166;
  if (call6166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  *var_outroot = *var_meth;
  if (*var_meth == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6167 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6168 = alloc_Block(NULL, NULL, "parser", 1934);
  gc_frame_newslot(block6168);
// method _apply
  block_savedest(block6168);
  Object closure6169 = createclosure(2, "_apply");
  setclosureframe(closure6169, stackframe);
  addtoclosure(closure6169, var_root);
  addtoclosure(closure6169, selfslot);
  struct UserObject *uo6169 = (struct UserObject*)block6168;
  uo6169->data[0] = (Object)closure6169;
  Method *meth_meth_parser__apply6169 = addmethod2pos(block6168, "_apply", &meth_parser__apply6169, 0);
  int argcv_meth_parser__apply6169[] = {0};
  meth_meth_parser__apply6169->type = alloc_MethodType(1, argcv_meth_parser__apply6169);
  meth_meth_parser__apply6169->definitionModule = modulename;
  meth_meth_parser__apply6169->definitionLine = 1932;
// compiled block node returning block6168 (depth = 8)
  gc_frame_newslot(block6168);
// starting to compile block node (depth = 8)
  Object block6177 = alloc_Block(NULL, NULL, "parser", 1934);
  gc_frame_newslot(block6177);
// method _apply
  block_savedest(block6177);
  Object closure6178 = createclosure(3, "_apply");
  setclosureframe(closure6178, stackframe);
  addtoclosure(closure6178, var_root);
  addtoclosure(closure6178, var_outroot);
  addtoclosure(closure6178, selfslot);
  struct UserObject *uo6178 = (struct UserObject*)block6177;
  uo6178->data[0] = (Object)closure6178;
  Method *meth_meth_parser__apply6178 = addmethod2pos(block6177, "_apply", &meth_parser__apply6178, 0);
  int argcv_meth_parser__apply6178[] = {0};
  meth_meth_parser__apply6178->type = alloc_MethodType(1, argcv_meth_parser__apply6178);
  meth_meth_parser__apply6178->definitionModule = modulename;
  meth_meth_parser__apply6178->definitionLine = 1934;
// compiled block node returning block6177 (depth = 8)
  gc_frame_newslot(block6177);
// call case 5: prelude request
  params[0] = block6168;
  params[1] = block6177;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6184 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6167);
// compiled call node returning call6184 (depth = 7)
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6187 == NULL) {
    strlit6187 = alloc_String("identifier");
    gc_root(strlit6187);
  }
// compiled string node returning strlit6187 (depth = 9)
  int op_slot_right_6186 = gc_frame_newslot(strlit6187);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6189 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_root (depth = 11)
  partcv[0] = 0;
  Object call6190 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe6189);
// compiled call node returning call6190 (depth = 10)
// compiled member node returning call6190 (depth = 9)
  int op_slot_left_6186 = gc_frame_newslot(call6190);
  params[0] = strlit6187;
  partcv[0] = 1;
  Object opresult6191 = callmethod(call6190, "==", 1, partcv, params);
// compiled op node returning opresult6191 (depth = 8)
  Object if6185 = done;
  if (istrue(opresult6191)) {
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6192 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6193 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6192);
// compiled call node returning call6193 (depth = 8)
    gc_frame_newslot(call6193);
    if6185 = call6193;
  } else {
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6194 = gc_frame_new();
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_genericIdents (depth = 10)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call6195 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6194);
// compiled call node returning call6195 (depth = 9)
// compiled bind node returning done (depth = 8)
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6196 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6197 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6196);
// compiled call node returning call6197 (depth = 8)
    gc_frame_newslot(call6197);
    if6185 = call6197;
  }
// compiled if node returning if6185 (depth = 7)
    gc_frame_newslot(if6185);
    if6158 = if6185;
  } else {
  }
// compiled if node returning if6158 (depth = 6)
    gc_frame_newslot(if6158);
    if6149 = if6158;
  }
// compiled if node returning if6149 (depth = 5)
    gc_frame_newslot(if6149);
    if6096 = if6149;
  }
// compiled if node returning if6096 (depth = 4)
    gc_frame_newslot(if6096);
    if6082 = if6096;
  }
// compiled if node returning if6082 (depth = 3)
    gc_frame_newslot(if6082);
    if6063 = if6082;
  }
// compiled if node returning if6063 (depth = 2)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_hadcall (depth = 3)
  Object if6198 = done;
  if (istrue(*var_hadcall)) {
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6200 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6201 == NULL) {
    strlit6201 = alloc_String("identifier");
    gc_root(strlit6201);
  }
// compiled string node returning strlit6201 (depth = 5)
  gc_frame_newslot(strlit6201);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6201;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6202 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6200);
// compiled call node returning call6202 (depth = 4)
  Object if6199 = done;
  if (istrue(call6202)) {
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6203 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// starting to compile identifier node (depth = 6)
  Object bool6204 = alloc_Boolean(0);
// compiled identifier node returning bool6204 (depth = 6)
  gc_frame_newslot(bool6204);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call6206 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe6205);
// compiled call node returning call6206 (depth = 7)
// compiled member node returning call6206 (depth = 6)
  params[0] = *var_methn;
  params[1] = bool6204;
  partcv[0] = 2;
  Object call6207 = callmethod(call6206, "new",
    1, partcv, params);
  gc_frame_end(callframe6203);
// compiled call node returning call6207 (depth = 5)
  *var_meth_39_ = call6207;
  if (call6207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6208 = gc_frame_new();
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lnum (depth = 6)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call6209 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6208);
// compiled call node returning call6209 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6210 = gc_frame_new();
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lpos (depth = 6)
  gc_frame_newslot(*var_lpos);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  params[0] = *var_lpos;
  partcv[0] = 1;
  Object call6211 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6210);
// compiled call node returning call6211 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6212 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  gc_frame_newslot(*var_meth_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_meth_39_;
  params[1] = *var_signature;
  params[2] = *var_tok;
  partcv[0] = 3;
  Object call6213 = callmethodflags(self, "callmprest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6212);
// compiled call node returning call6213 (depth = 5)
  *var_methn = call6213;
  if (call6213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6217 == NULL) {
    strlit6217 = alloc_String("member");
    gc_root(strlit6217);
  }
// compiled string node returning strlit6217 (depth = 6)
  int op_slot_right_6216 = gc_frame_newslot(strlit6217);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call6220 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6219);
// compiled call node returning call6220 (depth = 7)
// compiled member node returning call6220 (depth = 6)
  int op_slot_left_6216 = gc_frame_newslot(call6220);
  params[0] = strlit6217;
  partcv[0] = 1;
  Object opresult6221 = callmethod(call6220, "==", 1, partcv, params);
// compiled op node returning opresult6221 (depth = 5)
  Object if6215 = done;
  if (istrue(opresult6221)) {
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6222 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call6224 = callmethod(*var_methn, "value",
    1, partcv, params);
  gc_frame_end(callframe6223);
// compiled call node returning call6224 (depth = 8)
// compiled member node returning call6224 (depth = 7)
  gc_frame_newslot(call6224);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call6226 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe6225);
// compiled call node returning call6226 (depth = 8)
// compiled member node returning call6226 (depth = 7)
  gc_frame_newslot(call6226);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call6228 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe6227);
// compiled call node returning call6228 (depth = 8)
// compiled member node returning call6228 (depth = 7)
  params[0] = call6224;
  params[1] = call6226;
  partcv[0] = 2;
  Object call6229 = callmethod(call6228, "new",
    1, partcv, params);
  gc_frame_end(callframe6222);
// compiled call node returning call6229 (depth = 6)
  *var_meth = call6229;
  if (call6229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6231 = gc_frame_new();
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call6233 = callmethod(*var_methn, "line",
    1, partcv, params);
  gc_frame_end(callframe6232);
// compiled call node returning call6233 (depth = 8)
// compiled member node returning call6233 (depth = 7)
  gc_frame_newslot(call6233);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  params[0] = call6233;
  partcv[0] = 1;
  Object call6234 = callmethod(*var_meth, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6231);
// compiled call node returning call6234 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6235 = gc_frame_new();
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6236 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call6237 = callmethod(*var_methn, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6236);
// compiled call node returning call6237 (depth = 8)
// compiled member node returning call6237 (depth = 7)
  gc_frame_newslot(call6237);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  params[0] = call6237;
  partcv[0] = 1;
  Object call6238 = callmethod(*var_meth, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6235);
// compiled call node returning call6238 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6215 = done;
  } else {
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  *var_meth = *var_methn;
  if (*var_methn == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6215 = done;
  }
// compiled if node returning if6215 (depth = 4)
    gc_frame_newslot(if6215);
    if6199 = if6215;
  } else {
  }
// compiled if node returning if6199 (depth = 3)
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6240 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lnum (depth = 4)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call6241 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe6240);
// compiled call node returning call6241 (depth = 3)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6242 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6243 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call6244 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe6243);
// compiled call node returning call6244 (depth = 6)
// compiled member node returning call6244 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  partcv[0] = 2;
  Object call6245 = callmethod(call6244, "new",
    1, partcv, params);
  gc_frame_end(callframe6242);
// compiled call node returning call6245 (depth = 4)
  *var_call = call6245;
  if (call6245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6246 = gc_frame_new();
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_call (depth = 5)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call6247 = callmethod(*var_call, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6246);
// compiled call node returning call6247 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6248 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call6249 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6248);
// compiled call node returning call6249 (depth = 3)
    gc_frame_newslot(call6249);
    if6198 = call6249;
  } else {
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6252 = alloc_Boolean(0);
// compiled identifier node returning bool6252 (depth = 5)
  int op_slot_right_6251 = gc_frame_newslot(bool6252);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  int op_slot_left_6251 = gc_frame_newslot(*var_genericIdents);
  params[0] = bool6252;
  partcv[0] = 1;
  Object opresult6254 = callmethod(*var_genericIdents, "!=", 1, partcv, params);
// compiled op node returning opresult6254 (depth = 4)
  Object if6250 = done;
  if (istrue(opresult6254)) {
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6255 = gc_frame_new();
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_genericIdents (depth = 6)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call6256 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6255);
// compiled call node returning call6256 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6250 = done;
  } else {
  }
// compiled if node returning if6250 (depth = 3)
    gc_frame_newslot(if6250);
    if6198 = if6250;
  }
// compiled if node returning if6198 (depth = 2)
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startInd (depth = 3)
  *var_minIndentLevel = *var_startInd;
  if (*var_startInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6258 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_acceptBlocks (depth = 3)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call6259 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6258);
// compiled call node returning call6259 (depth = 2)
  gc_frame_end(frame);
  return call6259;
}
Object meth_parser__apply6265(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6266 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blocksOK (depth = 5)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6267 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6266);
// compiled call node returning call6267 (depth = 4)
  gc_frame_end(frame);
  return call6267;
}
Object meth_parser__apply6344(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe6345 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6346 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6345);
// compiled call node returning call6346 (depth = 10)
  gc_frame_end(frame);
  return call6346;
}
Object meth_parser__apply6407(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe6408 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6409 == NULL) {
    strlit6409 = alloc_String("comma");
    gc_root(strlit6409);
  }
// compiled string node returning strlit6409 (depth = 7)
  gc_frame_newslot(strlit6409);
// call case 4: self request
  params[0] = strlit6409;
  partcv[0] = 1;
  Object call6410 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6408);
// compiled call node returning call6410 (depth = 6)
  gc_frame_end(frame);
  return call6410;
}
Object meth_parser__apply6426(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe6427 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6428 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6427);
// compiled call node returning call6428 (depth = 11)
  gc_frame_end(frame);
  return call6428;
}
Object meth_parser__apply6550(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe6551 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6552 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6551);
// compiled call node returning call6552 (depth = 12)
  gc_frame_end(frame);
  return call6552;
}
Object meth_parser__apply6413(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arg = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arg");
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6414 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6415 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call6416 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6415);
// compiled call node returning call6416 (depth = 8)
// compiled member node returning call6416 (depth = 7)
  gc_frame_newslot(call6416);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call6418 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6417);
// compiled call node returning call6418 (depth = 8)
// compiled member node returning call6418 (depth = 7)
  params[0] = call6416;
  partcv[0] = 1;
  Object call6419 = callmethod(call6418, "push",
    1, partcv, params);
  gc_frame_end(callframe6414);
// compiled call node returning call6419 (depth = 6)
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6421 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6420);
// compiled call node returning call6421 (depth = 7)
// compiled member node returning call6421 (depth = 6)
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6423 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6424 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block6425 = alloc_Block(NULL, NULL, "parser", 2016);
  gc_frame_newslot(block6425);
// method _apply
  block_savedest(block6425);
  Object closure6426 = createclosure(2, "_apply");
  setclosureframe(closure6426, stackframe);
  addtoclosure(closure6426, var_blocksOK);
  addtoclosure(closure6426, selfslot);
  struct UserObject *uo6426 = (struct UserObject*)block6425;
  uo6426->data[0] = (Object)closure6426;
  Method *meth_meth_parser__apply6426 = addmethod2pos(block6425, "_apply", &meth_parser__apply6426, 0);
  int argcv_meth_parser__apply6426[] = {0};
  meth_meth_parser__apply6426->type = alloc_MethodType(1, argcv_meth_parser__apply6426);
  meth_meth_parser__apply6426->definitionModule = modulename;
  meth_meth_parser__apply6426->definitionLine = 2016;
// compiled block node returning block6425 (depth = 10)
  gc_frame_newslot(block6425);
// call case 4: self request
  params[0] = block6425;
  partcv[0] = 1;
  Object call6430 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6424);
// compiled call node returning call6430 (depth = 9)
  partcv[0] = 0;
  Object call6431 = callmethod(call6430, "not",
    1, partcv, params);
  gc_frame_end(callframe6423);
// compiled call node returning call6431 (depth = 8)
// compiled member node returning call6431 (depth = 7)
  Object if6422 = done;
  if (istrue(call6431)) {
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6432 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6433 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6434 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6433);
// compiled call node returning call6434 (depth = 11)
// compiled member node returning call6434 (depth = 10)
  partcv[0] = 0;
  Object call6435 = callmethod(call6434, "empty",
    1, partcv, params);
  gc_frame_end(callframe6432);
// compiled call node returning call6435 (depth = 9)
// compiled member node returning call6435 (depth = 8)
  *var_suggestions = call6435;
  if (call6435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6436 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6438 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6437);
// compiled call node returning call6438 (depth = 11)
// compiled member node returning call6438 (depth = 10)
  partcv[0] = 0;
  Object call6439 = callmethod(call6438, "new",
    1, partcv, params);
  gc_frame_end(callframe6436);
// compiled call node returning call6439 (depth = 9)
// compiled member node returning call6439 (depth = 8)
  *var_suggestion = call6439;
  if (call6439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6440 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6441 == NULL) {
    strlit6441 = alloc_String("rparen");
    gc_root(strlit6441);
  }
// compiled string node returning strlit6441 (depth = 9)
  gc_frame_newslot(strlit6441);
// call case 4: self request
  params[0] = strlit6441;
  partcv[0] = 1;
  Object call6442 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6440);
// compiled call node returning call6442 (depth = 8)
  *var_nextTok = call6442;
  if (call6442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6444 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6444 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6446 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6446 (depth = 8)
  Object if6443 = done;
  if (istrue(opresult6446)) {
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6447 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6448 == NULL) {
    strlit6448 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6448);
  }
// compiled string node returning strlit6448 (depth = 9)
  gc_frame_newslot(strlit6448);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6448;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6449 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6447);
// compiled call node returning call6449 (depth = 8)
    gc_frame_newslot(call6449);
    if6443 = call6449;
  } else {
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6450 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6452 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6451);
// compiled call node returning call6452 (depth = 10)
// compiled member node returning call6452 (depth = 9)
  gc_frame_newslot(call6452);
// starting to compile identifier node (depth = 9)
  Object bool6453 = alloc_Boolean(1);
// compiled identifier node returning bool6453 (depth = 9)
  gc_frame_newslot(bool6453);
// starting to compile identifier node (depth = 9)
  Object bool6454 = alloc_Boolean(0);
// compiled identifier node returning bool6454 (depth = 9)
  gc_frame_newslot(bool6454);
// starting to compile string node (depth = 9)
  if (strlit6455 == NULL) {
    strlit6455 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6455);
  }
// compiled string node returning strlit6455 (depth = 9)
  gc_frame_newslot(strlit6455);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6452;
  params[2] = bool6453;
  params[3] = bool6454;
  params[4] = strlit6455;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6456 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6450);
// compiled call node returning call6456 (depth = 8)
    gc_frame_newslot(call6456);
    if6443 = call6456;
  }
// compiled if node returning if6443 (depth = 7)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6457 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6458 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6457);
// compiled call node returning call6458 (depth = 7)
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6459 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6460 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6461 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6460);
// compiled call node returning call6461 (depth = 11)
// compiled member node returning call6461 (depth = 10)
  partcv[0] = 0;
  Object call6462 = callmethod(call6461, "new",
    1, partcv, params);
  gc_frame_end(callframe6459);
// compiled call node returning call6462 (depth = 9)
// compiled member node returning call6462 (depth = 8)
  *var_suggestion = call6462;
  if (call6462 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6464 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6465 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call6466 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6465);
// compiled call node returning call6466 (depth = 9)
// compiled member node returning call6466 (depth = 8)
  gc_frame_newslot(call6466);
// starting to compile identifier node (depth = 8)
  Object bool6467 = alloc_Boolean(1);
// compiled identifier node returning bool6467 (depth = 8)
  gc_frame_newslot(bool6467);
// starting to compile identifier node (depth = 8)
  Object bool6468 = alloc_Boolean(0);
// compiled identifier node returning bool6468 (depth = 8)
  gc_frame_newslot(bool6468);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call6466;
  params[2] = bool6467;
  params[3] = bool6468;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6469 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6464);
// compiled call node returning call6469 (depth = 7)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6470 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6471 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6470);
// compiled call node returning call6471 (depth = 7)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6472 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6473 == NULL) {
    strlit6473 = alloc_String("A method request must have an expression after a ','.");
    gc_root(strlit6473);
  }
// compiled string node returning strlit6473 (depth = 8)
  gc_frame_newslot(strlit6473);
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6474 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6475 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6474);
// compiled call node returning call6475 (depth = 9)
// compiled member node returning call6475 (depth = 8)
  gc_frame_newslot(call6475);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6477 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6476);
// compiled call node returning call6477 (depth = 9)
// compiled member node returning call6477 (depth = 8)
  gc_frame_newslot(call6477);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6473;
  params[1] = call6475;
  params[2] = call6477;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6478 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6472);
// compiled call node returning call6478 (depth = 7)
    gc_frame_newslot(call6478);
    if6422 = call6478;
  } else {
  }
// compiled if node returning if6422 (depth = 6)
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6480 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6481 == NULL) {
    strlit6481 = alloc_String("colon");
    gc_root(strlit6481);
  }
// compiled string node returning strlit6481 (depth = 8)
  gc_frame_newslot(strlit6481);
// call case 4: self request
  params[0] = strlit6481;
  partcv[0] = 1;
  Object call6482 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6480);
// compiled call node returning call6482 (depth = 7)
  Object if6479 = done;
  if (istrue(call6482)) {
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6483 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6484 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6483);
// compiled call node returning call6484 (depth = 9)
// compiled member node returning call6484 (depth = 8)
  *var_arg = call6484;
  if (call6484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6487 == NULL) {
    strlit6487 = alloc_String("identifier");
    gc_root(strlit6487);
  }
// compiled string node returning strlit6487 (depth = 9)
  int op_slot_right_6486 = gc_frame_newslot(strlit6487);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  partcv[0] = 0;
  Object call6490 = callmethod(*var_arg, "kind",
    1, partcv, params);
  gc_frame_end(callframe6489);
// compiled call node returning call6490 (depth = 10)
// compiled member node returning call6490 (depth = 9)
  int op_slot_left_6486 = gc_frame_newslot(call6490);
  params[0] = strlit6487;
  partcv[0] = 1;
  Object opresult6491 = callmethod(call6490, "!=", 1, partcv, params);
// compiled op node returning opresult6491 (depth = 8)
  Object if6485 = done;
  if (istrue(opresult6491)) {
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6492 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6493 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6494 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6493);
// compiled call node returning call6494 (depth = 12)
// compiled member node returning call6494 (depth = 11)
  partcv[0] = 0;
  Object call6495 = callmethod(call6494, "new",
    1, partcv, params);
  gc_frame_end(callframe6492);
// compiled call node returning call6495 (depth = 10)
// compiled member node returning call6495 (depth = 9)
  *var_suggestion = call6495;
  if (call6495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6498 == NULL) {
    strlit6498 = alloc_String("identifier");
    gc_root(strlit6498);
  }
// compiled string node returning strlit6498 (depth = 10)
  int op_slot_right_6497 = gc_frame_newslot(strlit6498);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6500 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6501 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call6502 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6501);
// compiled call node returning call6502 (depth = 13)
// compiled member node returning call6502 (depth = 12)
  partcv[0] = 0;
  Object call6503 = callmethod(call6502, "kind",
    1, partcv, params);
  gc_frame_end(callframe6500);
// compiled call node returning call6503 (depth = 11)
// compiled member node returning call6503 (depth = 10)
  int op_slot_left_6497 = gc_frame_newslot(call6503);
  params[0] = strlit6498;
  partcv[0] = 1;
  Object opresult6504 = callmethod(call6503, "==", 1, partcv, params);
// compiled op node returning opresult6504 (depth = 9)
  Object if6496 = done;
  if (istrue(opresult6504)) {
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6505 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6507 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6506);
// compiled call node returning call6507 (depth = 11)
// compiled member node returning call6507 (depth = 10)
  gc_frame_newslot(call6507);
// starting to compile identifier node (depth = 10)
  Object bool6508 = alloc_Boolean(1);
// compiled identifier node returning bool6508 (depth = 10)
  gc_frame_newslot(bool6508);
// starting to compile identifier node (depth = 10)
  Object bool6509 = alloc_Boolean(0);
// compiled identifier node returning bool6509 (depth = 10)
  gc_frame_newslot(bool6509);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6507;
  params[2] = bool6508;
  params[3] = bool6509;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6510 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6505);
// compiled call node returning call6510 (depth = 9)
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6511 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6512 == NULL) {
    strlit6512 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6512);
  }
// compiled string node returning strlit6512 (depth = 10)
  gc_frame_newslot(strlit6512);
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6513 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6514 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6513);
// compiled call node returning call6514 (depth = 11)
// compiled member node returning call6514 (depth = 10)
  gc_frame_newslot(call6514);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6515 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6516 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6515);
// compiled call node returning call6516 (depth = 11)
// compiled member node returning call6516 (depth = 10)
  gc_frame_newslot(call6516);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num6518 = alloc_Float64(1);
// compiled num node returning num6518 (depth = 11)
  int op_slot_right_6517 = gc_frame_newslot(num6518);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6521 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe6522 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call6523 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6522);
// compiled call node returning call6523 (depth = 15)
// compiled member node returning call6523 (depth = 14)
  partcv[0] = 0;
  Object call6524 = callmethod(call6523, "size",
    1, partcv, params);
  gc_frame_end(callframe6521);
// compiled call node returning call6524 (depth = 13)
// compiled member node returning call6524 (depth = 12)
  int op_slot_right_6520 = gc_frame_newslot(call6524);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6526 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe6527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call6528 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6527);
// compiled call node returning call6528 (depth = 15)
// compiled member node returning call6528 (depth = 14)
  partcv[0] = 0;
  Object call6529 = callmethod(call6528, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6526);
// compiled call node returning call6529 (depth = 13)
// compiled member node returning call6529 (depth = 12)
  int op_slot_left_6520 = gc_frame_newslot(call6529);
  params[0] = call6524;
  partcv[0] = 1;
  Object sum6530 = callmethod(call6529, "+", 1, partcv, params);
// compiled op node returning sum6530 (depth = 11)
  int op_slot_left_6517 = gc_frame_newslot(sum6530);
  params[0] = num6518;
  partcv[0] = 1;
  Object diff6531 = callmethod(sum6530, "-", 1, partcv, params);
// compiled op node returning diff6531 (depth = 10)
  gc_frame_newslot(diff6531);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6512;
  params[1] = call6514;
  params[2] = call6516;
  params[3] = diff6531;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6532 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6511);
// compiled call node returning call6532 (depth = 9)
    gc_frame_newslot(call6532);
    if6496 = call6532;
  } else {
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6533 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call6534 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe6533);
// compiled call node returning call6534 (depth = 9)
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6535 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6536 == NULL) {
    strlit6536 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6536);
  }
// compiled string node returning strlit6536 (depth = 10)
  gc_frame_newslot(strlit6536);
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6538 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6537);
// compiled call node returning call6538 (depth = 11)
// compiled member node returning call6538 (depth = 10)
  gc_frame_newslot(call6538);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6540 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6539);
// compiled call node returning call6540 (depth = 11)
// compiled member node returning call6540 (depth = 10)
  gc_frame_newslot(call6540);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6541 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6542 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6541);
// compiled call node returning call6542 (depth = 11)
// compiled member node returning call6542 (depth = 10)
  gc_frame_newslot(call6542);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6536;
  params[1] = call6538;
  params[2] = call6540;
  params[3] = call6542;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6543 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6535);
// compiled call node returning call6543 (depth = 9)
    gc_frame_newslot(call6543);
    if6496 = call6543;
  }
// compiled if node returning if6496 (depth = 8)
    gc_frame_newslot(if6496);
    if6485 = if6496;
  } else {
  }
// compiled if node returning if6485 (depth = 7)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6545 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6544);
// compiled call node returning call6545 (depth = 8)
// compiled member node returning call6545 (depth = 7)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6547 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6548 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block6549 = alloc_Block(NULL, NULL, "parser", 2048);
  gc_frame_newslot(block6549);
// method _apply
  block_savedest(block6549);
  Object closure6550 = createclosure(2, "_apply");
  setclosureframe(closure6550, stackframe);
  addtoclosure(closure6550, var_blocksOK);
  addtoclosure(closure6550, selfslot);
  struct UserObject *uo6550 = (struct UserObject*)block6549;
  uo6550->data[0] = (Object)closure6550;
  Method *meth_meth_parser__apply6550 = addmethod2pos(block6549, "_apply", &meth_parser__apply6550, 0);
  int argcv_meth_parser__apply6550[] = {0};
  meth_meth_parser__apply6550->type = alloc_MethodType(1, argcv_meth_parser__apply6550);
  meth_meth_parser__apply6550->definitionModule = modulename;
  meth_meth_parser__apply6550->definitionLine = 2048;
// compiled block node returning block6549 (depth = 11)
  gc_frame_newslot(block6549);
// call case 4: self request
  params[0] = block6549;
  partcv[0] = 1;
  Object call6554 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6548);
// compiled call node returning call6554 (depth = 10)
  partcv[0] = 0;
  Object call6555 = callmethod(call6554, "not",
    1, partcv, params);
  gc_frame_end(callframe6547);
// compiled call node returning call6555 (depth = 9)
// compiled member node returning call6555 (depth = 8)
  Object if6546 = done;
  if (istrue(call6555)) {
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6556 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6557 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6556);
// compiled call node returning call6557 (depth = 9)
// compiled member node returning call6557 (depth = 8)
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6558 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6559 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6560 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6559);
// compiled call node returning call6560 (depth = 12)
// compiled member node returning call6560 (depth = 11)
  partcv[0] = 0;
  Object call6561 = callmethod(call6560, "empty",
    1, partcv, params);
  gc_frame_end(callframe6558);
// compiled call node returning call6561 (depth = 10)
// compiled member node returning call6561 (depth = 9)
  *var_suggestions = call6561;
  if (call6561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6562 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6563 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6564 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6563);
// compiled call node returning call6564 (depth = 12)
// compiled member node returning call6564 (depth = 11)
  partcv[0] = 0;
  Object call6565 = callmethod(call6564, "new",
    1, partcv, params);
  gc_frame_end(callframe6562);
// compiled call node returning call6565 (depth = 10)
// compiled member node returning call6565 (depth = 9)
  *var_suggestion = call6565;
  if (call6565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6566 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6567 == NULL) {
    strlit6567 = alloc_String("rparen");
    gc_root(strlit6567);
  }
// compiled string node returning strlit6567 (depth = 10)
  gc_frame_newslot(strlit6567);
// call case 4: self request
  params[0] = strlit6567;
  partcv[0] = 1;
  Object call6568 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6566);
// compiled call node returning call6568 (depth = 9)
  *var_nextTok = call6568;
  if (call6568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_6570 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_6570 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6572 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6572 (depth = 9)
  Object if6569 = done;
  if (istrue(opresult6572)) {
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6573 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6574 == NULL) {
    strlit6574 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6574);
  }
// compiled string node returning strlit6574 (depth = 10)
  gc_frame_newslot(strlit6574);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6574;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6575 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6573);
// compiled call node returning call6575 (depth = 9)
    gc_frame_newslot(call6575);
    if6569 = call6575;
  } else {
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6576 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6577 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call6578 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6577);
// compiled call node returning call6578 (depth = 11)
// compiled member node returning call6578 (depth = 10)
  gc_frame_newslot(call6578);
// starting to compile identifier node (depth = 10)
  Object bool6579 = alloc_Boolean(1);
// compiled identifier node returning bool6579 (depth = 10)
  gc_frame_newslot(bool6579);
// starting to compile identifier node (depth = 10)
  Object bool6580 = alloc_Boolean(0);
// compiled identifier node returning bool6580 (depth = 10)
  gc_frame_newslot(bool6580);
// starting to compile string node (depth = 10)
  if (strlit6581 == NULL) {
    strlit6581 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6581);
  }
// compiled string node returning strlit6581 (depth = 10)
  gc_frame_newslot(strlit6581);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6578;
  params[2] = bool6579;
  params[3] = bool6580;
  params[4] = strlit6581;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6582 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6576);
// compiled call node returning call6582 (depth = 9)
    gc_frame_newslot(call6582);
    if6569 = call6582;
  }
// compiled if node returning if6569 (depth = 8)
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6583 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6584 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6583);
// compiled call node returning call6584 (depth = 8)
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6585 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6586 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6587 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6586);
// compiled call node returning call6587 (depth = 12)
// compiled member node returning call6587 (depth = 11)
  partcv[0] = 0;
  Object call6588 = callmethod(call6587, "new",
    1, partcv, params);
  gc_frame_end(callframe6585);
// compiled call node returning call6588 (depth = 10)
// compiled member node returning call6588 (depth = 9)
  *var_suggestion = call6588;
  if (call6588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6590 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6591 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6592 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6591);
// compiled call node returning call6592 (depth = 10)
// compiled member node returning call6592 (depth = 9)
  gc_frame_newslot(call6592);
// starting to compile identifier node (depth = 9)
  Object bool6593 = alloc_Boolean(1);
// compiled identifier node returning bool6593 (depth = 9)
  gc_frame_newslot(bool6593);
// starting to compile identifier node (depth = 9)
  Object bool6594 = alloc_Boolean(0);
// compiled identifier node returning bool6594 (depth = 9)
  gc_frame_newslot(bool6594);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call6592;
  params[2] = bool6593;
  params[3] = bool6594;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6595 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6590);
// compiled call node returning call6595 (depth = 8)
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6596 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6597 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6596);
// compiled call node returning call6597 (depth = 8)
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6598 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6599 == NULL) {
    strlit6599 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit6599);
  }
// compiled string node returning strlit6599 (depth = 9)
  gc_frame_newslot(strlit6599);
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6601 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6600);
// compiled call node returning call6601 (depth = 10)
// compiled member node returning call6601 (depth = 9)
  gc_frame_newslot(call6601);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6602 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6603 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6602);
// compiled call node returning call6603 (depth = 10)
// compiled member node returning call6603 (depth = 9)
  gc_frame_newslot(call6603);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6599;
  params[1] = call6601;
  params[2] = call6603;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6604 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6598);
// compiled call node returning call6604 (depth = 8)
    gc_frame_newslot(call6604);
    if6546 = call6604;
  } else {
  }
// compiled if node returning if6546 (depth = 7)
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6605 = gc_frame_new();
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call6607 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6606);
// compiled call node returning call6607 (depth = 10)
// compiled member node returning call6607 (depth = 9)
  gc_frame_newslot(call6607);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = call6607;
  partcv[0] = 1;
  Object call6608 = callmethod(*var_arg, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6605);
// compiled call node returning call6608 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6609 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call6610 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6609);
// compiled call node returning call6610 (depth = 7)
    gc_frame_newslot(call6610);
    if6479 = call6610;
  } else {
  }
// compiled if node returning if6479 (depth = 6)
  gc_frame_end(frame);
  return if6479;
}
Object meth_parser__apply6270(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6272 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6273 == NULL) {
    strlit6273 = alloc_String("colon");
    gc_root(strlit6273);
  }
// compiled string node returning strlit6273 (depth = 6)
  gc_frame_newslot(strlit6273);
// call case 4: self request
  params[0] = strlit6273;
  partcv[0] = 1;
  Object call6274 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6272);
// compiled call node returning call6274 (depth = 5)
  Object if6271 = done;
  if (istrue(call6274)) {
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6276 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6275);
// compiled call node returning call6276 (depth = 7)
// compiled member node returning call6276 (depth = 6)
  *var_expr = call6276;
  if (call6276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6279 == NULL) {
    strlit6279 = alloc_String("identifier");
    gc_root(strlit6279);
  }
// compiled string node returning strlit6279 (depth = 7)
  int op_slot_right_6278 = gc_frame_newslot(strlit6279);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr (depth = 9)
  partcv[0] = 0;
  Object call6282 = callmethod(*var_expr, "kind",
    1, partcv, params);
  gc_frame_end(callframe6281);
// compiled call node returning call6282 (depth = 8)
// compiled member node returning call6282 (depth = 7)
  int op_slot_left_6278 = gc_frame_newslot(call6282);
  params[0] = strlit6279;
  partcv[0] = 1;
  Object opresult6283 = callmethod(call6282, "!=", 1, partcv, params);
// compiled op node returning opresult6283 (depth = 6)
  Object if6277 = done;
  if (istrue(opresult6283)) {
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6284 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6285 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6286 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6285);
// compiled call node returning call6286 (depth = 10)
// compiled member node returning call6286 (depth = 9)
  partcv[0] = 0;
  Object call6287 = callmethod(call6286, "new",
    1, partcv, params);
  gc_frame_end(callframe6284);
// compiled call node returning call6287 (depth = 8)
// compiled member node returning call6287 (depth = 7)
  *var_suggestion = call6287;
  if (call6287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6290 == NULL) {
    strlit6290 = alloc_String("identifier");
    gc_root(strlit6290);
  }
// compiled string node returning strlit6290 (depth = 8)
  int op_slot_right_6289 = gc_frame_newslot(strlit6290);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6292 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6294 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6293);
// compiled call node returning call6294 (depth = 11)
// compiled member node returning call6294 (depth = 10)
  partcv[0] = 0;
  Object call6295 = callmethod(call6294, "kind",
    1, partcv, params);
  gc_frame_end(callframe6292);
// compiled call node returning call6295 (depth = 9)
// compiled member node returning call6295 (depth = 8)
  int op_slot_left_6289 = gc_frame_newslot(call6295);
  params[0] = strlit6290;
  partcv[0] = 1;
  Object opresult6296 = callmethod(call6295, "==", 1, partcv, params);
// compiled op node returning opresult6296 (depth = 7)
  Object if6288 = done;
  if (istrue(opresult6296)) {
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6297 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6299 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6298);
// compiled call node returning call6299 (depth = 9)
// compiled member node returning call6299 (depth = 8)
  gc_frame_newslot(call6299);
// starting to compile identifier node (depth = 8)
  Object bool6300 = alloc_Boolean(1);
// compiled identifier node returning bool6300 (depth = 8)
  gc_frame_newslot(bool6300);
// starting to compile identifier node (depth = 8)
  Object bool6301 = alloc_Boolean(0);
// compiled identifier node returning bool6301 (depth = 8)
  gc_frame_newslot(bool6301);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call6299;
  params[2] = bool6300;
  params[3] = bool6301;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6302 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6297);
// compiled call node returning call6302 (depth = 7)
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6303 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6304 == NULL) {
    strlit6304 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6304);
  }
// compiled string node returning strlit6304 (depth = 8)
  gc_frame_newslot(strlit6304);
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6306 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6305);
// compiled call node returning call6306 (depth = 9)
// compiled member node returning call6306 (depth = 8)
  gc_frame_newslot(call6306);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6307 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6308 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6307);
// compiled call node returning call6308 (depth = 9)
// compiled member node returning call6308 (depth = 8)
  gc_frame_newslot(call6308);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6310 = alloc_Float64(1);
// compiled num node returning num6310 (depth = 9)
  int op_slot_right_6309 = gc_frame_newslot(num6310);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6313 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6314 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call6315 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6314);
// compiled call node returning call6315 (depth = 13)
// compiled member node returning call6315 (depth = 12)
  partcv[0] = 0;
  Object call6316 = callmethod(call6315, "size",
    1, partcv, params);
  gc_frame_end(callframe6313);
// compiled call node returning call6316 (depth = 11)
// compiled member node returning call6316 (depth = 10)
  int op_slot_right_6312 = gc_frame_newslot(call6316);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6318 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call6320 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6319);
// compiled call node returning call6320 (depth = 13)
// compiled member node returning call6320 (depth = 12)
  partcv[0] = 0;
  Object call6321 = callmethod(call6320, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6318);
// compiled call node returning call6321 (depth = 11)
// compiled member node returning call6321 (depth = 10)
  int op_slot_left_6312 = gc_frame_newslot(call6321);
  params[0] = call6316;
  partcv[0] = 1;
  Object sum6322 = callmethod(call6321, "+", 1, partcv, params);
// compiled op node returning sum6322 (depth = 9)
  int op_slot_left_6309 = gc_frame_newslot(sum6322);
  params[0] = num6310;
  partcv[0] = 1;
  Object diff6323 = callmethod(sum6322, "-", 1, partcv, params);
// compiled op node returning diff6323 (depth = 8)
  gc_frame_newslot(diff6323);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6304;
  params[1] = call6306;
  params[2] = call6308;
  params[3] = diff6323;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6324 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6303);
// compiled call node returning call6324 (depth = 7)
    gc_frame_newslot(call6324);
    if6288 = call6324;
  } else {
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6325 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool6326 = alloc_Boolean(1);
// compiled identifier node returning bool6326 (depth = 8)
  gc_frame_newslot(bool6326);
// starting to compile identifier node (depth = 8)
  Object bool6327 = alloc_Boolean(0);
// compiled identifier node returning bool6327 (depth = 8)
  gc_frame_newslot(bool6327);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool6326;
  params[2] = bool6327;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6328 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6325);
// compiled call node returning call6328 (depth = 7)
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6329 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6330 == NULL) {
    strlit6330 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6330);
  }
// compiled string node returning strlit6330 (depth = 8)
  gc_frame_newslot(strlit6330);
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6331 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6332 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6331);
// compiled call node returning call6332 (depth = 9)
// compiled member node returning call6332 (depth = 8)
  gc_frame_newslot(call6332);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6334 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6333);
// compiled call node returning call6334 (depth = 9)
// compiled member node returning call6334 (depth = 8)
  gc_frame_newslot(call6334);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6336 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6335);
// compiled call node returning call6336 (depth = 9)
// compiled member node returning call6336 (depth = 8)
  gc_frame_newslot(call6336);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6330;
  params[1] = call6332;
  params[2] = call6334;
  params[3] = call6336;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6337 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6329);
// compiled call node returning call6337 (depth = 7)
    gc_frame_newslot(call6337);
    if6288 = call6337;
  }
// compiled if node returning if6288 (depth = 6)
    gc_frame_newslot(if6288);
    if6277 = if6288;
  } else {
  }
// compiled if node returning if6277 (depth = 5)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6339 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6338);
// compiled call node returning call6339 (depth = 6)
// compiled member node returning call6339 (depth = 5)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6341 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe6342 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block6343 = alloc_Block(NULL, NULL, "parser", 1993);
  gc_frame_newslot(block6343);
// method _apply
  block_savedest(block6343);
  Object closure6344 = createclosure(2, "_apply");
  setclosureframe(closure6344, stackframe);
  addtoclosure(closure6344, var_blocksOK);
  addtoclosure(closure6344, selfslot);
  struct UserObject *uo6344 = (struct UserObject*)block6343;
  uo6344->data[0] = (Object)closure6344;
  Method *meth_meth_parser__apply6344 = addmethod2pos(block6343, "_apply", &meth_parser__apply6344, 0);
  int argcv_meth_parser__apply6344[] = {0};
  meth_meth_parser__apply6344->type = alloc_MethodType(1, argcv_meth_parser__apply6344);
  meth_meth_parser__apply6344->definitionModule = modulename;
  meth_meth_parser__apply6344->definitionLine = 1993;
// compiled block node returning block6343 (depth = 9)
  gc_frame_newslot(block6343);
// call case 4: self request
  params[0] = block6343;
  partcv[0] = 1;
  Object call6348 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6342);
// compiled call node returning call6348 (depth = 8)
  partcv[0] = 0;
  Object call6349 = callmethod(call6348, "not",
    1, partcv, params);
  gc_frame_end(callframe6341);
// compiled call node returning call6349 (depth = 7)
// compiled member node returning call6349 (depth = 6)
  Object if6340 = done;
  if (istrue(call6349)) {
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6351 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6350);
// compiled call node returning call6351 (depth = 7)
// compiled member node returning call6351 (depth = 6)
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6352 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6353 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6354 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6353);
// compiled call node returning call6354 (depth = 10)
// compiled member node returning call6354 (depth = 9)
  partcv[0] = 0;
  Object call6355 = callmethod(call6354, "empty",
    1, partcv, params);
  gc_frame_end(callframe6352);
// compiled call node returning call6355 (depth = 8)
// compiled member node returning call6355 (depth = 7)
  *var_suggestions = call6355;
  if (call6355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6356 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6358 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6357);
// compiled call node returning call6358 (depth = 10)
// compiled member node returning call6358 (depth = 9)
  partcv[0] = 0;
  Object call6359 = callmethod(call6358, "new",
    1, partcv, params);
  gc_frame_end(callframe6356);
// compiled call node returning call6359 (depth = 8)
// compiled member node returning call6359 (depth = 7)
  *var_suggestion = call6359;
  if (call6359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6360 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6361 == NULL) {
    strlit6361 = alloc_String("rparen");
    gc_root(strlit6361);
  }
// compiled string node returning strlit6361 (depth = 8)
  gc_frame_newslot(strlit6361);
// call case 4: self request
  params[0] = strlit6361;
  partcv[0] = 1;
  Object call6362 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6360);
// compiled call node returning call6362 (depth = 7)
  *var_nextTok = call6362;
  if (call6362 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_6364 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_6364 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6366 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6366 (depth = 7)
  Object if6363 = done;
  if (istrue(opresult6366)) {
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6367 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6368 == NULL) {
    strlit6368 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6368);
  }
// compiled string node returning strlit6368 (depth = 8)
  gc_frame_newslot(strlit6368);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit6368;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6369 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6367);
// compiled call node returning call6369 (depth = 7)
    gc_frame_newslot(call6369);
    if6363 = call6369;
  } else {
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6370 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call6372 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6371);
// compiled call node returning call6372 (depth = 9)
// compiled member node returning call6372 (depth = 8)
  gc_frame_newslot(call6372);
// starting to compile identifier node (depth = 8)
  Object bool6373 = alloc_Boolean(1);
// compiled identifier node returning bool6373 (depth = 8)
  gc_frame_newslot(bool6373);
// starting to compile identifier node (depth = 8)
  Object bool6374 = alloc_Boolean(0);
// compiled identifier node returning bool6374 (depth = 8)
  gc_frame_newslot(bool6374);
// starting to compile string node (depth = 8)
  if (strlit6375 == NULL) {
    strlit6375 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6375);
  }
// compiled string node returning strlit6375 (depth = 8)
  gc_frame_newslot(strlit6375);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call6372;
  params[2] = bool6373;
  params[3] = bool6374;
  params[4] = strlit6375;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6376 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6370);
// compiled call node returning call6376 (depth = 7)
    gc_frame_newslot(call6376);
    if6363 = call6376;
  }
// compiled if node returning if6363 (depth = 6)
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6377 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6378 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6377);
// compiled call node returning call6378 (depth = 6)
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6379 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6381 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6380);
// compiled call node returning call6381 (depth = 10)
// compiled member node returning call6381 (depth = 9)
  partcv[0] = 0;
  Object call6382 = callmethod(call6381, "new",
    1, partcv, params);
  gc_frame_end(callframe6379);
// compiled call node returning call6382 (depth = 8)
// compiled member node returning call6382 (depth = 7)
  *var_suggestion = call6382;
  if (call6382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6384 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call6386 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6385);
// compiled call node returning call6386 (depth = 8)
// compiled member node returning call6386 (depth = 7)
  gc_frame_newslot(call6386);
// starting to compile identifier node (depth = 7)
  Object bool6387 = alloc_Boolean(1);
// compiled identifier node returning bool6387 (depth = 7)
  gc_frame_newslot(bool6387);
// starting to compile identifier node (depth = 7)
  Object bool6388 = alloc_Boolean(0);
// compiled identifier node returning bool6388 (depth = 7)
  gc_frame_newslot(bool6388);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call6386;
  params[2] = bool6387;
  params[3] = bool6388;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6389 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6384);
// compiled call node returning call6389 (depth = 6)
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6390 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6391 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6390);
// compiled call node returning call6391 (depth = 6)
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6392 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6393 == NULL) {
    strlit6393 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit6393);
  }
// compiled string node returning strlit6393 (depth = 7)
  gc_frame_newslot(strlit6393);
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6394 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6395 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6394);
// compiled call node returning call6395 (depth = 8)
// compiled member node returning call6395 (depth = 7)
  gc_frame_newslot(call6395);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6396 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6397 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6396);
// compiled call node returning call6397 (depth = 8)
// compiled member node returning call6397 (depth = 7)
  gc_frame_newslot(call6397);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6393;
  params[1] = call6395;
  params[2] = call6397;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6398 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6392);
// compiled call node returning call6398 (depth = 6)
    gc_frame_newslot(call6398);
    if6340 = call6398;
  } else {
  }
// compiled if node returning if6340 (depth = 5)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6399 = gc_frame_new();
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6400 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call6401 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6400);
// compiled call node returning call6401 (depth = 8)
// compiled member node returning call6401 (depth = 7)
  gc_frame_newslot(call6401);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_expr (depth = 7)
  params[0] = call6401;
  partcv[0] = 1;
  Object call6402 = callmethod(*var_expr, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6399);
// compiled call node returning call6402 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6403 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  gc_frame_newslot(*var_expr);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call6404 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6403);
// compiled call node returning call6404 (depth = 5)
    gc_frame_newslot(call6404);
    if6271 = call6404;
  } else {
  }
// compiled if node returning if6271 (depth = 4)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6405 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6406 = alloc_Block(NULL, NULL, "parser", 2013);
  gc_frame_newslot(block6406);
// method _apply
  block_savedest(block6406);
  Object closure6407 = createclosure(1, "_apply");
  setclosureframe(closure6407, stackframe);
  addtoclosure(closure6407, selfslot);
  struct UserObject *uo6407 = (struct UserObject*)block6406;
  uo6407->data[0] = (Object)closure6407;
  Method *meth_meth_parser__apply6407 = addmethod2pos(block6406, "_apply", &meth_parser__apply6407, 0);
  int argcv_meth_parser__apply6407[] = {0};
  meth_meth_parser__apply6407->type = alloc_MethodType(1, argcv_meth_parser__apply6407);
  meth_meth_parser__apply6407->definitionModule = modulename;
  meth_meth_parser__apply6407->definitionLine = 2010;
// compiled block node returning block6406 (depth = 5)
  gc_frame_newslot(block6406);
// starting to compile block node (depth = 5)
  Object block6412 = alloc_Block(NULL, NULL, "parser", 2013);
  gc_frame_newslot(block6412);
// method _apply
  block_savedest(block6412);
  Object closure6413 = createclosure(7, "_apply");
  setclosureframe(closure6413, stackframe);
  addtoclosure(closure6413, var_values);
  addtoclosure(closure6413, var_part);
  addtoclosure(closure6413, var_blocksOK);
  addtoclosure(closure6413, var_errormessages);
  addtoclosure(closure6413, var_sym);
  addtoclosure(closure6413, var_lastToken);
  addtoclosure(closure6413, selfslot);
  struct UserObject *uo6413 = (struct UserObject*)block6412;
  uo6413->data[0] = (Object)closure6413;
  Method *meth_meth_parser__apply6413 = addmethod2pos(block6412, "_apply", &meth_parser__apply6413, 0);
  int argcv_meth_parser__apply6413[] = {0};
  meth_meth_parser__apply6413->type = alloc_MethodType(1, argcv_meth_parser__apply6413);
  meth_meth_parser__apply6413->definitionModule = modulename;
  meth_meth_parser__apply6413->definitionLine = 2010;
// compiled block node returning block6412 (depth = 5)
  gc_frame_newslot(block6412);
// call case 5: prelude request
  params[0] = block6406;
  params[1] = block6412;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6612 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6405);
// compiled call node returning call6612 (depth = 4)
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6613 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6615 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6614);
// compiled call node returning call6615 (depth = 6)
// compiled member node returning call6615 (depth = 5)
  gc_frame_newslot(call6615);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call6617 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6616);
// compiled call node returning call6617 (depth = 6)
// compiled member node returning call6617 (depth = 5)
  params[0] = call6615;
  partcv[0] = 1;
  Object call6618 = callmethod(call6617, "push",
    1, partcv, params);
  gc_frame_end(callframe6613);
// compiled call node returning call6618 (depth = 4)
  gc_frame_end(frame);
  return call6618;
}
Object meth_parser_parenthesizedArg6260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parenthesizedArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parenthesizedArg");
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parenthesizedArg (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parenthesizedArg");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6262 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6261);
// compiled call node returning call6262 (depth = 3)
// compiled member node returning call6262 (depth = 2)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6263 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6264 = alloc_Block(NULL, NULL, "parser", 1976);
  gc_frame_newslot(block6264);
// method _apply
  block_savedest(block6264);
  Object closure6265 = createclosure(2, "_apply");
  setclosureframe(closure6265, stackframe);
  addtoclosure(closure6265, var_blocksOK);
  addtoclosure(closure6265, selfslot);
  struct UserObject *uo6265 = (struct UserObject*)block6264;
  uo6265->data[0] = (Object)closure6265;
  Method *meth_meth_parser__apply6265 = addmethod2pos(block6264, "_apply", &meth_parser__apply6265, 0);
  int argcv_meth_parser__apply6265[] = {0};
  meth_meth_parser__apply6265->type = alloc_MethodType(1, argcv_meth_parser__apply6265);
  meth_meth_parser__apply6265->definitionModule = modulename;
  meth_meth_parser__apply6265->definitionLine = 1975;
// compiled block node returning block6264 (depth = 3)
  gc_frame_newslot(block6264);
// starting to compile block node (depth = 3)
  Object block6269 = alloc_Block(NULL, NULL, "parser", 1976);
  gc_frame_newslot(block6269);
// method _apply
  block_savedest(block6269);
  Object closure6270 = createclosure(7, "_apply");
  setclosureframe(closure6270, stackframe);
  addtoclosure(closure6270, var_values);
  addtoclosure(closure6270, var_errormessages);
  addtoclosure(closure6270, var_sym);
  addtoclosure(closure6270, var_blocksOK);
  addtoclosure(closure6270, var_lastToken);
  addtoclosure(closure6270, var_part);
  addtoclosure(closure6270, selfslot);
  struct UserObject *uo6270 = (struct UserObject*)block6269;
  uo6270->data[0] = (Object)closure6270;
  Method *meth_meth_parser__apply6270 = addmethod2pos(block6269, "_apply", &meth_parser__apply6270, 0);
  int argcv_meth_parser__apply6270[] = {0};
  meth_meth_parser__apply6270->type = alloc_MethodType(1, argcv_meth_parser__apply6270);
  meth_meth_parser__apply6270->definitionModule = modulename;
  meth_meth_parser__apply6270->definitionLine = 1975;
// compiled block node returning block6269 (depth = 3)
  gc_frame_newslot(block6269);
// call case 4: self request
  params[0] = block6264;
  params[1] = block6269;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6620 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6263);
// compiled call node returning call6620 (depth = 2)
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6623 == NULL) {
    strlit6623 = alloc_String("rparen");
    gc_root(strlit6623);
  }
// compiled string node returning strlit6623 (depth = 4)
  int op_slot_right_6622 = gc_frame_newslot(strlit6623);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6625 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6626 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6625);
// compiled call node returning call6626 (depth = 5)
// compiled member node returning call6626 (depth = 4)
  int op_slot_left_6622 = gc_frame_newslot(call6626);
  params[0] = strlit6623;
  partcv[0] = 1;
  Object opresult6627 = callmethod(call6626, "!=", 1, partcv, params);
// compiled op node returning opresult6627 (depth = 3)
  Object if6621 = done;
  if (istrue(opresult6627)) {
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6628 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6629 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6628);
// compiled call node returning call6629 (depth = 4)
// compiled member node returning call6629 (depth = 3)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6630 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6632 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6631);
// compiled call node returning call6632 (depth = 7)
// compiled member node returning call6632 (depth = 6)
  partcv[0] = 0;
  Object call6633 = callmethod(call6632, "new",
    1, partcv, params);
  gc_frame_end(callframe6630);
// compiled call node returning call6633 (depth = 5)
// compiled member node returning call6633 (depth = 4)
  *var_suggestion = call6633;
  if (call6633 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6634 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6635 == NULL) {
    strlit6635 = alloc_String(")");
    gc_root(strlit6635);
  }
// compiled string node returning strlit6635 (depth = 4)
  gc_frame_newslot(strlit6635);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6635;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6636 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6634);
// compiled call node returning call6636 (depth = 3)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6637 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6638 == NULL) {
    strlit6638 = alloc_String("A method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6638);
  }
// compiled string node returning strlit6638 (depth = 4)
  gc_frame_newslot(strlit6638);
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6639 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6640 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6639);
// compiled call node returning call6640 (depth = 5)
// compiled member node returning call6640 (depth = 4)
  gc_frame_newslot(call6640);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6643 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6642);
// compiled call node returning call6643 (depth = 6)
// compiled member node returning call6643 (depth = 5)
  int op_slot_right_6641 = gc_frame_newslot(call6643);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6645 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6646 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6645);
// compiled call node returning call6646 (depth = 6)
// compiled member node returning call6646 (depth = 5)
  int op_slot_left_6641 = gc_frame_newslot(call6646);
  params[0] = call6643;
  partcv[0] = 1;
  Object sum6647 = callmethod(call6646, "+", 1, partcv, params);
// compiled op node returning sum6647 (depth = 4)
  gc_frame_newslot(sum6647);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit6638;
  params[1] = call6640;
  params[2] = sum6647;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6648 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6637);
// compiled call node returning call6648 (depth = 3)
    gc_frame_newslot(call6648);
    if6621 = call6648;
  } else {
  }
// compiled if node returning if6621 (depth = 2)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call6652 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe6651);
// compiled call node returning call6652 (depth = 5)
// compiled member node returning call6652 (depth = 4)
  int op_slot_right_6650 = gc_frame_newslot(call6652);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6654 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6655 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6654);
// compiled call node returning call6655 (depth = 5)
// compiled member node returning call6655 (depth = 4)
  int op_slot_left_6650 = gc_frame_newslot(call6655);
  params[0] = call6652;
  partcv[0] = 1;
  Object opresult6656 = callmethod(call6655, "==", 1, partcv, params);
// compiled op node returning opresult6656 (depth = 3)
  Object if6649 = done;
  if (istrue(opresult6656)) {
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6657 = gc_frame_new();
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call6660 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6659);
// compiled call node returning call6660 (depth = 7)
// compiled member node returning call6660 (depth = 6)
  int op_slot_right_6658 = gc_frame_newslot(call6660);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6663 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6662);
// compiled call node returning call6663 (depth = 7)
// compiled member node returning call6663 (depth = 6)
  int op_slot_left_6658 = gc_frame_newslot(call6663);
  params[0] = call6660;
  partcv[0] = 1;
  Object diff6664 = callmethod(call6663, "-", 1, partcv, params);
// compiled op node returning diff6664 (depth = 5)
  gc_frame_newslot(diff6664);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff6664;
  partcv[0] = 1;
  Object call6665 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe6657);
// compiled call node returning call6665 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6649 = done;
  } else {
  }
// compiled if node returning if6649 (depth = 2)
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6667 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6666);
// compiled call node returning call6667 (depth = 3)
// compiled member node returning call6667 (depth = 2)
  gc_frame_end(frame);
  return call6667;
}
Object meth_parser__apply6687(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6688 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6689 = callmethodflags(self, "typeArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6688);
// compiled call node returning call6689 (depth = 7)
// compiled member node returning call6689 (depth = 6)
  gc_frame_end(frame);
  return call6689;
}
Object meth_parser__apply6684(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6685 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6686 = alloc_Block(NULL, NULL, "parser", 2090);
  gc_frame_newslot(block6686);
// method _apply
  block_savedest(block6686);
  Object closure6687 = createclosure(1, "_apply");
  setclosureframe(closure6687, stackframe);
  addtoclosure(closure6687, selfslot);
  struct UserObject *uo6687 = (struct UserObject*)block6686;
  uo6687->data[0] = (Object)closure6687;
  Method *meth_meth_parser__apply6687 = addmethod2pos(block6686, "_apply", &meth_parser__apply6687, 0);
  int argcv_meth_parser__apply6687[] = {0};
  meth_meth_parser__apply6687->type = alloc_MethodType(1, argcv_meth_parser__apply6687);
  meth_meth_parser__apply6687->definitionModule = modulename;
  meth_meth_parser__apply6687->definitionLine = 2089;
// compiled block node returning block6686 (depth = 5)
  gc_frame_newslot(block6686);
// call case 4: self request
  params[0] = block6686;
  partcv[0] = 1;
  Object call6691 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6685);
// compiled call node returning call6691 (depth = 4)
  gc_frame_end(frame);
  return call6691;
}
Object meth_parser__apply6694(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_args = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6695 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6697 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6696);
// compiled call node returning call6697 (depth = 6)
// compiled member node returning call6697 (depth = 5)
  gc_frame_newslot(call6697);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_args (depth = 5)
  params[0] = call6697;
  partcv[0] = 1;
  Object call6698 = callmethod(*var_args, "add",
    1, partcv, params);
  gc_frame_end(callframe6695);
// compiled call node returning call6698 (depth = 4)
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6701 == NULL) {
    strlit6701 = alloc_String("comma");
    gc_root(strlit6701);
  }
// compiled string node returning strlit6701 (depth = 6)
  int op_slot_right_6700 = gc_frame_newslot(strlit6701);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6703 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6704 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6703);
// compiled call node returning call6704 (depth = 7)
// compiled member node returning call6704 (depth = 6)
  int op_slot_left_6700 = gc_frame_newslot(call6704);
  params[0] = strlit6701;
  partcv[0] = 1;
  Object opresult6705 = callmethod(call6704, "==", 1, partcv, params);
// compiled op node returning opresult6705 (depth = 5)
  Object if6699 = done;
  if (istrue(opresult6705)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6706 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6707 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6706);
// compiled call node returning call6707 (depth = 6)
// compiled member node returning call6707 (depth = 5)
    gc_frame_newslot(call6707);
    if6699 = call6707;
  } else {
  }
// compiled if node returning if6699 (depth = 4)
  gc_frame_end(frame);
  return if6699;
}
Object meth_parser_typeArgs6668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeArgs (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeArgs");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_startToken = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startToken");
  Object *var_args = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "args");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6669 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6670 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6671 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6670);
// compiled call node returning call6671 (depth = 6)
// compiled member node returning call6671 (depth = 5)
  partcv[0] = 0;
  Object call6672 = callmethod(call6671, "empty",
    1, partcv, params);
  gc_frame_end(callframe6669);
// compiled call node returning call6672 (depth = 4)
// compiled member node returning call6672 (depth = 3)
  *var_args = call6672;
  if (call6672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6675 == NULL) {
    strlit6675 = alloc_String("lgeneric");
    gc_root(strlit6675);
  }
// compiled string node returning strlit6675 (depth = 4)
  int op_slot_right_6674 = gc_frame_newslot(strlit6675);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6677 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6678 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6677);
// compiled call node returning call6678 (depth = 5)
// compiled member node returning call6678 (depth = 4)
  int op_slot_left_6674 = gc_frame_newslot(call6678);
  params[0] = strlit6675;
  partcv[0] = 1;
  Object opresult6679 = callmethod(call6678, "!=", 1, partcv, params);
// compiled op node returning opresult6679 (depth = 3)
  Object if6673 = done;
  if (istrue(opresult6679)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_args (depth = 4)
  return *var_args;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6673 = undefined;
  } else {
  }
// compiled if node returning if6673 (depth = 2)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6680 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6681 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6680);
// compiled call node returning call6681 (depth = 3)
// compiled member node returning call6681 (depth = 2)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6682 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6683 = alloc_Block(NULL, NULL, "parser", 2090);
  gc_frame_newslot(block6683);
// method _apply
  block_savedest(block6683);
  Object closure6684 = createclosure(1, "_apply");
  setclosureframe(closure6684, stackframe);
  addtoclosure(closure6684, selfslot);
  struct UserObject *uo6684 = (struct UserObject*)block6683;
  uo6684->data[0] = (Object)closure6684;
  Method *meth_meth_parser__apply6684 = addmethod2pos(block6683, "_apply", &meth_parser__apply6684, 0);
  int argcv_meth_parser__apply6684[] = {0};
  meth_meth_parser__apply6684->type = alloc_MethodType(1, argcv_meth_parser__apply6684);
  meth_meth_parser__apply6684->definitionModule = modulename;
  meth_meth_parser__apply6684->definitionLine = 2089;
// compiled block node returning block6683 (depth = 3)
  gc_frame_newslot(block6683);
// starting to compile block node (depth = 3)
  Object block6693 = alloc_Block(NULL, NULL, "parser", 2090);
  gc_frame_newslot(block6693);
// method _apply
  block_savedest(block6693);
  Object closure6694 = createclosure(4, "_apply");
  setclosureframe(closure6694, stackframe);
  addtoclosure(closure6694, var_values);
  addtoclosure(closure6694, var_args);
  addtoclosure(closure6694, var_sym);
  addtoclosure(closure6694, selfslot);
  struct UserObject *uo6694 = (struct UserObject*)block6693;
  uo6694->data[0] = (Object)closure6694;
  Method *meth_meth_parser__apply6694 = addmethod2pos(block6693, "_apply", &meth_parser__apply6694, 0);
  int argcv_meth_parser__apply6694[] = {0};
  meth_meth_parser__apply6694->type = alloc_MethodType(1, argcv_meth_parser__apply6694);
  meth_meth_parser__apply6694->definitionModule = modulename;
  meth_meth_parser__apply6694->definitionLine = 2090;
// compiled block node returning block6693 (depth = 3)
  gc_frame_newslot(block6693);
// call case 5: prelude request
  params[0] = block6683;
  params[1] = block6693;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6709 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6682);
// compiled call node returning call6709 (depth = 2)
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6712 == NULL) {
    strlit6712 = alloc_String("rgeneric");
    gc_root(strlit6712);
  }
// compiled string node returning strlit6712 (depth = 4)
  int op_slot_right_6711 = gc_frame_newslot(strlit6712);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6714 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6715 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6714);
// compiled call node returning call6715 (depth = 5)
// compiled member node returning call6715 (depth = 4)
  int op_slot_left_6711 = gc_frame_newslot(call6715);
  params[0] = strlit6712;
  partcv[0] = 1;
  Object opresult6716 = callmethod(call6715, "!=", 1, partcv, params);
// compiled op node returning opresult6716 (depth = 3)
  Object if6710 = done;
  if (istrue(opresult6716)) {
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6717 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6719 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6718);
// compiled call node returning call6719 (depth = 7)
// compiled member node returning call6719 (depth = 6)
  partcv[0] = 0;
  Object call6720 = callmethod(call6719, "new",
    1, partcv, params);
  gc_frame_end(callframe6717);
// compiled call node returning call6720 (depth = 5)
// compiled member node returning call6720 (depth = 4)
  *var_suggestion = call6720;
  if (call6720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6721 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6722 == NULL) {
    strlit6722 = alloc_String(">");
    gc_root(strlit6722);
  }
// compiled string node returning strlit6722 (depth = 4)
  gc_frame_newslot(strlit6722);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6722;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6723 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6721);
// compiled call node returning call6723 (depth = 3)
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6724 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6726 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6725);
// compiled call node returning call6726 (depth = 7)
// compiled member node returning call6726 (depth = 6)
  partcv[0] = 0;
  Object call6727 = callmethod(call6726, "new",
    1, partcv, params);
  gc_frame_end(callframe6724);
// compiled call node returning call6727 (depth = 5)
// compiled member node returning call6727 (depth = 4)
  *var_suggestion2 = call6727;
  if (call6727 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6728 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6729 == NULL) {
    strlit6729 = alloc_String(" ");
    gc_root(strlit6729);
  }
// compiled string node returning strlit6729 (depth = 4)
  gc_frame_newslot(strlit6729);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startToken (depth = 4)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion2 (depth = 4)
  params[0] = strlit6729;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6730 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe6728);
// compiled call node returning call6730 (depth = 3)
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6731 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array6731, "push", 1, partcv, params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array6731, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array6731 (depth = 4)
  *var_suggestions = array6731;
  if (array6731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6732 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6734 == NULL) {
    strlit6734 = alloc_String("If '<' is intended as an operator, precede it by a space.");
    gc_root(strlit6734);
  }
// compiled string node returning strlit6734 (depth = 5)
  int op_slot_right_6733 = gc_frame_newslot(strlit6734);
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6736 == NULL) {
    strlit6736 = alloc_String("A method request containing a '<' must have a matching '>'. ");
    gc_root(strlit6736);
  }
// compiled string node returning strlit6736 (depth = 5)
  int op_slot_left_6733 = gc_frame_newslot(strlit6736);
  params[0] = strlit6734;
  partcv[0] = 1;
  Object opresult6737 = callmethod(strlit6736, "++", 1, partcv, params);
// compiled op node returning opresult6737 (depth = 4)
  gc_frame_newslot(opresult6737);
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6738 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6739 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6738);
// compiled call node returning call6739 (depth = 5)
// compiled member node returning call6739 (depth = 4)
  gc_frame_newslot(call6739);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6741 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6742 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6741);
// compiled call node returning call6742 (depth = 6)
// compiled member node returning call6742 (depth = 5)
  int op_slot_right_6740 = gc_frame_newslot(call6742);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6745 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6744);
// compiled call node returning call6745 (depth = 6)
// compiled member node returning call6745 (depth = 5)
  int op_slot_left_6740 = gc_frame_newslot(call6745);
  params[0] = call6742;
  partcv[0] = 1;
  Object sum6746 = callmethod(call6745, "+", 1, partcv, params);
// compiled op node returning sum6746 (depth = 4)
  gc_frame_newslot(sum6746);
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6737;
  params[1] = call6739;
  params[2] = sum6746;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6747 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6732);
// compiled call node returning call6747 (depth = 3)
    gc_frame_newslot(call6747);
    if6710 = call6747;
  } else {
  }
// compiled if node returning if6710 (depth = 2)
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6749 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6748);
// compiled call node returning call6749 (depth = 3)
// compiled member node returning call6749 (depth = 2)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_args (depth = 3)
  return *var_args;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply6777(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6778 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6779 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6778);
// compiled call node returning call6779 (depth = 7)
// compiled member node returning call6779 (depth = 6)
  gc_frame_end(frame);
  return call6779;
}
Object meth_parser_typeArg6750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeArg (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeArg");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6752 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6753 == NULL) {
    strlit6753 = alloc_String("identifier");
    gc_root(strlit6753);
  }
// compiled string node returning strlit6753 (depth = 4)
  gc_frame_newslot(strlit6753);
// call case 4: self request
  params[0] = strlit6753;
  partcv[0] = 1;
  Object call6754 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6752);
// compiled call node returning call6754 (depth = 3)
  Object if6751 = done;
  if (istrue(call6754)) {
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6755 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6756 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6755);
// compiled call node returning call6756 (depth = 4)
// compiled member node returning call6756 (depth = 3)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6759 == NULL) {
    strlit6759 = alloc_String("lgeneric");
    gc_root(strlit6759);
  }
// compiled string node returning strlit6759 (depth = 5)
  int op_slot_right_6758 = gc_frame_newslot(strlit6759);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6761 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6762 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6761);
// compiled call node returning call6762 (depth = 6)
// compiled member node returning call6762 (depth = 5)
  int op_slot_left_6758 = gc_frame_newslot(call6762);
  params[0] = strlit6759;
  partcv[0] = 1;
  Object opresult6763 = callmethod(call6762, "==", 1, partcv, params);
// compiled op node returning opresult6763 (depth = 4)
  Object if6757 = done;
  if (istrue(opresult6763)) {
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6764 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe6765 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6767 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6766);
// compiled call node returning call6767 (depth = 7)
// compiled member node returning call6767 (depth = 6)
  gc_frame_newslot(call6767);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6768 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6769 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6768);
// compiled call node returning call6769 (depth = 7)
// compiled member node returning call6769 (depth = 6)
  gc_frame_newslot(call6769);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6770 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call6771 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe6770);
// compiled call node returning call6771 (depth = 7)
// compiled member node returning call6771 (depth = 6)
  params[0] = call6767;
  params[1] = call6769;
  partcv[0] = 2;
  Object call6772 = callmethod(call6771, "new",
    1, partcv, params);
  gc_frame_end(callframe6765);
// compiled call node returning call6772 (depth = 5)
  gc_frame_newslot(call6772);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = call6772;
  partcv[0] = 1;
  Object call6773 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6764);
// compiled call node returning call6773 (depth = 4)
    gc_frame_newslot(call6773);
    if6757 = call6773;
  } else {
  }
// compiled if node returning if6757 (depth = 3)
    gc_frame_newslot(if6757);
    if6751 = if6757;
  } else {
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6775 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6776 = alloc_Block(NULL, NULL, "parser", 2120);
  gc_frame_newslot(block6776);
// method _apply
  block_savedest(block6776);
  Object closure6777 = createclosure(1, "_apply");
  setclosureframe(closure6777, stackframe);
  addtoclosure(closure6777, selfslot);
  struct UserObject *uo6777 = (struct UserObject*)block6776;
  uo6777->data[0] = (Object)closure6777;
  Method *meth_meth_parser__apply6777 = addmethod2pos(block6776, "_apply", &meth_parser__apply6777, 0);
  int argcv_meth_parser__apply6777[] = {0};
  meth_meth_parser__apply6777->type = alloc_MethodType(1, argcv_meth_parser__apply6777);
  meth_meth_parser__apply6777->definitionModule = modulename;
  meth_meth_parser__apply6777->definitionLine = 2116;
// compiled block node returning block6776 (depth = 5)
  gc_frame_newslot(block6776);
// call case 4: self request
  params[0] = block6776;
  partcv[0] = 1;
  Object call6781 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6775);
// compiled call node returning call6781 (depth = 4)
  Object if6774 = done;
  if (istrue(call6781)) {
    gc_frame_newslot(done);
    if6774 = done;
  } else {
  }
// compiled if node returning if6774 (depth = 3)
    gc_frame_newslot(if6774);
    if6751 = if6774;
  }
// compiled if node returning if6751 (depth = 2)
  gc_frame_end(frame);
  return if6751;
}
Object meth_parser__apply6789(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6791 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6792 == NULL) {
    strlit6792 = alloc_String("identifier");
    gc_root(strlit6792);
  }
// compiled string node returning strlit6792 (depth = 6)
  gc_frame_newslot(strlit6792);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = strlit6792;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6793 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6791);
// compiled call node returning call6793 (depth = 5)
  int op_slot_right_6790 = gc_frame_newslot(call6793);
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6795 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6796 == NULL) {
    strlit6796 = alloc_String("identifier");
    gc_root(strlit6796);
  }
// compiled string node returning strlit6796 (depth = 6)
  gc_frame_newslot(strlit6796);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6796;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6797 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6795);
// compiled call node returning call6797 (depth = 5)
  int op_slot_left_6790 = gc_frame_newslot(call6797);
  params[0] = call6793;
  partcv[0] = 1;
  Object opresult6798 = callmethod(call6797, "||", 1, partcv, params);
// compiled op node returning opresult6798 (depth = 4)
  gc_frame_end(frame);
  return opresult6798;
}
Object meth_parser__apply7021(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe7022 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7023 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7022);
// compiled call node returning call7023 (depth = 11)
  gc_frame_end(frame);
  return call7023;
}
Object meth_parser__apply7076(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe7077 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7078 == NULL) {
    strlit7078 = alloc_String("comma");
    gc_root(strlit7078);
  }
// compiled string node returning strlit7078 (depth = 8)
  gc_frame_newslot(strlit7078);
// call case 4: self request
  params[0] = strlit7078;
  partcv[0] = 1;
  Object call7079 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7077);
// compiled call node returning call7079 (depth = 7)
  gc_frame_end(frame);
  return call7079;
}
Object meth_parser__apply7096(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe7097 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7098 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7097);
// compiled call node returning call7098 (depth = 12)
  gc_frame_end(frame);
  return call7098;
}
Object meth_parser__apply7082(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_nxt = getfromclosure(closure, 1);
  Object *var_part = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call7084 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7083);
// compiled call node returning call7084 (depth = 9)
// compiled member node returning call7084 (depth = 8)
  *var_nxt = call7084;
  if (call7084 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7086 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call7088 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe7087);
// compiled call node returning call7088 (depth = 9)
// compiled member node returning call7088 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call7089 = callmethod(call7088, "push",
    1, partcv, params);
  gc_frame_end(callframe7086);
// compiled call node returning call7089 (depth = 7)
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7090 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7091 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7090);
// compiled call node returning call7091 (depth = 8)
// compiled member node returning call7091 (depth = 7)
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7093 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe7094 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block7095 = alloc_Block(NULL, NULL, "parser", 2215);
  gc_frame_newslot(block7095);
// method _apply
  block_savedest(block7095);
  Object closure7096 = createclosure(2, "_apply");
  setclosureframe(closure7096, stackframe);
  addtoclosure(closure7096, var_blocksOK);
  addtoclosure(closure7096, selfslot);
  struct UserObject *uo7096 = (struct UserObject*)block7095;
  uo7096->data[0] = (Object)closure7096;
  Method *meth_meth_parser__apply7096 = addmethod2pos(block7095, "_apply", &meth_parser__apply7096, 0);
  int argcv_meth_parser__apply7096[] = {0};
  meth_meth_parser__apply7096->type = alloc_MethodType(1, argcv_meth_parser__apply7096);
  meth_meth_parser__apply7096->definitionModule = modulename;
  meth_meth_parser__apply7096->definitionLine = 2215;
// compiled block node returning block7095 (depth = 11)
  gc_frame_newslot(block7095);
// call case 4: self request
  params[0] = block7095;
  partcv[0] = 1;
  Object call7100 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7094);
// compiled call node returning call7100 (depth = 10)
  partcv[0] = 0;
  Object call7101 = callmethod(call7100, "not",
    1, partcv, params);
  gc_frame_end(callframe7093);
// compiled call node returning call7101 (depth = 9)
// compiled member node returning call7101 (depth = 8)
  Object if7092 = done;
  if (istrue(call7101)) {
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7102 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7103 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7104 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7103);
// compiled call node returning call7104 (depth = 12)
// compiled member node returning call7104 (depth = 11)
  partcv[0] = 0;
  Object call7105 = callmethod(call7104, "empty",
    1, partcv, params);
  gc_frame_end(callframe7102);
// compiled call node returning call7105 (depth = 10)
// compiled member node returning call7105 (depth = 9)
  *var_suggestions = call7105;
  if (call7105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7106 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7108 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7107);
// compiled call node returning call7108 (depth = 12)
// compiled member node returning call7108 (depth = 11)
  partcv[0] = 0;
  Object call7109 = callmethod(call7108, "new",
    1, partcv, params);
  gc_frame_end(callframe7106);
// compiled call node returning call7109 (depth = 10)
// compiled member node returning call7109 (depth = 9)
  *var_suggestion = call7109;
  if (call7109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7110 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7111 == NULL) {
    strlit7111 = alloc_String("rparen");
    gc_root(strlit7111);
  }
// compiled string node returning strlit7111 (depth = 10)
  gc_frame_newslot(strlit7111);
// call case 4: self request
  params[0] = strlit7111;
  partcv[0] = 1;
  Object call7112 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7110);
// compiled call node returning call7112 (depth = 9)
  *var_nextTok = call7112;
  if (call7112 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_7114 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_7114 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7116 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7116 (depth = 9)
  Object if7113 = done;
  if (istrue(opresult7116)) {
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7117 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7118 == NULL) {
    strlit7118 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7118);
  }
// compiled string node returning strlit7118 (depth = 10)
  gc_frame_newslot(strlit7118);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit7118;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7119 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7117);
// compiled call node returning call7119 (depth = 9)
    gc_frame_newslot(call7119);
    if7113 = call7119;
  } else {
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7120 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7121 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call7122 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7121);
// compiled call node returning call7122 (depth = 11)
// compiled member node returning call7122 (depth = 10)
  gc_frame_newslot(call7122);
// starting to compile identifier node (depth = 10)
  Object bool7123 = alloc_Boolean(1);
// compiled identifier node returning bool7123 (depth = 10)
  gc_frame_newslot(bool7123);
// starting to compile identifier node (depth = 10)
  Object bool7124 = alloc_Boolean(0);
// compiled identifier node returning bool7124 (depth = 10)
  gc_frame_newslot(bool7124);
// starting to compile string node (depth = 10)
  if (strlit7125 == NULL) {
    strlit7125 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7125);
  }
// compiled string node returning strlit7125 (depth = 10)
  gc_frame_newslot(strlit7125);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call7122;
  params[2] = bool7123;
  params[3] = bool7124;
  params[4] = strlit7125;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7126 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7120);
// compiled call node returning call7126 (depth = 9)
    gc_frame_newslot(call7126);
    if7113 = call7126;
  }
// compiled if node returning if7113 (depth = 8)
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7127 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7128 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7127);
// compiled call node returning call7128 (depth = 8)
// Begin line 2225
  setline(2225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7129 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7131 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7130);
// compiled call node returning call7131 (depth = 12)
// compiled member node returning call7131 (depth = 11)
  partcv[0] = 0;
  Object call7132 = callmethod(call7131, "new",
    1, partcv, params);
  gc_frame_end(callframe7129);
// compiled call node returning call7132 (depth = 10)
// compiled member node returning call7132 (depth = 9)
  *var_suggestion = call7132;
  if (call7132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7134 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7135 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7136 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7135);
// compiled call node returning call7136 (depth = 10)
// compiled member node returning call7136 (depth = 9)
  gc_frame_newslot(call7136);
// starting to compile identifier node (depth = 9)
  Object bool7137 = alloc_Boolean(1);
// compiled identifier node returning bool7137 (depth = 9)
  gc_frame_newslot(bool7137);
// starting to compile identifier node (depth = 9)
  Object bool7138 = alloc_Boolean(0);
// compiled identifier node returning bool7138 (depth = 9)
  gc_frame_newslot(bool7138);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call7136;
  params[2] = bool7137;
  params[3] = bool7138;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7139 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7134);
// compiled call node returning call7139 (depth = 8)
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7140 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7141 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7140);
// compiled call node returning call7141 (depth = 8)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7142 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7143 == NULL) {
    strlit7143 = alloc_String("A method request must have an expression after a ','.");
    gc_root(strlit7143);
  }
// compiled string node returning strlit7143 (depth = 9)
  gc_frame_newslot(strlit7143);
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7144 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7145 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7144);
// compiled call node returning call7145 (depth = 10)
// compiled member node returning call7145 (depth = 9)
  gc_frame_newslot(call7145);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7147 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7146);
// compiled call node returning call7147 (depth = 10)
// compiled member node returning call7147 (depth = 9)
  gc_frame_newslot(call7147);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7143;
  params[1] = call7145;
  params[2] = call7147;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7148 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7142);
// compiled call node returning call7148 (depth = 8)
    gc_frame_newslot(call7148);
    if7092 = call7148;
  } else {
  }
// compiled if node returning if7092 (depth = 7)
  gc_frame_end(frame);
  return if7092;
}
Object meth_parser__apply6801(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_signature = getfromclosure(closure, 2);
  Object *var_methname = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_nxt = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_sym = getfromclosure(closure, 7);
  Object *var_lastToken = getfromclosure(closure, 8);
  Object *var_tok = getfromclosure(closure, 9);
  Object *var_blocksOK = getfromclosure(closure, 10);
  Object self = *(getfromclosure(closure, 11));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isTerm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "isTerm");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_isEmpty = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isEmpty");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6802 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call6804 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe6803);
// compiled call node returning call6804 (depth = 8)
// compiled member node returning call6804 (depth = 7)
  partcv[0] = 0;
  Object call6805 = callmethod(call6804, "new",
    1, partcv, params);
  gc_frame_end(callframe6802);
// compiled call node returning call6805 (depth = 6)
// compiled member node returning call6805 (depth = 5)
  *var_part = call6805;
  if (call6805 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6807 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6808 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe6807);
// compiled call node returning call6808 (depth = 4)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6810 == NULL) {
    strlit6810 = alloc_String("()");
    gc_root(strlit6810);
  }
// compiled string node returning strlit6810 (depth = 6)
  int op_slot_right_6809 = gc_frame_newslot(strlit6810);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6809 = gc_frame_newslot(*var_methname);
  params[0] = strlit6810;
  partcv[0] = 1;
  Object opresult6812 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6812 (depth = 5)
  *var_methname = opresult6812;
  if (opresult6812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6815 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6814);
// compiled call node returning call6815 (depth = 5)
// compiled member node returning call6815 (depth = 4)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6816 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6817 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6816);
// compiled call node returning call6817 (depth = 6)
// compiled member node returning call6817 (depth = 5)
  *var_nxt = call6817;
  if (call6817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call6821 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6820);
// compiled call node returning call6821 (depth = 7)
// compiled member node returning call6821 (depth = 6)
  int op_slot_right_6819 = gc_frame_newslot(call6821);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6819 = gc_frame_newslot(*var_methname);
  params[0] = call6821;
  partcv[0] = 1;
  Object opresult6823 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6823 (depth = 5)
  *var_methname = opresult6823;
  if (opresult6823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6825 = gc_frame_new();
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call6827 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6826);
// compiled call node returning call6827 (depth = 7)
// compiled member node returning call6827 (depth = 6)
  gc_frame_newslot(call6827);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = call6827;
  partcv[0] = 1;
  Object call6828 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6825);
// compiled call node returning call6828 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6829 = alloc_Boolean(0);
// compiled identifier node returning bool6829 (depth = 5)
  *var_isTerm = bool6829;
  if (bool6829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6832 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe6833 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6834 == NULL) {
    strlit6834 = alloc_String("num");
    gc_root(strlit6834);
  }
// compiled string node returning strlit6834 (depth = 9)
  gc_frame_newslot(strlit6834);
// call case 4: self request
  params[0] = strlit6834;
  partcv[0] = 1;
  Object call6835 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6833);
// compiled call node returning call6835 (depth = 8)
  partcv[0] = 0;
  Object call6836 = callmethod(call6835, "not",
    1, partcv, params);
  gc_frame_end(callframe6832);
// compiled call node returning call6836 (depth = 7)
// compiled member node returning call6836 (depth = 6)
  int op_slot_right_6831 = gc_frame_newslot(call6836);
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6839 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6840 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6841 == NULL) {
    strlit6841 = alloc_String("string");
    gc_root(strlit6841);
  }
// compiled string node returning strlit6841 (depth = 10)
  gc_frame_newslot(strlit6841);
// call case 4: self request
  params[0] = strlit6841;
  partcv[0] = 1;
  Object call6842 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6840);
// compiled call node returning call6842 (depth = 9)
  partcv[0] = 0;
  Object call6843 = callmethod(call6842, "not",
    1, partcv, params);
  gc_frame_end(callframe6839);
// compiled call node returning call6843 (depth = 8)
// compiled member node returning call6843 (depth = 7)
  int op_slot_right_6838 = gc_frame_newslot(call6843);
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6846 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6847 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit6848 == NULL) {
    strlit6848 = alloc_String("lbrace");
    gc_root(strlit6848);
  }
// compiled string node returning strlit6848 (depth = 11)
  gc_frame_newslot(strlit6848);
// call case 4: self request
  params[0] = strlit6848;
  partcv[0] = 1;
  Object call6849 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6847);
// compiled call node returning call6849 (depth = 10)
  partcv[0] = 0;
  Object call6850 = callmethod(call6849, "not",
    1, partcv, params);
  gc_frame_end(callframe6846);
// compiled call node returning call6850 (depth = 9)
// compiled member node returning call6850 (depth = 8)
  int op_slot_right_6845 = gc_frame_newslot(call6850);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6852 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6853 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit6854 == NULL) {
    strlit6854 = alloc_String("lparen");
    gc_root(strlit6854);
  }
// compiled string node returning strlit6854 (depth = 11)
  gc_frame_newslot(strlit6854);
// call case 4: self request
  params[0] = strlit6854;
  partcv[0] = 1;
  Object call6855 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6853);
// compiled call node returning call6855 (depth = 10)
  partcv[0] = 0;
  Object call6856 = callmethod(call6855, "not",
    1, partcv, params);
  gc_frame_end(callframe6852);
// compiled call node returning call6856 (depth = 9)
// compiled member node returning call6856 (depth = 8)
  int op_slot_left_6845 = gc_frame_newslot(call6856);
  params[0] = call6850;
  partcv[0] = 1;
  Object opresult6857 = callmethod(call6856, "&&", 1, partcv, params);
// compiled op node returning opresult6857 (depth = 7)
  int op_slot_left_6838 = gc_frame_newslot(opresult6857);
  params[0] = call6843;
  partcv[0] = 1;
  Object opresult6858 = callmethod(opresult6857, "&&", 1, partcv, params);
// compiled op node returning opresult6858 (depth = 6)
  int op_slot_left_6831 = gc_frame_newslot(opresult6858);
  params[0] = call6836;
  partcv[0] = 1;
  Object opresult6859 = callmethod(opresult6858, "&&", 1, partcv, params);
// compiled op node returning opresult6859 (depth = 5)
  Object if6830 = done;
  if (istrue(opresult6859)) {
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6860 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6862 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6861);
// compiled call node returning call6862 (depth = 9)
// compiled member node returning call6862 (depth = 8)
  partcv[0] = 0;
  Object call6863 = callmethod(call6862, "new",
    1, partcv, params);
  gc_frame_end(callframe6860);
// compiled call node returning call6863 (depth = 7)
// compiled member node returning call6863 (depth = 6)
  *var_suggestion = call6863;
  if (call6863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6866 == NULL) {
    strlit6866 = alloc_String("identifier");
    gc_root(strlit6866);
  }
// compiled string node returning strlit6866 (depth = 7)
  int op_slot_right_6865 = gc_frame_newslot(strlit6866);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6869 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6868);
// compiled call node returning call6869 (depth = 8)
// compiled member node returning call6869 (depth = 7)
  int op_slot_left_6865 = gc_frame_newslot(call6869);
  params[0] = strlit6866;
  partcv[0] = 1;
  Object opresult6870 = callmethod(call6869, "==", 1, partcv, params);
// compiled op node returning opresult6870 (depth = 6)
  Object if6864 = done;
  if (istrue(opresult6870)) {
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6871 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool6872 = alloc_Boolean(1);
// compiled identifier node returning bool6872 (depth = 7)
  gc_frame_newslot(bool6872);
// starting to compile identifier node (depth = 7)
  Object bool6873 = alloc_Boolean(0);
// compiled identifier node returning bool6873 (depth = 7)
  gc_frame_newslot(bool6873);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6875 == NULL) {
    strlit6875 = alloc_String(")");
    gc_root(strlit6875);
  }
// compiled string node returning strlit6875 (depth = 8)
  int op_slot_right_6874 = gc_frame_newslot(strlit6875);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6878 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6879 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6878);
// compiled call node returning call6879 (depth = 10)
// compiled member node returning call6879 (depth = 9)
  int op_slot_right_6877 = gc_frame_newslot(call6879);
// starting to compile string node (depth = 9)
  if (strlit6881 == NULL) {
    strlit6881 = alloc_String("(");
    gc_root(strlit6881);
  }
// compiled string node returning strlit6881 (depth = 9)
  int op_slot_left_6877 = gc_frame_newslot(strlit6881);
  params[0] = call6879;
  partcv[0] = 1;
  Object opresult6882 = callmethod(strlit6881, "++", 1, partcv, params);
// compiled op node returning opresult6882 (depth = 8)
  int op_slot_left_6874 = gc_frame_newslot(opresult6882);
  params[0] = strlit6875;
  partcv[0] = 1;
  Object opresult6883 = callmethod(opresult6882, "++", 1, partcv, params);
// compiled op node returning opresult6883 (depth = 7)
  gc_frame_newslot(opresult6883);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool6872;
  params[2] = bool6873;
  params[3] = opresult6883;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6884 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6871);
// compiled call node returning call6884 (depth = 6)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6887 == NULL) {
    strlit6887 = alloc_String("while()do");
    gc_root(strlit6887);
  }
// compiled string node returning strlit6887 (depth = 8)
  int op_slot_right_6886 = gc_frame_newslot(strlit6887);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methname (depth = 8)
  int op_slot_left_6886 = gc_frame_newslot(*var_methname);
  params[0] = strlit6887;
  partcv[0] = 1;
  Object opresult6889 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6889 (depth = 7)
  Object if6885 = done;
  if (istrue(opresult6889)) {
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6890 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6891 == NULL) {
    strlit6891 = alloc_String("A while loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6891);
  }
// compiled string node returning strlit6891 (depth = 8)
  gc_frame_newslot(strlit6891);
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6892 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6893 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6892);
// compiled call node returning call6893 (depth = 9)
// compiled member node returning call6893 (depth = 8)
  gc_frame_newslot(call6893);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6895 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6894);
// compiled call node returning call6895 (depth = 9)
// compiled member node returning call6895 (depth = 8)
  gc_frame_newslot(call6895);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6891;
  params[1] = call6893;
  params[2] = call6895;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6896 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6890);
// compiled call node returning call6896 (depth = 7)
    gc_frame_newslot(call6896);
    if6885 = call6896;
  } else {
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6899 == NULL) {
    strlit6899 = alloc_String("for()do");
    gc_root(strlit6899);
  }
// compiled string node returning strlit6899 (depth = 9)
  int op_slot_right_6898 = gc_frame_newslot(strlit6899);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6898 = gc_frame_newslot(*var_methname);
  params[0] = strlit6899;
  partcv[0] = 1;
  Object opresult6901 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6901 (depth = 8)
  Object if6897 = done;
  if (istrue(opresult6901)) {
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6902 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6903 == NULL) {
    strlit6903 = alloc_String("A for loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6903);
  }
// compiled string node returning strlit6903 (depth = 9)
  gc_frame_newslot(strlit6903);
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6904 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6905 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6904);
// compiled call node returning call6905 (depth = 10)
// compiled member node returning call6905 (depth = 9)
  gc_frame_newslot(call6905);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6906 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6907 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6906);
// compiled call node returning call6907 (depth = 10)
// compiled member node returning call6907 (depth = 9)
  gc_frame_newslot(call6907);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6903;
  params[1] = call6905;
  params[2] = call6907;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6908 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6902);
// compiled call node returning call6908 (depth = 8)
    gc_frame_newslot(call6908);
    if6897 = call6908;
  } else {
  }
// compiled if node returning if6897 (depth = 7)
    gc_frame_newslot(if6897);
    if6885 = if6897;
  }
// compiled if node returning if6885 (depth = 6)
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6909 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6910 == NULL) {
    strlit6910 = alloc_String("Each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.");
    gc_root(strlit6910);
  }
// compiled string node returning strlit6910 (depth = 7)
  gc_frame_newslot(strlit6910);
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6912 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6911);
// compiled call node returning call6912 (depth = 8)
// compiled member node returning call6912 (depth = 7)
  gc_frame_newslot(call6912);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6914 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6913);
// compiled call node returning call6914 (depth = 8)
// compiled member node returning call6914 (depth = 7)
  gc_frame_newslot(call6914);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6910;
  params[1] = call6912;
  params[2] = call6914;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6915 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6909);
// compiled call node returning call6915 (depth = 6)
    gc_frame_newslot(call6915);
    if6864 = call6915;
  } else {
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6918 == NULL) {
    strlit6918 = alloc_String("while()do");
    gc_root(strlit6918);
  }
// compiled string node returning strlit6918 (depth = 8)
  int op_slot_right_6917 = gc_frame_newslot(strlit6918);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methname (depth = 8)
  int op_slot_left_6917 = gc_frame_newslot(*var_methname);
  params[0] = strlit6918;
  partcv[0] = 1;
  Object opresult6920 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6920 (depth = 7)
  Object if6916 = done;
  if (istrue(opresult6920)) {
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6921 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6922 == NULL) {
    strlit6922 = alloc_String(" {}");
    gc_root(strlit6922);
  }
// compiled string node returning strlit6922 (depth = 8)
  gc_frame_newslot(strlit6922);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit6922;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6923 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6921);
// compiled call node returning call6923 (depth = 7)
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6924 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6925 == NULL) {
    strlit6925 = alloc_String("A while loop must have a body.");
    gc_root(strlit6925);
  }
// compiled string node returning strlit6925 (depth = 8)
  gc_frame_newslot(strlit6925);
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6926 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6927 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6926);
// compiled call node returning call6927 (depth = 9)
// compiled member node returning call6927 (depth = 8)
  gc_frame_newslot(call6927);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6929 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6928);
// compiled call node returning call6929 (depth = 9)
// compiled member node returning call6929 (depth = 8)
  gc_frame_newslot(call6929);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6925;
  params[1] = call6927;
  params[2] = call6929;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6930 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6924);
// compiled call node returning call6930 (depth = 7)
    gc_frame_newslot(call6930);
    if6916 = call6930;
  } else {
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6933 == NULL) {
    strlit6933 = alloc_String("for()do");
    gc_root(strlit6933);
  }
// compiled string node returning strlit6933 (depth = 9)
  int op_slot_right_6932 = gc_frame_newslot(strlit6933);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6932 = gc_frame_newslot(*var_methname);
  params[0] = strlit6933;
  partcv[0] = 1;
  Object opresult6935 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6935 (depth = 8)
  Object if6931 = done;
  if (istrue(opresult6935)) {
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6936 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6937 == NULL) {
    strlit6937 = alloc_String(" {}");
    gc_root(strlit6937);
  }
// compiled string node returning strlit6937 (depth = 9)
  gc_frame_newslot(strlit6937);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6937;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6938 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6936);
// compiled call node returning call6938 (depth = 8)
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6939 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6940 == NULL) {
    strlit6940 = alloc_String("A for loop must have a body.");
    gc_root(strlit6940);
  }
// compiled string node returning strlit6940 (depth = 9)
  gc_frame_newslot(strlit6940);
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6942 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6941);
// compiled call node returning call6942 (depth = 10)
// compiled member node returning call6942 (depth = 9)
  gc_frame_newslot(call6942);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6943 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6944 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6943);
// compiled call node returning call6944 (depth = 10)
// compiled member node returning call6944 (depth = 9)
  gc_frame_newslot(call6944);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6940;
  params[1] = call6942;
  params[2] = call6944;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6945 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6939);
// compiled call node returning call6945 (depth = 8)
    gc_frame_newslot(call6945);
    if6931 = call6945;
  } else {
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6946 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6947 == NULL) {
    strlit6947 = alloc_String("()");
    gc_root(strlit6947);
  }
// compiled string node returning strlit6947 (depth = 9)
  gc_frame_newslot(strlit6947);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6947;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6948 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6946);
// compiled call node returning call6948 (depth = 8)
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6949 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6950 == NULL) {
    strlit6950 = alloc_String("A multi-part method request must end with '()'.");
    gc_root(strlit6950);
  }
// compiled string node returning strlit6950 (depth = 9)
  gc_frame_newslot(strlit6950);
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6952 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6951);
// compiled call node returning call6952 (depth = 10)
// compiled member node returning call6952 (depth = 9)
  gc_frame_newslot(call6952);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6953 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6954 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6953);
// compiled call node returning call6954 (depth = 10)
// compiled member node returning call6954 (depth = 9)
  gc_frame_newslot(call6954);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6950;
  params[1] = call6952;
  params[2] = call6954;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6955 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6949);
// compiled call node returning call6955 (depth = 8)
    gc_frame_newslot(call6955);
    if6931 = call6955;
  }
// compiled if node returning if6931 (depth = 7)
    gc_frame_newslot(if6931);
    if6916 = if6931;
  }
// compiled if node returning if6916 (depth = 6)
    gc_frame_newslot(if6916);
    if6864 = if6916;
  }
// compiled if node returning if6864 (depth = 5)
    gc_frame_newslot(if6864);
    if6830 = if6864;
  } else {
  }
// compiled if node returning if6830 (depth = 4)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6961 == NULL) {
    strlit6961 = alloc_String("false");
    gc_root(strlit6961);
  }
// compiled string node returning strlit6961 (depth = 9)
  int op_slot_right_6960 = gc_frame_newslot(strlit6961);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6964 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6963);
// compiled call node returning call6964 (depth = 10)
// compiled member node returning call6964 (depth = 9)
  int op_slot_left_6960 = gc_frame_newslot(call6964);
  params[0] = strlit6961;
  partcv[0] = 1;
  Object opresult6965 = callmethod(call6964, "==", 1, partcv, params);
// compiled op node returning opresult6965 (depth = 8)
  int op_slot_right_6959 = gc_frame_newslot(opresult6965);
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6968 == NULL) {
    strlit6968 = alloc_String("true");
    gc_root(strlit6968);
  }
// compiled string node returning strlit6968 (depth = 9)
  int op_slot_right_6967 = gc_frame_newslot(strlit6968);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6971 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6970);
// compiled call node returning call6971 (depth = 10)
// compiled member node returning call6971 (depth = 9)
  int op_slot_left_6967 = gc_frame_newslot(call6971);
  params[0] = strlit6968;
  partcv[0] = 1;
  Object opresult6972 = callmethod(call6971, "==", 1, partcv, params);
// compiled op node returning opresult6972 (depth = 8)
  int op_slot_left_6959 = gc_frame_newslot(opresult6972);
  params[0] = opresult6965;
  partcv[0] = 1;
  Object opresult6973 = callmethod(opresult6972, "||", 1, partcv, params);
// compiled op node returning opresult6973 (depth = 7)
  int op_slot_right_6958 = gc_frame_newslot(opresult6973);
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6975 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6976 == NULL) {
    strlit6976 = alloc_String("identifier");
    gc_root(strlit6976);
  }
// compiled string node returning strlit6976 (depth = 8)
  gc_frame_newslot(strlit6976);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6976;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6977 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6975);
// compiled call node returning call6977 (depth = 7)
  int op_slot_left_6958 = gc_frame_newslot(call6977);
  params[0] = opresult6973;
  partcv[0] = 1;
  Object opresult6978 = callmethod(call6977, "&&", 1, partcv, params);
// compiled op node returning opresult6978 (depth = 6)
  int op_slot_right_6957 = gc_frame_newslot(opresult6978);
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6981 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6982 == NULL) {
    strlit6982 = alloc_String("num");
    gc_root(strlit6982);
  }
// compiled string node returning strlit6982 (depth = 8)
  gc_frame_newslot(strlit6982);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6982;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6983 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6981);
// compiled call node returning call6983 (depth = 7)
  int op_slot_right_6980 = gc_frame_newslot(call6983);
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6986 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6987 == NULL) {
    strlit6987 = alloc_String("string");
    gc_root(strlit6987);
  }
// compiled string node returning strlit6987 (depth = 9)
  gc_frame_newslot(strlit6987);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6987;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6988 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6986);
// compiled call node returning call6988 (depth = 8)
  int op_slot_right_6985 = gc_frame_newslot(call6988);
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6990 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6991 == NULL) {
    strlit6991 = alloc_String("lbrace");
    gc_root(strlit6991);
  }
// compiled string node returning strlit6991 (depth = 9)
  gc_frame_newslot(strlit6991);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6991;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6992 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6990);
// compiled call node returning call6992 (depth = 8)
  int op_slot_left_6985 = gc_frame_newslot(call6992);
  params[0] = call6988;
  partcv[0] = 1;
  Object opresult6993 = callmethod(call6992, "||", 1, partcv, params);
// compiled op node returning opresult6993 (depth = 7)
  int op_slot_left_6980 = gc_frame_newslot(opresult6993);
  params[0] = call6983;
  partcv[0] = 1;
  Object opresult6994 = callmethod(opresult6993, "||", 1, partcv, params);
// compiled op node returning opresult6994 (depth = 6)
  int op_slot_left_6957 = gc_frame_newslot(opresult6994);
  params[0] = opresult6978;
  partcv[0] = 1;
  Object opresult6995 = callmethod(opresult6994, "||", 1, partcv, params);
// compiled op node returning opresult6995 (depth = 5)
  Object if6956 = done;
  if (istrue(opresult6995)) {
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6996 = alloc_Boolean(1);
// compiled identifier node returning bool6996 (depth = 6)
  *var_isTerm = bool6996;
  if (bool6996 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6956 = done;
  } else {
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6999 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6998);
// compiled call node returning call6999 (depth = 6)
// compiled member node returning call6999 (depth = 5)
    gc_frame_newslot(call6999);
    if6956 = call6999;
  }
// compiled if node returning if6956 (depth = 4)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7000 = alloc_Boolean(0);
// compiled identifier node returning bool7000 (depth = 5)
  *var_isEmpty = bool7000;
  if (bool7000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7002 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7003 == NULL) {
    strlit7003 = alloc_String("rparen");
    gc_root(strlit7003);
  }
// compiled string node returning strlit7003 (depth = 6)
  gc_frame_newslot(strlit7003);
// call case 4: self request
  params[0] = strlit7003;
  partcv[0] = 1;
  Object call7004 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7002);
// compiled call node returning call7004 (depth = 5)
  Object if7001 = done;
  if (istrue(call7004)) {
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7005 = alloc_Boolean(1);
// compiled identifier node returning bool7005 (depth = 6)
  *var_isEmpty = bool7005;
  if (bool7005 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7001 = done;
  } else {
  }
// compiled if node returning if7001 (depth = 4)
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isTerm (depth = 5)
  Object if7007 = done;
  if (istrue(*var_isTerm)) {
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7008 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7009 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7008);
// compiled call node returning call7009 (depth = 6)
// compiled member node returning call7009 (depth = 5)
    gc_frame_newslot(call7009);
    if7007 = call7009;
  } else {
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7012 == NULL) {
    strlit7012 = alloc_String("rparen");
    gc_root(strlit7012);
  }
// compiled string node returning strlit7012 (depth = 7)
  int op_slot_right_7011 = gc_frame_newslot(strlit7012);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7014 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7015 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7014);
// compiled call node returning call7015 (depth = 8)
// compiled member node returning call7015 (depth = 7)
  int op_slot_left_7011 = gc_frame_newslot(call7015);
  params[0] = strlit7012;
  partcv[0] = 1;
  Object opresult7016 = callmethod(call7015, "!=", 1, partcv, params);
// compiled op node returning opresult7016 (depth = 6)
  Object if7010 = done;
  if (istrue(opresult7016)) {
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7018 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe7019 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block7020 = alloc_Block(NULL, NULL, "parser", 2194);
  gc_frame_newslot(block7020);
// method _apply
  block_savedest(block7020);
  Object closure7021 = createclosure(2, "_apply");
  setclosureframe(closure7021, stackframe);
  addtoclosure(closure7021, var_blocksOK);
  addtoclosure(closure7021, selfslot);
  struct UserObject *uo7021 = (struct UserObject*)block7020;
  uo7021->data[0] = (Object)closure7021;
  Method *meth_meth_parser__apply7021 = addmethod2pos(block7020, "_apply", &meth_parser__apply7021, 0);
  int argcv_meth_parser__apply7021[] = {0};
  meth_meth_parser__apply7021->type = alloc_MethodType(1, argcv_meth_parser__apply7021);
  meth_meth_parser__apply7021->definitionModule = modulename;
  meth_meth_parser__apply7021->definitionLine = 2194;
// compiled block node returning block7020 (depth = 10)
  gc_frame_newslot(block7020);
// call case 4: self request
  params[0] = block7020;
  partcv[0] = 1;
  Object call7025 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7019);
// compiled call node returning call7025 (depth = 9)
  partcv[0] = 0;
  Object call7026 = callmethod(call7025, "not",
    1, partcv, params);
  gc_frame_end(callframe7018);
// compiled call node returning call7026 (depth = 8)
// compiled member node returning call7026 (depth = 7)
  Object if7017 = done;
  if (istrue(call7026)) {
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7027 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7028 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7029 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7028);
// compiled call node returning call7029 (depth = 11)
// compiled member node returning call7029 (depth = 10)
  partcv[0] = 0;
  Object call7030 = callmethod(call7029, "empty",
    1, partcv, params);
  gc_frame_end(callframe7027);
// compiled call node returning call7030 (depth = 9)
// compiled member node returning call7030 (depth = 8)
  *var_suggestions = call7030;
  if (call7030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7031 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7032 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call7033 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7032);
// compiled call node returning call7033 (depth = 11)
// compiled member node returning call7033 (depth = 10)
  partcv[0] = 0;
  Object call7034 = callmethod(call7033, "new",
    1, partcv, params);
  gc_frame_end(callframe7031);
// compiled call node returning call7034 (depth = 9)
// compiled member node returning call7034 (depth = 8)
  *var_suggestion = call7034;
  if (call7034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7035 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7036 == NULL) {
    strlit7036 = alloc_String("rparen");
    gc_root(strlit7036);
  }
// compiled string node returning strlit7036 (depth = 9)
  gc_frame_newslot(strlit7036);
// call case 4: self request
  params[0] = strlit7036;
  partcv[0] = 1;
  Object call7037 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7035);
// compiled call node returning call7037 (depth = 8)
  *var_nextTok = call7037;
  if (call7037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_7039 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_7039 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7041 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7041 (depth = 8)
  Object if7038 = done;
  if (istrue(opresult7041)) {
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7042 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7043 == NULL) {
    strlit7043 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7043);
  }
// compiled string node returning strlit7043 (depth = 9)
  gc_frame_newslot(strlit7043);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit7043;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7044 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7042);
// compiled call node returning call7044 (depth = 8)
    gc_frame_newslot(call7044);
    if7038 = call7044;
  } else {
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7045 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7047 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7046);
// compiled call node returning call7047 (depth = 10)
// compiled member node returning call7047 (depth = 9)
  gc_frame_newslot(call7047);
// starting to compile identifier node (depth = 9)
  Object bool7048 = alloc_Boolean(1);
// compiled identifier node returning bool7048 (depth = 9)
  gc_frame_newslot(bool7048);
// starting to compile identifier node (depth = 9)
  Object bool7049 = alloc_Boolean(0);
// compiled identifier node returning bool7049 (depth = 9)
  gc_frame_newslot(bool7049);
// starting to compile string node (depth = 9)
  if (strlit7050 == NULL) {
    strlit7050 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7050);
  }
// compiled string node returning strlit7050 (depth = 9)
  gc_frame_newslot(strlit7050);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call7047;
  params[2] = bool7048;
  params[3] = bool7049;
  params[4] = strlit7050;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7051 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7045);
// compiled call node returning call7051 (depth = 8)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7052 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7053 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7052);
// compiled call node returning call7053 (depth = 8)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7054 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7056 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7055);
// compiled call node returning call7056 (depth = 12)
// compiled member node returning call7056 (depth = 11)
  partcv[0] = 0;
  Object call7057 = callmethod(call7056, "new",
    1, partcv, params);
  gc_frame_end(callframe7054);
// compiled call node returning call7057 (depth = 10)
// compiled member node returning call7057 (depth = 9)
  *var_suggestion = call7057;
  if (call7057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7059 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7061 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7060);
// compiled call node returning call7061 (depth = 10)
// compiled member node returning call7061 (depth = 9)
  gc_frame_newslot(call7061);
// starting to compile identifier node (depth = 9)
  Object bool7062 = alloc_Boolean(1);
// compiled identifier node returning bool7062 (depth = 9)
  gc_frame_newslot(bool7062);
// starting to compile identifier node (depth = 9)
  Object bool7063 = alloc_Boolean(0);
// compiled identifier node returning bool7063 (depth = 9)
  gc_frame_newslot(bool7063);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call7061;
  params[2] = bool7062;
  params[3] = bool7063;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7064 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7059);
// compiled call node returning call7064 (depth = 8)
    gc_frame_newslot(call7064);
    if7038 = call7064;
  }
// compiled if node returning if7038 (depth = 7)
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7065 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7066 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7065);
// compiled call node returning call7066 (depth = 7)
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7067 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7068 == NULL) {
    strlit7068 = alloc_String("A method request must have an expression or a ')' after a '('.");
    gc_root(strlit7068);
  }
// compiled string node returning strlit7068 (depth = 8)
  gc_frame_newslot(strlit7068);
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7070 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7069);
// compiled call node returning call7070 (depth = 9)
// compiled member node returning call7070 (depth = 8)
  gc_frame_newslot(call7070);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7072 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7071);
// compiled call node returning call7072 (depth = 9)
// compiled member node returning call7072 (depth = 8)
  gc_frame_newslot(call7072);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit7068;
  params[1] = call7070;
  params[2] = call7072;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7073 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7067);
// compiled call node returning call7073 (depth = 7)
    gc_frame_newslot(call7073);
    if7017 = call7073;
  } else {
  }
// compiled if node returning if7017 (depth = 6)
    gc_frame_newslot(if7017);
    if7010 = if7017;
  } else {
  }
// compiled if node returning if7010 (depth = 5)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7074 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7075 = alloc_Block(NULL, NULL, "parser", 2211);
  gc_frame_newslot(block7075);
// method _apply
  block_savedest(block7075);
  Object closure7076 = createclosure(1, "_apply");
  setclosureframe(closure7076, stackframe);
  addtoclosure(closure7076, selfslot);
  struct UserObject *uo7076 = (struct UserObject*)block7075;
  uo7076->data[0] = (Object)closure7076;
  Method *meth_meth_parser__apply7076 = addmethod2pos(block7075, "_apply", &meth_parser__apply7076, 0);
  int argcv_meth_parser__apply7076[] = {0};
  meth_meth_parser__apply7076->type = alloc_MethodType(1, argcv_meth_parser__apply7076);
  meth_meth_parser__apply7076->definitionModule = modulename;
  meth_meth_parser__apply7076->definitionLine = 2208;
// compiled block node returning block7075 (depth = 6)
  gc_frame_newslot(block7075);
// starting to compile block node (depth = 6)
  Object block7081 = alloc_Block(NULL, NULL, "parser", 2211);
  gc_frame_newslot(block7081);
// method _apply
  block_savedest(block7081);
  Object closure7082 = createclosure(8, "_apply");
  setclosureframe(closure7082, stackframe);
  addtoclosure(closure7082, var_values);
  addtoclosure(closure7082, var_nxt);
  addtoclosure(closure7082, var_part);
  addtoclosure(closure7082, var_blocksOK);
  addtoclosure(closure7082, var_errormessages);
  addtoclosure(closure7082, var_sym);
  addtoclosure(closure7082, var_lastToken);
  addtoclosure(closure7082, selfslot);
  struct UserObject *uo7082 = (struct UserObject*)block7081;
  uo7082->data[0] = (Object)closure7082;
  Method *meth_meth_parser__apply7082 = addmethod2pos(block7081, "_apply", &meth_parser__apply7082, 0);
  int argcv_meth_parser__apply7082[] = {0};
  meth_meth_parser__apply7082->type = alloc_MethodType(1, argcv_meth_parser__apply7082);
  meth_meth_parser__apply7082->definitionModule = modulename;
  meth_meth_parser__apply7082->definitionLine = 2208;
// compiled block node returning block7081 (depth = 6)
  gc_frame_newslot(block7081);
// call case 5: prelude request
  params[0] = block7075;
  params[1] = block7081;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7150 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7074);
// compiled call node returning call7150 (depth = 5)
    gc_frame_newslot(call7150);
    if7007 = call7150;
  }
// compiled if node returning if7007 (depth = 4)
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7152 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isEmpty (depth = 6)
  partcv[0] = 0;
  Object call7153 = callmethod(*var_isEmpty, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7152);
// compiled call node returning call7153 (depth = 5)
  Object if7151 = done;
  if (istrue(call7153)) {
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7155 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7154);
// compiled call node returning call7155 (depth = 7)
// compiled member node returning call7155 (depth = 6)
  *var_nxt = call7155;
  if (call7155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7157 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nxt (depth = 6)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call7159 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe7158);
// compiled call node returning call7159 (depth = 7)
// compiled member node returning call7159 (depth = 6)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call7160 = callmethod(call7159, "push",
    1, partcv, params);
  gc_frame_end(callframe7157);
// compiled call node returning call7160 (depth = 5)
    gc_frame_newslot(call7160);
    if7151 = call7160;
  } else {
  }
// compiled if node returning if7151 (depth = 4)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7162 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_isTerm (depth = 7)
  partcv[0] = 0;
  Object call7163 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe7162);
// compiled call node returning call7163 (depth = 6)
// compiled member node returning call7163 (depth = 5)
  Object if7161 = done;
  if (istrue(call7163)) {
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7166 == NULL) {
    strlit7166 = alloc_String("rparen");
    gc_root(strlit7166);
  }
// compiled string node returning strlit7166 (depth = 7)
  int op_slot_right_7165 = gc_frame_newslot(strlit7166);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7168 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7169 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7168);
// compiled call node returning call7169 (depth = 8)
// compiled member node returning call7169 (depth = 7)
  int op_slot_left_7165 = gc_frame_newslot(call7169);
  params[0] = strlit7166;
  partcv[0] = 1;
  Object opresult7170 = callmethod(call7169, "!=", 1, partcv, params);
// compiled op node returning opresult7170 (depth = 6)
  Object if7164 = done;
  if (istrue(opresult7170)) {
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7171 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7172 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7171);
// compiled call node returning call7172 (depth = 7)
// compiled member node returning call7172 (depth = 6)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7173 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call7175 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7174);
// compiled call node returning call7175 (depth = 10)
// compiled member node returning call7175 (depth = 9)
  partcv[0] = 0;
  Object call7176 = callmethod(call7175, "new",
    1, partcv, params);
  gc_frame_end(callframe7173);
// compiled call node returning call7176 (depth = 8)
// compiled member node returning call7176 (depth = 7)
  *var_suggestion = call7176;
  if (call7176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7177 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7178 == NULL) {
    strlit7178 = alloc_String(")");
    gc_root(strlit7178);
  }
// compiled string node returning strlit7178 (depth = 7)
  gc_frame_newslot(strlit7178);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7178;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7179 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7177);
// compiled call node returning call7179 (depth = 6)
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7180 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7181 == NULL) {
    strlit7181 = alloc_String("A part of a multi-part method request beginning with a '(' must end with a ')'.");
    gc_root(strlit7181);
  }
// compiled string node returning strlit7181 (depth = 7)
  gc_frame_newslot(strlit7181);
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7183 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7182);
// compiled call node returning call7183 (depth = 8)
// compiled member node returning call7183 (depth = 7)
  gc_frame_newslot(call7183);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7186 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7185);
// compiled call node returning call7186 (depth = 9)
// compiled member node returning call7186 (depth = 8)
  int op_slot_right_7184 = gc_frame_newslot(call7186);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7189 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7188);
// compiled call node returning call7189 (depth = 9)
// compiled member node returning call7189 (depth = 8)
  int op_slot_left_7184 = gc_frame_newslot(call7189);
  params[0] = call7186;
  partcv[0] = 1;
  Object sum7190 = callmethod(call7189, "+", 1, partcv, params);
// compiled op node returning sum7190 (depth = 7)
  gc_frame_newslot(sum7190);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit7181;
  params[1] = call7183;
  params[2] = sum7190;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7191 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7180);
// compiled call node returning call7191 (depth = 6)
    gc_frame_newslot(call7191);
    if7164 = call7191;
  } else {
  }
// compiled if node returning if7164 (depth = 5)
    gc_frame_newslot(if7164);
    if7161 = if7164;
  } else {
  }
// compiled if node returning if7161 (depth = 4)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7194 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isTerm (depth = 8)
  partcv[0] = 0;
  Object call7195 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe7194);
// compiled call node returning call7195 (depth = 7)
// compiled member node returning call7195 (depth = 6)
  int op_slot_right_7193 = gc_frame_newslot(call7195);
// starting to compile call node (depth = 6)
  int callframe7197 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7198 == NULL) {
    strlit7198 = alloc_String("rparen");
    gc_root(strlit7198);
  }
// compiled string node returning strlit7198 (depth = 7)
  gc_frame_newslot(strlit7198);
// call case 4: self request
  params[0] = strlit7198;
  partcv[0] = 1;
  Object call7199 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7197);
// compiled call node returning call7199 (depth = 6)
  int op_slot_left_7193 = gc_frame_newslot(call7199);
  params[0] = call7195;
  partcv[0] = 1;
  Object opresult7200 = callmethod(call7199, "&&", 1, partcv, params);
// compiled op node returning opresult7200 (depth = 5)
  Object if7192 = done;
  if (istrue(opresult7200)) {
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7202 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7201);
// compiled call node returning call7202 (depth = 6)
// compiled member node returning call7202 (depth = 5)
    gc_frame_newslot(call7202);
    if7192 = call7202;
  } else {
  }
// compiled if node returning if7192 (depth = 4)
  gc_frame_end(frame);
  return if7192;
}
Object meth_parser_callmprest6782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callmprest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method callmprest");
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callmprest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for callmprest");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "methname");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_lp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lp");
  Object *var_part = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "part");
  Object *var_meth_39_ = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "meth'");
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6783 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6784 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6783);
// compiled call node returning call6784 (depth = 4)
// compiled member node returning call6784 (depth = 3)
  *var_methname = call6784;
  if (call6784 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6786 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6785);
// compiled call node returning call6786 (depth = 4)
// compiled member node returning call6786 (depth = 3)
  *var_lp = call6786;
  if (call6786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_part = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6787 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6788 = alloc_Block(NULL, NULL, "parser", 2134);
  gc_frame_newslot(block6788);
// method _apply
  block_savedest(block6788);
  Object closure6789 = createclosure(3, "_apply");
  setclosureframe(closure6789, stackframe);
  addtoclosure(closure6789, var_lastToken);
  addtoclosure(closure6789, var_tok);
  addtoclosure(closure6789, selfslot);
  struct UserObject *uo6789 = (struct UserObject*)block6788;
  uo6789->data[0] = (Object)closure6789;
  Method *meth_meth_parser__apply6789 = addmethod2pos(block6788, "_apply", &meth_parser__apply6789, 0);
  int argcv_meth_parser__apply6789[] = {0};
  meth_meth_parser__apply6789->type = alloc_MethodType(1, argcv_meth_parser__apply6789);
  meth_meth_parser__apply6789->definitionModule = modulename;
  meth_meth_parser__apply6789->definitionLine = 2132;
// compiled block node returning block6788 (depth = 3)
  gc_frame_newslot(block6788);
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block6800 = alloc_Block(NULL, NULL, "parser", 2135);
  gc_frame_newslot(block6800);
// method _apply
  block_savedest(block6800);
  Object closure6801 = createclosure(12, "_apply");
  setclosureframe(closure6801, stackframe);
  addtoclosure(closure6801, var_ast);
  addtoclosure(closure6801, var_part);
  addtoclosure(closure6801, var_signature);
  addtoclosure(closure6801, var_methname);
  addtoclosure(closure6801, var_values);
  addtoclosure(closure6801, var_nxt);
  addtoclosure(closure6801, var_errormessages);
  addtoclosure(closure6801, var_sym);
  addtoclosure(closure6801, var_lastToken);
  addtoclosure(closure6801, var_tok);
  addtoclosure(closure6801, var_blocksOK);
  addtoclosure(closure6801, selfslot);
  struct UserObject *uo6801 = (struct UserObject*)block6800;
  uo6801->data[0] = (Object)closure6801;
  Method *meth_meth_parser__apply6801 = addmethod2pos(block6800, "_apply", &meth_parser__apply6801, 0);
  int argcv_meth_parser__apply6801[] = {0};
  meth_meth_parser__apply6801->type = alloc_MethodType(1, argcv_meth_parser__apply6801);
  meth_meth_parser__apply6801->definitionModule = modulename;
  meth_meth_parser__apply6801->definitionLine = 2132;
// compiled block node returning block6800 (depth = 3)
  gc_frame_newslot(block6800);
// call case 5: prelude request
  params[0] = block6788;
  params[1] = block6800;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7204 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6787);
// compiled call node returning call7204 (depth = 2)
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7205 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool7206 = alloc_Boolean(0);
// compiled identifier node returning bool7206 (depth = 4)
  gc_frame_newslot(bool7206);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call7208 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7207);
// compiled call node returning call7208 (depth = 5)
// compiled member node returning call7208 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool7206;
  partcv[0] = 2;
  Object call7209 = callmethod(call7208, "new",
    1, partcv, params);
  gc_frame_end(callframe7205);
// compiled call node returning call7209 (depth = 3)
  *var_meth_39_ = call7209;
  if (call7209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7210 = gc_frame_new();
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call7212 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe7211);
// compiled call node returning call7212 (depth = 5)
// compiled member node returning call7212 (depth = 4)
  gc_frame_newslot(call7212);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth_39_ (depth = 4)
  params[0] = call7212;
  partcv[0] = 1;
  Object call7213 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7210);
// compiled call node returning call7213 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7214 = gc_frame_new();
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call7216 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7215);
// compiled call node returning call7216 (depth = 5)
// compiled member node returning call7216 (depth = 4)
  gc_frame_newslot(call7216);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth_39_ (depth = 4)
  params[0] = call7216;
  partcv[0] = 1;
  Object call7217 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe7214);
// compiled call node returning call7217 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth_39_ (depth = 2)
  gc_frame_end(frame);
  return *var_meth_39_;
}
Object meth_parser__apply7251(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7255 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7254);
// compiled call node returning call7255 (depth = 10)
// compiled member node returning call7255 (depth = 9)
  int op_slot_right_7253 = gc_frame_newslot(call7255);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7257 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7258 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe7257);
// compiled call node returning call7258 (depth = 10)
// compiled member node returning call7258 (depth = 9)
  int op_slot_left_7253 = gc_frame_newslot(call7258);
  params[0] = call7255;
  partcv[0] = 1;
  Object opresult7259 = callmethod(call7258, "==", 1, partcv, params);
// compiled op node returning opresult7259 (depth = 8)
  int op_slot_right_7252 = gc_frame_newslot(opresult7259);
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7263 == NULL) {
    strlit7263 = alloc_String("=");
    gc_root(strlit7263);
  }
// compiled string node returning strlit7263 (depth = 10)
  int op_slot_right_7262 = gc_frame_newslot(strlit7263);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7265 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call7266 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe7265);
// compiled call node returning call7266 (depth = 11)
// compiled member node returning call7266 (depth = 10)
  int op_slot_left_7262 = gc_frame_newslot(call7266);
  params[0] = strlit7263;
  partcv[0] = 1;
  Object opresult7267 = callmethod(call7266, "==", 1, partcv, params);
// compiled op node returning opresult7267 (depth = 9)
  int op_slot_right_7261 = gc_frame_newslot(opresult7267);
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7270 == NULL) {
    strlit7270 = alloc_String("op");
    gc_root(strlit7270);
  }
// compiled string node returning strlit7270 (depth = 10)
  int op_slot_right_7269 = gc_frame_newslot(strlit7270);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call7273 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7272);
// compiled call node returning call7273 (depth = 11)
// compiled member node returning call7273 (depth = 10)
  int op_slot_left_7269 = gc_frame_newslot(call7273);
  params[0] = strlit7270;
  partcv[0] = 1;
  Object opresult7274 = callmethod(call7273, "==", 1, partcv, params);
// compiled op node returning opresult7274 (depth = 9)
  int op_slot_left_7261 = gc_frame_newslot(opresult7274);
  params[0] = opresult7267;
  partcv[0] = 1;
  Object opresult7275 = callmethod(opresult7274, "&&", 1, partcv, params);
// compiled op node returning opresult7275 (depth = 8)
  int op_slot_left_7252 = gc_frame_newslot(opresult7275);
  params[0] = opresult7259;
  partcv[0] = 1;
  Object opresult7276 = callmethod(opresult7275, "&&", 1, partcv, params);
// compiled op node returning opresult7276 (depth = 7)
  gc_frame_end(frame);
  return opresult7276;
}
Object meth_parser__apply7339(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe7340 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7341 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7340);
// compiled call node returning call7341 (depth = 9)
  gc_frame_end(frame);
  return call7341;
}
Object meth_parser_defdec7218(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_defaultDefVisibility = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defdec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for defdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_defTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "defTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_nextTok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "nextTok");
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7222 == NULL) {
    strlit7222 = alloc_String("def");
    gc_root(strlit7222);
  }
// compiled string node returning strlit7222 (depth = 5)
  int op_slot_right_7221 = gc_frame_newslot(strlit7222);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7224 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7225 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7224);
// compiled call node returning call7225 (depth = 6)
// compiled member node returning call7225 (depth = 5)
  int op_slot_left_7221 = gc_frame_newslot(call7225);
  params[0] = strlit7222;
  partcv[0] = 1;
  Object opresult7226 = callmethod(call7225, "==", 1, partcv, params);
// compiled op node returning opresult7226 (depth = 4)
  int op_slot_right_7220 = gc_frame_newslot(opresult7226);
// starting to compile call node (depth = 4)
  int callframe7228 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7229 == NULL) {
    strlit7229 = alloc_String("keyword");
    gc_root(strlit7229);
  }
// compiled string node returning strlit7229 (depth = 5)
  gc_frame_newslot(strlit7229);
// call case 4: self request
  params[0] = strlit7229;
  partcv[0] = 1;
  Object call7230 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7228);
// compiled call node returning call7230 (depth = 4)
  int op_slot_left_7220 = gc_frame_newslot(call7230);
  params[0] = opresult7226;
  partcv[0] = 1;
  Object opresult7231 = callmethod(call7230, "&&", 1, partcv, params);
// compiled op node returning opresult7231 (depth = 3)
  Object if7219 = done;
  if (istrue(opresult7231)) {
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7233 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7232);
// compiled call node returning call7233 (depth = 5)
// compiled member node returning call7233 (depth = 4)
  *var_line = call7233;
  if (call7233 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7234 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7235 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7234);
// compiled call node returning call7235 (depth = 5)
// compiled member node returning call7235 (depth = 4)
  *var_pos = call7235;
  if (call7235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7237 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7236);
// compiled call node returning call7237 (depth = 4)
// compiled member node returning call7237 (depth = 3)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7240 == NULL) {
    strlit7240 = alloc_String("identifier");
    gc_root(strlit7240);
  }
// compiled string node returning strlit7240 (depth = 5)
  int op_slot_right_7239 = gc_frame_newslot(strlit7240);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7243 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7242);
// compiled call node returning call7243 (depth = 6)
// compiled member node returning call7243 (depth = 5)
  int op_slot_left_7239 = gc_frame_newslot(call7243);
  params[0] = strlit7240;
  partcv[0] = 1;
  Object opresult7244 = callmethod(call7243, "!=", 1, partcv, params);
// compiled op node returning opresult7244 (depth = 4)
  Object if7238 = done;
  if (istrue(opresult7244)) {
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7245 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7246 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7247 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7246);
// compiled call node returning call7247 (depth = 8)
// compiled member node returning call7247 (depth = 7)
  partcv[0] = 0;
  Object call7248 = callmethod(call7247, "new",
    1, partcv, params);
  gc_frame_end(callframe7245);
// compiled call node returning call7248 (depth = 6)
// compiled member node returning call7248 (depth = 5)
  *var_suggestion = call7248;
  if (call7248 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7249 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7250 = alloc_Block(NULL, NULL, "parser", 2265);
  gc_frame_newslot(block7250);
// method _apply
  block_savedest(block7250);
  Object closure7251 = createclosure(2, "_apply");
  setclosureframe(closure7251, stackframe);
  addtoclosure(closure7251, var_sym);
  addtoclosure(closure7251, selfslot);
  struct UserObject *uo7251 = (struct UserObject*)block7250;
  uo7251->data[0] = (Object)closure7251;
  Method *meth_meth_parser__apply7251 = addmethod2pos(block7250, "_apply", &meth_parser__apply7251, 0);
  int argcv_meth_parser__apply7251[] = {1};
  meth_meth_parser__apply7251->type = alloc_MethodType(1, argcv_meth_parser__apply7251);
  meth_meth_parser__apply7251->definitionModule = modulename;
  meth_meth_parser__apply7251->definitionLine = 2264;
// compiled block node returning block7250 (depth = 6)
  gc_frame_newslot(block7250);
// call case 4: self request
  params[0] = block7250;
  partcv[0] = 1;
  Object call7278 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7249);
// compiled call node returning call7278 (depth = 5)
  *var_nextToken = call7278;
  if (call7278 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7281 = alloc_Boolean(0);
// compiled identifier node returning bool7281 (depth = 6)
  int op_slot_right_7280 = gc_frame_newslot(bool7281);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextToken (depth = 6)
  int op_slot_left_7280 = gc_frame_newslot(*var_nextToken);
  params[0] = bool7281;
  partcv[0] = 1;
  Object opresult7283 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7283 (depth = 5)
  Object if7279 = done;
  if (istrue(opresult7283)) {
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7284 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7285 == NULL) {
    strlit7285 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit7285);
  }
// compiled string node returning strlit7285 (depth = 6)
  gc_frame_newslot(strlit7285);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7285;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7286 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7284);
// compiled call node returning call7286 (depth = 5)
    gc_frame_newslot(call7286);
    if7279 = call7286;
  } else {
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_7288 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_7288 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7290 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7290 (depth = 6)
  Object if7287 = done;
  if (istrue(opresult7290)) {
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7291 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7292 == NULL) {
    strlit7292 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit7292);
  }
// compiled string node returning strlit7292 (depth = 7)
  gc_frame_newslot(strlit7292);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7292;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7293 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7291);
// compiled call node returning call7293 (depth = 6)
    gc_frame_newslot(call7293);
    if7287 = call7293;
  } else {
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7294 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7295 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextToken (depth = 9)
  partcv[0] = 0;
  Object call7296 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe7295);
// compiled call node returning call7296 (depth = 8)
// compiled member node returning call7296 (depth = 7)
  gc_frame_newslot(call7296);
// starting to compile identifier node (depth = 7)
  Object bool7297 = alloc_Boolean(0);
// compiled identifier node returning bool7297 (depth = 7)
  gc_frame_newslot(bool7297);
// starting to compile identifier node (depth = 7)
  Object bool7298 = alloc_Boolean(1);
// compiled identifier node returning bool7298 (depth = 7)
  gc_frame_newslot(bool7298);
// starting to compile string node (depth = 7)
  if (strlit7299 == NULL) {
    strlit7299 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit7299);
  }
// compiled string node returning strlit7299 (depth = 7)
  gc_frame_newslot(strlit7299);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call7296;
  params[2] = bool7297;
  params[3] = bool7298;
  params[4] = strlit7299;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7300 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7294);
// compiled call node returning call7300 (depth = 6)
    gc_frame_newslot(call7300);
    if7287 = call7300;
  }
// compiled if node returning if7287 (depth = 5)
    gc_frame_newslot(if7287);
    if7279 = if7287;
  }
// compiled if node returning if7279 (depth = 4)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7301 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7302 == NULL) {
    strlit7302 = alloc_String("A definition must have a name, '=', and a value after the 'def'.");
    gc_root(strlit7302);
  }
// compiled string node returning strlit7302 (depth = 5)
  gc_frame_newslot(strlit7302);
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7303 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7304 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7303);
// compiled call node returning call7304 (depth = 6)
// compiled member node returning call7304 (depth = 5)
  gc_frame_newslot(call7304);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7306 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7305);
// compiled call node returning call7306 (depth = 6)
// compiled member node returning call7306 (depth = 5)
  gc_frame_newslot(call7306);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7302;
  params[1] = call7304;
  params[2] = call7306;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7307 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7301);
// compiled call node returning call7307 (depth = 4)
    gc_frame_newslot(call7307);
    if7238 = call7307;
  } else {
  }
// compiled if node returning if7238 (depth = 3)
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7308 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7309 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7308);
// compiled call node returning call7309 (depth = 4)
// compiled member node returning call7309 (depth = 3)
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7310 = alloc_Boolean(0);
// compiled identifier node returning bool7310 (depth = 4)
  *var_val = bool7310;
  if (bool7310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7311 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call7312 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7311);
// compiled call node returning call7312 (depth = 5)
// compiled member node returning call7312 (depth = 4)
  *var_name = call7312;
  if (call7312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7313 = gc_frame_new();
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool7314 = alloc_Boolean(1);
// compiled identifier node returning bool7314 (depth = 5)
  gc_frame_newslot(bool7314);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  params[0] = bool7314;
  partcv[0] = 1;
  Object call7315 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7313);
// compiled call node returning call7315 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7317 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7316);
// compiled call node returning call7317 (depth = 5)
// compiled member node returning call7317 (depth = 4)
  *var_dtype = call7317;
  if (call7317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7319 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7318);
// compiled call node returning call7319 (depth = 5)
// compiled member node returning call7319 (depth = 4)
  *var_anns = call7319;
  if (call7319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7323 == NULL) {
    strlit7323 = alloc_String("=");
    gc_root(strlit7323);
  }
// compiled string node returning strlit7323 (depth = 6)
  int op_slot_right_7322 = gc_frame_newslot(strlit7323);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7326 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7325);
// compiled call node returning call7326 (depth = 7)
// compiled member node returning call7326 (depth = 6)
  int op_slot_left_7322 = gc_frame_newslot(call7326);
  params[0] = strlit7323;
  partcv[0] = 1;
  Object opresult7327 = callmethod(call7326, "==", 1, partcv, params);
// compiled op node returning opresult7327 (depth = 5)
  int op_slot_right_7321 = gc_frame_newslot(opresult7327);
// starting to compile call node (depth = 5)
  int callframe7329 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7330 == NULL) {
    strlit7330 = alloc_String("op");
    gc_root(strlit7330);
  }
// compiled string node returning strlit7330 (depth = 6)
  gc_frame_newslot(strlit7330);
// call case 4: self request
  params[0] = strlit7330;
  partcv[0] = 1;
  Object call7331 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7329);
// compiled call node returning call7331 (depth = 5)
  int op_slot_left_7321 = gc_frame_newslot(call7331);
  params[0] = opresult7327;
  partcv[0] = 1;
  Object opresult7332 = callmethod(call7331, "&&", 1, partcv, params);
// compiled op node returning opresult7332 (depth = 4)
  Object if7320 = done;
  if (istrue(opresult7332)) {
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7334 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7333);
// compiled call node returning call7334 (depth = 5)
// compiled member node returning call7334 (depth = 4)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7336 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe7337 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7338 = alloc_Block(NULL, NULL, "parser", 2285);
  gc_frame_newslot(block7338);
// method _apply
  block_savedest(block7338);
  Object closure7339 = createclosure(2, "_apply");
  setclosureframe(closure7339, stackframe);
  addtoclosure(closure7339, var_blocksOK);
  addtoclosure(closure7339, selfslot);
  struct UserObject *uo7339 = (struct UserObject*)block7338;
  uo7339->data[0] = (Object)closure7339;
  Method *meth_meth_parser__apply7339 = addmethod2pos(block7338, "_apply", &meth_parser__apply7339, 0);
  int argcv_meth_parser__apply7339[] = {0};
  meth_meth_parser__apply7339->type = alloc_MethodType(1, argcv_meth_parser__apply7339);
  meth_meth_parser__apply7339->definitionModule = modulename;
  meth_meth_parser__apply7339->definitionLine = 2285;
// compiled block node returning block7338 (depth = 8)
  gc_frame_newslot(block7338);
// call case 4: self request
  params[0] = block7338;
  partcv[0] = 1;
  Object call7343 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7337);
// compiled call node returning call7343 (depth = 7)
  partcv[0] = 0;
  Object call7344 = callmethod(call7343, "not",
    1, partcv, params);
  gc_frame_end(callframe7336);
// compiled call node returning call7344 (depth = 6)
// compiled member node returning call7344 (depth = 5)
  Object if7335 = done;
  if (istrue(call7344)) {
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7345 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7347 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7346);
// compiled call node returning call7347 (depth = 9)
// compiled member node returning call7347 (depth = 8)
  partcv[0] = 0;
  Object call7348 = callmethod(call7347, "new",
    1, partcv, params);
  gc_frame_end(callframe7345);
// compiled call node returning call7348 (depth = 7)
// compiled member node returning call7348 (depth = 6)
  *var_suggestion = call7348;
  if (call7348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7350 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7349);
// compiled call node returning call7350 (depth = 6)
  *var_nextTok = call7350;
  if (call7350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_7352 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_7352 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7354 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7354 (depth = 6)
  Object if7351 = done;
  if (istrue(opresult7354)) {
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7355 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7356 == NULL) {
    strlit7356 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7356);
  }
// compiled string node returning strlit7356 (depth = 7)
  gc_frame_newslot(strlit7356);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7356;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7357 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7355);
// compiled call node returning call7357 (depth = 6)
    gc_frame_newslot(call7357);
    if7351 = call7357;
  } else {
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7358 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call7360 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7359);
// compiled call node returning call7360 (depth = 8)
// compiled member node returning call7360 (depth = 7)
  gc_frame_newslot(call7360);
// starting to compile identifier node (depth = 7)
  Object bool7361 = alloc_Boolean(1);
// compiled identifier node returning bool7361 (depth = 7)
  gc_frame_newslot(bool7361);
// starting to compile identifier node (depth = 7)
  Object bool7362 = alloc_Boolean(0);
// compiled identifier node returning bool7362 (depth = 7)
  gc_frame_newslot(bool7362);
// starting to compile string node (depth = 7)
  if (strlit7363 == NULL) {
    strlit7363 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7363);
  }
// compiled string node returning strlit7363 (depth = 7)
  gc_frame_newslot(strlit7363);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call7360;
  params[2] = bool7361;
  params[3] = bool7362;
  params[4] = strlit7363;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7364 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7358);
// compiled call node returning call7364 (depth = 6)
    gc_frame_newslot(call7364);
    if7351 = call7364;
  }
// compiled if node returning if7351 (depth = 5)
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7365 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7366 == NULL) {
    strlit7366 = alloc_String("A definition must have a value after the '='.");
    gc_root(strlit7366);
  }
// compiled string node returning strlit7366 (depth = 6)
  gc_frame_newslot(strlit7366);
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7367 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7368 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7367);
// compiled call node returning call7368 (depth = 7)
// compiled member node returning call7368 (depth = 6)
  gc_frame_newslot(call7368);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7371 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7370);
// compiled call node returning call7371 (depth = 8)
// compiled member node returning call7371 (depth = 7)
  int op_slot_right_7369 = gc_frame_newslot(call7371);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7373 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7374 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7373);
// compiled call node returning call7374 (depth = 8)
// compiled member node returning call7374 (depth = 7)
  int op_slot_left_7369 = gc_frame_newslot(call7374);
  params[0] = call7371;
  partcv[0] = 1;
  Object sum7375 = callmethod(call7374, "+", 1, partcv, params);
// compiled op node returning sum7375 (depth = 6)
  gc_frame_newslot(sum7375);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7366;
  params[1] = call7368;
  params[2] = sum7375;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7376 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7365);
// compiled call node returning call7376 (depth = 5)
    gc_frame_newslot(call7376);
    if7335 = call7376;
  } else {
  }
// compiled if node returning if7335 (depth = 4)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7377 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7378 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7377);
// compiled call node returning call7378 (depth = 6)
// compiled member node returning call7378 (depth = 5)
  *var_val = call7378;
  if (call7378 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7320 = done;
  } else {
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7381 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7382 == NULL) {
    strlit7382 = alloc_String("bind");
    gc_root(strlit7382);
  }
// compiled string node returning strlit7382 (depth = 6)
  gc_frame_newslot(strlit7382);
// call case 4: self request
  params[0] = strlit7382;
  partcv[0] = 1;
  Object call7383 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7381);
// compiled call node returning call7383 (depth = 5)
  Object if7380 = done;
  if (istrue(call7383)) {
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7384 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7385 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7386 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7385);
// compiled call node returning call7386 (depth = 9)
// compiled member node returning call7386 (depth = 8)
  partcv[0] = 0;
  Object call7387 = callmethod(call7386, "empty",
    1, partcv, params);
  gc_frame_end(callframe7384);
// compiled call node returning call7387 (depth = 7)
// compiled member node returning call7387 (depth = 6)
  *var_suggestions = call7387;
  if (call7387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7388 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7390 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7389);
// compiled call node returning call7390 (depth = 9)
// compiled member node returning call7390 (depth = 8)
  partcv[0] = 0;
  Object call7391 = callmethod(call7390, "new",
    1, partcv, params);
  gc_frame_end(callframe7388);
// compiled call node returning call7391 (depth = 7)
// compiled member node returning call7391 (depth = 6)
  *var_suggestion = call7391;
  if (call7391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7392 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit7393 == NULL) {
    strlit7393 = alloc_String("=");
    gc_root(strlit7393);
  }
// compiled string node returning strlit7393 (depth = 6)
  gc_frame_newslot(strlit7393);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit7393;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7394 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7392);
// compiled call node returning call7394 (depth = 5)
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7395 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7396 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7395);
// compiled call node returning call7396 (depth = 5)
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7397 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7399 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7398);
// compiled call node returning call7399 (depth = 9)
// compiled member node returning call7399 (depth = 8)
  partcv[0] = 0;
  Object call7400 = callmethod(call7399, "new",
    1, partcv, params);
  gc_frame_end(callframe7397);
// compiled call node returning call7400 (depth = 7)
// compiled member node returning call7400 (depth = 6)
  *var_suggestion = call7400;
  if (call7400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7402 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit7403 == NULL) {
    strlit7403 = alloc_String("var");
    gc_root(strlit7403);
  }
// compiled string node returning strlit7403 (depth = 6)
  gc_frame_newslot(strlit7403);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit7403;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7404 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7402);
// compiled call node returning call7404 (depth = 5)
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7405 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7406 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7405);
// compiled call node returning call7406 (depth = 5)
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7407 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7408 == NULL) {
    strlit7408 = alloc_String("A definition must use '=' instead of ':='. A variable declaration uses 'var' and ':='.");
    gc_root(strlit7408);
  }
// compiled string node returning strlit7408 (depth = 6)
  gc_frame_newslot(strlit7408);
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7409 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7410 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7409);
// compiled call node returning call7410 (depth = 7)
// compiled member node returning call7410 (depth = 6)
  gc_frame_newslot(call7410);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7411 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7412 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7411);
// compiled call node returning call7412 (depth = 7)
// compiled member node returning call7412 (depth = 6)
  gc_frame_newslot(call7412);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7414 = alloc_Float64(1);
// compiled num node returning num7414 (depth = 7)
  int op_slot_right_7413 = gc_frame_newslot(num7414);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7417 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7416);
// compiled call node returning call7417 (depth = 8)
// compiled member node returning call7417 (depth = 7)
  int op_slot_left_7413 = gc_frame_newslot(call7417);
  params[0] = num7414;
  partcv[0] = 1;
  Object sum7418 = callmethod(call7417, "+", 1, partcv, params);
// compiled op node returning sum7418 (depth = 6)
  gc_frame_newslot(sum7418);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7408;
  params[1] = call7410;
  params[2] = call7412;
  params[3] = sum7418;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7419 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7407);
// compiled call node returning call7419 (depth = 5)
    gc_frame_newslot(call7419);
    if7380 = call7419;
  } else {
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7420 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7421 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7422 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7421);
// compiled call node returning call7422 (depth = 9)
// compiled member node returning call7422 (depth = 8)
  partcv[0] = 0;
  Object call7423 = callmethod(call7422, "empty",
    1, partcv, params);
  gc_frame_end(callframe7420);
// compiled call node returning call7423 (depth = 7)
// compiled member node returning call7423 (depth = 6)
  *var_suggestions = call7423;
  if (call7423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7424 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7425 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7426 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7425);
// compiled call node returning call7426 (depth = 9)
// compiled member node returning call7426 (depth = 8)
  partcv[0] = 0;
  Object call7427 = callmethod(call7426, "new",
    1, partcv, params);
  gc_frame_end(callframe7424);
// compiled call node returning call7427 (depth = 7)
// compiled member node returning call7427 (depth = 6)
  *var_suggestion = call7427;
  if (call7427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7428 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7429 == NULL) {
    strlit7429 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7429);
  }
// compiled string node returning strlit7429 (depth = 6)
  gc_frame_newslot(strlit7429);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7429;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7430 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7428);
// compiled call node returning call7430 (depth = 5)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7431 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7432 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7431);
// compiled call node returning call7432 (depth = 5)
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7433 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7435 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7434);
// compiled call node returning call7435 (depth = 9)
// compiled member node returning call7435 (depth = 8)
  partcv[0] = 0;
  Object call7436 = callmethod(call7435, "new",
    1, partcv, params);
  gc_frame_end(callframe7433);
// compiled call node returning call7436 (depth = 7)
// compiled member node returning call7436 (depth = 6)
  *var_suggestion = call7436;
  if (call7436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7438 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit7439 == NULL) {
    strlit7439 = alloc_String("var");
    gc_root(strlit7439);
  }
// compiled string node returning strlit7439 (depth = 6)
  gc_frame_newslot(strlit7439);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit7439;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7440 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7438);
// compiled call node returning call7440 (depth = 5)
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7441 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7442 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7441);
// compiled call node returning call7442 (depth = 5)
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7443 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7445 == NULL) {
    strlit7445 = alloc_String("A variable declaration does not require a value and uses 'var' instead of 'def'.");
    gc_root(strlit7445);
  }
// compiled string node returning strlit7445 (depth = 7)
  int op_slot_right_7444 = gc_frame_newslot(strlit7445);
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7447 == NULL) {
    strlit7447 = alloc_String("A definition must have '=' and a value after the name. ");
    gc_root(strlit7447);
  }
// compiled string node returning strlit7447 (depth = 7)
  int op_slot_left_7444 = gc_frame_newslot(strlit7447);
  params[0] = strlit7445;
  partcv[0] = 1;
  Object opresult7448 = callmethod(strlit7447, "++", 1, partcv, params);
// compiled op node returning opresult7448 (depth = 6)
  gc_frame_newslot(opresult7448);
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7449 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7450 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7449);
// compiled call node returning call7450 (depth = 7)
// compiled member node returning call7450 (depth = 6)
  gc_frame_newslot(call7450);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7452 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7451);
// compiled call node returning call7452 (depth = 7)
// compiled member node returning call7452 (depth = 6)
  gc_frame_newslot(call7452);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7448;
  params[1] = call7450;
  params[2] = call7452;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7453 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7443);
// compiled call node returning call7453 (depth = 5)
    gc_frame_newslot(call7453);
    if7380 = call7453;
  }
// compiled if node returning if7380 (depth = 4)
    gc_frame_newslot(if7380);
    if7320 = if7380;
  }
// compiled if node returning if7320 (depth = 3)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7454 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  partcv[0] = 0;
  Object call7456 = callmethod(*var_defTok, "line",
    1, partcv, params);
  gc_frame_end(callframe7455);
// compiled call node returning call7456 (depth = 5)
// compiled member node returning call7456 (depth = 4)
  gc_frame_newslot(call7456);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  partcv[0] = 0;
  Object call7458 = callmethod(*var_defTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7457);
// compiled call node returning call7458 (depth = 5)
// compiled member node returning call7458 (depth = 4)
  gc_frame_newslot(call7458);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7456;
  params[1] = call7458;
  partcv[0] = 2;
  Object call7459 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7454);
// compiled call node returning call7459 (depth = 3)
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7460 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7462 = callmethod(*var_ast, "defDecNode",
    1, partcv, params);
  gc_frame_end(callframe7461);
// compiled call node returning call7462 (depth = 6)
// compiled member node returning call7462 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7463 = callmethod(call7462, "new",
    1, partcv, params);
  gc_frame_end(callframe7460);
// compiled call node returning call7463 (depth = 4)
  *var_o = call7463;
  if (call7463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7466 = alloc_Boolean(0);
// compiled identifier node returning bool7466 (depth = 5)
  int op_slot_right_7465 = gc_frame_newslot(bool7466);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_7465 = gc_frame_newslot(*var_anns);
  params[0] = bool7466;
  partcv[0] = 1;
  Object opresult7468 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult7468 (depth = 4)
  Object if7464 = done;
  if (istrue(opresult7468)) {
// starting to compile call node (depth = 4)
  int callframe7469 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call7471 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7470);
// compiled call node returning call7471 (depth = 6)
// compiled member node returning call7471 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7472 = callmethod(call7471, "addAll",
    1, partcv, params);
  gc_frame_end(callframe7469);
// compiled call node returning call7472 (depth = 4)
    gc_frame_newslot(call7472);
    if7464 = call7472;
  } else {
  }
// compiled if node returning if7464 (depth = 3)
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7473 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultDefVisibility (depth = 4)
  gc_frame_newslot(*var_defaultDefVisibility);
// starting to compile string node (depth = 4)
  if (strlit7474 == NULL) {
    strlit7474 = alloc_String("confidential");
    gc_root(strlit7474);
  }
// compiled string node returning strlit7474 (depth = 4)
  gc_frame_newslot(strlit7474);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultDefVisibility;
  params[2] = strlit7474;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7475 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7473);
// compiled call node returning call7475 (depth = 3)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7476 = gc_frame_new();
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  gc_frame_newslot(*var_defTok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call7477 = callmethod(*var_o, "startToken:=",
    1, partcv, params);
  gc_frame_end(callframe7476);
// compiled call node returning call7477 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7478 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7479 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7478);
// compiled call node returning call7479 (depth = 3)
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7481 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7480);
// compiled call node returning call7481 (depth = 4)
// compiled member node returning call7481 (depth = 3)
    gc_frame_newslot(call7481);
    if7219 = call7481;
  } else {
  }
// compiled if node returning if7219 (depth = 2)
  gc_frame_end(frame);
  return if7219;
}
Object meth_parser__apply7515(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7519 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7518);
// compiled call node returning call7519 (depth = 10)
// compiled member node returning call7519 (depth = 9)
  int op_slot_right_7517 = gc_frame_newslot(call7519);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7522 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe7521);
// compiled call node returning call7522 (depth = 10)
// compiled member node returning call7522 (depth = 9)
  int op_slot_left_7517 = gc_frame_newslot(call7522);
  params[0] = call7519;
  partcv[0] = 1;
  Object opresult7523 = callmethod(call7522, "==", 1, partcv, params);
// compiled op node returning opresult7523 (depth = 8)
  int op_slot_right_7516 = gc_frame_newslot(opresult7523);
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7526 == NULL) {
    strlit7526 = alloc_String("bind");
    gc_root(strlit7526);
  }
// compiled string node returning strlit7526 (depth = 9)
  int op_slot_right_7525 = gc_frame_newslot(strlit7526);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7528 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7529 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7528);
// compiled call node returning call7529 (depth = 10)
// compiled member node returning call7529 (depth = 9)
  int op_slot_left_7525 = gc_frame_newslot(call7529);
  params[0] = strlit7526;
  partcv[0] = 1;
  Object opresult7530 = callmethod(call7529, "==", 1, partcv, params);
// compiled op node returning opresult7530 (depth = 8)
  int op_slot_left_7516 = gc_frame_newslot(opresult7530);
  params[0] = opresult7523;
  partcv[0] = 1;
  Object opresult7531 = callmethod(opresult7530, "&&", 1, partcv, params);
// compiled op node returning opresult7531 (depth = 7)
  gc_frame_end(frame);
  return opresult7531;
}
Object meth_parser__apply7537(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_7538 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  int op_slot_left_7538 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7540 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7540 (depth = 7)
  gc_frame_end(frame);
  return opresult7540;
}
Object meth_parser__apply7586(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe7587 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7588 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7587);
// compiled call node returning call7588 (depth = 9)
  gc_frame_end(frame);
  return call7588;
}
Object meth_parser_vardec7482(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(16, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_defaultVarVisibility = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for vardec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for vardec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_varTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "varTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_suggestions = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "suggestions");
  Object *var_nextTok = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "nextTok");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7486 == NULL) {
    strlit7486 = alloc_String("var");
    gc_root(strlit7486);
  }
// compiled string node returning strlit7486 (depth = 5)
  int op_slot_right_7485 = gc_frame_newslot(strlit7486);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7489 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7488);
// compiled call node returning call7489 (depth = 6)
// compiled member node returning call7489 (depth = 5)
  int op_slot_left_7485 = gc_frame_newslot(call7489);
  params[0] = strlit7486;
  partcv[0] = 1;
  Object opresult7490 = callmethod(call7489, "==", 1, partcv, params);
// compiled op node returning opresult7490 (depth = 4)
  int op_slot_right_7484 = gc_frame_newslot(opresult7490);
// starting to compile call node (depth = 4)
  int callframe7492 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7493 == NULL) {
    strlit7493 = alloc_String("keyword");
    gc_root(strlit7493);
  }
// compiled string node returning strlit7493 (depth = 5)
  gc_frame_newslot(strlit7493);
// call case 4: self request
  params[0] = strlit7493;
  partcv[0] = 1;
  Object call7494 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7492);
// compiled call node returning call7494 (depth = 4)
  int op_slot_left_7484 = gc_frame_newslot(call7494);
  params[0] = opresult7490;
  partcv[0] = 1;
  Object opresult7495 = callmethod(call7494, "&&", 1, partcv, params);
// compiled op node returning opresult7495 (depth = 3)
  Object if7483 = done;
  if (istrue(opresult7495)) {
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7497 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7496);
// compiled call node returning call7497 (depth = 5)
// compiled member node returning call7497 (depth = 4)
  *var_line = call7497;
  if (call7497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7499 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7498);
// compiled call node returning call7499 (depth = 5)
// compiled member node returning call7499 (depth = 4)
  *var_pos = call7499;
  if (call7499 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2334
  setline(2334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7501 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7500);
// compiled call node returning call7501 (depth = 4)
// compiled member node returning call7501 (depth = 3)
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7504 == NULL) {
    strlit7504 = alloc_String("identifier");
    gc_root(strlit7504);
  }
// compiled string node returning strlit7504 (depth = 5)
  int op_slot_right_7503 = gc_frame_newslot(strlit7504);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7507 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7506);
// compiled call node returning call7507 (depth = 6)
// compiled member node returning call7507 (depth = 5)
  int op_slot_left_7503 = gc_frame_newslot(call7507);
  params[0] = strlit7504;
  partcv[0] = 1;
  Object opresult7508 = callmethod(call7507, "!=", 1, partcv, params);
// compiled op node returning opresult7508 (depth = 4)
  Object if7502 = done;
  if (istrue(opresult7508)) {
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7509 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7511 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7510);
// compiled call node returning call7511 (depth = 8)
// compiled member node returning call7511 (depth = 7)
  partcv[0] = 0;
  Object call7512 = callmethod(call7511, "new",
    1, partcv, params);
  gc_frame_end(callframe7509);
// compiled call node returning call7512 (depth = 6)
// compiled member node returning call7512 (depth = 5)
  *var_suggestion = call7512;
  if (call7512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7513 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7514 = alloc_Block(NULL, NULL, "parser", 2338);
  gc_frame_newslot(block7514);
// method _apply
  block_savedest(block7514);
  Object closure7515 = createclosure(2, "_apply");
  setclosureframe(closure7515, stackframe);
  addtoclosure(closure7515, var_sym);
  addtoclosure(closure7515, selfslot);
  struct UserObject *uo7515 = (struct UserObject*)block7514;
  uo7515->data[0] = (Object)closure7515;
  Method *meth_meth_parser__apply7515 = addmethod2pos(block7514, "_apply", &meth_parser__apply7515, 0);
  int argcv_meth_parser__apply7515[] = {1};
  meth_meth_parser__apply7515->type = alloc_MethodType(1, argcv_meth_parser__apply7515);
  meth_meth_parser__apply7515->definitionModule = modulename;
  meth_meth_parser__apply7515->definitionLine = 2337;
// compiled block node returning block7514 (depth = 6)
  gc_frame_newslot(block7514);
// call case 4: self request
  params[0] = block7514;
  partcv[0] = 1;
  Object call7533 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7513);
// compiled call node returning call7533 (depth = 5)
  *var_nextToken = call7533;
  if (call7533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7535 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7536 = alloc_Block(NULL, NULL, "parser", 2340);
  gc_frame_newslot(block7536);
// method _apply
  block_savedest(block7536);
  Object closure7537 = createclosure(3, "_apply");
  setclosureframe(closure7537, stackframe);
  addtoclosure(closure7537, var_sym);
  addtoclosure(closure7537, var_nextToken);
  addtoclosure(closure7537, selfslot);
  struct UserObject *uo7537 = (struct UserObject*)block7536;
  uo7537->data[0] = (Object)closure7537;
  Method *meth_meth_parser__apply7537 = addmethod2pos(block7536, "_apply", &meth_parser__apply7537, 0);
  int argcv_meth_parser__apply7537[] = {0};
  meth_meth_parser__apply7537->type = alloc_MethodType(1, argcv_meth_parser__apply7537);
  meth_meth_parser__apply7537->definitionModule = modulename;
  meth_meth_parser__apply7537->definitionLine = 2338;
// compiled block node returning block7536 (depth = 6)
  gc_frame_newslot(block7536);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7543 = alloc_Boolean(0);
// compiled identifier node returning bool7543 (depth = 7)
  int op_slot_right_7542 = gc_frame_newslot(bool7543);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_7542 = gc_frame_newslot(*var_nextToken);
  params[0] = bool7543;
  partcv[0] = 1;
  Object opresult7545 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7545 (depth = 6)
  params[0] = block7536;
  partcv[0] = 1;
  Object call7546 = callmethod(opresult7545, "orElse",
    1, partcv, params);
  gc_frame_end(callframe7535);
// compiled call node returning call7546 (depth = 5)
  Object if7534 = done;
  if (istrue(call7546)) {
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7547 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7548 == NULL) {
    strlit7548 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit7548);
  }
// compiled string node returning strlit7548 (depth = 6)
  gc_frame_newslot(strlit7548);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7548;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7549 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7547);
// compiled call node returning call7549 (depth = 5)
    gc_frame_newslot(call7549);
    if7534 = call7549;
  } else {
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7550 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7551 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  partcv[0] = 0;
  Object call7552 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe7551);
// compiled call node returning call7552 (depth = 7)
// compiled member node returning call7552 (depth = 6)
  gc_frame_newslot(call7552);
// starting to compile identifier node (depth = 6)
  Object bool7553 = alloc_Boolean(0);
// compiled identifier node returning bool7553 (depth = 6)
  gc_frame_newslot(bool7553);
// starting to compile identifier node (depth = 6)
  Object bool7554 = alloc_Boolean(1);
// compiled identifier node returning bool7554 (depth = 6)
  gc_frame_newslot(bool7554);
// starting to compile string node (depth = 6)
  if (strlit7555 == NULL) {
    strlit7555 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit7555);
  }
// compiled string node returning strlit7555 (depth = 6)
  gc_frame_newslot(strlit7555);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7552;
  params[2] = bool7553;
  params[3] = bool7554;
  params[4] = strlit7555;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7556 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7550);
// compiled call node returning call7556 (depth = 5)
    gc_frame_newslot(call7556);
    if7534 = call7556;
  }
// compiled if node returning if7534 (depth = 4)
// Begin line 2345
  setline(2345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7557 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7558 == NULL) {
    strlit7558 = alloc_String("A variable declaration must have a name after the 'var'.");
    gc_root(strlit7558);
  }
// compiled string node returning strlit7558 (depth = 5)
  gc_frame_newslot(strlit7558);
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7560 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7559);
// compiled call node returning call7560 (depth = 6)
// compiled member node returning call7560 (depth = 5)
  gc_frame_newslot(call7560);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7562 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7561);
// compiled call node returning call7562 (depth = 6)
// compiled member node returning call7562 (depth = 5)
  gc_frame_newslot(call7562);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2345
  setline(2345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7558;
  params[1] = call7560;
  params[2] = call7562;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7563 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7557);
// compiled call node returning call7563 (depth = 4)
    gc_frame_newslot(call7563);
    if7502 = call7563;
  } else {
  }
// compiled if node returning if7502 (depth = 3)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7565 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7564);
// compiled call node returning call7565 (depth = 4)
// compiled member node returning call7565 (depth = 3)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7566 = alloc_Boolean(0);
// compiled identifier node returning bool7566 (depth = 4)
  *var_val = bool7566;
  if (bool7566 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call7568 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7567);
// compiled call node returning call7568 (depth = 5)
// compiled member node returning call7568 (depth = 4)
  *var_name = call7568;
  if (call7568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7569 = gc_frame_new();
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool7570 = alloc_Boolean(1);
// compiled identifier node returning bool7570 (depth = 5)
  gc_frame_newslot(bool7570);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  params[0] = bool7570;
  partcv[0] = 1;
  Object call7571 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7569);
// compiled call node returning call7571 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7572 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7573 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7572);
// compiled call node returning call7573 (depth = 5)
// compiled member node returning call7573 (depth = 4)
  *var_dtype = call7573;
  if (call7573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7575 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7574);
// compiled call node returning call7575 (depth = 5)
// compiled member node returning call7575 (depth = 4)
  *var_anns = call7575;
  if (call7575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2354
  setline(2354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7577 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7578 == NULL) {
    strlit7578 = alloc_String("bind");
    gc_root(strlit7578);
  }
// compiled string node returning strlit7578 (depth = 5)
  gc_frame_newslot(strlit7578);
// call case 4: self request
  params[0] = strlit7578;
  partcv[0] = 1;
  Object call7579 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7577);
// compiled call node returning call7579 (depth = 4)
  Object if7576 = done;
  if (istrue(call7579)) {
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7580 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7581 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7580);
// compiled call node returning call7581 (depth = 5)
// compiled member node returning call7581 (depth = 4)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7583 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe7584 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7585 = alloc_Block(NULL, NULL, "parser", 2356);
  gc_frame_newslot(block7585);
// method _apply
  block_savedest(block7585);
  Object closure7586 = createclosure(2, "_apply");
  setclosureframe(closure7586, stackframe);
  addtoclosure(closure7586, var_blocksOK);
  addtoclosure(closure7586, selfslot);
  struct UserObject *uo7586 = (struct UserObject*)block7585;
  uo7586->data[0] = (Object)closure7586;
  Method *meth_meth_parser__apply7586 = addmethod2pos(block7585, "_apply", &meth_parser__apply7586, 0);
  int argcv_meth_parser__apply7586[] = {0};
  meth_meth_parser__apply7586->type = alloc_MethodType(1, argcv_meth_parser__apply7586);
  meth_meth_parser__apply7586->definitionModule = modulename;
  meth_meth_parser__apply7586->definitionLine = 2356;
// compiled block node returning block7585 (depth = 8)
  gc_frame_newslot(block7585);
// call case 4: self request
  params[0] = block7585;
  partcv[0] = 1;
  Object call7590 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7584);
// compiled call node returning call7590 (depth = 7)
  partcv[0] = 0;
  Object call7591 = callmethod(call7590, "not",
    1, partcv, params);
  gc_frame_end(callframe7583);
// compiled call node returning call7591 (depth = 6)
// compiled member node returning call7591 (depth = 5)
  Object if7582 = done;
  if (istrue(call7591)) {
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7592 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7593 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7594 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7593);
// compiled call node returning call7594 (depth = 9)
// compiled member node returning call7594 (depth = 8)
  partcv[0] = 0;
  Object call7595 = callmethod(call7594, "empty",
    1, partcv, params);
  gc_frame_end(callframe7592);
// compiled call node returning call7595 (depth = 7)
// compiled member node returning call7595 (depth = 6)
  *var_suggestions = call7595;
  if (call7595 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7596 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7598 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7597);
// compiled call node returning call7598 (depth = 9)
// compiled member node returning call7598 (depth = 8)
  partcv[0] = 0;
  Object call7599 = callmethod(call7598, "new",
    1, partcv, params);
  gc_frame_end(callframe7596);
// compiled call node returning call7599 (depth = 7)
// compiled member node returning call7599 (depth = 6)
  *var_suggestion = call7599;
  if (call7599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7600 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7601 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7600);
// compiled call node returning call7601 (depth = 6)
  *var_nextTok = call7601;
  if (call7601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_7603 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_7603 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7605 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7605 (depth = 6)
  Object if7602 = done;
  if (istrue(opresult7605)) {
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7606 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7607 == NULL) {
    strlit7607 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7607);
  }
// compiled string node returning strlit7607 (depth = 7)
  gc_frame_newslot(strlit7607);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7607;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7608 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7606);
// compiled call node returning call7608 (depth = 6)
    gc_frame_newslot(call7608);
    if7602 = call7608;
  } else {
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7609 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7610 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call7611 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7610);
// compiled call node returning call7611 (depth = 8)
// compiled member node returning call7611 (depth = 7)
  gc_frame_newslot(call7611);
// starting to compile identifier node (depth = 7)
  Object bool7612 = alloc_Boolean(1);
// compiled identifier node returning bool7612 (depth = 7)
  gc_frame_newslot(bool7612);
// starting to compile identifier node (depth = 7)
  Object bool7613 = alloc_Boolean(0);
// compiled identifier node returning bool7613 (depth = 7)
  gc_frame_newslot(bool7613);
// starting to compile string node (depth = 7)
  if (strlit7614 == NULL) {
    strlit7614 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7614);
  }
// compiled string node returning strlit7614 (depth = 7)
  gc_frame_newslot(strlit7614);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call7611;
  params[2] = bool7612;
  params[3] = bool7613;
  params[4] = strlit7614;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7615 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7609);
// compiled call node returning call7615 (depth = 6)
    gc_frame_newslot(call7615);
    if7602 = call7615;
  }
// compiled if node returning if7602 (depth = 5)
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7616 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7617 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7616);
// compiled call node returning call7617 (depth = 5)
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7618 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7619 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7620 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7619);
// compiled call node returning call7620 (depth = 9)
// compiled member node returning call7620 (depth = 8)
  partcv[0] = 0;
  Object call7621 = callmethod(call7620, "new",
    1, partcv, params);
  gc_frame_end(callframe7618);
// compiled call node returning call7621 (depth = 7)
// compiled member node returning call7621 (depth = 6)
  *var_suggestion = call7621;
  if (call7621 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7623 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7624 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call7625 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7624);
// compiled call node returning call7625 (depth = 7)
// compiled member node returning call7625 (depth = 6)
  gc_frame_newslot(call7625);
// starting to compile identifier node (depth = 6)
  Object bool7626 = alloc_Boolean(1);
// compiled identifier node returning bool7626 (depth = 6)
  gc_frame_newslot(bool7626);
// starting to compile identifier node (depth = 6)
  Object bool7627 = alloc_Boolean(0);
// compiled identifier node returning bool7627 (depth = 6)
  gc_frame_newslot(bool7627);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call7625;
  params[2] = bool7626;
  params[3] = bool7627;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7628 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7623);
// compiled call node returning call7628 (depth = 5)
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7629 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7630 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7629);
// compiled call node returning call7630 (depth = 5)
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7631 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7633 == NULL) {
    strlit7633 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit7633);
  }
// compiled string node returning strlit7633 (depth = 7)
  int op_slot_right_7632 = gc_frame_newslot(strlit7633);
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7635 == NULL) {
    strlit7635 = alloc_String("A variable declaration must have a value after the ':='. ");
    gc_root(strlit7635);
  }
// compiled string node returning strlit7635 (depth = 7)
  int op_slot_left_7632 = gc_frame_newslot(strlit7635);
  params[0] = strlit7633;
  partcv[0] = 1;
  Object opresult7636 = callmethod(strlit7635, "++", 1, partcv, params);
// compiled op node returning opresult7636 (depth = 6)
  gc_frame_newslot(opresult7636);
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7638 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7637);
// compiled call node returning call7638 (depth = 7)
// compiled member node returning call7638 (depth = 6)
  gc_frame_newslot(call7638);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7640 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7641 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7640);
// compiled call node returning call7641 (depth = 8)
// compiled member node returning call7641 (depth = 7)
  int op_slot_right_7639 = gc_frame_newslot(call7641);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7644 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7643);
// compiled call node returning call7644 (depth = 8)
// compiled member node returning call7644 (depth = 7)
  int op_slot_left_7639 = gc_frame_newslot(call7644);
  params[0] = call7641;
  partcv[0] = 1;
  Object sum7645 = callmethod(call7644, "+", 1, partcv, params);
// compiled op node returning sum7645 (depth = 6)
  gc_frame_newslot(sum7645);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7636;
  params[1] = call7638;
  params[2] = sum7645;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7646 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7631);
// compiled call node returning call7646 (depth = 5)
    gc_frame_newslot(call7646);
    if7582 = call7646;
  } else {
  }
// compiled if node returning if7582 (depth = 4)
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7648 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7647);
// compiled call node returning call7648 (depth = 6)
// compiled member node returning call7648 (depth = 5)
  *var_val = call7648;
  if (call7648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7576 = done;
  } else {
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7653 == NULL) {
    strlit7653 = alloc_String("=");
    gc_root(strlit7653);
  }
// compiled string node returning strlit7653 (depth = 7)
  int op_slot_right_7652 = gc_frame_newslot(strlit7653);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7655 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7656 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7655);
// compiled call node returning call7656 (depth = 8)
// compiled member node returning call7656 (depth = 7)
  int op_slot_left_7652 = gc_frame_newslot(call7656);
  params[0] = strlit7653;
  partcv[0] = 1;
  Object opresult7657 = callmethod(call7656, "==", 1, partcv, params);
// compiled op node returning opresult7657 (depth = 6)
  int op_slot_right_7651 = gc_frame_newslot(opresult7657);
// starting to compile call node (depth = 6)
  int callframe7659 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7660 == NULL) {
    strlit7660 = alloc_String("op");
    gc_root(strlit7660);
  }
// compiled string node returning strlit7660 (depth = 7)
  gc_frame_newslot(strlit7660);
// call case 4: self request
  params[0] = strlit7660;
  partcv[0] = 1;
  Object call7661 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7659);
// compiled call node returning call7661 (depth = 6)
  int op_slot_left_7651 = gc_frame_newslot(call7661);
  params[0] = opresult7657;
  partcv[0] = 1;
  Object opresult7662 = callmethod(call7661, "&&", 1, partcv, params);
// compiled op node returning opresult7662 (depth = 5)
  Object if7650 = done;
  if (istrue(opresult7662)) {
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7663 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7664 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7665 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7664);
// compiled call node returning call7665 (depth = 9)
// compiled member node returning call7665 (depth = 8)
  partcv[0] = 0;
  Object call7666 = callmethod(call7665, "empty",
    1, partcv, params);
  gc_frame_end(callframe7663);
// compiled call node returning call7666 (depth = 7)
// compiled member node returning call7666 (depth = 6)
  *var_suggestions = call7666;
  if (call7666 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7667 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7669 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7668);
// compiled call node returning call7669 (depth = 9)
// compiled member node returning call7669 (depth = 8)
  partcv[0] = 0;
  Object call7670 = callmethod(call7669, "new",
    1, partcv, params);
  gc_frame_end(callframe7667);
// compiled call node returning call7670 (depth = 7)
// compiled member node returning call7670 (depth = 6)
  *var_suggestion = call7670;
  if (call7670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7671 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit7672 == NULL) {
    strlit7672 = alloc_String(":=");
    gc_root(strlit7672);
  }
// compiled string node returning strlit7672 (depth = 6)
  gc_frame_newslot(strlit7672);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit7672;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7673 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7671);
// compiled call node returning call7673 (depth = 5)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7674 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7675 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7674);
// compiled call node returning call7675 (depth = 5)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7676 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7677 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7678 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7677);
// compiled call node returning call7678 (depth = 9)
// compiled member node returning call7678 (depth = 8)
  partcv[0] = 0;
  Object call7679 = callmethod(call7678, "new",
    1, partcv, params);
  gc_frame_end(callframe7676);
// compiled call node returning call7679 (depth = 7)
// compiled member node returning call7679 (depth = 6)
  *var_suggestion = call7679;
  if (call7679 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7681 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varTok (depth = 6)
  gc_frame_newslot(*var_varTok);
// starting to compile string node (depth = 6)
  if (strlit7682 == NULL) {
    strlit7682 = alloc_String("def");
    gc_root(strlit7682);
  }
// compiled string node returning strlit7682 (depth = 6)
  gc_frame_newslot(strlit7682);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_varTok;
  params[1] = strlit7682;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7683 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7681);
// compiled call node returning call7683 (depth = 5)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7684 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7685 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7684);
// compiled call node returning call7685 (depth = 5)
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7686 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7687 == NULL) {
    strlit7687 = alloc_String("A variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.");
    gc_root(strlit7687);
  }
// compiled string node returning strlit7687 (depth = 6)
  gc_frame_newslot(strlit7687);
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7689 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7688);
// compiled call node returning call7689 (depth = 7)
// compiled member node returning call7689 (depth = 6)
  gc_frame_newslot(call7689);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7690 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7691 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7690);
// compiled call node returning call7691 (depth = 7)
// compiled member node returning call7691 (depth = 6)
  gc_frame_newslot(call7691);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7693 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7692);
// compiled call node returning call7693 (depth = 7)
// compiled member node returning call7693 (depth = 6)
  gc_frame_newslot(call7693);
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7687;
  params[1] = call7689;
  params[2] = call7691;
  params[3] = call7693;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7694 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7686);
// compiled call node returning call7694 (depth = 5)
    gc_frame_newslot(call7694);
    if7650 = call7694;
  } else {
  }
// compiled if node returning if7650 (depth = 4)
    gc_frame_newslot(if7650);
    if7576 = if7650;
  }
// compiled if node returning if7576 (depth = 3)
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7695 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call7696 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7695);
// compiled call node returning call7696 (depth = 3)
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7697 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7699 = callmethod(*var_ast, "varDecNode",
    1, partcv, params);
  gc_frame_end(callframe7698);
// compiled call node returning call7699 (depth = 6)
// compiled member node returning call7699 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7700 = callmethod(call7699, "new",
    1, partcv, params);
  gc_frame_end(callframe7697);
// compiled call node returning call7700 (depth = 4)
  *var_o = call7700;
  if (call7700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7703 = alloc_Boolean(0);
// compiled identifier node returning bool7703 (depth = 5)
  int op_slot_right_7702 = gc_frame_newslot(bool7703);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_7702 = gc_frame_newslot(*var_anns);
  params[0] = bool7703;
  partcv[0] = 1;
  Object opresult7705 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult7705 (depth = 4)
  Object if7701 = done;
  if (istrue(opresult7705)) {
// starting to compile call node (depth = 4)
  int callframe7706 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7707 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call7708 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7707);
// compiled call node returning call7708 (depth = 6)
// compiled member node returning call7708 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7709 = callmethod(call7708, "addAll",
    1, partcv, params);
  gc_frame_end(callframe7706);
// compiled call node returning call7709 (depth = 4)
    gc_frame_newslot(call7709);
    if7701 = call7709;
  } else {
  }
// compiled if node returning if7701 (depth = 3)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7710 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultVarVisibility (depth = 4)
  gc_frame_newslot(*var_defaultVarVisibility);
// starting to compile string node (depth = 4)
  if (strlit7711 == NULL) {
    strlit7711 = alloc_String("confidential");
    gc_root(strlit7711);
  }
// compiled string node returning strlit7711 (depth = 4)
  gc_frame_newslot(strlit7711);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultVarVisibility;
  params[2] = strlit7711;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7712 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7710);
// compiled call node returning call7712 (depth = 3)
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7713 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7714 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7713);
// compiled call node returning call7714 (depth = 3)
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7715 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7716 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7715);
// compiled call node returning call7716 (depth = 4)
// compiled member node returning call7716 (depth = 3)
    gc_frame_newslot(call7716);
    if7483 = call7716;
  } else {
  }
// compiled if node returning if7483 (depth = 2)
  gc_frame_end(frame);
  return if7483;
}
Object meth_parser__apply7727(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7728 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7729 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7728);
// compiled call node returning call7729 (depth = 5)
  gc_frame_end(frame);
  return call7729;
}
Object meth_parser__apply7735(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe7736 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7737 == NULL) {
    strlit7737 = alloc_String("comma");
    gc_root(strlit7737);
  }
// compiled string node returning strlit7737 (depth = 8)
  gc_frame_newslot(strlit7737);
// call case 4: self request
  params[0] = strlit7737;
  partcv[0] = 1;
  Object call7738 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7736);
// compiled call node returning call7738 (depth = 7)
  gc_frame_end(frame);
  return call7738;
}
Object meth_parser__apply7753(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe7754 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7755 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7754);
// compiled call node returning call7755 (depth = 12)
  gc_frame_end(frame);
  return call7755;
}
Object meth_parser__apply7741(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call7743 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7742);
// compiled call node returning call7743 (depth = 9)
// compiled member node returning call7743 (depth = 8)
  *var_tmp = call7743;
  if (call7743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7745 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7746 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7745);
// compiled call node returning call7746 (depth = 7)
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7748 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7747);
// compiled call node returning call7748 (depth = 8)
// compiled member node returning call7748 (depth = 7)
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7750 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe7751 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block7752 = alloc_Block(NULL, NULL, "parser", 2408);
  gc_frame_newslot(block7752);
// method _apply
  block_savedest(block7752);
  Object closure7753 = createclosure(2, "_apply");
  setclosureframe(closure7753, stackframe);
  addtoclosure(closure7753, var_blocksOK);
  addtoclosure(closure7753, selfslot);
  struct UserObject *uo7753 = (struct UserObject*)block7752;
  uo7753->data[0] = (Object)closure7753;
  Method *meth_meth_parser__apply7753 = addmethod2pos(block7752, "_apply", &meth_parser__apply7753, 0);
  int argcv_meth_parser__apply7753[] = {0};
  meth_meth_parser__apply7753->type = alloc_MethodType(1, argcv_meth_parser__apply7753);
  meth_meth_parser__apply7753->definitionModule = modulename;
  meth_meth_parser__apply7753->definitionLine = 2408;
// compiled block node returning block7752 (depth = 11)
  gc_frame_newslot(block7752);
// call case 4: self request
  params[0] = block7752;
  partcv[0] = 1;
  Object call7757 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7751);
// compiled call node returning call7757 (depth = 10)
  partcv[0] = 0;
  Object call7758 = callmethod(call7757, "not",
    1, partcv, params);
  gc_frame_end(callframe7750);
// compiled call node returning call7758 (depth = 9)
// compiled member node returning call7758 (depth = 8)
  Object if7749 = done;
  if (istrue(call7758)) {
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7759 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7760 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7761 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7760);
// compiled call node returning call7761 (depth = 12)
// compiled member node returning call7761 (depth = 11)
  partcv[0] = 0;
  Object call7762 = callmethod(call7761, "empty",
    1, partcv, params);
  gc_frame_end(callframe7759);
// compiled call node returning call7762 (depth = 10)
// compiled member node returning call7762 (depth = 9)
  *var_suggestions = call7762;
  if (call7762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7763 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7764 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7765 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7764);
// compiled call node returning call7765 (depth = 12)
// compiled member node returning call7765 (depth = 11)
  partcv[0] = 0;
  Object call7766 = callmethod(call7765, "new",
    1, partcv, params);
  gc_frame_end(callframe7763);
// compiled call node returning call7766 (depth = 10)
// compiled member node returning call7766 (depth = 9)
  *var_suggestion = call7766;
  if (call7766 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7767 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7768 == NULL) {
    strlit7768 = alloc_String("rsquare");
    gc_root(strlit7768);
  }
// compiled string node returning strlit7768 (depth = 10)
  gc_frame_newslot(strlit7768);
// call case 4: self request
  params[0] = strlit7768;
  partcv[0] = 1;
  Object call7769 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7767);
// compiled call node returning call7769 (depth = 9)
  *var_nextTok = call7769;
  if (call7769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_7771 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_7771 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7773 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7773 (depth = 9)
  Object if7770 = done;
  if (istrue(opresult7773)) {
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7774 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7775 == NULL) {
    strlit7775 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7775);
  }
// compiled string node returning strlit7775 (depth = 10)
  gc_frame_newslot(strlit7775);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit7775;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7776 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7774);
// compiled call node returning call7776 (depth = 9)
    gc_frame_newslot(call7776);
    if7770 = call7776;
  } else {
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7777 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7778 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call7779 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7778);
// compiled call node returning call7779 (depth = 11)
// compiled member node returning call7779 (depth = 10)
  gc_frame_newslot(call7779);
// starting to compile identifier node (depth = 10)
  Object bool7780 = alloc_Boolean(1);
// compiled identifier node returning bool7780 (depth = 10)
  gc_frame_newslot(bool7780);
// starting to compile identifier node (depth = 10)
  Object bool7781 = alloc_Boolean(0);
// compiled identifier node returning bool7781 (depth = 10)
  gc_frame_newslot(bool7781);
// starting to compile string node (depth = 10)
  if (strlit7782 == NULL) {
    strlit7782 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7782);
  }
// compiled string node returning strlit7782 (depth = 10)
  gc_frame_newslot(strlit7782);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call7779;
  params[2] = bool7780;
  params[3] = bool7781;
  params[4] = strlit7782;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7783 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7777);
// compiled call node returning call7783 (depth = 9)
    gc_frame_newslot(call7783);
    if7770 = call7783;
  }
// compiled if node returning if7770 (depth = 8)
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7784 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7785 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7784);
// compiled call node returning call7785 (depth = 8)
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7786 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7788 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7787);
// compiled call node returning call7788 (depth = 12)
// compiled member node returning call7788 (depth = 11)
  partcv[0] = 0;
  Object call7789 = callmethod(call7788, "new",
    1, partcv, params);
  gc_frame_end(callframe7786);
// compiled call node returning call7789 (depth = 10)
// compiled member node returning call7789 (depth = 9)
  *var_suggestion = call7789;
  if (call7789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7791 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7792 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7793 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7792);
// compiled call node returning call7793 (depth = 10)
// compiled member node returning call7793 (depth = 9)
  gc_frame_newslot(call7793);
// starting to compile identifier node (depth = 9)
  Object bool7794 = alloc_Boolean(1);
// compiled identifier node returning bool7794 (depth = 9)
  gc_frame_newslot(bool7794);
// starting to compile identifier node (depth = 9)
  Object bool7795 = alloc_Boolean(0);
// compiled identifier node returning bool7795 (depth = 9)
  gc_frame_newslot(bool7795);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call7793;
  params[2] = bool7794;
  params[3] = bool7795;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7796 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7791);
// compiled call node returning call7796 (depth = 8)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7797 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7798 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7797);
// compiled call node returning call7798 (depth = 8)
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7799 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7800 == NULL) {
    strlit7800 = alloc_String("A list must contain zero or more valid expressions separated by commas.");
    gc_root(strlit7800);
  }
// compiled string node returning strlit7800 (depth = 9)
  gc_frame_newslot(strlit7800);
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7802 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7801);
// compiled call node returning call7802 (depth = 10)
// compiled member node returning call7802 (depth = 9)
  gc_frame_newslot(call7802);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7804 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7803);
// compiled call node returning call7804 (depth = 10)
// compiled member node returning call7804 (depth = 9)
  gc_frame_newslot(call7804);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7800;
  params[1] = call7802;
  params[2] = call7804;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7805 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7799);
// compiled call node returning call7805 (depth = 8)
    gc_frame_newslot(call7805);
    if7749 = call7805;
  } else {
  }
// compiled if node returning if7749 (depth = 7)
  gc_frame_end(frame);
  return if7749;
}
Object meth_parser__apply7732(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7733 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7734 = alloc_Block(NULL, NULL, "parser", 2404);
  gc_frame_newslot(block7734);
// method _apply
  block_savedest(block7734);
  Object closure7735 = createclosure(1, "_apply");
  setclosureframe(closure7735, stackframe);
  addtoclosure(closure7735, selfslot);
  struct UserObject *uo7735 = (struct UserObject*)block7734;
  uo7735->data[0] = (Object)closure7735;
  Method *meth_meth_parser__apply7735 = addmethod2pos(block7734, "_apply", &meth_parser__apply7735, 0);
  int argcv_meth_parser__apply7735[] = {0};
  meth_meth_parser__apply7735->type = alloc_MethodType(1, argcv_meth_parser__apply7735);
  meth_meth_parser__apply7735->definitionModule = modulename;
  meth_meth_parser__apply7735->definitionLine = 2400;
// compiled block node returning block7734 (depth = 6)
  gc_frame_newslot(block7734);
// starting to compile block node (depth = 6)
  Object block7740 = alloc_Block(NULL, NULL, "parser", 2404);
  gc_frame_newslot(block7740);
// method _apply
  block_savedest(block7740);
  Object closure7741 = createclosure(8, "_apply");
  setclosureframe(closure7741, stackframe);
  addtoclosure(closure7741, var_values);
  addtoclosure(closure7741, var_tmp);
  addtoclosure(closure7741, var_params);
  addtoclosure(closure7741, var_blocksOK);
  addtoclosure(closure7741, var_errormessages);
  addtoclosure(closure7741, var_sym);
  addtoclosure(closure7741, var_lastToken);
  addtoclosure(closure7741, selfslot);
  struct UserObject *uo7741 = (struct UserObject*)block7740;
  uo7741->data[0] = (Object)closure7741;
  Method *meth_meth_parser__apply7741 = addmethod2pos(block7740, "_apply", &meth_parser__apply7741, 0);
  int argcv_meth_parser__apply7741[] = {0};
  meth_meth_parser__apply7741->type = alloc_MethodType(1, argcv_meth_parser__apply7741);
  meth_meth_parser__apply7741->definitionModule = modulename;
  meth_meth_parser__apply7741->definitionLine = 2400;
// compiled block node returning block7740 (depth = 6)
  gc_frame_newslot(block7740);
// call case 5: prelude request
  params[0] = block7734;
  params[1] = block7740;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7807 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7733);
// compiled call node returning call7807 (depth = 5)
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7809 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7808);
// compiled call node returning call7809 (depth = 7)
// compiled member node returning call7809 (depth = 6)
  *var_tmp = call7809;
  if (call7809 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7811 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7812 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7811);
// compiled call node returning call7812 (depth = 5)
  gc_frame_end(frame);
  return call7812;
}
Object meth_parser_doarray7717(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doarray (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doarray");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tmp = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tmp");
  Object *var_params = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "params");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7719 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7720 == NULL) {
    strlit7720 = alloc_String("lsquare");
    gc_root(strlit7720);
  }
// compiled string node returning strlit7720 (depth = 4)
  gc_frame_newslot(strlit7720);
// call case 4: self request
  params[0] = strlit7720;
  partcv[0] = 1;
  Object call7721 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7719);
// compiled call node returning call7721 (depth = 3)
  Object if7718 = done;
  if (istrue(call7721)) {
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7723 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7722);
// compiled call node returning call7723 (depth = 4)
// compiled member node returning call7723 (depth = 3)
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7724 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7724 (depth = 4)
  *var_params = array7724;
  if (array7724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7725 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7726 = alloc_Block(NULL, NULL, "parser", 2403);
  gc_frame_newslot(block7726);
// method _apply
  block_savedest(block7726);
  Object closure7727 = createclosure(2, "_apply");
  setclosureframe(closure7727, stackframe);
  addtoclosure(closure7727, var_blocksOK);
  addtoclosure(closure7727, selfslot);
  struct UserObject *uo7727 = (struct UserObject*)block7726;
  uo7727->data[0] = (Object)closure7727;
  Method *meth_meth_parser__apply7727 = addmethod2pos(block7726, "_apply", &meth_parser__apply7727, 0);
  int argcv_meth_parser__apply7727[] = {0};
  meth_meth_parser__apply7727->type = alloc_MethodType(1, argcv_meth_parser__apply7727);
  meth_meth_parser__apply7727->definitionModule = modulename;
  meth_meth_parser__apply7727->definitionLine = 2400;
// compiled block node returning block7726 (depth = 4)
  gc_frame_newslot(block7726);
// starting to compile block node (depth = 4)
  Object block7731 = alloc_Block(NULL, NULL, "parser", 2403);
  gc_frame_newslot(block7731);
// method _apply
  block_savedest(block7731);
  Object closure7732 = createclosure(8, "_apply");
  setclosureframe(closure7732, stackframe);
  addtoclosure(closure7732, var_values);
  addtoclosure(closure7732, var_tmp);
  addtoclosure(closure7732, var_params);
  addtoclosure(closure7732, var_blocksOK);
  addtoclosure(closure7732, var_errormessages);
  addtoclosure(closure7732, var_sym);
  addtoclosure(closure7732, var_lastToken);
  addtoclosure(closure7732, selfslot);
  struct UserObject *uo7732 = (struct UserObject*)block7731;
  uo7732->data[0] = (Object)closure7732;
  Method *meth_meth_parser__apply7732 = addmethod2pos(block7731, "_apply", &meth_parser__apply7732, 0);
  int argcv_meth_parser__apply7732[] = {0};
  meth_meth_parser__apply7732->type = alloc_MethodType(1, argcv_meth_parser__apply7732);
  meth_meth_parser__apply7732->definitionModule = modulename;
  meth_meth_parser__apply7732->definitionLine = 2400;
// compiled block node returning block7731 (depth = 4)
  gc_frame_newslot(block7731);
// call case 4: self request
  params[0] = block7726;
  params[1] = block7731;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7814 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7725);
// compiled call node returning call7814 (depth = 3)
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7817 == NULL) {
    strlit7817 = alloc_String("rsquare");
    gc_root(strlit7817);
  }
// compiled string node returning strlit7817 (depth = 5)
  int op_slot_right_7816 = gc_frame_newslot(strlit7817);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7820 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7819);
// compiled call node returning call7820 (depth = 6)
// compiled member node returning call7820 (depth = 5)
  int op_slot_left_7816 = gc_frame_newslot(call7820);
  params[0] = strlit7817;
  partcv[0] = 1;
  Object opresult7821 = callmethod(call7820, "!=", 1, partcv, params);
// compiled op node returning opresult7821 (depth = 4)
  Object if7815 = done;
  if (istrue(opresult7821)) {
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7822 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7824 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7823);
// compiled call node returning call7824 (depth = 8)
// compiled member node returning call7824 (depth = 7)
  partcv[0] = 0;
  Object call7825 = callmethod(call7824, "new",
    1, partcv, params);
  gc_frame_end(callframe7822);
// compiled call node returning call7825 (depth = 6)
// compiled member node returning call7825 (depth = 5)
  *var_suggestion = call7825;
  if (call7825 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7826 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7827 == NULL) {
    strlit7827 = alloc_String("]");
    gc_root(strlit7827);
  }
// compiled string node returning strlit7827 (depth = 5)
  gc_frame_newslot(strlit7827);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7827;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7828 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7826);
// compiled call node returning call7828 (depth = 4)
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7829 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7830 == NULL) {
    strlit7830 = alloc_String("A list beginning with a '[' must end with a ']'.");
    gc_root(strlit7830);
  }
// compiled string node returning strlit7830 (depth = 5)
  gc_frame_newslot(strlit7830);
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7832 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7831);
// compiled call node returning call7832 (depth = 6)
// compiled member node returning call7832 (depth = 5)
  gc_frame_newslot(call7832);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7835 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7834);
// compiled call node returning call7835 (depth = 7)
// compiled member node returning call7835 (depth = 6)
  int op_slot_right_7833 = gc_frame_newslot(call7835);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7837 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7838 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7837);
// compiled call node returning call7838 (depth = 7)
// compiled member node returning call7838 (depth = 6)
  int op_slot_left_7833 = gc_frame_newslot(call7838);
  params[0] = call7835;
  partcv[0] = 1;
  Object sum7839 = callmethod(call7838, "+", 1, partcv, params);
// compiled op node returning sum7839 (depth = 5)
  gc_frame_newslot(sum7839);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7830;
  params[1] = call7832;
  params[2] = sum7839;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7840 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7829);
// compiled call node returning call7840 (depth = 4)
    gc_frame_newslot(call7840);
    if7815 = call7840;
  } else {
  }
// compiled if node returning if7815 (depth = 3)
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7841 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7843 = callmethod(*var_ast, "arrayNode",
    1, partcv, params);
  gc_frame_end(callframe7842);
// compiled call node returning call7843 (depth = 6)
// compiled member node returning call7843 (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call7844 = callmethod(call7843, "new",
    1, partcv, params);
  gc_frame_end(callframe7841);
// compiled call node returning call7844 (depth = 4)
  *var_o = call7844;
  if (call7844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7845 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7846 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7845);
// compiled call node returning call7846 (depth = 3)
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7847 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7848 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7847);
// compiled call node returning call7848 (depth = 4)
// compiled member node returning call7848 (depth = 3)
    gc_frame_newslot(call7848);
    if7718 = call7848;
  } else {
  }
// compiled if node returning if7718 (depth = 2)
  gc_frame_end(frame);
  return if7718;
}
Object meth_parser_dodialect7849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dodialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dodialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7853 == NULL) {
    strlit7853 = alloc_String("dialect");
    gc_root(strlit7853);
  }
// compiled string node returning strlit7853 (depth = 5)
  int op_slot_right_7852 = gc_frame_newslot(strlit7853);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7855 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7856 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7855);
// compiled call node returning call7856 (depth = 6)
// compiled member node returning call7856 (depth = 5)
  int op_slot_left_7852 = gc_frame_newslot(call7856);
  params[0] = strlit7853;
  partcv[0] = 1;
  Object opresult7857 = callmethod(call7856, "==", 1, partcv, params);
// compiled op node returning opresult7857 (depth = 4)
  int op_slot_right_7851 = gc_frame_newslot(opresult7857);
// starting to compile call node (depth = 4)
  int callframe7859 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7860 == NULL) {
    strlit7860 = alloc_String("keyword");
    gc_root(strlit7860);
  }
// compiled string node returning strlit7860 (depth = 5)
  gc_frame_newslot(strlit7860);
// call case 4: self request
  params[0] = strlit7860;
  partcv[0] = 1;
  Object call7861 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7859);
// compiled call node returning call7861 (depth = 4)
  int op_slot_left_7851 = gc_frame_newslot(call7861);
  params[0] = opresult7857;
  partcv[0] = 1;
  Object opresult7862 = callmethod(call7861, "&&", 1, partcv, params);
// compiled op node returning opresult7862 (depth = 3)
  Object if7850 = done;
  if (istrue(opresult7862)) {
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7863 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7864 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7863);
// compiled call node returning call7864 (depth = 4)
// compiled member node returning call7864 (depth = 3)
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7867 == NULL) {
    strlit7867 = alloc_String("string");
    gc_root(strlit7867);
  }
// compiled string node returning strlit7867 (depth = 5)
  int op_slot_right_7866 = gc_frame_newslot(strlit7867);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7869 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7870 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7869);
// compiled call node returning call7870 (depth = 6)
// compiled member node returning call7870 (depth = 5)
  int op_slot_left_7866 = gc_frame_newslot(call7870);
  params[0] = strlit7867;
  partcv[0] = 1;
  Object opresult7871 = callmethod(call7870, "!=", 1, partcv, params);
// compiled op node returning opresult7871 (depth = 4)
  Object if7865 = done;
  if (istrue(opresult7871)) {
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7872 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7873 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7874 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7873);
// compiled call node returning call7874 (depth = 8)
// compiled member node returning call7874 (depth = 7)
  partcv[0] = 0;
  Object call7875 = callmethod(call7874, "new",
    1, partcv, params);
  gc_frame_end(callframe7872);
// compiled call node returning call7875 (depth = 6)
// compiled member node returning call7875 (depth = 5)
  *var_suggestion = call7875;
  if (call7875 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7880 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7879);
// compiled call node returning call7880 (depth = 8)
// compiled member node returning call7880 (depth = 7)
  int op_slot_right_7878 = gc_frame_newslot(call7880);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7882 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7883 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7882);
// compiled call node returning call7883 (depth = 8)
// compiled member node returning call7883 (depth = 7)
  int op_slot_left_7878 = gc_frame_newslot(call7883);
  params[0] = call7880;
  partcv[0] = 1;
  Object opresult7884 = callmethod(call7883, "==", 1, partcv, params);
// compiled op node returning opresult7884 (depth = 6)
  int op_slot_right_7877 = gc_frame_newslot(opresult7884);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7887 == NULL) {
    strlit7887 = alloc_String("identifier");
    gc_root(strlit7887);
  }
// compiled string node returning strlit7887 (depth = 7)
  int op_slot_right_7886 = gc_frame_newslot(strlit7887);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7889 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7890 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7889);
// compiled call node returning call7890 (depth = 8)
// compiled member node returning call7890 (depth = 7)
  int op_slot_left_7886 = gc_frame_newslot(call7890);
  params[0] = strlit7887;
  partcv[0] = 1;
  Object opresult7891 = callmethod(call7890, "==", 1, partcv, params);
// compiled op node returning opresult7891 (depth = 6)
  int op_slot_left_7877 = gc_frame_newslot(opresult7891);
  params[0] = opresult7884;
  partcv[0] = 1;
  Object opresult7892 = callmethod(opresult7891, "&&", 1, partcv, params);
// compiled op node returning opresult7892 (depth = 5)
  Object if7876 = done;
  if (istrue(opresult7892)) {
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7893 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7895 == NULL) {
    strlit7895 = alloc_String("""\x22""");
    gc_root(strlit7895);
  }
// compiled string node returning strlit7895 (depth = 7)
  int op_slot_right_7894 = gc_frame_newslot(strlit7895);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7898 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7899 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7898);
// compiled call node returning call7899 (depth = 9)
// compiled member node returning call7899 (depth = 8)
  int op_slot_right_7897 = gc_frame_newslot(call7899);
// starting to compile string node (depth = 8)
  if (strlit7901 == NULL) {
    strlit7901 = alloc_String("""\x22""");
    gc_root(strlit7901);
  }
// compiled string node returning strlit7901 (depth = 8)
  int op_slot_left_7897 = gc_frame_newslot(strlit7901);
  params[0] = call7899;
  partcv[0] = 1;
  Object opresult7902 = callmethod(strlit7901, "++", 1, partcv, params);
// compiled op node returning opresult7902 (depth = 7)
  int op_slot_left_7894 = gc_frame_newslot(opresult7902);
  params[0] = strlit7895;
  partcv[0] = 1;
  Object opresult7903 = callmethod(opresult7902, "++", 1, partcv, params);
// compiled op node returning opresult7903 (depth = 6)
  gc_frame_newslot(opresult7903);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult7903;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7904 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7893);
// compiled call node returning call7904 (depth = 5)
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7905 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7906 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7905);
// compiled call node returning call7906 (depth = 7)
// compiled member node returning call7906 (depth = 6)
  *var_errorPos = call7906;
  if (call7906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7876 = done;
  } else {
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7908 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7909 == NULL) {
    strlit7909 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7909);
  }
// compiled string node returning strlit7909 (depth = 6)
  gc_frame_newslot(strlit7909);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7909;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7910 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7908);
// compiled call node returning call7910 (depth = 5)
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7912 = alloc_Float64(1);
// compiled num node returning num7912 (depth = 7)
  int op_slot_right_7911 = gc_frame_newslot(num7912);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7916 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7915);
// compiled call node returning call7916 (depth = 9)
// compiled member node returning call7916 (depth = 8)
  int op_slot_right_7914 = gc_frame_newslot(call7916);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7919 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7918);
// compiled call node returning call7919 (depth = 9)
// compiled member node returning call7919 (depth = 8)
  int op_slot_left_7914 = gc_frame_newslot(call7919);
  params[0] = call7916;
  partcv[0] = 1;
  Object sum7920 = callmethod(call7919, "+", 1, partcv, params);
// compiled op node returning sum7920 (depth = 7)
  int op_slot_left_7911 = gc_frame_newslot(sum7920);
  params[0] = num7912;
  partcv[0] = 1;
  Object sum7921 = callmethod(sum7920, "+", 1, partcv, params);
// compiled op node returning sum7921 (depth = 6)
  *var_errorPos = sum7921;
  if (sum7921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7876 = done;
  }
// compiled if node returning if7876 (depth = 4)
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7923 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7924 == NULL) {
    strlit7924 = alloc_String("A dialect statement must have the name of the dialect in quotes after the 'dialect'.");
    gc_root(strlit7924);
  }
// compiled string node returning strlit7924 (depth = 5)
  gc_frame_newslot(strlit7924);
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7925 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7926 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7925);
// compiled call node returning call7926 (depth = 6)
// compiled member node returning call7926 (depth = 5)
  gc_frame_newslot(call7926);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7924;
  params[1] = call7926;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7927 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7923);
// compiled call node returning call7927 (depth = 4)
    gc_frame_newslot(call7927);
    if7865 = call7927;
  } else {
  }
// compiled if node returning if7865 (depth = 3)
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7928 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7929 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7931 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7930);
// compiled call node returning call7931 (depth = 6)
// compiled member node returning call7931 (depth = 5)
  gc_frame_newslot(call7931);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7933 = callmethod(*var_ast, "dialectNode",
    1, partcv, params);
  gc_frame_end(callframe7932);
// compiled call node returning call7933 (depth = 6)
// compiled member node returning call7933 (depth = 5)
  params[0] = call7931;
  partcv[0] = 1;
  Object call7934 = callmethod(call7933, "new",
    1, partcv, params);
  gc_frame_end(callframe7929);
// compiled call node returning call7934 (depth = 4)
  gc_frame_newslot(call7934);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call7934;
  partcv[0] = 1;
  Object call7935 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7928);
// compiled call node returning call7935 (depth = 3)
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7936 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7937 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7936);
// compiled call node returning call7937 (depth = 4)
// compiled member node returning call7937 (depth = 3)
    gc_frame_newslot(call7937);
    if7850 = call7937;
  } else {
  }
// compiled if node returning if7850 (depth = 2)
  gc_frame_end(frame);
  return if7850;
}
Object meth_parser__apply7960(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe7961 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_noBlocks (depth = 9)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call7962 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7961);
// compiled call node returning call7962 (depth = 8)
  gc_frame_end(frame);
  return call7962;
}
Object meth_parser_inheritsdec7938(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_noBlocks = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsdec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inheritsdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_inhNode = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "inhNode");
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7942 == NULL) {
    strlit7942 = alloc_String("inherits");
    gc_root(strlit7942);
  }
// compiled string node returning strlit7942 (depth = 5)
  int op_slot_right_7941 = gc_frame_newslot(strlit7942);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7945 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7944);
// compiled call node returning call7945 (depth = 6)
// compiled member node returning call7945 (depth = 5)
  int op_slot_left_7941 = gc_frame_newslot(call7945);
  params[0] = strlit7942;
  partcv[0] = 1;
  Object opresult7946 = callmethod(call7945, "==", 1, partcv, params);
// compiled op node returning opresult7946 (depth = 4)
  int op_slot_right_7940 = gc_frame_newslot(opresult7946);
// starting to compile call node (depth = 4)
  int callframe7948 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7949 == NULL) {
    strlit7949 = alloc_String("keyword");
    gc_root(strlit7949);
  }
// compiled string node returning strlit7949 (depth = 5)
  gc_frame_newslot(strlit7949);
// call case 4: self request
  params[0] = strlit7949;
  partcv[0] = 1;
  Object call7950 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7948);
// compiled call node returning call7950 (depth = 4)
  int op_slot_left_7940 = gc_frame_newslot(call7950);
  params[0] = opresult7946;
  partcv[0] = 1;
  Object opresult7951 = callmethod(call7950, "&&", 1, partcv, params);
// compiled op node returning opresult7951 (depth = 3)
  Object if7939 = done;
  if (istrue(opresult7951)) {
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7952 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7953 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7952);
// compiled call node returning call7953 (depth = 4)
// compiled member node returning call7953 (depth = 3)
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7954 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7955 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7954);
// compiled call node returning call7955 (depth = 4)
// compiled member node returning call7955 (depth = 3)
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7957 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe7958 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7959 = alloc_Block(NULL, NULL, "parser", 2469);
  gc_frame_newslot(block7959);
// method _apply
  block_savedest(block7959);
  Object closure7960 = createclosure(2, "_apply");
  setclosureframe(closure7960, stackframe);
  addtoclosure(closure7960, var_noBlocks);
  addtoclosure(closure7960, selfslot);
  struct UserObject *uo7960 = (struct UserObject*)block7959;
  uo7960->data[0] = (Object)closure7960;
  Method *meth_meth_parser__apply7960 = addmethod2pos(block7959, "_apply", &meth_parser__apply7960, 0);
  int argcv_meth_parser__apply7960[] = {0};
  meth_meth_parser__apply7960->type = alloc_MethodType(1, argcv_meth_parser__apply7960);
  meth_meth_parser__apply7960->definitionModule = modulename;
  meth_meth_parser__apply7960->definitionLine = 2469;
// compiled block node returning block7959 (depth = 7)
  gc_frame_newslot(block7959);
// call case 4: self request
  params[0] = block7959;
  partcv[0] = 1;
  Object call7964 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7958);
// compiled call node returning call7964 (depth = 6)
  partcv[0] = 0;
  Object call7965 = callmethod(call7964, "not",
    1, partcv, params);
  gc_frame_end(callframe7957);
// compiled call node returning call7965 (depth = 5)
// compiled member node returning call7965 (depth = 4)
  Object if7956 = done;
  if (istrue(call7965)) {
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7966 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7967 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call7968 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7967);
// compiled call node returning call7968 (depth = 8)
// compiled member node returning call7968 (depth = 7)
  partcv[0] = 0;
  Object call7969 = callmethod(call7968, "empty",
    1, partcv, params);
  gc_frame_end(callframe7966);
// compiled call node returning call7969 (depth = 6)
// compiled member node returning call7969 (depth = 5)
  *var_suggestions = call7969;
  if (call7969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7970 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7971 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7972 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7971);
// compiled call node returning call7972 (depth = 8)
// compiled member node returning call7972 (depth = 7)
  partcv[0] = 0;
  Object call7973 = callmethod(call7972, "new",
    1, partcv, params);
  gc_frame_end(callframe7970);
// compiled call node returning call7973 (depth = 6)
// compiled member node returning call7973 (depth = 5)
  *var_suggestion = call7973;
  if (call7973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7974 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7975 == NULL) {
    strlit7975 = alloc_String("rsquare");
    gc_root(strlit7975);
  }
// compiled string node returning strlit7975 (depth = 6)
  gc_frame_newslot(strlit7975);
// call case 4: self request
  params[0] = strlit7975;
  partcv[0] = 1;
  Object call7976 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7974);
// compiled call node returning call7976 (depth = 5)
  *var_nextTok = call7976;
  if (call7976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_7978 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_7978 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7980 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7980 (depth = 5)
  Object if7977 = done;
  if (istrue(opresult7980)) {
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7981 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7982 == NULL) {
    strlit7982 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7982);
  }
// compiled string node returning strlit7982 (depth = 6)
  gc_frame_newslot(strlit7982);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7982;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7983 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7981);
// compiled call node returning call7983 (depth = 5)
    gc_frame_newslot(call7983);
    if7977 = call7983;
  } else {
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7984 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call7986 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7985);
// compiled call node returning call7986 (depth = 7)
// compiled member node returning call7986 (depth = 6)
  gc_frame_newslot(call7986);
// starting to compile identifier node (depth = 6)
  Object bool7987 = alloc_Boolean(1);
// compiled identifier node returning bool7987 (depth = 6)
  gc_frame_newslot(bool7987);
// starting to compile identifier node (depth = 6)
  Object bool7988 = alloc_Boolean(0);
// compiled identifier node returning bool7988 (depth = 6)
  gc_frame_newslot(bool7988);
// starting to compile string node (depth = 6)
  if (strlit7989 == NULL) {
    strlit7989 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7989);
  }
// compiled string node returning strlit7989 (depth = 6)
  gc_frame_newslot(strlit7989);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7986;
  params[2] = bool7987;
  params[3] = bool7988;
  params[4] = strlit7989;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7990 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7984);
// compiled call node returning call7990 (depth = 5)
    gc_frame_newslot(call7990);
    if7977 = call7990;
  }
// compiled if node returning if7977 (depth = 4)
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7991 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7992 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7991);
// compiled call node returning call7992 (depth = 4)
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7993 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7994 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7995 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7994);
// compiled call node returning call7995 (depth = 8)
// compiled member node returning call7995 (depth = 7)
  partcv[0] = 0;
  Object call7996 = callmethod(call7995, "new",
    1, partcv, params);
  gc_frame_end(callframe7993);
// compiled call node returning call7996 (depth = 6)
// compiled member node returning call7996 (depth = 5)
  *var_suggestion = call7996;
  if (call7996 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7998 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call8000 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7999);
// compiled call node returning call8000 (depth = 6)
// compiled member node returning call8000 (depth = 5)
  gc_frame_newslot(call8000);
// starting to compile identifier node (depth = 5)
  Object bool8001 = alloc_Boolean(1);
// compiled identifier node returning bool8001 (depth = 5)
  gc_frame_newslot(bool8001);
// starting to compile identifier node (depth = 5)
  Object bool8002 = alloc_Boolean(0);
// compiled identifier node returning bool8002 (depth = 5)
  gc_frame_newslot(bool8002);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = call8000;
  params[2] = bool8001;
  params[3] = bool8002;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8003 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7998);
// compiled call node returning call8003 (depth = 4)
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8004 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8005 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8004);
// compiled call node returning call8005 (depth = 4)
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8006 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8007 == NULL) {
    strlit8007 = alloc_String("The inherits keyword must be followed by an expression that creates the object being inherited.");
    gc_root(strlit8007);
  }
// compiled string node returning strlit8007 (depth = 5)
  gc_frame_newslot(strlit8007);
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8009 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8008);
// compiled call node returning call8009 (depth = 6)
// compiled member node returning call8009 (depth = 5)
  gc_frame_newslot(call8009);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8011 = alloc_Float64(1);
// compiled num node returning num8011 (depth = 6)
  int op_slot_right_8010 = gc_frame_newslot(num8011);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8014 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8015 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8014);
// compiled call node returning call8015 (depth = 8)
// compiled member node returning call8015 (depth = 7)
  int op_slot_right_8013 = gc_frame_newslot(call8015);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8017 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8018 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8017);
// compiled call node returning call8018 (depth = 8)
// compiled member node returning call8018 (depth = 7)
  int op_slot_left_8013 = gc_frame_newslot(call8018);
  params[0] = call8015;
  partcv[0] = 1;
  Object sum8019 = callmethod(call8018, "+", 1, partcv, params);
// compiled op node returning sum8019 (depth = 6)
  int op_slot_left_8010 = gc_frame_newslot(sum8019);
  params[0] = num8011;
  partcv[0] = 1;
  Object sum8020 = callmethod(sum8019, "+", 1, partcv, params);
// compiled op node returning sum8020 (depth = 5)
  gc_frame_newslot(sum8020);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8007;
  params[1] = call8009;
  params[2] = sum8020;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8021 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8006);
// compiled call node returning call8021 (depth = 4)
    gc_frame_newslot(call8021);
    if7956 = call8021;
  } else {
  }
// compiled if node returning if7956 (depth = 3)
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8022 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8024 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8023);
// compiled call node returning call8024 (depth = 5)
// compiled member node returning call8024 (depth = 4)
  gc_frame_newslot(call8024);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8026 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8025);
// compiled call node returning call8026 (depth = 5)
// compiled member node returning call8026 (depth = 4)
  gc_frame_newslot(call8026);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8024;
  params[1] = call8026;
  partcv[0] = 2;
  Object call8027 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe8022);
// compiled call node returning call8027 (depth = 3)
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8028 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8029 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8030 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8029);
// compiled call node returning call8030 (depth = 6)
// compiled member node returning call8030 (depth = 5)
  gc_frame_newslot(call8030);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8031 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8032 = callmethod(*var_ast, "inheritsNode",
    1, partcv, params);
  gc_frame_end(callframe8031);
// compiled call node returning call8032 (depth = 6)
// compiled member node returning call8032 (depth = 5)
  params[0] = call8030;
  partcv[0] = 1;
  Object call8033 = callmethod(call8032, "new",
    1, partcv, params);
  gc_frame_end(callframe8028);
// compiled call node returning call8033 (depth = 4)
  *var_inhNode = call8033;
  if (call8033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8034 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inhNode (depth = 4)
  gc_frame_newslot(*var_inhNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_inhNode;
  partcv[0] = 1;
  Object call8035 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8034);
// compiled call node returning call8035 (depth = 3)
    gc_frame_newslot(call8035);
    if7939 = call8035;
  } else {
  }
// compiled if node returning if7939 (depth = 2)
  gc_frame_end(frame);
  return if7939;
}
Object meth_parser__apply8065(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8067 == NULL) {
    strlit8067 = alloc_String("rbrace");
    gc_root(strlit8067);
  }
// compiled string node returning strlit8067 (depth = 8)
  int op_slot_right_8066 = gc_frame_newslot(strlit8067);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call8070 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe8069);
// compiled call node returning call8070 (depth = 9)
// compiled member node returning call8070 (depth = 8)
  int op_slot_left_8066 = gc_frame_newslot(call8070);
  params[0] = strlit8067;
  partcv[0] = 1;
  Object opresult8071 = callmethod(call8070, "==", 1, partcv, params);
// compiled op node returning opresult8071 (depth = 7)
  gc_frame_end(frame);
  return opresult8071;
}
Object meth_parser__apply8133(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8134 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8135 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8136 == NULL) {
    strlit8136 = alloc_String("rbrace");
    gc_root(strlit8136);
  }
// compiled string node returning strlit8136 (depth = 8)
  gc_frame_newslot(strlit8136);
// call case 4: self request
  params[0] = strlit8136;
  partcv[0] = 1;
  Object call8137 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8135);
// compiled call node returning call8137 (depth = 7)
  partcv[0] = 0;
  Object call8138 = callmethod(call8137, "not",
    1, partcv, params);
  gc_frame_end(callframe8134);
// compiled call node returning call8138 (depth = 6)
// compiled member node returning call8138 (depth = 5)
  gc_frame_end(frame);
  return call8138;
}
Object meth_parser__apply8141(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sz = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8142 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8143 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8142);
// compiled call node returning call8143 (depth = 6)
// compiled member node returning call8143 (depth = 5)
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8144 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8145 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8144);
// compiled call node returning call8145 (depth = 6)
// compiled member node returning call8145 (depth = 5)
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8146 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8147 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8146);
// compiled call node returning call8147 (depth = 6)
// compiled member node returning call8147 (depth = 5)
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8150 == NULL) {
    strlit8150 = alloc_String("eof");
    gc_root(strlit8150);
  }
// compiled string node returning strlit8150 (depth = 7)
  int op_slot_right_8149 = gc_frame_newslot(strlit8150);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8152 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8153 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8152);
// compiled call node returning call8153 (depth = 8)
// compiled member node returning call8153 (depth = 7)
  int op_slot_left_8149 = gc_frame_newslot(call8153);
  params[0] = strlit8150;
  partcv[0] = 1;
  Object opresult8154 = callmethod(call8153, "==", 1, partcv, params);
// compiled op node returning opresult8154 (depth = 6)
  Object if8148 = done;
  if (istrue(opresult8154)) {
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8157 == NULL) {
    strlit8157 = alloc_String("rbrace");
    gc_root(strlit8157);
  }
// compiled string node returning strlit8157 (depth = 8)
  int op_slot_right_8156 = gc_frame_newslot(strlit8157);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8160 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8159);
// compiled call node returning call8160 (depth = 9)
// compiled member node returning call8160 (depth = 8)
  int op_slot_left_8156 = gc_frame_newslot(call8160);
  params[0] = strlit8157;
  partcv[0] = 1;
  Object opresult8161 = callmethod(call8160, "!=", 1, partcv, params);
// compiled op node returning opresult8161 (depth = 7)
  Object if8155 = done;
  if (istrue(opresult8161)) {
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8162 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8163 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call8164 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8163);
// compiled call node returning call8164 (depth = 11)
// compiled member node returning call8164 (depth = 10)
  partcv[0] = 0;
  Object call8165 = callmethod(call8164, "new",
    1, partcv, params);
  gc_frame_end(callframe8162);
// compiled call node returning call8165 (depth = 9)
// compiled member node returning call8165 (depth = 8)
  *var_suggestion = call8165;
  if (call8165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8166 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8167 == NULL) {
    strlit8167 = alloc_String("}");
    gc_root(strlit8167);
  }
// compiled string node returning strlit8167 (depth = 8)
  gc_frame_newslot(strlit8167);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit8167;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8168 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8166);
// compiled call node returning call8168 (depth = 7)
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8169 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8170 == NULL) {
    strlit8170 = alloc_String("An object literal must end with a '}'.");
    gc_root(strlit8170);
  }
// compiled string node returning strlit8170 (depth = 8)
  gc_frame_newslot(strlit8170);
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8171 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call8172 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8171);
// compiled call node returning call8172 (depth = 9)
// compiled member node returning call8172 (depth = 8)
  gc_frame_newslot(call8172);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8175 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8174);
// compiled call node returning call8175 (depth = 10)
// compiled member node returning call8175 (depth = 9)
  int op_slot_right_8173 = gc_frame_newslot(call8175);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8178 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8177);
// compiled call node returning call8178 (depth = 10)
// compiled member node returning call8178 (depth = 9)
  int op_slot_left_8173 = gc_frame_newslot(call8178);
  params[0] = call8175;
  partcv[0] = 1;
  Object sum8179 = callmethod(call8178, "+", 1, partcv, params);
// compiled op node returning sum8179 (depth = 8)
  gc_frame_newslot(sum8179);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit8170;
  params[1] = call8172;
  params[2] = sum8179;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8180 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8169);
// compiled call node returning call8180 (depth = 7)
    gc_frame_newslot(call8180);
    if8155 = call8180;
  } else {
  }
// compiled if node returning if8155 (depth = 6)
    gc_frame_newslot(if8155);
    if8148 = if8155;
  } else {
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8184 == NULL) {
    strlit8184 = alloc_String("semicolon");
    gc_root(strlit8184);
  }
// compiled string node returning strlit8184 (depth = 9)
  int op_slot_right_8183 = gc_frame_newslot(strlit8184);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8187 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe8186);
// compiled call node returning call8187 (depth = 10)
// compiled member node returning call8187 (depth = 9)
  int op_slot_left_8183 = gc_frame_newslot(call8187);
  params[0] = strlit8184;
  partcv[0] = 1;
  Object opresult8188 = callmethod(call8187, "!=", 1, partcv, params);
// compiled op node returning opresult8188 (depth = 8)
  int op_slot_right_8182 = gc_frame_newslot(opresult8188);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sz (depth = 9)
  int op_slot_right_8190 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call8193 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8192);
// compiled call node returning call8193 (depth = 10)
// compiled member node returning call8193 (depth = 9)
  int op_slot_left_8190 = gc_frame_newslot(call8193);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult8194 = callmethod(call8193, "==", 1, partcv, params);
// compiled op node returning opresult8194 (depth = 8)
  int op_slot_left_8182 = gc_frame_newslot(opresult8194);
  params[0] = opresult8188;
  partcv[0] = 1;
  Object opresult8195 = callmethod(opresult8194, "&&", 1, partcv, params);
// compiled op node returning opresult8195 (depth = 7)
  Object if8181 = done;
  if (istrue(opresult8195)) {
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8196 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8197 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call8198 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8197);
// compiled call node returning call8198 (depth = 11)
// compiled member node returning call8198 (depth = 10)
  partcv[0] = 0;
  Object call8199 = callmethod(call8198, "new",
    1, partcv, params);
  gc_frame_end(callframe8196);
// compiled call node returning call8199 (depth = 9)
// compiled member node returning call8199 (depth = 8)
  *var_suggestion = call8199;
  if (call8199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8200 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8201 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8200);
// compiled call node returning call8201 (depth = 7)
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8202 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8203 == NULL) {
    strlit8203 = alloc_String("An object literal can contain only definitions, variable and method declarations, and statements.");
    gc_root(strlit8203);
  }
// compiled string node returning strlit8203 (depth = 8)
  gc_frame_newslot(strlit8203);
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8205 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8204);
// compiled call node returning call8205 (depth = 9)
// compiled member node returning call8205 (depth = 8)
  gc_frame_newslot(call8205);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8207 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8206);
// compiled call node returning call8207 (depth = 9)
// compiled member node returning call8207 (depth = 8)
  gc_frame_newslot(call8207);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8209 = alloc_Float64(1);
// compiled num node returning num8209 (depth = 9)
  int op_slot_right_8208 = gc_frame_newslot(num8209);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8212 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call8213 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe8212);
// compiled call node returning call8213 (depth = 11)
// compiled member node returning call8213 (depth = 10)
  int op_slot_right_8211 = gc_frame_newslot(call8213);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call8216 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8215);
// compiled call node returning call8216 (depth = 11)
// compiled member node returning call8216 (depth = 10)
  int op_slot_left_8211 = gc_frame_newslot(call8216);
  params[0] = call8213;
  partcv[0] = 1;
  Object sum8217 = callmethod(call8216, "+", 1, partcv, params);
// compiled op node returning sum8217 (depth = 9)
  int op_slot_left_8208 = gc_frame_newslot(sum8217);
  params[0] = num8209;
  partcv[0] = 1;
  Object diff8218 = callmethod(sum8217, "-", 1, partcv, params);
// compiled op node returning diff8218 (depth = 8)
  gc_frame_newslot(diff8218);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit8203;
  params[1] = call8205;
  params[2] = call8207;
  params[3] = diff8218;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8219 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8202);
// compiled call node returning call8219 (depth = 7)
    gc_frame_newslot(call8219);
    if8181 = call8219;
  } else {
  }
// compiled if node returning if8181 (depth = 6)
    gc_frame_newslot(if8181);
    if8148 = if8181;
  }
// compiled if node returning if8148 (depth = 5)
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8220 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8221 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8220);
// compiled call node returning call8221 (depth = 7)
// compiled member node returning call8221 (depth = 6)
  *var_sz = call8221;
  if (call8221 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8232(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8234 == NULL) {
    strlit8234 = alloc_String("lbrace");
    gc_root(strlit8234);
  }
// compiled string node returning strlit8234 (depth = 6)
  int op_slot_right_8233 = gc_frame_newslot(strlit8234);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8236 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call8237 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe8236);
// compiled call node returning call8237 (depth = 7)
// compiled member node returning call8237 (depth = 6)
  int op_slot_left_8233 = gc_frame_newslot(call8237);
  params[0] = strlit8234;
  partcv[0] = 1;
  Object opresult8238 = callmethod(call8237, "!=", 1, partcv, params);
// compiled op node returning opresult8238 (depth = 5)
  gc_frame_end(frame);
  return opresult8238;
}
Object meth_parser__apply8241(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_rbody = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8242 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rbody (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8243 = callmethod(*var_rbody, "push",
    1, partcv, params);
  gc_frame_end(callframe8242);
// compiled call node returning call8243 (depth = 5)
// Begin line 2549
  setline(2549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8245 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8244);
// compiled call node returning call8245 (depth = 7)
// compiled member node returning call8245 (depth = 6)
  *var_n = call8245;
  if (call8245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8254(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_rbody = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8255 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_rbody (depth = 8)
  partcv[0] = 0;
  Object call8256 = callmethod(*var_rbody, "pop",
    1, partcv, params);
  gc_frame_end(callframe8255);
// compiled call node returning call8256 (depth = 7)
// compiled member node returning call8256 (depth = 6)
  *var_p = call8256;
  if (call8256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8257 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  params[0] = *var_p;
  partcv[0] = 1;
  Object call8258 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8257);
// compiled call node returning call8258 (depth = 5)
  gc_frame_end(frame);
  return call8258;
}
Object meth_parser_doobject8036(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_statementToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doobject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doobject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_sz = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "sz");
  Object *var_rbody = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rbody");
  Object *var_n = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "n");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_o = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "o");
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8040 == NULL) {
    strlit8040 = alloc_String("object");
    gc_root(strlit8040);
  }
// compiled string node returning strlit8040 (depth = 5)
  int op_slot_right_8039 = gc_frame_newslot(strlit8040);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8043 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8042);
// compiled call node returning call8043 (depth = 6)
// compiled member node returning call8043 (depth = 5)
  int op_slot_left_8039 = gc_frame_newslot(call8043);
  params[0] = strlit8040;
  partcv[0] = 1;
  Object opresult8044 = callmethod(call8043, "==", 1, partcv, params);
// compiled op node returning opresult8044 (depth = 4)
  int op_slot_right_8038 = gc_frame_newslot(opresult8044);
// starting to compile call node (depth = 4)
  int callframe8046 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8047 == NULL) {
    strlit8047 = alloc_String("keyword");
    gc_root(strlit8047);
  }
// compiled string node returning strlit8047 (depth = 5)
  gc_frame_newslot(strlit8047);
// call case 4: self request
  params[0] = strlit8047;
  partcv[0] = 1;
  Object call8048 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8046);
// compiled call node returning call8048 (depth = 4)
  int op_slot_left_8038 = gc_frame_newslot(call8048);
  params[0] = opresult8044;
  partcv[0] = 1;
  Object opresult8049 = callmethod(call8048, "&&", 1, partcv, params);
// compiled op node returning opresult8049 (depth = 3)
  Object if8037 = done;
  if (istrue(opresult8049)) {
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8050 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8051 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8050);
// compiled call node returning call8051 (depth = 4)
// compiled member node returning call8051 (depth = 3)
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8054 == NULL) {
    strlit8054 = alloc_String("lbrace");
    gc_root(strlit8054);
  }
// compiled string node returning strlit8054 (depth = 5)
  int op_slot_right_8053 = gc_frame_newslot(strlit8054);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8057 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8056);
// compiled call node returning call8057 (depth = 6)
// compiled member node returning call8057 (depth = 5)
  int op_slot_left_8053 = gc_frame_newslot(call8057);
  params[0] = strlit8054;
  partcv[0] = 1;
  Object opresult8058 = callmethod(call8057, "!=", 1, partcv, params);
// compiled op node returning opresult8058 (depth = 4)
  Object if8052 = done;
  if (istrue(opresult8058)) {
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8059 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8061 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8060);
// compiled call node returning call8061 (depth = 8)
// compiled member node returning call8061 (depth = 7)
  partcv[0] = 0;
  Object call8062 = callmethod(call8061, "new",
    1, partcv, params);
  gc_frame_end(callframe8059);
// compiled call node returning call8062 (depth = 6)
// compiled member node returning call8062 (depth = 5)
  *var_suggestion = call8062;
  if (call8062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8063 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8064 = alloc_Block(NULL, NULL, "parser", 2502);
  gc_frame_newslot(block8064);
// method _apply
  block_savedest(block8064);
  Object closure8065 = createclosure(1, "_apply");
  setclosureframe(closure8065, stackframe);
  addtoclosure(closure8065, selfslot);
  struct UserObject *uo8065 = (struct UserObject*)block8064;
  uo8065->data[0] = (Object)closure8065;
  Method *meth_meth_parser__apply8065 = addmethod2pos(block8064, "_apply", &meth_parser__apply8065, 0);
  int argcv_meth_parser__apply8065[] = {1};
  meth_meth_parser__apply8065->type = alloc_MethodType(1, argcv_meth_parser__apply8065);
  meth_meth_parser__apply8065->definitionModule = modulename;
  meth_meth_parser__apply8065->definitionLine = 2501;
// compiled block node returning block8064 (depth = 6)
  gc_frame_newslot(block8064);
// call case 4: self request
  params[0] = block8064;
  partcv[0] = 1;
  Object call8073 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8063);
// compiled call node returning call8073 (depth = 5)
  *var_nextTok = call8073;
  if (call8073 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8076 = alloc_Boolean(0);
// compiled identifier node returning bool8076 (depth = 6)
  int op_slot_right_8075 = gc_frame_newslot(bool8076);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_8075 = gc_frame_newslot(*var_nextTok);
  params[0] = bool8076;
  partcv[0] = 1;
  Object opresult8078 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult8078 (depth = 5)
  Object if8074 = done;
  if (istrue(opresult8078)) {
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8079 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8080 == NULL) {
    strlit8080 = alloc_String(" {}");
    gc_root(strlit8080);
  }
// compiled string node returning strlit8080 (depth = 6)
  gc_frame_newslot(strlit8080);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8080;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8081 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8079);
// compiled call node returning call8081 (depth = 5)
    gc_frame_newslot(call8081);
    if8074 = call8081;
  } else {
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8082 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8083 == NULL) {
    strlit8083 = alloc_String(" {");
    gc_root(strlit8083);
  }
// compiled string node returning strlit8083 (depth = 6)
  gc_frame_newslot(strlit8083);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8083;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8084 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8082);
// compiled call node returning call8084 (depth = 5)
    gc_frame_newslot(call8084);
    if8074 = call8084;
  }
// compiled if node returning if8074 (depth = 4)
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8085 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8086 == NULL) {
    strlit8086 = alloc_String("An object literal must have a '{' after the 'object'.");
    gc_root(strlit8086);
  }
// compiled string node returning strlit8086 (depth = 5)
  gc_frame_newslot(strlit8086);
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8088 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8087);
// compiled call node returning call8088 (depth = 6)
// compiled member node returning call8088 (depth = 5)
  gc_frame_newslot(call8088);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8091 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8090);
// compiled call node returning call8091 (depth = 7)
// compiled member node returning call8091 (depth = 6)
  int op_slot_right_8089 = gc_frame_newslot(call8091);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8093 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8094 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8093);
// compiled call node returning call8094 (depth = 7)
// compiled member node returning call8094 (depth = 6)
  int op_slot_left_8089 = gc_frame_newslot(call8094);
  params[0] = call8091;
  partcv[0] = 1;
  Object sum8095 = callmethod(call8094, "+", 1, partcv, params);
// compiled op node returning sum8095 (depth = 5)
  gc_frame_newslot(sum8095);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8086;
  params[1] = call8088;
  params[2] = sum8095;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8096 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8085);
// compiled call node returning call8096 (depth = 4)
    gc_frame_newslot(call8096);
    if8052 = call8096;
  } else {
  }
// compiled if node returning if8052 (depth = 3)
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8097 = gc_frame_new();
// starting to compile object node (depth = 4)
  Object inheritingObject8098 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8098 = alloc_userobj2(3,4, objclass8098);
  gc_frame_newslot(obj8098);
// OBJECT OUTER DEC outer
  adddatum2(obj8098, self, 0);
  addmethodreal(obj8098,"outer", &reader_parser_outer_8099);
  Object oldself8098 = self;
  struct StackFrameObject *oldstackframe8098 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8098);
  gc_frame_newslot((Object)stackframe);
  self = obj8098;
  Object *oldselfslot8098 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8098 = (*(struct UserObject *)self).data[0], lowerouter8098 = thisouter8098;
  if (inheritingObject8098) {
    struct UserObject *inho8098 = (struct UserObject *)inheritingObject8098;
    while (inho8098->super != GraceDefaultObject) inho8098 = (struct UserObject *)inho8098->super;
    inho8098->super = obj8098;
    self = inheritingObject8098;
    *selfslot = self;
    lowerouter8098 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8098;
  }
if (objclass8098 == NULL) {
  Method *reader8100 = addmethodrealflags(obj8098, "kind",&reader_parser_kind_8100, MFLAG_DEF);
  reader8100->definitionModule = modulename;
  reader8100->definitionLine = 2512;
}
adddatum2(obj8098, alloc_Undefined(), 1);
if (objclass8098 == NULL) {
  Method *reader8101 = addmethodrealflags(obj8098, "register",&reader_parser_register_8101, 0);
  Method *writer8101 = addmethodrealflags(obj8098, "register:=",&writer_parser_register_8101, 0);
  reader8101->definitionModule = modulename;
  writer8101->definitionModule = modulename;
  reader8101->definitionLine = 2513;
  writer8101->definitionLine = 2513;
}
obj8098->flags |= OFLAG_MUTABLE;
adddatum2(obj8098, alloc_Undefined(), 2);
  sourceObject = obj8098;
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8102 == NULL) {
    strlit8102 = alloc_String("lbrace");
    gc_root(strlit8102);
  }
// compiled string node returning strlit8102 (depth = 5)
  adddatum2(obj8098, strlit8102, 1);
  sourceObject = obj8098;
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8103 == NULL) {
    strlit8103 = alloc_String("");
    gc_root(strlit8103);
  }
// compiled string node returning strlit8103 (depth = 5)
  adddatum2(obj8098, strlit8103, 2);
  objclass8098 = obj8098->class;
  objclass8098->definitionModule = modulename;
  objclass8098->definitionLine = 2511;
  (*(struct UserObject *)self).data[0] = lowerouter8098;
  self = oldself8098;
  selfslot = oldselfslot8098;
  stackframe = oldstackframe8098;
// compiled object node returning obj8098 (depth = 4)
  gc_frame_newslot(obj8098);
// call case 6: other member request
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = obj8098;
  partcv[0] = 1;
  Object call8104 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8097);
// compiled call node returning call8104 (depth = 3)
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8105 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8106 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8105);
// compiled call node returning call8106 (depth = 4)
// compiled member node returning call8106 (depth = 3)
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call8110 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8109);
// compiled call node returning call8110 (depth = 6)
// compiled member node returning call8110 (depth = 5)
  int op_slot_right_8108 = gc_frame_newslot(call8110);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8112 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8113 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8112);
// compiled call node returning call8113 (depth = 6)
// compiled member node returning call8113 (depth = 5)
  int op_slot_left_8108 = gc_frame_newslot(call8113);
  params[0] = call8110;
  partcv[0] = 1;
  Object opresult8114 = callmethod(call8113, "==", 1, partcv, params);
// compiled op node returning opresult8114 (depth = 4)
  Object if8107 = done;
  if (istrue(opresult8114)) {
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8116 = alloc_Float64(1);
// compiled num node returning num8116 (depth = 6)
  int op_slot_right_8115 = gc_frame_newslot(num8116);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8118 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8119 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8118);
// compiled call node returning call8119 (depth = 7)
// compiled member node returning call8119 (depth = 6)
  int op_slot_left_8115 = gc_frame_newslot(call8119);
  params[0] = num8116;
  partcv[0] = 1;
  Object diff8120 = callmethod(call8119, "-", 1, partcv, params);
// compiled op node returning diff8120 (depth = 5)
  *var_minIndentLevel = diff8120;
  if (diff8120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8107 = done;
  } else {
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8123 = alloc_Float64(1);
// compiled num node returning num8123 (depth = 6)
  int op_slot_right_8122 = gc_frame_newslot(num8123);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8125 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  partcv[0] = 0;
  Object call8126 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8125);
// compiled call node returning call8126 (depth = 7)
// compiled member node returning call8126 (depth = 6)
  int op_slot_left_8122 = gc_frame_newslot(call8126);
  params[0] = num8123;
  partcv[0] = 1;
  Object sum8127 = callmethod(call8126, "+", 1, partcv, params);
// compiled op node returning sum8127 (depth = 5)
  *var_minIndentLevel = sum8127;
  if (sum8127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8107 = done;
  }
// compiled if node returning if8107 (depth = 3)
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8129 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8130 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8129);
// compiled call node returning call8130 (depth = 5)
// compiled member node returning call8130 (depth = 4)
  *var_sz = call8130;
  if (call8130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8131 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8132 = alloc_Block(NULL, NULL, "parser", 2522);
  gc_frame_newslot(block8132);
// method _apply
  block_savedest(block8132);
  Object closure8133 = createclosure(1, "_apply");
  setclosureframe(closure8133, stackframe);
  addtoclosure(closure8133, selfslot);
  struct UserObject *uo8133 = (struct UserObject*)block8132;
  uo8133->data[0] = (Object)closure8133;
  Method *meth_meth_parser__apply8133 = addmethod2pos(block8132, "_apply", &meth_parser__apply8133, 0);
  int argcv_meth_parser__apply8133[] = {0};
  meth_meth_parser__apply8133->type = alloc_MethodType(1, argcv_meth_parser__apply8133);
  meth_meth_parser__apply8133->definitionModule = modulename;
  meth_meth_parser__apply8133->definitionLine = 2521;
// compiled block node returning block8132 (depth = 4)
  gc_frame_newslot(block8132);
// starting to compile block node (depth = 4)
  Object block8140 = alloc_Block(NULL, NULL, "parser", 2522);
  gc_frame_newslot(block8140);
// method _apply
  block_savedest(block8140);
  Object closure8141 = createclosure(6, "_apply");
  setclosureframe(closure8141, stackframe);
  addtoclosure(closure8141, var_sym);
  addtoclosure(closure8141, var_errormessages);
  addtoclosure(closure8141, var_lastToken);
  addtoclosure(closure8141, var_sz);
  addtoclosure(closure8141, var_values);
  addtoclosure(closure8141, selfslot);
  struct UserObject *uo8141 = (struct UserObject*)block8140;
  uo8141->data[0] = (Object)closure8141;
  Method *meth_meth_parser__apply8141 = addmethod2pos(block8140, "_apply", &meth_parser__apply8141, 0);
  int argcv_meth_parser__apply8141[] = {0};
  meth_meth_parser__apply8141->type = alloc_MethodType(1, argcv_meth_parser__apply8141);
  meth_meth_parser__apply8141->definitionModule = modulename;
  meth_meth_parser__apply8141->definitionLine = 2522;
// compiled block node returning block8140 (depth = 4)
  gc_frame_newslot(block8140);
// call case 5: prelude request
  params[0] = block8132;
  params[1] = block8140;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8224 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8131);
// compiled call node returning call8224 (depth = 3)
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8225 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8226 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8225);
// compiled call node returning call8226 (depth = 4)
// compiled member node returning call8226 (depth = 3)
// Begin line 2545
  setline(2545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8227 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8227 (depth = 4)
  *var_rbody = array8227;
  if (array8227 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8228 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8229 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8228);
// compiled call node returning call8229 (depth = 5)
// compiled member node returning call8229 (depth = 4)
  *var_n = call8229;
  if (call8229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8230 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8231 = alloc_Block(NULL, NULL, "parser", 2547);
  gc_frame_newslot(block8231);
// method _apply
  block_savedest(block8231);
  Object closure8232 = createclosure(2, "_apply");
  setclosureframe(closure8232, stackframe);
  addtoclosure(closure8232, var_n);
  addtoclosure(closure8232, selfslot);
  struct UserObject *uo8232 = (struct UserObject*)block8231;
  uo8232->data[0] = (Object)closure8232;
  Method *meth_meth_parser__apply8232 = addmethod2pos(block8231, "_apply", &meth_parser__apply8232, 0);
  int argcv_meth_parser__apply8232[] = {0};
  meth_meth_parser__apply8232->type = alloc_MethodType(1, argcv_meth_parser__apply8232);
  meth_meth_parser__apply8232->definitionModule = modulename;
  meth_meth_parser__apply8232->definitionLine = 2546;
// compiled block node returning block8231 (depth = 4)
  gc_frame_newslot(block8231);
// starting to compile block node (depth = 4)
  Object block8240 = alloc_Block(NULL, NULL, "parser", 2547);
  gc_frame_newslot(block8240);
// method _apply
  block_savedest(block8240);
  Object closure8241 = createclosure(4, "_apply");
  setclosureframe(closure8241, stackframe);
  addtoclosure(closure8241, var_n);
  addtoclosure(closure8241, var_rbody);
  addtoclosure(closure8241, var_values);
  addtoclosure(closure8241, selfslot);
  struct UserObject *uo8241 = (struct UserObject*)block8240;
  uo8241->data[0] = (Object)closure8241;
  Method *meth_meth_parser__apply8241 = addmethod2pos(block8240, "_apply", &meth_parser__apply8241, 0);
  int argcv_meth_parser__apply8241[] = {0};
  meth_meth_parser__apply8241->type = alloc_MethodType(1, argcv_meth_parser__apply8241);
  meth_meth_parser__apply8241->definitionModule = modulename;
  meth_meth_parser__apply8241->definitionLine = 2547;
// compiled block node returning block8240 (depth = 4)
  gc_frame_newslot(block8240);
// call case 5: prelude request
  params[0] = block8231;
  params[1] = block8240;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8248 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8230);
// compiled call node returning call8248 (depth = 3)
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8249 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8249 (depth = 4)
  *var_body = array8249;
  if (array8249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8250 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8251 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rbody (depth = 6)
  partcv[0] = 0;
  Object call8252 = callmethod(*var_rbody, "indices",
    1, partcv, params);
  gc_frame_end(callframe8251);
// compiled call node returning call8252 (depth = 5)
// compiled member node returning call8252 (depth = 4)
  gc_frame_newslot(call8252);
// starting to compile block node (depth = 4)
  Object block8253 = alloc_Block(NULL, NULL, "parser", 2552);
  gc_frame_newslot(block8253);
// method _apply
  block_savedest(block8253);
  Object closure8254 = createclosure(3, "_apply");
  setclosureframe(closure8254, stackframe);
  addtoclosure(closure8254, var_rbody);
  addtoclosure(closure8254, var_body);
  addtoclosure(closure8254, selfslot);
  struct UserObject *uo8254 = (struct UserObject*)block8253;
  uo8254->data[0] = (Object)closure8254;
  Method *meth_meth_parser__apply8254 = addmethod2pos(block8253, "_apply", &meth_parser__apply8254, 0);
  int argcv_meth_parser__apply8254[] = {1};
  meth_meth_parser__apply8254->type = alloc_MethodType(1, argcv_meth_parser__apply8254);
  meth_meth_parser__apply8254->definitionModule = modulename;
  meth_meth_parser__apply8254->definitionLine = 2552;
// compiled block node returning block8253 (depth = 4)
  gc_frame_newslot(block8253);
// call case 5: prelude request
  params[0] = call8252;
  params[1] = block8253;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8260 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8250);
// compiled call node returning call8260 (depth = 3)
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8261 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8262 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8263 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8262);
// compiled call node returning call8263 (depth = 5)
// compiled member node returning call8263 (depth = 4)
  gc_frame_newslot(call8263);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8263;
  partcv[0] = 1;
  Object call8264 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8261);
// compiled call node returning call8264 (depth = 3)
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8265 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
  Object bool8266 = alloc_Boolean(0);
// compiled identifier node returning bool8266 (depth = 5)
  gc_frame_newslot(bool8266);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8267 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8268 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8267);
// compiled call node returning call8268 (depth = 6)
// compiled member node returning call8268 (depth = 5)
  params[0] = *var_body;
  params[1] = bool8266;
  partcv[0] = 2;
  Object call8269 = callmethod(call8268, "new",
    1, partcv, params);
  gc_frame_end(callframe8265);
// compiled call node returning call8269 (depth = 4)
  *var_o = call8269;
  if (call8269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8270 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8271 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8270);
// compiled call node returning call8271 (depth = 3)
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8037 = done;
  } else {
  }
// compiled if node returning if8037 (depth = 2)
  gc_frame_end(frame);
  return if8037;
}
Object meth_parser__apply8472(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8474 == NULL) {
    strlit8474 = alloc_String("eof");
    gc_root(strlit8474);
  }
// compiled string node returning strlit8474 (depth = 8)
  int op_slot_right_8473 = gc_frame_newslot(strlit8474);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8477 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8476);
// compiled call node returning call8477 (depth = 9)
// compiled member node returning call8477 (depth = 8)
  int op_slot_left_8473 = gc_frame_newslot(call8477);
  params[0] = strlit8474;
  partcv[0] = 1;
  Object opresult8478 = callmethod(call8477, "!=", 1, partcv, params);
// compiled op node returning opresult8478 (depth = 7)
  gc_frame_end(frame);
  return opresult8478;
}
Object meth_parser__apply8469(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe8470 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8471 = alloc_Block(NULL, NULL, "parser", 2628);
  gc_frame_newslot(block8471);
// method _apply
  block_savedest(block8471);
  Object closure8472 = createclosure(2, "_apply");
  setclosureframe(closure8472, stackframe);
  addtoclosure(closure8472, var_sym);
  addtoclosure(closure8472, selfslot);
  struct UserObject *uo8472 = (struct UserObject*)block8471;
  uo8472->data[0] = (Object)closure8472;
  Method *meth_meth_parser__apply8472 = addmethod2pos(block8471, "_apply", &meth_parser__apply8472, 0);
  int argcv_meth_parser__apply8472[] = {0};
  meth_meth_parser__apply8472->type = alloc_MethodType(1, argcv_meth_parser__apply8472);
  meth_meth_parser__apply8472->definitionModule = modulename;
  meth_meth_parser__apply8472->definitionLine = 2625;
// compiled block node returning block8471 (depth = 6)
  gc_frame_newslot(block8471);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8480 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe8481 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8482 == NULL) {
    strlit8482 = alloc_String("rbrace");
    gc_root(strlit8482);
  }
// compiled string node returning strlit8482 (depth = 9)
  gc_frame_newslot(strlit8482);
// call case 4: self request
  params[0] = strlit8482;
  partcv[0] = 1;
  Object call8483 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8481);
// compiled call node returning call8483 (depth = 8)
  partcv[0] = 0;
  Object call8484 = callmethod(call8483, "not",
    1, partcv, params);
  gc_frame_end(callframe8480);
// compiled call node returning call8484 (depth = 7)
// compiled member node returning call8484 (depth = 6)
  params[0] = block8471;
  partcv[0] = 1;
  Object call8485 = callmethod(call8484, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8470);
// compiled call node returning call8485 (depth = 5)
  gc_frame_end(frame);
  return call8485;
}
Object meth_parser__apply8491(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8492 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8493 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8492);
// compiled call node returning call8493 (depth = 8)
// compiled member node returning call8493 (depth = 7)
  gc_frame_end(frame);
  return call8493;
}
Object meth_parser__apply8496(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8497 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8499 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8498);
// compiled call node returning call8499 (depth = 9)
// compiled member node returning call8499 (depth = 8)
  gc_frame_newslot(call8499);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8499;
  partcv[0] = 1;
  Object call8500 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8497);
// compiled call node returning call8500 (depth = 7)
  gc_frame_end(frame);
  return call8500;
}
Object meth_parser__apply8505(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8506 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8507 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8506);
// compiled call node returning call8507 (depth = 8)
// compiled member node returning call8507 (depth = 7)
  gc_frame_end(frame);
  return call8507;
}
Object meth_parser__apply8510(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8511 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8512 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8513 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8512);
// compiled call node returning call8513 (depth = 9)
// compiled member node returning call8513 (depth = 8)
  gc_frame_newslot(call8513);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8513;
  partcv[0] = 1;
  Object call8514 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8511);
// compiled call node returning call8514 (depth = 7)
  gc_frame_end(frame);
  return call8514;
}
Object meth_parser__apply8519(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8520 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8521 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8520);
// compiled call node returning call8521 (depth = 8)
// compiled member node returning call8521 (depth = 7)
  gc_frame_end(frame);
  return call8521;
}
Object meth_parser__apply8524(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8525 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8527 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8526);
// compiled call node returning call8527 (depth = 9)
// compiled member node returning call8527 (depth = 8)
  gc_frame_newslot(call8527);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8527;
  partcv[0] = 1;
  Object call8528 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8525);
// compiled call node returning call8528 (depth = 7)
  gc_frame_end(frame);
  return call8528;
}
Object meth_parser__apply8488(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8489 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8490 = alloc_Block(NULL, NULL, "parser", 2629);
  gc_frame_newslot(block8490);
// method _apply
  block_savedest(block8490);
  Object closure8491 = createclosure(1, "_apply");
  setclosureframe(closure8491, stackframe);
  addtoclosure(closure8491, selfslot);
  struct UserObject *uo8491 = (struct UserObject*)block8490;
  uo8491->data[0] = (Object)closure8491;
  Method *meth_meth_parser__apply8491 = addmethod2pos(block8490, "_apply", &meth_parser__apply8491, 0);
  int argcv_meth_parser__apply8491[] = {0};
  meth_meth_parser__apply8491->type = alloc_MethodType(1, argcv_meth_parser__apply8491);
  meth_meth_parser__apply8491->definitionModule = modulename;
  meth_meth_parser__apply8491->definitionLine = 2628;
// compiled block node returning block8490 (depth = 6)
  gc_frame_newslot(block8490);
// starting to compile block node (depth = 6)
  Object block8495 = alloc_Block(NULL, NULL, "parser", 2629);
  gc_frame_newslot(block8495);
// method _apply
  block_savedest(block8495);
  Object closure8496 = createclosure(3, "_apply");
  setclosureframe(closure8496, stackframe);
  addtoclosure(closure8496, var_values);
  addtoclosure(closure8496, var_body);
  addtoclosure(closure8496, selfslot);
  struct UserObject *uo8496 = (struct UserObject*)block8495;
  uo8496->data[0] = (Object)closure8496;
  Method *meth_meth_parser__apply8496 = addmethod2pos(block8495, "_apply", &meth_parser__apply8496, 0);
  int argcv_meth_parser__apply8496[] = {0};
  meth_meth_parser__apply8496->type = alloc_MethodType(1, argcv_meth_parser__apply8496);
  meth_meth_parser__apply8496->definitionModule = modulename;
  meth_meth_parser__apply8496->definitionLine = 2629;
// compiled block node returning block8495 (depth = 6)
  gc_frame_newslot(block8495);
// call case 4: self request
  params[0] = block8490;
  params[1] = block8495;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8502 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8489);
// compiled call node returning call8502 (depth = 5)
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8503 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8504 = alloc_Block(NULL, NULL, "parser", 2632);
  gc_frame_newslot(block8504);
// method _apply
  block_savedest(block8504);
  Object closure8505 = createclosure(1, "_apply");
  setclosureframe(closure8505, stackframe);
  addtoclosure(closure8505, selfslot);
  struct UserObject *uo8505 = (struct UserObject*)block8504;
  uo8505->data[0] = (Object)closure8505;
  Method *meth_meth_parser__apply8505 = addmethod2pos(block8504, "_apply", &meth_parser__apply8505, 0);
  int argcv_meth_parser__apply8505[] = {0};
  meth_meth_parser__apply8505->type = alloc_MethodType(1, argcv_meth_parser__apply8505);
  meth_meth_parser__apply8505->definitionModule = modulename;
  meth_meth_parser__apply8505->definitionLine = 2630;
// compiled block node returning block8504 (depth = 6)
  gc_frame_newslot(block8504);
// starting to compile block node (depth = 6)
  Object block8509 = alloc_Block(NULL, NULL, "parser", 2632);
  gc_frame_newslot(block8509);
// method _apply
  block_savedest(block8509);
  Object closure8510 = createclosure(3, "_apply");
  setclosureframe(closure8510, stackframe);
  addtoclosure(closure8510, var_values);
  addtoclosure(closure8510, var_body);
  addtoclosure(closure8510, selfslot);
  struct UserObject *uo8510 = (struct UserObject*)block8509;
  uo8510->data[0] = (Object)closure8510;
  Method *meth_meth_parser__apply8510 = addmethod2pos(block8509, "_apply", &meth_parser__apply8510, 0);
  int argcv_meth_parser__apply8510[] = {0};
  meth_meth_parser__apply8510->type = alloc_MethodType(1, argcv_meth_parser__apply8510);
  meth_meth_parser__apply8510->definitionModule = modulename;
  meth_meth_parser__apply8510->definitionLine = 2632;
// compiled block node returning block8509 (depth = 6)
  gc_frame_newslot(block8509);
// call case 4: self request
  params[0] = block8504;
  params[1] = block8509;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8516 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8503);
// compiled call node returning call8516 (depth = 5)
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8517 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8518 = alloc_Block(NULL, NULL, "parser", 2635);
  gc_frame_newslot(block8518);
// method _apply
  block_savedest(block8518);
  Object closure8519 = createclosure(1, "_apply");
  setclosureframe(closure8519, stackframe);
  addtoclosure(closure8519, selfslot);
  struct UserObject *uo8519 = (struct UserObject*)block8518;
  uo8519->data[0] = (Object)closure8519;
  Method *meth_meth_parser__apply8519 = addmethod2pos(block8518, "_apply", &meth_parser__apply8519, 0);
  int argcv_meth_parser__apply8519[] = {0};
  meth_meth_parser__apply8519->type = alloc_MethodType(1, argcv_meth_parser__apply8519);
  meth_meth_parser__apply8519->definitionModule = modulename;
  meth_meth_parser__apply8519->definitionLine = 2633;
// compiled block node returning block8518 (depth = 6)
  gc_frame_newslot(block8518);
// starting to compile block node (depth = 6)
  Object block8523 = alloc_Block(NULL, NULL, "parser", 2635);
  gc_frame_newslot(block8523);
// method _apply
  block_savedest(block8523);
  Object closure8524 = createclosure(3, "_apply");
  setclosureframe(closure8524, stackframe);
  addtoclosure(closure8524, var_values);
  addtoclosure(closure8524, var_body);
  addtoclosure(closure8524, selfslot);
  struct UserObject *uo8524 = (struct UserObject*)block8523;
  uo8524->data[0] = (Object)closure8524;
  Method *meth_meth_parser__apply8524 = addmethod2pos(block8523, "_apply", &meth_parser__apply8524, 0);
  int argcv_meth_parser__apply8524[] = {0};
  meth_meth_parser__apply8524->type = alloc_MethodType(1, argcv_meth_parser__apply8524);
  meth_meth_parser__apply8524->definitionModule = modulename;
  meth_meth_parser__apply8524->definitionLine = 2635;
// compiled block node returning block8523 (depth = 6)
  gc_frame_newslot(block8523);
// call case 4: self request
  params[0] = block8518;
  params[1] = block8523;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8530 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8517);
// compiled call node returning call8530 (depth = 5)
  gc_frame_end(frame);
  return call8530;
}
Object meth_parser_doclass8273(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[6];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_statementToken = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doclass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doclass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_cname = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cname");
  Object *var_s = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "s");
  Object *var_csig = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "csig");
  Object *var_methodName = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "methodName");
  Object *var_dtype = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "dtype");
  Object *var_anns = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "anns");
  Object *var_body = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "body");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8277 == NULL) {
    strlit8277 = alloc_String("class");
    gc_root(strlit8277);
  }
// compiled string node returning strlit8277 (depth = 5)
  int op_slot_right_8276 = gc_frame_newslot(strlit8277);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8280 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8279);
// compiled call node returning call8280 (depth = 6)
// compiled member node returning call8280 (depth = 5)
  int op_slot_left_8276 = gc_frame_newslot(call8280);
  params[0] = strlit8277;
  partcv[0] = 1;
  Object opresult8281 = callmethod(call8280, "==", 1, partcv, params);
// compiled op node returning opresult8281 (depth = 4)
  int op_slot_right_8275 = gc_frame_newslot(opresult8281);
// starting to compile call node (depth = 4)
  int callframe8283 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8284 == NULL) {
    strlit8284 = alloc_String("keyword");
    gc_root(strlit8284);
  }
// compiled string node returning strlit8284 (depth = 5)
  gc_frame_newslot(strlit8284);
// call case 4: self request
  params[0] = strlit8284;
  partcv[0] = 1;
  Object call8285 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8283);
// compiled call node returning call8285 (depth = 4)
  int op_slot_left_8275 = gc_frame_newslot(call8285);
  params[0] = opresult8281;
  partcv[0] = 1;
  Object opresult8286 = callmethod(call8285, "&&", 1, partcv, params);
// compiled op node returning opresult8286 (depth = 3)
  Object if8274 = done;
  if (istrue(opresult8286)) {
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8288 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8287);
// compiled call node returning call8288 (depth = 4)
// compiled member node returning call8288 (depth = 3)
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8291 == NULL) {
    strlit8291 = alloc_String("identifier");
    gc_root(strlit8291);
  }
// compiled string node returning strlit8291 (depth = 5)
  int op_slot_right_8290 = gc_frame_newslot(strlit8291);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8294 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8293);
// compiled call node returning call8294 (depth = 6)
// compiled member node returning call8294 (depth = 5)
  int op_slot_left_8290 = gc_frame_newslot(call8294);
  params[0] = strlit8291;
  partcv[0] = 1;
  Object opresult8295 = callmethod(call8294, "!=", 1, partcv, params);
// compiled op node returning opresult8295 (depth = 4)
  Object if8289 = done;
  if (istrue(opresult8295)) {
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8296 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8297 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8298 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8297);
// compiled call node returning call8298 (depth = 8)
// compiled member node returning call8298 (depth = 7)
  partcv[0] = 0;
  Object call8299 = callmethod(call8298, "empty",
    1, partcv, params);
  gc_frame_end(callframe8296);
// compiled call node returning call8299 (depth = 6)
// compiled member node returning call8299 (depth = 5)
  *var_suggestions = call8299;
  if (call8299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8302 == NULL) {
    strlit8302 = alloc_String("lbrace");
    gc_root(strlit8302);
  }
// compiled string node returning strlit8302 (depth = 6)
  int op_slot_right_8301 = gc_frame_newslot(strlit8302);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8304 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8305 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8304);
// compiled call node returning call8305 (depth = 7)
// compiled member node returning call8305 (depth = 6)
  int op_slot_left_8301 = gc_frame_newslot(call8305);
  params[0] = strlit8302;
  partcv[0] = 1;
  Object opresult8306 = callmethod(call8305, "==", 1, partcv, params);
// compiled op node returning opresult8306 (depth = 5)
  Object if8300 = done;
  if (istrue(opresult8306)) {
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8307 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8309 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8308);
// compiled call node returning call8309 (depth = 9)
// compiled member node returning call8309 (depth = 8)
  partcv[0] = 0;
  Object call8310 = callmethod(call8309, "new",
    1, partcv, params);
  gc_frame_end(callframe8307);
// compiled call node returning call8310 (depth = 7)
// compiled member node returning call8310 (depth = 6)
  *var_suggestion = call8310;
  if (call8310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8311 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8312 == NULL) {
    strlit8312 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit8312);
  }
// compiled string node returning strlit8312 (depth = 6)
  gc_frame_newslot(strlit8312);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8312;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8313 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8311);
// compiled call node returning call8313 (depth = 5)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8314 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8315 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8314);
// compiled call node returning call8315 (depth = 5)
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8316 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8317 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8318 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8317);
// compiled call node returning call8318 (depth = 9)
// compiled member node returning call8318 (depth = 8)
  partcv[0] = 0;
  Object call8319 = callmethod(call8318, "new",
    1, partcv, params);
  gc_frame_end(callframe8316);
// compiled call node returning call8319 (depth = 7)
// compiled member node returning call8319 (depth = 6)
  *var_suggestion = call8319;
  if (call8319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8321 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8322 == NULL) {
    strlit8322 = alloc_String("object");
    gc_root(strlit8322);
  }
// compiled string node returning strlit8322 (depth = 6)
  gc_frame_newslot(strlit8322);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8322;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8323 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8321);
// compiled call node returning call8323 (depth = 5)
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8324 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8325 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8324);
// compiled call node returning call8325 (depth = 5)
    gc_frame_newslot(call8325);
    if8300 = call8325;
  } else {
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8326 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8328 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8327);
// compiled call node returning call8328 (depth = 9)
// compiled member node returning call8328 (depth = 8)
  partcv[0] = 0;
  Object call8329 = callmethod(call8328, "new",
    1, partcv, params);
  gc_frame_end(callframe8326);
// compiled call node returning call8329 (depth = 7)
// compiled member node returning call8329 (depth = 6)
  *var_suggestion = call8329;
  if (call8329 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8330 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8331 == NULL) {
    strlit8331 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit8331);
  }
// compiled string node returning strlit8331 (depth = 6)
  gc_frame_newslot(strlit8331);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8331;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8332 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8330);
// compiled call node returning call8332 (depth = 5)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8333 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8334 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8333);
// compiled call node returning call8334 (depth = 5)
    gc_frame_newslot(call8334);
    if8300 = call8334;
  }
// compiled if node returning if8300 (depth = 4)
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8335 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8336 == NULL) {
    strlit8336 = alloc_String("A class must have a name after the 'class'.");
    gc_root(strlit8336);
  }
// compiled string node returning strlit8336 (depth = 5)
  gc_frame_newslot(strlit8336);
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8337 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8338 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8337);
// compiled call node returning call8338 (depth = 6)
// compiled member node returning call8338 (depth = 5)
  gc_frame_newslot(call8338);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8340 = alloc_Float64(1);
// compiled num node returning num8340 (depth = 6)
  int op_slot_right_8339 = gc_frame_newslot(num8340);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8344 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8343);
// compiled call node returning call8344 (depth = 8)
// compiled member node returning call8344 (depth = 7)
  int op_slot_right_8342 = gc_frame_newslot(call8344);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8347 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8346);
// compiled call node returning call8347 (depth = 8)
// compiled member node returning call8347 (depth = 7)
  int op_slot_left_8342 = gc_frame_newslot(call8347);
  params[0] = call8344;
  partcv[0] = 1;
  Object sum8348 = callmethod(call8347, "+", 1, partcv, params);
// compiled op node returning sum8348 (depth = 6)
  int op_slot_left_8339 = gc_frame_newslot(sum8348);
  params[0] = num8340;
  partcv[0] = 1;
  Object sum8349 = callmethod(sum8348, "+", 1, partcv, params);
// compiled op node returning sum8349 (depth = 5)
  gc_frame_newslot(sum8349);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8336;
  params[1] = call8338;
  params[2] = sum8349;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8350 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8335);
// compiled call node returning call8350 (depth = 4)
    gc_frame_newslot(call8350);
    if8289 = call8350;
  } else {
  }
// compiled if node returning if8289 (depth = 3)
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8353 == NULL) {
    strlit8353 = alloc_String("dot");
    gc_root(strlit8353);
  }
// compiled string node returning strlit8353 (depth = 6)
  int op_slot_right_8352 = gc_frame_newslot(strlit8353);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8355 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8356 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call8357 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8356);
// compiled call node returning call8357 (depth = 9)
// compiled member node returning call8357 (depth = 8)
  partcv[0] = 0;
  Object call8358 = callmethod(call8357, "kind",
    1, partcv, params);
  gc_frame_end(callframe8355);
// compiled call node returning call8358 (depth = 7)
// compiled member node returning call8358 (depth = 6)
  int op_slot_left_8352 = gc_frame_newslot(call8358);
  params[0] = strlit8353;
  partcv[0] = 1;
  Object opresult8359 = callmethod(call8358, "==", 1, partcv, params);
// compiled op node returning opresult8359 (depth = 5)
  Object if8351 = done;
struct StackFrameObject *iftmpstackframe8351 = stackframe;
  if (istrue(opresult8359)) {
stackframe = alloc_StackFrame(2, iftmpstackframe8351);
gc_frame_newslot((Object)stackframe);
  Object *var_cname_39_ = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "cname'");
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8361 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8360);
// compiled call node returning call8361 (depth = 6)
// compiled member node returning call8361 (depth = 5)
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8363 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8362);
// compiled call node returning call8363 (depth = 7)
// compiled member node returning call8363 (depth = 6)
  *var_cname_39_ = call8363;
  if (call8363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8364 = gc_frame_new();
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool8365 = alloc_Boolean(1);
// compiled identifier node returning bool8365 (depth = 7)
  gc_frame_newslot(bool8365);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cname_39_ (depth = 7)
  params[0] = bool8365;
  partcv[0] = 1;
  Object call8366 = callmethod(*var_cname_39_, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8364);
// compiled call node returning call8366 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8368 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8369 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8370 == NULL) {
    strlit8370 = alloc_String("dot");
    gc_root(strlit8370);
  }
// compiled string node returning strlit8370 (depth = 8)
  gc_frame_newslot(strlit8370);
// call case 4: self request
  params[0] = strlit8370;
  partcv[0] = 1;
  Object call8371 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8369);
// compiled call node returning call8371 (depth = 7)
  partcv[0] = 0;
  Object call8372 = callmethod(call8371, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8368);
// compiled call node returning call8372 (depth = 6)
  Object if8367 = done;
  if (istrue(call8372)) {
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8373 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8374 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call8375 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8374);
// compiled call node returning call8375 (depth = 10)
// compiled member node returning call8375 (depth = 9)
  partcv[0] = 0;
  Object call8376 = callmethod(call8375, "new",
    1, partcv, params);
  gc_frame_end(callframe8373);
// compiled call node returning call8376 (depth = 8)
// compiled member node returning call8376 (depth = 7)
  *var_suggestion = call8376;
  if (call8376 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8377 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 7)
  if (strlit8378 == NULL) {
    strlit8378 = alloc_String(".");
    gc_root(strlit8378);
  }
// compiled string node returning strlit8378 (depth = 7)
  gc_frame_newslot(strlit8378);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = strlit8378;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8379 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8377);
// compiled call node returning call8379 (depth = 6)
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8380 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8381 == NULL) {
    strlit8381 = alloc_String("A class must have a dot after the object name.");
    gc_root(strlit8381);
  }
// compiled string node returning strlit8381 (depth = 7)
  gc_frame_newslot(strlit8381);
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8382 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8383 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8382);
// compiled call node returning call8383 (depth = 8)
// compiled member node returning call8383 (depth = 7)
  gc_frame_newslot(call8383);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8385 = alloc_Float64(1);
// compiled num node returning num8385 (depth = 8)
  int op_slot_right_8384 = gc_frame_newslot(num8385);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8388 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8389 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8388);
// compiled call node returning call8389 (depth = 10)
// compiled member node returning call8389 (depth = 9)
  int op_slot_right_8387 = gc_frame_newslot(call8389);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8391 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8392 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8391);
// compiled call node returning call8392 (depth = 10)
// compiled member node returning call8392 (depth = 9)
  int op_slot_left_8387 = gc_frame_newslot(call8392);
  params[0] = call8389;
  partcv[0] = 1;
  Object sum8393 = callmethod(call8392, "+", 1, partcv, params);
// compiled op node returning sum8393 (depth = 8)
  int op_slot_left_8384 = gc_frame_newslot(sum8393);
  params[0] = num8385;
  partcv[0] = 1;
  Object sum8394 = callmethod(sum8393, "+", 1, partcv, params);
// compiled op node returning sum8394 (depth = 7)
  gc_frame_newslot(sum8394);
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit8381;
  params[1] = call8383;
  params[2] = sum8394;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8395 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8380);
// compiled call node returning call8395 (depth = 6)
    gc_frame_newslot(call8395);
    if8367 = call8395;
  } else {
  }
// compiled if node returning if8367 (depth = 5)
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8397 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8396);
// compiled call node returning call8397 (depth = 6)
// compiled member node returning call8397 (depth = 5)
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cname_39_ (depth = 5)
    gc_frame_newslot(*var_cname_39_);
    if8351 = *var_cname_39_;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8351);
  gc_frame_newslot((Object)stackframe);
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool8398 = alloc_Boolean(0);
// compiled identifier node returning bool8398 (depth = 5)
    gc_frame_newslot(bool8398);
    if8351 = bool8398;
  }
stackframe = iftmpstackframe8351;
// compiled if node returning if8351 (depth = 4)
  *var_cname = if8351;
  if (if8351 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8399 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8400 = alloc_Boolean(0);
// compiled identifier node returning bool8400 (depth = 5)
  gc_frame_newslot(bool8400);
// call case 4: self request
  params[0] = bool8400;
  partcv[0] = 1;
  Object call8401 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8399);
// compiled call node returning call8401 (depth = 4)
  *var_s = call8401;
  if (call8401 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8403 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8402);
// compiled call node returning call8403 (depth = 5)
// compiled member node returning call8403 (depth = 4)
  *var_csig = call8403;
  if (call8403 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8404 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8405 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8404);
// compiled call node returning call8405 (depth = 5)
// compiled member node returning call8405 (depth = 4)
  *var_methodName = call8405;
  if (call8405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8406 = gc_frame_new();
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool8407 = alloc_Boolean(1);
// compiled identifier node returning bool8407 (depth = 5)
  gc_frame_newslot(bool8407);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  params[0] = bool8407;
  partcv[0] = 1;
  Object call8408 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8406);
// compiled call node returning call8408 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8409 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8410 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8409);
// compiled call node returning call8410 (depth = 5)
// compiled member node returning call8410 (depth = 4)
  *var_dtype = call8410;
  if (call8410 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8412 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8411);
// compiled call node returning call8412 (depth = 5)
// compiled member node returning call8412 (depth = 4)
  *var_anns = call8412;
  if (call8412 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8414 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8415 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8416 == NULL) {
    strlit8416 = alloc_String("lbrace");
    gc_root(strlit8416);
  }
// compiled string node returning strlit8416 (depth = 6)
  gc_frame_newslot(strlit8416);
// call case 4: self request
  params[0] = strlit8416;
  partcv[0] = 1;
  Object call8417 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8415);
// compiled call node returning call8417 (depth = 5)
  partcv[0] = 0;
  Object call8418 = callmethod(call8417, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8414);
// compiled call node returning call8418 (depth = 4)
  Object if8413 = done;
  if (istrue(call8418)) {
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8419 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8421 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8420);
// compiled call node returning call8421 (depth = 8)
// compiled member node returning call8421 (depth = 7)
  partcv[0] = 0;
  Object call8422 = callmethod(call8421, "new",
    1, partcv, params);
  gc_frame_end(callframe8419);
// compiled call node returning call8422 (depth = 6)
// compiled member node returning call8422 (depth = 5)
  *var_suggestion = call8422;
  if (call8422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8423 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8424 == NULL) {
    strlit8424 = alloc_String(" {");
    gc_root(strlit8424);
  }
// compiled string node returning strlit8424 (depth = 5)
  gc_frame_newslot(strlit8424);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8424;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8425 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8423);
// compiled call node returning call8425 (depth = 4)
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8426 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8427 == NULL) {
    strlit8427 = alloc_String("A class must have a '{' after the method name.");
    gc_root(strlit8427);
  }
// compiled string node returning strlit8427 (depth = 5)
  gc_frame_newslot(strlit8427);
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8429 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8428);
// compiled call node returning call8429 (depth = 6)
// compiled member node returning call8429 (depth = 5)
  gc_frame_newslot(call8429);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8431 = alloc_Float64(1);
// compiled num node returning num8431 (depth = 6)
  int op_slot_right_8430 = gc_frame_newslot(num8431);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8435 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8434);
// compiled call node returning call8435 (depth = 8)
// compiled member node returning call8435 (depth = 7)
  int op_slot_right_8433 = gc_frame_newslot(call8435);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8438 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8437);
// compiled call node returning call8438 (depth = 8)
// compiled member node returning call8438 (depth = 7)
  int op_slot_left_8433 = gc_frame_newslot(call8438);
  params[0] = call8435;
  partcv[0] = 1;
  Object sum8439 = callmethod(call8438, "+", 1, partcv, params);
// compiled op node returning sum8439 (depth = 6)
  int op_slot_left_8430 = gc_frame_newslot(sum8439);
  params[0] = num8431;
  partcv[0] = 1;
  Object sum8440 = callmethod(sum8439, "+", 1, partcv, params);
// compiled op node returning sum8440 (depth = 5)
  gc_frame_newslot(sum8440);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8427;
  params[1] = call8429;
  params[2] = sum8440;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8441 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8426);
// compiled call node returning call8441 (depth = 4)
    gc_frame_newslot(call8441);
    if8413 = call8441;
  } else {
  }
// compiled if node returning if8413 (depth = 3)
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8443 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8442);
// compiled call node returning call8443 (depth = 4)
// compiled member node returning call8443 (depth = 3)
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call8447 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8446);
// compiled call node returning call8447 (depth = 6)
// compiled member node returning call8447 (depth = 5)
  int op_slot_right_8445 = gc_frame_newslot(call8447);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8449 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8450 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8449);
// compiled call node returning call8450 (depth = 6)
// compiled member node returning call8450 (depth = 5)
  int op_slot_left_8445 = gc_frame_newslot(call8450);
  params[0] = call8447;
  partcv[0] = 1;
  Object opresult8451 = callmethod(call8450, "==", 1, partcv, params);
// compiled op node returning opresult8451 (depth = 4)
  Object if8444 = done;
  if (istrue(opresult8451)) {
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8453 = alloc_Float64(1);
// compiled num node returning num8453 (depth = 6)
  int op_slot_right_8452 = gc_frame_newslot(num8453);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8456 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8455);
// compiled call node returning call8456 (depth = 7)
// compiled member node returning call8456 (depth = 6)
  int op_slot_left_8452 = gc_frame_newslot(call8456);
  params[0] = num8453;
  partcv[0] = 1;
  Object diff8457 = callmethod(call8456, "-", 1, partcv, params);
// compiled op node returning diff8457 (depth = 5)
  *var_minIndentLevel = diff8457;
  if (diff8457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8444 = done;
  } else {
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8460 = alloc_Float64(1);
// compiled num node returning num8460 (depth = 6)
  int op_slot_right_8459 = gc_frame_newslot(num8460);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8462 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  partcv[0] = 0;
  Object call8463 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8462);
// compiled call node returning call8463 (depth = 7)
// compiled member node returning call8463 (depth = 6)
  int op_slot_left_8459 = gc_frame_newslot(call8463);
  params[0] = num8460;
  partcv[0] = 1;
  Object sum8464 = callmethod(call8463, "+", 1, partcv, params);
// compiled op node returning sum8464 (depth = 5)
  *var_minIndentLevel = sum8464;
  if (sum8464 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8444 = done;
  }
// compiled if node returning if8444 (depth = 3)
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8466 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8466 (depth = 4)
  *var_body = array8466;
  if (array8466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8467 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8468 = alloc_Block(NULL, NULL, "parser", 2628);
  gc_frame_newslot(block8468);
// method _apply
  block_savedest(block8468);
  Object closure8469 = createclosure(2, "_apply");
  setclosureframe(closure8469, stackframe);
  addtoclosure(closure8469, var_sym);
  addtoclosure(closure8469, selfslot);
  struct UserObject *uo8469 = (struct UserObject*)block8468;
  uo8469->data[0] = (Object)closure8469;
  Method *meth_meth_parser__apply8469 = addmethod2pos(block8468, "_apply", &meth_parser__apply8469, 0);
  int argcv_meth_parser__apply8469[] = {0};
  meth_meth_parser__apply8469->type = alloc_MethodType(1, argcv_meth_parser__apply8469);
  meth_meth_parser__apply8469->definitionModule = modulename;
  meth_meth_parser__apply8469->definitionLine = 2625;
// compiled block node returning block8468 (depth = 4)
  gc_frame_newslot(block8468);
// starting to compile block node (depth = 4)
  Object block8487 = alloc_Block(NULL, NULL, "parser", 2628);
  gc_frame_newslot(block8487);
// method _apply
  block_savedest(block8487);
  Object closure8488 = createclosure(3, "_apply");
  setclosureframe(closure8488, stackframe);
  addtoclosure(closure8488, var_values);
  addtoclosure(closure8488, var_body);
  addtoclosure(closure8488, selfslot);
  struct UserObject *uo8488 = (struct UserObject*)block8487;
  uo8488->data[0] = (Object)closure8488;
  Method *meth_meth_parser__apply8488 = addmethod2pos(block8487, "_apply", &meth_parser__apply8488, 0);
  int argcv_meth_parser__apply8488[] = {0};
  meth_meth_parser__apply8488->type = alloc_MethodType(1, argcv_meth_parser__apply8488);
  meth_meth_parser__apply8488->definitionModule = modulename;
  meth_meth_parser__apply8488->definitionLine = 2628;
// compiled block node returning block8487 (depth = 4)
  gc_frame_newslot(block8487);
// call case 5: prelude request
  params[0] = block8468;
  params[1] = block8487;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8532 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8467);
// compiled call node returning call8532 (depth = 3)
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8533 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8534 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8533);
// compiled call node returning call8534 (depth = 4)
// compiled member node returning call8534 (depth = 3)
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8535 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8537 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8536);
// compiled call node returning call8537 (depth = 5)
// compiled member node returning call8537 (depth = 4)
  gc_frame_newslot(call8537);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8537;
  partcv[0] = 1;
  Object call8538 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8535);
// compiled call node returning call8538 (depth = 3)
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cname (depth = 6)
  int op_slot_right_8540 = gc_frame_newslot(*var_cname);
// starting to compile identifier node (depth = 6)
  Object bool8542 = alloc_Boolean(0);
// compiled identifier node returning bool8542 (depth = 6)
  int op_slot_left_8540 = gc_frame_newslot(bool8542);
  params[0] = *var_cname;
  partcv[0] = 1;
  Object opresult8543 = callmethod(bool8542, "==", 1, partcv, params);
// compiled op node returning opresult8543 (depth = 5)
  Object if8539 = done;
struct StackFrameObject *iftmpstackframe8539 = stackframe;
  if (istrue(opresult8543)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8539);
gc_frame_newslot((Object)stackframe);
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8544 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodName (depth = 6)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_csig (depth = 6)
  gc_frame_newslot(*var_csig);
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array8545 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 7)
  int callframe8546 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 8)
  Object bool8547 = alloc_Boolean(0);
// compiled identifier node returning bool8547 (depth = 8)
  gc_frame_newslot(bool8547);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call8549 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8548);
// compiled call node returning call8549 (depth = 9)
// compiled member node returning call8549 (depth = 8)
  params[0] = *var_body;
  params[1] = bool8547;
  partcv[0] = 2;
  Object call8550 = callmethod(call8549, "new",
    1, partcv, params);
  gc_frame_end(callframe8546);
// compiled call node returning call8550 (depth = 7)
  params[0] = call8550;
  partcv[0] = 1;
  callmethod(array8545, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array8545 (depth = 6)
  gc_frame_newslot(array8545);
// starting to compile identifier node (depth = 6)
  Object bool8551 = alloc_Boolean(0);
// compiled identifier node returning bool8551 (depth = 6)
  gc_frame_newslot(bool8551);
// call case 6: other member request
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8553 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8552);
// compiled call node returning call8553 (depth = 7)
// compiled member node returning call8553 (depth = 6)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = array8545;
  params[3] = bool8551;
  partcv[0] = 4;
  Object call8554 = callmethod(call8553, "new",
    1, partcv, params);
  gc_frame_end(callframe8544);
// compiled call node returning call8554 (depth = 5)
    gc_frame_newslot(call8554);
    if8539 = call8554;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8539);
  gc_frame_newslot((Object)stackframe);
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8555 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cname (depth = 6)
  gc_frame_newslot(*var_cname);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_csig (depth = 6)
  gc_frame_newslot(*var_csig);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
  Object bool8556 = alloc_Boolean(0);
// compiled identifier node returning bool8556 (depth = 6)
  gc_frame_newslot(bool8556);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodName (depth = 6)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dtype (depth = 6)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8558 = callmethod(*var_ast, "classNode",
    1, partcv, params);
  gc_frame_end(callframe8557);
// compiled call node returning call8558 (depth = 7)
// compiled member node returning call8558 (depth = 6)
  params[0] = *var_cname;
  params[1] = *var_csig;
  params[2] = *var_body;
  params[3] = bool8556;
  params[4] = *var_methodName;
  params[5] = *var_dtype;
  partcv[0] = 6;
  Object call8559 = callmethod(call8558, "new",
    1, partcv, params);
  gc_frame_end(callframe8555);
// compiled call node returning call8559 (depth = 5)
    gc_frame_newslot(call8559);
    if8539 = call8559;
  }
stackframe = iftmpstackframe8539;
// compiled if node returning if8539 (depth = 4)
  *var_o = if8539;
  if (if8539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8560 = gc_frame_new();
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  partcv[0] = 0;
  Object call8562 = callmethod(*var_s, "generics",
    1, partcv, params);
  gc_frame_end(callframe8561);
// compiled call node returning call8562 (depth = 6)
// compiled member node returning call8562 (depth = 5)
  gc_frame_newslot(call8562);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = call8562;
  partcv[0] = 1;
  Object call8563 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe8560);
// compiled call node returning call8563 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8565 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8567 = alloc_Boolean(0);
// compiled identifier node returning bool8567 (depth = 5)
  int op_slot_left_8565 = gc_frame_newslot(bool8567);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8568 = callmethod(bool8567, "!=", 1, partcv, params);
// compiled op node returning opresult8568 (depth = 4)
  Object if8564 = done;
  if (istrue(opresult8568)) {
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8569 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call8571 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8570);
// compiled call node returning call8571 (depth = 6)
// compiled member node returning call8571 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8572 = callmethod(call8571, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8569);
// compiled call node returning call8572 (depth = 4)
    gc_frame_newslot(call8572);
    if8564 = call8572;
  } else {
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8575 == NULL) {
    strlit8575 = alloc_String("confidential");
    gc_root(strlit8575);
  }
// compiled string node returning strlit8575 (depth = 6)
  int op_slot_right_8574 = gc_frame_newslot(strlit8575);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 6)
  int op_slot_left_8574 = gc_frame_newslot(*var_defaultMethodVisibility);
  params[0] = strlit8575;
  partcv[0] = 1;
  Object opresult8577 = callmethod(*var_defaultMethodVisibility, "==", 1, partcv, params);
// compiled op node returning opresult8577 (depth = 5)
  Object if8573 = done;
  if (istrue(opresult8577)) {
// Begin line 2652
  setline(2652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8578 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe8579 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8580 == NULL) {
    strlit8580 = alloc_String("confidential");
    gc_root(strlit8580);
  }
// compiled string node returning strlit8580 (depth = 7)
  gc_frame_newslot(strlit8580);
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool8581 = alloc_Boolean(0);
// compiled identifier node returning bool8581 (depth = 7)
  gc_frame_newslot(bool8581);
// call case 6: other member request
// Begin line 2652
  setline(2652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8582 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call8583 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8582);
// compiled call node returning call8583 (depth = 8)
// compiled member node returning call8583 (depth = 7)
  params[0] = strlit8580;
  params[1] = bool8581;
  partcv[0] = 2;
  Object call8584 = callmethod(call8583, "new",
    1, partcv, params);
  gc_frame_end(callframe8579);
// compiled call node returning call8584 (depth = 6)
  gc_frame_newslot(call8584);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8585 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call8586 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8585);
// compiled call node returning call8586 (depth = 7)
// compiled member node returning call8586 (depth = 6)
  params[0] = call8584;
  partcv[0] = 1;
  Object call8587 = callmethod(call8586, "push",
    1, partcv, params);
  gc_frame_end(callframe8578);
// compiled call node returning call8587 (depth = 5)
    gc_frame_newslot(call8587);
    if8573 = call8587;
  } else {
  }
// compiled if node returning if8573 (depth = 4)
    gc_frame_newslot(if8573);
    if8564 = if8573;
  }
// compiled if node returning if8564 (depth = 3)
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8588 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8589 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8588);
// compiled call node returning call8589 (depth = 3)
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8590 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8591 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8590);
// compiled call node returning call8591 (depth = 4)
// compiled member node returning call8591 (depth = 3)
// Begin line 2658
  setline(2658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8274 = done;
  } else {
  }
// compiled if node returning if8274 (depth = 2)
  gc_frame_end(frame);
  return if8274;
}
Object meth_parser__apply8597(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8599 == NULL) {
    strlit8599 = alloc_String("method");
    gc_root(strlit8599);
  }
// compiled string node returning strlit8599 (depth = 6)
  int op_slot_right_8598 = gc_frame_newslot(strlit8599);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8601 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8602 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call8603 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8602);
// compiled call node returning call8603 (depth = 9)
// compiled member node returning call8603 (depth = 8)
  partcv[0] = 0;
  Object call8604 = callmethod(call8603, "value",
    1, partcv, params);
  gc_frame_end(callframe8601);
// compiled call node returning call8604 (depth = 7)
// compiled member node returning call8604 (depth = 6)
  int op_slot_left_8598 = gc_frame_newslot(call8604);
  params[0] = strlit8599;
  partcv[0] = 1;
  Object opresult8605 = callmethod(call8604, "==", 1, partcv, params);
// compiled op node returning opresult8605 (depth = 5)
  gc_frame_end(frame);
  return opresult8605;
}
Object meth_parser__apply8609(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8611 == NULL) {
    strlit8611 = alloc_String("keyword");
    gc_root(strlit8611);
  }
// compiled string node returning strlit8611 (depth = 7)
  int op_slot_right_8610 = gc_frame_newslot(strlit8611);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8613 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  partcv[0] = 0;
  Object call8615 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8614);
// compiled call node returning call8615 (depth = 10)
// compiled member node returning call8615 (depth = 9)
  partcv[0] = 0;
  Object call8616 = callmethod(call8615, "kind",
    1, partcv, params);
  gc_frame_end(callframe8613);
// compiled call node returning call8616 (depth = 8)
// compiled member node returning call8616 (depth = 7)
  int op_slot_left_8610 = gc_frame_newslot(call8616);
  params[0] = strlit8611;
  partcv[0] = 1;
  Object opresult8617 = callmethod(call8616, "==", 1, partcv, params);
// compiled op node returning opresult8617 (depth = 6)
  gc_frame_end(frame);
  return opresult8617;
}
Object meth_parser__apply8769(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8770 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8771 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8772 == NULL) {
    strlit8772 = alloc_String("rbrace");
    gc_root(strlit8772);
  }
// compiled string node returning strlit8772 (depth = 8)
  gc_frame_newslot(strlit8772);
// call case 4: self request
  params[0] = strlit8772;
  partcv[0] = 1;
  Object call8773 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8771);
// compiled call node returning call8773 (depth = 7)
  partcv[0] = 0;
  Object call8774 = callmethod(call8773, "not",
    1, partcv, params);
  gc_frame_end(callframe8770);
// compiled call node returning call8774 (depth = 6)
// compiled member node returning call8774 (depth = 5)
  gc_frame_end(frame);
  return call8774;
}
Object meth_parser__apply8780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8781 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8782 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8781);
// compiled call node returning call8782 (depth = 8)
// compiled member node returning call8782 (depth = 7)
  gc_frame_end(frame);
  return call8782;
}
Object meth_parser__apply8785(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8786 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8788 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8787);
// compiled call node returning call8788 (depth = 9)
// compiled member node returning call8788 (depth = 8)
  gc_frame_newslot(call8788);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8788;
  partcv[0] = 1;
  Object call8789 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8786);
// compiled call node returning call8789 (depth = 7)
  gc_frame_end(frame);
  return call8789;
}
Object meth_parser__apply8794(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8795 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8796 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8795);
// compiled call node returning call8796 (depth = 8)
// compiled member node returning call8796 (depth = 7)
  gc_frame_end(frame);
  return call8796;
}
Object meth_parser__apply8799(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8800 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8802 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8801);
// compiled call node returning call8802 (depth = 9)
// compiled member node returning call8802 (depth = 8)
  gc_frame_newslot(call8802);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8802;
  partcv[0] = 1;
  Object call8803 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8800);
// compiled call node returning call8803 (depth = 7)
  gc_frame_end(frame);
  return call8803;
}
Object meth_parser__apply8808(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8809 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8810 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8809);
// compiled call node returning call8810 (depth = 8)
// compiled member node returning call8810 (depth = 7)
  gc_frame_end(frame);
  return call8810;
}
Object meth_parser__apply8813(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8814 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8815 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8816 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8815);
// compiled call node returning call8816 (depth = 9)
// compiled member node returning call8816 (depth = 8)
  gc_frame_newslot(call8816);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8816;
  partcv[0] = 1;
  Object call8817 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8814);
// compiled call node returning call8817 (depth = 7)
  gc_frame_end(frame);
  return call8817;
}
Object meth_parser__apply8777(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8778 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8779 = alloc_Block(NULL, NULL, "parser", 2708);
  gc_frame_newslot(block8779);
// method _apply
  block_savedest(block8779);
  Object closure8780 = createclosure(1, "_apply");
  setclosureframe(closure8780, stackframe);
  addtoclosure(closure8780, selfslot);
  struct UserObject *uo8780 = (struct UserObject*)block8779;
  uo8780->data[0] = (Object)closure8780;
  Method *meth_meth_parser__apply8780 = addmethod2pos(block8779, "_apply", &meth_parser__apply8780, 0);
  int argcv_meth_parser__apply8780[] = {0};
  meth_meth_parser__apply8780->type = alloc_MethodType(1, argcv_meth_parser__apply8780);
  meth_meth_parser__apply8780->definitionModule = modulename;
  meth_meth_parser__apply8780->definitionLine = 2707;
// compiled block node returning block8779 (depth = 6)
  gc_frame_newslot(block8779);
// starting to compile block node (depth = 6)
  Object block8784 = alloc_Block(NULL, NULL, "parser", 2708);
  gc_frame_newslot(block8784);
// method _apply
  block_savedest(block8784);
  Object closure8785 = createclosure(3, "_apply");
  setclosureframe(closure8785, stackframe);
  addtoclosure(closure8785, var_values);
  addtoclosure(closure8785, var_body);
  addtoclosure(closure8785, selfslot);
  struct UserObject *uo8785 = (struct UserObject*)block8784;
  uo8785->data[0] = (Object)closure8785;
  Method *meth_meth_parser__apply8785 = addmethod2pos(block8784, "_apply", &meth_parser__apply8785, 0);
  int argcv_meth_parser__apply8785[] = {0};
  meth_meth_parser__apply8785->type = alloc_MethodType(1, argcv_meth_parser__apply8785);
  meth_meth_parser__apply8785->definitionModule = modulename;
  meth_meth_parser__apply8785->definitionLine = 2708;
// compiled block node returning block8784 (depth = 6)
  gc_frame_newslot(block8784);
// call case 4: self request
  params[0] = block8779;
  params[1] = block8784;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8791 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8778);
// compiled call node returning call8791 (depth = 5)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8792 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8793 = alloc_Block(NULL, NULL, "parser", 2711);
  gc_frame_newslot(block8793);
// method _apply
  block_savedest(block8793);
  Object closure8794 = createclosure(1, "_apply");
  setclosureframe(closure8794, stackframe);
  addtoclosure(closure8794, selfslot);
  struct UserObject *uo8794 = (struct UserObject*)block8793;
  uo8794->data[0] = (Object)closure8794;
  Method *meth_meth_parser__apply8794 = addmethod2pos(block8793, "_apply", &meth_parser__apply8794, 0);
  int argcv_meth_parser__apply8794[] = {0};
  meth_meth_parser__apply8794->type = alloc_MethodType(1, argcv_meth_parser__apply8794);
  meth_meth_parser__apply8794->definitionModule = modulename;
  meth_meth_parser__apply8794->definitionLine = 2709;
// compiled block node returning block8793 (depth = 6)
  gc_frame_newslot(block8793);
// starting to compile block node (depth = 6)
  Object block8798 = alloc_Block(NULL, NULL, "parser", 2711);
  gc_frame_newslot(block8798);
// method _apply
  block_savedest(block8798);
  Object closure8799 = createclosure(3, "_apply");
  setclosureframe(closure8799, stackframe);
  addtoclosure(closure8799, var_values);
  addtoclosure(closure8799, var_body);
  addtoclosure(closure8799, selfslot);
  struct UserObject *uo8799 = (struct UserObject*)block8798;
  uo8799->data[0] = (Object)closure8799;
  Method *meth_meth_parser__apply8799 = addmethod2pos(block8798, "_apply", &meth_parser__apply8799, 0);
  int argcv_meth_parser__apply8799[] = {0};
  meth_meth_parser__apply8799->type = alloc_MethodType(1, argcv_meth_parser__apply8799);
  meth_meth_parser__apply8799->definitionModule = modulename;
  meth_meth_parser__apply8799->definitionLine = 2711;
// compiled block node returning block8798 (depth = 6)
  gc_frame_newslot(block8798);
// call case 4: self request
  params[0] = block8793;
  params[1] = block8798;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8805 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8792);
// compiled call node returning call8805 (depth = 5)
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8806 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8807 = alloc_Block(NULL, NULL, "parser", 2714);
  gc_frame_newslot(block8807);
// method _apply
  block_savedest(block8807);
  Object closure8808 = createclosure(1, "_apply");
  setclosureframe(closure8808, stackframe);
  addtoclosure(closure8808, selfslot);
  struct UserObject *uo8808 = (struct UserObject*)block8807;
  uo8808->data[0] = (Object)closure8808;
  Method *meth_meth_parser__apply8808 = addmethod2pos(block8807, "_apply", &meth_parser__apply8808, 0);
  int argcv_meth_parser__apply8808[] = {0};
  meth_meth_parser__apply8808->type = alloc_MethodType(1, argcv_meth_parser__apply8808);
  meth_meth_parser__apply8808->definitionModule = modulename;
  meth_meth_parser__apply8808->definitionLine = 2712;
// compiled block node returning block8807 (depth = 6)
  gc_frame_newslot(block8807);
// starting to compile block node (depth = 6)
  Object block8812 = alloc_Block(NULL, NULL, "parser", 2714);
  gc_frame_newslot(block8812);
// method _apply
  block_savedest(block8812);
  Object closure8813 = createclosure(3, "_apply");
  setclosureframe(closure8813, stackframe);
  addtoclosure(closure8813, var_values);
  addtoclosure(closure8813, var_body);
  addtoclosure(closure8813, selfslot);
  struct UserObject *uo8813 = (struct UserObject*)block8812;
  uo8813->data[0] = (Object)closure8813;
  Method *meth_meth_parser__apply8813 = addmethod2pos(block8812, "_apply", &meth_parser__apply8813, 0);
  int argcv_meth_parser__apply8813[] = {0};
  meth_meth_parser__apply8813->type = alloc_MethodType(1, argcv_meth_parser__apply8813);
  meth_meth_parser__apply8813->definitionModule = modulename;
  meth_meth_parser__apply8813->definitionLine = 2714;
// compiled block node returning block8812 (depth = 6)
  gc_frame_newslot(block8812);
// call case 4: self request
  params[0] = block8807;
  params[1] = block8812;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8819 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8806);
// compiled call node returning call8819 (depth = 5)
  gc_frame_end(frame);
  return call8819;
}
Object meth_parser_dofactoryMethod8593(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dofactoryMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_statementToken = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dofactoryMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dofactoryMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_csig = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "csig");
  Object *var_methodName = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "methodName");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_body = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "body");
  Object *var_obj = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "obj");
  Object *var_meth = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "meth");
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8595 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8596 = alloc_Block(NULL, NULL, "parser", 2665);
  gc_frame_newslot(block8596);
// method _apply
  block_savedest(block8596);
  Object closure8597 = createclosure(2, "_apply");
  setclosureframe(closure8597, stackframe);
  addtoclosure(closure8597, var_tokens);
  addtoclosure(closure8597, selfslot);
  struct UserObject *uo8597 = (struct UserObject*)block8596;
  uo8597->data[0] = (Object)closure8597;
  Method *meth_meth_parser__apply8597 = addmethod2pos(block8596, "_apply", &meth_parser__apply8597, 0);
  int argcv_meth_parser__apply8597[] = {0};
  meth_meth_parser__apply8597->type = alloc_MethodType(1, argcv_meth_parser__apply8597);
  meth_meth_parser__apply8597->definitionModule = modulename;
  meth_meth_parser__apply8597->definitionLine = 2657;
// compiled block node returning block8596 (depth = 4)
  gc_frame_newslot(block8596);
// call case 6: other member request
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8607 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8608 = alloc_Block(NULL, NULL, "parser", 2664);
  gc_frame_newslot(block8608);
// method _apply
  block_savedest(block8608);
  Object closure8609 = createclosure(2, "_apply");
  setclosureframe(closure8609, stackframe);
  addtoclosure(closure8609, var_tokens);
  addtoclosure(closure8609, selfslot);
  struct UserObject *uo8609 = (struct UserObject*)block8608;
  uo8609->data[0] = (Object)closure8609;
  Method *meth_meth_parser__apply8609 = addmethod2pos(block8608, "_apply", &meth_parser__apply8609, 0);
  int argcv_meth_parser__apply8609[] = {0};
  meth_meth_parser__apply8609->type = alloc_MethodType(1, argcv_meth_parser__apply8609);
  meth_meth_parser__apply8609->definitionModule = modulename;
  meth_meth_parser__apply8609->definitionLine = 2666;
// compiled block node returning block8608 (depth = 5)
  gc_frame_newslot(block8608);
// call case 6: other member request
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8621 == NULL) {
    strlit8621 = alloc_String("factory");
    gc_root(strlit8621);
  }
// compiled string node returning strlit8621 (depth = 7)
  int op_slot_right_8620 = gc_frame_newslot(strlit8621);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8624 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8623);
// compiled call node returning call8624 (depth = 8)
// compiled member node returning call8624 (depth = 7)
  int op_slot_left_8620 = gc_frame_newslot(call8624);
  params[0] = strlit8621;
  partcv[0] = 1;
  Object opresult8625 = callmethod(call8624, "==", 1, partcv, params);
// compiled op node returning opresult8625 (depth = 6)
  int op_slot_right_8619 = gc_frame_newslot(opresult8625);
// starting to compile call node (depth = 6)
  int callframe8627 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8628 == NULL) {
    strlit8628 = alloc_String("keyword");
    gc_root(strlit8628);
  }
// compiled string node returning strlit8628 (depth = 7)
  gc_frame_newslot(strlit8628);
// call case 4: self request
  params[0] = strlit8628;
  partcv[0] = 1;
  Object call8629 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8627);
// compiled call node returning call8629 (depth = 6)
  int op_slot_left_8619 = gc_frame_newslot(call8629);
  params[0] = opresult8625;
  partcv[0] = 1;
  Object opresult8630 = callmethod(call8629, "&&", 1, partcv, params);
// compiled op node returning opresult8630 (depth = 5)
  params[0] = block8608;
  partcv[0] = 1;
  Object call8631 = callmethod(opresult8630, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8607);
// compiled call node returning call8631 (depth = 4)
  params[0] = block8596;
  partcv[0] = 1;
  Object call8632 = callmethod(call8631, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8595);
// compiled call node returning call8632 (depth = 3)
  Object if8594 = done;
  if (istrue(call8632)) {
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8634 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8633);
// compiled call node returning call8634 (depth = 4)
// compiled member node returning call8634 (depth = 3)
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8635 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8636 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8635);
// compiled call node returning call8636 (depth = 4)
// compiled member node returning call8636 (depth = 3)
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8639 == NULL) {
    strlit8639 = alloc_String("identifier");
    gc_root(strlit8639);
  }
// compiled string node returning strlit8639 (depth = 5)
  int op_slot_right_8638 = gc_frame_newslot(strlit8639);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8642 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8641);
// compiled call node returning call8642 (depth = 6)
// compiled member node returning call8642 (depth = 5)
  int op_slot_left_8638 = gc_frame_newslot(call8642);
  params[0] = strlit8639;
  partcv[0] = 1;
  Object opresult8643 = callmethod(call8642, "!=", 1, partcv, params);
// compiled op node returning opresult8643 (depth = 4)
  Object if8637 = done;
  if (istrue(opresult8643)) {
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8644 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8645 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8646 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8645);
// compiled call node returning call8646 (depth = 8)
// compiled member node returning call8646 (depth = 7)
  partcv[0] = 0;
  Object call8647 = callmethod(call8646, "empty",
    1, partcv, params);
  gc_frame_end(callframe8644);
// compiled call node returning call8647 (depth = 6)
// compiled member node returning call8647 (depth = 5)
  *var_suggestions = call8647;
  if (call8647 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8650 == NULL) {
    strlit8650 = alloc_String("lbrace");
    gc_root(strlit8650);
  }
// compiled string node returning strlit8650 (depth = 6)
  int op_slot_right_8649 = gc_frame_newslot(strlit8650);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8652 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8653 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8652);
// compiled call node returning call8653 (depth = 7)
// compiled member node returning call8653 (depth = 6)
  int op_slot_left_8649 = gc_frame_newslot(call8653);
  params[0] = strlit8650;
  partcv[0] = 1;
  Object opresult8654 = callmethod(call8653, "==", 1, partcv, params);
// compiled op node returning opresult8654 (depth = 5)
  Object if8648 = done;
  if (istrue(opresult8654)) {
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8655 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8656 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8657 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8656);
// compiled call node returning call8657 (depth = 9)
// compiled member node returning call8657 (depth = 8)
  partcv[0] = 0;
  Object call8658 = callmethod(call8657, "new",
    1, partcv, params);
  gc_frame_end(callframe8655);
// compiled call node returning call8658 (depth = 7)
// compiled member node returning call8658 (depth = 6)
  *var_suggestion = call8658;
  if (call8658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8659 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8660 == NULL) {
    strlit8660 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8660);
  }
// compiled string node returning strlit8660 (depth = 6)
  gc_frame_newslot(strlit8660);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8660;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8661 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8659);
// compiled call node returning call8661 (depth = 5)
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8662 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8663 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8662);
// compiled call node returning call8663 (depth = 5)
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8664 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8665 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8666 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8665);
// compiled call node returning call8666 (depth = 9)
// compiled member node returning call8666 (depth = 8)
  partcv[0] = 0;
  Object call8667 = callmethod(call8666, "new",
    1, partcv, params);
  gc_frame_end(callframe8664);
// compiled call node returning call8667 (depth = 7)
// compiled member node returning call8667 (depth = 6)
  *var_suggestion = call8667;
  if (call8667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8669 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8670 == NULL) {
    strlit8670 = alloc_String("object");
    gc_root(strlit8670);
  }
// compiled string node returning strlit8670 (depth = 6)
  gc_frame_newslot(strlit8670);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8670;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8671 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8669);
// compiled call node returning call8671 (depth = 5)
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8672 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8673 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8672);
// compiled call node returning call8673 (depth = 5)
    gc_frame_newslot(call8673);
    if8648 = call8673;
  } else {
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8674 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8676 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8675);
// compiled call node returning call8676 (depth = 9)
// compiled member node returning call8676 (depth = 8)
  partcv[0] = 0;
  Object call8677 = callmethod(call8676, "new",
    1, partcv, params);
  gc_frame_end(callframe8674);
// compiled call node returning call8677 (depth = 7)
// compiled member node returning call8677 (depth = 6)
  *var_suggestion = call8677;
  if (call8677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8678 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8679 == NULL) {
    strlit8679 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb"" {}");
    gc_root(strlit8679);
  }
// compiled string node returning strlit8679 (depth = 6)
  gc_frame_newslot(strlit8679);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8679;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8680 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8678);
// compiled call node returning call8680 (depth = 5)
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8681 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8682 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8681);
// compiled call node returning call8682 (depth = 5)
    gc_frame_newslot(call8682);
    if8648 = call8682;
  }
// compiled if node returning if8648 (depth = 4)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8683 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8684 == NULL) {
    strlit8684 = alloc_String("A factory method must have a name after the 'method'.");
    gc_root(strlit8684);
  }
// compiled string node returning strlit8684 (depth = 5)
  gc_frame_newslot(strlit8684);
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8685 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8686 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8685);
// compiled call node returning call8686 (depth = 6)
// compiled member node returning call8686 (depth = 5)
  gc_frame_newslot(call8686);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8688 = alloc_Float64(1);
// compiled num node returning num8688 (depth = 6)
  int op_slot_right_8687 = gc_frame_newslot(num8688);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8692 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8691);
// compiled call node returning call8692 (depth = 8)
// compiled member node returning call8692 (depth = 7)
  int op_slot_right_8690 = gc_frame_newslot(call8692);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8694 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8695 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8694);
// compiled call node returning call8695 (depth = 8)
// compiled member node returning call8695 (depth = 7)
  int op_slot_left_8690 = gc_frame_newslot(call8695);
  params[0] = call8692;
  partcv[0] = 1;
  Object sum8696 = callmethod(call8695, "+", 1, partcv, params);
// compiled op node returning sum8696 (depth = 6)
  int op_slot_left_8687 = gc_frame_newslot(sum8696);
  params[0] = num8688;
  partcv[0] = 1;
  Object sum8697 = callmethod(sum8696, "+", 1, partcv, params);
// compiled op node returning sum8697 (depth = 5)
  gc_frame_newslot(sum8697);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8684;
  params[1] = call8686;
  params[2] = sum8697;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8698 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8683);
// compiled call node returning call8698 (depth = 4)
    gc_frame_newslot(call8698);
    if8637 = call8698;
  } else {
  }
// compiled if node returning if8637 (depth = 3)
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8699 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8700 = alloc_Boolean(0);
// compiled identifier node returning bool8700 (depth = 5)
  gc_frame_newslot(bool8700);
// call case 4: self request
  params[0] = bool8700;
  partcv[0] = 1;
  Object call8701 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8699);
// compiled call node returning call8701 (depth = 4)
  *var_s = call8701;
  if (call8701 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8702 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8703 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8702);
// compiled call node returning call8703 (depth = 5)
// compiled member node returning call8703 (depth = 4)
  *var_csig = call8703;
  if (call8703 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8704 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8705 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8704);
// compiled call node returning call8705 (depth = 5)
// compiled member node returning call8705 (depth = 4)
  *var_methodName = call8705;
  if (call8705 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8706 = gc_frame_new();
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool8707 = alloc_Boolean(1);
// compiled identifier node returning bool8707 (depth = 5)
  gc_frame_newslot(bool8707);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  params[0] = bool8707;
  partcv[0] = 1;
  Object call8708 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8706);
// compiled call node returning call8708 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8710 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8709);
// compiled call node returning call8710 (depth = 5)
// compiled member node returning call8710 (depth = 4)
  *var_dtype = call8710;
  if (call8710 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8711 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8712 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8711);
// compiled call node returning call8712 (depth = 5)
// compiled member node returning call8712 (depth = 4)
  *var_anns = call8712;
  if (call8712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8714 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8715 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8716 == NULL) {
    strlit8716 = alloc_String("lbrace");
    gc_root(strlit8716);
  }
// compiled string node returning strlit8716 (depth = 6)
  gc_frame_newslot(strlit8716);
// call case 4: self request
  params[0] = strlit8716;
  partcv[0] = 1;
  Object call8717 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8715);
// compiled call node returning call8717 (depth = 5)
  partcv[0] = 0;
  Object call8718 = callmethod(call8717, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8714);
// compiled call node returning call8718 (depth = 4)
  Object if8713 = done;
  if (istrue(call8718)) {
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8719 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8720 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8721 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8720);
// compiled call node returning call8721 (depth = 8)
// compiled member node returning call8721 (depth = 7)
  partcv[0] = 0;
  Object call8722 = callmethod(call8721, "new",
    1, partcv, params);
  gc_frame_end(callframe8719);
// compiled call node returning call8722 (depth = 6)
// compiled member node returning call8722 (depth = 5)
  *var_suggestion = call8722;
  if (call8722 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8723 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8724 == NULL) {
    strlit8724 = alloc_String(" {");
    gc_root(strlit8724);
  }
// compiled string node returning strlit8724 (depth = 5)
  gc_frame_newslot(strlit8724);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8724;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8725 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8723);
// compiled call node returning call8725 (depth = 4)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8726 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8727 == NULL) {
    strlit8727 = alloc_String("A factory method must have a '{' after the name.");
    gc_root(strlit8727);
  }
// compiled string node returning strlit8727 (depth = 5)
  gc_frame_newslot(strlit8727);
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8729 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8728);
// compiled call node returning call8729 (depth = 6)
// compiled member node returning call8729 (depth = 5)
  gc_frame_newslot(call8729);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8731 = alloc_Float64(1);
// compiled num node returning num8731 (depth = 6)
  int op_slot_right_8730 = gc_frame_newslot(num8731);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8735 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8734);
// compiled call node returning call8735 (depth = 8)
// compiled member node returning call8735 (depth = 7)
  int op_slot_right_8733 = gc_frame_newslot(call8735);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8737 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8738 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8737);
// compiled call node returning call8738 (depth = 8)
// compiled member node returning call8738 (depth = 7)
  int op_slot_left_8733 = gc_frame_newslot(call8738);
  params[0] = call8735;
  partcv[0] = 1;
  Object sum8739 = callmethod(call8738, "+", 1, partcv, params);
// compiled op node returning sum8739 (depth = 6)
  int op_slot_left_8730 = gc_frame_newslot(sum8739);
  params[0] = num8731;
  partcv[0] = 1;
  Object sum8740 = callmethod(sum8739, "+", 1, partcv, params);
// compiled op node returning sum8740 (depth = 5)
  gc_frame_newslot(sum8740);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8727;
  params[1] = call8729;
  params[2] = sum8740;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8741 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8726);
// compiled call node returning call8741 (depth = 4)
    gc_frame_newslot(call8741);
    if8713 = call8741;
  } else {
  }
// compiled if node returning if8713 (depth = 3)
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8743 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8742);
// compiled call node returning call8743 (depth = 4)
// compiled member node returning call8743 (depth = 3)
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8746 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call8747 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8746);
// compiled call node returning call8747 (depth = 6)
// compiled member node returning call8747 (depth = 5)
  int op_slot_right_8745 = gc_frame_newslot(call8747);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8750 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8749);
// compiled call node returning call8750 (depth = 6)
// compiled member node returning call8750 (depth = 5)
  int op_slot_left_8745 = gc_frame_newslot(call8750);
  params[0] = call8747;
  partcv[0] = 1;
  Object opresult8751 = callmethod(call8750, "==", 1, partcv, params);
// compiled op node returning opresult8751 (depth = 4)
  Object if8744 = done;
  if (istrue(opresult8751)) {
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8753 = alloc_Float64(1);
// compiled num node returning num8753 (depth = 6)
  int op_slot_right_8752 = gc_frame_newslot(num8753);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8756 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8755);
// compiled call node returning call8756 (depth = 7)
// compiled member node returning call8756 (depth = 6)
  int op_slot_left_8752 = gc_frame_newslot(call8756);
  params[0] = num8753;
  partcv[0] = 1;
  Object diff8757 = callmethod(call8756, "-", 1, partcv, params);
// compiled op node returning diff8757 (depth = 5)
  *var_minIndentLevel = diff8757;
  if (diff8757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8744 = done;
  } else {
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8760 = alloc_Float64(1);
// compiled num node returning num8760 (depth = 6)
  int op_slot_right_8759 = gc_frame_newslot(num8760);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  partcv[0] = 0;
  Object call8763 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8762);
// compiled call node returning call8763 (depth = 7)
// compiled member node returning call8763 (depth = 6)
  int op_slot_left_8759 = gc_frame_newslot(call8763);
  params[0] = num8760;
  partcv[0] = 1;
  Object sum8764 = callmethod(call8763, "+", 1, partcv, params);
// compiled op node returning sum8764 (depth = 5)
  *var_minIndentLevel = sum8764;
  if (sum8764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8744 = done;
  }
// compiled if node returning if8744 (depth = 3)
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8766 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8766 (depth = 4)
  *var_body = array8766;
  if (array8766 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8767 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8768 = alloc_Block(NULL, NULL, "parser", 2707);
  gc_frame_newslot(block8768);
// method _apply
  block_savedest(block8768);
  Object closure8769 = createclosure(1, "_apply");
  setclosureframe(closure8769, stackframe);
  addtoclosure(closure8769, selfslot);
  struct UserObject *uo8769 = (struct UserObject*)block8768;
  uo8769->data[0] = (Object)closure8769;
  Method *meth_meth_parser__apply8769 = addmethod2pos(block8768, "_apply", &meth_parser__apply8769, 0);
  int argcv_meth_parser__apply8769[] = {0};
  meth_meth_parser__apply8769->type = alloc_MethodType(1, argcv_meth_parser__apply8769);
  meth_meth_parser__apply8769->definitionModule = modulename;
  meth_meth_parser__apply8769->definitionLine = 2704;
// compiled block node returning block8768 (depth = 4)
  gc_frame_newslot(block8768);
// starting to compile block node (depth = 4)
  Object block8776 = alloc_Block(NULL, NULL, "parser", 2707);
  gc_frame_newslot(block8776);
// method _apply
  block_savedest(block8776);
  Object closure8777 = createclosure(3, "_apply");
  setclosureframe(closure8777, stackframe);
  addtoclosure(closure8777, var_values);
  addtoclosure(closure8777, var_body);
  addtoclosure(closure8777, selfslot);
  struct UserObject *uo8777 = (struct UserObject*)block8776;
  uo8777->data[0] = (Object)closure8777;
  Method *meth_meth_parser__apply8777 = addmethod2pos(block8776, "_apply", &meth_parser__apply8777, 0);
  int argcv_meth_parser__apply8777[] = {0};
  meth_meth_parser__apply8777->type = alloc_MethodType(1, argcv_meth_parser__apply8777);
  meth_meth_parser__apply8777->definitionModule = modulename;
  meth_meth_parser__apply8777->definitionLine = 2707;
// compiled block node returning block8776 (depth = 4)
  gc_frame_newslot(block8776);
// call case 5: prelude request
  params[0] = block8768;
  params[1] = block8776;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8821 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8767);
// compiled call node returning call8821 (depth = 3)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8822 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8823 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8822);
// compiled call node returning call8823 (depth = 4)
// compiled member node returning call8823 (depth = 3)
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8824 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8826 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8825);
// compiled call node returning call8826 (depth = 5)
// compiled member node returning call8826 (depth = 4)
  gc_frame_newslot(call8826);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8826;
  partcv[0] = 1;
  Object call8827 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8824);
// compiled call node returning call8827 (depth = 3)
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8828 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
  Object bool8829 = alloc_Boolean(0);
// compiled identifier node returning bool8829 (depth = 5)
  gc_frame_newslot(bool8829);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8831 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8830);
// compiled call node returning call8831 (depth = 6)
// compiled member node returning call8831 (depth = 5)
  params[0] = *var_body;
  params[1] = bool8829;
  partcv[0] = 2;
  Object call8832 = callmethod(call8831, "new",
    1, partcv, params);
  gc_frame_end(callframe8828);
// compiled call node returning call8832 (depth = 4)
  *var_obj = call8832;
  if (call8832 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8833 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_csig (depth = 5)
  gc_frame_newslot(*var_csig);
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8834 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_obj (depth = 6)
  gc_frame_newslot(*var_obj);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8835 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8836 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8835);
// compiled call node returning call8836 (depth = 7)
// compiled member node returning call8836 (depth = 6)
  params[0] = *var_obj;
  partcv[0] = 1;
  Object call8837 = callmethod(call8836, "with",
    1, partcv, params);
  gc_frame_end(callframe8834);
// compiled call node returning call8837 (depth = 5)
  gc_frame_newslot(call8837);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8838 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8839 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8838);
// compiled call node returning call8839 (depth = 6)
// compiled member node returning call8839 (depth = 5)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = call8837;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8840 = callmethod(call8839, "new",
    1, partcv, params);
  gc_frame_end(callframe8833);
// compiled call node returning call8840 (depth = 4)
  *var_meth = call8840;
  if (call8840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8841 = gc_frame_new();
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  partcv[0] = 0;
  Object call8843 = callmethod(*var_s, "generics",
    1, partcv, params);
  gc_frame_end(callframe8842);
// compiled call node returning call8843 (depth = 6)
// compiled member node returning call8843 (depth = 5)
  gc_frame_newslot(call8843);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = call8843;
  partcv[0] = 1;
  Object call8844 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe8841);
// compiled call node returning call8844 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8846 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8848 = alloc_Boolean(0);
// compiled identifier node returning bool8848 (depth = 5)
  int op_slot_left_8846 = gc_frame_newslot(bool8848);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8849 = callmethod(bool8848, "!=", 1, partcv, params);
// compiled op node returning opresult8849 (depth = 4)
  Object if8845 = done;
  if (istrue(opresult8849)) {
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8850 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8851 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call8852 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8851);
// compiled call node returning call8852 (depth = 6)
// compiled member node returning call8852 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8853 = callmethod(call8852, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8850);
// compiled call node returning call8853 (depth = 4)
    gc_frame_newslot(call8853);
    if8845 = call8853;
  } else {
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8856 == NULL) {
    strlit8856 = alloc_String("confidential");
    gc_root(strlit8856);
  }
// compiled string node returning strlit8856 (depth = 6)
  int op_slot_right_8855 = gc_frame_newslot(strlit8856);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 6)
  int op_slot_left_8855 = gc_frame_newslot(*var_defaultMethodVisibility);
  params[0] = strlit8856;
  partcv[0] = 1;
  Object opresult8858 = callmethod(*var_defaultMethodVisibility, "==", 1, partcv, params);
// compiled op node returning opresult8858 (depth = 5)
  Object if8854 = done;
  if (istrue(opresult8858)) {
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8859 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe8860 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8861 == NULL) {
    strlit8861 = alloc_String("confidential");
    gc_root(strlit8861);
  }
// compiled string node returning strlit8861 (depth = 7)
  gc_frame_newslot(strlit8861);
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool8862 = alloc_Boolean(0);
// compiled identifier node returning bool8862 (depth = 7)
  gc_frame_newslot(bool8862);
// call case 6: other member request
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8863 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call8864 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8863);
// compiled call node returning call8864 (depth = 8)
// compiled member node returning call8864 (depth = 7)
  params[0] = strlit8861;
  params[1] = bool8862;
  partcv[0] = 2;
  Object call8865 = callmethod(call8864, "new",
    1, partcv, params);
  gc_frame_end(callframe8860);
// compiled call node returning call8865 (depth = 6)
  gc_frame_newslot(call8865);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8866 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call8867 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8866);
// compiled call node returning call8867 (depth = 7)
// compiled member node returning call8867 (depth = 6)
  params[0] = call8865;
  partcv[0] = 1;
  Object call8868 = callmethod(call8867, "push",
    1, partcv, params);
  gc_frame_end(callframe8859);
// compiled call node returning call8868 (depth = 5)
    gc_frame_newslot(call8868);
    if8854 = call8868;
  } else {
  }
// compiled if node returning if8854 (depth = 4)
    gc_frame_newslot(if8854);
    if8845 = if8854;
  }
// compiled if node returning if8845 (depth = 3)
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8869 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8870 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8869);
// compiled call node returning call8870 (depth = 3)
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8871 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8872 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8871);
// compiled call node returning call8872 (depth = 4)
// compiled member node returning call8872 (depth = 3)
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8594 = done;
  } else {
  }
// compiled if node returning if8594 (depth = 2)
  gc_frame_end(frame);
  return if8594;
}
Object meth_parser__apply8952(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8954 == NULL) {
    strlit8954 = alloc_String("lbrace");
    gc_root(strlit8954);
  }
// compiled string node returning strlit8954 (depth = 7)
  int op_slot_right_8953 = gc_frame_newslot(strlit8954);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call8957 = callmethod(*var_s, "kind",
    1, partcv, params);
  gc_frame_end(callframe8956);
// compiled call node returning call8957 (depth = 8)
// compiled member node returning call8957 (depth = 7)
  int op_slot_left_8953 = gc_frame_newslot(call8957);
  params[0] = strlit8954;
  partcv[0] = 1;
  Object opresult8958 = callmethod(call8957, "!=", 1, partcv, params);
// compiled op node returning opresult8958 (depth = 6)
  gc_frame_end(frame);
  return opresult8958;
}
Object meth_parser__apply8961(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8962 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8963 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8962);
// compiled call node returning call8963 (depth = 6)
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8964 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8965 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8964);
// compiled call node returning call8965 (depth = 7)
// compiled member node returning call8965 (depth = 6)
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8966 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call8967 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8966);
// compiled call node returning call8967 (depth = 8)
// compiled member node returning call8967 (depth = 7)
  *var_s = call8967;
  if (call8967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_methoddec8874(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methoddec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for methoddec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_stok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "stok");
  Object *var_m = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "m");
  Object *var_meth = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "meth");
  Object *var_signature = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "signature");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_varargs = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "varargs");
  Object *var_generics = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "generics");
  Object *var_body = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "body");
  Object *var_localMin = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "localMin");
  Object *var_anns = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "anns");
  Object *var_s = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "s");
  Object *var_suggestion = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "closingBrace");
  Object *var_o = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "o");
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8878 == NULL) {
    strlit8878 = alloc_String("method");
    gc_root(strlit8878);
  }
// compiled string node returning strlit8878 (depth = 5)
  int op_slot_right_8877 = gc_frame_newslot(strlit8878);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8880 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8881 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8880);
// compiled call node returning call8881 (depth = 6)
// compiled member node returning call8881 (depth = 5)
  int op_slot_left_8877 = gc_frame_newslot(call8881);
  params[0] = strlit8878;
  partcv[0] = 1;
  Object opresult8882 = callmethod(call8881, "==", 1, partcv, params);
// compiled op node returning opresult8882 (depth = 4)
  int op_slot_right_8876 = gc_frame_newslot(opresult8882);
// starting to compile call node (depth = 4)
  int callframe8884 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8885 == NULL) {
    strlit8885 = alloc_String("keyword");
    gc_root(strlit8885);
  }
// compiled string node returning strlit8885 (depth = 5)
  gc_frame_newslot(strlit8885);
// call case 4: self request
  params[0] = strlit8885;
  partcv[0] = 1;
  Object call8886 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8884);
// compiled call node returning call8886 (depth = 4)
  int op_slot_left_8876 = gc_frame_newslot(call8886);
  params[0] = opresult8882;
  partcv[0] = 1;
  Object opresult8887 = callmethod(call8886, "&&", 1, partcv, params);
// compiled op node returning opresult8887 (depth = 3)
  Object if8875 = done;
  if (istrue(opresult8887)) {
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8888 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8889 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8888);
// compiled call node returning call8889 (depth = 4)
// compiled member node returning call8889 (depth = 3)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_stok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8891 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8892 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8891);
// compiled call node returning call8892 (depth = 4)
// compiled member node returning call8892 (depth = 3)
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8893 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8894 = alloc_Boolean(0);
// compiled identifier node returning bool8894 (depth = 5)
  gc_frame_newslot(bool8894);
// call case 4: self request
  params[0] = bool8894;
  partcv[0] = 1;
  Object call8895 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8893);
// compiled call node returning call8895 (depth = 4)
  *var_m = call8895;
  if (call8895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8896 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8897 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe8896);
// compiled call node returning call8897 (depth = 5)
// compiled member node returning call8897 (depth = 4)
  *var_meth = call8897;
  if (call8897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8898 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8899 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe8898);
// compiled call node returning call8899 (depth = 5)
// compiled member node returning call8899 (depth = 4)
  *var_signature = call8899;
  if (call8899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8901 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8900);
// compiled call node returning call8901 (depth = 5)
// compiled member node returning call8901 (depth = 4)
  *var_dtype = call8901;
  if (call8901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8902 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8903 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe8902);
// compiled call node returning call8903 (depth = 5)
// compiled member node returning call8903 (depth = 4)
  *var_varargs = call8903;
  if (call8903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8904 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8905 = callmethod(*var_m, "generics",
    1, partcv, params);
  gc_frame_end(callframe8904);
// compiled call node returning call8905 (depth = 5)
// compiled member node returning call8905 (depth = 4)
  *var_generics = call8905;
  if (call8905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8906 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8906 (depth = 4)
  *var_body = array8906;
  if (array8906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_localMin = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8908 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8907);
// compiled call node returning call8908 (depth = 5)
// compiled member node returning call8908 (depth = 4)
  *var_anns = call8908;
  if (call8908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8910 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8911 == NULL) {
    strlit8911 = alloc_String("lbrace");
    gc_root(strlit8911);
  }
// compiled string node returning strlit8911 (depth = 5)
  gc_frame_newslot(strlit8911);
// call case 4: self request
  params[0] = strlit8911;
  partcv[0] = 1;
  Object call8912 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8910);
// compiled call node returning call8912 (depth = 4)
  Object if8909 = done;
  if (istrue(call8912)) {
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8913 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8914 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8913);
// compiled call node returning call8914 (depth = 5)
// compiled member node returning call8914 (depth = 4)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minIndentLevel (depth = 5)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stok (depth = 8)
  partcv[0] = 0;
  Object call8919 = callmethod(*var_stok, "line",
    1, partcv, params);
  gc_frame_end(callframe8918);
// compiled call node returning call8919 (depth = 7)
// compiled member node returning call8919 (depth = 6)
  int op_slot_right_8917 = gc_frame_newslot(call8919);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8922 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8921);
// compiled call node returning call8922 (depth = 7)
// compiled member node returning call8922 (depth = 6)
  int op_slot_left_8917 = gc_frame_newslot(call8922);
  params[0] = call8919;
  partcv[0] = 1;
  Object opresult8923 = callmethod(call8922, "==", 1, partcv, params);
// compiled op node returning opresult8923 (depth = 5)
  Object if8916 = done;
  if (istrue(opresult8923)) {
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8925 = alloc_Float64(1);
// compiled num node returning num8925 (depth = 7)
  int op_slot_right_8924 = gc_frame_newslot(num8925);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8927 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8928 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8927);
// compiled call node returning call8928 (depth = 8)
// compiled member node returning call8928 (depth = 7)
  int op_slot_left_8924 = gc_frame_newslot(call8928);
  params[0] = num8925;
  partcv[0] = 1;
  Object diff8929 = callmethod(call8928, "-", 1, partcv, params);
// compiled op node returning diff8929 (depth = 6)
  *var_minIndentLevel = diff8929;
  if (diff8929 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8916 = done;
  } else {
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8932 = alloc_Float64(1);
// compiled num node returning num8932 (depth = 7)
  int op_slot_right_8931 = gc_frame_newslot(num8932);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8934 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_stok (depth = 9)
  partcv[0] = 0;
  Object call8935 = callmethod(*var_stok, "indent",
    1, partcv, params);
  gc_frame_end(callframe8934);
// compiled call node returning call8935 (depth = 8)
// compiled member node returning call8935 (depth = 7)
  int op_slot_left_8931 = gc_frame_newslot(call8935);
  params[0] = num8932;
  partcv[0] = 1;
  Object sum8936 = callmethod(call8935, "+", 1, partcv, params);
// compiled op node returning sum8936 (depth = 6)
  *var_minIndentLevel = sum8936;
  if (sum8936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8916 = done;
  }
// compiled if node returning if8916 (depth = 4)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8938 = gc_frame_new();
// starting to compile object node (depth = 5)
  Object inheritingObject8939 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8939 = alloc_userobj2(3,4, objclass8939);
  gc_frame_newslot(obj8939);
// OBJECT OUTER DEC outer
  adddatum2(obj8939, self, 0);
  addmethodreal(obj8939,"outer", &reader_parser_outer_8940);
  Object oldself8939 = self;
  struct StackFrameObject *oldstackframe8939 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8939);
  gc_frame_newslot((Object)stackframe);
  self = obj8939;
  Object *oldselfslot8939 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8939 = (*(struct UserObject *)self).data[0], lowerouter8939 = thisouter8939;
  if (inheritingObject8939) {
    struct UserObject *inho8939 = (struct UserObject *)inheritingObject8939;
    while (inho8939->super != GraceDefaultObject) inho8939 = (struct UserObject *)inho8939->super;
    inho8939->super = obj8939;
    self = inheritingObject8939;
    *selfslot = self;
    lowerouter8939 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8939;
  }
if (objclass8939 == NULL) {
  Method *reader8941 = addmethodrealflags(obj8939, "kind",&reader_parser_kind_8941, MFLAG_DEF);
  reader8941->definitionModule = modulename;
  reader8941->definitionLine = 2764;
}
adddatum2(obj8939, alloc_Undefined(), 1);
if (objclass8939 == NULL) {
  Method *reader8942 = addmethodrealflags(obj8939, "register",&reader_parser_register_8942, 0);
  Method *writer8942 = addmethodrealflags(obj8939, "register:=",&writer_parser_register_8942, 0);
  reader8942->definitionModule = modulename;
  writer8942->definitionModule = modulename;
  reader8942->definitionLine = 2765;
  writer8942->definitionLine = 2765;
}
obj8939->flags |= OFLAG_MUTABLE;
adddatum2(obj8939, alloc_Undefined(), 2);
  sourceObject = obj8939;
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8943 == NULL) {
    strlit8943 = alloc_String("lbrace");
    gc_root(strlit8943);
  }
// compiled string node returning strlit8943 (depth = 6)
  adddatum2(obj8939, strlit8943, 1);
  sourceObject = obj8939;
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8944 == NULL) {
    strlit8944 = alloc_String("");
    gc_root(strlit8944);
  }
// compiled string node returning strlit8944 (depth = 6)
  adddatum2(obj8939, strlit8944, 2);
  objclass8939 = obj8939->class;
  objclass8939->definitionModule = modulename;
  objclass8939->definitionLine = 2763;
  (*(struct UserObject *)self).data[0] = lowerouter8939;
  self = oldself8939;
  selfslot = oldselfslot8939;
  stackframe = oldstackframe8939;
// compiled object node returning obj8939 (depth = 5)
  gc_frame_newslot(obj8939);
// call case 6: other member request
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = obj8939;
  partcv[0] = 1;
  Object call8945 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8938);
// compiled call node returning call8945 (depth = 4)
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8946 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8947 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8946);
// compiled call node returning call8947 (depth = 5)
// compiled member node returning call8947 (depth = 4)
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8948 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8949 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8948);
// compiled call node returning call8949 (depth = 6)
// compiled member node returning call8949 (depth = 5)
  *var_s = call8949;
  if (call8949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8950 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8951 = alloc_Block(NULL, NULL, "parser", 2769);
  gc_frame_newslot(block8951);
// method _apply
  block_savedest(block8951);
  Object closure8952 = createclosure(2, "_apply");
  setclosureframe(closure8952, stackframe);
  addtoclosure(closure8952, var_s);
  addtoclosure(closure8952, selfslot);
  struct UserObject *uo8952 = (struct UserObject*)block8951;
  uo8952->data[0] = (Object)closure8952;
  Method *meth_meth_parser__apply8952 = addmethod2pos(block8951, "_apply", &meth_parser__apply8952, 0);
  int argcv_meth_parser__apply8952[] = {0};
  meth_meth_parser__apply8952->type = alloc_MethodType(1, argcv_meth_parser__apply8952);
  meth_meth_parser__apply8952->definitionModule = modulename;
  meth_meth_parser__apply8952->definitionLine = 2768;
// compiled block node returning block8951 (depth = 5)
  gc_frame_newslot(block8951);
// starting to compile block node (depth = 5)
  Object block8960 = alloc_Block(NULL, NULL, "parser", 2769);
  gc_frame_newslot(block8960);
// method _apply
  block_savedest(block8960);
  Object closure8961 = createclosure(4, "_apply");
  setclosureframe(closure8961, stackframe);
  addtoclosure(closure8961, var_s);
  addtoclosure(closure8961, var_body);
  addtoclosure(closure8961, var_values);
  addtoclosure(closure8961, selfslot);
  struct UserObject *uo8961 = (struct UserObject*)block8960;
  uo8961->data[0] = (Object)closure8961;
  Method *meth_meth_parser__apply8961 = addmethod2pos(block8960, "_apply", &meth_parser__apply8961, 0);
  int argcv_meth_parser__apply8961[] = {0};
  meth_meth_parser__apply8961->type = alloc_MethodType(1, argcv_meth_parser__apply8961);
  meth_meth_parser__apply8961->definitionModule = modulename;
  meth_meth_parser__apply8961->definitionLine = 2769;
// compiled block node returning block8960 (depth = 5)
  gc_frame_newslot(block8960);
// call case 5: prelude request
  params[0] = block8951;
  params[1] = block8960;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8970 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8950);
// compiled call node returning call8970 (depth = 4)
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8973 == NULL) {
    strlit8973 = alloc_String("rbrace");
    gc_root(strlit8973);
  }
// compiled string node returning strlit8973 (depth = 6)
  int op_slot_right_8972 = gc_frame_newslot(strlit8973);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8975 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8976 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8975);
// compiled call node returning call8976 (depth = 7)
// compiled member node returning call8976 (depth = 6)
  int op_slot_left_8972 = gc_frame_newslot(call8976);
  params[0] = strlit8973;
  partcv[0] = 1;
  Object opresult8977 = callmethod(call8976, "!=", 1, partcv, params);
// compiled op node returning opresult8977 (depth = 5)
  Object if8971 = done;
  if (istrue(opresult8977)) {
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8978 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8980 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8979);
// compiled call node returning call8980 (depth = 9)
// compiled member node returning call8980 (depth = 8)
  partcv[0] = 0;
  Object call8981 = callmethod(call8980, "new",
    1, partcv, params);
  gc_frame_end(callframe8978);
// compiled call node returning call8981 (depth = 7)
// compiled member node returning call8981 (depth = 6)
  *var_suggestion = call8981;
  if (call8981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8982 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool8983 = alloc_Boolean(0);
// compiled identifier node returning bool8983 (depth = 7)
  gc_frame_newslot(bool8983);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8983;
  partcv[0] = 2;
  Object call8984 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8982);
// compiled call node returning call8984 (depth = 6)
  *var_closingBrace = call8984;
  if (call8984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool8987 = alloc_Boolean(0);
// compiled identifier node returning bool8987 (depth = 7)
  int op_slot_right_8986 = gc_frame_newslot(bool8987);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call8990 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8989);
// compiled call node returning call8990 (depth = 8)
// compiled member node returning call8990 (depth = 7)
  int op_slot_left_8986 = gc_frame_newslot(call8990);
  params[0] = bool8987;
  partcv[0] = 1;
  Object opresult8991 = callmethod(call8990, "==", 1, partcv, params);
// compiled op node returning opresult8991 (depth = 6)
  Object if8985 = done;
  if (istrue(opresult8991)) {
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_8993 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call8996 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8995);
// compiled call node returning call8996 (depth = 9)
// compiled member node returning call8996 (depth = 8)
  int op_slot_left_8993 = gc_frame_newslot(call8996);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8997 = callmethod(call8996, "==", 1, partcv, params);
// compiled op node returning opresult8997 (depth = 7)
  Object if8992 = done;
  if (istrue(opresult8997)) {
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8998 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8999 == NULL) {
    strlit8999 = alloc_String("}");
    gc_root(strlit8999);
  }
// compiled string node returning strlit8999 (depth = 8)
  gc_frame_newslot(strlit8999);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit8999;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9000 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8998);
// compiled call node returning call9000 (depth = 7)
    gc_frame_newslot(call9000);
    if8992 = call9000;
  } else {
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9001 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9003 = alloc_Float64(0.1);
// compiled num node returning num9003 (depth = 9)
  int op_slot_right_9002 = gc_frame_newslot(num9003);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9005 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call9007 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe9006);
// compiled call node returning call9007 (depth = 12)
// compiled member node returning call9007 (depth = 11)
  partcv[0] = 0;
  Object call9008 = callmethod(call9007, "line",
    1, partcv, params);
  gc_frame_end(callframe9005);
// compiled call node returning call9008 (depth = 10)
// compiled member node returning call9008 (depth = 9)
  int op_slot_left_9002 = gc_frame_newslot(call9008);
  params[0] = num9003;
  partcv[0] = 1;
  Object sum9009 = callmethod(call9008, "+", 1, partcv, params);
// compiled op node returning sum9009 (depth = 8)
  gc_frame_newslot(sum9009);
// starting to compile string node (depth = 8)
  if (strlit9010 == NULL) {
    strlit9010 = alloc_String("}");
    gc_root(strlit9010);
  }
// compiled string node returning strlit9010 (depth = 8)
  gc_frame_newslot(strlit9010);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum9009;
  params[1] = strlit9010;
  partcv[0] = 2;
  Object call9011 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe9001);
// compiled call node returning call9011 (depth = 7)
    gc_frame_newslot(call9011);
    if8992 = call9011;
  }
// compiled if node returning if8992 (depth = 6)
    gc_frame_newslot(if8992);
    if8985 = if8992;
  } else {
  }
// compiled if node returning if8985 (depth = 5)
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9012 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9013 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9012);
// compiled call node returning call9013 (depth = 5)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9014 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9015 == NULL) {
    strlit9015 = alloc_String("A method must end with a '}'.");
    gc_root(strlit9015);
  }
// compiled string node returning strlit9015 (depth = 6)
  gc_frame_newslot(strlit9015);
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9017 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9016);
// compiled call node returning call9017 (depth = 7)
// compiled member node returning call9017 (depth = 6)
  gc_frame_newslot(call9017);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9018 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9019 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9018);
// compiled call node returning call9019 (depth = 7)
// compiled member node returning call9019 (depth = 6)
  gc_frame_newslot(call9019);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9015;
  params[1] = call9017;
  params[2] = call9019;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9020 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9014);
// compiled call node returning call9020 (depth = 5)
    gc_frame_newslot(call9020);
    if8971 = call9020;
  } else {
  }
// compiled if node returning if8971 (depth = 4)
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9022 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9021);
// compiled call node returning call9022 (depth = 5)
// compiled member node returning call9022 (depth = 4)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_localMin (depth = 5)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8909 = done;
  } else {
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9024 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9026 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9025);
// compiled call node returning call9026 (depth = 8)
// compiled member node returning call9026 (depth = 7)
  partcv[0] = 0;
  Object call9027 = callmethod(call9026, "new",
    1, partcv, params);
  gc_frame_end(callframe9024);
// compiled call node returning call9027 (depth = 6)
// compiled member node returning call9027 (depth = 5)
  *var_suggestion = call9027;
  if (call9027 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9028 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 6)
  Object bool9029 = alloc_Boolean(1);
// compiled identifier node returning bool9029 (depth = 6)
  gc_frame_newslot(bool9029);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool9029;
  partcv[0] = 2;
  Object call9030 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9028);
// compiled call node returning call9030 (depth = 5)
  *var_closingBrace = call9030;
  if (call9030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9033 = alloc_Boolean(0);
// compiled identifier node returning bool9033 (depth = 6)
  int op_slot_right_9032 = gc_frame_newslot(bool9033);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call9036 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe9035);
// compiled call node returning call9036 (depth = 7)
// compiled member node returning call9036 (depth = 6)
  int op_slot_left_9032 = gc_frame_newslot(call9036);
  params[0] = bool9033;
  partcv[0] = 1;
  Object opresult9037 = callmethod(call9036, "==", 1, partcv, params);
// compiled op node returning opresult9037 (depth = 5)
  Object if9031 = done;
  if (istrue(opresult9037)) {
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  int op_slot_right_9039 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9041 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call9042 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe9041);
// compiled call node returning call9042 (depth = 8)
// compiled member node returning call9042 (depth = 7)
  int op_slot_left_9039 = gc_frame_newslot(call9042);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult9043 = callmethod(call9042, "==", 1, partcv, params);
// compiled op node returning opresult9043 (depth = 6)
  Object if9038 = done;
  if (istrue(opresult9043)) {
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9044 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9045 == NULL) {
    strlit9045 = alloc_String(" {}");
    gc_root(strlit9045);
  }
// compiled string node returning strlit9045 (depth = 7)
  gc_frame_newslot(strlit9045);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool9046 = alloc_Boolean(1);
// compiled identifier node returning bool9046 (depth = 7)
  gc_frame_newslot(bool9046);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit9045;
  params[1] = *var_lastToken;
  params[2] = bool9046;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9047 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe9044);
// compiled call node returning call9047 (depth = 6)
    gc_frame_newslot(call9047);
    if9038 = call9047;
  } else {
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9048 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9050 = alloc_Float64(0.1);
// compiled num node returning num9050 (depth = 8)
  int op_slot_right_9049 = gc_frame_newslot(num9050);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9052 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call9054 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe9053);
// compiled call node returning call9054 (depth = 11)
// compiled member node returning call9054 (depth = 10)
  partcv[0] = 0;
  Object call9055 = callmethod(call9054, "line",
    1, partcv, params);
  gc_frame_end(callframe9052);
// compiled call node returning call9055 (depth = 9)
// compiled member node returning call9055 (depth = 8)
  int op_slot_left_9049 = gc_frame_newslot(call9055);
  params[0] = num9050;
  partcv[0] = 1;
  Object sum9056 = callmethod(call9055, "+", 1, partcv, params);
// compiled op node returning sum9056 (depth = 7)
  gc_frame_newslot(sum9056);
// starting to compile string node (depth = 7)
  if (strlit9057 == NULL) {
    strlit9057 = alloc_String("}");
    gc_root(strlit9057);
  }
// compiled string node returning strlit9057 (depth = 7)
  gc_frame_newslot(strlit9057);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum9056;
  params[1] = strlit9057;
  partcv[0] = 2;
  Object call9058 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe9048);
// compiled call node returning call9058 (depth = 6)
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9059 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9060 == NULL) {
    strlit9060 = alloc_String(" {");
    gc_root(strlit9060);
  }
// compiled string node returning strlit9060 (depth = 7)
  gc_frame_newslot(strlit9060);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool9061 = alloc_Boolean(1);
// compiled identifier node returning bool9061 (depth = 7)
  gc_frame_newslot(bool9061);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit9060;
  params[1] = *var_lastToken;
  params[2] = bool9061;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9062 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe9059);
// compiled call node returning call9062 (depth = 6)
    gc_frame_newslot(call9062);
    if9038 = call9062;
  }
// compiled if node returning if9038 (depth = 5)
    gc_frame_newslot(if9038);
    if9031 = if9038;
  } else {
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9063 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9064 == NULL) {
    strlit9064 = alloc_String(" {");
    gc_root(strlit9064);
  }
// compiled string node returning strlit9064 (depth = 6)
  gc_frame_newslot(strlit9064);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
  Object bool9065 = alloc_Boolean(1);
// compiled identifier node returning bool9065 (depth = 6)
  gc_frame_newslot(bool9065);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9064;
  params[1] = *var_lastToken;
  params[2] = bool9065;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9066 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe9063);
// compiled call node returning call9066 (depth = 5)
    gc_frame_newslot(call9066);
    if9031 = call9066;
  }
// compiled if node returning if9031 (depth = 4)
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9067 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9068 == NULL) {
    strlit9068 = alloc_String("A method must have a '{' after the name.");
    gc_root(strlit9068);
  }
// compiled string node returning strlit9068 (depth = 5)
  gc_frame_newslot(strlit9068);
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9070 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9069);
// compiled call node returning call9070 (depth = 6)
// compiled member node returning call9070 (depth = 5)
  gc_frame_newslot(call9070);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9072 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9073 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9072);
// compiled call node returning call9073 (depth = 7)
// compiled member node returning call9073 (depth = 6)
  int op_slot_right_9071 = gc_frame_newslot(call9073);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9075 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9076 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9075);
// compiled call node returning call9076 (depth = 7)
// compiled member node returning call9076 (depth = 6)
  int op_slot_left_9071 = gc_frame_newslot(call9076);
  params[0] = call9073;
  partcv[0] = 1;
  Object sum9077 = callmethod(call9076, "+", 1, partcv, params);
// compiled op node returning sum9077 (depth = 5)
  gc_frame_newslot(sum9077);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9068;
  params[1] = call9070;
  params[2] = sum9077;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9078 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9067);
// compiled call node returning call9078 (depth = 4)
    gc_frame_newslot(call9078);
    if8909 = call9078;
  }
// compiled if node returning if8909 (depth = 3)
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9079 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call9081 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe9080);
// compiled call node returning call9081 (depth = 5)
// compiled member node returning call9081 (depth = 4)
  gc_frame_newslot(call9081);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call9081;
  partcv[0] = 1;
  Object call9082 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe9079);
// compiled call node returning call9082 (depth = 3)
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9083 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9084 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9085 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9084);
// compiled call node returning call9085 (depth = 6)
// compiled member node returning call9085 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call9086 = callmethod(call9085, "new",
    1, partcv, params);
  gc_frame_end(callframe9083);
// compiled call node returning call9086 (depth = 4)
  *var_o = call9086;
  if (call9086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_varargs (depth = 4)
  Object if9087 = done;
  if (istrue(*var_varargs)) {
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9088 = gc_frame_new();
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool9089 = alloc_Boolean(1);
// compiled identifier node returning bool9089 (depth = 6)
  gc_frame_newslot(bool9089);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  params[0] = bool9089;
  partcv[0] = 1;
  Object call9090 = callmethod(*var_o, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe9088);
// compiled call node returning call9090 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9087 = done;
  } else {
  }
// compiled if node returning if9087 (depth = 3)
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9091 = gc_frame_new();
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_generics (depth = 5)
  gc_frame_newslot(*var_generics);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_generics;
  partcv[0] = 1;
  Object call9092 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe9091);
// compiled call node returning call9092 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9095 = alloc_Boolean(0);
// compiled identifier node returning bool9095 (depth = 5)
  int op_slot_right_9094 = gc_frame_newslot(bool9095);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_9094 = gc_frame_newslot(*var_anns);
  params[0] = bool9095;
  partcv[0] = 1;
  Object opresult9097 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult9097 (depth = 4)
  Object if9093 = done;
  if (istrue(opresult9097)) {
// starting to compile call node (depth = 4)
  int callframe9098 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9099 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call9100 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe9099);
// compiled call node returning call9100 (depth = 6)
// compiled member node returning call9100 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call9101 = callmethod(call9100, "addAll",
    1, partcv, params);
  gc_frame_end(callframe9098);
// compiled call node returning call9101 (depth = 4)
    gc_frame_newslot(call9101);
    if9093 = call9101;
  } else {
  }
// compiled if node returning if9093 (depth = 3)
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9102 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 4)
  gc_frame_newslot(*var_defaultMethodVisibility);
// starting to compile string node (depth = 4)
  if (strlit9103 == NULL) {
    strlit9103 = alloc_String("public");
    gc_root(strlit9103);
  }
// compiled string node returning strlit9103 (depth = 4)
  gc_frame_newslot(strlit9103);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultMethodVisibility;
  params[2] = strlit9103;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9104 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9102);
// compiled call node returning call9104 (depth = 3)
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9106 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe9105);
// compiled call node returning call9106 (depth = 3)
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9108 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9107);
// compiled call node returning call9108 (depth = 4)
// compiled member node returning call9108 (depth = 3)
    gc_frame_newslot(call9108);
    if8875 = call9108;
  } else {
  }
// compiled if node returning if8875 (depth = 2)
  gc_frame_end(frame);
  return if8875;
}
Object meth_parser__apply9118(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9120 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9121 == NULL) {
    strlit9121 = alloc_String("identifier");
    gc_root(strlit9121);
  }
// compiled string node returning strlit9121 (depth = 6)
  gc_frame_newslot(strlit9121);
// call case 4: self request
  params[0] = strlit9121;
  partcv[0] = 1;
  Object call9122 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9120);
// compiled call node returning call9122 (depth = 5)
  int op_slot_right_9119 = gc_frame_newslot(call9122);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9125 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9126 == NULL) {
    strlit9126 = alloc_String("identifier");
    gc_root(strlit9126);
  }
// compiled string node returning strlit9126 (depth = 7)
  gc_frame_newslot(strlit9126);
// call case 4: self request
  params[0] = strlit9126;
  partcv[0] = 1;
  Object call9127 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9125);
// compiled call node returning call9127 (depth = 6)
  int op_slot_right_9124 = gc_frame_newslot(call9127);
// starting to compile call node (depth = 6)
  int callframe9129 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call9130 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9129);
// compiled call node returning call9130 (depth = 6)
  int op_slot_left_9124 = gc_frame_newslot(call9130);
  params[0] = call9127;
  partcv[0] = 1;
  Object opresult9131 = callmethod(call9130, "&&", 1, partcv, params);
// compiled op node returning opresult9131 (depth = 5)
  int op_slot_left_9119 = gc_frame_newslot(opresult9131);
  params[0] = call9122;
  partcv[0] = 1;
  Object opresult9132 = callmethod(opresult9131, "||", 1, partcv, params);
// compiled op node returning opresult9132 (depth = 4)
  gc_frame_end(frame);
  return opresult9132;
}
Object meth_parser__apply9186(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9190 == NULL) {
    strlit9190 = alloc_String("*");
    gc_root(strlit9190);
  }
// compiled string node returning strlit9190 (depth = 9)
  int op_slot_right_9189 = gc_frame_newslot(strlit9190);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9193 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9192);
// compiled call node returning call9193 (depth = 10)
// compiled member node returning call9193 (depth = 9)
  int op_slot_left_9189 = gc_frame_newslot(call9193);
  params[0] = strlit9190;
  partcv[0] = 1;
  Object opresult9194 = callmethod(call9193, "==", 1, partcv, params);
// compiled op node returning opresult9194 (depth = 8)
  int op_slot_right_9188 = gc_frame_newslot(opresult9194);
// starting to compile call node (depth = 8)
  int callframe9196 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9197 == NULL) {
    strlit9197 = alloc_String("op");
    gc_root(strlit9197);
  }
// compiled string node returning strlit9197 (depth = 9)
  gc_frame_newslot(strlit9197);
// call case 4: self request
  params[0] = strlit9197;
  partcv[0] = 1;
  Object call9198 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9196);
// compiled call node returning call9198 (depth = 8)
  int op_slot_left_9188 = gc_frame_newslot(call9198);
  params[0] = opresult9194;
  partcv[0] = 1;
  Object opresult9199 = callmethod(call9198, "&&", 1, partcv, params);
// compiled op node returning opresult9199 (depth = 7)
  int op_slot_right_9187 = gc_frame_newslot(opresult9199);
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9201 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9202 == NULL) {
    strlit9202 = alloc_String("identifier");
    gc_root(strlit9202);
  }
// compiled string node returning strlit9202 (depth = 8)
  gc_frame_newslot(strlit9202);
// call case 4: self request
  params[0] = strlit9202;
  partcv[0] = 1;
  Object call9203 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9201);
// compiled call node returning call9203 (depth = 7)
  int op_slot_left_9187 = gc_frame_newslot(call9203);
  params[0] = opresult9199;
  partcv[0] = 1;
  Object opresult9204 = callmethod(call9203, "||", 1, partcv, params);
// compiled op node returning opresult9204 (depth = 6)
  gc_frame_end(frame);
  return opresult9204;
}
Object meth_parser__apply9207(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_vararg = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_comma = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_nxt = getfromclosure(closure, 6);
  Object *var_part = getfromclosure(closure, 7);
  Object *var_tm = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9209 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9210 == NULL) {
    strlit9210 = alloc_String("op");
    gc_root(strlit9210);
  }
// compiled string node returning strlit9210 (depth = 8)
  gc_frame_newslot(strlit9210);
// call case 4: self request
  params[0] = strlit9210;
  partcv[0] = 1;
  Object call9211 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9209);
// compiled call node returning call9211 (depth = 7)
  Object if9208 = done;
  if (istrue(call9211)) {
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9213 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9212);
// compiled call node returning call9213 (depth = 8)
// compiled member node returning call9213 (depth = 7)
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool9214 = alloc_Boolean(1);
// compiled identifier node returning bool9214 (depth = 8)
  *var_vararg = bool9214;
  if (bool9214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9218 == NULL) {
    strlit9218 = alloc_String("identifier");
    gc_root(strlit9218);
  }
// compiled string node returning strlit9218 (depth = 9)
  int op_slot_right_9217 = gc_frame_newslot(strlit9218);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9220 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9221 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9220);
// compiled call node returning call9221 (depth = 10)
// compiled member node returning call9221 (depth = 9)
  int op_slot_left_9217 = gc_frame_newslot(call9221);
  params[0] = strlit9218;
  partcv[0] = 1;
  Object opresult9222 = callmethod(call9221, "!=", 1, partcv, params);
// compiled op node returning opresult9222 (depth = 8)
  Object if9216 = done;
  if (istrue(opresult9222)) {
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9223 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9224 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9225 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9224);
// compiled call node returning call9225 (depth = 12)
// compiled member node returning call9225 (depth = 11)
  partcv[0] = 0;
  Object call9226 = callmethod(call9225, "empty",
    1, partcv, params);
  gc_frame_end(callframe9223);
// compiled call node returning call9226 (depth = 10)
// compiled member node returning call9226 (depth = 9)
  *var_suggestions = call9226;
  if (call9226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9227 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9228 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9229 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9228);
// compiled call node returning call9229 (depth = 12)
// compiled member node returning call9229 (depth = 11)
  partcv[0] = 0;
  Object call9230 = callmethod(call9229, "new",
    1, partcv, params);
  gc_frame_end(callframe9227);
// compiled call node returning call9230 (depth = 10)
// compiled member node returning call9230 (depth = 9)
  *var_suggestion = call9230;
  if (call9230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9231 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9232 == NULL) {
    strlit9232 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit9232);
  }
// compiled string node returning strlit9232 (depth = 9)
  gc_frame_newslot(strlit9232);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9232;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9233 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9231);
// compiled call node returning call9233 (depth = 8)
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9234 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9235 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9234);
// compiled call node returning call9235 (depth = 8)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool9238 = alloc_Boolean(0);
// compiled identifier node returning bool9238 (depth = 10)
  int op_slot_right_9237 = gc_frame_newslot(bool9238);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comma (depth = 10)
  int op_slot_left_9237 = gc_frame_newslot(*var_comma);
  params[0] = bool9238;
  partcv[0] = 1;
  Object opresult9240 = callmethod(*var_comma, "==", 1, partcv, params);
// compiled op node returning opresult9240 (depth = 9)
  Object if9236 = done;
  if (istrue(opresult9240)) {
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9241 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call9243 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9242);
// compiled call node returning call9243 (depth = 13)
// compiled member node returning call9243 (depth = 12)
  partcv[0] = 0;
  Object call9244 = callmethod(call9243, "new",
    1, partcv, params);
  gc_frame_end(callframe9241);
// compiled call node returning call9244 (depth = 11)
// compiled member node returning call9244 (depth = 10)
  *var_suggestion = call9244;
  if (call9244 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9246 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call9247 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9246);
// compiled call node returning call9247 (depth = 9)
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9248 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9249 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9248);
// compiled call node returning call9249 (depth = 9)
    gc_frame_newslot(call9249);
    if9236 = call9249;
  } else {
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9250 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9251 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call9252 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9251);
// compiled call node returning call9252 (depth = 13)
// compiled member node returning call9252 (depth = 12)
  partcv[0] = 0;
  Object call9253 = callmethod(call9252, "new",
    1, partcv, params);
  gc_frame_end(callframe9250);
// compiled call node returning call9253 (depth = 11)
// compiled member node returning call9253 (depth = 10)
  *var_suggestion = call9253;
  if (call9253 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9255 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comma (depth = 10)
  gc_frame_newslot(*var_comma);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call9256 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe9255);
// compiled call node returning call9256 (depth = 9)
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9257 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9258 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9257);
// compiled call node returning call9258 (depth = 9)
    gc_frame_newslot(call9258);
    if9236 = call9258;
  }
// compiled if node returning if9236 (depth = 8)
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9259 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9260 == NULL) {
    strlit9260 = alloc_String("A variable length parameter (a parameter beginning with '*') must have a name after the '*'.");
    gc_root(strlit9260);
  }
// compiled string node returning strlit9260 (depth = 9)
  gc_frame_newslot(strlit9260);
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9262 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9261);
// compiled call node returning call9262 (depth = 10)
// compiled member node returning call9262 (depth = 9)
  gc_frame_newslot(call9262);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9264 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9265 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9264);
// compiled call node returning call9265 (depth = 11)
// compiled member node returning call9265 (depth = 10)
  int op_slot_right_9263 = gc_frame_newslot(call9265);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9267 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9268 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9267);
// compiled call node returning call9268 (depth = 11)
// compiled member node returning call9268 (depth = 10)
  int op_slot_left_9263 = gc_frame_newslot(call9268);
  params[0] = call9265;
  partcv[0] = 1;
  Object sum9269 = callmethod(call9268, "+", 1, partcv, params);
// compiled op node returning sum9269 (depth = 9)
  gc_frame_newslot(sum9269);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9260;
  params[1] = call9262;
  params[2] = sum9269;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9270 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9259);
// compiled call node returning call9270 (depth = 8)
    gc_frame_newslot(call9270);
    if9216 = call9270;
  } else {
  }
// compiled if node returning if9216 (depth = 7)
    gc_frame_newslot(if9216);
    if9208 = if9216;
  } else {
  }
// compiled if node returning if9208 (depth = 6)
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9272 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9271);
// compiled call node returning call9272 (depth = 7)
// compiled member node returning call9272 (depth = 6)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9273 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call9274 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9273);
// compiled call node returning call9274 (depth = 8)
// compiled member node returning call9274 (depth = 7)
  *var_nxt = call9274;
  if (call9274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9276 = gc_frame_new();
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool9277 = alloc_Boolean(1);
// compiled identifier node returning bool9277 (depth = 8)
  gc_frame_newslot(bool9277);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  params[0] = bool9277;
  partcv[0] = 1;
  Object call9278 = callmethod(*var_nxt, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9276);
// compiled call node returning call9278 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9279 = gc_frame_new();
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9280 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9281 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9280);
// compiled call node returning call9281 (depth = 9)
// compiled member node returning call9281 (depth = 8)
  gc_frame_newslot(call9281);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  params[0] = call9281;
  partcv[0] = 1;
  Object call9282 = callmethod(*var_nxt, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9279);
// compiled call node returning call9282 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vararg (depth = 7)
  Object if9283 = done;
  if (istrue(*var_vararg)) {
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9284 = gc_frame_new();
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nxt (depth = 9)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call9285 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9284);
// compiled call node returning call9285 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9286 = gc_frame_new();
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool9287 = alloc_Boolean(1);
// compiled identifier node returning bool9287 (depth = 9)
  gc_frame_newslot(bool9287);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tm (depth = 9)
  params[0] = bool9287;
  partcv[0] = 1;
  Object call9288 = callmethod(*var_tm, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe9286);
// compiled call node returning call9288 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9291 == NULL) {
    strlit9291 = alloc_String("rparen");
    gc_root(strlit9291);
  }
// compiled string node returning strlit9291 (depth = 9)
  int op_slot_right_9290 = gc_frame_newslot(strlit9291);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9294 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9293);
// compiled call node returning call9294 (depth = 10)
// compiled member node returning call9294 (depth = 9)
  int op_slot_left_9290 = gc_frame_newslot(call9294);
  params[0] = strlit9291;
  partcv[0] = 1;
  Object opresult9295 = callmethod(call9294, "!=", 1, partcv, params);
// compiled op node returning opresult9295 (depth = 8)
  Object if9289 = done;
  if (istrue(opresult9295)) {
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9296 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9297 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9298 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9297);
// compiled call node returning call9298 (depth = 12)
// compiled member node returning call9298 (depth = 11)
  partcv[0] = 0;
  Object call9299 = callmethod(call9298, "new",
    1, partcv, params);
  gc_frame_end(callframe9296);
// compiled call node returning call9299 (depth = 10)
// compiled member node returning call9299 (depth = 9)
  *var_suggestion = call9299;
  if (call9299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9300 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9301 == NULL) {
    strlit9301 = alloc_String(")");
    gc_root(strlit9301);
  }
// compiled string node returning strlit9301 (depth = 9)
  gc_frame_newslot(strlit9301);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9301;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9302 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9300);
// compiled call node returning call9302 (depth = 8)
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9303 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9304 == NULL) {
    strlit9304 = alloc_String("A part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit9304);
  }
// compiled string node returning strlit9304 (depth = 9)
  gc_frame_newslot(strlit9304);
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9306 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9305);
// compiled call node returning call9306 (depth = 10)
// compiled member node returning call9306 (depth = 9)
  gc_frame_newslot(call9306);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9309 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9308);
// compiled call node returning call9309 (depth = 11)
// compiled member node returning call9309 (depth = 10)
  int op_slot_right_9307 = gc_frame_newslot(call9309);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9311 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9312 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9311);
// compiled call node returning call9312 (depth = 11)
// compiled member node returning call9312 (depth = 10)
  int op_slot_left_9307 = gc_frame_newslot(call9312);
  params[0] = call9309;
  partcv[0] = 1;
  Object sum9313 = callmethod(call9312, "+", 1, partcv, params);
// compiled op node returning sum9313 (depth = 9)
  gc_frame_newslot(sum9313);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9304;
  params[1] = call9306;
  params[2] = sum9313;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9314 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9303);
// compiled call node returning call9314 (depth = 8)
    gc_frame_newslot(call9314);
    if9289 = call9314;
  } else {
  }
// compiled if node returning if9289 (depth = 7)
    gc_frame_newslot(if9289);
    if9283 = if9289;
  } else {
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9315 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call9317 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe9316);
// compiled call node returning call9317 (depth = 9)
// compiled member node returning call9317 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call9318 = callmethod(call9317, "push",
    1, partcv, params);
  gc_frame_end(callframe9315);
// compiled call node returning call9318 (depth = 7)
    gc_frame_newslot(call9318);
    if9283 = call9318;
  }
// compiled if node returning if9283 (depth = 6)
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9320 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9321 == NULL) {
    strlit9321 = alloc_String("comma");
    gc_root(strlit9321);
  }
// compiled string node returning strlit9321 (depth = 8)
  gc_frame_newslot(strlit9321);
// call case 4: self request
  params[0] = strlit9321;
  partcv[0] = 1;
  Object call9322 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9320);
// compiled call node returning call9322 (depth = 7)
  Object if9319 = done;
  if (istrue(call9322)) {
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9325 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9324);
// compiled call node returning call9325 (depth = 8)
// compiled member node returning call9325 (depth = 7)
    gc_frame_newslot(call9325);
    if9319 = call9325;
  } else {
  }
// compiled if node returning if9319 (depth = 6)
  gc_frame_end(frame);
  return if9319;
}
Object meth_parser__apply9135(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_methname = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_nxt = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_tm = getfromclosure(closure, 7);
  Object *var_signature = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
  Object *var_vararg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "vararg");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_comma = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "comma");
// starting to compile bind node (depth = 4)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9137 == NULL) {
    strlit9137 = alloc_String("()");
    gc_root(strlit9137);
  }
// compiled string node returning strlit9137 (depth = 6)
  int op_slot_right_9136 = gc_frame_newslot(strlit9137);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_9136 = gc_frame_newslot(*var_methname);
  params[0] = strlit9137;
  partcv[0] = 1;
  Object opresult9139 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult9139 (depth = 5)
  *var_methname = opresult9139;
  if (opresult9139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9141 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call9143 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe9142);
// compiled call node returning call9143 (depth = 8)
// compiled member node returning call9143 (depth = 7)
  partcv[0] = 0;
  Object call9144 = callmethod(call9143, "new",
    1, partcv, params);
  gc_frame_end(callframe9141);
// compiled call node returning call9144 (depth = 6)
// compiled member node returning call9144 (depth = 5)
  *var_part = call9144;
  if (call9144 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9146 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9145);
// compiled call node returning call9146 (depth = 5)
// compiled member node returning call9146 (depth = 4)
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9147 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call9148 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9147);
// compiled call node returning call9148 (depth = 6)
// compiled member node returning call9148 (depth = 5)
  *var_nxt = call9148;
  if (call9148 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9151 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call9152 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe9151);
// compiled call node returning call9152 (depth = 7)
// compiled member node returning call9152 (depth = 6)
  int op_slot_right_9150 = gc_frame_newslot(call9152);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_9150 = gc_frame_newslot(*var_methname);
  params[0] = call9152;
  partcv[0] = 1;
  Object opresult9154 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult9154 (depth = 5)
  *var_methname = opresult9154;
  if (opresult9154 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9156 = gc_frame_new();
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9157 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call9158 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe9157);
// compiled call node returning call9158 (depth = 7)
// compiled member node returning call9158 (depth = 6)
  gc_frame_newslot(call9158);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = call9158;
  partcv[0] = 1;
  Object call9159 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9156);
// compiled call node returning call9159 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9160 = alloc_Boolean(0);
// compiled identifier node returning bool9160 (depth = 5)
  *var_vararg = bool9160;
  if (bool9160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9162 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe9163 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9164 == NULL) {
    strlit9164 = alloc_String("lparen");
    gc_root(strlit9164);
  }
// compiled string node returning strlit9164 (depth = 8)
  gc_frame_newslot(strlit9164);
// call case 4: self request
  params[0] = strlit9164;
  partcv[0] = 1;
  Object call9165 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9163);
// compiled call node returning call9165 (depth = 7)
  partcv[0] = 0;
  Object call9166 = callmethod(call9165, "not",
    1, partcv, params);
  gc_frame_end(callframe9162);
// compiled call node returning call9166 (depth = 6)
// compiled member node returning call9166 (depth = 5)
  Object if9161 = done;
  if (istrue(call9166)) {
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9167 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9168 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9169 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9168);
// compiled call node returning call9169 (depth = 9)
// compiled member node returning call9169 (depth = 8)
  partcv[0] = 0;
  Object call9170 = callmethod(call9169, "new",
    1, partcv, params);
  gc_frame_end(callframe9167);
// compiled call node returning call9170 (depth = 7)
// compiled member node returning call9170 (depth = 6)
  *var_suggestion = call9170;
  if (call9170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9171 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9172 == NULL) {
    strlit9172 = alloc_String("()");
    gc_root(strlit9172);
  }
// compiled string node returning strlit9172 (depth = 6)
  gc_frame_newslot(strlit9172);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9172;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9173 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9171);
// compiled call node returning call9173 (depth = 5)
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9174 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9175 == NULL) {
    strlit9175 = alloc_String("A multi-part method must have parentheses around each parameter list.");
    gc_root(strlit9175);
  }
// compiled string node returning strlit9175 (depth = 6)
  gc_frame_newslot(strlit9175);
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9176 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9177 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9176);
// compiled call node returning call9177 (depth = 7)
// compiled member node returning call9177 (depth = 6)
  gc_frame_newslot(call9177);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9179 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9178);
// compiled call node returning call9179 (depth = 7)
// compiled member node returning call9179 (depth = 6)
  gc_frame_newslot(call9179);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9175;
  params[1] = call9177;
  params[2] = call9179;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9180 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9174);
// compiled call node returning call9180 (depth = 5)
    gc_frame_newslot(call9180);
    if9161 = call9180;
  } else {
  }
// compiled if node returning if9161 (depth = 4)
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9182 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9181);
// compiled call node returning call9182 (depth = 5)
// compiled member node returning call9182 (depth = 4)
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool9183 = alloc_Boolean(0);
// compiled identifier node returning bool9183 (depth = 5)
  *var_comma = bool9183;
  if (bool9183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9184 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9185 = alloc_Block(NULL, NULL, "parser", 2848);
  gc_frame_newslot(block9185);
// method _apply
  block_savedest(block9185);
  Object closure9186 = createclosure(2, "_apply");
  setclosureframe(closure9186, stackframe);
  addtoclosure(closure9186, var_sym);
  addtoclosure(closure9186, selfslot);
  struct UserObject *uo9186 = (struct UserObject*)block9185;
  uo9186->data[0] = (Object)closure9186;
  Method *meth_meth_parser__apply9186 = addmethod2pos(block9185, "_apply", &meth_parser__apply9186, 0);
  int argcv_meth_parser__apply9186[] = {0};
  meth_meth_parser__apply9186->type = alloc_MethodType(1, argcv_meth_parser__apply9186);
  meth_meth_parser__apply9186->definitionModule = modulename;
  meth_meth_parser__apply9186->definitionLine = 2846;
// compiled block node returning block9185 (depth = 5)
  gc_frame_newslot(block9185);
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block9206 = alloc_Block(NULL, NULL, "parser", 2849);
  gc_frame_newslot(block9206);
// method _apply
  block_savedest(block9206);
  Object closure9207 = createclosure(10, "_apply");
  setclosureframe(closure9207, stackframe);
  addtoclosure(closure9207, var_vararg);
  addtoclosure(closure9207, var_sym);
  addtoclosure(closure9207, var_errormessages);
  addtoclosure(closure9207, var_lastToken);
  addtoclosure(closure9207, var_comma);
  addtoclosure(closure9207, var_values);
  addtoclosure(closure9207, var_nxt);
  addtoclosure(closure9207, var_part);
  addtoclosure(closure9207, var_tm);
  addtoclosure(closure9207, selfslot);
  struct UserObject *uo9207 = (struct UserObject*)block9206;
  uo9207->data[0] = (Object)closure9207;
  Method *meth_meth_parser__apply9207 = addmethod2pos(block9206, "_apply", &meth_parser__apply9207, 0);
  int argcv_meth_parser__apply9207[] = {0};
  meth_meth_parser__apply9207->type = alloc_MethodType(1, argcv_meth_parser__apply9207);
  meth_meth_parser__apply9207->definitionModule = modulename;
  meth_meth_parser__apply9207->definitionLine = 2849;
// compiled block node returning block9206 (depth = 5)
  gc_frame_newslot(block9206);
// call case 5: prelude request
  params[0] = block9185;
  params[1] = block9206;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9327 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9184);
// compiled call node returning call9327 (depth = 4)
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9330 == NULL) {
    strlit9330 = alloc_String("rparen");
    gc_root(strlit9330);
  }
// compiled string node returning strlit9330 (depth = 6)
  int op_slot_right_9329 = gc_frame_newslot(strlit9330);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9333 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9332);
// compiled call node returning call9333 (depth = 7)
// compiled member node returning call9333 (depth = 6)
  int op_slot_left_9329 = gc_frame_newslot(call9333);
  params[0] = strlit9330;
  partcv[0] = 1;
  Object opresult9334 = callmethod(call9333, "!=", 1, partcv, params);
// compiled op node returning opresult9334 (depth = 5)
  Object if9328 = done;
  if (istrue(opresult9334)) {
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9335 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9337 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9336);
// compiled call node returning call9337 (depth = 9)
// compiled member node returning call9337 (depth = 8)
  partcv[0] = 0;
  Object call9338 = callmethod(call9337, "new",
    1, partcv, params);
  gc_frame_end(callframe9335);
// compiled call node returning call9338 (depth = 7)
// compiled member node returning call9338 (depth = 6)
  *var_suggestion = call9338;
  if (call9338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9339 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9340 == NULL) {
    strlit9340 = alloc_String(")");
    gc_root(strlit9340);
  }
// compiled string node returning strlit9340 (depth = 6)
  gc_frame_newslot(strlit9340);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9340;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9341 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9339);
// compiled call node returning call9341 (depth = 5)
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9342 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9343 == NULL) {
    strlit9343 = alloc_String("A part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit9343);
  }
// compiled string node returning strlit9343 (depth = 6)
  gc_frame_newslot(strlit9343);
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9344 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9345 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9344);
// compiled call node returning call9345 (depth = 7)
// compiled member node returning call9345 (depth = 6)
  gc_frame_newslot(call9345);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9347 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9348 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9347);
// compiled call node returning call9348 (depth = 8)
// compiled member node returning call9348 (depth = 7)
  int op_slot_right_9346 = gc_frame_newslot(call9348);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9350 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9351 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9350);
// compiled call node returning call9351 (depth = 8)
// compiled member node returning call9351 (depth = 7)
  int op_slot_left_9346 = gc_frame_newslot(call9351);
  params[0] = call9348;
  partcv[0] = 1;
  Object sum9352 = callmethod(call9351, "+", 1, partcv, params);
// compiled op node returning sum9352 (depth = 6)
  gc_frame_newslot(sum9352);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9343;
  params[1] = call9345;
  params[2] = sum9352;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9353 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9342);
// compiled call node returning call9353 (depth = 5)
    gc_frame_newslot(call9353);
    if9328 = call9353;
  } else {
  }
// compiled if node returning if9328 (depth = 4)
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9354 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9355 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9354);
// compiled call node returning call9355 (depth = 5)
// compiled member node returning call9355 (depth = 4)
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9356 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9357 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9356);
// compiled call node returning call9357 (depth = 4)
  gc_frame_end(frame);
  return call9357;
}
Object meth_parser_parsempmndecrest9109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parsempmndecrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method parsempmndecrest");
  Object params[2];
  int partcv[2];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parsempmndecrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for parsempmndecrest");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "methname");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_newName = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "newName");
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9110 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9111 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tm (depth = 7)
  partcv[0] = 0;
  Object call9112 = callmethod(*var_tm, "value",
    1, partcv, params);
  gc_frame_end(callframe9111);
// compiled call node returning call9112 (depth = 6)
// compiled member node returning call9112 (depth = 5)
  partcv[0] = 0;
  Object call9113 = callmethod(call9112, "value",
    1, partcv, params);
  gc_frame_end(callframe9110);
// compiled call node returning call9113 (depth = 4)
// compiled member node returning call9113 (depth = 3)
  *var_methname = call9113;
  if (call9113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9114 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tm (depth = 5)
  partcv[0] = 0;
  Object call9115 = callmethod(*var_tm, "signature",
    1, partcv, params);
  gc_frame_end(callframe9114);
// compiled call node returning call9115 (depth = 4)
// compiled member node returning call9115 (depth = 3)
  *var_signature = call9115;
  if (call9115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9116 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9117 = alloc_Block(NULL, NULL, "parser", 2832);
  gc_frame_newslot(block9117);
// method _apply
  block_savedest(block9117);
  Object closure9118 = createclosure(2, "_apply");
  setclosureframe(closure9118, stackframe);
  addtoclosure(closure9118, var_sameline);
  addtoclosure(closure9118, selfslot);
  struct UserObject *uo9118 = (struct UserObject*)block9117;
  uo9118->data[0] = (Object)closure9118;
  Method *meth_meth_parser__apply9118 = addmethod2pos(block9117, "_apply", &meth_parser__apply9118, 0);
  int argcv_meth_parser__apply9118[] = {0};
  meth_meth_parser__apply9118->type = alloc_MethodType(1, argcv_meth_parser__apply9118);
  meth_meth_parser__apply9118->definitionModule = modulename;
  meth_meth_parser__apply9118->definitionLine = 2830;
// compiled block node returning block9117 (depth = 3)
  gc_frame_newslot(block9117);
// starting to compile block node (depth = 3)
  Object block9134 = alloc_Block(NULL, NULL, "parser", 2832);
  gc_frame_newslot(block9134);
// method _apply
  block_savedest(block9134);
  Object closure9135 = createclosure(10, "_apply");
  setclosureframe(closure9135, stackframe);
  addtoclosure(closure9135, var_methname);
  addtoclosure(closure9135, var_ast);
  addtoclosure(closure9135, var_values);
  addtoclosure(closure9135, var_nxt);
  addtoclosure(closure9135, var_errormessages);
  addtoclosure(closure9135, var_lastToken);
  addtoclosure(closure9135, var_sym);
  addtoclosure(closure9135, var_tm);
  addtoclosure(closure9135, var_signature);
  addtoclosure(closure9135, selfslot);
  struct UserObject *uo9135 = (struct UserObject*)block9134;
  uo9135->data[0] = (Object)closure9135;
  Method *meth_meth_parser__apply9135 = addmethod2pos(block9134, "_apply", &meth_parser__apply9135, 0);
  int argcv_meth_parser__apply9135[] = {0};
  meth_meth_parser__apply9135->type = alloc_MethodType(1, argcv_meth_parser__apply9135);
  meth_meth_parser__apply9135->definitionModule = modulename;
  meth_meth_parser__apply9135->definitionLine = 2830;
// compiled block node returning block9134 (depth = 3)
  gc_frame_newslot(block9134);
// call case 5: prelude request
  params[0] = block9117;
  params[1] = block9134;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9359 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9116);
// compiled call node returning call9359 (depth = 2)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9360 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool9361 = alloc_Boolean(0);
// compiled identifier node returning bool9361 (depth = 4)
  gc_frame_newslot(bool9361);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call9363 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe9362);
// compiled call node returning call9363 (depth = 5)
// compiled member node returning call9363 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool9361;
  partcv[0] = 2;
  Object call9364 = callmethod(call9363, "new",
    1, partcv, params);
  gc_frame_end(callframe9360);
// compiled call node returning call9364 (depth = 3)
  *var_newName = call9364;
  if (call9364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9365 = gc_frame_new();
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9366 = alloc_Boolean(1);
// compiled identifier node returning bool9366 (depth = 4)
  gc_frame_newslot(bool9366);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newName (depth = 4)
  params[0] = bool9366;
  partcv[0] = 1;
  Object call9367 = callmethod(*var_newName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9365);
// compiled call node returning call9367 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newName (depth = 2)
  gc_frame_end(frame);
  return *var_newName;
}
Object meth_parser__apply9378(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9379 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9380 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9379);
// compiled call node returning call9380 (depth = 7)
// compiled member node returning call9380 (depth = 6)
  gc_frame_end(frame);
  return call9380;
}
Object meth_parser_optionalTypeAnnotation9368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "optionalTypeAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for optionalTypeAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for optionalTypeAnnotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9370 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9371 == NULL) {
    strlit9371 = alloc_String("colon");
    gc_root(strlit9371);
  }
// compiled string node returning strlit9371 (depth = 4)
  gc_frame_newslot(strlit9371);
// call case 4: self request
  params[0] = strlit9371;
  partcv[0] = 1;
  Object call9372 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9370);
// compiled call node returning call9372 (depth = 3)
  Object if9369 = done;
  if (istrue(call9372)) {
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9374 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9373);
// compiled call node returning call9374 (depth = 4)
// compiled member node returning call9374 (depth = 3)
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9376 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9377 = alloc_Block(NULL, NULL, "parser", 2911);
  gc_frame_newslot(block9377);
// method _apply
  block_savedest(block9377);
  Object closure9378 = createclosure(1, "_apply");
  setclosureframe(closure9378, stackframe);
  addtoclosure(closure9378, selfslot);
  struct UserObject *uo9378 = (struct UserObject*)block9377;
  uo9378->data[0] = (Object)closure9378;
  Method *meth_meth_parser__apply9378 = addmethod2pos(block9377, "_apply", &meth_parser__apply9378, 0);
  int argcv_meth_parser__apply9378[] = {0};
  meth_meth_parser__apply9378->type = alloc_MethodType(1, argcv_meth_parser__apply9378);
  meth_meth_parser__apply9378->definitionModule = modulename;
  meth_meth_parser__apply9378->definitionLine = 2910;
// compiled block node returning block9377 (depth = 5)
  gc_frame_newslot(block9377);
// call case 4: self request
  params[0] = block9377;
  partcv[0] = 1;
  Object call9382 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9376);
// compiled call node returning call9382 (depth = 4)
  Object if9375 = done;
  if (istrue(call9382)) {
// Begin line 2912
  setline(2912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9384 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9383);
// compiled call node returning call9384 (depth = 5)
// compiled member node returning call9384 (depth = 4)
    gc_frame_newslot(call9384);
    if9375 = call9384;
  } else {
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9385 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9386 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9385);
// compiled call node returning call9386 (depth = 5)
// compiled member node returning call9386 (depth = 4)
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9387 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9388 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9389 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9388);
// compiled call node returning call9389 (depth = 8)
// compiled member node returning call9389 (depth = 7)
  partcv[0] = 0;
  Object call9390 = callmethod(call9389, "empty",
    1, partcv, params);
  gc_frame_end(callframe9387);
// compiled call node returning call9390 (depth = 6)
// compiled member node returning call9390 (depth = 5)
  *var_suggestions = call9390;
  if (call9390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9391 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9392 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9393 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9392);
// compiled call node returning call9393 (depth = 8)
// compiled member node returning call9393 (depth = 7)
  partcv[0] = 0;
  Object call9394 = callmethod(call9393, "new",
    1, partcv, params);
  gc_frame_end(callframe9391);
// compiled call node returning call9394 (depth = 6)
// compiled member node returning call9394 (depth = 5)
  *var_suggestion = call9394;
  if (call9394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9395 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9396 == NULL) {
    strlit9396 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit9396);
  }
// compiled string node returning strlit9396 (depth = 5)
  gc_frame_newslot(strlit9396);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit9396;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9397 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9395);
// compiled call node returning call9397 (depth = 4)
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9398 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9399 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9398);
// compiled call node returning call9399 (depth = 4)
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9400 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9402 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9401);
// compiled call node returning call9402 (depth = 8)
// compiled member node returning call9402 (depth = 7)
  partcv[0] = 0;
  Object call9403 = callmethod(call9402, "new",
    1, partcv, params);
  gc_frame_end(callframe9400);
// compiled call node returning call9403 (depth = 6)
// compiled member node returning call9403 (depth = 5)
  *var_suggestion = call9403;
  if (call9403 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9405 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 5)
  Object bool9406 = alloc_Boolean(1);
// compiled identifier node returning bool9406 (depth = 5)
  gc_frame_newslot(bool9406);
// starting to compile identifier node (depth = 5)
  Object bool9407 = alloc_Boolean(0);
// compiled identifier node returning bool9407 (depth = 5)
  gc_frame_newslot(bool9407);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = bool9406;
  params[2] = bool9407;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9408 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9405);
// compiled call node returning call9408 (depth = 4)
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9409 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9410 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9409);
// compiled call node returning call9410 (depth = 4)
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9411 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9412 == NULL) {
    strlit9412 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit9412);
  }
// compiled string node returning strlit9412 (depth = 5)
  gc_frame_newslot(strlit9412);
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9413 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9414 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9413);
// compiled call node returning call9414 (depth = 6)
// compiled member node returning call9414 (depth = 5)
  gc_frame_newslot(call9414);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9415 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9416 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9415);
// compiled call node returning call9416 (depth = 6)
// compiled member node returning call9416 (depth = 5)
  gc_frame_newslot(call9416);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9412;
  params[1] = call9414;
  params[2] = call9416;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9417 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9411);
// compiled call node returning call9417 (depth = 4)
    gc_frame_newslot(call9417);
    if9375 = call9417;
  }
// compiled if node returning if9375 (depth = 3)
    gc_frame_newslot(if9375);
    if9369 = if9375;
  } else {
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9418 = alloc_Boolean(0);
// compiled identifier node returning bool9418 (depth = 3)
    gc_frame_newslot(bool9418);
    if9369 = bool9418;
  }
// compiled if node returning if9369 (depth = 2)
  gc_frame_end(frame);
  return if9369;
}
Object meth_parser__apply9509(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9511 == NULL) {
    strlit9511 = alloc_String("rsquare");
    gc_root(strlit9511);
  }
// compiled string node returning strlit9511 (depth = 9)
  int op_slot_right_9510 = gc_frame_newslot(strlit9511);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9513 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9514 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call9515 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9514);
// compiled call node returning call9515 (depth = 12)
// compiled member node returning call9515 (depth = 11)
  partcv[0] = 0;
  Object call9516 = callmethod(call9515, "kind",
    1, partcv, params);
  gc_frame_end(callframe9513);
// compiled call node returning call9516 (depth = 10)
// compiled member node returning call9516 (depth = 9)
  int op_slot_left_9510 = gc_frame_newslot(call9516);
  params[0] = strlit9511;
  partcv[0] = 1;
  Object opresult9517 = callmethod(call9516, "==", 1, partcv, params);
// compiled op node returning opresult9517 (depth = 8)
  gc_frame_end(frame);
  return opresult9517;
}
Object meth_parser__apply9702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9706 == NULL) {
    strlit9706 = alloc_String("*");
    gc_root(strlit9706);
  }
// compiled string node returning strlit9706 (depth = 8)
  int op_slot_right_9705 = gc_frame_newslot(strlit9706);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9708 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9709 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9708);
// compiled call node returning call9709 (depth = 9)
// compiled member node returning call9709 (depth = 8)
  int op_slot_left_9705 = gc_frame_newslot(call9709);
  params[0] = strlit9706;
  partcv[0] = 1;
  Object opresult9710 = callmethod(call9709, "==", 1, partcv, params);
// compiled op node returning opresult9710 (depth = 7)
  int op_slot_right_9704 = gc_frame_newslot(opresult9710);
// starting to compile call node (depth = 7)
  int callframe9712 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9713 == NULL) {
    strlit9713 = alloc_String("op");
    gc_root(strlit9713);
  }
// compiled string node returning strlit9713 (depth = 8)
  gc_frame_newslot(strlit9713);
// call case 4: self request
  params[0] = strlit9713;
  partcv[0] = 1;
  Object call9714 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9712);
// compiled call node returning call9714 (depth = 7)
  int op_slot_left_9704 = gc_frame_newslot(call9714);
  params[0] = opresult9710;
  partcv[0] = 1;
  Object opresult9715 = callmethod(call9714, "&&", 1, partcv, params);
// compiled op node returning opresult9715 (depth = 6)
  int op_slot_right_9703 = gc_frame_newslot(opresult9715);
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9717 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9718 == NULL) {
    strlit9718 = alloc_String("identifier");
    gc_root(strlit9718);
  }
// compiled string node returning strlit9718 (depth = 7)
  gc_frame_newslot(strlit9718);
// call case 4: self request
  params[0] = strlit9718;
  partcv[0] = 1;
  Object call9719 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9717);
// compiled call node returning call9719 (depth = 6)
  int op_slot_left_9703 = gc_frame_newslot(call9719);
  params[0] = opresult9715;
  partcv[0] = 1;
  Object opresult9720 = callmethod(call9719, "||", 1, partcv, params);
// compiled op node returning opresult9720 (depth = 5)
  gc_frame_end(frame);
  return opresult9720;
}
Object meth_parser__apply9818(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9821 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call9822 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9821);
// compiled call node returning call9822 (depth = 13)
// compiled member node returning call9822 (depth = 12)
  int op_slot_right_9820 = gc_frame_newslot(call9822);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call9825 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9824);
// compiled call node returning call9825 (depth = 13)
// compiled member node returning call9825 (depth = 12)
  int op_slot_left_9820 = gc_frame_newslot(call9825);
  params[0] = call9822;
  partcv[0] = 1;
  Object opresult9826 = callmethod(call9825, "==", 1, partcv, params);
// compiled op node returning opresult9826 (depth = 11)
  int op_slot_right_9819 = gc_frame_newslot(opresult9826);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9829 == NULL) {
    strlit9829 = alloc_String("rparen");
    gc_root(strlit9829);
  }
// compiled string node returning strlit9829 (depth = 12)
  int op_slot_right_9828 = gc_frame_newslot(strlit9829);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call9832 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9831);
// compiled call node returning call9832 (depth = 13)
// compiled member node returning call9832 (depth = 12)
  int op_slot_left_9828 = gc_frame_newslot(call9832);
  params[0] = strlit9829;
  partcv[0] = 1;
  Object opresult9833 = callmethod(call9832, "==", 1, partcv, params);
// compiled op node returning opresult9833 (depth = 11)
  int op_slot_left_9819 = gc_frame_newslot(opresult9833);
  params[0] = opresult9826;
  partcv[0] = 1;
  Object opresult9834 = callmethod(opresult9833, "&&", 1, partcv, params);
// compiled op node returning opresult9834 (depth = 10)
  gc_frame_end(frame);
  return opresult9834;
}
Object meth_parser__apply9723(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_comma = getfromclosure(closure, 3);
  Object *var_vararg = getfromclosure(closure, 4);
  Object *var_varargs = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_id = getfromclosure(closure, 7);
  Object *var_dtype = getfromclosure(closure, 8);
  Object *var_part = getfromclosure(closure, 9);
  Object *var_lparen = getfromclosure(closure, 10);
  Object self = *(getfromclosure(closure, 11));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_rparen = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "rparen");
// Begin line 2993
  setline(2993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9725 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9726 == NULL) {
    strlit9726 = alloc_String("op");
    gc_root(strlit9726);
  }
// compiled string node returning strlit9726 (depth = 7)
  gc_frame_newslot(strlit9726);
// call case 4: self request
  params[0] = strlit9726;
  partcv[0] = 1;
  Object call9727 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9725);
// compiled call node returning call9727 (depth = 6)
  Object if9724 = done;
  if (istrue(call9727)) {
// Begin line 2994
  setline(2994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9729 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9728);
// compiled call node returning call9729 (depth = 7)
// compiled member node returning call9729 (depth = 6)
// Begin line 2995
  setline(2995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9732 == NULL) {
    strlit9732 = alloc_String("identifier");
    gc_root(strlit9732);
  }
// compiled string node returning strlit9732 (depth = 8)
  int op_slot_right_9731 = gc_frame_newslot(strlit9732);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9735 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9734);
// compiled call node returning call9735 (depth = 9)
// compiled member node returning call9735 (depth = 8)
  int op_slot_left_9731 = gc_frame_newslot(call9735);
  params[0] = strlit9732;
  partcv[0] = 1;
  Object opresult9736 = callmethod(call9735, "!=", 1, partcv, params);
// compiled op node returning opresult9736 (depth = 7)
  Object if9730 = done;
  if (istrue(opresult9736)) {
// Begin line 2996
  setline(2996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9737 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9738 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9739 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9738);
// compiled call node returning call9739 (depth = 11)
// compiled member node returning call9739 (depth = 10)
  partcv[0] = 0;
  Object call9740 = callmethod(call9739, "empty",
    1, partcv, params);
  gc_frame_end(callframe9737);
// compiled call node returning call9740 (depth = 9)
// compiled member node returning call9740 (depth = 8)
  *var_suggestions = call9740;
  if (call9740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2997
  setline(2997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9741 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9743 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9742);
// compiled call node returning call9743 (depth = 11)
// compiled member node returning call9743 (depth = 10)
  partcv[0] = 0;
  Object call9744 = callmethod(call9743, "new",
    1, partcv, params);
  gc_frame_end(callframe9741);
// compiled call node returning call9744 (depth = 9)
// compiled member node returning call9744 (depth = 8)
  *var_suggestion = call9744;
  if (call9744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9745 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9746 == NULL) {
    strlit9746 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit9746);
  }
// compiled string node returning strlit9746 (depth = 8)
  gc_frame_newslot(strlit9746);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit9746;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9747 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9745);
// compiled call node returning call9747 (depth = 7)
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9748 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9749 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9748);
// compiled call node returning call9749 (depth = 7)
// Begin line 3000
  setline(3000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool9752 = alloc_Boolean(0);
// compiled identifier node returning bool9752 (depth = 9)
  int op_slot_right_9751 = gc_frame_newslot(bool9752);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_comma (depth = 9)
  int op_slot_left_9751 = gc_frame_newslot(*var_comma);
  params[0] = bool9752;
  partcv[0] = 1;
  Object opresult9754 = callmethod(*var_comma, "==", 1, partcv, params);
// compiled op node returning opresult9754 (depth = 8)
  Object if9750 = done;
  if (istrue(opresult9754)) {
// Begin line 3001
  setline(3001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9755 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9757 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9756);
// compiled call node returning call9757 (depth = 12)
// compiled member node returning call9757 (depth = 11)
  partcv[0] = 0;
  Object call9758 = callmethod(call9757, "new",
    1, partcv, params);
  gc_frame_end(callframe9755);
// compiled call node returning call9758 (depth = 10)
// compiled member node returning call9758 (depth = 9)
  *var_suggestion = call9758;
  if (call9758 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9760 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call9761 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9760);
// compiled call node returning call9761 (depth = 8)
// Begin line 3003
  setline(3003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9762 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9763 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9762);
// compiled call node returning call9763 (depth = 8)
    gc_frame_newslot(call9763);
    if9750 = call9763;
  } else {
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9764 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9765 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9766 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9765);
// compiled call node returning call9766 (depth = 12)
// compiled member node returning call9766 (depth = 11)
  partcv[0] = 0;
  Object call9767 = callmethod(call9766, "new",
    1, partcv, params);
  gc_frame_end(callframe9764);
// compiled call node returning call9767 (depth = 10)
// compiled member node returning call9767 (depth = 9)
  *var_suggestion = call9767;
  if (call9767 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9769 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_comma (depth = 9)
  gc_frame_newslot(*var_comma);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call9770 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe9769);
// compiled call node returning call9770 (depth = 8)
// Begin line 3007
  setline(3007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9771 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9772 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9771);
// compiled call node returning call9772 (depth = 8)
    gc_frame_newslot(call9772);
    if9750 = call9772;
  }
// compiled if node returning if9750 (depth = 7)
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9773 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9774 == NULL) {
    strlit9774 = alloc_String("A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.");
    gc_root(strlit9774);
  }
// compiled string node returning strlit9774 (depth = 8)
  gc_frame_newslot(strlit9774);
// Begin line 3010
  setline(3010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9776 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9775);
// compiled call node returning call9776 (depth = 9)
// compiled member node returning call9776 (depth = 8)
  gc_frame_newslot(call9776);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9778 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9779 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9778);
// compiled call node returning call9779 (depth = 10)
// compiled member node returning call9779 (depth = 9)
  int op_slot_right_9777 = gc_frame_newslot(call9779);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9782 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9781);
// compiled call node returning call9782 (depth = 10)
// compiled member node returning call9782 (depth = 9)
  int op_slot_left_9777 = gc_frame_newslot(call9782);
  params[0] = call9779;
  partcv[0] = 1;
  Object sum9783 = callmethod(call9782, "+", 1, partcv, params);
// compiled op node returning sum9783 (depth = 8)
  gc_frame_newslot(sum9783);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit9774;
  params[1] = call9776;
  params[2] = sum9783;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9784 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9773);
// compiled call node returning call9784 (depth = 7)
    gc_frame_newslot(call9784);
    if9730 = call9784;
  } else {
  }
// compiled if node returning if9730 (depth = 6)
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9785 = alloc_Boolean(1);
// compiled identifier node returning bool9785 (depth = 7)
  *var_vararg = bool9785;
  if (bool9785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool9787 = alloc_Boolean(1);
// compiled identifier node returning bool9787 (depth = 7)
  *var_varargs = bool9787;
  if (bool9787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9724 = done;
  } else {
  }
// compiled if node returning if9724 (depth = 5)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9789 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9790 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9789);
// compiled call node returning call9790 (depth = 6)
// compiled member node returning call9790 (depth = 5)
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9791 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9792 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9791);
// compiled call node returning call9792 (depth = 7)
// compiled member node returning call9792 (depth = 6)
  *var_id = call9792;
  if (call9792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9794 = gc_frame_new();
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool9795 = alloc_Boolean(1);
// compiled identifier node returning bool9795 (depth = 7)
  gc_frame_newslot(bool9795);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  params[0] = bool9795;
  partcv[0] = 1;
  Object call9796 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9794);
// compiled call node returning call9796 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9798 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9797);
// compiled call node returning call9798 (depth = 7)
// compiled member node returning call9798 (depth = 6)
  *var_dtype = call9798;
  if (call9798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3019
  setline(3019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9800 = gc_frame_new();
// Begin line 3019
  setline(3019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_dtype (depth = 7)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  params[0] = *var_dtype;
  partcv[0] = 1;
  Object call9801 = callmethod(*var_id, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9800);
// compiled call node returning call9801 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_vararg (depth = 6)
  Object if9802 = done;
  if (istrue(*var_vararg)) {
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9803 = gc_frame_new();
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_id (depth = 8)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9804 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9803);
// compiled call node returning call9804 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9807 == NULL) {
    strlit9807 = alloc_String("rparen");
    gc_root(strlit9807);
  }
// compiled string node returning strlit9807 (depth = 8)
  int op_slot_right_9806 = gc_frame_newslot(strlit9807);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9810 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9809);
// compiled call node returning call9810 (depth = 9)
// compiled member node returning call9810 (depth = 8)
  int op_slot_left_9806 = gc_frame_newslot(call9810);
  params[0] = strlit9807;
  partcv[0] = 1;
  Object opresult9811 = callmethod(call9810, "!=", 1, partcv, params);
// compiled op node returning opresult9811 (depth = 7)
  Object if9805 = done;
  if (istrue(opresult9811)) {
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9812 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9814 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9813);
// compiled call node returning call9814 (depth = 11)
// compiled member node returning call9814 (depth = 10)
  partcv[0] = 0;
  Object call9815 = callmethod(call9814, "new",
    1, partcv, params);
  gc_frame_end(callframe9812);
// compiled call node returning call9815 (depth = 9)
// compiled member node returning call9815 (depth = 8)
  *var_suggestion = call9815;
  if (call9815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9816 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block9817 = alloc_Block(NULL, NULL, "parser", 3024);
  gc_frame_newslot(block9817);
// method _apply
  block_savedest(block9817);
  Object closure9818 = createclosure(2, "_apply");
  setclosureframe(closure9818, stackframe);
  addtoclosure(closure9818, var_sym);
  addtoclosure(closure9818, selfslot);
  struct UserObject *uo9818 = (struct UserObject*)block9817;
  uo9818->data[0] = (Object)closure9818;
  Method *meth_meth_parser__apply9818 = addmethod2pos(block9817, "_apply", &meth_parser__apply9818, 0);
  int argcv_meth_parser__apply9818[] = {1};
  meth_meth_parser__apply9818->type = alloc_MethodType(1, argcv_meth_parser__apply9818);
  meth_meth_parser__apply9818->definitionModule = modulename;
  meth_meth_parser__apply9818->definitionLine = 3023;
// compiled block node returning block9817 (depth = 9)
  gc_frame_newslot(block9817);
// call case 4: self request
  params[0] = block9817;
  partcv[0] = 1;
  Object call9836 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9816);
// compiled call node returning call9836 (depth = 8)
  *var_rparen = call9836;
  if (call9836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool9840 = alloc_Boolean(0);
// compiled identifier node returning bool9840 (depth = 10)
  int op_slot_right_9839 = gc_frame_newslot(bool9840);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rparen (depth = 10)
  int op_slot_left_9839 = gc_frame_newslot(*var_rparen);
  params[0] = bool9840;
  partcv[0] = 1;
  Object opresult9842 = callmethod(*var_rparen, "!=", 1, partcv, params);
// compiled op node returning opresult9842 (depth = 9)
  int op_slot_right_9838 = gc_frame_newslot(opresult9842);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9845 == NULL) {
    strlit9845 = alloc_String("comma");
    gc_root(strlit9845);
  }
// compiled string node returning strlit9845 (depth = 10)
  int op_slot_right_9844 = gc_frame_newslot(strlit9845);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9847 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9848 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9847);
// compiled call node returning call9848 (depth = 11)
// compiled member node returning call9848 (depth = 10)
  int op_slot_left_9844 = gc_frame_newslot(call9848);
  params[0] = strlit9845;
  partcv[0] = 1;
  Object opresult9849 = callmethod(call9848, "==", 1, partcv, params);
// compiled op node returning opresult9849 (depth = 9)
  int op_slot_left_9838 = gc_frame_newslot(opresult9849);
  params[0] = opresult9842;
  partcv[0] = 1;
  Object opresult9850 = callmethod(opresult9849, "&&", 1, partcv, params);
// compiled op node returning opresult9850 (depth = 8)
  Object if9837 = done;
  if (istrue(opresult9850)) {
// Begin line 3026
  setline(3026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9851 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9853 == NULL) {
    strlit9853 = alloc_String("");
    gc_root(strlit9853);
  }
// compiled string node returning strlit9853 (depth = 10)
  int op_slot_right_9852 = gc_frame_newslot(strlit9853);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9856 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_id (depth = 13)
  partcv[0] = 0;
  Object call9857 = callmethod(*var_id, "value",
    1, partcv, params);
  gc_frame_end(callframe9856);
// compiled call node returning call9857 (depth = 12)
// compiled member node returning call9857 (depth = 11)
  int op_slot_right_9855 = gc_frame_newslot(call9857);
// starting to compile string node (depth = 11)
  if (strlit9859 == NULL) {
    strlit9859 = alloc_String(",*");
    gc_root(strlit9859);
  }
// compiled string node returning strlit9859 (depth = 11)
  int op_slot_left_9855 = gc_frame_newslot(strlit9859);
  params[0] = call9857;
  partcv[0] = 1;
  Object opresult9860 = callmethod(strlit9859, "++", 1, partcv, params);
// compiled op node returning opresult9860 (depth = 10)
  int op_slot_left_9852 = gc_frame_newslot(opresult9860);
  params[0] = strlit9853;
  partcv[0] = 1;
  Object opresult9861 = callmethod(opresult9860, "++", 1, partcv, params);
// compiled op node returning opresult9861 (depth = 9)
  gc_frame_newslot(opresult9861);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_rparen (depth = 9)
  gc_frame_newslot(*var_rparen);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = opresult9861;
  params[1] = *var_rparen;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9862 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe9851);
// compiled call node returning call9862 (depth = 8)
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9863 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lparen (depth = 11)
  partcv[0] = 0;
  Object call9865 = callmethod(*var_lparen, "next",
    1, partcv, params);
  gc_frame_end(callframe9864);
// compiled call node returning call9865 (depth = 10)
// compiled member node returning call9865 (depth = 9)
  gc_frame_newslot(call9865);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
  Object bool9866 = alloc_Boolean(1);
// compiled identifier node returning bool9866 (depth = 9)
  gc_frame_newslot(bool9866);
// starting to compile identifier node (depth = 9)
  Object bool9867 = alloc_Boolean(0);
// compiled identifier node returning bool9867 (depth = 9)
  gc_frame_newslot(bool9867);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = call9865;
  params[1] = *var_sym;
  params[2] = bool9866;
  params[3] = bool9867;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9868 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9863);
// compiled call node returning call9868 (depth = 8)
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9869 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9870 == NULL) {
    strlit9870 = alloc_String("A variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.");
    gc_root(strlit9870);
  }
// compiled string node returning strlit9870 (depth = 9)
  gc_frame_newslot(strlit9870);
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9872 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9871);
// compiled call node returning call9872 (depth = 10)
// compiled member node returning call9872 (depth = 9)
  gc_frame_newslot(call9872);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9873 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9874 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9873);
// compiled call node returning call9874 (depth = 10)
// compiled member node returning call9874 (depth = 9)
  gc_frame_newslot(call9874);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9876 = alloc_Float64(1);
// compiled num node returning num9876 (depth = 10)
  int op_slot_right_9875 = gc_frame_newslot(num9876);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9878 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_rparen (depth = 12)
  partcv[0] = 0;
  Object call9879 = callmethod(*var_rparen, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9878);
// compiled call node returning call9879 (depth = 11)
// compiled member node returning call9879 (depth = 10)
  int op_slot_left_9875 = gc_frame_newslot(call9879);
  params[0] = num9876;
  partcv[0] = 1;
  Object diff9880 = callmethod(call9879, "-", 1, partcv, params);
// compiled op node returning diff9880 (depth = 9)
  gc_frame_newslot(diff9880);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9870;
  params[1] = call9872;
  params[2] = call9874;
  params[3] = diff9880;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9881 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9869);
// compiled call node returning call9881 (depth = 8)
    gc_frame_newslot(call9881);
    if9837 = call9881;
  } else {
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9882 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9883 == NULL) {
    strlit9883 = alloc_String(")");
    gc_root(strlit9883);
  }
// compiled string node returning strlit9883 (depth = 9)
  gc_frame_newslot(strlit9883);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9883;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9884 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9882);
// compiled call node returning call9884 (depth = 8)
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9885 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9886 == NULL) {
    strlit9886 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9886);
  }
// compiled string node returning strlit9886 (depth = 9)
  gc_frame_newslot(strlit9886);
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9888 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9887);
// compiled call node returning call9888 (depth = 10)
// compiled member node returning call9888 (depth = 9)
  gc_frame_newslot(call9888);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9891 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9890);
// compiled call node returning call9891 (depth = 11)
// compiled member node returning call9891 (depth = 10)
  int op_slot_right_9889 = gc_frame_newslot(call9891);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9893 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9894 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9893);
// compiled call node returning call9894 (depth = 11)
// compiled member node returning call9894 (depth = 10)
  int op_slot_left_9889 = gc_frame_newslot(call9894);
  params[0] = call9891;
  partcv[0] = 1;
  Object sum9895 = callmethod(call9894, "+", 1, partcv, params);
// compiled op node returning sum9895 (depth = 9)
  gc_frame_newslot(sum9895);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9886;
  params[1] = call9888;
  params[2] = sum9895;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9896 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9885);
// compiled call node returning call9896 (depth = 8)
    gc_frame_newslot(call9896);
    if9837 = call9896;
  }
// compiled if node returning if9837 (depth = 7)
    gc_frame_newslot(if9837);
    if9805 = if9837;
  } else {
  }
// compiled if node returning if9805 (depth = 6)
    gc_frame_newslot(if9805);
    if9802 = if9805;
  } else {
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9897 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9898 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call9899 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe9898);
// compiled call node returning call9899 (depth = 8)
// compiled member node returning call9899 (depth = 7)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9900 = callmethod(call9899, "push",
    1, partcv, params);
  gc_frame_end(callframe9897);
// compiled call node returning call9900 (depth = 6)
    gc_frame_newslot(call9900);
    if9802 = call9900;
  }
// compiled if node returning if9802 (depth = 5)
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9902 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9903 == NULL) {
    strlit9903 = alloc_String("comma");
    gc_root(strlit9903);
  }
// compiled string node returning strlit9903 (depth = 7)
  gc_frame_newslot(strlit9903);
// call case 4: self request
  params[0] = strlit9903;
  partcv[0] = 1;
  Object call9904 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9902);
// compiled call node returning call9904 (depth = 6)
  Object if9901 = done;
  if (istrue(call9904)) {
// Begin line 3040
  setline(3040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9906 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9907 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9906);
// compiled call node returning call9907 (depth = 7)
// compiled member node returning call9907 (depth = 6)
    gc_frame_newslot(call9907);
    if9901 = call9907;
  } else {
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3042
  setline(3042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9910 == NULL) {
    strlit9910 = alloc_String("rparen");
    gc_root(strlit9910);
  }
// compiled string node returning strlit9910 (depth = 8)
  int op_slot_right_9909 = gc_frame_newslot(strlit9910);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9913 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9912);
// compiled call node returning call9913 (depth = 9)
// compiled member node returning call9913 (depth = 8)
  int op_slot_left_9909 = gc_frame_newslot(call9913);
  params[0] = strlit9910;
  partcv[0] = 1;
  Object opresult9914 = callmethod(call9913, "!=", 1, partcv, params);
// compiled op node returning opresult9914 (depth = 7)
  Object if9908 = done;
  if (istrue(opresult9914)) {
// Begin line 3043
  setline(3043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9917 == NULL) {
    strlit9917 = alloc_String("rparen");
    gc_root(strlit9917);
  }
// compiled string node returning strlit9917 (depth = 9)
  int op_slot_right_9916 = gc_frame_newslot(strlit9917);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9920 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9919);
// compiled call node returning call9920 (depth = 10)
// compiled member node returning call9920 (depth = 9)
  int op_slot_left_9916 = gc_frame_newslot(call9920);
  params[0] = strlit9917;
  partcv[0] = 1;
  Object opresult9921 = callmethod(call9920, "!=", 1, partcv, params);
// compiled op node returning opresult9921 (depth = 8)
  Object if9915 = done;
  if (istrue(opresult9921)) {
// Begin line 3044
  setline(3044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9922 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9923 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9924 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9923);
// compiled call node returning call9924 (depth = 12)
// compiled member node returning call9924 (depth = 11)
  partcv[0] = 0;
  Object call9925 = callmethod(call9924, "new",
    1, partcv, params);
  gc_frame_end(callframe9922);
// compiled call node returning call9925 (depth = 10)
// compiled member node returning call9925 (depth = 9)
  *var_suggestion = call9925;
  if (call9925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9926 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9927 == NULL) {
    strlit9927 = alloc_String(")");
    gc_root(strlit9927);
  }
// compiled string node returning strlit9927 (depth = 9)
  gc_frame_newslot(strlit9927);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9927;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9928 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9926);
// compiled call node returning call9928 (depth = 8)
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9929 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9930 == NULL) {
    strlit9930 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9930);
  }
// compiled string node returning strlit9930 (depth = 9)
  gc_frame_newslot(strlit9930);
// Begin line 3047
  setline(3047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9932 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9931);
// compiled call node returning call9932 (depth = 10)
// compiled member node returning call9932 (depth = 9)
  gc_frame_newslot(call9932);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9934 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9935 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9934);
// compiled call node returning call9935 (depth = 11)
// compiled member node returning call9935 (depth = 10)
  int op_slot_right_9933 = gc_frame_newslot(call9935);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9938 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9937);
// compiled call node returning call9938 (depth = 11)
// compiled member node returning call9938 (depth = 10)
  int op_slot_left_9933 = gc_frame_newslot(call9938);
  params[0] = call9935;
  partcv[0] = 1;
  Object sum9939 = callmethod(call9938, "+", 1, partcv, params);
// compiled op node returning sum9939 (depth = 9)
  gc_frame_newslot(sum9939);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9930;
  params[1] = call9932;
  params[2] = sum9939;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9940 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9929);
// compiled call node returning call9940 (depth = 8)
    gc_frame_newslot(call9940);
    if9915 = call9940;
  } else {
  }
// compiled if node returning if9915 (depth = 7)
    gc_frame_newslot(if9915);
    if9908 = if9915;
  } else {
  }
// compiled if node returning if9908 (depth = 6)
    gc_frame_newslot(if9908);
    if9901 = if9908;
  }
// compiled if node returning if9901 (depth = 5)
  gc_frame_end(frame);
  return if9901;
}
Object meth_parser__apply9956(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9960 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9959);
// compiled call node returning call9960 (depth = 10)
// compiled member node returning call9960 (depth = 9)
  int op_slot_right_9958 = gc_frame_newslot(call9960);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call9963 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9962);
// compiled call node returning call9963 (depth = 10)
// compiled member node returning call9963 (depth = 9)
  int op_slot_left_9958 = gc_frame_newslot(call9963);
  params[0] = call9960;
  partcv[0] = 1;
  Object opresult9964 = callmethod(call9963, "==", 1, partcv, params);
// compiled op node returning opresult9964 (depth = 8)
  int op_slot_right_9957 = gc_frame_newslot(opresult9964);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9967 == NULL) {
    strlit9967 = alloc_String("rparen");
    gc_root(strlit9967);
  }
// compiled string node returning strlit9967 (depth = 9)
  int op_slot_right_9966 = gc_frame_newslot(strlit9967);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9969 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call9970 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9969);
// compiled call node returning call9970 (depth = 10)
// compiled member node returning call9970 (depth = 9)
  int op_slot_left_9966 = gc_frame_newslot(call9970);
  params[0] = strlit9967;
  partcv[0] = 1;
  Object opresult9971 = callmethod(call9970, "==", 1, partcv, params);
// compiled op node returning opresult9971 (depth = 8)
  int op_slot_left_9957 = gc_frame_newslot(opresult9971);
  params[0] = opresult9964;
  partcv[0] = 1;
  Object opresult9972 = callmethod(opresult9971, "&&", 1, partcv, params);
// compiled op node returning opresult9972 (depth = 7)
  gc_frame_end(frame);
  return opresult9972;
}
Object meth_parser_methodsignature9419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(19, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method methodsignature");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_varargs = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "varargs");
  Object *var_vararg = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "vararg");
  Object *var_lparen = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "lparen");
  Object *var_id = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "id");
  Object *var_comma = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "comma");
  Object *var_rparen = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "rparen");
  Object *var_tm = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "tm");
  Object *var_o = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "o");
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9423 == NULL) {
    strlit9423 = alloc_String("lsquare");
    gc_root(strlit9423);
  }
// compiled string node returning strlit9423 (depth = 5)
  int op_slot_right_9422 = gc_frame_newslot(strlit9423);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9425 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9426 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9425);
// compiled call node returning call9426 (depth = 6)
// compiled member node returning call9426 (depth = 5)
  int op_slot_left_9422 = gc_frame_newslot(call9426);
  params[0] = strlit9423;
  partcv[0] = 1;
  Object opresult9427 = callmethod(call9426, "!=", 1, partcv, params);
// compiled op node returning opresult9427 (depth = 4)
  int op_slot_right_9421 = gc_frame_newslot(opresult9427);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9431 == NULL) {
    strlit9431 = alloc_String("op");
    gc_root(strlit9431);
  }
// compiled string node returning strlit9431 (depth = 6)
  int op_slot_right_9430 = gc_frame_newslot(strlit9431);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9434 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9433);
// compiled call node returning call9434 (depth = 7)
// compiled member node returning call9434 (depth = 6)
  int op_slot_left_9430 = gc_frame_newslot(call9434);
  params[0] = strlit9431;
  partcv[0] = 1;
  Object opresult9435 = callmethod(call9434, "!=", 1, partcv, params);
// compiled op node returning opresult9435 (depth = 5)
  int op_slot_right_9429 = gc_frame_newslot(opresult9435);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9438 == NULL) {
    strlit9438 = alloc_String("identifier");
    gc_root(strlit9438);
  }
// compiled string node returning strlit9438 (depth = 6)
  int op_slot_right_9437 = gc_frame_newslot(strlit9438);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9440 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9441 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9440);
// compiled call node returning call9441 (depth = 7)
// compiled member node returning call9441 (depth = 6)
  int op_slot_left_9437 = gc_frame_newslot(call9441);
  params[0] = strlit9438;
  partcv[0] = 1;
  Object opresult9442 = callmethod(call9441, "!=", 1, partcv, params);
// compiled op node returning opresult9442 (depth = 5)
  int op_slot_left_9429 = gc_frame_newslot(opresult9442);
  params[0] = opresult9435;
  partcv[0] = 1;
  Object opresult9443 = callmethod(opresult9442, "&&", 1, partcv, params);
// compiled op node returning opresult9443 (depth = 4)
  int op_slot_left_9421 = gc_frame_newslot(opresult9443);
  params[0] = opresult9427;
  partcv[0] = 1;
  Object opresult9444 = callmethod(opresult9443, "&&", 1, partcv, params);
// compiled op node returning opresult9444 (depth = 3)
  Object if9420 = done;
  if (istrue(opresult9444)) {
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9445 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9447 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9446);
// compiled call node returning call9447 (depth = 7)
// compiled member node returning call9447 (depth = 6)
  partcv[0] = 0;
  Object call9448 = callmethod(call9447, "new",
    1, partcv, params);
  gc_frame_end(callframe9445);
// compiled call node returning call9448 (depth = 5)
// compiled member node returning call9448 (depth = 4)
  *var_suggestion = call9448;
  if (call9448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2933
  setline(2933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9449 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9450 == NULL) {
    strlit9450 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit9450);
  }
// compiled string node returning strlit9450 (depth = 4)
  gc_frame_newslot(strlit9450);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit9450;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9451 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9449);
// compiled call node returning call9451 (depth = 3)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9452 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9453 == NULL) {
    strlit9453 = alloc_String("A method name must start with an identifier, or be an operator or '[]'.");
    gc_root(strlit9453);
  }
// compiled string node returning strlit9453 (depth = 4)
  gc_frame_newslot(strlit9453);
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9454 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call9455 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9454);
// compiled call node returning call9455 (depth = 5)
// compiled member node returning call9455 (depth = 4)
  gc_frame_newslot(call9455);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9458 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9457);
// compiled call node returning call9458 (depth = 6)
// compiled member node returning call9458 (depth = 5)
  int op_slot_right_9456 = gc_frame_newslot(call9458);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9460 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9461 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9460);
// compiled call node returning call9461 (depth = 6)
// compiled member node returning call9461 (depth = 5)
  int op_slot_left_9456 = gc_frame_newslot(call9461);
  params[0] = call9458;
  partcv[0] = 1;
  Object sum9462 = callmethod(call9461, "+", 1, partcv, params);
// compiled op node returning sum9462 (depth = 4)
  gc_frame_newslot(sum9462);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9453;
  params[1] = call9455;
  params[2] = sum9462;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9463 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9452);
// compiled call node returning call9463 (depth = 3)
    gc_frame_newslot(call9463);
    if9420 = call9463;
  } else {
  }
// compiled if node returning if9420 (depth = 2)
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9465 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9464);
// compiled call node returning call9465 (depth = 3)
// compiled member node returning call9465 (depth = 2)
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9466 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call9467 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9466);
// compiled call node returning call9467 (depth = 4)
// compiled member node returning call9467 (depth = 3)
  *var_meth = call9467;
  if (call9467 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9468 = gc_frame_new();
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9469 = alloc_Boolean(1);
// compiled identifier node returning bool9469 (depth = 4)
  gc_frame_newslot(bool9469);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = bool9469;
  partcv[0] = 1;
  Object call9470 = callmethod(*var_meth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9468);
// compiled call node returning call9470 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9471 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9472 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9473 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9472);
// compiled call node returning call9473 (depth = 6)
// compiled member node returning call9473 (depth = 5)
  partcv[0] = 0;
  Object call9474 = callmethod(call9473, "empty",
    1, partcv, params);
  gc_frame_end(callframe9471);
// compiled call node returning call9474 (depth = 4)
// compiled member node returning call9474 (depth = 3)
  *var_signature = call9474;
  if (call9474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2941
  setline(2941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9475 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9477 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9476);
// compiled call node returning call9477 (depth = 5)
// compiled member node returning call9477 (depth = 4)
  gc_frame_newslot(call9477);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9478 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call9479 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe9478);
// compiled call node returning call9479 (depth = 5)
// compiled member node returning call9479 (depth = 4)
  params[0] = call9477;
  partcv[0] = 1;
  Object call9480 = callmethod(call9479, "new",
    1, partcv, params);
  gc_frame_end(callframe9475);
// compiled call node returning call9480 (depth = 3)
  *var_part = call9480;
  if (call9480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2941
  setline(2941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9481 = gc_frame_new();
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9482 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9483 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe9482);
// compiled call node returning call9483 (depth = 5)
// compiled member node returning call9483 (depth = 4)
  gc_frame_newslot(call9483);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call9483;
  partcv[0] = 1;
  Object call9484 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe9481);
// compiled call node returning call9484 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9485 = gc_frame_new();
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9486 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9487 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9486);
// compiled call node returning call9487 (depth = 5)
// compiled member node returning call9487 (depth = 4)
  gc_frame_newslot(call9487);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call9487;
  partcv[0] = 1;
  Object call9488 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9485);
// compiled call node returning call9488 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9489 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9490 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9489);
// compiled call node returning call9490 (depth = 2)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9493 == NULL) {
    strlit9493 = alloc_String("[");
    gc_root(strlit9493);
  }
// compiled string node returning strlit9493 (depth = 4)
  int op_slot_right_9492 = gc_frame_newslot(strlit9493);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9496 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9495);
// compiled call node returning call9496 (depth = 5)
// compiled member node returning call9496 (depth = 4)
  int op_slot_left_9492 = gc_frame_newslot(call9496);
  params[0] = strlit9493;
  partcv[0] = 1;
  Object opresult9497 = callmethod(call9496, "==", 1, partcv, params);
// compiled op node returning opresult9497 (depth = 3)
  Object if9491 = done;
  if (istrue(opresult9497)) {
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9500 == NULL) {
    strlit9500 = alloc_String("rsquare");
    gc_root(strlit9500);
  }
// compiled string node returning strlit9500 (depth = 5)
  int op_slot_right_9499 = gc_frame_newslot(strlit9500);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9503 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9502);
// compiled call node returning call9503 (depth = 6)
// compiled member node returning call9503 (depth = 5)
  int op_slot_left_9499 = gc_frame_newslot(call9503);
  params[0] = strlit9500;
  partcv[0] = 1;
  Object opresult9504 = callmethod(call9503, "!=", 1, partcv, params);
// compiled op node returning opresult9504 (depth = 4)
  Object if9498 = done;
  if (istrue(opresult9504)) {
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9507 = gc_frame_new();
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 7)
  Object block9508 = alloc_Block(NULL, NULL, "parser", 2948);
  gc_frame_newslot(block9508);
// method _apply
  block_savedest(block9508);
  Object closure9509 = createclosure(2, "_apply");
  setclosureframe(closure9509, stackframe);
  addtoclosure(closure9509, var_tokens);
  addtoclosure(closure9509, selfslot);
  struct UserObject *uo9509 = (struct UserObject*)block9508;
  uo9509->data[0] = (Object)closure9509;
  Method *meth_meth_parser__apply9509 = addmethod2pos(block9508, "_apply", &meth_parser__apply9509, 0);
  int argcv_meth_parser__apply9509[] = {0};
  meth_meth_parser__apply9509->type = alloc_MethodType(1, argcv_meth_parser__apply9509);
  meth_meth_parser__apply9509->definitionModule = modulename;
  meth_meth_parser__apply9509->definitionLine = 2946;
// compiled block node returning block9508 (depth = 7)
  gc_frame_newslot(block9508);
// call case 6: other member request
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9520 = alloc_Float64(0);
// compiled num node returning num9520 (depth = 8)
  int op_slot_right_9519 = gc_frame_newslot(num9520);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9522 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9523 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9522);
// compiled call node returning call9523 (depth = 9)
// compiled member node returning call9523 (depth = 8)
  int op_slot_left_9519 = gc_frame_newslot(call9523);
  params[0] = num9520;
  partcv[0] = 1;
  Object opresult9524 = callmethod(call9523, "==", 1, partcv, params);
// compiled op node returning opresult9524 (depth = 7)
  params[0] = block9508;
  partcv[0] = 1;
  Object call9525 = callmethod(opresult9524, "orElse",
    1, partcv, params);
  gc_frame_end(callframe9507);
// compiled call node returning call9525 (depth = 6)
  int op_slot_right_9506 = gc_frame_newslot(call9525);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9528 == NULL) {
    strlit9528 = alloc_String("identifier");
    gc_root(strlit9528);
  }
// compiled string node returning strlit9528 (depth = 7)
  int op_slot_right_9527 = gc_frame_newslot(strlit9528);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9531 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9530);
// compiled call node returning call9531 (depth = 8)
// compiled member node returning call9531 (depth = 7)
  int op_slot_left_9527 = gc_frame_newslot(call9531);
  params[0] = strlit9528;
  partcv[0] = 1;
  Object opresult9532 = callmethod(call9531, "==", 1, partcv, params);
// compiled op node returning opresult9532 (depth = 6)
  int op_slot_left_9506 = gc_frame_newslot(opresult9532);
  params[0] = call9525;
  partcv[0] = 1;
  Object opresult9533 = callmethod(opresult9532, "&&", 1, partcv, params);
// compiled op node returning opresult9533 (depth = 5)
  Object if9505 = done;
  if (istrue(opresult9533)) {
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9534 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9535 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9536 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9535);
// compiled call node returning call9536 (depth = 9)
// compiled member node returning call9536 (depth = 8)
  partcv[0] = 0;
  Object call9537 = callmethod(call9536, "empty",
    1, partcv, params);
  gc_frame_end(callframe9534);
// compiled call node returning call9537 (depth = 7)
// compiled member node returning call9537 (depth = 6)
  *var_suggestions = call9537;
  if (call9537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9538 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9540 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9539);
// compiled call node returning call9540 (depth = 9)
// compiled member node returning call9540 (depth = 8)
  partcv[0] = 0;
  Object call9541 = callmethod(call9540, "new",
    1, partcv, params);
  gc_frame_end(callframe9538);
// compiled call node returning call9541 (depth = 7)
// compiled member node returning call9541 (depth = 6)
  *var_suggestion = call9541;
  if (call9541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9544 = alloc_Float64(0);
// compiled num node returning num9544 (depth = 7)
  int op_slot_right_9543 = gc_frame_newslot(num9544);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9546 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call9547 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9546);
// compiled call node returning call9547 (depth = 8)
// compiled member node returning call9547 (depth = 7)
  int op_slot_left_9543 = gc_frame_newslot(call9547);
  params[0] = num9544;
  partcv[0] = 1;
  Object opresult9548 = callmethod(call9547, "==", 1, partcv, params);
// compiled op node returning opresult9548 (depth = 6)
  Object if9542 = done;
  if (istrue(opresult9548)) {
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9549 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9551 == NULL) {
    strlit9551 = alloc_String(")");
    gc_root(strlit9551);
  }
// compiled string node returning strlit9551 (depth = 8)
  int op_slot_right_9550 = gc_frame_newslot(strlit9551);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9555 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9554);
// compiled call node returning call9555 (depth = 10)
// compiled member node returning call9555 (depth = 9)
  int op_slot_right_9553 = gc_frame_newslot(call9555);
// starting to compile string node (depth = 9)
  if (strlit9557 == NULL) {
    strlit9557 = alloc_String("](");
    gc_root(strlit9557);
  }
// compiled string node returning strlit9557 (depth = 9)
  int op_slot_left_9553 = gc_frame_newslot(strlit9557);
  params[0] = call9555;
  partcv[0] = 1;
  Object opresult9558 = callmethod(strlit9557, "++", 1, partcv, params);
// compiled op node returning opresult9558 (depth = 8)
  int op_slot_left_9550 = gc_frame_newslot(opresult9558);
  params[0] = strlit9551;
  partcv[0] = 1;
  Object opresult9559 = callmethod(opresult9558, "++", 1, partcv, params);
// compiled op node returning opresult9559 (depth = 7)
  gc_frame_newslot(opresult9559);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = opresult9559;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9560 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9549);
// compiled call node returning call9560 (depth = 6)
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9561 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9562 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9561);
// compiled call node returning call9562 (depth = 6)
    gc_frame_newslot(call9562);
    if9542 = call9562;
  } else {
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call9566 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe9565);
// compiled call node returning call9566 (depth = 9)
// compiled member node returning call9566 (depth = 8)
  int op_slot_right_9564 = gc_frame_newslot(call9566);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9568 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9569 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  partcv[0] = 0;
  Object call9570 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9569);
// compiled call node returning call9570 (depth = 11)
// compiled member node returning call9570 (depth = 10)
  partcv[0] = 0;
  Object call9571 = callmethod(call9570, "line",
    1, partcv, params);
  gc_frame_end(callframe9568);
// compiled call node returning call9571 (depth = 9)
// compiled member node returning call9571 (depth = 8)
  int op_slot_left_9564 = gc_frame_newslot(call9571);
  params[0] = call9566;
  partcv[0] = 1;
  Object opresult9572 = callmethod(call9571, "==", 1, partcv, params);
// compiled op node returning opresult9572 (depth = 7)
  Object if9563 = done;
  if (istrue(opresult9572)) {
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9573 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9574 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9575 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9574);
// compiled call node returning call9575 (depth = 9)
// compiled member node returning call9575 (depth = 8)
  gc_frame_newslot(call9575);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9577 == NULL) {
    strlit9577 = alloc_String(")");
    gc_root(strlit9577);
  }
// compiled string node returning strlit9577 (depth = 9)
  int op_slot_right_9576 = gc_frame_newslot(strlit9577);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9580 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9581 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9580);
// compiled call node returning call9581 (depth = 11)
// compiled member node returning call9581 (depth = 10)
  int op_slot_right_9579 = gc_frame_newslot(call9581);
// starting to compile string node (depth = 10)
  if (strlit9583 == NULL) {
    strlit9583 = alloc_String("](");
    gc_root(strlit9583);
  }
// compiled string node returning strlit9583 (depth = 10)
  int op_slot_left_9579 = gc_frame_newslot(strlit9583);
  params[0] = call9581;
  partcv[0] = 1;
  Object opresult9584 = callmethod(strlit9583, "++", 1, partcv, params);
// compiled op node returning opresult9584 (depth = 9)
  int op_slot_left_9576 = gc_frame_newslot(opresult9584);
  params[0] = strlit9577;
  partcv[0] = 1;
  Object opresult9585 = callmethod(opresult9584, "++", 1, partcv, params);
// compiled op node returning opresult9585 (depth = 8)
  gc_frame_newslot(opresult9585);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call9575;
  params[2] = opresult9585;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9586 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe9573);
// compiled call node returning call9586 (depth = 7)
// Begin line 2956
  setline(2956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9587 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9588 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9587);
// compiled call node returning call9588 (depth = 7)
    gc_frame_newslot(call9588);
    if9563 = call9588;
  } else {
  }
// compiled if node returning if9563 (depth = 6)
    gc_frame_newslot(if9563);
    if9542 = if9563;
  }
// compiled if node returning if9542 (depth = 5)
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9589 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9590 == NULL) {
    strlit9590 = alloc_String("A declaration of a method named '[]' must have the parameter name in parentheses after the '[]'.");
    gc_root(strlit9590);
  }
// compiled string node returning strlit9590 (depth = 6)
  gc_frame_newslot(strlit9590);
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9591 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9592 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9591);
// compiled call node returning call9592 (depth = 7)
// compiled member node returning call9592 (depth = 6)
  gc_frame_newslot(call9592);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9594 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9595 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9594);
// compiled call node returning call9595 (depth = 8)
// compiled member node returning call9595 (depth = 7)
  int op_slot_right_9593 = gc_frame_newslot(call9595);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9598 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9597);
// compiled call node returning call9598 (depth = 8)
// compiled member node returning call9598 (depth = 7)
  int op_slot_left_9593 = gc_frame_newslot(call9598);
  params[0] = call9595;
  partcv[0] = 1;
  Object sum9599 = callmethod(call9598, "+", 1, partcv, params);
// compiled op node returning sum9599 (depth = 6)
  gc_frame_newslot(sum9599);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9590;
  params[1] = call9592;
  params[2] = sum9599;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9600 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9589);
// compiled call node returning call9600 (depth = 5)
    gc_frame_newslot(call9600);
    if9505 = call9600;
  } else {
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9601 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9602 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9603 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9602);
// compiled call node returning call9603 (depth = 9)
// compiled member node returning call9603 (depth = 8)
  partcv[0] = 0;
  Object call9604 = callmethod(call9603, "new",
    1, partcv, params);
  gc_frame_end(callframe9601);
// compiled call node returning call9604 (depth = 7)
// compiled member node returning call9604 (depth = 6)
  *var_suggestion = call9604;
  if (call9604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9605 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9606 == NULL) {
    strlit9606 = alloc_String("]");
    gc_root(strlit9606);
  }
// compiled string node returning strlit9606 (depth = 6)
  gc_frame_newslot(strlit9606);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9606;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9607 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9605);
// compiled call node returning call9607 (depth = 5)
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9608 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9609 == NULL) {
    strlit9609 = alloc_String("A method name must start with either an identifier or '[]'.");
    gc_root(strlit9609);
  }
// compiled string node returning strlit9609 (depth = 6)
  gc_frame_newslot(strlit9609);
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9610 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9611 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9610);
// compiled call node returning call9611 (depth = 7)
// compiled member node returning call9611 (depth = 6)
  gc_frame_newslot(call9611);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9614 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9613);
// compiled call node returning call9614 (depth = 8)
// compiled member node returning call9614 (depth = 7)
  int op_slot_right_9612 = gc_frame_newslot(call9614);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9617 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9616);
// compiled call node returning call9617 (depth = 8)
// compiled member node returning call9617 (depth = 7)
  int op_slot_left_9612 = gc_frame_newslot(call9617);
  params[0] = call9614;
  partcv[0] = 1;
  Object sum9618 = callmethod(call9617, "+", 1, partcv, params);
// compiled op node returning sum9618 (depth = 6)
  gc_frame_newslot(sum9618);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9609;
  params[1] = call9611;
  params[2] = sum9618;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9619 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9608);
// compiled call node returning call9619 (depth = 5)
    gc_frame_newslot(call9619);
    if9505 = call9619;
  }
// compiled if node returning if9505 (depth = 4)
    gc_frame_newslot(if9505);
    if9498 = if9505;
  } else {
  }
// compiled if node returning if9498 (depth = 3)
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9620 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9621 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9620);
// compiled call node returning call9621 (depth = 4)
// compiled member node returning call9621 (depth = 3)
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9622 = gc_frame_new();
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit9623 == NULL) {
    strlit9623 = alloc_String("[]");
    gc_root(strlit9623);
  }
// compiled string node returning strlit9623 (depth = 5)
  gc_frame_newslot(strlit9623);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = strlit9623;
  partcv[0] = 1;
  Object call9624 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9622);
// compiled call node returning call9624 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9491 = done;
  } else {
  }
// compiled if node returning if9491 (depth = 2)
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9626 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9627 == NULL) {
    strlit9627 = alloc_String("lgeneric");
    gc_root(strlit9627);
  }
// compiled string node returning strlit9627 (depth = 4)
  gc_frame_newslot(strlit9627);
// call case 4: self request
  params[0] = strlit9627;
  partcv[0] = 1;
  Object call9628 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9626);
// compiled call node returning call9628 (depth = 3)
  Object if9625 = done;
  if (istrue(call9628)) {
// starting to compile call node (depth = 3)
  int callframe9629 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// call case 4: self request
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9630 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9629);
// compiled call node returning call9630 (depth = 3)
    gc_frame_newslot(call9630);
    if9625 = call9630;
  } else {
  }
// compiled if node returning if9625 (depth = 2)
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9632 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9633 == NULL) {
    strlit9633 = alloc_String("bind");
    gc_root(strlit9633);
  }
// compiled string node returning strlit9633 (depth = 4)
  gc_frame_newslot(strlit9633);
// call case 4: self request
  params[0] = strlit9633;
  partcv[0] = 1;
  Object call9634 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9632);
// compiled call node returning call9634 (depth = 3)
  Object if9631 = done;
  if (istrue(call9634)) {
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9635 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9636 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9635);
// compiled call node returning call9636 (depth = 4)
// compiled member node returning call9636 (depth = 3)
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9637 = gc_frame_new();
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9639 == NULL) {
    strlit9639 = alloc_String(":=");
    gc_root(strlit9639);
  }
// compiled string node returning strlit9639 (depth = 6)
  int op_slot_right_9638 = gc_frame_newslot(strlit9639);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9642 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9641);
// compiled call node returning call9642 (depth = 7)
// compiled member node returning call9642 (depth = 6)
  int op_slot_left_9638 = gc_frame_newslot(call9642);
  params[0] = strlit9639;
  partcv[0] = 1;
  Object opresult9643 = callmethod(call9642, "++", 1, partcv, params);
// compiled op node returning opresult9643 (depth = 5)
  gc_frame_newslot(opresult9643);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = opresult9643;
  partcv[0] = 1;
  Object call9644 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9637);
// compiled call node returning call9644 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9645 = gc_frame_new();
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9647 == NULL) {
    strlit9647 = alloc_String(":=");
    gc_root(strlit9647);
  }
// compiled string node returning strlit9647 (depth = 6)
  int op_slot_right_9646 = gc_frame_newslot(strlit9647);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9650 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9649);
// compiled call node returning call9650 (depth = 7)
// compiled member node returning call9650 (depth = 6)
  int op_slot_left_9646 = gc_frame_newslot(call9650);
  params[0] = strlit9647;
  partcv[0] = 1;
  Object opresult9651 = callmethod(call9650, "++", 1, partcv, params);
// compiled op node returning opresult9651 (depth = 5)
  gc_frame_newslot(opresult9651);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult9651;
  partcv[0] = 1;
  Object call9652 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9645);
// compiled call node returning call9652 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9631 = done;
  } else {
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9656 == NULL) {
    strlit9656 = alloc_String("prefix");
    gc_root(strlit9656);
  }
// compiled string node returning strlit9656 (depth = 6)
  int op_slot_right_9655 = gc_frame_newslot(strlit9656);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9658 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9659 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9658);
// compiled call node returning call9659 (depth = 7)
// compiled member node returning call9659 (depth = 6)
  int op_slot_left_9655 = gc_frame_newslot(call9659);
  params[0] = strlit9656;
  partcv[0] = 1;
  Object opresult9660 = callmethod(call9659, "==", 1, partcv, params);
// compiled op node returning opresult9660 (depth = 5)
  int op_slot_right_9654 = gc_frame_newslot(opresult9660);
// starting to compile call node (depth = 5)
  int callframe9662 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9663 == NULL) {
    strlit9663 = alloc_String("op");
    gc_root(strlit9663);
  }
// compiled string node returning strlit9663 (depth = 6)
  gc_frame_newslot(strlit9663);
// call case 4: self request
  params[0] = strlit9663;
  partcv[0] = 1;
  Object call9664 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9662);
// compiled call node returning call9664 (depth = 5)
  int op_slot_left_9654 = gc_frame_newslot(call9664);
  params[0] = opresult9660;
  partcv[0] = 1;
  Object opresult9665 = callmethod(call9664, "&&", 1, partcv, params);
// compiled op node returning opresult9665 (depth = 4)
  Object if9653 = done;
  if (istrue(opresult9665)) {
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9666 = gc_frame_new();
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9669 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9668);
// compiled call node returning call9669 (depth = 8)
// compiled member node returning call9669 (depth = 7)
  int op_slot_right_9667 = gc_frame_newslot(call9669);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call9672 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9671);
// compiled call node returning call9672 (depth = 8)
// compiled member node returning call9672 (depth = 7)
  int op_slot_left_9667 = gc_frame_newslot(call9672);
  params[0] = call9669;
  partcv[0] = 1;
  Object opresult9673 = callmethod(call9672, "++", 1, partcv, params);
// compiled op node returning opresult9673 (depth = 6)
  gc_frame_newslot(opresult9673);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = opresult9673;
  partcv[0] = 1;
  Object call9674 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9666);
// compiled call node returning call9674 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9675 = gc_frame_new();
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9677 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9678 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9677);
// compiled call node returning call9678 (depth = 8)
// compiled member node returning call9678 (depth = 7)
  int op_slot_right_9676 = gc_frame_newslot(call9678);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call9681 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9680);
// compiled call node returning call9681 (depth = 8)
// compiled member node returning call9681 (depth = 7)
  int op_slot_left_9676 = gc_frame_newslot(call9681);
  params[0] = call9678;
  partcv[0] = 1;
  Object opresult9682 = callmethod(call9681, "++", 1, partcv, params);
// compiled op node returning opresult9682 (depth = 6)
  gc_frame_newslot(opresult9682);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = opresult9682;
  partcv[0] = 1;
  Object call9683 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9675);
// compiled call node returning call9683 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9684 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9685 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9684);
// compiled call node returning call9685 (depth = 5)
// compiled member node returning call9685 (depth = 4)
    gc_frame_newslot(call9685);
    if9653 = call9685;
  } else {
  }
// compiled if node returning if9653 (depth = 3)
    gc_frame_newslot(if9653);
    if9631 = if9653;
  }
// compiled if node returning if9631 (depth = 2)
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9686 = alloc_Boolean(0);
// compiled identifier node returning bool9686 (depth = 3)
  *var_dtype = bool9686;
  if (bool9686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9687 = alloc_Boolean(0);
// compiled identifier node returning bool9687 (depth = 3)
  *var_varargs = bool9687;
  if (bool9687 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool9688 = alloc_Boolean(0);
// compiled identifier node returning bool9688 (depth = 3)
  *var_vararg = bool9688;
  if (bool9688 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2983
  setline(2983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9690 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9691 == NULL) {
    strlit9691 = alloc_String("lparen");
    gc_root(strlit9691);
  }
// compiled string node returning strlit9691 (depth = 4)
  gc_frame_newslot(strlit9691);
// call case 4: self request
  params[0] = strlit9691;
  partcv[0] = 1;
  Object call9692 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9690);
// compiled call node returning call9692 (depth = 3)
  Object if9689 = done;
  if (istrue(call9692)) {
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9693 = gc_frame_new();
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9694 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9695 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9694);
// compiled call node returning call9695 (depth = 6)
// compiled member node returning call9695 (depth = 5)
  gc_frame_newslot(call9695);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call9695;
  partcv[0] = 1;
  Object call9696 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9693);
// compiled call node returning call9696 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9697 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9698 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9697);
// compiled call node returning call9698 (depth = 4)
// compiled member node returning call9698 (depth = 3)
// Begin line 2987
  setline(2987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2988
  setline(2988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9699 = alloc_Boolean(0);
// compiled identifier node returning bool9699 (depth = 4)
  *var_comma = bool9699;
  if (bool9699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9700 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9701 = alloc_Block(NULL, NULL, "parser", 2989);
  gc_frame_newslot(block9701);
// method _apply
  block_savedest(block9701);
  Object closure9702 = createclosure(2, "_apply");
  setclosureframe(closure9702, stackframe);
  addtoclosure(closure9702, var_sym);
  addtoclosure(closure9702, selfslot);
  struct UserObject *uo9702 = (struct UserObject*)block9701;
  uo9702->data[0] = (Object)closure9702;
  Method *meth_meth_parser__apply9702 = addmethod2pos(block9701, "_apply", &meth_parser__apply9702, 0);
  int argcv_meth_parser__apply9702[] = {0};
  meth_meth_parser__apply9702->type = alloc_MethodType(1, argcv_meth_parser__apply9702);
  meth_meth_parser__apply9702->definitionModule = modulename;
  meth_meth_parser__apply9702->definitionLine = 2986;
// compiled block node returning block9701 (depth = 4)
  gc_frame_newslot(block9701);
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block9722 = alloc_Block(NULL, NULL, "parser", 2990);
  gc_frame_newslot(block9722);
// method _apply
  block_savedest(block9722);
  Object closure9723 = createclosure(12, "_apply");
  setclosureframe(closure9723, stackframe);
  addtoclosure(closure9723, var_sym);
  addtoclosure(closure9723, var_errormessages);
  addtoclosure(closure9723, var_lastToken);
  addtoclosure(closure9723, var_comma);
  addtoclosure(closure9723, var_vararg);
  addtoclosure(closure9723, var_varargs);
  addtoclosure(closure9723, var_values);
  addtoclosure(closure9723, var_id);
  addtoclosure(closure9723, var_dtype);
  addtoclosure(closure9723, var_part);
  addtoclosure(closure9723, var_lparen);
  addtoclosure(closure9723, selfslot);
  struct UserObject *uo9723 = (struct UserObject*)block9722;
  uo9723->data[0] = (Object)closure9723;
  Method *meth_meth_parser__apply9723 = addmethod2pos(block9722, "_apply", &meth_parser__apply9723, 0);
  int argcv_meth_parser__apply9723[] = {0};
  meth_meth_parser__apply9723->type = alloc_MethodType(1, argcv_meth_parser__apply9723);
  meth_meth_parser__apply9723->definitionModule = modulename;
  meth_meth_parser__apply9723->definitionLine = 2990;
// compiled block node returning block9722 (depth = 4)
  gc_frame_newslot(block9722);
// call case 5: prelude request
  params[0] = block9701;
  params[1] = block9722;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9942 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9700);
// compiled call node returning call9942 (depth = 3)
// Begin line 3051
  setline(3051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9945 == NULL) {
    strlit9945 = alloc_String("rparen");
    gc_root(strlit9945);
  }
// compiled string node returning strlit9945 (depth = 5)
  int op_slot_right_9944 = gc_frame_newslot(strlit9945);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9948 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9947);
// compiled call node returning call9948 (depth = 6)
// compiled member node returning call9948 (depth = 5)
  int op_slot_left_9944 = gc_frame_newslot(call9948);
  params[0] = strlit9945;
  partcv[0] = 1;
  Object opresult9949 = callmethod(call9948, "!=", 1, partcv, params);
// compiled op node returning opresult9949 (depth = 4)
  Object if9943 = done;
  if (istrue(opresult9949)) {
// Begin line 3052
  setline(3052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9950 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9952 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9951);
// compiled call node returning call9952 (depth = 8)
// compiled member node returning call9952 (depth = 7)
  partcv[0] = 0;
  Object call9953 = callmethod(call9952, "new",
    1, partcv, params);
  gc_frame_end(callframe9950);
// compiled call node returning call9953 (depth = 6)
// compiled member node returning call9953 (depth = 5)
  *var_suggestion = call9953;
  if (call9953 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9954 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9955 = alloc_Block(NULL, NULL, "parser", 3053);
  gc_frame_newslot(block9955);
// method _apply
  block_savedest(block9955);
  Object closure9956 = createclosure(2, "_apply");
  setclosureframe(closure9956, stackframe);
  addtoclosure(closure9956, var_lastToken);
  addtoclosure(closure9956, selfslot);
  struct UserObject *uo9956 = (struct UserObject*)block9955;
  uo9956->data[0] = (Object)closure9956;
  Method *meth_meth_parser__apply9956 = addmethod2pos(block9955, "_apply", &meth_parser__apply9956, 0);
  int argcv_meth_parser__apply9956[] = {1};
  meth_meth_parser__apply9956->type = alloc_MethodType(1, argcv_meth_parser__apply9956);
  meth_meth_parser__apply9956->definitionModule = modulename;
  meth_meth_parser__apply9956->definitionLine = 3052;
// compiled block node returning block9955 (depth = 6)
  gc_frame_newslot(block9955);
// call case 4: self request
  params[0] = block9955;
  partcv[0] = 1;
  Object call9974 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9954);
// compiled call node returning call9974 (depth = 5)
  *var_rparen = call9974;
  if (call9974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9977 = alloc_Boolean(0);
// compiled identifier node returning bool9977 (depth = 6)
  int op_slot_right_9976 = gc_frame_newslot(bool9977);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_left_9976 = gc_frame_newslot(*var_rparen);
  params[0] = bool9977;
  partcv[0] = 1;
  Object opresult9979 = callmethod(*var_rparen, "==", 1, partcv, params);
// compiled op node returning opresult9979 (depth = 5)
  Object if9975 = done;
  if (istrue(opresult9979)) {
// Begin line 3055
  setline(3055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9980 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit9981 == NULL) {
    strlit9981 = alloc_String(")");
    gc_root(strlit9981);
  }
// compiled string node returning strlit9981 (depth = 6)
  gc_frame_newslot(strlit9981);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit9981;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9982 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9980);
// compiled call node returning call9982 (depth = 5)
    gc_frame_newslot(call9982);
    if9975 = call9982;
  } else {
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9983 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9984 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9983);
// compiled call node returning call9984 (depth = 5)
    gc_frame_newslot(call9984);
    if9975 = call9984;
  }
// compiled if node returning if9975 (depth = 4)
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9985 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9986 == NULL) {
    strlit9986 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9986);
  }
// compiled string node returning strlit9986 (depth = 5)
  gc_frame_newslot(strlit9986);
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9988 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9987);
// compiled call node returning call9988 (depth = 6)
// compiled member node returning call9988 (depth = 5)
  gc_frame_newslot(call9988);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9990 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9989);
// compiled call node returning call9990 (depth = 6)
// compiled member node returning call9990 (depth = 5)
  gc_frame_newslot(call9990);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9991 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9992 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9991);
// compiled call node returning call9992 (depth = 6)
// compiled member node returning call9992 (depth = 5)
  gc_frame_newslot(call9992);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9986;
  params[1] = call9988;
  params[2] = call9990;
  params[3] = call9992;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9993 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9985);
// compiled call node returning call9993 (depth = 4)
    gc_frame_newslot(call9993);
    if9943 = call9993;
  } else {
  }
// compiled if node returning if9943 (depth = 3)
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9996 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9997 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9996);
// compiled call node returning call9997 (depth = 6)
// compiled member node returning call9997 (depth = 5)
  int op_slot_right_9995 = gc_frame_newslot(call9997);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10000 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9999);
// compiled call node returning call10000 (depth = 6)
// compiled member node returning call10000 (depth = 5)
  int op_slot_left_9995 = gc_frame_newslot(call10000);
  params[0] = call9997;
  partcv[0] = 1;
  Object opresult10001 = callmethod(call10000, "==", 1, partcv, params);
// compiled op node returning opresult10001 (depth = 4)
  Object if9994 = done;
  if (istrue(opresult10001)) {
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10002 = gc_frame_new();
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call10005 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10004);
// compiled call node returning call10005 (depth = 8)
// compiled member node returning call10005 (depth = 7)
  int op_slot_right_10003 = gc_frame_newslot(call10005);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10007 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10008 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10007);
// compiled call node returning call10008 (depth = 8)
// compiled member node returning call10008 (depth = 7)
  int op_slot_left_10003 = gc_frame_newslot(call10008);
  params[0] = call10005;
  partcv[0] = 1;
  Object diff10009 = callmethod(call10008, "-", 1, partcv, params);
// compiled op node returning diff10009 (depth = 6)
  gc_frame_newslot(diff10009);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = diff10009;
  partcv[0] = 1;
  Object call10010 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe10002);
// compiled call node returning call10010 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9994 = done;
  } else {
  }
// compiled if node returning if9994 (depth = 3)
// Begin line 3065
  setline(3065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10011 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10012 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10011);
// compiled call node returning call10012 (depth = 4)
// compiled member node returning call10012 (depth = 3)
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10015 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10016 == NULL) {
    strlit10016 = alloc_String("identifier");
    gc_root(strlit10016);
  }
// compiled string node returning strlit10016 (depth = 6)
  gc_frame_newslot(strlit10016);
// call case 4: self request
  params[0] = strlit10016;
  partcv[0] = 1;
  Object call10017 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10015);
// compiled call node returning call10017 (depth = 5)
  int op_slot_right_10014 = gc_frame_newslot(call10017);
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10020 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit10021 == NULL) {
    strlit10021 = alloc_String("identifier");
    gc_root(strlit10021);
  }
// compiled string node returning strlit10021 (depth = 7)
  gc_frame_newslot(strlit10021);
// call case 4: self request
  params[0] = strlit10021;
  partcv[0] = 1;
  Object call10022 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10020);
// compiled call node returning call10022 (depth = 6)
  int op_slot_right_10019 = gc_frame_newslot(call10022);
// starting to compile call node (depth = 6)
  int callframe10024 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call10025 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10024);
// compiled call node returning call10025 (depth = 6)
  int op_slot_left_10019 = gc_frame_newslot(call10025);
  params[0] = call10022;
  partcv[0] = 1;
  Object opresult10026 = callmethod(call10025, "&&", 1, partcv, params);
// compiled op node returning opresult10026 (depth = 5)
  int op_slot_left_10014 = gc_frame_newslot(opresult10026);
  params[0] = call10017;
  partcv[0] = 1;
  Object opresult10027 = callmethod(opresult10026, "||", 1, partcv, params);
// compiled op node returning opresult10027 (depth = 4)
  Object if10013 = done;
  if (istrue(opresult10027)) {
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10028 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile array node (depth = 6)
  Object array10029 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10029 (depth = 6)
  gc_frame_newslot(array10029);
// starting to compile identifier node (depth = 6)
  Object bool10030 = alloc_Boolean(0);
// compiled identifier node returning bool10030 (depth = 6)
  gc_frame_newslot(bool10030);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10031 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call10032 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe10031);
// compiled call node returning call10032 (depth = 7)
// compiled member node returning call10032 (depth = 6)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array10029;
  params[3] = bool10030;
  partcv[0] = 4;
  Object call10033 = callmethod(call10032, "new",
    1, partcv, params);
  gc_frame_end(callframe10028);
// compiled call node returning call10033 (depth = 5)
  *var_tm = call10033;
  if (call10033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3071
  setline(3071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10034 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tm (depth = 6)
  gc_frame_newslot(*var_tm);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sameline (depth = 6)
  gc_frame_newslot(*var_sameline);
// call case 4: self request
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call10035 = callmethodflags(self, "parsempmndecrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10034);
// compiled call node returning call10035 (depth = 5)
  *var_meth = call10035;
  if (call10035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tm (depth = 8)
  partcv[0] = 0;
  Object call10039 = callmethod(*var_tm, "varargs",
    1, partcv, params);
  gc_frame_end(callframe10038);
// compiled call node returning call10039 (depth = 7)
// compiled member node returning call10039 (depth = 6)
  int op_slot_right_10037 = gc_frame_newslot(call10039);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varargs (depth = 6)
  int op_slot_left_10037 = gc_frame_newslot(*var_varargs);
  params[0] = call10039;
  partcv[0] = 1;
  Object opresult10041 = callmethod(*var_varargs, "||", 1, partcv, params);
// compiled op node returning opresult10041 (depth = 5)
  *var_varargs = opresult10041;
  if (opresult10041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10013 = done;
  } else {
  }
// compiled if node returning if10013 (depth = 3)
    gc_frame_newslot(if10013);
    if9689 = if10013;
  } else {
  }
// compiled if node returning if9689 (depth = 2)
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10044 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10045 == NULL) {
    strlit10045 = alloc_String("arrow");
    gc_root(strlit10045);
  }
// compiled string node returning strlit10045 (depth = 4)
  gc_frame_newslot(strlit10045);
// call case 4: self request
  params[0] = strlit10045;
  partcv[0] = 1;
  Object call10046 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10044);
// compiled call node returning call10046 (depth = 3)
  Object if10043 = done;
  if (istrue(call10046)) {
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10047 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10048 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10047);
// compiled call node returning call10048 (depth = 4)
// compiled member node returning call10048 (depth = 3)
// Begin line 3078
  setline(3078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10049 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10050 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10049);
// compiled call node returning call10050 (depth = 4)
// compiled member node returning call10050 (depth = 3)
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10052 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10051);
// compiled call node returning call10052 (depth = 5)
// compiled member node returning call10052 (depth = 4)
  *var_dtype = call10052;
  if (call10052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10043 = done;
  } else {
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10054 = alloc_Boolean(0);
// compiled identifier node returning bool10054 (depth = 4)
  *var_dtype = bool10054;
  if (bool10054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10043 = done;
  }
// compiled if node returning if10043 (depth = 2)
// Begin line 3083
  setline(3083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject10056 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10056 = alloc_userobj2(10,6, objclass10056);
  gc_frame_newslot(obj10056);
// OBJECT OUTER DEC outer
  adddatum2(obj10056, self, 0);
  addmethodreal(obj10056,"outer", &reader_parser_outer_10057);
  Object oldself10056 = self;
  struct StackFrameObject *oldstackframe10056 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10056);
  gc_frame_newslot((Object)stackframe);
  self = obj10056;
  Object *oldselfslot10056 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10056 = (*(struct UserObject *)self).data[0], lowerouter10056 = thisouter10056;
  if (inheritingObject10056) {
    struct UserObject *inho10056 = (struct UserObject *)inheritingObject10056;
    while (inho10056->super != GraceDefaultObject) inho10056 = (struct UserObject *)inho10056->super;
    inho10056->super = obj10056;
    self = inheritingObject10056;
    *selfslot = self;
    lowerouter10056 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10056;
  }
if (objclass10056 == NULL) {
  Method *reader10058 = addmethodrealflags(obj10056, "m",&reader_parser_m_10058, 0);
  Method *writer10058 = addmethodrealflags(obj10056, "m:=",&writer_parser_m_10058, 0);
  reader10058->definitionModule = modulename;
  writer10058->definitionModule = modulename;
  reader10058->definitionLine = 3084;
  writer10058->definitionLine = 3084;
}
obj10056->flags |= OFLAG_MUTABLE;
adddatum2(obj10056, alloc_Undefined(), 1);
if (objclass10056 == NULL) {
  Method *reader10059 = addmethodrealflags(obj10056, "sig",&reader_parser_sig_10059, 0);
  Method *writer10059 = addmethodrealflags(obj10056, "sig:=",&writer_parser_sig_10059, 0);
  reader10059->definitionModule = modulename;
  writer10059->definitionModule = modulename;
  reader10059->definitionLine = 3085;
  writer10059->definitionLine = 3085;
}
obj10056->flags |= OFLAG_MUTABLE;
adddatum2(obj10056, alloc_Undefined(), 2);
if (objclass10056 == NULL) {
  Method *reader10060 = addmethodrealflags(obj10056, "rtype",&reader_parser_rtype_10060, 0);
  Method *writer10060 = addmethodrealflags(obj10056, "rtype:=",&writer_parser_rtype_10060, 0);
  reader10060->definitionModule = modulename;
  writer10060->definitionModule = modulename;
  reader10060->definitionLine = 3086;
  writer10060->definitionLine = 3086;
}
obj10056->flags |= OFLAG_MUTABLE;
adddatum2(obj10056, alloc_Undefined(), 3);
if (objclass10056 == NULL) {
  Method *reader10061 = addmethodrealflags(obj10056, "v",&reader_parser_v_10061, 0);
  Method *writer10061 = addmethodrealflags(obj10056, "v:=",&writer_parser_v_10061, 0);
  reader10061->definitionModule = modulename;
  writer10061->definitionModule = modulename;
  reader10061->definitionLine = 3087;
  writer10061->definitionLine = 3087;
}
obj10056->flags |= OFLAG_MUTABLE;
adddatum2(obj10056, alloc_Undefined(), 4);
if (objclass10056 == NULL) {
  Method *reader10062 = addmethodrealflags(obj10056, "generics",&reader_parser_generics_10062, 0);
  Method *writer10062 = addmethodrealflags(obj10056, "generics:=",&writer_parser_generics_10062, 0);
  reader10062->definitionModule = modulename;
  writer10062->definitionModule = modulename;
  reader10062->definitionLine = 3088;
  writer10062->definitionLine = 3088;
}
obj10056->flags |= OFLAG_MUTABLE;
adddatum2(obj10056, alloc_Undefined(), 5);
  sourceObject = obj10056;
// Begin line 3084
  setline(3084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  adddatum2(obj10056, *var_meth, 1);
  sourceObject = obj10056;
// Begin line 3085
  setline(3085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature (depth = 4)
  adddatum2(obj10056, *var_signature, 2);
  sourceObject = obj10056;
// Begin line 3086
  setline(3086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  adddatum2(obj10056, *var_dtype, 3);
  sourceObject = obj10056;
// Begin line 3087
  setline(3087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_varargs (depth = 4)
  adddatum2(obj10056, *var_varargs, 4);
  sourceObject = obj10056;
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10063 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call10064 = callmethod(*var_part, "generics",
    1, partcv, params);
  gc_frame_end(callframe10063);
// compiled call node returning call10064 (depth = 5)
// compiled member node returning call10064 (depth = 4)
  adddatum2(obj10056, call10064, 5);
  objclass10056 = obj10056->class;
  objclass10056->definitionModule = modulename;
  objclass10056->definitionLine = 3083;
  (*(struct UserObject *)self).data[0] = lowerouter10056;
  self = oldself10056;
  selfslot = oldselfslot10056;
  stackframe = oldstackframe10056;
// compiled object node returning obj10056 (depth = 3)
  *var_o = obj10056;
  if (obj10056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_o (depth = 2)
  gc_frame_end(frame);
  return *var_o;
}
Object meth_parser__apply10074(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe10075 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10076 == NULL) {
    strlit10076 = alloc_String("identifier");
    gc_root(strlit10076);
  }
// compiled string node returning strlit10076 (depth = 5)
  gc_frame_newslot(strlit10076);
// call case 4: self request
  params[0] = strlit10076;
  partcv[0] = 1;
  Object call10077 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10075);
// compiled call node returning call10077 (depth = 4)
  gc_frame_end(frame);
  return call10077;
}
Object meth_parser__apply10080(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_typeIds = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10081 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10082 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10081);
// compiled call node returning call10082 (depth = 5)
// compiled member node returning call10082 (depth = 4)
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10084 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10083);
// compiled call node returning call10084 (depth = 6)
// compiled member node returning call10084 (depth = 5)
  *var_id = call10084;
  if (call10084 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10085 = gc_frame_new();
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool10086 = alloc_Boolean(1);
// compiled identifier node returning bool10086 (depth = 6)
  gc_frame_newslot(bool10086);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = bool10086;
  partcv[0] = 1;
  Object call10087 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10085);
// compiled call node returning call10087 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10088 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call10089 = callmethod(*var_typeIds, "push",
    1, partcv, params);
  gc_frame_end(callframe10088);
// compiled call node returning call10089 (depth = 4)
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10091 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10092 == NULL) {
    strlit10092 = alloc_String("comma");
    gc_root(strlit10092);
  }
// compiled string node returning strlit10092 (depth = 6)
  gc_frame_newslot(strlit10092);
// call case 4: self request
  params[0] = strlit10092;
  partcv[0] = 1;
  Object call10093 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10091);
// compiled call node returning call10093 (depth = 5)
  Object if10090 = done;
  if (istrue(call10093)) {
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10095 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10094);
// compiled call node returning call10095 (depth = 6)
// compiled member node returning call10095 (depth = 5)
    gc_frame_newslot(call10095);
    if10090 = call10095;
  } else {
  }
// compiled if node returning if10090 (depth = 4)
  gc_frame_end(frame);
  return if10090;
}
Object meth_parser__apply10100(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10101 = gc_frame_new();
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool10102 = alloc_Boolean(1);
// compiled identifier node returning bool10102 (depth = 6)
  gc_frame_newslot(bool10102);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  params[0] = bool10102;
  partcv[0] = 1;
  Object call10103 = callmethod(*var_each, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10101);
// compiled call node returning call10103 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_typeparameters10065(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeparameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method typeparameters");
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeparameters (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for typeparameters");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeIds = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "typeIds");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 3094
  setline(3094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10066 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10067 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10066);
// compiled call node returning call10067 (depth = 3)
// compiled member node returning call10067 (depth = 2)
// Begin line 3095
  setline(3095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10068 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10069 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10070 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10069);
// compiled call node returning call10070 (depth = 6)
// compiled member node returning call10070 (depth = 5)
  partcv[0] = 0;
  Object call10071 = callmethod(call10070, "empty",
    1, partcv, params);
  gc_frame_end(callframe10068);
// compiled call node returning call10071 (depth = 4)
// compiled member node returning call10071 (depth = 3)
  *var_typeIds = call10071;
  if (call10071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10072 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10073 = alloc_Block(NULL, NULL, "parser", 3096);
  gc_frame_newslot(block10073);
// method _apply
  block_savedest(block10073);
  Object closure10074 = createclosure(1, "_apply");
  setclosureframe(closure10074, stackframe);
  addtoclosure(closure10074, selfslot);
  struct UserObject *uo10074 = (struct UserObject*)block10073;
  uo10074->data[0] = (Object)closure10074;
  Method *meth_meth_parser__apply10074 = addmethod2pos(block10073, "_apply", &meth_parser__apply10074, 0);
  int argcv_meth_parser__apply10074[] = {0};
  meth_meth_parser__apply10074->type = alloc_MethodType(1, argcv_meth_parser__apply10074);
  meth_meth_parser__apply10074->definitionModule = modulename;
  meth_meth_parser__apply10074->definitionLine = 3095;
// compiled block node returning block10073 (depth = 3)
  gc_frame_newslot(block10073);
// starting to compile block node (depth = 3)
  Object block10079 = alloc_Block(NULL, NULL, "parser", 3096);
  gc_frame_newslot(block10079);
// method _apply
  block_savedest(block10079);
  Object closure10080 = createclosure(3, "_apply");
  setclosureframe(closure10080, stackframe);
  addtoclosure(closure10080, var_values);
  addtoclosure(closure10080, var_typeIds);
  addtoclosure(closure10080, selfslot);
  struct UserObject *uo10080 = (struct UserObject*)block10079;
  uo10080->data[0] = (Object)closure10080;
  Method *meth_meth_parser__apply10080 = addmethod2pos(block10079, "_apply", &meth_parser__apply10080, 0);
  int argcv_meth_parser__apply10080[] = {0};
  meth_meth_parser__apply10080->type = alloc_MethodType(1, argcv_meth_parser__apply10080);
  meth_meth_parser__apply10080->definitionModule = modulename;
  meth_meth_parser__apply10080->definitionLine = 3095;
// compiled block node returning block10079 (depth = 3)
  gc_frame_newslot(block10079);
// call case 5: prelude request
  params[0] = block10073;
  params[1] = block10079;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10097 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10072);
// compiled call node returning call10097 (depth = 2)
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10098 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10099 = alloc_Block(NULL, NULL, "parser", 3105);
  gc_frame_newslot(block10099);
// method _apply
  block_savedest(block10099);
  Object closure10100 = createclosure(1, "_apply");
  setclosureframe(closure10100, stackframe);
  addtoclosure(closure10100, selfslot);
  struct UserObject *uo10100 = (struct UserObject*)block10099;
  uo10100->data[0] = (Object)closure10100;
  Method *meth_meth_parser__apply10100 = addmethod2pos(block10099, "_apply", &meth_parser__apply10100, 0);
  int argcv_meth_parser__apply10100[] = {1};
  meth_meth_parser__apply10100->type = alloc_MethodType(1, argcv_meth_parser__apply10100);
  meth_meth_parser__apply10100->definitionModule = modulename;
  meth_meth_parser__apply10100->definitionLine = 3102;
// compiled block node returning block10099 (depth = 3)
  gc_frame_newslot(block10099);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeIds (depth = 3)
  params[0] = block10099;
  partcv[0] = 1;
  Object call10105 = callmethod(*var_typeIds, "do",
    1, partcv, params);
  gc_frame_end(callframe10098);
// compiled call node returning call10105 (depth = 2)
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10106 = gc_frame_new();
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10107 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  gc_frame_newslot(*var_typeIds);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10109 = callmethod(*var_ast, "typeParametersNode",
    1, partcv, params);
  gc_frame_end(callframe10108);
// compiled call node returning call10109 (depth = 6)
// compiled member node returning call10109 (depth = 5)
  params[0] = *var_typeIds;
  partcv[0] = 1;
  Object call10110 = callmethod(call10109, "new",
    1, partcv, params);
  gc_frame_end(callframe10107);
// compiled call node returning call10110 (depth = 4)
  gc_frame_newslot(call10110);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  params[0] = call10110;
  partcv[0] = 1;
  Object call10111 = callmethod(*var_node, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10106);
// compiled call node returning call10111 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10114 == NULL) {
    strlit10114 = alloc_String("rgeneric");
    gc_root(strlit10114);
  }
// compiled string node returning strlit10114 (depth = 4)
  int op_slot_right_10113 = gc_frame_newslot(strlit10114);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10117 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10116);
// compiled call node returning call10117 (depth = 5)
// compiled member node returning call10117 (depth = 4)
  int op_slot_left_10113 = gc_frame_newslot(call10117);
  params[0] = strlit10114;
  partcv[0] = 1;
  Object opresult10118 = callmethod(call10117, "!=", 1, partcv, params);
// compiled op node returning opresult10118 (depth = 3)
  Object if10112 = done;
  if (istrue(opresult10118)) {
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10119 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10120 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call10121 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10120);
// compiled call node returning call10121 (depth = 7)
// compiled member node returning call10121 (depth = 6)
  partcv[0] = 0;
  Object call10122 = callmethod(call10121, "new",
    1, partcv, params);
  gc_frame_end(callframe10119);
// compiled call node returning call10122 (depth = 5)
// compiled member node returning call10122 (depth = 4)
  *var_suggestion = call10122;
  if (call10122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10123 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10124 == NULL) {
    strlit10124 = alloc_String(">");
    gc_root(strlit10124);
  }
// compiled string node returning strlit10124 (depth = 4)
  gc_frame_newslot(strlit10124);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit10124;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10125 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10123);
// compiled call node returning call10125 (depth = 3)
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10126 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10127 == NULL) {
    strlit10127 = alloc_String("A list of type parameters starting with '<' must end with '>'.");
    gc_root(strlit10127);
  }
// compiled string node returning strlit10127 (depth = 4)
  gc_frame_newslot(strlit10127);
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call10129 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10128);
// compiled call node returning call10129 (depth = 5)
// compiled member node returning call10129 (depth = 4)
  gc_frame_newslot(call10129);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10131 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10132 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10131);
// compiled call node returning call10132 (depth = 6)
// compiled member node returning call10132 (depth = 5)
  int op_slot_right_10130 = gc_frame_newslot(call10132);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10135 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10134);
// compiled call node returning call10135 (depth = 6)
// compiled member node returning call10135 (depth = 5)
  int op_slot_left_10130 = gc_frame_newslot(call10135);
  params[0] = call10132;
  partcv[0] = 1;
  Object sum10136 = callmethod(call10135, "+", 1, partcv, params);
// compiled op node returning sum10136 (depth = 4)
  gc_frame_newslot(sum10136);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10127;
  params[1] = call10129;
  params[2] = sum10136;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10137 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10126);
// compiled call node returning call10137 (depth = 3)
    gc_frame_newslot(call10137);
    if10112 = call10137;
  } else {
  }
// compiled if node returning if10112 (depth = 2)
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10139 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10138);
// compiled call node returning call10139 (depth = 3)
// compiled member node returning call10139 (depth = 2)
  gc_frame_end(frame);
  return call10139;
}
Object meth_parser_doimport10140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_defaultDefVisibility = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doimport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doimport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_importline = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importline");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_errorPos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errorPos");
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
  Object *var_name = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "name");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10144 == NULL) {
    strlit10144 = alloc_String("import");
    gc_root(strlit10144);
  }
// compiled string node returning strlit10144 (depth = 5)
  int op_slot_right_10143 = gc_frame_newslot(strlit10144);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10147 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10146);
// compiled call node returning call10147 (depth = 6)
// compiled member node returning call10147 (depth = 5)
  int op_slot_left_10143 = gc_frame_newslot(call10147);
  params[0] = strlit10144;
  partcv[0] = 1;
  Object opresult10148 = callmethod(call10147, "==", 1, partcv, params);
// compiled op node returning opresult10148 (depth = 4)
  int op_slot_right_10142 = gc_frame_newslot(opresult10148);
// starting to compile call node (depth = 4)
  int callframe10150 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10151 == NULL) {
    strlit10151 = alloc_String("keyword");
    gc_root(strlit10151);
  }
// compiled string node returning strlit10151 (depth = 5)
  gc_frame_newslot(strlit10151);
// call case 4: self request
  params[0] = strlit10151;
  partcv[0] = 1;
  Object call10152 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10150);
// compiled call node returning call10152 (depth = 4)
  int op_slot_left_10142 = gc_frame_newslot(call10152);
  params[0] = opresult10148;
  partcv[0] = 1;
  Object opresult10153 = callmethod(call10152, "&&", 1, partcv, params);
// compiled op node returning opresult10153 (depth = 3)
  Object if10141 = done;
  if (istrue(opresult10153)) {
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10155 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10154);
// compiled call node returning call10155 (depth = 5)
// compiled member node returning call10155 (depth = 4)
  *var_importline = call10155;
  if (call10155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3121
  setline(3121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10156 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10157 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10156);
// compiled call node returning call10157 (depth = 4)
// compiled member node returning call10157 (depth = 3)
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10160 == NULL) {
    strlit10160 = alloc_String("string");
    gc_root(strlit10160);
  }
// compiled string node returning strlit10160 (depth = 5)
  int op_slot_right_10159 = gc_frame_newslot(strlit10160);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10162 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10163 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10162);
// compiled call node returning call10163 (depth = 6)
// compiled member node returning call10163 (depth = 5)
  int op_slot_left_10159 = gc_frame_newslot(call10163);
  params[0] = strlit10160;
  partcv[0] = 1;
  Object opresult10164 = callmethod(call10163, "!=", 1, partcv, params);
// compiled op node returning opresult10164 (depth = 4)
  Object if10158 = done;
  if (istrue(opresult10164)) {
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10165 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10166 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10167 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10166);
// compiled call node returning call10167 (depth = 8)
// compiled member node returning call10167 (depth = 7)
  partcv[0] = 0;
  Object call10168 = callmethod(call10167, "new",
    1, partcv, params);
  gc_frame_end(callframe10165);
// compiled call node returning call10168 (depth = 6)
// compiled member node returning call10168 (depth = 5)
  *var_suggestion = call10168;
  if (call10168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3125
  setline(3125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10173 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10172);
// compiled call node returning call10173 (depth = 8)
// compiled member node returning call10173 (depth = 7)
  int op_slot_right_10171 = gc_frame_newslot(call10173);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10176 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10175);
// compiled call node returning call10176 (depth = 8)
// compiled member node returning call10176 (depth = 7)
  int op_slot_left_10171 = gc_frame_newslot(call10176);
  params[0] = call10173;
  partcv[0] = 1;
  Object opresult10177 = callmethod(call10176, "==", 1, partcv, params);
// compiled op node returning opresult10177 (depth = 6)
  int op_slot_right_10170 = gc_frame_newslot(opresult10177);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10180 == NULL) {
    strlit10180 = alloc_String("identifier");
    gc_root(strlit10180);
  }
// compiled string node returning strlit10180 (depth = 7)
  int op_slot_right_10179 = gc_frame_newslot(strlit10180);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10183 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10182);
// compiled call node returning call10183 (depth = 8)
// compiled member node returning call10183 (depth = 7)
  int op_slot_left_10179 = gc_frame_newslot(call10183);
  params[0] = strlit10180;
  partcv[0] = 1;
  Object opresult10184 = callmethod(call10183, "==", 1, partcv, params);
// compiled op node returning opresult10184 (depth = 6)
  int op_slot_left_10170 = gc_frame_newslot(opresult10184);
  params[0] = opresult10177;
  partcv[0] = 1;
  Object opresult10185 = callmethod(opresult10184, "&&", 1, partcv, params);
// compiled op node returning opresult10185 (depth = 5)
  Object if10169 = done;
  if (istrue(opresult10185)) {
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10186 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10188 == NULL) {
    strlit10188 = alloc_String("""\x22""");
    gc_root(strlit10188);
  }
// compiled string node returning strlit10188 (depth = 7)
  int op_slot_right_10187 = gc_frame_newslot(strlit10188);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10191 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10192 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10191);
// compiled call node returning call10192 (depth = 9)
// compiled member node returning call10192 (depth = 8)
  int op_slot_right_10190 = gc_frame_newslot(call10192);
// starting to compile string node (depth = 8)
  if (strlit10194 == NULL) {
    strlit10194 = alloc_String("""\x22""");
    gc_root(strlit10194);
  }
// compiled string node returning strlit10194 (depth = 8)
  int op_slot_left_10190 = gc_frame_newslot(strlit10194);
  params[0] = call10192;
  partcv[0] = 1;
  Object opresult10195 = callmethod(strlit10194, "++", 1, partcv, params);
// compiled op node returning opresult10195 (depth = 7)
  int op_slot_left_10187 = gc_frame_newslot(opresult10195);
  params[0] = strlit10188;
  partcv[0] = 1;
  Object opresult10196 = callmethod(opresult10195, "++", 1, partcv, params);
// compiled op node returning opresult10196 (depth = 6)
  gc_frame_newslot(opresult10196);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult10196;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10197 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10186);
// compiled call node returning call10197 (depth = 5)
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10199 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10198);
// compiled call node returning call10199 (depth = 7)
// compiled member node returning call10199 (depth = 6)
  *var_errorPos = call10199;
  if (call10199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10169 = done;
  } else {
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10201 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10202 == NULL) {
    strlit10202 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit10202);
  }
// compiled string node returning strlit10202 (depth = 6)
  gc_frame_newslot(strlit10202);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit10202;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10203 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10201);
// compiled call node returning call10203 (depth = 5)
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10205 = alloc_Float64(1);
// compiled num node returning num10205 (depth = 7)
  int op_slot_right_10204 = gc_frame_newslot(num10205);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10209 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10208);
// compiled call node returning call10209 (depth = 9)
// compiled member node returning call10209 (depth = 8)
  int op_slot_right_10207 = gc_frame_newslot(call10209);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10212 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10211);
// compiled call node returning call10212 (depth = 9)
// compiled member node returning call10212 (depth = 8)
  int op_slot_left_10207 = gc_frame_newslot(call10212);
  params[0] = call10209;
  partcv[0] = 1;
  Object sum10213 = callmethod(call10212, "+", 1, partcv, params);
// compiled op node returning sum10213 (depth = 7)
  int op_slot_left_10204 = gc_frame_newslot(sum10213);
  params[0] = num10205;
  partcv[0] = 1;
  Object sum10214 = callmethod(sum10213, "+", 1, partcv, params);
// compiled op node returning sum10214 (depth = 6)
  *var_errorPos = sum10214;
  if (sum10214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10169 = done;
  }
// compiled if node returning if10169 (depth = 4)
// Begin line 3132
  setline(3132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10216 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10217 == NULL) {
    strlit10217 = alloc_String("An import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit10217);
  }
// compiled string node returning strlit10217 (depth = 5)
  gc_frame_newslot(strlit10217);
// Begin line 3133
  setline(3133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10218 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10219 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10218);
// compiled call node returning call10219 (depth = 6)
// compiled member node returning call10219 (depth = 5)
  gc_frame_newslot(call10219);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3132
  setline(3132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10217;
  params[1] = call10219;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10220 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10216);
// compiled call node returning call10220 (depth = 4)
    gc_frame_newslot(call10220);
    if10158 = call10220;
  } else {
  }
// compiled if node returning if10158 (depth = 3)
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10221 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10222 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10221);
// compiled call node returning call10222 (depth = 4)
// compiled member node returning call10222 (depth = 3)
// Begin line 3136
  setline(3136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10224 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10223);
// compiled call node returning call10224 (depth = 5)
// compiled member node returning call10224 (depth = 4)
  *var_p = call10224;
  if (call10224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3137
  setline(3137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10228 == NULL) {
    strlit10228 = alloc_String("as");
    gc_root(strlit10228);
  }
// compiled string node returning strlit10228 (depth = 6)
  int op_slot_right_10227 = gc_frame_newslot(strlit10228);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10231 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10230);
// compiled call node returning call10231 (depth = 7)
// compiled member node returning call10231 (depth = 6)
  int op_slot_left_10227 = gc_frame_newslot(call10231);
  params[0] = strlit10228;
  partcv[0] = 1;
  Object opresult10232 = callmethod(call10231, "!=", 1, partcv, params);
// compiled op node returning opresult10232 (depth = 5)
  int op_slot_right_10226 = gc_frame_newslot(opresult10232);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10235 == NULL) {
    strlit10235 = alloc_String("identifier");
    gc_root(strlit10235);
  }
// compiled string node returning strlit10235 (depth = 6)
  int op_slot_right_10234 = gc_frame_newslot(strlit10235);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10237 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10238 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10237);
// compiled call node returning call10238 (depth = 7)
// compiled member node returning call10238 (depth = 6)
  int op_slot_left_10234 = gc_frame_newslot(call10238);
  params[0] = strlit10235;
  partcv[0] = 1;
  Object opresult10239 = callmethod(call10238, "!=", 1, partcv, params);
// compiled op node returning opresult10239 (depth = 5)
  int op_slot_left_10226 = gc_frame_newslot(opresult10239);
  params[0] = opresult10232;
  partcv[0] = 1;
  Object opresult10240 = callmethod(opresult10239, "||", 1, partcv, params);
// compiled op node returning opresult10240 (depth = 4)
  Object if10225 = done;
  if (istrue(opresult10240)) {
// Begin line 3138
  setline(3138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10241 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10243 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10242);
// compiled call node returning call10243 (depth = 8)
// compiled member node returning call10243 (depth = 7)
  partcv[0] = 0;
  Object call10244 = callmethod(call10243, "new",
    1, partcv, params);
  gc_frame_end(callframe10241);
// compiled call node returning call10244 (depth = 6)
// compiled member node returning call10244 (depth = 5)
  *var_suggestion = call10244;
  if (call10244 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10248 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10249 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10248);
// compiled call node returning call10249 (depth = 8)
// compiled member node returning call10249 (depth = 7)
  int op_slot_right_10247 = gc_frame_newslot(call10249);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10251 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10252 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10251);
// compiled call node returning call10252 (depth = 8)
// compiled member node returning call10252 (depth = 7)
  int op_slot_left_10247 = gc_frame_newslot(call10252);
  params[0] = call10249;
  partcv[0] = 1;
  Object opresult10253 = callmethod(call10252, "==", 1, partcv, params);
// compiled op node returning opresult10253 (depth = 6)
  int op_slot_right_10246 = gc_frame_newslot(opresult10253);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10256 == NULL) {
    strlit10256 = alloc_String("identifier");
    gc_root(strlit10256);
  }
// compiled string node returning strlit10256 (depth = 7)
  int op_slot_right_10255 = gc_frame_newslot(strlit10256);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10258 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10259 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10258);
// compiled call node returning call10259 (depth = 8)
// compiled member node returning call10259 (depth = 7)
  int op_slot_left_10255 = gc_frame_newslot(call10259);
  params[0] = strlit10256;
  partcv[0] = 1;
  Object opresult10260 = callmethod(call10259, "==", 1, partcv, params);
// compiled op node returning opresult10260 (depth = 6)
  int op_slot_left_10246 = gc_frame_newslot(opresult10260);
  params[0] = opresult10253;
  partcv[0] = 1;
  Object opresult10261 = callmethod(opresult10260, "&&", 1, partcv, params);
// compiled op node returning opresult10261 (depth = 5)
  Object if10245 = done;
  if (istrue(opresult10261)) {
// Begin line 3140
  setline(3140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10262 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10263 == NULL) {
    strlit10263 = alloc_String(" as");
    gc_root(strlit10263);
  }
// compiled string node returning strlit10263 (depth = 6)
  gc_frame_newslot(strlit10263);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit10263;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10264 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10262);
// compiled call node returning call10264 (depth = 5)
    gc_frame_newslot(call10264);
    if10245 = call10264;
  } else {
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10265 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10267 == NULL) {
    strlit10267 = alloc_String("");
    gc_root(strlit10267);
  }
// compiled string node returning strlit10267 (depth = 7)
  int op_slot_right_10266 = gc_frame_newslot(strlit10267);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10270 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call10271 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10270);
// compiled call node returning call10271 (depth = 9)
// compiled member node returning call10271 (depth = 8)
  int op_slot_right_10269 = gc_frame_newslot(call10271);
// starting to compile string node (depth = 8)
  if (strlit10273 == NULL) {
    strlit10273 = alloc_String(" as ");
    gc_root(strlit10273);
  }
// compiled string node returning strlit10273 (depth = 8)
  int op_slot_left_10269 = gc_frame_newslot(strlit10273);
  params[0] = call10271;
  partcv[0] = 1;
  Object opresult10274 = callmethod(strlit10273, "++", 1, partcv, params);
// compiled op node returning opresult10274 (depth = 7)
  int op_slot_left_10266 = gc_frame_newslot(opresult10274);
  params[0] = strlit10267;
  partcv[0] = 1;
  Object opresult10275 = callmethod(opresult10274, "++", 1, partcv, params);
// compiled op node returning opresult10275 (depth = 6)
  gc_frame_newslot(opresult10275);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult10275;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10276 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10265);
// compiled call node returning call10276 (depth = 5)
    gc_frame_newslot(call10276);
    if10245 = call10276;
  }
// compiled if node returning if10245 (depth = 4)
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10277 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10278 == NULL) {
    strlit10278 = alloc_String("An import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit10278);
  }
// compiled string node returning strlit10278 (depth = 5)
  gc_frame_newslot(strlit10278);
// Begin line 3145
  setline(3145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10280 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10279);
// compiled call node returning call10280 (depth = 6)
// compiled member node returning call10280 (depth = 5)
  gc_frame_newslot(call10280);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10282 = alloc_Float64(1);
// compiled num node returning num10282 (depth = 6)
  int op_slot_right_10281 = gc_frame_newslot(num10282);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10285 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10286 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10285);
// compiled call node returning call10286 (depth = 8)
// compiled member node returning call10286 (depth = 7)
  int op_slot_right_10284 = gc_frame_newslot(call10286);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10288 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10289 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10288);
// compiled call node returning call10289 (depth = 8)
// compiled member node returning call10289 (depth = 7)
  int op_slot_left_10284 = gc_frame_newslot(call10289);
  params[0] = call10286;
  partcv[0] = 1;
  Object sum10290 = callmethod(call10289, "+", 1, partcv, params);
// compiled op node returning sum10290 (depth = 6)
  int op_slot_left_10281 = gc_frame_newslot(sum10290);
  params[0] = num10282;
  partcv[0] = 1;
  Object sum10291 = callmethod(sum10290, "+", 1, partcv, params);
// compiled op node returning sum10291 (depth = 5)
  gc_frame_newslot(sum10291);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10278;
  params[1] = call10280;
  params[2] = sum10291;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10292 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10277);
// compiled call node returning call10292 (depth = 4)
    gc_frame_newslot(call10292);
    if10225 = call10292;
  } else {
  }
// compiled if node returning if10225 (depth = 3)
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10294 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10293);
// compiled call node returning call10294 (depth = 4)
// compiled member node returning call10294 (depth = 3)
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10297 == NULL) {
    strlit10297 = alloc_String("identifier");
    gc_root(strlit10297);
  }
// compiled string node returning strlit10297 (depth = 5)
  int op_slot_right_10296 = gc_frame_newslot(strlit10297);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10300 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10299);
// compiled call node returning call10300 (depth = 6)
// compiled member node returning call10300 (depth = 5)
  int op_slot_left_10296 = gc_frame_newslot(call10300);
  params[0] = strlit10297;
  partcv[0] = 1;
  Object opresult10301 = callmethod(call10300, "!=", 1, partcv, params);
// compiled op node returning opresult10301 (depth = 4)
  Object if10295 = done;
  if (istrue(opresult10301)) {
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10302 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10303 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10304 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10303);
// compiled call node returning call10304 (depth = 8)
// compiled member node returning call10304 (depth = 7)
  partcv[0] = 0;
  Object call10305 = callmethod(call10304, "new",
    1, partcv, params);
  gc_frame_end(callframe10302);
// compiled call node returning call10305 (depth = 6)
// compiled member node returning call10305 (depth = 5)
  *var_suggestion = call10305;
  if (call10305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3151
  setline(3151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10309 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10310 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10309);
// compiled call node returning call10310 (depth = 8)
// compiled member node returning call10310 (depth = 7)
  int op_slot_right_10308 = gc_frame_newslot(call10310);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10312 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10313 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10312);
// compiled call node returning call10313 (depth = 8)
// compiled member node returning call10313 (depth = 7)
  int op_slot_left_10308 = gc_frame_newslot(call10313);
  params[0] = call10310;
  partcv[0] = 1;
  Object opresult10314 = callmethod(call10313, "==", 1, partcv, params);
// compiled op node returning opresult10314 (depth = 6)
  int op_slot_right_10307 = gc_frame_newslot(opresult10314);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10317 == NULL) {
    strlit10317 = alloc_String("string");
    gc_root(strlit10317);
  }
// compiled string node returning strlit10317 (depth = 7)
  int op_slot_right_10316 = gc_frame_newslot(strlit10317);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10320 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10319);
// compiled call node returning call10320 (depth = 8)
// compiled member node returning call10320 (depth = 7)
  int op_slot_left_10316 = gc_frame_newslot(call10320);
  params[0] = strlit10317;
  partcv[0] = 1;
  Object opresult10321 = callmethod(call10320, "==", 1, partcv, params);
// compiled op node returning opresult10321 (depth = 6)
  int op_slot_left_10307 = gc_frame_newslot(opresult10321);
  params[0] = opresult10314;
  partcv[0] = 1;
  Object opresult10322 = callmethod(opresult10321, "&&", 1, partcv, params);
// compiled op node returning opresult10322 (depth = 5)
  Object if10306 = done;
  if (istrue(opresult10322)) {
// Begin line 3152
  setline(3152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10323 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10325 == NULL) {
    strlit10325 = alloc_String("");
    gc_root(strlit10325);
  }
// compiled string node returning strlit10325 (depth = 7)
  int op_slot_right_10324 = gc_frame_newslot(strlit10325);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10329 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10328);
// compiled call node returning call10329 (depth = 9)
// compiled member node returning call10329 (depth = 8)
  int op_slot_right_10327 = gc_frame_newslot(call10329);
// starting to compile string node (depth = 8)
  if (strlit10331 == NULL) {
    strlit10331 = alloc_String("");
    gc_root(strlit10331);
  }
// compiled string node returning strlit10331 (depth = 8)
  int op_slot_left_10327 = gc_frame_newslot(strlit10331);
  params[0] = call10329;
  partcv[0] = 1;
  Object opresult10332 = callmethod(strlit10331, "++", 1, partcv, params);
// compiled op node returning opresult10332 (depth = 7)
  int op_slot_left_10324 = gc_frame_newslot(opresult10332);
  params[0] = strlit10325;
  partcv[0] = 1;
  Object opresult10333 = callmethod(opresult10332, "++", 1, partcv, params);
// compiled op node returning opresult10333 (depth = 6)
  gc_frame_newslot(opresult10333);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult10333;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10334 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10323);
// compiled call node returning call10334 (depth = 5)
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10336 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10335);
// compiled call node returning call10336 (depth = 7)
// compiled member node returning call10336 (depth = 6)
  *var_errorPos = call10336;
  if (call10336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10306 = done;
  } else {
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10338 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10340 == NULL) {
    strlit10340 = alloc_String("");
    gc_root(strlit10340);
  }
// compiled string node returning strlit10340 (depth = 7)
  int op_slot_right_10339 = gc_frame_newslot(strlit10340);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call10344 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10343);
// compiled call node returning call10344 (depth = 9)
// compiled member node returning call10344 (depth = 8)
  int op_slot_right_10342 = gc_frame_newslot(call10344);
// starting to compile string node (depth = 8)
  if (strlit10346 == NULL) {
    strlit10346 = alloc_String(" ");
    gc_root(strlit10346);
  }
// compiled string node returning strlit10346 (depth = 8)
  int op_slot_left_10342 = gc_frame_newslot(strlit10346);
  params[0] = call10344;
  partcv[0] = 1;
  Object opresult10347 = callmethod(strlit10346, "++", 1, partcv, params);
// compiled op node returning opresult10347 (depth = 7)
  int op_slot_left_10339 = gc_frame_newslot(opresult10347);
  params[0] = strlit10340;
  partcv[0] = 1;
  Object opresult10348 = callmethod(opresult10347, "++", 1, partcv, params);
// compiled op node returning opresult10348 (depth = 6)
  gc_frame_newslot(opresult10348);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult10348;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10349 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10338);
// compiled call node returning call10349 (depth = 5)
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10351 = alloc_Float64(1);
// compiled num node returning num10351 (depth = 7)
  int op_slot_right_10350 = gc_frame_newslot(num10351);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10354 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10355 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10354);
// compiled call node returning call10355 (depth = 9)
// compiled member node returning call10355 (depth = 8)
  int op_slot_right_10353 = gc_frame_newslot(call10355);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10358 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10357);
// compiled call node returning call10358 (depth = 9)
// compiled member node returning call10358 (depth = 8)
  int op_slot_left_10353 = gc_frame_newslot(call10358);
  params[0] = call10355;
  partcv[0] = 1;
  Object sum10359 = callmethod(call10358, "+", 1, partcv, params);
// compiled op node returning sum10359 (depth = 7)
  int op_slot_left_10350 = gc_frame_newslot(sum10359);
  params[0] = num10351;
  partcv[0] = 1;
  Object sum10360 = callmethod(sum10359, "+", 1, partcv, params);
// compiled op node returning sum10360 (depth = 6)
  *var_errorPos = sum10360;
  if (sum10360 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10306 = done;
  }
// compiled if node returning if10306 (depth = 4)
// Begin line 3158
  setline(3158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10362 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10363 == NULL) {
    strlit10363 = alloc_String("An import statement must have an identifier after 'as'.");
    gc_root(strlit10363);
  }
// compiled string node returning strlit10363 (depth = 5)
  gc_frame_newslot(strlit10363);
// Begin line 3159
  setline(3159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10364 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10365 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10364);
// compiled call node returning call10365 (depth = 6)
// compiled member node returning call10365 (depth = 5)
  gc_frame_newslot(call10365);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3158
  setline(3158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10363;
  params[1] = call10365;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10366 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10362);
// compiled call node returning call10366 (depth = 4)
    gc_frame_newslot(call10366);
    if10295 = call10366;
  } else {
  }
// compiled if node returning if10295 (depth = 3)
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10367 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10368 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10367);
// compiled call node returning call10368 (depth = 4)
// compiled member node returning call10368 (depth = 3)
// Begin line 3162
  setline(3162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10370 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10369);
// compiled call node returning call10370 (depth = 5)
// compiled member node returning call10370 (depth = 4)
  *var_name = call10370;
  if (call10370 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3162
  setline(3162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10371 = gc_frame_new();
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool10372 = alloc_Boolean(1);
// compiled identifier node returning bool10372 (depth = 5)
  gc_frame_newslot(bool10372);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  params[0] = bool10372;
  partcv[0] = 1;
  Object call10373 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10371);
// compiled call node returning call10373 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10374 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10375 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10374);
// compiled call node returning call10375 (depth = 5)
// compiled member node returning call10375 (depth = 4)
  *var_dtype = call10375;
  if (call10375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3165
  setline(3165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10376 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_importline (depth = 4)
  gc_frame_newslot(*var_importline);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_importline;
  partcv[0] = 1;
  Object call10377 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe10376);
// compiled call node returning call10377 (depth = 3)
// Begin line 3166
  setline(3166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10378 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10379 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call10380 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10379);
// compiled call node returning call10380 (depth = 6)
// compiled member node returning call10380 (depth = 5)
  gc_frame_newslot(call10380);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10382 = callmethod(*var_ast, "importNode",
    1, partcv, params);
  gc_frame_end(callframe10381);
// compiled call node returning call10382 (depth = 6)
// compiled member node returning call10382 (depth = 5)
  params[0] = call10380;
  params[1] = *var_name;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call10383 = callmethod(call10382, "new",
    1, partcv, params);
  gc_frame_end(callframe10378);
// compiled call node returning call10383 (depth = 4)
  *var_o = call10383;
  if (call10383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3167
  setline(3167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10385 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10384);
// compiled call node returning call10385 (depth = 5)
// compiled member node returning call10385 (depth = 4)
  *var_anns = call10385;
  if (call10385 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3168
  setline(3168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool10388 = alloc_Boolean(0);
// compiled identifier node returning bool10388 (depth = 5)
  int op_slot_right_10387 = gc_frame_newslot(bool10388);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_10387 = gc_frame_newslot(*var_anns);
  params[0] = bool10388;
  partcv[0] = 1;
  Object opresult10390 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult10390 (depth = 4)
  Object if10386 = done;
  if (istrue(opresult10390)) {
// starting to compile call node (depth = 4)
  int callframe10391 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10392 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call10393 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe10392);
// compiled call node returning call10393 (depth = 6)
// compiled member node returning call10393 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call10394 = callmethod(call10393, "addAll",
    1, partcv, params);
  gc_frame_end(callframe10391);
// compiled call node returning call10394 (depth = 4)
    gc_frame_newslot(call10394);
    if10386 = call10394;
  } else {
  }
// compiled if node returning if10386 (depth = 3)
// Begin line 3169
  setline(3169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10395 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultDefVisibility (depth = 4)
  gc_frame_newslot(*var_defaultDefVisibility);
// starting to compile string node (depth = 4)
  if (strlit10396 == NULL) {
    strlit10396 = alloc_String("confidential");
    gc_root(strlit10396);
  }
// compiled string node returning strlit10396 (depth = 4)
  gc_frame_newslot(strlit10396);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultDefVisibility;
  params[2] = strlit10396;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10397 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10395);
// compiled call node returning call10397 (depth = 3)
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10398 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10399 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10398);
// compiled call node returning call10399 (depth = 3)
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10400 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10401 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10400);
// compiled call node returning call10401 (depth = 4)
// compiled member node returning call10401 (depth = 3)
    gc_frame_newslot(call10401);
    if10141 = call10401;
  } else {
  }
// compiled if node returning if10141 (depth = 2)
  gc_frame_end(frame);
  return if10141;
}
Object meth_parser__apply10421(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10422 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe10423 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit10424 == NULL) {
    strlit10424 = alloc_String("rbrace");
    gc_root(strlit10424);
  }
// compiled string node returning strlit10424 (depth = 9)
  gc_frame_newslot(strlit10424);
// call case 4: self request
  params[0] = strlit10424;
  partcv[0] = 1;
  Object call10425 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10423);
// compiled call node returning call10425 (depth = 8)
  partcv[0] = 0;
  Object call10426 = callmethod(call10425, "not",
    1, partcv, params);
  gc_frame_end(callframe10422);
// compiled call node returning call10426 (depth = 7)
// compiled member node returning call10426 (depth = 6)
  gc_frame_end(frame);
  return call10426;
}
Object meth_parser__apply10435(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe10436 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10437 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10436);
// compiled call node returning call10437 (depth = 9)
  gc_frame_end(frame);
  return call10437;
}
Object meth_parser_doreturn10402(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doreturn (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doreturn");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_retTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retTok");
  Object *var_retval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "retval");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10406 == NULL) {
    strlit10406 = alloc_String("return");
    gc_root(strlit10406);
  }
// compiled string node returning strlit10406 (depth = 5)
  int op_slot_right_10405 = gc_frame_newslot(strlit10406);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10408 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10409 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10408);
// compiled call node returning call10409 (depth = 6)
// compiled member node returning call10409 (depth = 5)
  int op_slot_left_10405 = gc_frame_newslot(call10409);
  params[0] = strlit10406;
  partcv[0] = 1;
  Object opresult10410 = callmethod(call10409, "==", 1, partcv, params);
// compiled op node returning opresult10410 (depth = 4)
  int op_slot_right_10404 = gc_frame_newslot(opresult10410);
// starting to compile call node (depth = 4)
  int callframe10412 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10413 == NULL) {
    strlit10413 = alloc_String("keyword");
    gc_root(strlit10413);
  }
// compiled string node returning strlit10413 (depth = 5)
  gc_frame_newslot(strlit10413);
// call case 4: self request
  params[0] = strlit10413;
  partcv[0] = 1;
  Object call10414 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10412);
// compiled call node returning call10414 (depth = 4)
  int op_slot_left_10404 = gc_frame_newslot(call10414);
  params[0] = opresult10410;
  partcv[0] = 1;
  Object opresult10415 = callmethod(call10414, "&&", 1, partcv, params);
// compiled op node returning opresult10415 (depth = 3)
  Object if10403 = done;
  if (istrue(opresult10415)) {
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_retTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10417 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10416);
// compiled call node returning call10417 (depth = 4)
// compiled member node returning call10417 (depth = 3)
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_retval = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10419 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10420 = alloc_Block(NULL, NULL, "parser", 3181);
  gc_frame_newslot(block10420);
// method _apply
  block_savedest(block10420);
  Object closure10421 = createclosure(1, "_apply");
  setclosureframe(closure10421, stackframe);
  addtoclosure(closure10421, selfslot);
  struct UserObject *uo10421 = (struct UserObject*)block10420;
  uo10421->data[0] = (Object)closure10421;
  Method *meth_meth_parser__apply10421 = addmethod2pos(block10420, "_apply", &meth_parser__apply10421, 0);
  int argcv_meth_parser__apply10421[] = {0};
  meth_meth_parser__apply10421->type = alloc_MethodType(1, argcv_meth_parser__apply10421);
  meth_meth_parser__apply10421->definitionModule = modulename;
  meth_meth_parser__apply10421->definitionLine = 3179;
// compiled block node returning block10420 (depth = 5)
  gc_frame_newslot(block10420);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10428 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10429 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10428);
// compiled call node returning call10429 (depth = 6)
// compiled member node returning call10429 (depth = 5)
  params[0] = block10420;
  partcv[0] = 1;
  Object call10430 = callmethod(call10429, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe10419);
// compiled call node returning call10430 (depth = 4)
  Object if10418 = done;
  if (istrue(call10430)) {
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10432 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10433 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block10434 = alloc_Block(NULL, NULL, "parser", 3182);
  gc_frame_newslot(block10434);
// method _apply
  block_savedest(block10434);
  Object closure10435 = createclosure(2, "_apply");
  setclosureframe(closure10435, stackframe);
  addtoclosure(closure10435, var_blocksOK);
  addtoclosure(closure10435, selfslot);
  struct UserObject *uo10435 = (struct UserObject*)block10434;
  uo10435->data[0] = (Object)closure10435;
  Method *meth_meth_parser__apply10435 = addmethod2pos(block10434, "_apply", &meth_parser__apply10435, 0);
  int argcv_meth_parser__apply10435[] = {0};
  meth_meth_parser__apply10435->type = alloc_MethodType(1, argcv_meth_parser__apply10435);
  meth_meth_parser__apply10435->definitionModule = modulename;
  meth_meth_parser__apply10435->definitionLine = 3182;
// compiled block node returning block10434 (depth = 8)
  gc_frame_newslot(block10434);
// call case 4: self request
  params[0] = block10434;
  partcv[0] = 1;
  Object call10439 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10433);
// compiled call node returning call10439 (depth = 7)
  partcv[0] = 0;
  Object call10440 = callmethod(call10439, "not",
    1, partcv, params);
  gc_frame_end(callframe10432);
// compiled call node returning call10440 (depth = 6)
// compiled member node returning call10440 (depth = 5)
  Object if10431 = done;
  if (istrue(call10440)) {
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10441 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10442 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10443 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10442);
// compiled call node returning call10443 (depth = 9)
// compiled member node returning call10443 (depth = 8)
  partcv[0] = 0;
  Object call10444 = callmethod(call10443, "empty",
    1, partcv, params);
  gc_frame_end(callframe10441);
// compiled call node returning call10444 (depth = 7)
// compiled member node returning call10444 (depth = 6)
  *var_suggestions = call10444;
  if (call10444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10445 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10446 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10447 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10446);
// compiled call node returning call10447 (depth = 9)
// compiled member node returning call10447 (depth = 8)
  partcv[0] = 0;
  Object call10448 = callmethod(call10447, "new",
    1, partcv, params);
  gc_frame_end(callframe10445);
// compiled call node returning call10448 (depth = 7)
// compiled member node returning call10448 (depth = 6)
  *var_suggestion = call10448;
  if (call10448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10449 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit10450 == NULL) {
    strlit10450 = alloc_String("rbrace");
    gc_root(strlit10450);
  }
// compiled string node returning strlit10450 (depth = 7)
  gc_frame_newslot(strlit10450);
// call case 4: self request
  params[0] = strlit10450;
  partcv[0] = 1;
  Object call10451 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10449);
// compiled call node returning call10451 (depth = 6)
  *var_nextTok = call10451;
  if (call10451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3186
  setline(3186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_10453 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_10453 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10455 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10455 (depth = 6)
  Object if10452 = done;
  if (istrue(opresult10455)) {
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10456 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit10457 == NULL) {
    strlit10457 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10457);
  }
// compiled string node returning strlit10457 (depth = 7)
  gc_frame_newslot(strlit10457);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit10457;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10458 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10456);
// compiled call node returning call10458 (depth = 6)
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10459 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10460 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10459);
// compiled call node returning call10460 (depth = 6)
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10461 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10462 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call10463 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10462);
// compiled call node returning call10463 (depth = 10)
// compiled member node returning call10463 (depth = 9)
  partcv[0] = 0;
  Object call10464 = callmethod(call10463, "new",
    1, partcv, params);
  gc_frame_end(callframe10461);
// compiled call node returning call10464 (depth = 8)
// compiled member node returning call10464 (depth = 7)
  *var_suggestion = call10464;
  if (call10464 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3190
  setline(3190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10466 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool10467 = alloc_Boolean(1);
// compiled identifier node returning bool10467 (depth = 7)
  gc_frame_newslot(bool10467);
// starting to compile identifier node (depth = 7)
  Object bool10468 = alloc_Boolean(0);
// compiled identifier node returning bool10468 (depth = 7)
  gc_frame_newslot(bool10468);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool10467;
  params[2] = bool10468;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10469 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10466);
// compiled call node returning call10469 (depth = 6)
    gc_frame_newslot(call10469);
    if10452 = call10469;
  } else {
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10470 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call10472 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10471);
// compiled call node returning call10472 (depth = 8)
// compiled member node returning call10472 (depth = 7)
  gc_frame_newslot(call10472);
// starting to compile identifier node (depth = 7)
  Object bool10473 = alloc_Boolean(1);
// compiled identifier node returning bool10473 (depth = 7)
  gc_frame_newslot(bool10473);
// starting to compile identifier node (depth = 7)
  Object bool10474 = alloc_Boolean(0);
// compiled identifier node returning bool10474 (depth = 7)
  gc_frame_newslot(bool10474);
// starting to compile string node (depth = 7)
  if (strlit10475 == NULL) {
    strlit10475 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10475);
  }
// compiled string node returning strlit10475 (depth = 7)
  gc_frame_newslot(strlit10475);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call10472;
  params[2] = bool10473;
  params[3] = bool10474;
  params[4] = strlit10475;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10476 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10470);
// compiled call node returning call10476 (depth = 6)
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10477 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10478 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10477);
// compiled call node returning call10478 (depth = 6)
// Begin line 3194
  setline(3194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10479 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call10481 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10480);
// compiled call node returning call10481 (depth = 10)
// compiled member node returning call10481 (depth = 9)
  partcv[0] = 0;
  Object call10482 = callmethod(call10481, "new",
    1, partcv, params);
  gc_frame_end(callframe10479);
// compiled call node returning call10482 (depth = 8)
// compiled member node returning call10482 (depth = 7)
  *var_suggestion = call10482;
  if (call10482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10484 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call10486 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10485);
// compiled call node returning call10486 (depth = 8)
// compiled member node returning call10486 (depth = 7)
  gc_frame_newslot(call10486);
// starting to compile identifier node (depth = 7)
  Object bool10487 = alloc_Boolean(1);
// compiled identifier node returning bool10487 (depth = 7)
  gc_frame_newslot(bool10487);
// starting to compile identifier node (depth = 7)
  Object bool10488 = alloc_Boolean(0);
// compiled identifier node returning bool10488 (depth = 7)
  gc_frame_newslot(bool10488);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call10486;
  params[2] = bool10487;
  params[3] = bool10488;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10489 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10484);
// compiled call node returning call10489 (depth = 6)
    gc_frame_newslot(call10489);
    if10452 = call10489;
  }
// compiled if node returning if10452 (depth = 5)
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10490 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10491 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10490);
// compiled call node returning call10491 (depth = 5)
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10492 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10493 == NULL) {
    strlit10493 = alloc_String("A return statement must have either an expression or a new-line after 'return'.");
    gc_root(strlit10493);
  }
// compiled string node returning strlit10493 (depth = 6)
  gc_frame_newslot(strlit10493);
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10495 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10494);
// compiled call node returning call10495 (depth = 7)
// compiled member node returning call10495 (depth = 6)
  gc_frame_newslot(call10495);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10497 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10496);
// compiled call node returning call10497 (depth = 7)
// compiled member node returning call10497 (depth = 6)
  gc_frame_newslot(call10497);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10499 = alloc_Float64(1);
// compiled num node returning num10499 (depth = 7)
  int op_slot_right_10498 = gc_frame_newslot(num10499);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10503 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe10502);
// compiled call node returning call10503 (depth = 9)
// compiled member node returning call10503 (depth = 8)
  int op_slot_right_10501 = gc_frame_newslot(call10503);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10506 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10505);
// compiled call node returning call10506 (depth = 9)
// compiled member node returning call10506 (depth = 8)
  int op_slot_left_10501 = gc_frame_newslot(call10506);
  params[0] = call10503;
  partcv[0] = 1;
  Object sum10507 = callmethod(call10506, "+", 1, partcv, params);
// compiled op node returning sum10507 (depth = 7)
  int op_slot_left_10498 = gc_frame_newslot(sum10507);
  params[0] = num10499;
  partcv[0] = 1;
  Object diff10508 = callmethod(sum10507, "-", 1, partcv, params);
// compiled op node returning diff10508 (depth = 6)
  gc_frame_newslot(diff10508);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit10493;
  params[1] = call10495;
  params[2] = call10497;
  params[3] = diff10508;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10509 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10492);
// compiled call node returning call10509 (depth = 5)
    gc_frame_newslot(call10509);
    if10431 = call10509;
  } else {
  }
// compiled if node returning if10431 (depth = 4)
// Begin line 3201
  setline(3201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10511 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10510);
// compiled call node returning call10511 (depth = 6)
// compiled member node returning call10511 (depth = 5)
  *var_retval = call10511;
  if (call10511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10418 = done;
  } else {
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10513 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10514 == NULL) {
    strlit10514 = alloc_String("done");
    gc_root(strlit10514);
  }
// compiled string node returning strlit10514 (depth = 6)
  gc_frame_newslot(strlit10514);
// starting to compile identifier node (depth = 6)
  Object bool10515 = alloc_Boolean(0);
// compiled identifier node returning bool10515 (depth = 6)
  gc_frame_newslot(bool10515);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10516 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call10517 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10516);
// compiled call node returning call10517 (depth = 7)
// compiled member node returning call10517 (depth = 6)
  params[0] = strlit10514;
  params[1] = bool10515;
  partcv[0] = 2;
  Object call10518 = callmethod(call10517, "new",
    1, partcv, params);
  gc_frame_end(callframe10513);
// compiled call node returning call10518 (depth = 5)
  *var_retval = call10518;
  if (call10518 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10418 = done;
  }
// compiled if node returning if10418 (depth = 3)
// Begin line 3205
  setline(3205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10520 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_retTok (depth = 6)
  partcv[0] = 0;
  Object call10522 = callmethod(*var_retTok, "line",
    1, partcv, params);
  gc_frame_end(callframe10521);
// compiled call node returning call10522 (depth = 5)
// compiled member node returning call10522 (depth = 4)
  gc_frame_newslot(call10522);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_retTok (depth = 6)
  partcv[0] = 0;
  Object call10524 = callmethod(*var_retTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10523);
// compiled call node returning call10524 (depth = 5)
// compiled member node returning call10524 (depth = 4)
  gc_frame_newslot(call10524);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call10522;
  params[1] = call10524;
  partcv[0] = 2;
  Object call10525 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10520);
// compiled call node returning call10525 (depth = 3)
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10526 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  gc_frame_newslot(*var_retval);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10528 = callmethod(*var_ast, "returnNode",
    1, partcv, params);
  gc_frame_end(callframe10527);
// compiled call node returning call10528 (depth = 6)
// compiled member node returning call10528 (depth = 5)
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call10529 = callmethod(call10528, "new",
    1, partcv, params);
  gc_frame_end(callframe10526);
// compiled call node returning call10529 (depth = 4)
  *var_o = call10529;
  if (call10529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10530 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10531 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10530);
// compiled call node returning call10531 (depth = 3)
    gc_frame_newslot(call10531);
    if10403 = call10531;
  } else {
  }
// compiled if node returning if10403 (depth = 2)
  gc_frame_end(frame);
  return if10403;
}
Object meth_parser_domethodtype10532(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for domethodtype (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for domethodtype");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methodTypeTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "methodTypeTok");
  Object *var_m = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "m");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_dtype = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "dtype");
  Object *var_varargs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "varargs");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_suggestion = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestion");
  Object *var_newLine = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "newLine");
// Begin line 3213
  setline(3213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_methodTypeTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10533 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10534 = alloc_Boolean(1);
// compiled identifier node returning bool10534 (depth = 4)
  gc_frame_newslot(bool10534);
// call case 4: self request
  params[0] = bool10534;
  partcv[0] = 1;
  Object call10535 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10533);
// compiled call node returning call10535 (depth = 3)
  *var_m = call10535;
  if (call10535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10537 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe10536);
// compiled call node returning call10537 (depth = 4)
// compiled member node returning call10537 (depth = 3)
  *var_meth = call10537;
  if (call10537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10539 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe10538);
// compiled call node returning call10539 (depth = 4)
// compiled member node returning call10539 (depth = 3)
  *var_signature = call10539;
  if (call10539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10540 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10541 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe10540);
// compiled call node returning call10541 (depth = 4)
// compiled member node returning call10541 (depth = 3)
  *var_dtype = call10541;
  if (call10541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3218
  setline(3218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10543 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe10542);
// compiled call node returning call10543 (depth = 4)
// compiled member node returning call10543 (depth = 3)
  *var_varargs = call10543;
  if (call10543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3219
  setline(3219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10546 = alloc_Boolean(0);
// compiled identifier node returning bool10546 (depth = 4)
  int op_slot_right_10545 = gc_frame_newslot(bool10546);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  int op_slot_left_10545 = gc_frame_newslot(*var_dtype);
  params[0] = bool10546;
  partcv[0] = 1;
  Object opresult10548 = callmethod(*var_dtype, "==", 1, partcv, params);
// compiled op node returning opresult10548 (depth = 3)
  Object if10544 = done;
  if (istrue(opresult10548)) {
// Begin line 3220
  setline(3220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10549 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10550 == NULL) {
    strlit10550 = alloc_String("Done");
    gc_root(strlit10550);
  }
// compiled string node returning strlit10550 (depth = 5)
  gc_frame_newslot(strlit10550);
// starting to compile identifier node (depth = 5)
  Object bool10551 = alloc_Boolean(0);
// compiled identifier node returning bool10551 (depth = 5)
  gc_frame_newslot(bool10551);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10553 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10552);
// compiled call node returning call10553 (depth = 6)
// compiled member node returning call10553 (depth = 5)
  params[0] = strlit10550;
  params[1] = bool10551;
  partcv[0] = 2;
  Object call10554 = callmethod(call10553, "new",
    1, partcv, params);
  gc_frame_end(callframe10549);
// compiled call node returning call10554 (depth = 4)
  *var_dtype = call10554;
  if (call10554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10544 = done;
  } else {
  }
// compiled if node returning if10544 (depth = 2)
// Begin line 3222
  setline(3222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10556 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeTok (depth = 5)
  partcv[0] = 0;
  Object call10558 = callmethod(*var_methodTypeTok, "line",
    1, partcv, params);
  gc_frame_end(callframe10557);
// compiled call node returning call10558 (depth = 4)
// compiled member node returning call10558 (depth = 3)
  gc_frame_newslot(call10558);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeTok (depth = 5)
  partcv[0] = 0;
  Object call10560 = callmethod(*var_methodTypeTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10559);
// compiled call node returning call10560 (depth = 4)
// compiled member node returning call10560 (depth = 3)
  gc_frame_newslot(call10560);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call10558;
  params[1] = call10560;
  partcv[0] = 2;
  Object call10561 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10556);
// compiled call node returning call10561 (depth = 2)
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10562 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10563 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call10564 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe10563);
// compiled call node returning call10564 (depth = 5)
// compiled member node returning call10564 (depth = 4)
  gc_frame_newslot(call10564);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature (depth = 4)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call10566 = callmethod(*var_ast, "methodTypeNode",
    1, partcv, params);
  gc_frame_end(callframe10565);
// compiled call node returning call10566 (depth = 5)
// compiled member node returning call10566 (depth = 4)
  params[0] = call10564;
  params[1] = *var_signature;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call10567 = callmethod(call10566, "new",
    1, partcv, params);
  gc_frame_end(callframe10562);
// compiled call node returning call10567 (depth = 3)
  *var_o = call10567;
  if (call10567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10568 = gc_frame_new();
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10569 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call10570 = callmethod(*var_m, "generics",
    1, partcv, params);
  gc_frame_end(callframe10569);
// compiled call node returning call10570 (depth = 5)
// compiled member node returning call10570 (depth = 4)
  gc_frame_newslot(call10570);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = call10570;
  partcv[0] = 1;
  Object call10571 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10568);
// compiled call node returning call10571 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 3225
  setline(3225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10572 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10573 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10572);
// compiled call node returning call10573 (depth = 2)
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10575 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10574);
// compiled call node returning call10575 (depth = 3)
// compiled member node returning call10575 (depth = 2)
// Begin line 3227
  setline(3227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10577 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10578 == NULL) {
    strlit10578 = alloc_String("semicolon");
    gc_root(strlit10578);
  }
// compiled string node returning strlit10578 (depth = 4)
  gc_frame_newslot(strlit10578);
// call case 4: self request
  params[0] = strlit10578;
  partcv[0] = 1;
  Object call10579 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10577);
// compiled call node returning call10579 (depth = 3)
  Object if10576 = done;
  if (istrue(call10579)) {
// Begin line 3228
  setline(3228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10580 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10581 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10580);
// compiled call node returning call10581 (depth = 4)
// compiled member node returning call10581 (depth = 3)
    gc_frame_newslot(call10581);
    if10576 = call10581;
  } else {
// Begin line 3230
  setline(3230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10583 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe10584 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10585 == NULL) {
    strlit10585 = alloc_String("rbrace");
    gc_root(strlit10585);
  }
// compiled string node returning strlit10585 (depth = 6)
  gc_frame_newslot(strlit10585);
// call case 4: self request
  params[0] = strlit10585;
  partcv[0] = 1;
  Object call10586 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10584);
// compiled call node returning call10586 (depth = 5)
  partcv[0] = 0;
  Object call10587 = callmethod(call10586, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10583);
// compiled call node returning call10587 (depth = 4)
  Object if10582 = done;
  if (istrue(call10587)) {
// Begin line 3231
  setline(3231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10591 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10590);
// compiled call node returning call10591 (depth = 7)
// compiled member node returning call10591 (depth = 6)
  int op_slot_right_10589 = gc_frame_newslot(call10591);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10593 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call10594 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10593);
// compiled call node returning call10594 (depth = 7)
// compiled member node returning call10594 (depth = 6)
  int op_slot_left_10589 = gc_frame_newslot(call10594);
  params[0] = call10591;
  partcv[0] = 1;
  Object opresult10595 = callmethod(call10594, "==", 1, partcv, params);
// compiled op node returning opresult10595 (depth = 5)
  Object if10588 = done;
  if (istrue(opresult10595)) {
// Begin line 3232
  setline(3232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10596 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10598 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10597);
// compiled call node returning call10598 (depth = 9)
// compiled member node returning call10598 (depth = 8)
  partcv[0] = 0;
  Object call10599 = callmethod(call10598, "new",
    1, partcv, params);
  gc_frame_end(callframe10596);
// compiled call node returning call10599 (depth = 7)
// compiled member node returning call10599 (depth = 6)
  *var_suggestion = call10599;
  if (call10599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3233
  setline(3233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10601 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10602 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10601);
// compiled call node returning call10602 (depth = 8)
// compiled member node returning call10602 (depth = 7)
  int op_slot_right_10600 = gc_frame_newslot(call10602);
// starting to compile call node (depth = 7)
  int callframe10604 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num10605 = alloc_Float64(1);
// compiled num node returning num10605 (depth = 8)
  gc_frame_newslot(num10605);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10607 = alloc_Float64(1);
// compiled num node returning num10607 (depth = 9)
  int op_slot_right_10606 = gc_frame_newslot(num10607);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call10610 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10609);
// compiled call node returning call10610 (depth = 10)
// compiled member node returning call10610 (depth = 9)
  int op_slot_left_10606 = gc_frame_newslot(call10610);
  params[0] = num10607;
  partcv[0] = 1;
  Object diff10611 = callmethod(call10610, "-", 1, partcv, params);
// compiled op node returning diff10611 (depth = 8)
  gc_frame_newslot(diff10611);
// call case 6: other member request
// starting to compile index node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10612 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call10613 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe10612);
// compiled call node returning call10613 (depth = 10)
// compiled member node returning call10613 (depth = 9)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10615 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10614);
// compiled call node returning call10615 (depth = 10)
// compiled member node returning call10615 (depth = 9)
  params[0] = call10615;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10616 = callmethod(call10613, "[]", 1, partcv, params);
// compiled index node returning idxres10616 (depth = 8)
  params[0] = num10605;
  params[1] = diff10611;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10617 = callmethod(idxres10616, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe10604);
// compiled call node returning call10617 (depth = 7)
  int op_slot_left_10600 = gc_frame_newslot(call10617);
  params[0] = call10602;
  partcv[0] = 1;
  Object opresult10618 = callmethod(call10617, "++", 1, partcv, params);
// compiled op node returning opresult10618 (depth = 6)
  *var_newLine = opresult10618;
  if (opresult10618 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3234
  setline(3234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10619 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10621 = alloc_Float64(0.1);
// compiled num node returning num10621 (depth = 7)
  int op_slot_right_10620 = gc_frame_newslot(num10621);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10624 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10623);
// compiled call node returning call10624 (depth = 8)
// compiled member node returning call10624 (depth = 7)
  int op_slot_left_10620 = gc_frame_newslot(call10624);
  params[0] = num10621;
  partcv[0] = 1;
  Object sum10625 = callmethod(call10624, "+", 1, partcv, params);
// compiled op node returning sum10625 (depth = 6)
  gc_frame_newslot(sum10625);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum10625;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call10626 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10619);
// compiled call node returning call10626 (depth = 5)
// Begin line 3235
  setline(3235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10627 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool10628 = alloc_Boolean(1);
// compiled identifier node returning bool10628 (depth = 6)
  gc_frame_newslot(bool10628);
// starting to compile identifier node (depth = 6)
  Object bool10629 = alloc_Boolean(1);
// compiled identifier node returning bool10629 (depth = 6)
  gc_frame_newslot(bool10629);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool10628;
  params[2] = bool10629;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10630 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10627);
// compiled call node returning call10630 (depth = 5)
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10631 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10632 == NULL) {
    strlit10632 = alloc_String("Methods in a type literal must be on separate lines, or separated by semicolons.");
    gc_root(strlit10632);
  }
// compiled string node returning strlit10632 (depth = 6)
  gc_frame_newslot(strlit10632);
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10633 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10634 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10633);
// compiled call node returning call10634 (depth = 7)
// compiled member node returning call10634 (depth = 6)
  gc_frame_newslot(call10634);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10636 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10635);
// compiled call node returning call10636 (depth = 7)
// compiled member node returning call10636 (depth = 6)
  gc_frame_newslot(call10636);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit10632;
  params[1] = call10634;
  params[2] = call10636;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10637 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10631);
// compiled call node returning call10637 (depth = 5)
    gc_frame_newslot(call10637);
    if10588 = call10637;
  } else {
  }
// compiled if node returning if10588 (depth = 4)
    gc_frame_newslot(if10588);
    if10582 = if10588;
  } else {
  }
// compiled if node returning if10582 (depth = 3)
    gc_frame_newslot(if10582);
    if10576 = if10582;
  }
// compiled if node returning if10576 (depth = 2)
  gc_frame_end(frame);
  return if10576;
}
Object meth_parser__apply10642(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10644 == NULL) {
    strlit10644 = alloc_String("type");
    gc_root(strlit10644);
  }
// compiled string node returning strlit10644 (depth = 6)
  int op_slot_right_10643 = gc_frame_newslot(strlit10644);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10647 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10646);
// compiled call node returning call10647 (depth = 7)
// compiled member node returning call10647 (depth = 6)
  int op_slot_left_10643 = gc_frame_newslot(call10647);
  params[0] = strlit10644;
  partcv[0] = 1;
  Object opresult10648 = callmethod(call10647, "==", 1, partcv, params);
// compiled op node returning opresult10648 (depth = 5)
  gc_frame_end(frame);
  return opresult10648;
}
Object meth_parser__apply10691(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10692 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10693 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10694 == NULL) {
    strlit10694 = alloc_String("rbrace");
    gc_root(strlit10694);
  }
// compiled string node returning strlit10694 (depth = 8)
  gc_frame_newslot(strlit10694);
// call case 4: self request
  params[0] = strlit10694;
  partcv[0] = 1;
  Object call10695 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10693);
// compiled call node returning call10695 (depth = 7)
  partcv[0] = 0;
  Object call10696 = callmethod(call10695, "not",
    1, partcv, params);
  gc_frame_end(callframe10692);
// compiled call node returning call10696 (depth = 6)
// compiled member node returning call10696 (depth = 5)
  gc_frame_end(frame);
  return call10696;
}
Object meth_parser__apply10703(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10705 == NULL) {
    strlit10705 = alloc_String("type");
    gc_root(strlit10705);
  }
// compiled string node returning strlit10705 (depth = 9)
  int op_slot_right_10704 = gc_frame_newslot(strlit10705);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10707 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10708 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10707);
// compiled call node returning call10708 (depth = 10)
// compiled member node returning call10708 (depth = 9)
  int op_slot_left_10704 = gc_frame_newslot(call10708);
  params[0] = strlit10705;
  partcv[0] = 1;
  Object opresult10709 = callmethod(call10708, "==", 1, partcv, params);
// compiled op node returning opresult10709 (depth = 8)
  gc_frame_end(frame);
  return opresult10709;
}
Object meth_parser__apply10699(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_types = getfromclosure(closure, 2);
  Object *var_meths = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3263
  setline(3263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10701 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block10702 = alloc_Block(NULL, NULL, "parser", 3263);
  gc_frame_newslot(block10702);
// method _apply
  block_savedest(block10702);
  Object closure10703 = createclosure(2, "_apply");
  setclosureframe(closure10703, stackframe);
  addtoclosure(closure10703, var_sym);
  addtoclosure(closure10703, selfslot);
  struct UserObject *uo10703 = (struct UserObject*)block10702;
  uo10703->data[0] = (Object)closure10703;
  Method *meth_meth_parser__apply10703 = addmethod2pos(block10702, "_apply", &meth_parser__apply10703, 0);
  int argcv_meth_parser__apply10703[] = {0};
  meth_meth_parser__apply10703->type = alloc_MethodType(1, argcv_meth_parser__apply10703);
  meth_meth_parser__apply10703->definitionModule = modulename;
  meth_meth_parser__apply10703->definitionLine = 3262;
// compiled block node returning block10702 (depth = 7)
  gc_frame_newslot(block10702);
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10711 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10712 == NULL) {
    strlit10712 = alloc_String("keyword");
    gc_root(strlit10712);
  }
// compiled string node returning strlit10712 (depth = 8)
  gc_frame_newslot(strlit10712);
// call case 4: self request
  params[0] = strlit10712;
  partcv[0] = 1;
  Object call10713 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10711);
// compiled call node returning call10713 (depth = 7)
  params[0] = block10702;
  partcv[0] = 1;
  Object call10714 = callmethod(call10713, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe10701);
// compiled call node returning call10714 (depth = 6)
  Object if10700 = done;
  if (istrue(call10714)) {
// Begin line 3264
  setline(3264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10715 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10716 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10715);
// compiled call node returning call10716 (depth = 7)
// compiled member node returning call10716 (depth = 6)
// Begin line 3265
  setline(3265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10717 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10719 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10718);
// compiled call node returning call10719 (depth = 8)
// compiled member node returning call10719 (depth = 7)
  gc_frame_newslot(call10719);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_types (depth = 7)
  params[0] = call10719;
  partcv[0] = 1;
  Object call10720 = callmethod(*var_types, "push",
    1, partcv, params);
  gc_frame_end(callframe10717);
// compiled call node returning call10720 (depth = 6)
    gc_frame_newslot(call10720);
    if10700 = call10720;
  } else {
// Begin line 3267
  setline(3267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10721 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10722 = callmethodflags(self, "domethodtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10721);
// compiled call node returning call10722 (depth = 7)
// compiled member node returning call10722 (depth = 6)
// Begin line 3268
  setline(3268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10723 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10725 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10724);
// compiled call node returning call10725 (depth = 8)
// compiled member node returning call10725 (depth = 7)
  gc_frame_newslot(call10725);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meths (depth = 7)
  params[0] = call10725;
  partcv[0] = 1;
  Object call10726 = callmethod(*var_meths, "push",
    1, partcv, params);
  gc_frame_end(callframe10723);
// compiled call node returning call10726 (depth = 6)
    gc_frame_newslot(call10726);
    if10700 = call10726;
  }
// compiled if node returning if10700 (depth = 5)
  gc_frame_end(frame);
  return if10700;
}
Object meth_parser_dotypeLiteral10638(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dotypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeLiteralTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeLiteralTok");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meths = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meths");
  Object *var_types = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "types");
  Object *var_mc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mc");
  Object *var_t = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "t");
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_typeLiteralTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10640 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10641 = alloc_Block(NULL, NULL, "parser", 3246);
  gc_frame_newslot(block10641);
// method _apply
  block_savedest(block10641);
  Object closure10642 = createclosure(2, "_apply");
  setclosureframe(closure10642, stackframe);
  addtoclosure(closure10642, var_sym);
  addtoclosure(closure10642, selfslot);
  struct UserObject *uo10642 = (struct UserObject*)block10641;
  uo10642->data[0] = (Object)closure10642;
  Method *meth_meth_parser__apply10642 = addmethod2pos(block10641, "_apply", &meth_parser__apply10642, 0);
  int argcv_meth_parser__apply10642[] = {0};
  meth_meth_parser__apply10642->type = alloc_MethodType(1, argcv_meth_parser__apply10642);
  meth_meth_parser__apply10642->definitionModule = modulename;
  meth_meth_parser__apply10642->definitionLine = 3237;
// compiled block node returning block10641 (depth = 4)
  gc_frame_newslot(block10641);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10650 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10651 == NULL) {
    strlit10651 = alloc_String("keyword");
    gc_root(strlit10651);
  }
// compiled string node returning strlit10651 (depth = 5)
  gc_frame_newslot(strlit10651);
// call case 4: self request
  params[0] = strlit10651;
  partcv[0] = 1;
  Object call10652 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10650);
// compiled call node returning call10652 (depth = 4)
  params[0] = block10641;
  partcv[0] = 1;
  Object call10653 = callmethod(call10652, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe10640);
// compiled call node returning call10653 (depth = 3)
  Object if10639 = done;
  if (istrue(call10653)) {
// Begin line 3247
  setline(3247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10655 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10654);
// compiled call node returning call10655 (depth = 4)
// compiled member node returning call10655 (depth = 3)
// Begin line 3248
  setline(3248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10657 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe10658 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10659 == NULL) {
    strlit10659 = alloc_String("lbrace");
    gc_root(strlit10659);
  }
// compiled string node returning strlit10659 (depth = 6)
  gc_frame_newslot(strlit10659);
// call case 4: self request
  params[0] = strlit10659;
  partcv[0] = 1;
  Object call10660 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10658);
// compiled call node returning call10660 (depth = 5)
  partcv[0] = 0;
  Object call10661 = callmethod(call10660, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10657);
// compiled call node returning call10661 (depth = 4)
  Object if10656 = done;
  if (istrue(call10661)) {
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10662 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10663 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10664 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10663);
// compiled call node returning call10664 (depth = 8)
// compiled member node returning call10664 (depth = 7)
  partcv[0] = 0;
  Object call10665 = callmethod(call10664, "new",
    1, partcv, params);
  gc_frame_end(callframe10662);
// compiled call node returning call10665 (depth = 6)
// compiled member node returning call10665 (depth = 5)
  *var_suggestion = call10665;
  if (call10665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3250
  setline(3250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10666 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 5)
  if (strlit10667 == NULL) {
    strlit10667 = alloc_String("{");
    gc_root(strlit10667);
  }
// compiled string node returning strlit10667 (depth = 5)
  gc_frame_newslot(strlit10667);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = strlit10667;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10668 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10666);
// compiled call node returning call10668 (depth = 4)
// Begin line 3251
  setline(3251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10669 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10670 == NULL) {
    strlit10670 = alloc_String("type literals must open with a brace.");
    gc_root(strlit10670);
  }
// compiled string node returning strlit10670 (depth = 5)
  gc_frame_newslot(strlit10670);
// Begin line 3252
  setline(3252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10672 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10671);
// compiled call node returning call10672 (depth = 6)
// compiled member node returning call10672 (depth = 5)
  gc_frame_newslot(call10672);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10674 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10673);
// compiled call node returning call10674 (depth = 6)
// compiled member node returning call10674 (depth = 5)
  gc_frame_newslot(call10674);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3251
  setline(3251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10670;
  params[1] = call10672;
  params[2] = call10674;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10675 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10669);
// compiled call node returning call10675 (depth = 4)
// Begin line 3253
  setline(3253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 3254
  setline(3254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10656 = undefined;
  } else {
  }
// compiled if node returning if10656 (depth = 3)
    gc_frame_newslot(if10656);
    if10639 = if10656;
  } else {
  }
// compiled if node returning if10639 (depth = 2)
// Begin line 3256
  setline(3256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10677 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10678 == NULL) {
    strlit10678 = alloc_String("lbrace");
    gc_root(strlit10678);
  }
// compiled string node returning strlit10678 (depth = 4)
  gc_frame_newslot(strlit10678);
// call case 4: self request
  params[0] = strlit10678;
  partcv[0] = 1;
  Object call10679 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10677);
// compiled call node returning call10679 (depth = 3)
  Object if10676 = done;
  if (istrue(call10679)) {
// Begin line 3257
  setline(3257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array10680 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10680 (depth = 4)
  *var_meths = array10680;
  if (array10680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3258
  setline(3258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array10681 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10681 (depth = 4)
  *var_types = array10681;
  if (array10681 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_auto_count (depth = 4)
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3260
  setline(3260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10683 = alloc_Float64(1);
// compiled num node returning num10683 (depth = 5)
  int op_slot_right_10682 = gc_frame_newslot(num10683);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_10682 = gc_frame_newslot(*var_auto_count);
  params[0] = num10683;
  partcv[0] = 1;
  Object sum10685 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum10685 (depth = 4)
  *var_auto_count = sum10685;
  if (sum10685 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3261
  setline(3261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10687 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10688 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10687);
// compiled call node returning call10688 (depth = 4)
// compiled member node returning call10688 (depth = 3)
// Begin line 3262
  setline(3262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10689 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10690 = alloc_Block(NULL, NULL, "parser", 3262);
  gc_frame_newslot(block10690);
// method _apply
  block_savedest(block10690);
  Object closure10691 = createclosure(1, "_apply");
  setclosureframe(closure10691, stackframe);
  addtoclosure(closure10691, selfslot);
  struct UserObject *uo10691 = (struct UserObject*)block10690;
  uo10691->data[0] = (Object)closure10691;
  Method *meth_meth_parser__apply10691 = addmethod2pos(block10690, "_apply", &meth_parser__apply10691, 0);
  int argcv_meth_parser__apply10691[] = {0};
  meth_meth_parser__apply10691->type = alloc_MethodType(1, argcv_meth_parser__apply10691);
  meth_meth_parser__apply10691->definitionModule = modulename;
  meth_meth_parser__apply10691->definitionLine = 3261;
// compiled block node returning block10690 (depth = 4)
  gc_frame_newslot(block10690);
// starting to compile block node (depth = 4)
  Object block10698 = alloc_Block(NULL, NULL, "parser", 3262);
  gc_frame_newslot(block10698);
// method _apply
  block_savedest(block10698);
  Object closure10699 = createclosure(5, "_apply");
  setclosureframe(closure10699, stackframe);
  addtoclosure(closure10699, var_sym);
  addtoclosure(closure10699, var_values);
  addtoclosure(closure10699, var_types);
  addtoclosure(closure10699, var_meths);
  addtoclosure(closure10699, selfslot);
  struct UserObject *uo10699 = (struct UserObject*)block10698;
  uo10699->data[0] = (Object)closure10699;
  Method *meth_meth_parser__apply10699 = addmethod2pos(block10698, "_apply", &meth_parser__apply10699, 0);
  int argcv_meth_parser__apply10699[] = {0};
  meth_meth_parser__apply10699->type = alloc_MethodType(1, argcv_meth_parser__apply10699);
  meth_meth_parser__apply10699->definitionModule = modulename;
  meth_meth_parser__apply10699->definitionLine = 3262;
// compiled block node returning block10698 (depth = 4)
  gc_frame_newslot(block10698);
// call case 5: prelude request
  params[0] = block10690;
  params[1] = block10698;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10728 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10689);
// compiled call node returning call10728 (depth = 3)
// Begin line 3271
  setline(3271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10729 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10730 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10729);
// compiled call node returning call10730 (depth = 4)
// compiled member node returning call10730 (depth = 3)
// Begin line 3272
  setline(3272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10731 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralTok (depth = 6)
  partcv[0] = 0;
  Object call10733 = callmethod(*var_typeLiteralTok, "line",
    1, partcv, params);
  gc_frame_end(callframe10732);
// compiled call node returning call10733 (depth = 5)
// compiled member node returning call10733 (depth = 4)
  gc_frame_newslot(call10733);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralTok (depth = 6)
  partcv[0] = 0;
  Object call10735 = callmethod(*var_typeLiteralTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10734);
// compiled call node returning call10735 (depth = 5)
// compiled member node returning call10735 (depth = 4)
  gc_frame_newslot(call10735);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call10733;
  params[1] = call10735;
  partcv[0] = 2;
  Object call10736 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10731);
// compiled call node returning call10736 (depth = 3)
// Begin line 3273
  setline(3273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10737 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meths (depth = 5)
  gc_frame_newslot(*var_meths);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_types (depth = 5)
  gc_frame_newslot(*var_types);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10738 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10739 = callmethod(*var_ast, "typeLiteralNode",
    1, partcv, params);
  gc_frame_end(callframe10738);
// compiled call node returning call10739 (depth = 6)
// compiled member node returning call10739 (depth = 5)
  params[0] = *var_meths;
  params[1] = *var_types;
  partcv[0] = 2;
  Object call10740 = callmethod(call10739, "new",
    1, partcv, params);
  gc_frame_end(callframe10737);
// compiled call node returning call10740 (depth = 4)
  *var_t = call10740;
  if (call10740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10741 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call10742 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10741);
// compiled call node returning call10742 (depth = 3)
    gc_frame_newslot(call10742);
    if10676 = call10742;
  } else {
  }
// compiled if node returning if10676 (depth = 2)
  gc_frame_end(frame);
  return if10676;
}
Object meth_parser__apply10839(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10841 == NULL) {
    strlit10841 = alloc_String("lbrace");
    gc_root(strlit10841);
  }
// compiled string node returning strlit10841 (depth = 8)
  int op_slot_right_10840 = gc_frame_newslot(strlit10841);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10843 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call10844 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe10843);
// compiled call node returning call10844 (depth = 9)
// compiled member node returning call10844 (depth = 8)
  int op_slot_left_10840 = gc_frame_newslot(call10844);
  params[0] = strlit10841;
  partcv[0] = 1;
  Object opresult10845 = callmethod(call10844, "==", 1, partcv, params);
// compiled op node returning opresult10845 (depth = 7)
  gc_frame_end(frame);
  return opresult10845;
}
Object meth_parser__apply10851(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_10852 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_10852 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10854 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10854 (depth = 7)
  gc_frame_end(frame);
  return opresult10854;
}
Object meth_parser_typedec10743(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typedec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_noBlocks = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typedec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typedec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nt");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// Begin line 3280
  setline(3280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10747 == NULL) {
    strlit10747 = alloc_String("type");
    gc_root(strlit10747);
  }
// compiled string node returning strlit10747 (depth = 5)
  int op_slot_right_10746 = gc_frame_newslot(strlit10747);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10750 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10749);
// compiled call node returning call10750 (depth = 6)
// compiled member node returning call10750 (depth = 5)
  int op_slot_left_10746 = gc_frame_newslot(call10750);
  params[0] = strlit10747;
  partcv[0] = 1;
  Object opresult10751 = callmethod(call10750, "==", 1, partcv, params);
// compiled op node returning opresult10751 (depth = 4)
  int op_slot_right_10745 = gc_frame_newslot(opresult10751);
// starting to compile call node (depth = 4)
  int callframe10753 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10754 == NULL) {
    strlit10754 = alloc_String("keyword");
    gc_root(strlit10754);
  }
// compiled string node returning strlit10754 (depth = 5)
  gc_frame_newslot(strlit10754);
// call case 4: self request
  params[0] = strlit10754;
  partcv[0] = 1;
  Object call10755 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10753);
// compiled call node returning call10755 (depth = 4)
  int op_slot_left_10745 = gc_frame_newslot(call10755);
  params[0] = opresult10751;
  partcv[0] = 1;
  Object opresult10756 = callmethod(call10755, "&&", 1, partcv, params);
// compiled op node returning opresult10756 (depth = 3)
  Object if10744 = done;
  if (istrue(opresult10756)) {
// Begin line 3281
  setline(3281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10757 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10758 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10757);
// compiled call node returning call10758 (depth = 5)
// compiled member node returning call10758 (depth = 4)
  *var_line = call10758;
  if (call10758 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10759 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10760 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10759);
// compiled call node returning call10760 (depth = 5)
// compiled member node returning call10760 (depth = 4)
  *var_pos = call10760;
  if (call10760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3283
  setline(3283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10761 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10762 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10761);
// compiled call node returning call10762 (depth = 4)
// compiled member node returning call10762 (depth = 3)
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10765 == NULL) {
    strlit10765 = alloc_String("identifier");
    gc_root(strlit10765);
  }
// compiled string node returning strlit10765 (depth = 5)
  int op_slot_right_10764 = gc_frame_newslot(strlit10765);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10767 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10768 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10767);
// compiled call node returning call10768 (depth = 6)
// compiled member node returning call10768 (depth = 5)
  int op_slot_left_10764 = gc_frame_newslot(call10768);
  params[0] = strlit10765;
  partcv[0] = 1;
  Object opresult10769 = callmethod(call10768, "!=", 1, partcv, params);
// compiled op node returning opresult10769 (depth = 4)
  Object if10763 = done;
  if (istrue(opresult10769)) {
// Begin line 3285
  setline(3285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10770 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10771 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10772 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10771);
// compiled call node returning call10772 (depth = 8)
// compiled member node returning call10772 (depth = 7)
  partcv[0] = 0;
  Object call10773 = callmethod(call10772, "new",
    1, partcv, params);
  gc_frame_end(callframe10770);
// compiled call node returning call10773 (depth = 6)
// compiled member node returning call10773 (depth = 5)
  *var_suggestion = call10773;
  if (call10773 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3286
  setline(3286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10774 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10775 == NULL) {
    strlit10775 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit10775);
  }
// compiled string node returning strlit10775 (depth = 5)
  gc_frame_newslot(strlit10775);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit10775;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10776 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10774);
// compiled call node returning call10776 (depth = 4)
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10777 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10778 == NULL) {
    strlit10778 = alloc_String("A type declaration must have a name after the 'type'.");
    gc_root(strlit10778);
  }
// compiled string node returning strlit10778 (depth = 5)
  gc_frame_newslot(strlit10778);
// Begin line 3288
  setline(3288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10779 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10780 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10779);
// compiled call node returning call10780 (depth = 6)
// compiled member node returning call10780 (depth = 5)
  gc_frame_newslot(call10780);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10782 = alloc_Float64(1);
// compiled num node returning num10782 (depth = 6)
  int op_slot_right_10781 = gc_frame_newslot(num10782);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10786 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10785);
// compiled call node returning call10786 (depth = 8)
// compiled member node returning call10786 (depth = 7)
  int op_slot_right_10784 = gc_frame_newslot(call10786);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10789 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10788);
// compiled call node returning call10789 (depth = 8)
// compiled member node returning call10789 (depth = 7)
  int op_slot_left_10784 = gc_frame_newslot(call10789);
  params[0] = call10786;
  partcv[0] = 1;
  Object sum10790 = callmethod(call10789, "+", 1, partcv, params);
// compiled op node returning sum10790 (depth = 6)
  int op_slot_left_10781 = gc_frame_newslot(sum10790);
  params[0] = num10782;
  partcv[0] = 1;
  Object sum10791 = callmethod(sum10790, "+", 1, partcv, params);
// compiled op node returning sum10791 (depth = 5)
  gc_frame_newslot(sum10791);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10778;
  params[1] = call10780;
  params[2] = sum10791;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10792 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10777);
// compiled call node returning call10792 (depth = 4)
    gc_frame_newslot(call10792);
    if10763 = call10792;
  } else {
  }
// compiled if node returning if10763 (depth = 3)
// Begin line 3290
  setline(3290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10794 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10793);
// compiled call node returning call10794 (depth = 4)
// compiled member node returning call10794 (depth = 3)
// Begin line 3291
  setline(3291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10795 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call10796 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10795);
// compiled call node returning call10796 (depth = 3)
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10797 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10798 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10799 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10798);
// compiled call node returning call10799 (depth = 6)
// compiled member node returning call10799 (depth = 5)
  gc_frame_newslot(call10799);
// starting to compile identifier node (depth = 5)
  Object bool10800 = alloc_Boolean(0);
// compiled identifier node returning bool10800 (depth = 5)
  gc_frame_newslot(bool10800);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10802 = callmethod(*var_ast, "typeDecNode",
    1, partcv, params);
  gc_frame_end(callframe10801);
// compiled call node returning call10802 (depth = 6)
// compiled member node returning call10802 (depth = 5)
  params[0] = call10799;
  params[1] = bool10800;
  partcv[0] = 2;
  Object call10803 = callmethod(call10802, "new",
    1, partcv, params);
  gc_frame_end(callframe10797);
// compiled call node returning call10803 (depth = 4)
  *var_nt = call10803;
  if (call10803 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3293
  setline(3293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10805 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10806 == NULL) {
    strlit10806 = alloc_String("lgeneric");
    gc_root(strlit10806);
  }
// compiled string node returning strlit10806 (depth = 5)
  gc_frame_newslot(strlit10806);
// call case 4: self request
  params[0] = strlit10806;
  partcv[0] = 1;
  Object call10807 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10805);
// compiled call node returning call10807 (depth = 4)
  Object if10804 = done;
  if (istrue(call10807)) {
// starting to compile call node (depth = 4)
  int callframe10808 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  gc_frame_newslot(*var_nt);
// call case 4: self request
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call10809 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10808);
// compiled call node returning call10809 (depth = 4)
    gc_frame_newslot(call10809);
    if10804 = call10809;
  } else {
  }
// compiled if node returning if10804 (depth = 3)
// Begin line 3294
  setline(3294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10810 = gc_frame_new();
// Begin line 3294
  setline(3294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool10811 = alloc_Boolean(1);
// compiled identifier node returning bool10811 (depth = 5)
  gc_frame_newslot(bool10811);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10812 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nt (depth = 7)
  partcv[0] = 0;
  Object call10813 = callmethod(*var_nt, "name",
    1, partcv, params);
  gc_frame_end(callframe10812);
// compiled call node returning call10813 (depth = 6)
// compiled member node returning call10813 (depth = 5)
  params[0] = bool10811;
  partcv[0] = 1;
  Object call10814 = callmethod(call10813, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10810);
// compiled call node returning call10814 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 3295
  setline(3295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10815 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10816 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10815);
// compiled call node returning call10816 (depth = 5)
// compiled member node returning call10816 (depth = 4)
  *var_anns = call10816;
  if (call10816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3296
  setline(3296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10820 == NULL) {
    strlit10820 = alloc_String("=");
    gc_root(strlit10820);
  }
// compiled string node returning strlit10820 (depth = 6)
  int op_slot_right_10819 = gc_frame_newslot(strlit10820);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10823 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10822);
// compiled call node returning call10823 (depth = 7)
// compiled member node returning call10823 (depth = 6)
  int op_slot_left_10819 = gc_frame_newslot(call10823);
  params[0] = strlit10820;
  partcv[0] = 1;
  Object opresult10824 = callmethod(call10823, "!=", 1, partcv, params);
// compiled op node returning opresult10824 (depth = 5)
  int op_slot_right_10818 = gc_frame_newslot(opresult10824);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10827 == NULL) {
    strlit10827 = alloc_String("op");
    gc_root(strlit10827);
  }
// compiled string node returning strlit10827 (depth = 6)
  int op_slot_right_10826 = gc_frame_newslot(strlit10827);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10829 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10830 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10829);
// compiled call node returning call10830 (depth = 7)
// compiled member node returning call10830 (depth = 6)
  int op_slot_left_10826 = gc_frame_newslot(call10830);
  params[0] = strlit10827;
  partcv[0] = 1;
  Object opresult10831 = callmethod(call10830, "!=", 1, partcv, params);
// compiled op node returning opresult10831 (depth = 5)
  int op_slot_left_10818 = gc_frame_newslot(opresult10831);
  params[0] = opresult10824;
  partcv[0] = 1;
  Object opresult10832 = callmethod(opresult10831, "||", 1, partcv, params);
// compiled op node returning opresult10832 (depth = 4)
  Object if10817 = done;
  if (istrue(opresult10832)) {
// Begin line 3297
  setline(3297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10833 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10835 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10834);
// compiled call node returning call10835 (depth = 8)
// compiled member node returning call10835 (depth = 7)
  partcv[0] = 0;
  Object call10836 = callmethod(call10835, "new",
    1, partcv, params);
  gc_frame_end(callframe10833);
// compiled call node returning call10836 (depth = 6)
// compiled member node returning call10836 (depth = 5)
  *var_suggestion = call10836;
  if (call10836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10837 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block10838 = alloc_Block(NULL, NULL, "parser", 3298);
  gc_frame_newslot(block10838);
// method _apply
  block_savedest(block10838);
  Object closure10839 = createclosure(1, "_apply");
  setclosureframe(closure10839, stackframe);
  addtoclosure(closure10839, selfslot);
  struct UserObject *uo10839 = (struct UserObject*)block10838;
  uo10839->data[0] = (Object)closure10839;
  Method *meth_meth_parser__apply10839 = addmethod2pos(block10838, "_apply", &meth_parser__apply10839, 0);
  int argcv_meth_parser__apply10839[] = {1};
  meth_meth_parser__apply10839->type = alloc_MethodType(1, argcv_meth_parser__apply10839);
  meth_meth_parser__apply10839->definitionModule = modulename;
  meth_meth_parser__apply10839->definitionLine = 3297;
// compiled block node returning block10838 (depth = 6)
  gc_frame_newslot(block10838);
// call case 4: self request
  params[0] = block10838;
  partcv[0] = 1;
  Object call10847 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10837);
// compiled call node returning call10847 (depth = 5)
  *var_nextTok = call10847;
  if (call10847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3299
  setline(3299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10849 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block10850 = alloc_Block(NULL, NULL, "parser", 3299);
  gc_frame_newslot(block10850);
// method _apply
  block_savedest(block10850);
  Object closure10851 = createclosure(3, "_apply");
  setclosureframe(closure10851, stackframe);
  addtoclosure(closure10851, var_sym);
  addtoclosure(closure10851, var_nextTok);
  addtoclosure(closure10851, selfslot);
  struct UserObject *uo10851 = (struct UserObject*)block10850;
  uo10851->data[0] = (Object)closure10851;
  Method *meth_meth_parser__apply10851 = addmethod2pos(block10850, "_apply", &meth_parser__apply10851, 0);
  int argcv_meth_parser__apply10851[] = {0};
  meth_meth_parser__apply10851->type = alloc_MethodType(1, argcv_meth_parser__apply10851);
  meth_meth_parser__apply10851->definitionModule = modulename;
  meth_meth_parser__apply10851->definitionLine = 3298;
// compiled block node returning block10850 (depth = 6)
  gc_frame_newslot(block10850);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool10857 = alloc_Boolean(0);
// compiled identifier node returning bool10857 (depth = 7)
  int op_slot_right_10856 = gc_frame_newslot(bool10857);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_10856 = gc_frame_newslot(*var_nextTok);
  params[0] = bool10857;
  partcv[0] = 1;
  Object opresult10859 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10859 (depth = 6)
  params[0] = block10850;
  partcv[0] = 1;
  Object call10860 = callmethod(opresult10859, "orElse",
    1, partcv, params);
  gc_frame_end(callframe10849);
// compiled call node returning call10860 (depth = 5)
  Object if10848 = done;
  if (istrue(call10860)) {
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10861 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10862 == NULL) {
    strlit10862 = alloc_String(" =");
    gc_root(strlit10862);
  }
// compiled string node returning strlit10862 (depth = 6)
  gc_frame_newslot(strlit10862);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit10862;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10863 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10861);
// compiled call node returning call10863 (depth = 5)
    gc_frame_newslot(call10863);
    if10848 = call10863;
  } else {
// Begin line 3302
  setline(3302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10864 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call10866 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10865);
// compiled call node returning call10866 (depth = 7)
// compiled member node returning call10866 (depth = 6)
  gc_frame_newslot(call10866);
// starting to compile string node (depth = 6)
  if (strlit10867 == NULL) {
    strlit10867 = alloc_String("=");
    gc_root(strlit10867);
  }
// compiled string node returning strlit10867 (depth = 6)
  gc_frame_newslot(strlit10867);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call10866;
  params[2] = strlit10867;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10868 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe10864);
// compiled call node returning call10868 (depth = 5)
    gc_frame_newslot(call10868);
    if10848 = call10868;
  }
// compiled if node returning if10848 (depth = 4)
// Begin line 3304
  setline(3304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10869 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10870 == NULL) {
    strlit10870 = alloc_String("A type declaration must have a '=' after the type name.");
    gc_root(strlit10870);
  }
// compiled string node returning strlit10870 (depth = 5)
  gc_frame_newslot(strlit10870);
// Begin line 3305
  setline(3305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10872 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10871);
// compiled call node returning call10872 (depth = 6)
// compiled member node returning call10872 (depth = 5)
  gc_frame_newslot(call10872);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10874 = alloc_Float64(1);
// compiled num node returning num10874 (depth = 6)
  int op_slot_right_10873 = gc_frame_newslot(num10874);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10877 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10878 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10877);
// compiled call node returning call10878 (depth = 8)
// compiled member node returning call10878 (depth = 7)
  int op_slot_right_10876 = gc_frame_newslot(call10878);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10880 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10881 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10880);
// compiled call node returning call10881 (depth = 8)
// compiled member node returning call10881 (depth = 7)
  int op_slot_left_10876 = gc_frame_newslot(call10881);
  params[0] = call10878;
  partcv[0] = 1;
  Object sum10882 = callmethod(call10881, "+", 1, partcv, params);
// compiled op node returning sum10882 (depth = 6)
  int op_slot_left_10873 = gc_frame_newslot(sum10882);
  params[0] = num10874;
  partcv[0] = 1;
  Object sum10883 = callmethod(sum10882, "+", 1, partcv, params);
// compiled op node returning sum10883 (depth = 5)
  gc_frame_newslot(sum10883);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3304
  setline(3304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10870;
  params[1] = call10872;
  params[2] = sum10883;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10884 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10869);
// compiled call node returning call10884 (depth = 4)
    gc_frame_newslot(call10884);
    if10817 = call10884;
  } else {
  }
// compiled if node returning if10817 (depth = 3)
// Begin line 3307
  setline(3307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10885 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10886 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10885);
// compiled call node returning call10886 (depth = 4)
// compiled member node returning call10886 (depth = 3)
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10888 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10889 == NULL) {
    strlit10889 = alloc_String("lbrace");
    gc_root(strlit10889);
  }
// compiled string node returning strlit10889 (depth = 5)
  gc_frame_newslot(strlit10889);
// call case 4: self request
  params[0] = strlit10889;
  partcv[0] = 1;
  Object call10890 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10888);
// compiled call node returning call10890 (depth = 4)
  Object if10887 = done;
  if (istrue(call10890)) {
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10891 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10892 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10891);
// compiled call node returning call10892 (depth = 5)
// compiled member node returning call10892 (depth = 4)
    gc_frame_newslot(call10892);
    if10887 = call10892;
  } else {
// Begin line 3312
  setline(3312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10893 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noBlocks (depth = 5)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call10894 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10893);
// compiled call node returning call10894 (depth = 4)
    gc_frame_newslot(call10894);
    if10887 = call10894;
  }
// compiled if node returning if10887 (depth = 3)
// Begin line 3314
  setline(3314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10895 = gc_frame_new();
// Begin line 3314
  setline(3314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10896 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10897 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10896);
// compiled call node returning call10897 (depth = 6)
// compiled member node returning call10897 (depth = 5)
  gc_frame_newslot(call10897);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  params[0] = call10897;
  partcv[0] = 1;
  Object call10898 = callmethod(*var_nt, "value:=",
    1, partcv, params);
  gc_frame_end(callframe10895);
// compiled call node returning call10898 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 3315
  setline(3315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_10900 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool10902 = alloc_Boolean(0);
// compiled identifier node returning bool10902 (depth = 5)
  int op_slot_left_10900 = gc_frame_newslot(bool10902);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult10903 = callmethod(bool10902, "!=", 1, partcv, params);
// compiled op node returning opresult10903 (depth = 4)
  Object if10899 = done;
  if (istrue(opresult10903)) {
// Begin line 3316
  setline(3316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10904 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10905 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nt (depth = 7)
  partcv[0] = 0;
  Object call10906 = callmethod(*var_nt, "annotations",
    1, partcv, params);
  gc_frame_end(callframe10905);
// compiled call node returning call10906 (depth = 6)
// compiled member node returning call10906 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call10907 = callmethod(call10906, "addAll",
    1, partcv, params);
  gc_frame_end(callframe10904);
// compiled call node returning call10907 (depth = 4)
    gc_frame_newslot(call10907);
    if10899 = call10907;
  } else {
  }
// compiled if node returning if10899 (depth = 3)
// Begin line 3318
  setline(3318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10908 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  gc_frame_newslot(*var_nt);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call10909 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10908);
// compiled call node returning call10909 (depth = 3)
// Begin line 3319
  setline(3319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10910 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10911 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10910);
// compiled call node returning call10911 (depth = 4)
// compiled member node returning call10911 (depth = 3)
    gc_frame_newslot(call10911);
    if10744 = call10911;
  } else {
  }
// compiled if node returning if10744 (depth = 2)
  gc_frame_end(frame);
  return if10744;
}
Object meth_parser__apply10994(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_suggestion = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3337
  setline(3337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe10995 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit10996 == NULL) {
    strlit10996 = alloc_String(" ");
    gc_root(strlit10996);
  }
// compiled string node returning strlit10996 (depth = 11)
  gc_frame_newslot(strlit10996);
// starting to compile num node (depth = 11)
  Object num10997 = alloc_Float64(1);
// compiled num node returning num10997 (depth = 11)
  gc_frame_newslot(num10997);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10998 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call10999 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10998);
// compiled call node returning call10999 (depth = 12)
// compiled member node returning call10999 (depth = 11)
  gc_frame_newslot(call10999);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit10996;
  params[1] = num10997;
  params[2] = call10999;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11000 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe10995);
// compiled call node returning call11000 (depth = 10)
  gc_frame_end(frame);
  return call11000;
}
Object meth_parser__apply11012(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_11014 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call11017 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe11016);
// compiled call node returning call11017 (depth = 13)
// compiled member node returning call11017 (depth = 12)
  int op_slot_left_11014 = gc_frame_newslot(call11017);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult11018 = callmethod(call11017, ">=", 1, partcv, params);
// compiled op node returning opresult11018 (depth = 11)
  int op_slot_right_11013 = gc_frame_newslot(opresult11018);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num11022 = alloc_Float64(1);
// compiled num node returning num11022 (depth = 13)
  int op_slot_right_11021 = gc_frame_newslot(num11022);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe11024 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call11025 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe11024);
// compiled call node returning call11025 (depth = 14)
// compiled member node returning call11025 (depth = 13)
  int op_slot_left_11021 = gc_frame_newslot(call11025);
  params[0] = num11022;
  partcv[0] = 1;
  Object sum11026 = callmethod(call11025, "+", 1, partcv, params);
// compiled op node returning sum11026 (depth = 12)
  int op_slot_right_11020 = gc_frame_newslot(sum11026);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call11029 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11028);
// compiled call node returning call11029 (depth = 13)
// compiled member node returning call11029 (depth = 12)
  int op_slot_left_11020 = gc_frame_newslot(call11029);
  params[0] = sum11026;
  partcv[0] = 1;
  Object opresult11030 = callmethod(call11029, "!=", 1, partcv, params);
// compiled op node returning opresult11030 (depth = 11)
  int op_slot_left_11013 = gc_frame_newslot(opresult11030);
  params[0] = opresult11018;
  partcv[0] = 1;
  Object opresult11031 = callmethod(opresult11030, "||", 1, partcv, params);
// compiled op node returning opresult11031 (depth = 10)
  gc_frame_end(frame);
  return opresult11031;
}
Object meth_parser__apply11034(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call11036 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11035);
// compiled call node returning call11036 (depth = 12)
// compiled member node returning call11036 (depth = 11)
  *var_tok = call11036;
  if (call11036 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply11049(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3346
  setline(3346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit11051 == NULL) {
    strlit11051 = alloc_String(" ");
    gc_root(strlit11051);
  }
// compiled string node returning strlit11051 (depth = 12)
  int op_slot_right_11050 = gc_frame_newslot(strlit11051);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  int op_slot_left_11050 = gc_frame_newslot(*var_line);
  params[0] = strlit11051;
  partcv[0] = 1;
  Object opresult11053 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult11053 (depth = 11)
  *var_line = opresult11053;
  if (opresult11053 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_checkIndent10912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tok");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
// Begin line 3324
  setline(3324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  Object if10913 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 3325
  setline(3325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10914 = alloc_Boolean(0);
// compiled identifier node returning bool10914 (depth = 4)
  *var_indentFreePass = bool10914;
  if (bool10914 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10913 = done;
  } else {
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3326
  setline(3326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10918 == NULL) {
    strlit10918 = alloc_String("semicolon");
    gc_root(strlit10918);
  }
// compiled string node returning strlit10918 (depth = 5)
  int op_slot_right_10917 = gc_frame_newslot(strlit10918);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10920 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10921 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10920);
// compiled call node returning call10921 (depth = 6)
// compiled member node returning call10921 (depth = 5)
  int op_slot_left_10917 = gc_frame_newslot(call10921);
  params[0] = strlit10918;
  partcv[0] = 1;
  Object opresult10922 = callmethod(call10921, "==", 1, partcv, params);
// compiled op node returning opresult10922 (depth = 4)
  Object if10916 = done;
  if (istrue(opresult10922)) {
    gc_frame_newslot(done);
    if10916 = done;
  } else {
// Begin line 3331
  setline(3331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 3329
  setline(3329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10926 == NULL) {
    strlit10926 = alloc_String("rsquare");
    gc_root(strlit10926);
  }
// compiled string node returning strlit10926 (depth = 7)
  int op_slot_right_10925 = gc_frame_newslot(strlit10926);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10929 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10928);
// compiled call node returning call10929 (depth = 8)
// compiled member node returning call10929 (depth = 7)
  int op_slot_left_10925 = gc_frame_newslot(call10929);
  params[0] = strlit10926;
  partcv[0] = 1;
  Object opresult10930 = callmethod(call10929, "==", 1, partcv, params);
// compiled op node returning opresult10930 (depth = 6)
  int op_slot_right_10924 = gc_frame_newslot(opresult10930);
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10934 == NULL) {
    strlit10934 = alloc_String("rparen");
    gc_root(strlit10934);
  }
// compiled string node returning strlit10934 (depth = 8)
  int op_slot_right_10933 = gc_frame_newslot(strlit10934);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10937 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10936);
// compiled call node returning call10937 (depth = 9)
// compiled member node returning call10937 (depth = 8)
  int op_slot_left_10933 = gc_frame_newslot(call10937);
  params[0] = strlit10934;
  partcv[0] = 1;
  Object opresult10938 = callmethod(call10937, "==", 1, partcv, params);
// compiled op node returning opresult10938 (depth = 7)
  int op_slot_right_10932 = gc_frame_newslot(opresult10938);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10941 == NULL) {
    strlit10941 = alloc_String("rbrace");
    gc_root(strlit10941);
  }
// compiled string node returning strlit10941 (depth = 8)
  int op_slot_right_10940 = gc_frame_newslot(strlit10941);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10943 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10944 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10943);
// compiled call node returning call10944 (depth = 9)
// compiled member node returning call10944 (depth = 8)
  int op_slot_left_10940 = gc_frame_newslot(call10944);
  params[0] = strlit10941;
  partcv[0] = 1;
  Object opresult10945 = callmethod(call10944, "==", 1, partcv, params);
// compiled op node returning opresult10945 (depth = 7)
  int op_slot_left_10932 = gc_frame_newslot(opresult10945);
  params[0] = opresult10938;
  partcv[0] = 1;
  Object opresult10946 = callmethod(opresult10945, "||", 1, partcv, params);
// compiled op node returning opresult10946 (depth = 6)
  int op_slot_left_10924 = gc_frame_newslot(opresult10946);
  params[0] = opresult10930;
  partcv[0] = 1;
  Object opresult10947 = callmethod(opresult10946, "||", 1, partcv, params);
// compiled op node returning opresult10947 (depth = 5)
  Object if10923 = done;
  if (istrue(opresult10947)) {
    gc_frame_newslot(done);
    if10923 = done;
  } else {
// Begin line 3332
  setline(3332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3331
  setline(3331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10950 == NULL) {
    strlit10950 = alloc_String("eof");
    gc_root(strlit10950);
  }
// compiled string node returning strlit10950 (depth = 7)
  int op_slot_right_10949 = gc_frame_newslot(strlit10950);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10952 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10953 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10952);
// compiled call node returning call10953 (depth = 8)
// compiled member node returning call10953 (depth = 7)
  int op_slot_left_10949 = gc_frame_newslot(call10953);
  params[0] = strlit10950;
  partcv[0] = 1;
  Object opresult10954 = callmethod(call10953, "==", 1, partcv, params);
// compiled op node returning opresult10954 (depth = 6)
  Object if10948 = done;
  if (istrue(opresult10954)) {
    gc_frame_newslot(done);
    if10948 = done;
  } else {
// Begin line 3354
  setline(3354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3332
  setline(3332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minIndentLevel (depth = 8)
  int op_slot_right_10956 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10958 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10959 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10958);
// compiled call node returning call10959 (depth = 9)
// compiled member node returning call10959 (depth = 8)
  int op_slot_left_10956 = gc_frame_newslot(call10959);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10960 = callmethod(call10959, "<", 1, partcv, params);
// compiled op node returning opresult10960 (depth = 7)
  Object if10955 = done;
  if (istrue(opresult10960)) {
// Begin line 3333
  setline(3333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_10962 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10965 = alloc_Float64(1);
// compiled num node returning num10965 (depth = 10)
  int op_slot_right_10964 = gc_frame_newslot(num10965);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10967 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10968 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10967);
// compiled call node returning call10968 (depth = 11)
// compiled member node returning call10968 (depth = 10)
  int op_slot_left_10964 = gc_frame_newslot(call10968);
  params[0] = num10965;
  partcv[0] = 1;
  Object diff10969 = callmethod(call10968, "-", 1, partcv, params);
// compiled op node returning diff10969 (depth = 9)
  int op_slot_left_10962 = gc_frame_newslot(diff10969);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10970 = callmethod(diff10969, "!=", 1, partcv, params);
// compiled op node returning opresult10970 (depth = 8)
  Object if10961 = done;
  if (istrue(opresult10970)) {
// Begin line 3334
  setline(3334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10971 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10972 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10973 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10972);
// compiled call node returning call10973 (depth = 12)
// compiled member node returning call10973 (depth = 11)
  partcv[0] = 0;
  Object call10974 = callmethod(call10973, "empty",
    1, partcv, params);
  gc_frame_end(callframe10971);
// compiled call node returning call10974 (depth = 10)
// compiled member node returning call10974 (depth = 9)
  *var_suggestions = call10974;
  if (call10974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 3335
  setline(3335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10975 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10976 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call10977 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10976);
// compiled call node returning call10977 (depth = 12)
// compiled member node returning call10977 (depth = 11)
  partcv[0] = 0;
  Object call10978 = callmethod(call10977, "new",
    1, partcv, params);
  gc_frame_end(callframe10975);
// compiled call node returning call10978 (depth = 10)
// compiled member node returning call10978 (depth = 9)
  *var_suggestion = call10978;
  if (call10978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10979 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num10983 = alloc_Float64(1);
// compiled num node returning num10983 (depth = 12)
  int op_slot_right_10982 = gc_frame_newslot(num10983);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call10986 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10985);
// compiled call node returning call10986 (depth = 13)
// compiled member node returning call10986 (depth = 12)
  int op_slot_left_10982 = gc_frame_newslot(call10986);
  params[0] = num10983;
  partcv[0] = 1;
  Object diff10987 = callmethod(call10986, "-", 1, partcv, params);
// compiled op node returning diff10987 (depth = 11)
  int op_slot_right_10981 = gc_frame_newslot(diff10987);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_left_10981 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff10987;
  partcv[0] = 1;
  Object diff10989 = callmethod(*var_minIndentLevel, "-", 1, partcv, params);
// compiled op node returning diff10989 (depth = 10)
  int op_slot_right_10980 = gc_frame_newslot(diff10989);
// starting to compile num node (depth = 10)
  Object num10991 = alloc_Float64(1);
// compiled num node returning num10991 (depth = 10)
  int op_slot_left_10980 = gc_frame_newslot(num10991);
  params[0] = diff10989;
  partcv[0] = 1;
  Object opresult10992 = callmethod(num10991, "..", 1, partcv, params);
// compiled op node returning opresult10992 (depth = 9)
  gc_frame_newslot(opresult10992);
// starting to compile block node (depth = 9)
  Object block10993 = alloc_Block(NULL, NULL, "parser", 3336);
  gc_frame_newslot(block10993);
// method _apply
  block_savedest(block10993);
  Object closure10994 = createclosure(3, "_apply");
  setclosureframe(closure10994, stackframe);
  addtoclosure(closure10994, var_sym);
  addtoclosure(closure10994, var_suggestion);
  addtoclosure(closure10994, selfslot);
  struct UserObject *uo10994 = (struct UserObject*)block10993;
  uo10994->data[0] = (Object)closure10994;
  Method *meth_meth_parser__apply10994 = addmethod2pos(block10993, "_apply", &meth_parser__apply10994, 0);
  int argcv_meth_parser__apply10994[] = {1};
  meth_meth_parser__apply10994->type = alloc_MethodType(1, argcv_meth_parser__apply10994);
  meth_meth_parser__apply10994->definitionModule = modulename;
  meth_meth_parser__apply10994->definitionLine = 3336;
// compiled block node returning block10993 (depth = 9)
  gc_frame_newslot(block10993);
// call case 5: prelude request
  params[0] = opresult10992;
  params[1] = block10993;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11002 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10979);
// compiled call node returning call11002 (depth = 8)
// Begin line 3339
  setline(3339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11003 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11004 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11003);
// compiled call node returning call11004 (depth = 8)
// Begin line 3340
  setline(3340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11005 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call11007 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11006);
// compiled call node returning call11007 (depth = 12)
// compiled member node returning call11007 (depth = 11)
  partcv[0] = 0;
  Object call11008 = callmethod(call11007, "new",
    1, partcv, params);
  gc_frame_end(callframe11005);
// compiled call node returning call11008 (depth = 10)
// compiled member node returning call11008 (depth = 9)
  *var_suggestion = call11008;
  if (call11008 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3342
  setline(3342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3343
  setline(3343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11010 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block11011 = alloc_Block(NULL, NULL, "parser", 3343);
  gc_frame_newslot(block11011);
// method _apply
  block_savedest(block11011);
  Object closure11012 = createclosure(3, "_apply");
  setclosureframe(closure11012, stackframe);
  addtoclosure(closure11012, var_minIndentLevel);
  addtoclosure(closure11012, var_tok);
  addtoclosure(closure11012, selfslot);
  struct UserObject *uo11012 = (struct UserObject*)block11011;
  uo11012->data[0] = (Object)closure11012;
  Method *meth_meth_parser__apply11012 = addmethod2pos(block11011, "_apply", &meth_parser__apply11012, 0);
  int argcv_meth_parser__apply11012[] = {0};
  meth_meth_parser__apply11012->type = alloc_MethodType(1, argcv_meth_parser__apply11012);
  meth_meth_parser__apply11012->definitionModule = modulename;
  meth_meth_parser__apply11012->definitionLine = 3340;
// compiled block node returning block11011 (depth = 9)
  gc_frame_newslot(block11011);
// starting to compile block node (depth = 9)
  Object block11033 = alloc_Block(NULL, NULL, "parser", 3343);
  gc_frame_newslot(block11033);
// method _apply
  block_savedest(block11033);
  Object closure11034 = createclosure(2, "_apply");
  setclosureframe(closure11034, stackframe);
  addtoclosure(closure11034, var_tok);
  addtoclosure(closure11034, selfslot);
  struct UserObject *uo11034 = (struct UserObject*)block11033;
  uo11034->data[0] = (Object)closure11034;
  Method *meth_meth_parser__apply11034 = addmethod2pos(block11033, "_apply", &meth_parser__apply11034, 0);
  int argcv_meth_parser__apply11034[] = {0};
  meth_meth_parser__apply11034->type = alloc_MethodType(1, argcv_meth_parser__apply11034);
  meth_meth_parser__apply11034->definitionModule = modulename;
  meth_meth_parser__apply11034->definitionLine = 3343;
// compiled block node returning block11033 (depth = 9)
  gc_frame_newslot(block11033);
// call case 5: prelude request
  params[0] = block11011;
  params[1] = block11033;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11039 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11010);
// compiled call node returning call11039 (depth = 8)
// Begin line 3344
  setline(3344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11040 == NULL) {
    strlit11040 = alloc_String("");
    gc_root(strlit11040);
  }
// compiled string node returning strlit11040 (depth = 9)
  *var_line = strlit11040;
  if (strlit11040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3345
  setline(3345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11041 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11043 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call11044 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe11043);
// compiled call node returning call11044 (depth = 11)
// compiled member node returning call11044 (depth = 10)
  int op_slot_right_11042 = gc_frame_newslot(call11044);
// starting to compile num node (depth = 10)
  Object num11046 = alloc_Float64(1);
// compiled num node returning num11046 (depth = 10)
  int op_slot_left_11042 = gc_frame_newslot(num11046);
  params[0] = call11044;
  partcv[0] = 1;
  Object opresult11047 = callmethod(num11046, "..", 1, partcv, params);
// compiled op node returning opresult11047 (depth = 9)
  gc_frame_newslot(opresult11047);
// starting to compile block node (depth = 9)
  Object block11048 = alloc_Block(NULL, NULL, "parser", 3345);
  gc_frame_newslot(block11048);
// method _apply
  block_savedest(block11048);
  Object closure11049 = createclosure(2, "_apply");
  setclosureframe(closure11049, stackframe);
  addtoclosure(closure11049, var_line);
  addtoclosure(closure11049, selfslot);
  struct UserObject *uo11049 = (struct UserObject*)block11048;
  uo11049->data[0] = (Object)closure11049;
  Method *meth_meth_parser__apply11049 = addmethod2pos(block11048, "_apply", &meth_parser__apply11049, 0);
  int argcv_meth_parser__apply11049[] = {1};
  meth_meth_parser__apply11049->type = alloc_MethodType(1, argcv_meth_parser__apply11049);
  meth_meth_parser__apply11049->definitionModule = modulename;
  meth_meth_parser__apply11049->definitionLine = 3345;
// compiled block node returning block11048 (depth = 9)
  gc_frame_newslot(block11048);
// call case 5: prelude request
  params[0] = opresult11047;
  params[1] = block11048;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11056 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11041);
// compiled call node returning call11056 (depth = 8)
// Begin line 3348
  setline(3348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11058 == NULL) {
    strlit11058 = alloc_String("}");
    gc_root(strlit11058);
  }
// compiled string node returning strlit11058 (depth = 10)
  int op_slot_right_11057 = gc_frame_newslot(strlit11058);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_11057 = gc_frame_newslot(*var_line);
  params[0] = strlit11058;
  partcv[0] = 1;
  Object opresult11060 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult11060 (depth = 9)
  *var_line = opresult11060;
  if (opresult11060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3349
  setline(3349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11062 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num11064 = alloc_Float64(0.9);
// compiled num node returning num11064 (depth = 10)
  int op_slot_right_11063 = gc_frame_newslot(num11064);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11066 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11067 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11066);
// compiled call node returning call11067 (depth = 11)
// compiled member node returning call11067 (depth = 10)
  int op_slot_left_11063 = gc_frame_newslot(call11067);
  params[0] = num11064;
  partcv[0] = 1;
  Object diff11068 = callmethod(call11067, "-", 1, partcv, params);
// compiled op node returning diff11068 (depth = 9)
  gc_frame_newslot(diff11068);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff11068;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call11069 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11062);
// compiled call node returning call11069 (depth = 8)
// Begin line 3350
  setline(3350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11070 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11071 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11070);
// compiled call node returning call11071 (depth = 8)
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11072 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11074 == NULL) {
    strlit11074 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit11074);
  }
// compiled string node returning strlit11074 (depth = 10)
  int op_slot_right_11073 = gc_frame_newslot(strlit11074);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_right_11076 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile string node (depth = 11)
  if (strlit11078 == NULL) {
    strlit11078 = alloc_String("The indentation for this line must be at least ");
    gc_root(strlit11078);
  }
// compiled string node returning strlit11078 (depth = 11)
  int op_slot_left_11076 = gc_frame_newslot(strlit11078);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult11079 = callmethod(strlit11078, "++", 1, partcv, params);
// compiled op node returning opresult11079 (depth = 10)
  int op_slot_left_11073 = gc_frame_newslot(opresult11079);
  params[0] = strlit11074;
  partcv[0] = 1;
  Object opresult11080 = callmethod(opresult11079, "++", 1, partcv, params);
// compiled op node returning opresult11080 (depth = 9)
  gc_frame_newslot(opresult11080);
// Begin line 3352
  setline(3352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11081 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11082 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11081);
// compiled call node returning call11082 (depth = 10)
// compiled member node returning call11082 (depth = 9)
  gc_frame_newslot(call11082);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11084 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11083);
// compiled call node returning call11084 (depth = 10)
// compiled member node returning call11084 (depth = 9)
  gc_frame_newslot(call11084);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult11080;
  params[1] = call11082;
  params[2] = call11084;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11085 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11072);
// compiled call node returning call11085 (depth = 8)
    gc_frame_newslot(call11085);
    if10961 = call11085;
  } else {
  }
// compiled if node returning if10961 (depth = 7)
    gc_frame_newslot(if10961);
    if10955 = if10961;
  } else {
// Begin line 3357
  setline(3357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3354
  setline(3354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_11087 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11089 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11090 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11089);
// compiled call node returning call11090 (depth = 10)
// compiled member node returning call11090 (depth = 9)
  int op_slot_left_11087 = gc_frame_newslot(call11090);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult11091 = callmethod(call11090, ">", 1, partcv, params);
// compiled op node returning opresult11091 (depth = 8)
  Object if11086 = done;
  if (istrue(opresult11091)) {
// Begin line 3355
  setline(3355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11092 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11093 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11092);
// compiled call node returning call11093 (depth = 10)
// compiled member node returning call11093 (depth = 9)
  *var_minIndentLevel = call11093;
  if (call11093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if11086 = done;
  } else {
  }
// compiled if node returning if11086 (depth = 7)
    gc_frame_newslot(if11086);
    if10955 = if11086;
  }
// compiled if node returning if10955 (depth = 6)
    gc_frame_newslot(if10955);
    if10948 = if10955;
  }
// compiled if node returning if10948 (depth = 5)
    gc_frame_newslot(if10948);
    if10923 = if10948;
  }
// compiled if node returning if10923 (depth = 4)
    gc_frame_newslot(if10923);
    if10916 = if10923;
  }
// compiled if node returning if10916 (depth = 3)
    gc_frame_newslot(if10916);
    if10913 = if10916;
  }
// compiled if node returning if10913 (depth = 2)
  gc_frame_end(frame);
  return if10913;
}
Object meth_parser__apply11182(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe11183 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call11184 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11183);
// compiled call node returning call11184 (depth = 5)
  gc_frame_end(frame);
  return call11184;
}
Object meth_parser__apply11233(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe11234 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call11235 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11234);
// compiled call node returning call11235 (depth = 11)
  gc_frame_end(frame);
  return call11235;
}
Object meth_parser__apply11187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_btok = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dest = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "dest");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 3395
  setline(3395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11190 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit11191 == NULL) {
    strlit11191 = alloc_String("bind");
    gc_root(strlit11191);
  }
// compiled string node returning strlit11191 (depth = 8)
  gc_frame_newslot(strlit11191);
// call case 4: self request
  params[0] = strlit11191;
  partcv[0] = 1;
  Object call11192 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11190);
// compiled call node returning call11192 (depth = 7)
  int op_slot_right_11189 = gc_frame_newslot(call11192);
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 3394
  setline(3394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11196 == NULL) {
    strlit11196 = alloc_String("index");
    gc_root(strlit11196);
  }
// compiled string node returning strlit11196 (depth = 9)
  int op_slot_right_11195 = gc_frame_newslot(strlit11196);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11198 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11199 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  partcv[0] = 0;
  Object call11200 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11199);
// compiled call node returning call11200 (depth = 12)
// compiled member node returning call11200 (depth = 11)
  partcv[0] = 0;
  Object call11201 = callmethod(call11200, "kind",
    1, partcv, params);
  gc_frame_end(callframe11198);
// compiled call node returning call11201 (depth = 10)
// compiled member node returning call11201 (depth = 9)
  int op_slot_left_11195 = gc_frame_newslot(call11201);
  params[0] = strlit11196;
  partcv[0] = 1;
  Object opresult11202 = callmethod(call11201, "==", 1, partcv, params);
// compiled op node returning opresult11202 (depth = 8)
  int op_slot_right_11194 = gc_frame_newslot(opresult11202);
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 3393
  setline(3393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11206 == NULL) {
    strlit11206 = alloc_String("member");
    gc_root(strlit11206);
  }
// compiled string node returning strlit11206 (depth = 10)
  int op_slot_right_11205 = gc_frame_newslot(strlit11206);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11208 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11209 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call11210 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11209);
// compiled call node returning call11210 (depth = 13)
// compiled member node returning call11210 (depth = 12)
  partcv[0] = 0;
  Object call11211 = callmethod(call11210, "kind",
    1, partcv, params);
  gc_frame_end(callframe11208);
// compiled call node returning call11211 (depth = 11)
// compiled member node returning call11211 (depth = 10)
  int op_slot_left_11205 = gc_frame_newslot(call11211);
  params[0] = strlit11206;
  partcv[0] = 1;
  Object opresult11212 = callmethod(call11211, "==", 1, partcv, params);
// compiled op node returning opresult11212 (depth = 9)
  int op_slot_right_11204 = gc_frame_newslot(opresult11212);
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11215 == NULL) {
    strlit11215 = alloc_String("identifier");
    gc_root(strlit11215);
  }
// compiled string node returning strlit11215 (depth = 10)
  int op_slot_right_11214 = gc_frame_newslot(strlit11215);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11217 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11218 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call11219 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11218);
// compiled call node returning call11219 (depth = 13)
// compiled member node returning call11219 (depth = 12)
  partcv[0] = 0;
  Object call11220 = callmethod(call11219, "kind",
    1, partcv, params);
  gc_frame_end(callframe11217);
// compiled call node returning call11220 (depth = 11)
// compiled member node returning call11220 (depth = 10)
  int op_slot_left_11214 = gc_frame_newslot(call11220);
  params[0] = strlit11215;
  partcv[0] = 1;
  Object opresult11221 = callmethod(call11220, "==", 1, partcv, params);
// compiled op node returning opresult11221 (depth = 9)
  int op_slot_left_11204 = gc_frame_newslot(opresult11221);
  params[0] = opresult11212;
  partcv[0] = 1;
  Object opresult11222 = callmethod(opresult11221, "||", 1, partcv, params);
// compiled op node returning opresult11222 (depth = 8)
  int op_slot_left_11194 = gc_frame_newslot(opresult11222);
  params[0] = opresult11202;
  partcv[0] = 1;
  Object opresult11223 = callmethod(opresult11222, "||", 1, partcv, params);
// compiled op node returning opresult11223 (depth = 7)
  int op_slot_left_11189 = gc_frame_newslot(opresult11223);
  params[0] = call11192;
  partcv[0] = 1;
  Object opresult11224 = callmethod(opresult11223, "&&", 1, partcv, params);
// compiled op node returning opresult11224 (depth = 6)
  Object if11188 = done;
  if (istrue(opresult11224)) {
// Begin line 3396
  setline(3396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11226 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe11225);
// compiled call node returning call11226 (depth = 8)
// compiled member node returning call11226 (depth = 7)
  *var_dest = call11226;
  if (call11226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3397
  setline(3397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11227 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11228 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11227);
// compiled call node returning call11228 (depth = 7)
// compiled member node returning call11228 (depth = 6)
// Begin line 3398
  setline(3398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11230 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe11231 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block11232 = alloc_Block(NULL, NULL, "parser", 3398);
  gc_frame_newslot(block11232);
// method _apply
  block_savedest(block11232);
  Object closure11233 = createclosure(2, "_apply");
  setclosureframe(closure11233, stackframe);
  addtoclosure(closure11233, var_blocksOK);
  addtoclosure(closure11233, selfslot);
  struct UserObject *uo11233 = (struct UserObject*)block11232;
  uo11233->data[0] = (Object)closure11233;
  Method *meth_meth_parser__apply11233 = addmethod2pos(block11232, "_apply", &meth_parser__apply11233, 0);
  int argcv_meth_parser__apply11233[] = {0};
  meth_meth_parser__apply11233->type = alloc_MethodType(1, argcv_meth_parser__apply11233);
  meth_meth_parser__apply11233->definitionModule = modulename;
  meth_meth_parser__apply11233->definitionLine = 3398;
// compiled block node returning block11232 (depth = 10)
  gc_frame_newslot(block11232);
// call case 4: self request
  params[0] = block11232;
  partcv[0] = 1;
  Object call11237 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11231);
// compiled call node returning call11237 (depth = 9)
  partcv[0] = 0;
  Object call11238 = callmethod(call11237, "not",
    1, partcv, params);
  gc_frame_end(callframe11230);
// compiled call node returning call11238 (depth = 8)
// compiled member node returning call11238 (depth = 7)
  Object if11229 = done;
  if (istrue(call11238)) {
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11239 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11240 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11241 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11240);
// compiled call node returning call11241 (depth = 11)
// compiled member node returning call11241 (depth = 10)
  partcv[0] = 0;
  Object call11242 = callmethod(call11241, "empty",
    1, partcv, params);
  gc_frame_end(callframe11239);
// compiled call node returning call11242 (depth = 9)
// compiled member node returning call11242 (depth = 8)
  *var_suggestions = call11242;
  if (call11242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3400
  setline(3400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11243 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call11245 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11244);
// compiled call node returning call11245 (depth = 11)
// compiled member node returning call11245 (depth = 10)
  partcv[0] = 0;
  Object call11246 = callmethod(call11245, "new",
    1, partcv, params);
  gc_frame_end(callframe11243);
// compiled call node returning call11246 (depth = 9)
// compiled member node returning call11246 (depth = 8)
  *var_suggestion = call11246;
  if (call11246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 3401
  setline(3401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11247 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit11248 == NULL) {
    strlit11248 = alloc_String("rbrace");
    gc_root(strlit11248);
  }
// compiled string node returning strlit11248 (depth = 9)
  gc_frame_newslot(strlit11248);
// call case 4: self request
  params[0] = strlit11248;
  partcv[0] = 1;
  Object call11249 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11247);
// compiled call node returning call11249 (depth = 8)
  *var_nextTok = call11249;
  if (call11249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3402
  setline(3402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_11251 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_11251 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult11253 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult11253 (depth = 8)
  Object if11250 = done;
  if (istrue(opresult11253)) {
// Begin line 3403
  setline(3403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11254 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit11255 == NULL) {
    strlit11255 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit11255);
  }
// compiled string node returning strlit11255 (depth = 9)
  gc_frame_newslot(strlit11255);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit11255;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11256 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe11254);
// compiled call node returning call11256 (depth = 8)
    gc_frame_newslot(call11256);
    if11250 = call11256;
  } else {
// Begin line 3405
  setline(3405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11257 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11258 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call11259 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11258);
// compiled call node returning call11259 (depth = 10)
// compiled member node returning call11259 (depth = 9)
  gc_frame_newslot(call11259);
// starting to compile identifier node (depth = 9)
  Object bool11260 = alloc_Boolean(1);
// compiled identifier node returning bool11260 (depth = 9)
  gc_frame_newslot(bool11260);
// starting to compile identifier node (depth = 9)
  Object bool11261 = alloc_Boolean(0);
// compiled identifier node returning bool11261 (depth = 9)
  gc_frame_newslot(bool11261);
// starting to compile string node (depth = 9)
  if (strlit11262 == NULL) {
    strlit11262 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit11262);
  }
// compiled string node returning strlit11262 (depth = 9)
  gc_frame_newslot(strlit11262);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call11259;
  params[2] = bool11260;
  params[3] = bool11261;
  params[4] = strlit11262;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11263 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11257);
// compiled call node returning call11263 (depth = 8)
    gc_frame_newslot(call11263);
    if11250 = call11263;
  }
// compiled if node returning if11250 (depth = 7)
// Begin line 3407
  setline(3407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11264 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11265 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11264);
// compiled call node returning call11265 (depth = 7)
// Begin line 3408
  setline(3408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11266 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11267 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call11268 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11267);
// compiled call node returning call11268 (depth = 11)
// compiled member node returning call11268 (depth = 10)
  partcv[0] = 0;
  Object call11269 = callmethod(call11268, "new",
    1, partcv, params);
  gc_frame_end(callframe11266);
// compiled call node returning call11269 (depth = 9)
// compiled member node returning call11269 (depth = 8)
  *var_suggestion = call11269;
  if (call11269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3409
  setline(3409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11271 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call11273 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11272);
// compiled call node returning call11273 (depth = 9)
// compiled member node returning call11273 (depth = 8)
  gc_frame_newslot(call11273);
// starting to compile identifier node (depth = 8)
  Object bool11274 = alloc_Boolean(1);
// compiled identifier node returning bool11274 (depth = 8)
  gc_frame_newslot(bool11274);
// starting to compile identifier node (depth = 8)
  Object bool11275 = alloc_Boolean(0);
// compiled identifier node returning bool11275 (depth = 8)
  gc_frame_newslot(bool11275);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call11273;
  params[2] = bool11274;
  params[3] = bool11275;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11276 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe11271);
// compiled call node returning call11276 (depth = 7)
// Begin line 3410
  setline(3410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11277 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11278 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11277);
// compiled call node returning call11278 (depth = 7)
// Begin line 3411
  setline(3411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11279 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit11280 == NULL) {
    strlit11280 = alloc_String("A valid expression must follow ':='.");
    gc_root(strlit11280);
  }
// compiled string node returning strlit11280 (depth = 8)
  gc_frame_newslot(strlit11280);
// Begin line 3412
  setline(3412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11282 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11281);
// compiled call node returning call11282 (depth = 9)
// compiled member node returning call11282 (depth = 8)
  gc_frame_newslot(call11282);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11283 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11284 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11283);
// compiled call node returning call11284 (depth = 9)
// compiled member node returning call11284 (depth = 8)
  gc_frame_newslot(call11284);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3411
  setline(3411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit11280;
  params[1] = call11282;
  params[2] = call11284;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11285 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11279);
// compiled call node returning call11285 (depth = 7)
    gc_frame_newslot(call11285);
    if11229 = call11285;
  } else {
  }
// compiled if node returning if11229 (depth = 6)
// Begin line 3414
  setline(3414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11286 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11287 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe11286);
// compiled call node returning call11287 (depth = 8)
// compiled member node returning call11287 (depth = 7)
  *var_val = call11287;
  if (call11287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3415
  setline(3415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11288 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11289 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call11290 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe11289);
// compiled call node returning call11290 (depth = 8)
// compiled member node returning call11290 (depth = 7)
  gc_frame_newslot(call11290);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11291 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call11292 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11291);
// compiled call node returning call11292 (depth = 8)
// compiled member node returning call11292 (depth = 7)
  gc_frame_newslot(call11292);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call11290;
  params[1] = call11292;
  partcv[0] = 2;
  Object call11293 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe11288);
// compiled call node returning call11293 (depth = 6)
// Begin line 3416
  setline(3416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11294 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_dest (depth = 8)
  gc_frame_newslot(*var_dest);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_val (depth = 8)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11295 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call11296 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe11295);
// compiled call node returning call11296 (depth = 9)
// compiled member node returning call11296 (depth = 8)
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call11297 = callmethod(call11296, "new",
    1, partcv, params);
  gc_frame_end(callframe11294);
// compiled call node returning call11297 (depth = 7)
  *var_o = call11297;
  if (call11297 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3417
  setline(3417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11298 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call11299 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe11298);
// compiled call node returning call11299 (depth = 6)
    gc_frame_newslot(call11299);
    if11188 = call11299;
  } else {
  }
// compiled if node returning if11188 (depth = 5)
  gc_frame_end(frame);
  return if11188;
}
Object meth_parser_statement11095(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_indentFreePass = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for statement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_oldLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldLine");
// Begin line 3366
  setline(3366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11096 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call11097 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11096);
// compiled call node returning call11097 (depth = 4)
// compiled member node returning call11097 (depth = 3)
  *var_statementIndent = call11097;
  if (call11097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3367
  setline(3367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3368
  setline(3368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3369
  setline(3369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11101 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11100);
// compiled call node returning call11101 (depth = 3)
// compiled member node returning call11101 (depth = 2)
// Begin line 3370
  setline(3370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11103 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11104 == NULL) {
    strlit11104 = alloc_String("keyword");
    gc_root(strlit11104);
  }
// compiled string node returning strlit11104 (depth = 4)
  gc_frame_newslot(strlit11104);
// call case 4: self request
  params[0] = strlit11104;
  partcv[0] = 1;
  Object call11105 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11103);
// compiled call node returning call11105 (depth = 3)
  Object if11102 = done;
  if (istrue(call11105)) {
// Begin line 3371
  setline(3371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11108 == NULL) {
    strlit11108 = alloc_String("var");
    gc_root(strlit11108);
  }
// compiled string node returning strlit11108 (depth = 5)
  int op_slot_right_11107 = gc_frame_newslot(strlit11108);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11111 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11110);
// compiled call node returning call11111 (depth = 6)
// compiled member node returning call11111 (depth = 5)
  int op_slot_left_11107 = gc_frame_newslot(call11111);
  params[0] = strlit11108;
  partcv[0] = 1;
  Object opresult11112 = callmethod(call11111, "==", 1, partcv, params);
// compiled op node returning opresult11112 (depth = 4)
  Object if11106 = done;
  if (istrue(opresult11112)) {
// Begin line 3372
  setline(3372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11113 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11114 = callmethodflags(self, "vardec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11113);
// compiled call node returning call11114 (depth = 5)
// compiled member node returning call11114 (depth = 4)
    gc_frame_newslot(call11114);
    if11106 = call11114;
  } else {
// Begin line 3375
  setline(3375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3373
  setline(3373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11117 == NULL) {
    strlit11117 = alloc_String("def");
    gc_root(strlit11117);
  }
// compiled string node returning strlit11117 (depth = 6)
  int op_slot_right_11116 = gc_frame_newslot(strlit11117);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11120 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11119);
// compiled call node returning call11120 (depth = 7)
// compiled member node returning call11120 (depth = 6)
  int op_slot_left_11116 = gc_frame_newslot(call11120);
  params[0] = strlit11117;
  partcv[0] = 1;
  Object opresult11121 = callmethod(call11120, "==", 1, partcv, params);
// compiled op node returning opresult11121 (depth = 5)
  Object if11115 = done;
  if (istrue(opresult11121)) {
// Begin line 3374
  setline(3374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11123 = callmethodflags(self, "defdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11122);
// compiled call node returning call11123 (depth = 6)
// compiled member node returning call11123 (depth = 5)
    gc_frame_newslot(call11123);
    if11115 = call11123;
  } else {
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3375
  setline(3375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11126 == NULL) {
    strlit11126 = alloc_String("import");
    gc_root(strlit11126);
  }
// compiled string node returning strlit11126 (depth = 7)
  int op_slot_right_11125 = gc_frame_newslot(strlit11126);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11129 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11128);
// compiled call node returning call11129 (depth = 8)
// compiled member node returning call11129 (depth = 7)
  int op_slot_left_11125 = gc_frame_newslot(call11129);
  params[0] = strlit11126;
  partcv[0] = 1;
  Object opresult11130 = callmethod(call11129, "==", 1, partcv, params);
// compiled op node returning opresult11130 (depth = 6)
  Object if11124 = done;
  if (istrue(opresult11130)) {
// Begin line 3376
  setline(3376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11131 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11132 = callmethodflags(self, "doimport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11131);
// compiled call node returning call11132 (depth = 7)
// compiled member node returning call11132 (depth = 6)
    gc_frame_newslot(call11132);
    if11124 = call11132;
  } else {
// Begin line 3379
  setline(3379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11135 == NULL) {
    strlit11135 = alloc_String("dialect");
    gc_root(strlit11135);
  }
// compiled string node returning strlit11135 (depth = 8)
  int op_slot_right_11134 = gc_frame_newslot(strlit11135);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11137 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11138 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11137);
// compiled call node returning call11138 (depth = 9)
// compiled member node returning call11138 (depth = 8)
  int op_slot_left_11134 = gc_frame_newslot(call11138);
  params[0] = strlit11135;
  partcv[0] = 1;
  Object opresult11139 = callmethod(call11138, "==", 1, partcv, params);
// compiled op node returning opresult11139 (depth = 7)
  Object if11133 = done;
  if (istrue(opresult11139)) {
// Begin line 3378
  setline(3378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11140 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11141 = callmethodflags(self, "dodialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11140);
// compiled call node returning call11141 (depth = 8)
// compiled member node returning call11141 (depth = 7)
    gc_frame_newslot(call11141);
    if11133 = call11141;
  } else {
// Begin line 3381
  setline(3381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3379
  setline(3379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11144 == NULL) {
    strlit11144 = alloc_String("type");
    gc_root(strlit11144);
  }
// compiled string node returning strlit11144 (depth = 9)
  int op_slot_right_11143 = gc_frame_newslot(strlit11144);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11147 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11146);
// compiled call node returning call11147 (depth = 10)
// compiled member node returning call11147 (depth = 9)
  int op_slot_left_11143 = gc_frame_newslot(call11147);
  params[0] = strlit11144;
  partcv[0] = 1;
  Object opresult11148 = callmethod(call11147, "==", 1, partcv, params);
// compiled op node returning opresult11148 (depth = 8)
  Object if11142 = done;
  if (istrue(opresult11148)) {
// Begin line 3380
  setline(3380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11150 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11149);
// compiled call node returning call11150 (depth = 9)
// compiled member node returning call11150 (depth = 8)
    gc_frame_newslot(call11150);
    if11142 = call11150;
  } else {
// Begin line 3383
  setline(3383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3381
  setline(3381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11153 == NULL) {
    strlit11153 = alloc_String("class");
    gc_root(strlit11153);
  }
// compiled string node returning strlit11153 (depth = 10)
  int op_slot_right_11152 = gc_frame_newslot(strlit11153);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11156 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11155);
// compiled call node returning call11156 (depth = 11)
// compiled member node returning call11156 (depth = 10)
  int op_slot_left_11152 = gc_frame_newslot(call11156);
  params[0] = strlit11153;
  partcv[0] = 1;
  Object opresult11157 = callmethod(call11156, "==", 1, partcv, params);
// compiled op node returning opresult11157 (depth = 9)
  Object if11151 = done;
  if (istrue(opresult11157)) {
// Begin line 3382
  setline(3382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11159 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11158);
// compiled call node returning call11159 (depth = 10)
// compiled member node returning call11159 (depth = 9)
    gc_frame_newslot(call11159);
    if11151 = call11159;
  } else {
// Begin line 3385
  setline(3385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 3383
  setline(3383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit11162 == NULL) {
    strlit11162 = alloc_String("factory");
    gc_root(strlit11162);
  }
// compiled string node returning strlit11162 (depth = 11)
  int op_slot_right_11161 = gc_frame_newslot(strlit11162);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call11165 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11164);
// compiled call node returning call11165 (depth = 12)
// compiled member node returning call11165 (depth = 11)
  int op_slot_left_11161 = gc_frame_newslot(call11165);
  params[0] = strlit11162;
  partcv[0] = 1;
  Object opresult11166 = callmethod(call11165, "==", 1, partcv, params);
// compiled op node returning opresult11166 (depth = 10)
  Object if11160 = done;
  if (istrue(opresult11166)) {
// Begin line 3384
  setline(3384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11168 = callmethodflags(self, "dofactoryMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11167);
// compiled call node returning call11168 (depth = 11)
// compiled member node returning call11168 (depth = 10)
    gc_frame_newslot(call11168);
    if11160 = call11168;
  } else {
// Begin line 3387
  setline(3387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 3385
  setline(3385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit11171 == NULL) {
    strlit11171 = alloc_String("return");
    gc_root(strlit11171);
  }
// compiled string node returning strlit11171 (depth = 12)
  int op_slot_right_11170 = gc_frame_newslot(strlit11171);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call11174 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11173);
// compiled call node returning call11174 (depth = 13)
// compiled member node returning call11174 (depth = 12)
  int op_slot_left_11170 = gc_frame_newslot(call11174);
  params[0] = strlit11171;
  partcv[0] = 1;
  Object opresult11175 = callmethod(call11174, "==", 1, partcv, params);
// compiled op node returning opresult11175 (depth = 11)
  Object if11169 = done;
  if (istrue(opresult11175)) {
// Begin line 3386
  setline(3386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11176 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11177 = callmethodflags(self, "doreturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11176);
// compiled call node returning call11177 (depth = 12)
// compiled member node returning call11177 (depth = 11)
    gc_frame_newslot(call11177);
    if11169 = call11177;
  } else {
// Begin line 3388
  setline(3388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe11178 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call11179 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11178);
// compiled call node returning call11179 (depth = 11)
    gc_frame_newslot(call11179);
    if11169 = call11179;
  }
// compiled if node returning if11169 (depth = 10)
    gc_frame_newslot(if11169);
    if11160 = if11169;
  }
// compiled if node returning if11160 (depth = 9)
    gc_frame_newslot(if11160);
    if11151 = if11160;
  }
// compiled if node returning if11151 (depth = 8)
    gc_frame_newslot(if11151);
    if11142 = if11151;
  }
// compiled if node returning if11142 (depth = 7)
    gc_frame_newslot(if11142);
    if11133 = if11142;
  }
// compiled if node returning if11133 (depth = 6)
    gc_frame_newslot(if11133);
    if11124 = if11133;
  }
// compiled if node returning if11124 (depth = 5)
    gc_frame_newslot(if11124);
    if11115 = if11124;
  }
// compiled if node returning if11115 (depth = 4)
    gc_frame_newslot(if11115);
    if11106 = if11115;
  }
// compiled if node returning if11106 (depth = 3)
    gc_frame_newslot(if11106);
    if11102 = if11106;
  } else {
// Begin line 3391
  setline(3391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11180 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block11181 = alloc_Block(NULL, NULL, "parser", 3391);
  gc_frame_newslot(block11181);
// method _apply
  block_savedest(block11181);
  Object closure11182 = createclosure(2, "_apply");
  setclosureframe(closure11182, stackframe);
  addtoclosure(closure11182, var_blocksOK);
  addtoclosure(closure11182, selfslot);
  struct UserObject *uo11182 = (struct UserObject*)block11181;
  uo11182->data[0] = (Object)closure11182;
  Method *meth_meth_parser__apply11182 = addmethod2pos(block11181, "_apply", &meth_parser__apply11182, 0);
  int argcv_meth_parser__apply11182[] = {0};
  meth_meth_parser__apply11182->type = alloc_MethodType(1, argcv_meth_parser__apply11182);
  meth_meth_parser__apply11182->definitionModule = modulename;
  meth_meth_parser__apply11182->definitionLine = 3386;
// compiled block node returning block11181 (depth = 4)
  gc_frame_newslot(block11181);
// starting to compile block node (depth = 4)
  Object block11186 = alloc_Block(NULL, NULL, "parser", 3391);
  gc_frame_newslot(block11186);
// method _apply
  block_savedest(block11186);
  Object closure11187 = createclosure(9, "_apply");
  setclosureframe(closure11187, stackframe);
  addtoclosure(closure11187, var_values);
  addtoclosure(closure11187, var_blocksOK);
  addtoclosure(closure11187, var_errormessages);
  addtoclosure(closure11187, var_sym);
  addtoclosure(closure11187, var_lastToken);
  addtoclosure(closure11187, var_btok);
  addtoclosure(closure11187, var_util);
  addtoclosure(closure11187, var_ast);
  addtoclosure(closure11187, selfslot);
  struct UserObject *uo11187 = (struct UserObject*)block11186;
  uo11187->data[0] = (Object)closure11187;
  Method *meth_meth_parser__apply11187 = addmethod2pos(block11186, "_apply", &meth_parser__apply11187, 0);
  int argcv_meth_parser__apply11187[] = {0};
  meth_meth_parser__apply11187->type = alloc_MethodType(1, argcv_meth_parser__apply11187);
  meth_meth_parser__apply11187->definitionModule = modulename;
  meth_meth_parser__apply11187->definitionLine = 3386;
// compiled block node returning block11186 (depth = 4)
  gc_frame_newslot(block11186);
// call case 4: self request
  params[0] = block11181;
  params[1] = block11186;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11301 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11180);
// compiled call node returning call11301 (depth = 3)
    gc_frame_newslot(call11301);
    if11102 = call11301;
  }
// compiled if node returning if11102 (depth = 2)
// Begin line 3421
  setline(3421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11303 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11302);
// compiled call node returning call11303 (depth = 3)
// compiled member node returning call11303 (depth = 2)
// Begin line 3422
  setline(3422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11305 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11306 == NULL) {
    strlit11306 = alloc_String("eof");
    gc_root(strlit11306);
  }
// compiled string node returning strlit11306 (depth = 4)
  gc_frame_newslot(strlit11306);
// call case 4: self request
  params[0] = strlit11306;
  partcv[0] = 1;
  Object call11307 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11305);
// compiled call node returning call11307 (depth = 3)
  Object if11304 = done;
  if (istrue(call11307)) {
// Begin line 3423
  setline(3423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool11308 = alloc_Boolean(1);
// compiled identifier node returning bool11308 (depth = 4)
  return bool11308;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11304 = undefined;
  } else {
  }
// compiled if node returning if11304 (depth = 2)
// Begin line 3425
  setline(3425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11310 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11311 == NULL) {
    strlit11311 = alloc_String("semicolon");
    gc_root(strlit11311);
  }
// compiled string node returning strlit11311 (depth = 4)
  gc_frame_newslot(strlit11311);
// call case 4: self request
  params[0] = strlit11311;
  partcv[0] = 1;
  Object call11312 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11310);
// compiled call node returning call11312 (depth = 3)
  Object if11309 = done;
  if (istrue(call11312)) {
// Begin line 3426
  setline(3426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11314 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11313);
// compiled call node returning call11314 (depth = 5)
// compiled member node returning call11314 (depth = 4)
  *var_oldLine = call11314;
  if (call11314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3427
  setline(3427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11316 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11315);
// compiled call node returning call11316 (depth = 4)
// compiled member node returning call11316 (depth = 3)
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldLine (depth = 5)
  int op_slot_right_11318 = gc_frame_newslot(*var_oldLine);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11320 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11321 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11320);
// compiled call node returning call11321 (depth = 6)
// compiled member node returning call11321 (depth = 5)
  int op_slot_left_11318 = gc_frame_newslot(call11321);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult11322 = callmethod(call11321, "==", 1, partcv, params);
// compiled op node returning opresult11322 (depth = 4)
  Object if11317 = done;
  if (istrue(opresult11322)) {
// Begin line 3429
  setline(3429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool11323 = alloc_Boolean(1);
// compiled identifier node returning bool11323 (depth = 5)
  *var_indentFreePass = bool11323;
  if (bool11323 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if11317 = done;
  } else {
  }
// compiled if node returning if11317 (depth = 3)
    gc_frame_newslot(if11317);
    if11309 = if11317;
  } else {
// Begin line 3432
  setline(3432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11325 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11326 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11325);
// compiled call node returning call11326 (depth = 4)
// compiled member node returning call11326 (depth = 3)
    gc_frame_newslot(call11326);
    if11309 = call11326;
  }
// compiled if node returning if11309 (depth = 2)
  gc_frame_end(frame);
  return if11309;
}
Object meth_parser__apply11385(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_previousCommentToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 3452
  setline(3452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  *var_previousCommentToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3453
  setline(3453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11387 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call11388 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe11387);
// compiled call node returning call11388 (depth = 6)
// compiled member node returning call11388 (depth = 5)
  *var_sym = call11388;
  if (call11388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3454
  setline(3454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11393 = alloc_Float64(1);
// compiled num node returning num11393 (depth = 7)
  int op_slot_right_11392 = gc_frame_newslot(num11393);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_previousCommentToken (depth = 9)
  partcv[0] = 0;
  Object call11396 = callmethod(*var_previousCommentToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11395);
// compiled call node returning call11396 (depth = 8)
// compiled member node returning call11396 (depth = 7)
  int op_slot_left_11392 = gc_frame_newslot(call11396);
  params[0] = num11393;
  partcv[0] = 1;
  Object sum11397 = callmethod(call11396, "+", 1, partcv, params);
// compiled op node returning sum11397 (depth = 6)
  int op_slot_right_11391 = gc_frame_newslot(sum11397);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11400 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11399);
// compiled call node returning call11400 (depth = 7)
// compiled member node returning call11400 (depth = 6)
  int op_slot_left_11391 = gc_frame_newslot(call11400);
  params[0] = sum11397;
  partcv[0] = 1;
  Object opresult11401 = callmethod(call11400, ">", 1, partcv, params);
// compiled op node returning opresult11401 (depth = 5)
  Object if11390 = done;
  if (istrue(opresult11401)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11403 = callmethodflags(self, "noteBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11402);
// compiled call node returning call11403 (depth = 6)
// compiled member node returning call11403 (depth = 5)
    gc_frame_newslot(call11403);
    if11390 = call11403;
  } else {
  }
// compiled if node returning if11390 (depth = 4)
// Begin line 3455
  setline(3455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11404 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11405 == NULL) {
    strlit11405 = alloc_String("comment");
    gc_root(strlit11405);
  }
// compiled string node returning strlit11405 (depth = 5)
  gc_frame_newslot(strlit11405);
// call case 4: self request
  params[0] = strlit11405;
  partcv[0] = 1;
  Object call11406 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11404);
// compiled call node returning call11406 (depth = 4)
  gc_frame_end(frame);
  return call11406;
}
Object meth_parser__apply11409(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_o = getfromclosure(closure, 3);
  Object *var_comments = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3457
  setline(3457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11410 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11411 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11412 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11411);
// compiled call node returning call11412 (depth = 6)
// compiled member node returning call11412 (depth = 5)
  gc_frame_newslot(call11412);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11413 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11414 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11413);
// compiled call node returning call11414 (depth = 6)
// compiled member node returning call11414 (depth = 5)
  gc_frame_newslot(call11414);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call11412;
  params[1] = call11414;
  partcv[0] = 2;
  Object call11415 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe11410);
// compiled call node returning call11415 (depth = 4)
// Begin line 3458
  setline(3458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11416 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11418 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11417);
// compiled call node returning call11418 (depth = 7)
// compiled member node returning call11418 (depth = 6)
  gc_frame_newslot(call11418);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call11420 = callmethod(*var_ast, "commentNode",
    1, partcv, params);
  gc_frame_end(callframe11419);
// compiled call node returning call11420 (depth = 7)
// compiled member node returning call11420 (depth = 6)
  params[0] = call11418;
  partcv[0] = 1;
  Object call11421 = callmethod(call11420, "new",
    1, partcv, params);
  gc_frame_end(callframe11416);
// compiled call node returning call11421 (depth = 5)
  *var_o = call11421;
  if (call11421 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3459
  setline(3459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11426 = alloc_Float64(1);
// compiled num node returning num11426 (depth = 7)
  int op_slot_right_11425 = gc_frame_newslot(num11426);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11429 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11428);
// compiled call node returning call11429 (depth = 8)
// compiled member node returning call11429 (depth = 7)
  int op_slot_left_11425 = gc_frame_newslot(call11429);
  params[0] = num11426;
  partcv[0] = 1;
  Object diff11430 = callmethod(call11429, "-", 1, partcv, params);
// compiled op node returning diff11430 (depth = 6)
  int op_slot_right_11424 = gc_frame_newslot(diff11430);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11432 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comments (depth = 10)
  partcv[0] = 0;
  Object call11434 = callmethod(*var_comments, "last",
    1, partcv, params);
  gc_frame_end(callframe11433);
// compiled call node returning call11434 (depth = 9)
// compiled member node returning call11434 (depth = 8)
  partcv[0] = 0;
  Object call11435 = callmethod(call11434, "endLine",
    1, partcv, params);
  gc_frame_end(callframe11432);
// compiled call node returning call11435 (depth = 7)
// compiled member node returning call11435 (depth = 6)
  int op_slot_left_11424 = gc_frame_newslot(call11435);
  params[0] = diff11430;
  partcv[0] = 1;
  Object opresult11436 = callmethod(call11435, "==", 1, partcv, params);
// compiled op node returning opresult11436 (depth = 5)
  Object if11423 = done;
  if (istrue(opresult11436)) {
// Begin line 3460
  setline(3460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11437 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  partcv[0] = 0;
  Object call11439 = callmethod(*var_comments, "last",
    1, partcv, params);
  gc_frame_end(callframe11438);
// compiled call node returning call11439 (depth = 7)
// compiled member node returning call11439 (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call11440 = callmethod(call11439, "extendCommentUsing",
    1, partcv, params);
  gc_frame_end(callframe11437);
// compiled call node returning call11440 (depth = 5)
    gc_frame_newslot(call11440);
    if11423 = call11440;
  } else {
// Begin line 3462
  setline(3462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11441 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call11442 = callmethod(*var_comments, "push",
    1, partcv, params);
  gc_frame_end(callframe11441);
// compiled call node returning call11442 (depth = 5)
// Begin line 3463
  setline(3463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11446 = alloc_Float64(1);
// compiled num node returning num11446 (depth = 8)
  int op_slot_right_11445 = gc_frame_newslot(num11446);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11449 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11448);
// compiled call node returning call11449 (depth = 9)
// compiled member node returning call11449 (depth = 8)
  int op_slot_left_11445 = gc_frame_newslot(call11449);
  params[0] = num11446;
  partcv[0] = 1;
  Object diff11450 = callmethod(call11449, "-", 1, partcv, params);
// compiled op node returning diff11450 (depth = 7)
  int op_slot_right_11444 = gc_frame_newslot(diff11450);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call11453 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11452);
// compiled call node returning call11453 (depth = 8)
// compiled member node returning call11453 (depth = 7)
  int op_slot_left_11444 = gc_frame_newslot(call11453);
  params[0] = diff11450;
  partcv[0] = 1;
  Object opresult11454 = callmethod(call11453, "<", 1, partcv, params);
// compiled op node returning opresult11454 (depth = 6)
  Object if11443 = done;
  if (istrue(opresult11454)) {
// Begin line 3464
  setline(3464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3463
  setline(3463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11455 = gc_frame_new();
// Begin line 3464
  setline(3464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool11456 = alloc_Boolean(1);
// compiled identifier node returning bool11456 (depth = 8)
  gc_frame_newslot(bool11456);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  params[0] = bool11456;
  partcv[0] = 1;
  Object call11457 = callmethod(*var_o, "isPreceededByBlankLine:=",
    1, partcv, params);
  gc_frame_end(callframe11455);
// compiled call node returning call11457 (depth = 7)
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if11443 = done;
  } else {
  }
// compiled if node returning if11443 (depth = 5)
    gc_frame_newslot(if11443);
    if11423 = if11443;
  }
// compiled if node returning if11423 (depth = 4)
  gc_frame_end(frame);
  return if11423;
}
Object meth_parser_pushcomments11327(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushcomments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_comments = getfromclosure(closure, 5);
  Object *var_previousCommentToken = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushcomments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushcomments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 3442
  setline(3442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11329 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe11330 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11331 == NULL) {
    strlit11331 = alloc_String("comment");
    gc_root(strlit11331);
  }
// compiled string node returning strlit11331 (depth = 5)
  gc_frame_newslot(strlit11331);
// call case 4: self request
  params[0] = strlit11331;
  partcv[0] = 1;
  Object call11332 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11330);
// compiled call node returning call11332 (depth = 4)
  partcv[0] = 0;
  Object call11333 = callmethod(call11332, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe11329);
// compiled call node returning call11333 (depth = 3)
  Object if11328 = done;
  if (istrue(call11333)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11328 = undefined;
  } else {
  }
// compiled if node returning if11328 (depth = 2)
// Begin line 3443
  setline(3443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11334 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call11336 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11335);
// compiled call node returning call11336 (depth = 4)
// compiled member node returning call11336 (depth = 3)
  gc_frame_newslot(call11336);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11337 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call11338 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11337);
// compiled call node returning call11338 (depth = 4)
// compiled member node returning call11338 (depth = 3)
  gc_frame_newslot(call11338);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call11336;
  params[1] = call11338;
  partcv[0] = 2;
  Object call11339 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe11334);
// compiled call node returning call11339 (depth = 2)
// Begin line 3444
  setline(3444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11340 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11342 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11341);
// compiled call node returning call11342 (depth = 5)
// compiled member node returning call11342 (depth = 4)
  gc_frame_newslot(call11342);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call11344 = callmethod(*var_ast, "commentNode",
    1, partcv, params);
  gc_frame_end(callframe11343);
// compiled call node returning call11344 (depth = 5)
// compiled member node returning call11344 (depth = 4)
  params[0] = call11342;
  partcv[0] = 1;
  Object call11345 = callmethod(call11344, "new",
    1, partcv, params);
  gc_frame_end(callframe11340);
// compiled call node returning call11345 (depth = 3)
  *var_o = call11345;
  if (call11345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3445
  setline(3445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11349 == NULL) {
    strlit11349 = alloc_String("comment");
    gc_root(strlit11349);
  }
// compiled string node returning strlit11349 (depth = 5)
  int op_slot_right_11348 = gc_frame_newslot(strlit11349);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11351 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call11352 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe11351);
// compiled call node returning call11352 (depth = 6)
// compiled member node returning call11352 (depth = 5)
  int op_slot_left_11348 = gc_frame_newslot(call11352);
  params[0] = strlit11349;
  partcv[0] = 1;
  Object opresult11353 = callmethod(call11352, "!=", 1, partcv, params);
// compiled op node returning opresult11353 (depth = 4)
  int op_slot_right_11347 = gc_frame_newslot(opresult11353);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11356 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11357 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11356);
// compiled call node returning call11357 (depth = 6)
// compiled member node returning call11357 (depth = 5)
  int op_slot_right_11355 = gc_frame_newslot(call11357);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call11360 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11359);
// compiled call node returning call11360 (depth = 6)
// compiled member node returning call11360 (depth = 5)
  int op_slot_left_11355 = gc_frame_newslot(call11360);
  params[0] = call11357;
  partcv[0] = 1;
  Object opresult11361 = callmethod(call11360, "==", 1, partcv, params);
// compiled op node returning opresult11361 (depth = 4)
  int op_slot_left_11347 = gc_frame_newslot(opresult11361);
  params[0] = opresult11353;
  partcv[0] = 1;
  Object opresult11362 = callmethod(opresult11361, "&&", 1, partcv, params);
// compiled op node returning opresult11362 (depth = 3)
  Object if11346 = done;
  if (istrue(opresult11362)) {
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3445
  setline(3445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11363 = gc_frame_new();
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool11364 = alloc_Boolean(1);
// compiled identifier node returning bool11364 (depth = 5)
  gc_frame_newslot(bool11364);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool11364;
  partcv[0] = 1;
  Object call11365 = callmethod(*var_o, "isPartialLine:=",
    1, partcv, params);
  gc_frame_end(callframe11363);
// compiled call node returning call11365 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11346 = done;
  } else {
// Begin line 3450
  setline(3450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3447
  setline(3447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num11369 = alloc_Float64(1);
// compiled num node returning num11369 (depth = 6)
  int op_slot_right_11368 = gc_frame_newslot(num11369);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11372 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11371);
// compiled call node returning call11372 (depth = 7)
// compiled member node returning call11372 (depth = 6)
  int op_slot_left_11368 = gc_frame_newslot(call11372);
  params[0] = num11369;
  partcv[0] = 1;
  Object diff11373 = callmethod(call11372, "-", 1, partcv, params);
// compiled op node returning diff11373 (depth = 5)
  int op_slot_right_11367 = gc_frame_newslot(diff11373);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call11376 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11375);
// compiled call node returning call11376 (depth = 6)
// compiled member node returning call11376 (depth = 5)
  int op_slot_left_11367 = gc_frame_newslot(call11376);
  params[0] = diff11373;
  partcv[0] = 1;
  Object opresult11377 = callmethod(call11376, "<", 1, partcv, params);
// compiled op node returning opresult11377 (depth = 4)
  Object if11366 = done;
  if (istrue(opresult11377)) {
// Begin line 3448
  setline(3448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3447
  setline(3447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11378 = gc_frame_new();
// Begin line 3448
  setline(3448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool11379 = alloc_Boolean(1);
// compiled identifier node returning bool11379 (depth = 6)
  gc_frame_newslot(bool11379);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  params[0] = bool11379;
  partcv[0] = 1;
  Object call11380 = callmethod(*var_o, "isPreceededByBlankLine:=",
    1, partcv, params);
  gc_frame_end(callframe11378);
// compiled call node returning call11380 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if11366 = done;
  } else {
  }
// compiled if node returning if11366 (depth = 3)
    gc_frame_newslot(if11366);
    if11346 = if11366;
  }
// compiled if node returning if11346 (depth = 2)
// Begin line 3450
  setline(3450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11381 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call11382 = callmethod(*var_comments, "push",
    1, partcv, params);
  gc_frame_end(callframe11381);
// compiled call node returning call11382 (depth = 2)
// Begin line 3451
  setline(3451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11383 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block11384 = alloc_Block(NULL, NULL, "parser", 3451);
  gc_frame_newslot(block11384);
// method _apply
  block_savedest(block11384);
  Object closure11385 = createclosure(4, "_apply");
  setclosureframe(closure11385, stackframe);
  addtoclosure(closure11385, var_sym);
  addtoclosure(closure11385, var_previousCommentToken);
  addtoclosure(closure11385, var_tokens);
  addtoclosure(closure11385, selfslot);
  struct UserObject *uo11385 = (struct UserObject*)block11384;
  uo11385->data[0] = (Object)closure11385;
  Method *meth_meth_parser__apply11385 = addmethod2pos(block11384, "_apply", &meth_parser__apply11385, 0);
  int argcv_meth_parser__apply11385[] = {0};
  meth_meth_parser__apply11385->type = alloc_MethodType(1, argcv_meth_parser__apply11385);
  meth_meth_parser__apply11385->definitionModule = modulename;
  meth_meth_parser__apply11385->definitionLine = 3447;
// compiled block node returning block11384 (depth = 3)
  gc_frame_newslot(block11384);
// Begin line 3456
  setline(3456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block11408 = alloc_Block(NULL, NULL, "parser", 3456);
  gc_frame_newslot(block11408);
// method _apply
  block_savedest(block11408);
  Object closure11409 = createclosure(7, "_apply");
  setclosureframe(closure11409, stackframe);
  addtoclosure(closure11409, var_sym);
  addtoclosure(closure11409, var_util);
  addtoclosure(closure11409, var_ast);
  addtoclosure(closure11409, var_o);
  addtoclosure(closure11409, var_comments);
  addtoclosure(closure11409, var_lastToken);
  addtoclosure(closure11409, selfslot);
  struct UserObject *uo11409 = (struct UserObject*)block11408;
  uo11409->data[0] = (Object)closure11409;
  Method *meth_meth_parser__apply11409 = addmethod2pos(block11408, "_apply", &meth_parser__apply11409, 0);
  int argcv_meth_parser__apply11409[] = {0};
  meth_meth_parser__apply11409->type = alloc_MethodType(1, argcv_meth_parser__apply11409);
  meth_meth_parser__apply11409->definitionModule = modulename;
  meth_meth_parser__apply11409->definitionLine = 3454;
// compiled block node returning block11408 (depth = 3)
  gc_frame_newslot(block11408);
// call case 5: prelude request
  params[0] = block11384;
  params[1] = block11408;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11459 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11383);
// compiled call node returning call11459 (depth = 2)
  gc_frame_end(frame);
  return call11459;
}
Object meth_parser__apply11493(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11495 = alloc_Float64(0);
// compiled num node returning num11495 (depth = 5)
  int op_slot_right_11494 = gc_frame_newslot(num11495);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_11494 = gc_frame_newslot(*var_ix);
  params[0] = num11495;
  partcv[0] = 1;
  Object opresult11497 = callmethod(*var_ix, ">", 1, partcv, params);
// compiled op node returning opresult11497 (depth = 4)
  gc_frame_end(frame);
  return opresult11497;
}
Object meth_parser__apply11500(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_comments = getfromclosure(closure, 1);
  Object *var_oLine = getfromclosure(closure, 2);
  Object *var_postComments = getfromclosure(closure, 3);
  Object *var_preComments = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
  Object *var_isPostComment = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isPostComment");
  Object *var_isPreComment = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isPreComment");
// Begin line 3490
  setline(3490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11501 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call11502 = callmethod(*var_comments, "at",
    1, partcv, params);
  gc_frame_end(callframe11501);
// compiled call node returning call11502 (depth = 5)
  *var_each = call11502;
  if (call11502 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3491
  setline(3491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11506 = alloc_Float64(1);
// compiled num node returning num11506 (depth = 8)
  int op_slot_right_11505 = gc_frame_newslot(num11506);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_11505 = gc_frame_newslot(*var_oLine);
  params[0] = num11506;
  partcv[0] = 1;
  Object sum11508 = callmethod(*var_oLine, "+", 1, partcv, params);
// compiled op node returning sum11508 (depth = 7)
  int op_slot_right_11504 = gc_frame_newslot(sum11508);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call11511 = callmethod(*var_each, "line",
    1, partcv, params);
  gc_frame_end(callframe11510);
// compiled call node returning call11511 (depth = 8)
// compiled member node returning call11511 (depth = 7)
  int op_slot_left_11504 = gc_frame_newslot(call11511);
  params[0] = sum11508;
  partcv[0] = 1;
  Object opresult11512 = callmethod(call11511, "==", 1, partcv, params);
// compiled op node returning opresult11512 (depth = 6)
  int op_slot_right_11503 = gc_frame_newslot(opresult11512);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oLine (depth = 7)
  int op_slot_right_11514 = gc_frame_newslot(*var_oLine);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11516 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call11517 = callmethod(*var_each, "line",
    1, partcv, params);
  gc_frame_end(callframe11516);
// compiled call node returning call11517 (depth = 8)
// compiled member node returning call11517 (depth = 7)
  int op_slot_left_11514 = gc_frame_newslot(call11517);
  params[0] = *var_oLine;
  partcv[0] = 1;
  Object opresult11518 = callmethod(call11517, "==", 1, partcv, params);
// compiled op node returning opresult11518 (depth = 6)
  int op_slot_left_11503 = gc_frame_newslot(opresult11518);
  params[0] = opresult11512;
  partcv[0] = 1;
  Object opresult11519 = callmethod(opresult11518, "||", 1, partcv, params);
// compiled op node returning opresult11519 (depth = 5)
  *var_isPostComment = opresult11519;
  if (opresult11519 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11523 = alloc_Float64(1);
// compiled num node returning num11523 (depth = 8)
  int op_slot_right_11522 = gc_frame_newslot(num11523);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_11522 = gc_frame_newslot(*var_oLine);
  params[0] = num11523;
  partcv[0] = 1;
  Object diff11525 = callmethod(*var_oLine, "-", 1, partcv, params);
// compiled op node returning diff11525 (depth = 7)
  int op_slot_right_11521 = gc_frame_newslot(diff11525);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call11528 = callmethod(*var_each, "endLine",
    1, partcv, params);
  gc_frame_end(callframe11527);
// compiled call node returning call11528 (depth = 8)
// compiled member node returning call11528 (depth = 7)
  int op_slot_left_11521 = gc_frame_newslot(call11528);
  params[0] = diff11525;
  partcv[0] = 1;
  Object opresult11529 = callmethod(call11528, "==", 1, partcv, params);
// compiled op node returning opresult11529 (depth = 6)
  int op_slot_right_11520 = gc_frame_newslot(opresult11529);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11531 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call11532 = callmethod(*var_each, "isPreceededByBlankLine",
    1, partcv, params);
  gc_frame_end(callframe11531);
// compiled call node returning call11532 (depth = 7)
// compiled member node returning call11532 (depth = 6)
  int op_slot_left_11520 = gc_frame_newslot(call11532);
  params[0] = opresult11529;
  partcv[0] = 1;
  Object opresult11533 = callmethod(call11532, "&&", 1, partcv, params);
// compiled op node returning opresult11533 (depth = 5)
  *var_isPreComment = opresult11533;
  if (opresult11533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isPostComment (depth = 5)
  Object if11534 = done;
  if (istrue(*var_isPostComment)) {
// Begin line 3494
  setline(3494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11535 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe11536 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call11537 = callmethod(*var_comments, "removeAt",
    1, partcv, params);
  gc_frame_end(callframe11536);
// compiled call node returning call11537 (depth = 6)
  gc_frame_newslot(call11537);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_postComments (depth = 6)
  params[0] = call11537;
  partcv[0] = 1;
  Object call11538 = callmethod(*var_postComments, "push",
    1, partcv, params);
  gc_frame_end(callframe11535);
// compiled call node returning call11538 (depth = 5)
    gc_frame_newslot(call11538);
    if11534 = call11538;
  } else {
// Begin line 3497
  setline(3497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3495
  setline(3495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isPreComment (depth = 6)
  Object if11539 = done;
  if (istrue(*var_isPreComment)) {
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11540 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe11541 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call11542 = callmethod(*var_comments, "removeAt",
    1, partcv, params);
  gc_frame_end(callframe11541);
// compiled call node returning call11542 (depth = 7)
  gc_frame_newslot(call11542);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  params[0] = call11542;
  partcv[0] = 1;
  Object call11543 = callmethod(*var_preComments, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe11540);
// compiled call node returning call11543 (depth = 6)
    gc_frame_newslot(call11543);
    if11539 = call11543;
  } else {
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3497
  setline(3497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num11547 = alloc_Float64(1);
// compiled num node returning num11547 (depth = 9)
  int op_slot_right_11546 = gc_frame_newslot(num11547);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_oLine (depth = 9)
  int op_slot_left_11546 = gc_frame_newslot(*var_oLine);
  params[0] = num11547;
  partcv[0] = 1;
  Object diff11549 = callmethod(*var_oLine, "-", 1, partcv, params);
// compiled op node returning diff11549 (depth = 8)
  int op_slot_right_11545 = gc_frame_newslot(diff11549);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11551 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  partcv[0] = 0;
  Object call11552 = callmethod(*var_each, "endLine",
    1, partcv, params);
  gc_frame_end(callframe11551);
// compiled call node returning call11552 (depth = 9)
// compiled member node returning call11552 (depth = 8)
  int op_slot_left_11545 = gc_frame_newslot(call11552);
  params[0] = diff11549;
  partcv[0] = 1;
  Object opresult11553 = callmethod(call11552, "<", 1, partcv, params);
// compiled op node returning opresult11553 (depth = 7)
  Object if11544 = done;
  if (istrue(opresult11553)) {
// Begin line 3498
  setline(3498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11554 = alloc_Float64(0);
// compiled num node returning num11554 (depth = 8)
  *var_ix = num11554;
  if (num11554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if11544 = done;
  } else {
  }
// compiled if node returning if11544 (depth = 6)
    gc_frame_newslot(if11544);
    if11539 = if11544;
  }
// compiled if node returning if11539 (depth = 5)
    gc_frame_newslot(if11539);
    if11534 = if11539;
  }
// compiled if node returning if11534 (depth = 4)
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num11557 = alloc_Float64(1);
// compiled num node returning num11557 (depth = 6)
  int op_slot_right_11556 = gc_frame_newslot(num11557);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_11556 = gc_frame_newslot(*var_ix);
  params[0] = num11557;
  partcv[0] = 1;
  Object diff11559 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff11559 (depth = 5)
  *var_ix = diff11559;
  if (diff11559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_reconcileComments11460(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reconcileComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_comments = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for reconcileComments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for reconcileComments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_node = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "node");
  Object *var_oLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oLine");
  Object *var_preComments = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "preComments");
  Object *var_postComments = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "postComments");
  Object *var_ix = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ix");
  Object *var_postSz = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "postSz");
  Object *var_preSz = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "preSz");
// Begin line 3476
  setline(3476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11461 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11462 = callmethodflags(self, "pushcomments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11461);
// compiled call node returning call11462 (depth = 3)
// compiled member node returning call11462 (depth = 2)
// Begin line 3477
  setline(3477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11465 = alloc_Float64(0);
// compiled num node returning num11465 (depth = 4)
  int op_slot_right_11464 = gc_frame_newslot(num11465);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call11468 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe11467);
// compiled call node returning call11468 (depth = 5)
// compiled member node returning call11468 (depth = 4)
  int op_slot_left_11464 = gc_frame_newslot(call11468);
  params[0] = num11465;
  partcv[0] = 1;
  Object opresult11469 = callmethod(call11468, "==", 1, partcv, params);
// compiled op node returning opresult11469 (depth = 3)
  Object if11463 = done;
  if (istrue(opresult11469)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11463 = undefined;
  } else {
  }
// compiled if node returning if11463 (depth = 2)
// Begin line 3478
  setline(3478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call11471 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11470);
// compiled call node returning call11471 (depth = 4)
// compiled member node returning call11471 (depth = 3)
  *var_node = call11471;
  if (call11471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3479
  setline(3479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11474 == NULL) {
    strlit11474 = alloc_String("lbrace");
    gc_root(strlit11474);
  }
// compiled string node returning strlit11474 (depth = 4)
  int op_slot_right_11473 = gc_frame_newslot(strlit11474);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_node (depth = 6)
  partcv[0] = 0;
  Object call11477 = callmethod(*var_node, "kind",
    1, partcv, params);
  gc_frame_end(callframe11476);
// compiled call node returning call11477 (depth = 5)
// compiled member node returning call11477 (depth = 4)
  int op_slot_left_11473 = gc_frame_newslot(call11477);
  params[0] = strlit11474;
  partcv[0] = 1;
  Object opresult11478 = callmethod(call11477, "==", 1, partcv, params);
// compiled op node returning opresult11478 (depth = 3)
  Object if11472 = done;
  if (istrue(opresult11478)) {
// Begin line 3482
  setline(3482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 3483
  setline(3483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11472 = undefined;
  } else {
  }
// compiled if node returning if11472 (depth = 2)
// Begin line 3484
  setline(3484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11479 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call11480 = callmethod(*var_node, "line",
    1, partcv, params);
  gc_frame_end(callframe11479);
// compiled call node returning call11480 (depth = 4)
// compiled member node returning call11480 (depth = 3)
  *var_oLine = call11480;
  if (call11480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3485
  setline(3485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11481 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11482 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11483 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11482);
// compiled call node returning call11483 (depth = 6)
// compiled member node returning call11483 (depth = 5)
  partcv[0] = 0;
  Object call11484 = callmethod(call11483, "empty",
    1, partcv, params);
  gc_frame_end(callframe11481);
// compiled call node returning call11484 (depth = 4)
// compiled member node returning call11484 (depth = 3)
  *var_preComments = call11484;
  if (call11484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11485 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11486 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11487 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11486);
// compiled call node returning call11487 (depth = 6)
// compiled member node returning call11487 (depth = 5)
  partcv[0] = 0;
  Object call11488 = callmethod(call11487, "empty",
    1, partcv, params);
  gc_frame_end(callframe11485);
// compiled call node returning call11488 (depth = 4)
// compiled member node returning call11488 (depth = 3)
  *var_postComments = call11488;
  if (call11488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3488
  setline(3488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_comments (depth = 5)
  partcv[0] = 0;
  Object call11490 = callmethod(*var_comments, "size",
    1, partcv, params);
  gc_frame_end(callframe11489);
// compiled call node returning call11490 (depth = 4)
// compiled member node returning call11490 (depth = 3)
  *var_ix = call11490;
  if (call11490 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3489
  setline(3489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11491 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block11492 = alloc_Block(NULL, NULL, "parser", 3489);
  gc_frame_newslot(block11492);
// method _apply
  block_savedest(block11492);
  Object closure11493 = createclosure(2, "_apply");
  setclosureframe(closure11493, stackframe);
  addtoclosure(closure11493, var_ix);
  addtoclosure(closure11493, selfslot);
  struct UserObject *uo11493 = (struct UserObject*)block11492;
  uo11493->data[0] = (Object)closure11493;
  Method *meth_meth_parser__apply11493 = addmethod2pos(block11492, "_apply", &meth_parser__apply11493, 0);
  int argcv_meth_parser__apply11493[] = {0};
  meth_meth_parser__apply11493->type = alloc_MethodType(1, argcv_meth_parser__apply11493);
  meth_meth_parser__apply11493->definitionModule = modulename;
  meth_meth_parser__apply11493->definitionLine = 3488;
// compiled block node returning block11492 (depth = 3)
  gc_frame_newslot(block11492);
// starting to compile block node (depth = 3)
  Object block11499 = alloc_Block(NULL, NULL, "parser", 3489);
  gc_frame_newslot(block11499);
// method _apply
  block_savedest(block11499);
  Object closure11500 = createclosure(6, "_apply");
  setclosureframe(closure11500, stackframe);
  addtoclosure(closure11500, var_ix);
  addtoclosure(closure11500, var_comments);
  addtoclosure(closure11500, var_oLine);
  addtoclosure(closure11500, var_postComments);
  addtoclosure(closure11500, var_preComments);
  addtoclosure(closure11500, selfslot);
  struct UserObject *uo11500 = (struct UserObject*)block11499;
  uo11500->data[0] = (Object)closure11500;
  Method *meth_meth_parser__apply11500 = addmethod2pos(block11499, "_apply", &meth_parser__apply11500, 0);
  int argcv_meth_parser__apply11500[] = {0};
  meth_meth_parser__apply11500->type = alloc_MethodType(1, argcv_meth_parser__apply11500);
  meth_meth_parser__apply11500->definitionModule = modulename;
  meth_meth_parser__apply11500->definitionLine = 3488;
// compiled block node returning block11499 (depth = 3)
  gc_frame_newslot(block11499);
// call case 5: prelude request
  params[0] = block11492;
  params[1] = block11499;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11562 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11491);
// compiled call node returning call11562 (depth = 2)
// Begin line 3503
  setline(3503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11563 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postComments (depth = 5)
  partcv[0] = 0;
  Object call11564 = callmethod(*var_postComments, "size",
    1, partcv, params);
  gc_frame_end(callframe11563);
// compiled call node returning call11564 (depth = 4)
// compiled member node returning call11564 (depth = 3)
  *var_postSz = call11564;
  if (call11564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3504
  setline(3504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preComments (depth = 5)
  partcv[0] = 0;
  Object call11566 = callmethod(*var_preComments, "size",
    1, partcv, params);
  gc_frame_end(callframe11565);
// compiled call node returning call11566 (depth = 4)
// compiled member node returning call11566 (depth = 3)
  *var_preSz = call11566;
  if (call11566 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3506
  setline(3506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11570 = alloc_Float64(1);
// compiled num node returning num11570 (depth = 5)
  int op_slot_right_11569 = gc_frame_newslot(num11570);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preSz (depth = 5)
  int op_slot_left_11569 = gc_frame_newslot(*var_preSz);
  params[0] = num11570;
  partcv[0] = 1;
  Object opresult11572 = callmethod(*var_preSz, ">", 1, partcv, params);
// compiled op node returning opresult11572 (depth = 4)
  int op_slot_right_11568 = gc_frame_newslot(opresult11572);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11575 = alloc_Float64(1);
// compiled num node returning num11575 (depth = 5)
  int op_slot_right_11574 = gc_frame_newslot(num11575);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postSz (depth = 5)
  int op_slot_left_11574 = gc_frame_newslot(*var_postSz);
  params[0] = num11575;
  partcv[0] = 1;
  Object opresult11577 = callmethod(*var_postSz, ">", 1, partcv, params);
// compiled op node returning opresult11577 (depth = 4)
  int op_slot_left_11568 = gc_frame_newslot(opresult11577);
  params[0] = opresult11572;
  partcv[0] = 1;
  Object opresult11578 = callmethod(opresult11577, "&&", 1, partcv, params);
// compiled op node returning opresult11578 (depth = 3)
  Object if11567 = done;
  if (istrue(opresult11578)) {
// Begin line 3507
  setline(3507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3504
  setline(3504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11579 = gc_frame_new();
// Begin line 3507
  setline(3507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11581 == NULL) {
    strlit11581 = alloc_String("""\x0a""");
    gc_root(strlit11581);
  }
// compiled string node returning strlit11581 (depth = 6)
  int op_slot_right_11580 = gc_frame_newslot(strlit11581);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11583 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11584 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_preComments (depth = 10)
  partcv[0] = 0;
  Object call11585 = callmethod(*var_preComments, "last",
    1, partcv, params);
  gc_frame_end(callframe11584);
// compiled call node returning call11585 (depth = 9)
// compiled member node returning call11585 (depth = 8)
  partcv[0] = 0;
  Object call11586 = callmethod(call11585, "value",
    1, partcv, params);
  gc_frame_end(callframe11583);
// compiled call node returning call11586 (depth = 7)
// compiled member node returning call11586 (depth = 6)
  int op_slot_left_11580 = gc_frame_newslot(call11586);
  params[0] = strlit11581;
  partcv[0] = 1;
  Object opresult11587 = callmethod(call11586, "++", 1, partcv, params);
// compiled op node returning opresult11587 (depth = 5)
  gc_frame_newslot(opresult11587);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11588 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  partcv[0] = 0;
  Object call11589 = callmethod(*var_preComments, "last",
    1, partcv, params);
  gc_frame_end(callframe11588);
// compiled call node returning call11589 (depth = 6)
// compiled member node returning call11589 (depth = 5)
  params[0] = opresult11587;
  partcv[0] = 1;
  Object call11590 = callmethod(call11589, "value:=",
    1, partcv, params);
  gc_frame_end(callframe11579);
// compiled call node returning call11590 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11567 = done;
  } else {
  }
// compiled if node returning if11567 (depth = 2)
// Begin line 3509
  setline(3509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11591 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_preComments (depth = 3)
  gc_frame_newslot(*var_preComments);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_preComments;
  partcv[0] = 1;
  Object call11592 = callmethod(*var_node, "addComments",
    1, partcv, params);
  gc_frame_end(callframe11591);
// compiled call node returning call11592 (depth = 2)
// Begin line 3510
  setline(3510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11593 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_postComments (depth = 3)
  gc_frame_newslot(*var_postComments);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_postComments;
  partcv[0] = 1;
  Object call11594 = callmethod(*var_node, "addComments",
    1, partcv, params);
  gc_frame_end(callframe11593);
// compiled call node returning call11594 (depth = 2)
  gc_frame_end(frame);
  return call11594;
}
Object meth_parser_checkBadOperators11595(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkBadOperators (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkBadOperators");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3514
  setline(3514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11598 == NULL) {
    strlit11598 = alloc_String("=");
    gc_root(strlit11598);
  }
// compiled string node returning strlit11598 (depth = 4)
  int op_slot_right_11597 = gc_frame_newslot(strlit11598);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11601 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11600);
// compiled call node returning call11601 (depth = 5)
// compiled member node returning call11601 (depth = 4)
  int op_slot_left_11597 = gc_frame_newslot(call11601);
  params[0] = strlit11598;
  partcv[0] = 1;
  Object opresult11602 = callmethod(call11601, "==", 1, partcv, params);
// compiled op node returning opresult11602 (depth = 3)
  Object if11596 = done;
  if (istrue(opresult11602)) {
// Begin line 3515
  setline(3515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11603 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11604 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11605 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11604);
// compiled call node returning call11605 (depth = 7)
// compiled member node returning call11605 (depth = 6)
  partcv[0] = 0;
  Object call11606 = callmethod(call11605, "new",
    1, partcv, params);
  gc_frame_end(callframe11603);
// compiled call node returning call11606 (depth = 5)
// compiled member node returning call11606 (depth = 4)
  *var_sugg = call11606;
  if (call11606 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3516
  setline(3516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11607 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11608 == NULL) {
    strlit11608 = alloc_String("=");
    gc_root(strlit11608);
  }
// compiled string node returning strlit11608 (depth = 4)
  gc_frame_newslot(strlit11608);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11608;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11609 = callmethod(*var_sugg, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe11607);
// compiled call node returning call11609 (depth = 3)
// Begin line 3517
  setline(3517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11610 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11611 == NULL) {
    strlit11611 = alloc_String("Use '==' to test equality, not '='.");
    gc_root(strlit11611);
  }
// compiled string node returning strlit11611 (depth = 4)
  gc_frame_newslot(strlit11611);
// Begin line 3518
  setline(3518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11612 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11613 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11612);
// compiled call node returning call11613 (depth = 5)
// compiled member node returning call11613 (depth = 4)
  gc_frame_newslot(call11613);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11615 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11614);
// compiled call node returning call11615 (depth = 5)
// compiled member node returning call11615 (depth = 4)
  gc_frame_newslot(call11615);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11617 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11616);
// compiled call node returning call11617 (depth = 5)
// compiled member node returning call11617 (depth = 4)
  gc_frame_newslot(call11617);
// Begin line 3519
  setline(3519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3517
  setline(3517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11611;
  params[1] = call11613;
  params[2] = call11615;
  params[3] = call11617;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11618 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11610);
// compiled call node returning call11618 (depth = 3)
    gc_frame_newslot(call11618);
    if11596 = call11618;
  } else {
  }
// compiled if node returning if11596 (depth = 2)
// Begin line 3521
  setline(3521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11621 == NULL) {
    strlit11621 = alloc_String("rgeneric");
    gc_root(strlit11621);
  }
// compiled string node returning strlit11621 (depth = 4)
  int op_slot_right_11620 = gc_frame_newslot(strlit11621);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11624 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11623);
// compiled call node returning call11624 (depth = 5)
// compiled member node returning call11624 (depth = 4)
  int op_slot_left_11620 = gc_frame_newslot(call11624);
  params[0] = strlit11621;
  partcv[0] = 1;
  Object opresult11625 = callmethod(call11624, "==", 1, partcv, params);
// compiled op node returning opresult11625 (depth = 3)
  Object if11619 = done;
  if (istrue(opresult11625)) {
// Begin line 3522
  setline(3522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11626 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11628 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11627);
// compiled call node returning call11628 (depth = 7)
// compiled member node returning call11628 (depth = 6)
  partcv[0] = 0;
  Object call11629 = callmethod(call11628, "new",
    1, partcv, params);
  gc_frame_end(callframe11626);
// compiled call node returning call11629 (depth = 5)
// compiled member node returning call11629 (depth = 4)
  *var_sugg = call11629;
  if (call11629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11630 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11631 == NULL) {
    strlit11631 = alloc_String(" ");
    gc_root(strlit11631);
  }
// compiled string node returning strlit11631 (depth = 4)
  gc_frame_newslot(strlit11631);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11631;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11632 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11630);
// compiled call node returning call11632 (depth = 3)
// Begin line 3524
  setline(3524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11633 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11634 == NULL) {
    strlit11634 = alloc_String("The '>' operator must be preceded by a space.");
    gc_root(strlit11634);
  }
// compiled string node returning strlit11634 (depth = 4)
  gc_frame_newslot(strlit11634);
// Begin line 3525
  setline(3525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11636 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11635);
// compiled call node returning call11636 (depth = 5)
// compiled member node returning call11636 (depth = 4)
  gc_frame_newslot(call11636);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11638 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11637);
// compiled call node returning call11638 (depth = 5)
// compiled member node returning call11638 (depth = 4)
  gc_frame_newslot(call11638);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11639 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11640 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11639);
// compiled call node returning call11640 (depth = 5)
// compiled member node returning call11640 (depth = 4)
  gc_frame_newslot(call11640);
// Begin line 3526
  setline(3526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3524
  setline(3524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11634;
  params[1] = call11636;
  params[2] = call11638;
  params[3] = call11640;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11641 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11633);
// compiled call node returning call11641 (depth = 3)
    gc_frame_newslot(call11641);
    if11619 = call11641;
  } else {
  }
// compiled if node returning if11619 (depth = 2)
  gc_frame_end(frame);
  return if11619;
}
Object meth_parser_checkBadTypeLiteral11642(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkBadTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkBadTypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3531
  setline(3531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11645 == NULL) {
    strlit11645 = alloc_String("lbrace");
    gc_root(strlit11645);
  }
// compiled string node returning strlit11645 (depth = 4)
  int op_slot_right_11644 = gc_frame_newslot(strlit11645);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11648 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11647);
// compiled call node returning call11648 (depth = 5)
// compiled member node returning call11648 (depth = 4)
  int op_slot_left_11644 = gc_frame_newslot(call11648);
  params[0] = strlit11645;
  partcv[0] = 1;
  Object opresult11649 = callmethod(call11648, "==", 1, partcv, params);
// compiled op node returning opresult11649 (depth = 3)
  Object if11643 = done;
  if (istrue(opresult11649)) {
// Begin line 3532
  setline(3532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11650 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11652 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11651);
// compiled call node returning call11652 (depth = 7)
// compiled member node returning call11652 (depth = 6)
  partcv[0] = 0;
  Object call11653 = callmethod(call11652, "new",
    1, partcv, params);
  gc_frame_end(callframe11650);
// compiled call node returning call11653 (depth = 5)
// compiled member node returning call11653 (depth = 4)
  *var_sugg = call11653;
  if (call11653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3533
  setline(3533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11654 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11655 == NULL) {
    strlit11655 = alloc_String("type ");
    gc_root(strlit11655);
  }
// compiled string node returning strlit11655 (depth = 4)
  gc_frame_newslot(strlit11655);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11655;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11656 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11654);
// compiled call node returning call11656 (depth = 3)
// Begin line 3534
  setline(3534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11657 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11658 == NULL) {
    strlit11658 = alloc_String("type literals must start with the keyword 'type'.");
    gc_root(strlit11658);
  }
// compiled string node returning strlit11658 (depth = 4)
  gc_frame_newslot(strlit11658);
// Begin line 3535
  setline(3535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11660 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11659);
// compiled call node returning call11660 (depth = 5)
// compiled member node returning call11660 (depth = 4)
  gc_frame_newslot(call11660);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11662 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11661);
// compiled call node returning call11662 (depth = 5)
// compiled member node returning call11662 (depth = 4)
  gc_frame_newslot(call11662);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11663 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11664 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11663);
// compiled call node returning call11664 (depth = 5)
// compiled member node returning call11664 (depth = 4)
  gc_frame_newslot(call11664);
// Begin line 3536
  setline(3536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3534
  setline(3534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11658;
  params[1] = call11660;
  params[2] = call11662;
  params[3] = call11664;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11665 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11657);
// compiled call node returning call11665 (depth = 3)
    gc_frame_newslot(call11665);
    if11643 = call11665;
  } else {
  }
// compiled if node returning if11643 (depth = 2)
  gc_frame_end(frame);
  return if11643;
}
Object meth_parser__apply11779(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3570
  setline(3570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11781 == NULL) {
    strlit11781 = alloc_String("identifier");
    gc_root(strlit11781);
  }
// compiled string node returning strlit11781 (depth = 10)
  int op_slot_right_11780 = gc_frame_newslot(strlit11781);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11783 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11784 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11783);
// compiled call node returning call11784 (depth = 11)
// compiled member node returning call11784 (depth = 10)
  int op_slot_left_11780 = gc_frame_newslot(call11784);
  params[0] = strlit11781;
  partcv[0] = 1;
  Object opresult11785 = callmethod(call11784, "==", 1, partcv, params);
// compiled op node returning opresult11785 (depth = 9)
  gc_frame_end(frame);
  return opresult11785;
}
Object meth_parser__apply11789(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3568
  setline(3568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit11791 == NULL) {
    strlit11791 = alloc_String("member");
    gc_root(strlit11791);
  }
// compiled string node returning strlit11791 (depth = 11)
  int op_slot_right_11790 = gc_frame_newslot(strlit11791);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11793 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe11794 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call11795 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11794);
// compiled call node returning call11795 (depth = 14)
// compiled member node returning call11795 (depth = 13)
  partcv[0] = 0;
  Object call11796 = callmethod(call11795, "kind",
    1, partcv, params);
  gc_frame_end(callframe11793);
// compiled call node returning call11796 (depth = 12)
// compiled member node returning call11796 (depth = 11)
  int op_slot_left_11790 = gc_frame_newslot(call11796);
  params[0] = strlit11791;
  partcv[0] = 1;
  Object opresult11797 = callmethod(call11796, "==", 1, partcv, params);
// compiled op node returning opresult11797 (depth = 10)
  gc_frame_end(frame);
  return opresult11797;
}
Object meth_parser__apply11776(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3569
  setline(3569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11777 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block11778 = alloc_Block(NULL, NULL, "parser", 3569);
  gc_frame_newslot(block11778);
// method _apply
  block_savedest(block11778);
  Object closure11779 = createclosure(2, "_apply");
  setclosureframe(closure11779, stackframe);
  addtoclosure(closure11779, var_sym);
  addtoclosure(closure11779, selfslot);
  struct UserObject *uo11779 = (struct UserObject*)block11778;
  uo11779->data[0] = (Object)closure11779;
  Method *meth_meth_parser__apply11779 = addmethod2pos(block11778, "_apply", &meth_parser__apply11779, 0);
  int argcv_meth_parser__apply11779[] = {0};
  meth_meth_parser__apply11779->type = alloc_MethodType(1, argcv_meth_parser__apply11779);
  meth_meth_parser__apply11779->definitionModule = modulename;
  meth_meth_parser__apply11779->definitionLine = 3564;
// compiled block node returning block11778 (depth = 8)
  gc_frame_newslot(block11778);
// call case 6: other member request
// Begin line 3567
  setline(3567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11787 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block11788 = alloc_Block(NULL, NULL, "parser", 3567);
  gc_frame_newslot(block11788);
// method _apply
  block_savedest(block11788);
  Object closure11789 = createclosure(2, "_apply");
  setclosureframe(closure11789, stackframe);
  addtoclosure(closure11789, var_values);
  addtoclosure(closure11789, selfslot);
  struct UserObject *uo11789 = (struct UserObject*)block11788;
  uo11789->data[0] = (Object)closure11789;
  Method *meth_meth_parser__apply11789 = addmethod2pos(block11788, "_apply", &meth_parser__apply11789, 0);
  int argcv_meth_parser__apply11789[] = {0};
  meth_meth_parser__apply11789->type = alloc_MethodType(1, argcv_meth_parser__apply11789);
  meth_meth_parser__apply11789->definitionModule = modulename;
  meth_meth_parser__apply11789->definitionLine = 3570;
// compiled block node returning block11788 (depth = 9)
  gc_frame_newslot(block11788);
// call case 6: other member request
// Begin line 3567
  setline(3567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11800 == NULL) {
    strlit11800 = alloc_String("identifier");
    gc_root(strlit11800);
  }
// compiled string node returning strlit11800 (depth = 10)
  int op_slot_right_11799 = gc_frame_newslot(strlit11800);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11802 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call11804 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11803);
// compiled call node returning call11804 (depth = 13)
// compiled member node returning call11804 (depth = 12)
  partcv[0] = 0;
  Object call11805 = callmethod(call11804, "kind",
    1, partcv, params);
  gc_frame_end(callframe11802);
// compiled call node returning call11805 (depth = 11)
// compiled member node returning call11805 (depth = 10)
  int op_slot_left_11799 = gc_frame_newslot(call11805);
  params[0] = strlit11800;
  partcv[0] = 1;
  Object opresult11806 = callmethod(call11805, "==", 1, partcv, params);
// compiled op node returning opresult11806 (depth = 9)
  params[0] = block11788;
  partcv[0] = 1;
  Object call11807 = callmethod(opresult11806, "orElse",
    1, partcv, params);
  gc_frame_end(callframe11787);
// compiled call node returning call11807 (depth = 8)
  params[0] = block11778;
  partcv[0] = 1;
  Object call11808 = callmethod(call11807, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11777);
// compiled call node returning call11808 (depth = 7)
  gc_frame_end(frame);
  return call11808;
}
Object meth_parser_checkUnexpectedTokenAfterStatement11666(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkUnexpectedTokenAfterStatement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkUnexpectedTokenAfterStatement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// Begin line 3541
  setline(3541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11669 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call11670 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11669);
// compiled call node returning call11670 (depth = 5)
// compiled member node returning call11670 (depth = 4)
  int op_slot_right_11668 = gc_frame_newslot(call11670);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11672 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11673 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11672);
// compiled call node returning call11673 (depth = 5)
// compiled member node returning call11673 (depth = 4)
  int op_slot_left_11668 = gc_frame_newslot(call11673);
  params[0] = call11670;
  partcv[0] = 1;
  Object opresult11674 = callmethod(call11673, "==", 1, partcv, params);
// compiled op node returning opresult11674 (depth = 3)
  Object if11667 = done;
  if (istrue(opresult11674)) {
// Begin line 3542
  setline(3542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3543
  setline(3543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11678 == NULL) {
    strlit11678 = alloc_String("identifier");
    gc_root(strlit11678);
  }
// compiled string node returning strlit11678 (depth = 6)
  int op_slot_right_11677 = gc_frame_newslot(strlit11678);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call11681 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe11680);
// compiled call node returning call11681 (depth = 7)
// compiled member node returning call11681 (depth = 6)
  int op_slot_left_11677 = gc_frame_newslot(call11681);
  params[0] = strlit11678;
  partcv[0] = 1;
  Object opresult11682 = callmethod(call11681, "==", 1, partcv, params);
// compiled op node returning opresult11682 (depth = 5)
  int op_slot_right_11676 = gc_frame_newslot(opresult11682);
// Begin line 3542
  setline(3542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11686 == NULL) {
    strlit11686 = alloc_String("=");
    gc_root(strlit11686);
  }
// compiled string node returning strlit11686 (depth = 7)
  int op_slot_right_11685 = gc_frame_newslot(strlit11686);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11689 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11688);
// compiled call node returning call11689 (depth = 8)
// compiled member node returning call11689 (depth = 7)
  int op_slot_left_11685 = gc_frame_newslot(call11689);
  params[0] = strlit11686;
  partcv[0] = 1;
  Object opresult11690 = callmethod(call11689, "==", 1, partcv, params);
// compiled op node returning opresult11690 (depth = 6)
  int op_slot_right_11684 = gc_frame_newslot(opresult11690);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11693 == NULL) {
    strlit11693 = alloc_String("op");
    gc_root(strlit11693);
  }
// compiled string node returning strlit11693 (depth = 7)
  int op_slot_right_11692 = gc_frame_newslot(strlit11693);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11696 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11695);
// compiled call node returning call11696 (depth = 8)
// compiled member node returning call11696 (depth = 7)
  int op_slot_left_11692 = gc_frame_newslot(call11696);
  params[0] = strlit11693;
  partcv[0] = 1;
  Object opresult11697 = callmethod(call11696, "==", 1, partcv, params);
// compiled op node returning opresult11697 (depth = 6)
  int op_slot_left_11684 = gc_frame_newslot(opresult11697);
  params[0] = opresult11690;
  partcv[0] = 1;
  Object opresult11698 = callmethod(opresult11697, "&&", 1, partcv, params);
// compiled op node returning opresult11698 (depth = 5)
  int op_slot_left_11676 = gc_frame_newslot(opresult11698);
  params[0] = opresult11682;
  partcv[0] = 1;
  Object opresult11699 = callmethod(opresult11698, "&&", 1, partcv, params);
// compiled op node returning opresult11699 (depth = 4)
  Object if11675 = done;
  if (istrue(opresult11699)) {
// Begin line 3544
  setline(3544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11700 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11702 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11701);
// compiled call node returning call11702 (depth = 8)
// compiled member node returning call11702 (depth = 7)
  partcv[0] = 0;
  Object call11703 = callmethod(call11702, "new",
    1, partcv, params);
  gc_frame_end(callframe11700);
// compiled call node returning call11703 (depth = 6)
// compiled member node returning call11703 (depth = 5)
  *var_sugg = call11703;
  if (call11703 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3545
  setline(3545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11704 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11705 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11706 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11705);
// compiled call node returning call11706 (depth = 8)
// compiled member node returning call11706 (depth = 7)
  partcv[0] = 0;
  Object call11707 = callmethod(call11706, "empty",
    1, partcv, params);
  gc_frame_end(callframe11704);
// compiled call node returning call11707 (depth = 6)
// compiled member node returning call11707 (depth = 5)
  *var_suggestions = call11707;
  if (call11707 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3546
  setline(3546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11708 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool11709 = alloc_Boolean(0);
// compiled identifier node returning bool11709 (depth = 5)
  gc_frame_newslot(bool11709);
// starting to compile identifier node (depth = 5)
  Object bool11710 = alloc_Boolean(0);
// compiled identifier node returning bool11710 (depth = 5)
  gc_frame_newslot(bool11710);
// starting to compile string node (depth = 5)
  if (strlit11711 == NULL) {
    strlit11711 = alloc_String(":=");
    gc_root(strlit11711);
  }
// compiled string node returning strlit11711 (depth = 5)
  gc_frame_newslot(strlit11711);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = *var_sym;
  params[1] = bool11709;
  params[2] = bool11710;
  params[3] = strlit11711;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11712 = callmethod(*var_sugg, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11708);
// compiled call node returning call11712 (depth = 4)
// Begin line 3547
  setline(3547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11713 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call11714 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11713);
// compiled call node returning call11714 (depth = 4)
// Begin line 3548
  setline(3548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11715 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11717 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11716);
// compiled call node returning call11717 (depth = 8)
// compiled member node returning call11717 (depth = 7)
  partcv[0] = 0;
  Object call11718 = callmethod(call11717, "new",
    1, partcv, params);
  gc_frame_end(callframe11715);
// compiled call node returning call11718 (depth = 6)
// compiled member node returning call11718 (depth = 5)
  *var_sugg2 = call11718;
  if (call11718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3549
  setline(3549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11719 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool11720 = alloc_Boolean(0);
// compiled identifier node returning bool11720 (depth = 5)
  gc_frame_newslot(bool11720);
// starting to compile identifier node (depth = 5)
  Object bool11721 = alloc_Boolean(0);
// compiled identifier node returning bool11721 (depth = 5)
  gc_frame_newslot(bool11721);
// starting to compile string node (depth = 5)
  if (strlit11722 == NULL) {
    strlit11722 = alloc_String("==");
    gc_root(strlit11722);
  }
// compiled string node returning strlit11722 (depth = 5)
  gc_frame_newslot(strlit11722);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  params[0] = *var_sym;
  params[1] = bool11720;
  params[2] = bool11721;
  params[3] = strlit11722;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11723 = callmethod(*var_sugg2, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11719);
// compiled call node returning call11723 (depth = 4)
// Begin line 3550
  setline(3550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11724 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  gc_frame_newslot(*var_sugg2);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call11725 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11724);
// compiled call node returning call11725 (depth = 4)
// Begin line 3551
  setline(3551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11726 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11727 == NULL) {
    strlit11727 = alloc_String("Assignment uses ':=', not '='.");
    gc_root(strlit11727);
  }
// compiled string node returning strlit11727 (depth = 5)
  gc_frame_newslot(strlit11727);
// Begin line 3552
  setline(3552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11729 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11728);
// compiled call node returning call11729 (depth = 6)
// compiled member node returning call11729 (depth = 5)
  gc_frame_newslot(call11729);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11730 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11731 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11730);
// compiled call node returning call11731 (depth = 6)
// compiled member node returning call11731 (depth = 5)
  gc_frame_newslot(call11731);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11733 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11732);
// compiled call node returning call11733 (depth = 6)
// compiled member node returning call11733 (depth = 5)
  gc_frame_newslot(call11733);
// Begin line 3553
  setline(3553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3551
  setline(3551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11727;
  params[1] = call11729;
  params[2] = call11731;
  params[3] = call11733;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11734 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11726);
// compiled call node returning call11734 (depth = 4)
    gc_frame_newslot(call11734);
    if11675 = call11734;
  } else {
  }
// compiled if node returning if11675 (depth = 3)
// Begin line 3555
  setline(3555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11737 == NULL) {
    strlit11737 = alloc_String("rgeneric");
    gc_root(strlit11737);
  }
// compiled string node returning strlit11737 (depth = 5)
  int op_slot_right_11736 = gc_frame_newslot(strlit11737);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11740 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11739);
// compiled call node returning call11740 (depth = 6)
// compiled member node returning call11740 (depth = 5)
  int op_slot_left_11736 = gc_frame_newslot(call11740);
  params[0] = strlit11737;
  partcv[0] = 1;
  Object opresult11741 = callmethod(call11740, "==", 1, partcv, params);
// compiled op node returning opresult11741 (depth = 4)
  Object if11735 = done;
  if (istrue(opresult11741)) {
// Begin line 3556
  setline(3556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11742 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11743 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11744 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11743);
// compiled call node returning call11744 (depth = 8)
// compiled member node returning call11744 (depth = 7)
  partcv[0] = 0;
  Object call11745 = callmethod(call11744, "new",
    1, partcv, params);
  gc_frame_end(callframe11742);
// compiled call node returning call11745 (depth = 6)
// compiled member node returning call11745 (depth = 5)
  *var_sugg = call11745;
  if (call11745 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3557
  setline(3557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11746 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11747 == NULL) {
    strlit11747 = alloc_String(" ");
    gc_root(strlit11747);
  }
// compiled string node returning strlit11747 (depth = 5)
  gc_frame_newslot(strlit11747);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11748 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11749 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11748);
// compiled call node returning call11749 (depth = 6)
// compiled member node returning call11749 (depth = 5)
  gc_frame_newslot(call11749);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11751 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11750);
// compiled call node returning call11751 (depth = 6)
// compiled member node returning call11751 (depth = 5)
  gc_frame_newslot(call11751);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = strlit11747;
  params[1] = call11749;
  params[2] = call11751;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11752 = callmethod(*var_sugg, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe11746);
// compiled call node returning call11752 (depth = 4)
// Begin line 3558
  setline(3558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11753 = gc_frame_new();
// Begin line 3559
  setline(3559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit11754 == NULL) {
    strlit11754 = alloc_String("The '>' operator must have a space before it.");
    gc_root(strlit11754);
  }
// compiled string node returning strlit11754 (depth = 5)
  gc_frame_newslot(strlit11754);
// Begin line 3560
  setline(3560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11756 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11755);
// compiled call node returning call11756 (depth = 6)
// compiled member node returning call11756 (depth = 5)
  gc_frame_newslot(call11756);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11757 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11758 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11757);
// compiled call node returning call11758 (depth = 6)
// compiled member node returning call11758 (depth = 5)
  gc_frame_newslot(call11758);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11759 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11760 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11759);
// compiled call node returning call11760 (depth = 6)
// compiled member node returning call11760 (depth = 5)
  gc_frame_newslot(call11760);
// Begin line 3561
  setline(3561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3558
  setline(3558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11754;
  params[1] = call11756;
  params[2] = call11758;
  params[3] = call11760;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11761 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11753);
// compiled call node returning call11761 (depth = 4)
    gc_frame_newslot(call11761);
    if11735 = call11761;
  } else {
  }
// compiled if node returning if11735 (depth = 3)
// Begin line 3563
  setline(3563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11764 == NULL) {
    strlit11764 = alloc_String("rbrace");
    gc_root(strlit11764);
  }
// compiled string node returning strlit11764 (depth = 5)
  int op_slot_right_11763 = gc_frame_newslot(strlit11764);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11767 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11766);
// compiled call node returning call11767 (depth = 6)
// compiled member node returning call11767 (depth = 5)
  int op_slot_left_11763 = gc_frame_newslot(call11767);
  params[0] = strlit11764;
  partcv[0] = 1;
  Object opresult11768 = callmethod(call11767, "!=", 1, partcv, params);
// compiled op node returning opresult11768 (depth = 4)
  Object if11762 = done;
  if (istrue(opresult11768)) {
// Begin line 3564
  setline(3564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11769 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11770 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11771 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11770);
// compiled call node returning call11771 (depth = 8)
// compiled member node returning call11771 (depth = 7)
  partcv[0] = 0;
  Object call11772 = callmethod(call11771, "empty",
    1, partcv, params);
  gc_frame_end(callframe11769);
// compiled call node returning call11772 (depth = 6)
// compiled member node returning call11772 (depth = 5)
  *var_suggestions = call11772;
  if (call11772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3565
  setline(3565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3566
  setline(3566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11774 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block11775 = alloc_Block(NULL, NULL, "parser", 3566);
  gc_frame_newslot(block11775);
// method _apply
  block_savedest(block11775);
  Object closure11776 = createclosure(3, "_apply");
  setclosureframe(closure11776, stackframe);
  addtoclosure(closure11776, var_sym);
  addtoclosure(closure11776, var_values);
  addtoclosure(closure11776, selfslot);
  struct UserObject *uo11776 = (struct UserObject*)block11775;
  uo11776->data[0] = (Object)closure11776;
  Method *meth_meth_parser__apply11776 = addmethod2pos(block11775, "_apply", &meth_parser__apply11776, 0);
  int argcv_meth_parser__apply11776[] = {0};
  meth_meth_parser__apply11776->type = alloc_MethodType(1, argcv_meth_parser__apply11776);
  meth_meth_parser__apply11776->definitionModule = modulename;
  meth_meth_parser__apply11776->definitionLine = 3564;
// compiled block node returning block11775 (depth = 6)
  gc_frame_newslot(block11775);
// call case 6: other member request
// Begin line 3566
  setline(3566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11811 = alloc_Float64(0);
// compiled num node returning num11811 (depth = 7)
  int op_slot_right_11810 = gc_frame_newslot(num11811);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11814 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe11813);
// compiled call node returning call11814 (depth = 8)
// compiled member node returning call11814 (depth = 7)
  int op_slot_left_11810 = gc_frame_newslot(call11814);
  params[0] = num11811;
  partcv[0] = 1;
  Object opresult11815 = callmethod(call11814, ">", 1, partcv, params);
// compiled op node returning opresult11815 (depth = 6)
  params[0] = block11775;
  partcv[0] = 1;
  Object call11816 = callmethod(opresult11815, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11774);
// compiled call node returning call11816 (depth = 5)
  Object if11773 = done;
  if (istrue(call11816)) {
// Begin line 3573
  setline(3573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11817 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11818 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11819 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11818);
// compiled call node returning call11819 (depth = 9)
// compiled member node returning call11819 (depth = 8)
  partcv[0] = 0;
  Object call11820 = callmethod(call11819, "new",
    1, partcv, params);
  gc_frame_end(callframe11817);
// compiled call node returning call11820 (depth = 7)
// compiled member node returning call11820 (depth = 6)
  *var_suggestion = call11820;
  if (call11820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3574
  setline(3574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11822 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool11823 = alloc_Boolean(1);
// compiled identifier node returning bool11823 (depth = 6)
  gc_frame_newslot(bool11823);
// starting to compile identifier node (depth = 6)
  Object bool11824 = alloc_Boolean(0);
// compiled identifier node returning bool11824 (depth = 6)
  gc_frame_newslot(bool11824);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11826 == NULL) {
    strlit11826 = alloc_String(")");
    gc_root(strlit11826);
  }
// compiled string node returning strlit11826 (depth = 7)
  int op_slot_right_11825 = gc_frame_newslot(strlit11826);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11829 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11830 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11829);
// compiled call node returning call11830 (depth = 9)
// compiled member node returning call11830 (depth = 8)
  int op_slot_right_11828 = gc_frame_newslot(call11830);
// starting to compile string node (depth = 8)
  if (strlit11832 == NULL) {
    strlit11832 = alloc_String("(");
    gc_root(strlit11832);
  }
// compiled string node returning strlit11832 (depth = 8)
  int op_slot_left_11828 = gc_frame_newslot(strlit11832);
  params[0] = call11830;
  partcv[0] = 1;
  Object opresult11833 = callmethod(strlit11832, "++", 1, partcv, params);
// compiled op node returning opresult11833 (depth = 7)
  int op_slot_left_11825 = gc_frame_newslot(opresult11833);
  params[0] = strlit11826;
  partcv[0] = 1;
  Object opresult11834 = callmethod(opresult11833, "++", 1, partcv, params);
// compiled op node returning opresult11834 (depth = 6)
  gc_frame_newslot(opresult11834);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool11823;
  params[2] = bool11824;
  params[3] = opresult11834;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11835 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11822);
// compiled call node returning call11835 (depth = 5)
// Begin line 3575
  setline(3575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11836 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11837 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11836);
// compiled call node returning call11837 (depth = 5)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11840 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11841 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11840);
// compiled call node returning call11841 (depth = 8)
// compiled member node returning call11841 (depth = 7)
  int op_slot_right_11839 = gc_frame_newslot(call11841);
// starting to compile identifier node (depth = 7)
  Object bool11843 = alloc_Boolean(0);
// compiled identifier node returning bool11843 (depth = 7)
  int op_slot_left_11839 = gc_frame_newslot(bool11843);
  params[0] = call11841;
  partcv[0] = 1;
  Object opresult11844 = callmethod(bool11843, "!=", 1, partcv, params);
// compiled op node returning opresult11844 (depth = 6)
  Object if11838 = done;
  if (istrue(opresult11844)) {
// Begin line 3577
  setline(3577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11845 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11846 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11845);
// compiled call node returning call11846 (depth = 8)
// compiled member node returning call11846 (depth = 7)
  *var_n = call11846;
  if (call11846 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 3578
  setline(3578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11849 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11850 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11849);
// compiled call node returning call11850 (depth = 9)
// compiled member node returning call11850 (depth = 8)
  int op_slot_right_11848 = gc_frame_newslot(call11850);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11852 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call11853 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe11852);
// compiled call node returning call11853 (depth = 9)
// compiled member node returning call11853 (depth = 8)
  int op_slot_left_11848 = gc_frame_newslot(call11853);
  params[0] = call11850;
  partcv[0] = 1;
  Object opresult11854 = callmethod(call11853, "==", 1, partcv, params);
// compiled op node returning opresult11854 (depth = 7)
  Object if11847 = done;
  if (istrue(opresult11854)) {
// Begin line 3579
  setline(3579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11855 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11856 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call11857 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11856);
// compiled call node returning call11857 (depth = 11)
// compiled member node returning call11857 (depth = 10)
  partcv[0] = 0;
  Object call11858 = callmethod(call11857, "new",
    1, partcv, params);
  gc_frame_end(callframe11855);
// compiled call node returning call11858 (depth = 9)
// compiled member node returning call11858 (depth = 8)
  *var_suggestion = call11858;
  if (call11858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3580
  setline(3580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11860 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool11861 = alloc_Boolean(1);
// compiled identifier node returning bool11861 (depth = 8)
  gc_frame_newslot(bool11861);
// starting to compile identifier node (depth = 8)
  Object bool11862 = alloc_Boolean(0);
// compiled identifier node returning bool11862 (depth = 8)
  gc_frame_newslot(bool11862);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11864 == NULL) {
    strlit11864 = alloc_String("");
    gc_root(strlit11864);
  }
// compiled string node returning strlit11864 (depth = 9)
  int op_slot_right_11863 = gc_frame_newslot(strlit11864);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11867 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11868 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11867);
// compiled call node returning call11868 (depth = 11)
// compiled member node returning call11868 (depth = 10)
  int op_slot_right_11866 = gc_frame_newslot(call11868);
// starting to compile string node (depth = 10)
  if (strlit11870 == NULL) {
    strlit11870 = alloc_String("(");
    gc_root(strlit11870);
  }
// compiled string node returning strlit11870 (depth = 10)
  int op_slot_left_11866 = gc_frame_newslot(strlit11870);
  params[0] = call11868;
  partcv[0] = 1;
  Object opresult11871 = callmethod(strlit11870, "++", 1, partcv, params);
// compiled op node returning opresult11871 (depth = 9)
  int op_slot_left_11863 = gc_frame_newslot(opresult11871);
  params[0] = strlit11864;
  partcv[0] = 1;
  Object opresult11872 = callmethod(opresult11871, "++", 1, partcv, params);
// compiled op node returning opresult11872 (depth = 8)
  gc_frame_newslot(opresult11872);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool11861;
  params[2] = bool11862;
  params[3] = opresult11872;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11873 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11860);
// compiled call node returning call11873 (depth = 7)
// Begin line 3581
  setline(3581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11874 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit11875 == NULL) {
    strlit11875 = alloc_String(")");
    gc_root(strlit11875);
  }
// compiled string node returning strlit11875 (depth = 8)
  gc_frame_newslot(strlit11875);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11876 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11877 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11876);
// compiled call node returning call11877 (depth = 9)
// compiled member node returning call11877 (depth = 8)
  gc_frame_newslot(call11877);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit11875;
  params[1] = call11877;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11878 = callmethod(*var_suggestion, "append()onLine",
    2, partcv, params);
  gc_frame_end(callframe11874);
// compiled call node returning call11878 (depth = 7)
// Begin line 3582
  setline(3582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11879 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11880 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11879);
// compiled call node returning call11880 (depth = 7)
    gc_frame_newslot(call11880);
    if11847 = call11880;
  } else {
  }
// compiled if node returning if11847 (depth = 6)
    gc_frame_newslot(if11847);
    if11838 = if11847;
  } else {
  }
// compiled if node returning if11838 (depth = 5)
// Begin line 3585
  setline(3585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11883 == NULL) {
    strlit11883 = alloc_String("identifier");
    gc_root(strlit11883);
  }
// compiled string node returning strlit11883 (depth = 7)
  int op_slot_right_11882 = gc_frame_newslot(strlit11883);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11885 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11886 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call11887 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11886);
// compiled call node returning call11887 (depth = 10)
// compiled member node returning call11887 (depth = 9)
  partcv[0] = 0;
  Object call11888 = callmethod(call11887, "kind",
    1, partcv, params);
  gc_frame_end(callframe11885);
// compiled call node returning call11888 (depth = 8)
// compiled member node returning call11888 (depth = 7)
  int op_slot_left_11882 = gc_frame_newslot(call11888);
  params[0] = strlit11883;
  partcv[0] = 1;
  Object opresult11889 = callmethod(call11888, "==", 1, partcv, params);
// compiled op node returning opresult11889 (depth = 6)
  Object if11881 = done;
  if (istrue(opresult11889)) {
// Begin line 3586
  setline(3586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11890 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call11892 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11891);
// compiled call node returning call11892 (depth = 10)
// compiled member node returning call11892 (depth = 9)
  partcv[0] = 0;
  Object call11893 = callmethod(call11892, "new",
    1, partcv, params);
  gc_frame_end(callframe11890);
// compiled call node returning call11893 (depth = 8)
// compiled member node returning call11893 (depth = 7)
  *var_suggestion = call11893;
  if (call11893 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3587
  setline(3587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11895 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool11896 = alloc_Boolean(0);
// compiled identifier node returning bool11896 (depth = 7)
  gc_frame_newslot(bool11896);
// starting to compile identifier node (depth = 7)
  Object bool11897 = alloc_Boolean(0);
// compiled identifier node returning bool11897 (depth = 7)
  gc_frame_newslot(bool11897);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11899 == NULL) {
    strlit11899 = alloc_String("""\x22""");
    gc_root(strlit11899);
  }
// compiled string node returning strlit11899 (depth = 8)
  int op_slot_right_11898 = gc_frame_newslot(strlit11899);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11902 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11903 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11902);
// compiled call node returning call11903 (depth = 10)
// compiled member node returning call11903 (depth = 9)
  int op_slot_right_11901 = gc_frame_newslot(call11903);
// starting to compile string node (depth = 9)
  if (strlit11905 == NULL) {
    strlit11905 = alloc_String("""\x22""");
    gc_root(strlit11905);
  }
// compiled string node returning strlit11905 (depth = 9)
  int op_slot_left_11901 = gc_frame_newslot(strlit11905);
  params[0] = call11903;
  partcv[0] = 1;
  Object opresult11906 = callmethod(strlit11905, "++", 1, partcv, params);
// compiled op node returning opresult11906 (depth = 8)
  int op_slot_left_11898 = gc_frame_newslot(opresult11906);
  params[0] = strlit11899;
  partcv[0] = 1;
  Object opresult11907 = callmethod(opresult11906, "++", 1, partcv, params);
// compiled op node returning opresult11907 (depth = 7)
  gc_frame_newslot(opresult11907);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool11896;
  params[2] = bool11897;
  params[3] = opresult11907;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11908 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11895);
// compiled call node returning call11908 (depth = 6)
// Begin line 3588
  setline(3588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11909 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11910 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11909);
// compiled call node returning call11910 (depth = 6)
    gc_frame_newslot(call11910);
    if11881 = call11910;
  } else {
  }
// compiled if node returning if11881 (depth = 5)
    gc_frame_newslot(if11881);
    if11773 = if11881;
  } else {
  }
// compiled if node returning if11773 (depth = 4)
// Begin line 3591
  setline(3591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11911 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit11912 == NULL) {
    strlit11912 = alloc_String("rbrace");
    gc_root(strlit11912);
  }
// compiled string node returning strlit11912 (depth = 6)
  gc_frame_newslot(strlit11912);
// call case 4: self request
  params[0] = strlit11912;
  partcv[0] = 1;
  Object call11913 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11911);
// compiled call node returning call11913 (depth = 5)
  *var_nextTok = call11913;
  if (call11913 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3592
  setline(3592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_11915 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_11915 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult11917 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult11917 (depth = 5)
  Object if11914 = done;
  if (istrue(opresult11917)) {
// Begin line 3593
  setline(3593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11918 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11920 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11919);
// compiled call node returning call11920 (depth = 9)
// compiled member node returning call11920 (depth = 8)
  partcv[0] = 0;
  Object call11921 = callmethod(call11920, "new",
    1, partcv, params);
  gc_frame_end(callframe11918);
// compiled call node returning call11921 (depth = 7)
// compiled member node returning call11921 (depth = 6)
  *var_suggestion = call11921;
  if (call11921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3594
  setline(3594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11923 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call11925 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11924);
// compiled call node returning call11925 (depth = 7)
// compiled member node returning call11925 (depth = 6)
  gc_frame_newslot(call11925);
// starting to compile call node (depth = 6)
  int callframe11926 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num11927 = alloc_Float64(1);
// compiled num node returning num11927 (depth = 7)
  gc_frame_newslot(num11927);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11929 = alloc_Float64(1);
// compiled num node returning num11929 (depth = 8)
  int op_slot_right_11928 = gc_frame_newslot(num11929);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call11933 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe11932);
// compiled call node returning call11933 (depth = 10)
// compiled member node returning call11933 (depth = 9)
  int op_slot_right_11931 = gc_frame_newslot(call11933);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call11936 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11935);
// compiled call node returning call11936 (depth = 10)
// compiled member node returning call11936 (depth = 9)
  int op_slot_left_11931 = gc_frame_newslot(call11936);
  params[0] = call11933;
  partcv[0] = 1;
  Object sum11937 = callmethod(call11936, "+", 1, partcv, params);
// compiled op node returning sum11937 (depth = 8)
  int op_slot_left_11928 = gc_frame_newslot(sum11937);
  params[0] = num11929;
  partcv[0] = 1;
  Object diff11938 = callmethod(sum11937, "-", 1, partcv, params);
// compiled op node returning diff11938 (depth = 7)
  gc_frame_newslot(diff11938);
// call case 6: other member request
// starting to compile index node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call11940 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11939);
// compiled call node returning call11940 (depth = 9)
// compiled member node returning call11940 (depth = 8)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call11942 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11941);
// compiled call node returning call11942 (depth = 9)
// compiled member node returning call11942 (depth = 8)
  params[0] = call11942;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11943 = callmethod(call11940, "[]", 1, partcv, params);
// compiled index node returning idxres11943 (depth = 7)
  params[0] = num11927;
  params[1] = diff11938;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11944 = callmethod(idxres11943, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11926);
// compiled call node returning call11944 (depth = 6)
  gc_frame_newslot(call11944);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = call11925;
  params[1] = call11944;
  partcv[0] = 2;
  Object call11945 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11923);
// compiled call node returning call11945 (depth = 5)
// Begin line 3595
  setline(3595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11946 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11948 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11947);
// compiled call node returning call11948 (depth = 8)
// compiled member node returning call11948 (depth = 7)
  gc_frame_newslot(call11948);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11949 = gc_frame_new();
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11950 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_util (depth = 12)
  partcv[0] = 0;
  Object call11951 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11950);
// compiled call node returning call11951 (depth = 11)
// compiled member node returning call11951 (depth = 10)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11952 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11953 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11952);
// compiled call node returning call11953 (depth = 11)
// compiled member node returning call11953 (depth = 10)
  params[0] = call11953;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11954 = callmethod(call11951, "[]", 1, partcv, params);
// compiled index node returning idxres11954 (depth = 9)
  partcv[0] = 0;
  Object call11955 = callmethod(idxres11954, "size",
    1, partcv, params);
  gc_frame_end(callframe11949);
// compiled call node returning call11955 (depth = 8)
// compiled member node returning call11955 (depth = 7)
  gc_frame_newslot(call11955);
// call case 6: other member request
// starting to compile index node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call11957 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11956);
// compiled call node returning call11957 (depth = 9)
// compiled member node returning call11957 (depth = 8)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11958 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11959 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11958);
// compiled call node returning call11959 (depth = 9)
// compiled member node returning call11959 (depth = 8)
  params[0] = call11959;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11960 = callmethod(call11957, "[]", 1, partcv, params);
// compiled index node returning idxres11960 (depth = 7)
  params[0] = call11948;
  params[1] = call11955;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11961 = callmethod(idxres11960, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11946);
// compiled call node returning call11961 (depth = 6)
  *var_newLine = call11961;
  if (call11961 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3596
  setline(3596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11962 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11964 = alloc_Float64(0.1);
// compiled num node returning num11964 (depth = 7)
  int op_slot_right_11963 = gc_frame_newslot(num11964);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11966 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call11967 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11966);
// compiled call node returning call11967 (depth = 8)
// compiled member node returning call11967 (depth = 7)
  int op_slot_left_11963 = gc_frame_newslot(call11967);
  params[0] = num11964;
  partcv[0] = 1;
  Object sum11968 = callmethod(call11967, "+", 1, partcv, params);
// compiled op node returning sum11968 (depth = 6)
  gc_frame_newslot(sum11968);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum11968;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call11969 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11962);
// compiled call node returning call11969 (depth = 5)
// Begin line 3597
  setline(3597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11970 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11971 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11970);
// compiled call node returning call11971 (depth = 5)
    gc_frame_newslot(call11971);
    if11914 = call11971;
  } else {
// Begin line 3599
  setline(3599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11972 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11973 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11974 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11973);
// compiled call node returning call11974 (depth = 9)
// compiled member node returning call11974 (depth = 8)
  partcv[0] = 0;
  Object call11975 = callmethod(call11974, "new",
    1, partcv, params);
  gc_frame_end(callframe11972);
// compiled call node returning call11975 (depth = 7)
// compiled member node returning call11975 (depth = 6)
  *var_suggestion = call11975;
  if (call11975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3600
  setline(3600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11977 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call11979 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11978);
// compiled call node returning call11979 (depth = 7)
// compiled member node returning call11979 (depth = 6)
  gc_frame_newslot(call11979);
// starting to compile identifier node (depth = 6)
  Object bool11980 = alloc_Boolean(1);
// compiled identifier node returning bool11980 (depth = 6)
  gc_frame_newslot(bool11980);
// starting to compile identifier node (depth = 6)
  Object bool11981 = alloc_Boolean(0);
// compiled identifier node returning bool11981 (depth = 6)
  gc_frame_newslot(bool11981);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call11979;
  params[2] = bool11980;
  params[3] = bool11981;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11982 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe11977);
// compiled call node returning call11982 (depth = 5)
// Begin line 3601
  setline(3601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11983 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11984 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11983);
// compiled call node returning call11984 (depth = 5)
    gc_frame_newslot(call11984);
    if11914 = call11984;
  }
// compiled if node returning if11914 (depth = 4)
// Begin line 3603
  setline(3603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11985 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11986 == NULL) {
    strlit11986 = alloc_String("Multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.");
    gc_root(strlit11986);
  }
// compiled string node returning strlit11986 (depth = 5)
  gc_frame_newslot(strlit11986);
// Begin line 3604
  setline(3604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11988 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11987);
// compiled call node returning call11988 (depth = 6)
// compiled member node returning call11988 (depth = 5)
  gc_frame_newslot(call11988);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11990 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11989);
// compiled call node returning call11990 (depth = 6)
// compiled member node returning call11990 (depth = 5)
  gc_frame_newslot(call11990);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3603
  setline(3603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11986;
  params[1] = call11988;
  params[2] = call11990;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11991 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11985);
// compiled call node returning call11991 (depth = 4)
    gc_frame_newslot(call11991);
    if11762 = call11991;
  } else {
  }
// compiled if node returning if11762 (depth = 3)
    gc_frame_newslot(if11762);
    if11667 = if11762;
  } else {
  }
// compiled if node returning if11667 (depth = 2)
  gc_frame_end(frame);
  return if11667;
}
Object meth_parser__apply12100(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num12102 = alloc_Float64(0);
// compiled num node returning num12102 (depth = 5)
  int op_slot_right_12101 = gc_frame_newslot(num12102);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12104 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call12105 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe12104);
// compiled call node returning call12105 (depth = 6)
// compiled member node returning call12105 (depth = 5)
  int op_slot_left_12101 = gc_frame_newslot(call12105);
  params[0] = num12102;
  partcv[0] = 1;
  Object opresult12106 = callmethod(call12105, ">", 1, partcv, params);
// compiled op node returning opresult12106 (depth = 4)
  gc_frame_end(frame);
  return opresult12106;
}
Object meth_parser__apply12109(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_oldlength = getfromclosure(closure, 0);
  Object *var_tokens = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 3644
  setline(3644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12111 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12110);
// compiled call node returning call12111 (depth = 5)
// compiled member node returning call12111 (depth = 4)
// Begin line 3645
  setline(3645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12112 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12113 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12112);
// compiled call node returning call12113 (depth = 5)
// compiled member node returning call12113 (depth = 4)
// Begin line 3646
  setline(3646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12114 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12115 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12114);
// compiled call node returning call12115 (depth = 5)
// compiled member node returning call12115 (depth = 4)
// Begin line 3647
  setline(3647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12117 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12116);
// compiled call node returning call12117 (depth = 5)
// compiled member node returning call12117 (depth = 4)
// Begin line 3648
  setline(3648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12119 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12118);
// compiled call node returning call12119 (depth = 5)
// compiled member node returning call12119 (depth = 4)
// Begin line 3649
  setline(3649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12121 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12120);
// compiled call node returning call12121 (depth = 5)
// compiled member node returning call12121 (depth = 4)
// Begin line 3650
  setline(3650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12123 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12122);
// compiled call node returning call12123 (depth = 5)
// compiled member node returning call12123 (depth = 4)
// Begin line 3651
  setline(3651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldlength (depth = 6)
  int op_slot_right_12125 = gc_frame_newslot(*var_oldlength);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe12127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call12128 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe12127);
// compiled call node returning call12128 (depth = 7)
// compiled member node returning call12128 (depth = 6)
  int op_slot_left_12125 = gc_frame_newslot(call12128);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult12129 = callmethod(call12128, "==", 1, partcv, params);
// compiled op node returning opresult12129 (depth = 5)
  Object if12124 = done;
  if (istrue(opresult12129)) {
// Begin line 3652
  setline(3652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe12130 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe12131 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call12132 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe12131);
// compiled call node returning call12132 (depth = 9)
// compiled member node returning call12132 (depth = 8)
  partcv[0] = 0;
  Object call12133 = callmethod(call12132, "new",
    1, partcv, params);
  gc_frame_end(callframe12130);
// compiled call node returning call12133 (depth = 7)
// compiled member node returning call12133 (depth = 6)
  *var_suggestion = call12133;
  if (call12133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3653
  setline(3653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe12134 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call12135 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe12134);
// compiled call node returning call12135 (depth = 5)
// Begin line 3654
  setline(3654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe12136 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit12137 == NULL) {
    strlit12137 = alloc_String("Invalid statement. This is often caused by an extra '}', ')', or ']'.");
    gc_root(strlit12137);
  }
// compiled string node returning strlit12137 (depth = 6)
  gc_frame_newslot(strlit12137);
// Begin line 3655
  setline(3655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe12138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call12139 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe12138);
// compiled call node returning call12139 (depth = 7)
// compiled member node returning call12139 (depth = 6)
  gc_frame_newslot(call12139);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe12140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call12141 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe12140);
// compiled call node returning call12141 (depth = 7)
// compiled member node returning call12141 (depth = 6)
  gc_frame_newslot(call12141);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num12143 = alloc_Float64(1);
// compiled num node returning num12143 (depth = 7)
  int op_slot_right_12142 = gc_frame_newslot(num12143);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe12146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call12147 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe12146);
// compiled call node returning call12147 (depth = 9)
// compiled member node returning call12147 (depth = 8)
  int op_slot_right_12145 = gc_frame_newslot(call12147);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe12149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call12150 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe12149);
// compiled call node returning call12150 (depth = 9)
// compiled member node returning call12150 (depth = 8)
  int op_slot_left_12145 = gc_frame_newslot(call12150);
  params[0] = call12147;
  partcv[0] = 1;
  Object sum12151 = callmethod(call12150, "+", 1, partcv, params);
// compiled op node returning sum12151 (depth = 7)
  int op_slot_left_12142 = gc_frame_newslot(sum12151);
  params[0] = num12143;
  partcv[0] = 1;
  Object diff12152 = callmethod(sum12151, "-", 1, partcv, params);
// compiled op node returning diff12152 (depth = 6)
  gc_frame_newslot(diff12152);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3654
  setline(3654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit12137;
  params[1] = call12139;
  params[2] = call12141;
  params[3] = diff12152;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call12153 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe12136);
// compiled call node returning call12153 (depth = 5)
    gc_frame_newslot(call12153);
    if12124 = call12153;
  } else {
  }
// compiled if node returning if12124 (depth = 4)
// Begin line 3657
  setline(3657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call12155 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe12154);
// compiled call node returning call12155 (depth = 6)
// compiled member node returning call12155 (depth = 5)
  *var_oldlength = call12155;
  if (call12155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_parse11992(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parse");
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_defaultDefVisibility = getfromclosure(closure, 1);
  Object *var_defaultVarVisibility = getfromclosure(closure, 2);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_values = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parse (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parse");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sugg");
  Object *var_oldlength = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldlength");
// Begin line 3614
  setline(3614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11993 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit11994 == NULL) {
    strlit11994 = alloc_String("parsing.");
    gc_root(strlit11994);
  }
// compiled string node returning strlit11994 (depth = 3)
  gc_frame_newslot(strlit11994);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit11994;
  partcv[0] = 1;
  Object call11995 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11993);
// compiled call node returning call11995 (depth = 2)
// Begin line 3616
  setline(3616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11997 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11998 == NULL) {
    strlit11998 = alloc_String("DefaultVisibility");
    gc_root(strlit11998);
  }
// compiled string node returning strlit11998 (depth = 4)
  gc_frame_newslot(strlit11998);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call12000 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11999);
// compiled call node returning call12000 (depth = 5)
// compiled member node returning call12000 (depth = 4)
  params[0] = strlit11998;
  partcv[0] = 1;
  Object call12001 = callmethod(call12000, "contains",
    1, partcv, params);
  gc_frame_end(callframe11997);
// compiled call node returning call12001 (depth = 3)
  Object if11996 = done;
  if (istrue(call12001)) {
// Begin line 3617
  setline(3617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe12002 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit12003 == NULL) {
    strlit12003 = alloc_String("DefaultVisibility");
    gc_root(strlit12003);
  }
// compiled string node returning strlit12003 (depth = 5)
  gc_frame_newslot(strlit12003);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call12005 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12004);
// compiled call node returning call12005 (depth = 6)
// compiled member node returning call12005 (depth = 5)
  params[0] = strlit12003;
  partcv[0] = 1;
  Object call12006 = callmethod(call12005, "get",
    1, partcv, params);
  gc_frame_end(callframe12002);
// compiled call node returning call12006 (depth = 4)
  *var_defaultDefVisibility = call12006;
  if (call12006 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3618
  setline(3618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe12008 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit12009 == NULL) {
    strlit12009 = alloc_String("DefaultVisibility");
    gc_root(strlit12009);
  }
// compiled string node returning strlit12009 (depth = 5)
  gc_frame_newslot(strlit12009);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call12011 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12010);
// compiled call node returning call12011 (depth = 6)
// compiled member node returning call12011 (depth = 5)
  params[0] = strlit12009;
  partcv[0] = 1;
  Object call12012 = callmethod(call12011, "get",
    1, partcv, params);
  gc_frame_end(callframe12008);
// compiled call node returning call12012 (depth = 4)
  *var_defaultVarVisibility = call12012;
  if (call12012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3619
  setline(3619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe12014 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit12015 == NULL) {
    strlit12015 = alloc_String("DefaultVisibility");
    gc_root(strlit12015);
  }
// compiled string node returning strlit12015 (depth = 5)
  gc_frame_newslot(strlit12015);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call12017 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12016);
// compiled call node returning call12017 (depth = 6)
// compiled member node returning call12017 (depth = 5)
  params[0] = strlit12015;
  partcv[0] = 1;
  Object call12018 = callmethod(call12017, "get",
    1, partcv, params);
  gc_frame_end(callframe12014);
// compiled call node returning call12018 (depth = 4)
  *var_defaultMethodVisibility = call12018;
  if (call12018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11996 = done;
  } else {
  }
// compiled if node returning if11996 (depth = 2)
// Begin line 3621
  setline(3621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12021 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit12022 == NULL) {
    strlit12022 = alloc_String("DefaultDefVisibility");
    gc_root(strlit12022);
  }
// compiled string node returning strlit12022 (depth = 4)
  gc_frame_newslot(strlit12022);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call12024 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12023);
// compiled call node returning call12024 (depth = 5)
// compiled member node returning call12024 (depth = 4)
  params[0] = strlit12022;
  partcv[0] = 1;
  Object call12025 = callmethod(call12024, "contains",
    1, partcv, params);
  gc_frame_end(callframe12021);
// compiled call node returning call12025 (depth = 3)
  Object if12020 = done;
  if (istrue(call12025)) {
// Begin line 3622
  setline(3622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe12026 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit12027 == NULL) {
    strlit12027 = alloc_String("DefaultDefVisibility");
    gc_root(strlit12027);
  }
// compiled string node returning strlit12027 (depth = 5)
  gc_frame_newslot(strlit12027);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call12029 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12028);
// compiled call node returning call12029 (depth = 6)
// compiled member node returning call12029 (depth = 5)
  params[0] = strlit12027;
  partcv[0] = 1;
  Object call12030 = callmethod(call12029, "get",
    1, partcv, params);
  gc_frame_end(callframe12026);
// compiled call node returning call12030 (depth = 4)
  *var_defaultDefVisibility = call12030;
  if (call12030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if12020 = done;
  } else {
  }
// compiled if node returning if12020 (depth = 2)
// Begin line 3624
  setline(3624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12033 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit12034 == NULL) {
    strlit12034 = alloc_String("DefaultVarVisibility");
    gc_root(strlit12034);
  }
// compiled string node returning strlit12034 (depth = 4)
  gc_frame_newslot(strlit12034);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call12036 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12035);
// compiled call node returning call12036 (depth = 5)
// compiled member node returning call12036 (depth = 4)
  params[0] = strlit12034;
  partcv[0] = 1;
  Object call12037 = callmethod(call12036, "contains",
    1, partcv, params);
  gc_frame_end(callframe12033);
// compiled call node returning call12037 (depth = 3)
  Object if12032 = done;
  if (istrue(call12037)) {
// Begin line 3625
  setline(3625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe12038 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit12039 == NULL) {
    strlit12039 = alloc_String("DefaultVarVisibility");
    gc_root(strlit12039);
  }
// compiled string node returning strlit12039 (depth = 5)
  gc_frame_newslot(strlit12039);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12040 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call12041 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12040);
// compiled call node returning call12041 (depth = 6)
// compiled member node returning call12041 (depth = 5)
  params[0] = strlit12039;
  partcv[0] = 1;
  Object call12042 = callmethod(call12041, "get",
    1, partcv, params);
  gc_frame_end(callframe12038);
// compiled call node returning call12042 (depth = 4)
  *var_defaultVarVisibility = call12042;
  if (call12042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if12032 = done;
  } else {
  }
// compiled if node returning if12032 (depth = 2)
// Begin line 3627
  setline(3627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12045 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit12046 == NULL) {
    strlit12046 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit12046);
  }
// compiled string node returning strlit12046 (depth = 4)
  gc_frame_newslot(strlit12046);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12047 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call12048 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12047);
// compiled call node returning call12048 (depth = 5)
// compiled member node returning call12048 (depth = 4)
  params[0] = strlit12046;
  partcv[0] = 1;
  Object call12049 = callmethod(call12048, "contains",
    1, partcv, params);
  gc_frame_end(callframe12045);
// compiled call node returning call12049 (depth = 3)
  Object if12044 = done;
  if (istrue(call12049)) {
// Begin line 3628
  setline(3628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe12050 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit12051 == NULL) {
    strlit12051 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit12051);
  }
// compiled string node returning strlit12051 (depth = 5)
  gc_frame_newslot(strlit12051);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12052 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call12053 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe12052);
// compiled call node returning call12053 (depth = 6)
// compiled member node returning call12053 (depth = 5)
  params[0] = strlit12051;
  partcv[0] = 1;
  Object call12054 = callmethod(call12053, "get",
    1, partcv, params);
  gc_frame_end(callframe12050);
// compiled call node returning call12054 (depth = 4)
  *var_defaultMethodVisibility = call12054;
  if (call12054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if12044 = done;
  } else {
  }
// compiled if node returning if12044 (depth = 2)
// Begin line 3630
  setline(3630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num12058 = alloc_Float64(0);
// compiled num node returning num12058 (depth = 4)
  int op_slot_right_12057 = gc_frame_newslot(num12058);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_toks (depth = 6)
  partcv[0] = 0;
  Object call12061 = callmethod(*var_toks, "size",
    1, partcv, params);
  gc_frame_end(callframe12060);
// compiled call node returning call12061 (depth = 5)
// compiled member node returning call12061 (depth = 4)
  int op_slot_left_12057 = gc_frame_newslot(call12061);
  params[0] = num12058;
  partcv[0] = 1;
  Object opresult12062 = callmethod(call12061, "==", 1, partcv, params);
// compiled op node returning opresult12062 (depth = 3)
  Object if12056 = done;
  if (istrue(opresult12062)) {
// Begin line 3631
  setline(3631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12063 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe12064 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call12065 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12064);
// compiled call node returning call12065 (depth = 7)
// compiled member node returning call12065 (depth = 6)
  partcv[0] = 0;
  Object call12066 = callmethod(call12065, "empty",
    1, partcv, params);
  gc_frame_end(callframe12063);
// compiled call node returning call12066 (depth = 5)
// compiled member node returning call12066 (depth = 4)
  return call12066;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if12056 = undefined;
  } else {
  }
// compiled if node returning if12056 (depth = 2)
// Begin line 3633
  setline(3633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_toks (depth = 3)
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3634
  setline(3634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12068 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12069 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12068);
// compiled call node returning call12069 (depth = 3)
// compiled member node returning call12069 (depth = 2)
// Begin line 3635
  setline(3635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num12072 = alloc_Float64(0);
// compiled num node returning num12072 (depth = 4)
  int op_slot_right_12071 = gc_frame_newslot(num12072);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12074 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call12075 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe12074);
// compiled call node returning call12075 (depth = 5)
// compiled member node returning call12075 (depth = 4)
  int op_slot_left_12071 = gc_frame_newslot(call12075);
  params[0] = num12072;
  partcv[0] = 1;
  Object opresult12076 = callmethod(call12075, ">", 1, partcv, params);
// compiled op node returning opresult12076 (depth = 3)
  Object if12070 = done;
  if (istrue(opresult12076)) {
// Begin line 3636
  setline(3636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12077 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe12078 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call12079 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe12078);
// compiled call node returning call12079 (depth = 7)
// compiled member node returning call12079 (depth = 6)
  partcv[0] = 0;
  Object call12080 = callmethod(call12079, "new",
    1, partcv, params);
  gc_frame_end(callframe12077);
// compiled call node returning call12080 (depth = 5)
// compiled member node returning call12080 (depth = 4)
  *var_sugg = call12080;
  if (call12080 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3637
  setline(3637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe12081 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num12082 = alloc_Float64(1);
// compiled num node returning num12082 (depth = 4)
  gc_frame_newslot(num12082);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call12084 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe12083);
// compiled call node returning call12084 (depth = 5)
// compiled member node returning call12084 (depth = 4)
  gc_frame_newslot(call12084);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12085 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call12086 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe12085);
// compiled call node returning call12086 (depth = 5)
// compiled member node returning call12086 (depth = 4)
  gc_frame_newslot(call12086);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = num12082;
  params[1] = call12084;
  params[2] = call12086;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call12087 = callmethod(*var_sugg, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe12081);
// compiled call node returning call12087 (depth = 3)
// Begin line 3638
  setline(3638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe12088 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit12089 == NULL) {
    strlit12089 = alloc_String("The first line must not be indented.");
    gc_root(strlit12089);
  }
// compiled string node returning strlit12089 (depth = 4)
  gc_frame_newslot(strlit12089);
// Begin line 3639
  setline(3639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call12091 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe12090);
// compiled call node returning call12091 (depth = 5)
// compiled member node returning call12091 (depth = 4)
  gc_frame_newslot(call12091);
// starting to compile num node (depth = 4)
  Object num12092 = alloc_Float64(1);
// compiled num node returning num12092 (depth = 4)
  gc_frame_newslot(num12092);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12093 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call12094 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe12093);
// compiled call node returning call12094 (depth = 5)
// compiled member node returning call12094 (depth = 4)
  gc_frame_newslot(call12094);
// Begin line 3640
  setline(3640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3638
  setline(3638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit12089;
  params[1] = call12091;
  params[2] = num12092;
  params[3] = call12094;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call12095 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe12088);
// compiled call node returning call12095 (depth = 3)
    gc_frame_newslot(call12095);
    if12070 = call12095;
  } else {
  }
// compiled if node returning if12070 (depth = 2)
// Begin line 3642
  setline(3642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe12096 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call12097 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe12096);
// compiled call node returning call12097 (depth = 4)
// compiled member node returning call12097 (depth = 3)
  *var_oldlength = call12097;
  if (call12097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3643
  setline(3643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe12098 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block12099 = alloc_Block(NULL, NULL, "parser", 3643);
  gc_frame_newslot(block12099);
// method _apply
  block_savedest(block12099);
  Object closure12100 = createclosure(2, "_apply");
  setclosureframe(closure12100, stackframe);
  addtoclosure(closure12100, var_tokens);
  addtoclosure(closure12100, selfslot);
  struct UserObject *uo12100 = (struct UserObject*)block12099;
  uo12100->data[0] = (Object)closure12100;
  Method *meth_meth_parser__apply12100 = addmethod2pos(block12099, "_apply", &meth_parser__apply12100, 0);
  int argcv_meth_parser__apply12100[] = {0};
  meth_meth_parser__apply12100->type = alloc_MethodType(1, argcv_meth_parser__apply12100);
  meth_meth_parser__apply12100->definitionModule = modulename;
  meth_meth_parser__apply12100->definitionLine = 3642;
// compiled block node returning block12099 (depth = 3)
  gc_frame_newslot(block12099);
// starting to compile block node (depth = 3)
  Object block12108 = alloc_Block(NULL, NULL, "parser", 3643);
  gc_frame_newslot(block12108);
// method _apply
  block_savedest(block12108);
  Object closure12109 = createclosure(5, "_apply");
  setclosureframe(closure12109, stackframe);
  addtoclosure(closure12109, var_oldlength);
  addtoclosure(closure12109, var_tokens);
  addtoclosure(closure12109, var_errormessages);
  addtoclosure(closure12109, var_sym);
  addtoclosure(closure12109, selfslot);
  struct UserObject *uo12109 = (struct UserObject*)block12108;
  uo12109->data[0] = (Object)closure12109;
  Method *meth_meth_parser__apply12109 = addmethod2pos(block12108, "_apply", &meth_parser__apply12109, 0);
  int argcv_meth_parser__apply12109[] = {0};
  meth_meth_parser__apply12109->type = alloc_MethodType(1, argcv_meth_parser__apply12109);
  meth_meth_parser__apply12109->definitionModule = modulename;
  meth_meth_parser__apply12109->definitionLine = 3643;
// compiled block node returning block12108 (depth = 3)
  gc_frame_newslot(block12108);
// call case 5: prelude request
  params[0] = block12099;
  params[1] = block12108;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call12158 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12098);
// compiled call node returning call12158 (depth = 2)
// Begin line 3659
  setline(3659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12159 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12160 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12159);
// compiled call node returning call12160 (depth = 3)
// compiled member node returning call12160 (depth = 2)
// Begin line 3660
  setline(3660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12162 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12161);
// compiled call node returning call12162 (depth = 3)
// compiled member node returning call12162 (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call12164 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12163);
// compiled call node returning call12164 (depth = 3)
// compiled member node returning call12164 (depth = 2)
// Begin line 3662
  setline(3662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  return *var_values;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_blankLocation12166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blankLocation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹blankLocation›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankLocation (depth = 3)
  gc_frame_end(frame);
  return *var_blankLocation;
}
Object meth_parser_blankLocation_58__61_12167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method blankLocation:=");
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blankLocation:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹blankLocation:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_blankLocation = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastLine12170(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastLine (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹lastLine›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastLine (depth = 3)
  gc_frame_end(frame);
  return *var_lastLine;
}
Object meth_parser_lastLine_58__61_12171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lastLine:=");
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastLine:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹lastLine:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastLine = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastIndent12174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹lastIndent›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastIndent (depth = 3)
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_lastIndent_58__61_12175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lastIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹lastIndent:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_indentFreePass12178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indentFreePass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹indentFreePass›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_indentFreePass_58__61_12179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method indentFreePass:=");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indentFreePass:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹indentFreePass:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_minIndentLevel12182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for minIndentLevel (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹minIndentLevel›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_minIndentLevel_58__61_12183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method minIndentLevel:=");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for minIndentLevel:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹minIndentLevel:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementIndent12186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹statementIndent›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementIndent (depth = 3)
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_statementIndent_58__61_12187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method statementIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹statementIndent:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_tokens12190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹tokens›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_tokens_58__61_12191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method tokens:=");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹tokens:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_values12197(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹values›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_values_58__61_12198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method values:=");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹values:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comments12204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹comments›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  gc_frame_end(frame);
  return *var_comments;
}
Object meth_parser_comments_58__61_12205(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method comments:=");
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comments:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹comments:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comments = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_auto_count12208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for auto_count (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹auto_count›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_auto_count (depth = 3)
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_auto_count_58__61_12209(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method auto_count:=");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for auto_count:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹auto_count:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_noBlocks12212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noBlocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for noBlocks (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹noBlocks›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noBlocks (depth = 3)
  gc_frame_end(frame);
  return *var_noBlocks;
}
Object meth_parser_blocksOK12214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blocksOK");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blocksOK (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹blocksOK›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blocksOK (depth = 3)
  gc_frame_end(frame);
  return *var_blocksOK;
}
Object meth_parser_braceIsType12216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for braceIsType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹braceIsType›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_braceIsType (depth = 3)
  gc_frame_end(frame);
  return *var_braceIsType;
}
Object meth_parser_braceIsType_58__61_12217(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method braceIsType:=");
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for braceIsType:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹braceIsType:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_braceIsType = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultDefVisibility12220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 97, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultDefVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹defaultDefVisibility›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultDefVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultDefVisibility;
}
Object meth_parser_defaultDefVisibility_58__61_12221(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 98, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method defaultDefVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultDefVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹defaultDefVisibility:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultDefVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultVarVisibility12224(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 99, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultVarVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹defaultVarVisibility›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultVarVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultVarVisibility;
}
Object meth_parser_defaultVarVisibility_58__61_12225(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 100, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method defaultVarVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultVarVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹defaultVarVisibility:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultVarVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultMethodVisibility12228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 101, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultMethodVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹defaultMethodVisibility›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultMethodVisibility;
}
Object meth_parser_defaultMethodVisibility_58__61_12229(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 102, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method defaultMethodVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultMethodVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹defaultMethodVisibility:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultMethodVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_emptySequence12235(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 103, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for emptySequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹emptySequence›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_parser_sym12250(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 104, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sym (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹sym›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_sym_58__61_12251(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 105, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sym:=");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sym:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹sym:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastToken12253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 106, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹lastToken›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_lastToken_58__61_12254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 107, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lastToken:=");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹lastToken:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_previousCommentToken12256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 108, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for previousCommentToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹previousCommentToken›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_previousCommentToken (depth = 3)
  gc_frame_end(frame);
  return *var_previousCommentToken;
}
Object meth_parser_previousCommentToken_58__61_12257(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 109, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method previousCommentToken:=");
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for previousCommentToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹previousCommentToken:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_previousCommentToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementToken12259(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 110, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹statementToken›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementToken (depth = 3)
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_statementToken_58__61_12260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 111, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method statementToken:=");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹statementToken:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comment12263(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 112, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹comment›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comment (depth = 3)
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_comment_58__61_12264(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 113, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method comment:=");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comment:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹comment:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_firstCallOfNext12267(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 114, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for firstCallOfNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierBinding‹firstCallOfNext›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_firstCallOfNext (depth = 3)
  gc_frame_end(frame);
  return *var_firstCallOfNext;
}
Object meth_parser_firstCallOfNext_58__61_12268(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 115, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method firstCallOfNext:=");
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for firstCallOfNext:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for identifier‹firstCallOfNext:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_firstCallOfNext = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(117, 117);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(117, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
  Object *var_io = alloc_var();
  Object *var_ast = alloc_var();
  Object *var_util = alloc_var();
  Object *var_errormessages = alloc_var();
  Object *var_blankLocation = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "blankLocation");
  Object *var_lastLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lastLine");
  Object *var_lastIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "statementIndent");
  Object *var_tokens = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "tokens");
  Object *var_values = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "values");
  Object *var_comments = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "comments");
  Object *var_auto_count = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "auto_count");
  Object *var_noBlocks = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "noBlocks");
  Object *var_blocksOK = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "blocksOK");
  Object *var_braceIsType = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "braceIsType");
  Object *var_defaultDefVisibility = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "defaultDefVisibility");
  Object *var_defaultVarVisibility = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "defaultVarVisibility");
  Object *var_defaultMethodVisibility = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "defaultMethodVisibility");
  Object *var_emptySequence = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "emptySequence");
  Object *var_sym = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "sym");
  Object *var_lastToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "lastToken");
  Object *var_previousCommentToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "previousCommentToken");
  Object *var_statementToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "statementToken");
  Object *var_comment = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "comment");
  Object *var_firstCallOfNext = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "firstCallOfNext");
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method noteBlank
  block_savedest(self);
  Object closure0 = createclosure(2, "noteBlank");
  setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_sym);
  addtoclosure(closure0, var_blankLocation);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_parser_noteBlank0 = addmethod2pos(self, "noteBlank", &meth_parser_noteBlank0, 1);
  int argcv_meth_parser_noteBlank0[] = {0};
  meth_meth_parser_noteBlank0->type = alloc_MethodType(1, argcv_meth_parser_noteBlank0);
  meth_meth_parser_noteBlank0->definitionModule = modulename;
  meth_meth_parser_noteBlank0->definitionLine = 39;
// compiled method node returning  (depth = 1)
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method next
  block_savedest(self);
  Object closure8 = createclosure(7, "next");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_tokens);
  addtoclosure(closure8, var_sym);
  addtoclosure(closure8, var_lastToken);
  addtoclosure(closure8, var_lastLine);
  addtoclosure(closure8, var_lastIndent);
  addtoclosure(closure8, var_util);
  addtoclosure(closure8, var_errormessages);
  struct UserObject *uo8 = (struct UserObject*)self;
  uo8->data[2] = (Object)closure8;
  Method *meth_meth_parser_next8 = addmethod2pos(self, "next", &meth_parser_next8, 2);
  int argcv_meth_parser_next8[] = {0};
  meth_meth_parser_next8->type = alloc_MethodType(1, argcv_meth_parser_next8);
  meth_meth_parser_next8->definitionModule = modulename;
  meth_meth_parser_next8->definitionLine = 45;
// compiled method node returning  (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findNextToken
  block_savedest(self);
  Object closure59 = createclosure(2, "findNextToken");
  setclosureframe(closure59, stackframe);
  addtoclosure(closure59, var_sym);
  addtoclosure(closure59, var_lastToken);
  struct UserObject *uo59 = (struct UserObject*)self;
  uo59->data[3] = (Object)closure59;
  Method *meth_meth_parser_findNextToken59 = addmethod2pos(self, "findNextToken", &meth_parser_findNextToken59, 3);
  int argcv_meth_parser_findNextToken59[] = {1};
  meth_meth_parser_findNextToken59->type = alloc_MethodType(1, argcv_meth_parser_findNextToken59);
  meth_meth_parser_findNextToken59->definitionModule = modulename;
  meth_meth_parser_findNextToken59->definitionLine = 65;
// compiled method node returning  (depth = 1)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findNextTokenIndentedAt
  block_savedest(self);
  Object closure104 = createclosure(1, "findNextTokenIndentedAt");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_sym);
  struct UserObject *uo104 = (struct UserObject*)self;
  uo104->data[4] = (Object)closure104;
  Method *meth_meth_parser_findNextTokenIndentedAt104 = addmethod2pos(self, "findNextTokenIndentedAt", &meth_parser_findNextTokenIndentedAt104, 4);
  int argcv_meth_parser_findNextTokenIndentedAt104[] = {1};
  meth_meth_parser_findNextTokenIndentedAt104->type = alloc_MethodType(1, argcv_meth_parser_findNextTokenIndentedAt104);
  meth_meth_parser_findNextTokenIndentedAt104->definitionModule = modulename;
  meth_meth_parser_findNextTokenIndentedAt104->definitionLine = 83;
// compiled method node returning  (depth = 1)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findNextValidToken
  block_savedest(self);
  Object closure185 = createclosure(1, "findNextValidToken");
  setclosureframe(closure185, stackframe);
  addtoclosure(closure185, var_sym);
  struct UserObject *uo185 = (struct UserObject*)self;
  uo185->data[5] = (Object)closure185;
  Method *meth_meth_parser_findNextValidToken185 = addmethod2pos(self, "findNextValidToken", &meth_parser_findNextValidToken185, 5);
  int argcv_meth_parser_findNextValidToken185[] = {0};
  meth_meth_parser_findNextValidToken185->type = alloc_MethodType(1, argcv_meth_parser_findNextValidToken185);
  meth_meth_parser_findNextValidToken185->definitionModule = modulename;
  meth_meth_parser_findNextValidToken185->definitionLine = 98;
// compiled method node returning  (depth = 1)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findClosingBrace
  block_savedest(self);
  Object closure227 = createclosure(1, "findClosingBrace");
  setclosureframe(closure227, stackframe);
  addtoclosure(closure227, var_sym);
  struct UserObject *uo227 = (struct UserObject*)self;
  uo227->data[6] = (Object)closure227;
  Method *meth_meth_parser_findClosingBrace227 = addmethod2pos(self, "findClosingBrace", &meth_parser_findClosingBrace227, 6);
  int argcv_meth_parser_findClosingBrace227[] = {2};
  meth_meth_parser_findClosingBrace227->type = alloc_MethodType(1, argcv_meth_parser_findClosingBrace227);
  meth_meth_parser_findClosingBrace227->definitionModule = modulename;
  meth_meth_parser_findClosingBrace227->definitionLine = 123;
// compiled method node returning  (depth = 1)
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method accept
  block_savedest(self);
  Object closure379 = createclosure(1, "accept");
  setclosureframe(closure379, stackframe);
  addtoclosure(closure379, var_sym);
  struct UserObject *uo379 = (struct UserObject*)self;
  uo379->data[7] = (Object)closure379;
  Method *meth_meth_parser_accept379 = addmethod2pos(self, "accept", &meth_parser_accept379, 7);
  int argcv_meth_parser_accept379[] = {1};
  meth_meth_parser_accept379->type = alloc_MethodType(1, argcv_meth_parser_accept379);
  meth_meth_parser_accept379->definitionModule = modulename;
  meth_meth_parser_accept379->definitionLine = 159;
// compiled method node returning  (depth = 1)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method acceptSameLine
  block_savedest(self);
  Object closure385 = createclosure(3, "acceptSameLine");
  setclosureframe(closure385, stackframe);
  addtoclosure(closure385, var_lastIndent);
  addtoclosure(closure385, var_sym);
  addtoclosure(closure385, var_lastLine);
  struct UserObject *uo385 = (struct UserObject*)self;
  uo385->data[8] = (Object)closure385;
  Method *meth_meth_parser_acceptSameLine385 = addmethod2pos(self, "acceptSameLine", &meth_parser_acceptSameLine385, 8);
  int argcv_meth_parser_acceptSameLine385[] = {1};
  meth_meth_parser_acceptSameLine385->type = alloc_MethodType(1, argcv_meth_parser_acceptSameLine385);
  meth_meth_parser_acceptSameLine385->definitionModule = modulename;
  meth_meth_parser_acceptSameLine385->definitionLine = 166;
// compiled method node returning  (depth = 1)
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method accept()onLineOf
  block_savedest(self);
  Object closure407 = createclosure(1, "accept()onLineOf");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_sym);
  struct UserObject *uo407 = (struct UserObject*)self;
  uo407->data[9] = (Object)closure407;
  Method *meth_meth_parser_accept_40__41_onLineOf407 = addmethod2pos(self, "accept()onLineOf", &meth_parser_accept_40__41_onLineOf407, 9);
  int argcv_meth_parser_accept_40__41_onLineOf407[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOf407->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOf407);
  meth_meth_parser_accept_40__41_onLineOf407->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOf407->definitionLine = 173;
// compiled method node returning  (depth = 1)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method accept()onLineOfLastOr
  block_savedest(self);
  Object closure433 = createclosure(2, "accept()onLineOfLastOr");
  setclosureframe(closure433, stackframe);
  addtoclosure(closure433, var_sym);
  addtoclosure(closure433, var_lastToken);
  struct UserObject *uo433 = (struct UserObject*)self;
  uo433->data[10] = (Object)closure433;
  Method *meth_meth_parser_accept_40__41_onLineOfLastOr433 = addmethod2pos(self, "accept()onLineOfLastOr", &meth_parser_accept_40__41_onLineOfLastOr433, 10);
  int argcv_meth_parser_accept_40__41_onLineOfLastOr433[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOfLastOr433->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOfLastOr433);
  meth_meth_parser_accept_40__41_onLineOfLastOr433->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOfLastOr433->definitionLine = 179;
// compiled method node returning  (depth = 1)
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method tokenOnSameLine
  block_savedest(self);
  Object closure469 = createclosure(3, "tokenOnSameLine");
  setclosureframe(closure469, stackframe);
  addtoclosure(closure469, var_lastIndent);
  addtoclosure(closure469, var_sym);
  addtoclosure(closure469, var_lastLine);
  struct UserObject *uo469 = (struct UserObject*)self;
  uo469->data[11] = (Object)closure469;
  Method *meth_meth_parser_tokenOnSameLine469 = addmethod2pos(self, "tokenOnSameLine", &meth_parser_tokenOnSameLine469, 11);
  int argcv_meth_parser_tokenOnSameLine469[] = {0};
  meth_meth_parser_tokenOnSameLine469->type = alloc_MethodType(1, argcv_meth_parser_tokenOnSameLine469);
  meth_meth_parser_tokenOnSameLine469->definitionModule = modulename;
  meth_meth_parser_tokenOnSameLine469->definitionLine = 184;
// compiled method node returning  (depth = 1)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method didConsume
  block_savedest(self);
  Object closure483 = createclosure(1, "didConsume");
  setclosureframe(closure483, stackframe);
  addtoclosure(closure483, var_tokens);
  struct UserObject *uo483 = (struct UserObject*)self;
  uo483->data[12] = (Object)closure483;
  Method *meth_meth_parser_didConsume483 = addmethod2pos(self, "didConsume", &meth_parser_didConsume483, 12);
  int argcv_meth_parser_didConsume483[] = {1};
  meth_meth_parser_didConsume483->type = alloc_MethodType(1, argcv_meth_parser_didConsume483);
  meth_meth_parser_didConsume483->definitionModule = modulename;
  meth_meth_parser_didConsume483->definitionLine = 188;
// compiled method node returning  (depth = 1)
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method ifConsume()then
  block_savedest(self);
  Object closure493 = createclosure(1, "ifConsume()then");
  setclosureframe(closure493, stackframe);
  addtoclosure(closure493, var_tokens);
  struct UserObject *uo493 = (struct UserObject*)self;
  uo493->data[13] = (Object)closure493;
  Method *meth_meth_parser_ifConsume_40__41_then493 = addmethod2pos(self, "ifConsume()then", &meth_parser_ifConsume_40__41_then493, 13);
  int argcv_meth_parser_ifConsume_40__41_then493[] = {1, 1};
  meth_meth_parser_ifConsume_40__41_then493->type = alloc_MethodType(2, argcv_meth_parser_ifConsume_40__41_then493);
  meth_meth_parser_ifConsume_40__41_then493->definitionModule = modulename;
  meth_meth_parser_ifConsume_40__41_then493->definitionLine = 194;
// compiled method node returning  (depth = 1)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushnum
  block_savedest(self);
  Object closure506 = createclosure(3, "pushnum");
  setclosureframe(closure506, stackframe);
  addtoclosure(closure506, var_sym);
  addtoclosure(closure506, var_ast);
  addtoclosure(closure506, var_values);
  struct UserObject *uo506 = (struct UserObject*)self;
  uo506->data[14] = (Object)closure506;
  Method *meth_meth_parser_pushnum506 = addmethod2pos(self, "pushnum", &meth_parser_pushnum506, 14);
  int argcv_meth_parser_pushnum506[] = {0};
  meth_meth_parser_pushnum506->type = alloc_MethodType(1, argcv_meth_parser_pushnum506);
  meth_meth_parser_pushnum506->definitionModule = modulename;
  meth_meth_parser_pushnum506->definitionLine = 203;
// compiled method node returning  (depth = 1)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushoctets
  block_savedest(self);
  Object closure517 = createclosure(3, "pushoctets");
  setclosureframe(closure517, stackframe);
  addtoclosure(closure517, var_sym);
  addtoclosure(closure517, var_ast);
  addtoclosure(closure517, var_values);
  struct UserObject *uo517 = (struct UserObject*)self;
  uo517->data[15] = (Object)closure517;
  Method *meth_meth_parser_pushoctets517 = addmethod2pos(self, "pushoctets", &meth_parser_pushoctets517, 15);
  int argcv_meth_parser_pushoctets517[] = {0};
  meth_meth_parser_pushoctets517->type = alloc_MethodType(1, argcv_meth_parser_pushoctets517);
  meth_meth_parser_pushoctets517->definitionModule = modulename;
  meth_meth_parser_pushoctets517->definitionLine = 210;
// compiled method node returning  (depth = 1)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushstring
  block_savedest(self);
  Object closure528 = createclosure(3, "pushstring");
  setclosureframe(closure528, stackframe);
  addtoclosure(closure528, var_sym);
  addtoclosure(closure528, var_ast);
  addtoclosure(closure528, var_values);
  struct UserObject *uo528 = (struct UserObject*)self;
  uo528->data[16] = (Object)closure528;
  Method *meth_meth_parser_pushstring528 = addmethod2pos(self, "pushstring", &meth_parser_pushstring528, 16);
  int argcv_meth_parser_pushstring528[] = {0};
  meth_meth_parser_pushstring528->type = alloc_MethodType(1, argcv_meth_parser_pushstring528);
  meth_meth_parser_pushstring528->definitionModule = modulename;
  meth_meth_parser_pushstring528->definitionLine = 217;
// compiled method node returning  (depth = 1)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushidentifier
  block_savedest(self);
  Object closure539 = createclosure(5, "pushidentifier");
  setclosureframe(closure539, stackframe);
  addtoclosure(closure539, var_sym);
  addtoclosure(closure539, var_util);
  addtoclosure(closure539, var_ast);
  addtoclosure(closure539, var_auto_count);
  addtoclosure(closure539, var_values);
  struct UserObject *uo539 = (struct UserObject*)self;
  uo539->data[17] = (Object)closure539;
  Method *meth_meth_parser_pushidentifier539 = addmethod2pos(self, "pushidentifier", &meth_parser_pushidentifier539, 17);
  int argcv_meth_parser_pushidentifier539[] = {0};
  meth_meth_parser_pushidentifier539->type = alloc_MethodType(1, argcv_meth_parser_pushidentifier539);
  meth_meth_parser_pushidentifier539->definitionModule = modulename;
  meth_meth_parser_pushidentifier539->definitionLine = 225;
// compiled method node returning  (depth = 1)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method adjustVisibilityOf()withSpecialDefault()overriding
  block_savedest(self);
  Object closure578 = createclosure(2, "adjustVisibilityOf()withSpecialDefault()overriding");
  setclosureframe(closure578, stackframe);
  addtoclosure(closure578, var_done);
  addtoclosure(closure578, var_ast);
  struct UserObject *uo578 = (struct UserObject*)self;
  uo578->data[18] = (Object)closure578;
  Method *meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578 = addmethod2pos(self, "adjustVisibilityOf()withSpecialDefault()overriding", &meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578, 18);
  int argcv_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578[] = {1, 1, 1};
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578->type = alloc_MethodType(3, argcv_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578);
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578->definitionModule = modulename;
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding578->definitionLine = 237;
// compiled method node returning  (depth = 1)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkAnnotation
  block_savedest(self);
  Object closure634 = createclosure(2, "checkAnnotation");
  setclosureframe(closure634, stackframe);
  addtoclosure(closure634, var_sym);
  addtoclosure(closure634, var_errormessages);
  struct UserObject *uo634 = (struct UserObject*)self;
  uo634->data[19] = (Object)closure634;
  Method *meth_meth_parser_checkAnnotation634 = addmethod2pos(self, "checkAnnotation", &meth_parser_checkAnnotation634, 19);
  int argcv_meth_parser_checkAnnotation634[] = {1};
  meth_meth_parser_checkAnnotation634->type = alloc_MethodType(1, argcv_meth_parser_checkAnnotation634);
  meth_meth_parser_checkAnnotation634->definitionModule = modulename;
  meth_meth_parser_checkAnnotation634->definitionLine = 253;
// compiled method node returning  (depth = 1)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doannotation
  block_savedest(self);
  Object closure723 = createclosure(5, "doannotation");
  setclosureframe(closure723, stackframe);
  addtoclosure(closure723, var_sym);
  addtoclosure(closure723, var_noBlocks);
  addtoclosure(closure723, var_errormessages);
  addtoclosure(closure723, var_lastToken);
  addtoclosure(closure723, var_values);
  struct UserObject *uo723 = (struct UserObject*)self;
  uo723->data[20] = (Object)closure723;
  Method *meth_meth_parser_doannotation723 = addmethod2pos(self, "doannotation", &meth_parser_doannotation723, 20);
  int argcv_meth_parser_doannotation723[] = {0};
  meth_meth_parser_doannotation723->type = alloc_MethodType(1, argcv_meth_parser_doannotation723);
  meth_meth_parser_doannotation723->definitionModule = modulename;
  meth_meth_parser_doannotation723->definitionLine = 271;
// compiled method node returning  (depth = 1)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method blank
  block_savedest(self);
  Object closure905 = createclosure(8, "blank");
  setclosureframe(closure905, stackframe);
  addtoclosure(closure905, var_blankLocation);
  addtoclosure(closure905, var_lastToken);
  addtoclosure(closure905, var_sym);
  addtoclosure(closure905, var_done);
  addtoclosure(closure905, var_previousCommentToken);
  addtoclosure(closure905, var_values);
  addtoclosure(closure905, var_util);
  addtoclosure(closure905, var_ast);
  struct UserObject *uo905 = (struct UserObject*)self;
  uo905->data[21] = (Object)closure905;
  Method *meth_meth_parser_blank905 = addmethod2pos(self, "blank", &meth_parser_blank905, 21);
  int argcv_meth_parser_blank905[] = {0};
  meth_meth_parser_blank905->type = alloc_MethodType(1, argcv_meth_parser_blank905);
  meth_meth_parser_blank905->definitionModule = modulename;
  meth_meth_parser_blank905->definitionLine = 317;
// compiled method node returning  (depth = 1)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dotypeterm
  block_savedest(self);
  Object closure991 = createclosure(2, "dotypeterm");
  setclosureframe(closure991, stackframe);
  addtoclosure(closure991, var_noBlocks);
  addtoclosure(closure991, var_sym);
  struct UserObject *uo991 = (struct UserObject*)self;
  uo991->data[22] = (Object)closure991;
  Method *meth_meth_parser_dotypeterm991 = addmethod2pos(self, "dotypeterm", &meth_parser_dotypeterm991, 22);
  int argcv_meth_parser_dotypeterm991[] = {0};
  meth_meth_parser_dotypeterm991->type = alloc_MethodType(1, argcv_meth_parser_dotypeterm991);
  meth_meth_parser_dotypeterm991->definitionModule = modulename;
  meth_meth_parser_dotypeterm991->definitionLine = 335;
// compiled method node returning  (depth = 1)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeexpression
  block_savedest(self);
  Object closure1019 = createclosure(6, "typeexpression");
  setclosureframe(closure1019, stackframe);
  addtoclosure(closure1019, var_values);
  addtoclosure(closure1019, var_statementToken);
  addtoclosure(closure1019, var_sym);
  addtoclosure(closure1019, var_errormessages);
  addtoclosure(closure1019, var_lastToken);
  addtoclosure(closure1019, var_noBlocks);
  struct UserObject *uo1019 = (struct UserObject*)self;
  uo1019->data[23] = (Object)closure1019;
  Method *meth_meth_parser_typeexpression1019 = addmethod2pos(self, "typeexpression", &meth_parser_typeexpression1019, 23);
  int argcv_meth_parser_typeexpression1019[] = {0};
  meth_meth_parser_typeexpression1019->type = alloc_MethodType(1, argcv_meth_parser_typeexpression1019);
  meth_meth_parser_typeexpression1019->definitionModule = modulename;
  meth_meth_parser_typeexpression1019->definitionLine = 347;
// compiled method node returning  (depth = 1)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method newIf
  block_savedest(self);
  Object closure1110 = createclosure(2, "newIf");
  setclosureframe(closure1110, stackframe);
  addtoclosure(closure1110, var_emptySequence);
  addtoclosure(closure1110, var_ast);
  struct UserObject *uo1110 = (struct UserObject*)self;
  uo1110->data[24] = (Object)closure1110;
  Method *meth_meth_parser_newIf1110 = addmethod2pos(self, "newIf", &meth_parser_newIf1110, 24);
  int argcv_meth_parser_newIf1110[] = {3};
  meth_meth_parser_newIf1110->type = alloc_MethodType(1, argcv_meth_parser_newIf1110);
  meth_meth_parser_newIf1110->definitionModule = modulename;
  meth_meth_parser_newIf1110->definitionLine = 384;
// compiled method node returning  (depth = 1)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method block
  block_savedest(self);
  Object closure1123 = createclosure(12, "block");
  setclosureframe(closure1123, stackframe);
  addtoclosure(closure1123, var_sym);
  addtoclosure(closure1123, var_statementIndent);
  addtoclosure(closure1123, var_statementToken);
  addtoclosure(closure1123, var_blocksOK);
  addtoclosure(closure1123, var_values);
  addtoclosure(closure1123, var_braceIsType);
  addtoclosure(closure1123, var_errormessages);
  addtoclosure(closure1123, var_lastToken);
  addtoclosure(closure1123, var_indentFreePass);
  addtoclosure(closure1123, var_util);
  addtoclosure(closure1123, var_ast);
  addtoclosure(closure1123, var_minIndentLevel);
  struct UserObject *uo1123 = (struct UserObject*)self;
  uo1123->data[25] = (Object)closure1123;
  Method *meth_meth_parser_block1123 = addmethod2pos(self, "block", &meth_parser_block1123, 25);
  int argcv_meth_parser_block1123[] = {0};
  meth_meth_parser_block1123->type = alloc_MethodType(1, argcv_meth_parser_block1123);
  meth_meth_parser_block1123->definitionModule = modulename;
  meth_meth_parser_block1123->definitionLine = 391;
// compiled method node returning  (depth = 1)
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doif
  block_savedest(self);
  Object closure1658 = createclosure(9, "doif");
  setclosureframe(closure1658, stackframe);
  addtoclosure(closure1658, var_sym);
  addtoclosure(closure1658, var_errormessages);
  addtoclosure(closure1658, var_blocksOK);
  addtoclosure(closure1658, var_lastToken);
  addtoclosure(closure1658, var_values);
  addtoclosure(closure1658, var_minIndentLevel);
  addtoclosure(closure1658, var_statementIndent);
  addtoclosure(closure1658, var_statementToken);
  addtoclosure(closure1658, var_util);
  struct UserObject *uo1658 = (struct UserObject*)self;
  uo1658->data[26] = (Object)closure1658;
  Method *meth_meth_parser_doif1658 = addmethod2pos(self, "doif", &meth_parser_doif1658, 26);
  int argcv_meth_parser_doif1658[] = {0};
  meth_meth_parser_doif1658->type = alloc_MethodType(1, argcv_meth_parser_doif1658);
  meth_meth_parser_doif1658->definitionModule = modulename;
  meth_meth_parser_doif1658->definitionLine = 562;
// compiled method node returning  (depth = 1)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method identifier
  block_savedest(self);
  Object closure3034 = createclosure(1, "identifier");
  setclosureframe(closure3034, stackframe);
  addtoclosure(closure3034, var_sym);
  struct UserObject *uo3034 = (struct UserObject*)self;
  uo3034->data[27] = (Object)closure3034;
  Method *meth_meth_parser_identifier3034 = addmethod2pos(self, "identifier", &meth_parser_identifier3034, 27);
  int argcv_meth_parser_identifier3034[] = {0};
  meth_meth_parser_identifier3034->type = alloc_MethodType(1, argcv_meth_parser_identifier3034);
  meth_meth_parser_identifier3034->definitionModule = modulename;
  meth_meth_parser_identifier3034->definitionLine = 944;
// compiled method node returning  (depth = 1)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method prefixop
  block_savedest(self);
  Object closure3050 = createclosure(6, "prefixop");
  setclosureframe(closure3050, stackframe);
  addtoclosure(closure3050, var_sym);
  addtoclosure(closure3050, var_blocksOK);
  addtoclosure(closure3050, var_errormessages);
  addtoclosure(closure3050, var_lastToken);
  addtoclosure(closure3050, var_values);
  addtoclosure(closure3050, var_ast);
  struct UserObject *uo3050 = (struct UserObject*)self;
  uo3050->data[28] = (Object)closure3050;
  Method *meth_meth_parser_prefixop3050 = addmethod2pos(self, "prefixop", &meth_parser_prefixop3050, 28);
  int argcv_meth_parser_prefixop3050[] = {0};
  meth_meth_parser_prefixop3050->type = alloc_MethodType(1, argcv_meth_parser_prefixop3050);
  meth_meth_parser_prefixop3050->definitionModule = modulename;
  meth_meth_parser_prefixop3050->definitionLine = 954;
// compiled method node returning  (depth = 1)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method generic
  block_savedest(self);
  Object closure3240 = createclosure(5, "generic");
  setclosureframe(closure3240, stackframe);
  addtoclosure(closure3240, var_values);
  addtoclosure(closure3240, var_sym);
  addtoclosure(closure3240, var_errormessages);
  addtoclosure(closure3240, var_lastToken);
  addtoclosure(closure3240, var_ast);
  struct UserObject *uo3240 = (struct UserObject*)self;
  uo3240->data[29] = (Object)closure3240;
  Method *meth_meth_parser_generic3240 = addmethod2pos(self, "generic", &meth_parser_generic3240, 29);
  int argcv_meth_parser_generic3240[] = {0};
  meth_meth_parser_generic3240->type = alloc_MethodType(1, argcv_meth_parser_generic3240);
  meth_meth_parser_generic3240->definitionModule = modulename;
  meth_meth_parser_generic3240->definitionLine = 1011;
// compiled method node returning  (depth = 1)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method trycatch
  block_savedest(self);
  Object closure3429 = createclosure(9, "trycatch");
  setclosureframe(closure3429, stackframe);
  addtoclosure(closure3429, var_sym);
  addtoclosure(closure3429, var_minIndentLevel);
  addtoclosure(closure3429, var_errormessages);
  addtoclosure(closure3429, var_lastToken);
  addtoclosure(closure3429, var_blocksOK);
  addtoclosure(closure3429, var_values);
  addtoclosure(closure3429, var_tokens);
  addtoclosure(closure3429, var_util);
  addtoclosure(closure3429, var_ast);
  struct UserObject *uo3429 = (struct UserObject*)self;
  uo3429->data[30] = (Object)closure3429;
  Method *meth_meth_parser_trycatch3429 = addmethod2pos(self, "trycatch", &meth_parser_trycatch3429, 30);
  int argcv_meth_parser_trycatch3429[] = {0};
  meth_meth_parser_trycatch3429->type = alloc_MethodType(1, argcv_meth_parser_trycatch3429);
  meth_meth_parser_trycatch3429->definitionModule = modulename;
  meth_meth_parser_trycatch3429->definitionLine = 1071;
// compiled method node returning  (depth = 1)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method catchcase
  block_savedest(self);
  Object closure4033 = createclosure(9, "catchcase");
  setclosureframe(closure4033, stackframe);
  addtoclosure(closure4033, var_sym);
  addtoclosure(closure4033, var_minIndentLevel);
  addtoclosure(closure4033, var_util);
  addtoclosure(closure4033, var_errormessages);
  addtoclosure(closure4033, var_lastToken);
  addtoclosure(closure4033, var_blocksOK);
  addtoclosure(closure4033, var_values);
  addtoclosure(closure4033, var_tokens);
  addtoclosure(closure4033, var_ast);
  struct UserObject *uo4033 = (struct UserObject*)self;
  uo4033->data[31] = (Object)closure4033;
  Method *meth_meth_parser_catchcase4033 = addmethod2pos(self, "catchcase", &meth_parser_catchcase4033, 31);
  int argcv_meth_parser_catchcase4033[] = {0};
  meth_meth_parser_catchcase4033->type = alloc_MethodType(1, argcv_meth_parser_catchcase4033);
  meth_meth_parser_catchcase4033->definitionModule = modulename;
  meth_meth_parser_catchcase4033->definitionLine = 1239;
// compiled method node returning  (depth = 1)
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method matchcase
  block_savedest(self);
  Object closure4607 = createclosure(9, "matchcase");
  setclosureframe(closure4607, stackframe);
  addtoclosure(closure4607, var_sym);
  addtoclosure(closure4607, var_minIndentLevel);
  addtoclosure(closure4607, var_errormessages);
  addtoclosure(closure4607, var_blocksOK);
  addtoclosure(closure4607, var_lastToken);
  addtoclosure(closure4607, var_values);
  addtoclosure(closure4607, var_tokens);
  addtoclosure(closure4607, var_util);
  addtoclosure(closure4607, var_ast);
  struct UserObject *uo4607 = (struct UserObject*)self;
  uo4607->data[32] = (Object)closure4607;
  Method *meth_meth_parser_matchcase4607 = addmethod2pos(self, "matchcase", &meth_parser_matchcase4607, 32);
  int argcv_meth_parser_matchcase4607[] = {0};
  meth_meth_parser_matchcase4607->type = alloc_MethodType(1, argcv_meth_parser_matchcase4607);
  meth_meth_parser_matchcase4607->definitionModule = modulename;
  meth_meth_parser_matchcase4607->definitionLine = 1401;
// compiled method node returning  (depth = 1)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method term
  block_savedest(self);
  Object closure4983 = createclosure(2, "term");
  setclosureframe(closure4983, stackframe);
  addtoclosure(closure4983, var_sym);
  addtoclosure(closure4983, var_util);
  struct UserObject *uo4983 = (struct UserObject*)self;
  uo4983->data[33] = (Object)closure4983;
  Method *meth_meth_parser_term4983 = addmethod2pos(self, "term", &meth_parser_term4983, 33);
  int argcv_meth_parser_term4983[] = {0};
  meth_meth_parser_term4983->type = alloc_MethodType(1, argcv_meth_parser_term4983);
  meth_meth_parser_term4983->definitionModule = modulename;
  meth_meth_parser_term4983->definitionLine = 1555;
// compiled method node returning  (depth = 1)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method expression
  block_savedest(self);
  Object closure5109 = createclosure(6, "expression");
  setclosureframe(closure5109, stackframe);
  addtoclosure(closure5109, var_values);
  addtoclosure(closure5109, var_sym);
  addtoclosure(closure5109, var_util);
  addtoclosure(closure5109, var_statementToken);
  addtoclosure(closure5109, var_errormessages);
  addtoclosure(closure5109, var_lastToken);
  struct UserObject *uo5109 = (struct UserObject*)self;
  uo5109->data[34] = (Object)closure5109;
  Method *meth_meth_parser_expression5109 = addmethod2pos(self, "expression", &meth_parser_expression5109, 34);
  int argcv_meth_parser_expression5109[] = {1};
  meth_meth_parser_expression5109->type = alloc_MethodType(1, argcv_meth_parser_expression5109);
  meth_meth_parser_expression5109->definitionModule = modulename;
  meth_meth_parser_expression5109->definitionLine = 1589;
// compiled method node returning  (depth = 1)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method postfixsquare
  block_savedest(self);
  Object closure5216 = createclosure(6, "postfixsquare");
  setclosureframe(closure5216, stackframe);
  addtoclosure(closure5216, var_values);
  addtoclosure(closure5216, var_blocksOK);
  addtoclosure(closure5216, var_errormessages);
  addtoclosure(closure5216, var_sym);
  addtoclosure(closure5216, var_lastToken);
  addtoclosure(closure5216, var_ast);
  struct UserObject *uo5216 = (struct UserObject*)self;
  uo5216->data[35] = (Object)closure5216;
  Method *meth_meth_parser_postfixsquare5216 = addmethod2pos(self, "postfixsquare", &meth_parser_postfixsquare5216, 35);
  int argcv_meth_parser_postfixsquare5216[] = {0};
  meth_meth_parser_postfixsquare5216->type = alloc_MethodType(1, argcv_meth_parser_postfixsquare5216);
  meth_meth_parser_postfixsquare5216->definitionModule = modulename;
  meth_meth_parser_postfixsquare5216->definitionLine = 1630;
// compiled method node returning  (depth = 1)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method oprec
  struct UserObject *uo5329 = (struct UserObject*)self;
  uo5329->data[36] = emptyclosure;
  Method *meth_meth_parser_oprec5329 = addmethod2pos(self, "oprec", &meth_parser_oprec5329, 36);
  int argcv_meth_parser_oprec5329[] = {1};
  meth_meth_parser_oprec5329->type = alloc_MethodType(1, argcv_meth_parser_oprec5329);
  meth_meth_parser_oprec5329->definitionModule = modulename;
  meth_meth_parser_oprec5329->definitionLine = 1671;
// compiled method node returning  (depth = 1)
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method toprec
  struct UserObject *uo5343 = (struct UserObject*)self;
  uo5343->data[37] = emptyclosure;
  Method *meth_meth_parser_toprec5343 = addmethod2pos(self, "toprec", &meth_parser_toprec5343, 37);
  int argcv_meth_parser_toprec5343[] = {1};
  meth_meth_parser_toprec5343->type = alloc_MethodType(1, argcv_meth_parser_toprec5343);
  meth_meth_parser_toprec5343->definitionModule = modulename;
  meth_meth_parser_toprec5343->definitionLine = 1681;
// compiled method node returning  (depth = 1)
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeexpressionrest
  block_savedest(self);
  Object closure5356 = createclosure(1, "typeexpressionrest");
  setclosureframe(closure5356, stackframe);
  addtoclosure(closure5356, var_noBlocks);
  struct UserObject *uo5356 = (struct UserObject*)self;
  uo5356->data[38] = (Object)closure5356;
  Method *meth_meth_parser_typeexpressionrest5356 = addmethod2pos(self, "typeexpressionrest", &meth_parser_typeexpressionrest5356, 38);
  int argcv_meth_parser_typeexpressionrest5356[] = {0};
  meth_meth_parser_typeexpressionrest5356->type = alloc_MethodType(1, argcv_meth_parser_typeexpressionrest5356);
  meth_meth_parser_typeexpressionrest5356->definitionModule = modulename;
  meth_meth_parser_typeexpressionrest5356->definitionLine = 1690;
// compiled method node returning  (depth = 1)
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method valueexpressionrest
  block_savedest(self);
  Object closure5369 = createclosure(1, "valueexpressionrest");
  setclosureframe(closure5369, stackframe);
  addtoclosure(closure5369, var_blocksOK);
  struct UserObject *uo5369 = (struct UserObject*)self;
  uo5369->data[39] = (Object)closure5369;
  Method *meth_meth_parser_valueexpressionrest5369 = addmethod2pos(self, "valueexpressionrest", &meth_parser_valueexpressionrest5369, 39);
  int argcv_meth_parser_valueexpressionrest5369[] = {0};
  meth_meth_parser_valueexpressionrest5369->type = alloc_MethodType(1, argcv_meth_parser_valueexpressionrest5369);
  meth_meth_parser_valueexpressionrest5369->definitionModule = modulename;
  meth_meth_parser_valueexpressionrest5369->definitionLine = 1696;
// compiled method node returning  (depth = 1)
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method expressionrest()recursingWith()blocks
  block_savedest(self);
  Object closure5382 = createclosure(7, "expressionrest()recursingWith()blocks");
  setclosureframe(closure5382, stackframe);
  addtoclosure(closure5382, var_values);
  addtoclosure(closure5382, var_sym);
  addtoclosure(closure5382, var_statementToken);
  addtoclosure(closure5382, var_errormessages);
  addtoclosure(closure5382, var_lastToken);
  addtoclosure(closure5382, var_util);
  addtoclosure(closure5382, var_ast);
  struct UserObject *uo5382 = (struct UserObject*)self;
  uo5382->data[40] = (Object)closure5382;
  Method *meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382 = addmethod2pos(self, "expressionrest()recursingWith()blocks", &meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382, 40);
  int argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382[] = {1, 1, 1};
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382->type = alloc_MethodType(3, argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382);
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382->definitionModule = modulename;
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5382->definitionLine = 1702;
// compiled method node returning  (depth = 1)
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dotrest
  block_savedest(self);
  Object closure5898 = createclosure(6, "dotrest");
  setclosureframe(closure5898, stackframe);
  addtoclosure(closure5898, var_sym);
  addtoclosure(closure5898, var_util);
  addtoclosure(closure5898, var_values);
  addtoclosure(closure5898, var_ast);
  addtoclosure(closure5898, var_errormessages);
  addtoclosure(closure5898, var_lastToken);
  struct UserObject *uo5898 = (struct UserObject*)self;
  uo5898->data[41] = (Object)closure5898;
  Method *meth_meth_parser_dotrest5898 = addmethod2pos(self, "dotrest", &meth_parser_dotrest5898, 41);
  int argcv_meth_parser_dotrest5898[] = {1};
  meth_meth_parser_dotrest5898->type = alloc_MethodType(1, argcv_meth_parser_dotrest5898);
  meth_meth_parser_dotrest5898->definitionModule = modulename;
  meth_meth_parser_dotrest5898->definitionLine = 1849;
// compiled method node returning  (depth = 1)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method callrest
  block_savedest(self);
  Object closure6007 = createclosure(6, "callrest");
  setclosureframe(closure6007, stackframe);
  addtoclosure(closure6007, var_values);
  addtoclosure(closure6007, var_sym);
  addtoclosure(closure6007, var_util);
  addtoclosure(closure6007, var_ast);
  addtoclosure(closure6007, var_lastToken);
  addtoclosure(closure6007, var_minIndentLevel);
  struct UserObject *uo6007 = (struct UserObject*)self;
  uo6007->data[42] = (Object)closure6007;
  Method *meth_meth_parser_callrest6007 = addmethod2pos(self, "callrest", &meth_parser_callrest6007, 42);
  int argcv_meth_parser_callrest6007[] = {1};
  meth_meth_parser_callrest6007->type = alloc_MethodType(1, argcv_meth_parser_callrest6007);
  meth_meth_parser_callrest6007->definitionModule = modulename;
  meth_meth_parser_callrest6007->definitionLine = 1884;
// compiled method node returning  (depth = 1)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method parenthesizedArg
  block_savedest(self);
  Object closure6260 = createclosure(5, "parenthesizedArg");
  setclosureframe(closure6260, stackframe);
  addtoclosure(closure6260, var_blocksOK);
  addtoclosure(closure6260, var_values);
  addtoclosure(closure6260, var_errormessages);
  addtoclosure(closure6260, var_sym);
  addtoclosure(closure6260, var_lastToken);
  struct UserObject *uo6260 = (struct UserObject*)self;
  uo6260->data[43] = (Object)closure6260;
  Method *meth_meth_parser_parenthesizedArg6260 = addmethod2pos(self, "parenthesizedArg", &meth_parser_parenthesizedArg6260, 43);
  int argcv_meth_parser_parenthesizedArg6260[] = {1};
  meth_meth_parser_parenthesizedArg6260->type = alloc_MethodType(1, argcv_meth_parser_parenthesizedArg6260);
  meth_meth_parser_parenthesizedArg6260->definitionModule = modulename;
  meth_meth_parser_parenthesizedArg6260->definitionLine = 1974;
// compiled method node returning  (depth = 1)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeArgs
  block_savedest(self);
  Object closure6668 = createclosure(4, "typeArgs");
  setclosureframe(closure6668, stackframe);
  addtoclosure(closure6668, var_sym);
  addtoclosure(closure6668, var_values);
  addtoclosure(closure6668, var_errormessages);
  addtoclosure(closure6668, var_lastToken);
  struct UserObject *uo6668 = (struct UserObject*)self;
  uo6668->data[44] = (Object)closure6668;
  Method *meth_meth_parser_typeArgs6668 = addmethod2pos(self, "typeArgs", &meth_parser_typeArgs6668, 44);
  int argcv_meth_parser_typeArgs6668[] = {0};
  meth_meth_parser_typeArgs6668->type = alloc_MethodType(1, argcv_meth_parser_typeArgs6668);
  meth_meth_parser_typeArgs6668->definitionModule = modulename;
  meth_meth_parser_typeArgs6668->definitionLine = 2084;
// compiled method node returning  (depth = 1)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeArg
  block_savedest(self);
  Object closure6750 = createclosure(3, "typeArg");
  setclosureframe(closure6750, stackframe);
  addtoclosure(closure6750, var_sym);
  addtoclosure(closure6750, var_values);
  addtoclosure(closure6750, var_ast);
  struct UserObject *uo6750 = (struct UserObject*)self;
  uo6750->data[45] = (Object)closure6750;
  Method *meth_meth_parser_typeArg6750 = addmethod2pos(self, "typeArg", &meth_parser_typeArg6750, 45);
  int argcv_meth_parser_typeArg6750[] = {0};
  meth_meth_parser_typeArg6750->type = alloc_MethodType(1, argcv_meth_parser_typeArg6750);
  meth_meth_parser_typeArg6750->definitionModule = modulename;
  meth_meth_parser_typeArg6750->definitionLine = 2109;
// compiled method node returning  (depth = 1)
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method callmprest
  block_savedest(self);
  Object closure6782 = createclosure(6, "callmprest");
  setclosureframe(closure6782, stackframe);
  addtoclosure(closure6782, var_lastToken);
  addtoclosure(closure6782, var_ast);
  addtoclosure(closure6782, var_values);
  addtoclosure(closure6782, var_errormessages);
  addtoclosure(closure6782, var_sym);
  addtoclosure(closure6782, var_blocksOK);
  struct UserObject *uo6782 = (struct UserObject*)self;
  uo6782->data[46] = (Object)closure6782;
  Method *meth_meth_parser_callmprest6782 = addmethod2pos(self, "callmprest", &meth_parser_callmprest6782, 46);
  int argcv_meth_parser_callmprest6782[] = {3};
  meth_meth_parser_callmprest6782->type = alloc_MethodType(1, argcv_meth_parser_callmprest6782);
  meth_meth_parser_callmprest6782->definitionModule = modulename;
  meth_meth_parser_callmprest6782->definitionLine = 2125;
// compiled method node returning  (depth = 1)
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method defdec
  block_savedest(self);
  Object closure7218 = createclosure(8, "defdec");
  setclosureframe(closure7218, stackframe);
  addtoclosure(closure7218, var_sym);
  addtoclosure(closure7218, var_errormessages);
  addtoclosure(closure7218, var_lastToken);
  addtoclosure(closure7218, var_values);
  addtoclosure(closure7218, var_blocksOK);
  addtoclosure(closure7218, var_util);
  addtoclosure(closure7218, var_ast);
  addtoclosure(closure7218, var_defaultDefVisibility);
  struct UserObject *uo7218 = (struct UserObject*)self;
  uo7218->data[47] = (Object)closure7218;
  Method *meth_meth_parser_defdec7218 = addmethod2pos(self, "defdec", &meth_parser_defdec7218, 47);
  int argcv_meth_parser_defdec7218[] = {0};
  meth_meth_parser_defdec7218->type = alloc_MethodType(1, argcv_meth_parser_defdec7218);
  meth_meth_parser_defdec7218->definitionModule = modulename;
  meth_meth_parser_defdec7218->definitionLine = 2257;
// compiled method node returning  (depth = 1)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method vardec
  block_savedest(self);
  Object closure7482 = createclosure(8, "vardec");
  setclosureframe(closure7482, stackframe);
  addtoclosure(closure7482, var_sym);
  addtoclosure(closure7482, var_errormessages);
  addtoclosure(closure7482, var_lastToken);
  addtoclosure(closure7482, var_values);
  addtoclosure(closure7482, var_blocksOK);
  addtoclosure(closure7482, var_util);
  addtoclosure(closure7482, var_ast);
  addtoclosure(closure7482, var_defaultVarVisibility);
  struct UserObject *uo7482 = (struct UserObject*)self;
  uo7482->data[48] = (Object)closure7482;
  Method *meth_meth_parser_vardec7482 = addmethod2pos(self, "vardec", &meth_parser_vardec7482, 48);
  int argcv_meth_parser_vardec7482[] = {0};
  meth_meth_parser_vardec7482->type = alloc_MethodType(1, argcv_meth_parser_vardec7482);
  meth_meth_parser_vardec7482->definitionModule = modulename;
  meth_meth_parser_vardec7482->definitionLine = 2330;
// compiled method node returning  (depth = 1)
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doarray
  block_savedest(self);
  Object closure7717 = createclosure(6, "doarray");
  setclosureframe(closure7717, stackframe);
  addtoclosure(closure7717, var_blocksOK);
  addtoclosure(closure7717, var_values);
  addtoclosure(closure7717, var_errormessages);
  addtoclosure(closure7717, var_sym);
  addtoclosure(closure7717, var_lastToken);
  addtoclosure(closure7717, var_ast);
  struct UserObject *uo7717 = (struct UserObject*)self;
  uo7717->data[49] = (Object)closure7717;
  Method *meth_meth_parser_doarray7717 = addmethod2pos(self, "doarray", &meth_parser_doarray7717, 49);
  int argcv_meth_parser_doarray7717[] = {0};
  meth_meth_parser_doarray7717->type = alloc_MethodType(1, argcv_meth_parser_doarray7717);
  meth_meth_parser_doarray7717->definitionModule = modulename;
  meth_meth_parser_doarray7717->definitionLine = 2398;
// compiled method node returning  (depth = 1)
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dodialect
  block_savedest(self);
  Object closure7849 = createclosure(5, "dodialect");
  setclosureframe(closure7849, stackframe);
  addtoclosure(closure7849, var_sym);
  addtoclosure(closure7849, var_errormessages);
  addtoclosure(closure7849, var_lastToken);
  addtoclosure(closure7849, var_ast);
  addtoclosure(closure7849, var_values);
  struct UserObject *uo7849 = (struct UserObject*)self;
  uo7849->data[50] = (Object)closure7849;
  Method *meth_meth_parser_dodialect7849 = addmethod2pos(self, "dodialect", &meth_parser_dodialect7849, 50);
  int argcv_meth_parser_dodialect7849[] = {0};
  meth_meth_parser_dodialect7849->type = alloc_MethodType(1, argcv_meth_parser_dodialect7849);
  meth_meth_parser_dodialect7849->definitionModule = modulename;
  meth_meth_parser_dodialect7849->definitionLine = 2441;
// compiled method node returning  (depth = 1)
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method inheritsdec
  block_savedest(self);
  Object closure7938 = createclosure(7, "inheritsdec");
  setclosureframe(closure7938, stackframe);
  addtoclosure(closure7938, var_sym);
  addtoclosure(closure7938, var_noBlocks);
  addtoclosure(closure7938, var_errormessages);
  addtoclosure(closure7938, var_lastToken);
  addtoclosure(closure7938, var_util);
  addtoclosure(closure7938, var_values);
  addtoclosure(closure7938, var_ast);
  struct UserObject *uo7938 = (struct UserObject*)self;
  uo7938->data[51] = (Object)closure7938;
  Method *meth_meth_parser_inheritsdec7938 = addmethod2pos(self, "inheritsdec", &meth_parser_inheritsdec7938, 51);
  int argcv_meth_parser_inheritsdec7938[] = {0};
  meth_meth_parser_inheritsdec7938->type = alloc_MethodType(1, argcv_meth_parser_inheritsdec7938);
  meth_meth_parser_inheritsdec7938->definitionModule = modulename;
  meth_meth_parser_inheritsdec7938->definitionLine = 2462;
// compiled method node returning  (depth = 1)
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doobject
  block_savedest(self);
  Object closure8036 = createclosure(8, "doobject");
  setclosureframe(closure8036, stackframe);
  addtoclosure(closure8036, var_sym);
  addtoclosure(closure8036, var_minIndentLevel);
  addtoclosure(closure8036, var_errormessages);
  addtoclosure(closure8036, var_lastToken);
  addtoclosure(closure8036, var_values);
  addtoclosure(closure8036, var_statementToken);
  addtoclosure(closure8036, var_util);
  addtoclosure(closure8036, var_ast);
  struct UserObject *uo8036 = (struct UserObject*)self;
  uo8036->data[52] = (Object)closure8036;
  Method *meth_meth_parser_doobject8036 = addmethod2pos(self, "doobject", &meth_parser_doobject8036, 52);
  int argcv_meth_parser_doobject8036[] = {0};
  meth_meth_parser_doobject8036->type = alloc_MethodType(1, argcv_meth_parser_doobject8036);
  meth_meth_parser_doobject8036->definitionModule = modulename;
  meth_meth_parser_doobject8036->definitionLine = 2492;
// compiled method node returning  (depth = 1)
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doclass
  block_savedest(self);
  Object closure8273 = createclosure(10, "doclass");
  setclosureframe(closure8273, stackframe);
  addtoclosure(closure8273, var_sym);
  addtoclosure(closure8273, var_minIndentLevel);
  addtoclosure(closure8273, var_errormessages);
  addtoclosure(closure8273, var_lastToken);
  addtoclosure(closure8273, var_tokens);
  addtoclosure(closure8273, var_values);
  addtoclosure(closure8273, var_statementToken);
  addtoclosure(closure8273, var_util);
  addtoclosure(closure8273, var_ast);
  addtoclosure(closure8273, var_defaultMethodVisibility);
  struct UserObject *uo8273 = (struct UserObject*)self;
  uo8273->data[53] = (Object)closure8273;
  Method *meth_meth_parser_doclass8273 = addmethod2pos(self, "doclass", &meth_parser_doclass8273, 53);
  int argcv_meth_parser_doclass8273[] = {0};
  meth_meth_parser_doclass8273->type = alloc_MethodType(1, argcv_meth_parser_doclass8273);
  meth_meth_parser_doclass8273->definitionModule = modulename;
  meth_meth_parser_doclass8273->definitionLine = 2571;
// compiled method node returning  (depth = 1)
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dofactoryMethod
  block_savedest(self);
  Object closure8593 = createclosure(10, "dofactoryMethod");
  setclosureframe(closure8593, stackframe);
  addtoclosure(closure8593, var_tokens);
  addtoclosure(closure8593, var_sym);
  addtoclosure(closure8593, var_minIndentLevel);
  addtoclosure(closure8593, var_errormessages);
  addtoclosure(closure8593, var_lastToken);
  addtoclosure(closure8593, var_statementToken);
  addtoclosure(closure8593, var_values);
  addtoclosure(closure8593, var_util);
  addtoclosure(closure8593, var_ast);
  addtoclosure(closure8593, var_defaultMethodVisibility);
  struct UserObject *uo8593 = (struct UserObject*)self;
  uo8593->data[54] = (Object)closure8593;
  Method *meth_meth_parser_dofactoryMethod8593 = addmethod2pos(self, "dofactoryMethod", &meth_parser_dofactoryMethod8593, 54);
  int argcv_meth_parser_dofactoryMethod8593[] = {0};
  meth_meth_parser_dofactoryMethod8593->type = alloc_MethodType(1, argcv_meth_parser_dofactoryMethod8593);
  meth_meth_parser_dofactoryMethod8593->definitionModule = modulename;
  meth_meth_parser_dofactoryMethod8593->definitionLine = 2663;
// compiled method node returning  (depth = 1)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method methoddec
  block_savedest(self);
  Object closure8874 = createclosure(9, "methoddec");
  setclosureframe(closure8874, stackframe);
  addtoclosure(closure8874, var_sym);
  addtoclosure(closure8874, var_statementToken);
  addtoclosure(closure8874, var_minIndentLevel);
  addtoclosure(closure8874, var_values);
  addtoclosure(closure8874, var_errormessages);
  addtoclosure(closure8874, var_lastToken);
  addtoclosure(closure8874, var_util);
  addtoclosure(closure8874, var_ast);
  addtoclosure(closure8874, var_defaultMethodVisibility);
  struct UserObject *uo8874 = (struct UserObject*)self;
  uo8874->data[55] = (Object)closure8874;
  Method *meth_meth_parser_methoddec8874 = addmethod2pos(self, "methoddec", &meth_parser_methoddec8874, 55);
  int argcv_meth_parser_methoddec8874[] = {0};
  meth_meth_parser_methoddec8874->type = alloc_MethodType(1, argcv_meth_parser_methoddec8874);
  meth_meth_parser_methoddec8874->definitionModule = modulename;
  meth_meth_parser_methoddec8874->definitionLine = 2739;
// compiled method node returning  (depth = 1)
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method parsempmndecrest
  block_savedest(self);
  Object closure9109 = createclosure(5, "parsempmndecrest");
  setclosureframe(closure9109, stackframe);
  addtoclosure(closure9109, var_ast);
  addtoclosure(closure9109, var_values);
  addtoclosure(closure9109, var_errormessages);
  addtoclosure(closure9109, var_lastToken);
  addtoclosure(closure9109, var_sym);
  struct UserObject *uo9109 = (struct UserObject*)self;
  uo9109->data[56] = (Object)closure9109;
  Method *meth_meth_parser_parsempmndecrest9109 = addmethod2pos(self, "parsempmndecrest", &meth_parser_parsempmndecrest9109, 56);
  int argcv_meth_parser_parsempmndecrest9109[] = {2};
  meth_meth_parser_parsempmndecrest9109->type = alloc_MethodType(1, argcv_meth_parser_parsempmndecrest9109);
  meth_meth_parser_parsempmndecrest9109->definitionModule = modulename;
  meth_meth_parser_parsempmndecrest9109->definitionLine = 2828;
// compiled method node returning  (depth = 1)
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method optionalTypeAnnotation
  block_savedest(self);
  Object closure9368 = createclosure(4, "optionalTypeAnnotation");
  setclosureframe(closure9368, stackframe);
  addtoclosure(closure9368, var_values);
  addtoclosure(closure9368, var_errormessages);
  addtoclosure(closure9368, var_lastToken);
  addtoclosure(closure9368, var_sym);
  struct UserObject *uo9368 = (struct UserObject*)self;
  uo9368->data[57] = (Object)closure9368;
  Method *meth_meth_parser_optionalTypeAnnotation9368 = addmethod2pos(self, "optionalTypeAnnotation", &meth_parser_optionalTypeAnnotation9368, 57);
  int argcv_meth_parser_optionalTypeAnnotation9368[] = {0};
  meth_meth_parser_optionalTypeAnnotation9368->type = alloc_MethodType(1, argcv_meth_parser_optionalTypeAnnotation9368);
  meth_meth_parser_optionalTypeAnnotation9368->definitionModule = modulename;
  meth_meth_parser_optionalTypeAnnotation9368->definitionLine = 2906;
// compiled method node returning  (depth = 1)
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method methodsignature
  block_savedest(self);
  Object closure9419 = createclosure(6, "methodsignature");
  setclosureframe(closure9419, stackframe);
  addtoclosure(closure9419, var_sym);
  addtoclosure(closure9419, var_errormessages);
  addtoclosure(closure9419, var_lastToken);
  addtoclosure(closure9419, var_values);
  addtoclosure(closure9419, var_ast);
  addtoclosure(closure9419, var_tokens);
  struct UserObject *uo9419 = (struct UserObject*)self;
  uo9419->data[58] = (Object)closure9419;
  Method *meth_meth_parser_methodsignature9419 = addmethod2pos(self, "methodsignature", &meth_parser_methodsignature9419, 58);
  int argcv_meth_parser_methodsignature9419[] = {1};
  meth_meth_parser_methodsignature9419->type = alloc_MethodType(1, argcv_meth_parser_methodsignature9419);
  meth_meth_parser_methodsignature9419->definitionModule = modulename;
  meth_meth_parser_methodsignature9419->definitionLine = 2929;
// compiled method node returning  (depth = 1)
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeparameters
  block_savedest(self);
  Object closure10065 = createclosure(5, "typeparameters");
  setclosureframe(closure10065, stackframe);
  addtoclosure(closure10065, var_values);
  addtoclosure(closure10065, var_ast);
  addtoclosure(closure10065, var_sym);
  addtoclosure(closure10065, var_errormessages);
  addtoclosure(closure10065, var_lastToken);
  struct UserObject *uo10065 = (struct UserObject*)self;
  uo10065->data[59] = (Object)closure10065;
  Method *meth_meth_parser_typeparameters10065 = addmethod2pos(self, "typeparameters", &meth_parser_typeparameters10065, 59);
  int argcv_meth_parser_typeparameters10065[] = {1};
  meth_meth_parser_typeparameters10065->type = alloc_MethodType(1, argcv_meth_parser_typeparameters10065);
  meth_meth_parser_typeparameters10065->definitionModule = modulename;
  meth_meth_parser_typeparameters10065->definitionLine = 3093;
// compiled method node returning  (depth = 1)
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doimport
  block_savedest(self);
  Object closure10140 = createclosure(7, "doimport");
  setclosureframe(closure10140, stackframe);
  addtoclosure(closure10140, var_sym);
  addtoclosure(closure10140, var_errormessages);
  addtoclosure(closure10140, var_lastToken);
  addtoclosure(closure10140, var_values);
  addtoclosure(closure10140, var_util);
  addtoclosure(closure10140, var_ast);
  addtoclosure(closure10140, var_defaultDefVisibility);
  struct UserObject *uo10140 = (struct UserObject*)self;
  uo10140->data[60] = (Object)closure10140;
  Method *meth_meth_parser_doimport10140 = addmethod2pos(self, "doimport", &meth_parser_doimport10140, 60);
  int argcv_meth_parser_doimport10140[] = {0};
  meth_meth_parser_doimport10140->type = alloc_MethodType(1, argcv_meth_parser_doimport10140);
  meth_meth_parser_doimport10140->definitionModule = modulename;
  meth_meth_parser_doimport10140->definitionLine = 3116;
// compiled method node returning  (depth = 1)
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doreturn
  block_savedest(self);
  Object closure10402 = createclosure(7, "doreturn");
  setclosureframe(closure10402, stackframe);
  addtoclosure(closure10402, var_sym);
  addtoclosure(closure10402, var_blocksOK);
  addtoclosure(closure10402, var_errormessages);
  addtoclosure(closure10402, var_lastToken);
  addtoclosure(closure10402, var_values);
  addtoclosure(closure10402, var_ast);
  addtoclosure(closure10402, var_util);
  struct UserObject *uo10402 = (struct UserObject*)self;
  uo10402->data[61] = (Object)closure10402;
  Method *meth_meth_parser_doreturn10402 = addmethod2pos(self, "doreturn", &meth_parser_doreturn10402, 61);
  int argcv_meth_parser_doreturn10402[] = {0};
  meth_meth_parser_doreturn10402->type = alloc_MethodType(1, argcv_meth_parser_doreturn10402);
  meth_meth_parser_doreturn10402->definitionModule = modulename;
  meth_meth_parser_doreturn10402->definitionLine = 3175;
// compiled method node returning  (depth = 1)
// Begin line 3211
  setline(3211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method domethodtype
  block_savedest(self);
  Object closure10532 = createclosure(6, "domethodtype");
  setclosureframe(closure10532, stackframe);
  addtoclosure(closure10532, var_sym);
  addtoclosure(closure10532, var_ast);
  addtoclosure(closure10532, var_util);
  addtoclosure(closure10532, var_values);
  addtoclosure(closure10532, var_lastToken);
  addtoclosure(closure10532, var_errormessages);
  struct UserObject *uo10532 = (struct UserObject*)self;
  uo10532->data[62] = (Object)closure10532;
  Method *meth_meth_parser_domethodtype10532 = addmethod2pos(self, "domethodtype", &meth_parser_domethodtype10532, 62);
  int argcv_meth_parser_domethodtype10532[] = {0};
  meth_meth_parser_domethodtype10532->type = alloc_MethodType(1, argcv_meth_parser_domethodtype10532);
  meth_meth_parser_domethodtype10532->definitionModule = modulename;
  meth_meth_parser_domethodtype10532->definitionLine = 3211;
// compiled method node returning  (depth = 1)
// Begin line 3243
  setline(3243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dotypeLiteral
  block_savedest(self);
  Object closure10638 = createclosure(7, "dotypeLiteral");
  setclosureframe(closure10638, stackframe);
  addtoclosure(closure10638, var_sym);
  addtoclosure(closure10638, var_errormessages);
  addtoclosure(closure10638, var_done);
  addtoclosure(closure10638, var_auto_count);
  addtoclosure(closure10638, var_values);
  addtoclosure(closure10638, var_util);
  addtoclosure(closure10638, var_ast);
  struct UserObject *uo10638 = (struct UserObject*)self;
  uo10638->data[63] = (Object)closure10638;
  Method *meth_meth_parser_dotypeLiteral10638 = addmethod2pos(self, "dotypeLiteral", &meth_parser_dotypeLiteral10638, 63);
  int argcv_meth_parser_dotypeLiteral10638[] = {0};
  meth_meth_parser_dotypeLiteral10638->type = alloc_MethodType(1, argcv_meth_parser_dotypeLiteral10638);
  meth_meth_parser_dotypeLiteral10638->definitionModule = modulename;
  meth_meth_parser_dotypeLiteral10638->definitionLine = 3243;
// compiled method node returning  (depth = 1)
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typedec
  block_savedest(self);
  Object closure10743 = createclosure(7, "typedec");
  setclosureframe(closure10743, stackframe);
  addtoclosure(closure10743, var_sym);
  addtoclosure(closure10743, var_errormessages);
  addtoclosure(closure10743, var_lastToken);
  addtoclosure(closure10743, var_util);
  addtoclosure(closure10743, var_values);
  addtoclosure(closure10743, var_ast);
  addtoclosure(closure10743, var_noBlocks);
  struct UserObject *uo10743 = (struct UserObject*)self;
  uo10743->data[64] = (Object)closure10743;
  Method *meth_meth_parser_typedec10743 = addmethod2pos(self, "typedec", &meth_parser_typedec10743, 64);
  int argcv_meth_parser_typedec10743[] = {0};
  meth_meth_parser_typedec10743->type = alloc_MethodType(1, argcv_meth_parser_typedec10743);
  meth_meth_parser_typedec10743->definitionModule = modulename;
  meth_meth_parser_typedec10743->definitionLine = 3278;
// compiled method node returning  (depth = 1)
// Begin line 3323
  setline(3323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkIndent
  block_savedest(self);
  Object closure10912 = createclosure(5, "checkIndent");
  setclosureframe(closure10912, stackframe);
  addtoclosure(closure10912, var_indentFreePass);
  addtoclosure(closure10912, var_sym);
  addtoclosure(closure10912, var_minIndentLevel);
  addtoclosure(closure10912, var_errormessages);
  addtoclosure(closure10912, var_lastToken);
  struct UserObject *uo10912 = (struct UserObject*)self;
  uo10912->data[65] = (Object)closure10912;
  Method *meth_meth_parser_checkIndent10912 = addmethod2pos(self, "checkIndent", &meth_parser_checkIndent10912, 65);
  int argcv_meth_parser_checkIndent10912[] = {0};
  meth_meth_parser_checkIndent10912->type = alloc_MethodType(1, argcv_meth_parser_checkIndent10912);
  meth_meth_parser_checkIndent10912->definitionModule = modulename;
  meth_meth_parser_checkIndent10912->definitionLine = 3323;
// compiled method node returning  (depth = 1)
// Begin line 3359
  setline(3359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method statement
  block_savedest(self);
  Object closure11095 = createclosure(10, "statement");
  setclosureframe(closure11095, stackframe);
  addtoclosure(closure11095, var_sym);
  addtoclosure(closure11095, var_statementIndent);
  addtoclosure(closure11095, var_statementToken);
  addtoclosure(closure11095, var_blocksOK);
  addtoclosure(closure11095, var_values);
  addtoclosure(closure11095, var_errormessages);
  addtoclosure(closure11095, var_lastToken);
  addtoclosure(closure11095, var_util);
  addtoclosure(closure11095, var_ast);
  addtoclosure(closure11095, var_indentFreePass);
  struct UserObject *uo11095 = (struct UserObject*)self;
  uo11095->data[66] = (Object)closure11095;
  Method *meth_meth_parser_statement11095 = addmethod2pos(self, "statement", &meth_parser_statement11095, 66);
  int argcv_meth_parser_statement11095[] = {0};
  meth_meth_parser_statement11095->type = alloc_MethodType(1, argcv_meth_parser_statement11095);
  meth_meth_parser_statement11095->definitionModule = modulename;
  meth_meth_parser_statement11095->definitionLine = 3359;
// compiled method node returning  (depth = 1)
// Begin line 3436
  setline(3436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushcomments
  block_savedest(self);
  Object closure11327 = createclosure(8, "pushcomments");
  setclosureframe(closure11327, stackframe);
  addtoclosure(closure11327, var_done);
  addtoclosure(closure11327, var_sym);
  addtoclosure(closure11327, var_util);
  addtoclosure(closure11327, var_ast);
  addtoclosure(closure11327, var_lastToken);
  addtoclosure(closure11327, var_comments);
  addtoclosure(closure11327, var_previousCommentToken);
  addtoclosure(closure11327, var_tokens);
  struct UserObject *uo11327 = (struct UserObject*)self;
  uo11327->data[67] = (Object)closure11327;
  Method *meth_meth_parser_pushcomments11327 = addmethod2pos(self, "pushcomments", &meth_parser_pushcomments11327, 67);
  int argcv_meth_parser_pushcomments11327[] = {0};
  meth_meth_parser_pushcomments11327->type = alloc_MethodType(1, argcv_meth_parser_pushcomments11327);
  meth_meth_parser_pushcomments11327->definitionModule = modulename;
  meth_meth_parser_pushcomments11327->definitionLine = 3436;
// compiled method node returning  (depth = 1)
// Begin line 3470
  setline(3470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method reconcileComments
  block_savedest(self);
  Object closure11460 = createclosure(3, "reconcileComments");
  setclosureframe(closure11460, stackframe);
  addtoclosure(closure11460, var_values);
  addtoclosure(closure11460, var_done);
  addtoclosure(closure11460, var_comments);
  struct UserObject *uo11460 = (struct UserObject*)self;
  uo11460->data[68] = (Object)closure11460;
  Method *meth_meth_parser_reconcileComments11460 = addmethod2pos(self, "reconcileComments", &meth_parser_reconcileComments11460, 68);
  int argcv_meth_parser_reconcileComments11460[] = {0};
  meth_meth_parser_reconcileComments11460->type = alloc_MethodType(1, argcv_meth_parser_reconcileComments11460);
  meth_meth_parser_reconcileComments11460->definitionModule = modulename;
  meth_meth_parser_reconcileComments11460->definitionLine = 3470;
// compiled method node returning  (depth = 1)
// Begin line 3513
  setline(3513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkBadOperators
  block_savedest(self);
  Object closure11595 = createclosure(2, "checkBadOperators");
  setclosureframe(closure11595, stackframe);
  addtoclosure(closure11595, var_sym);
  addtoclosure(closure11595, var_errormessages);
  struct UserObject *uo11595 = (struct UserObject*)self;
  uo11595->data[69] = (Object)closure11595;
  Method *meth_meth_parser_checkBadOperators11595 = addmethod2pos(self, "checkBadOperators", &meth_parser_checkBadOperators11595, 69);
  int argcv_meth_parser_checkBadOperators11595[] = {0};
  meth_meth_parser_checkBadOperators11595->type = alloc_MethodType(1, argcv_meth_parser_checkBadOperators11595);
  meth_meth_parser_checkBadOperators11595->definitionModule = modulename;
  meth_meth_parser_checkBadOperators11595->definitionLine = 3513;
// compiled method node returning  (depth = 1)
// Begin line 3530
  setline(3530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkBadTypeLiteral
  block_savedest(self);
  Object closure11642 = createclosure(2, "checkBadTypeLiteral");
  setclosureframe(closure11642, stackframe);
  addtoclosure(closure11642, var_sym);
  addtoclosure(closure11642, var_errormessages);
  struct UserObject *uo11642 = (struct UserObject*)self;
  uo11642->data[70] = (Object)closure11642;
  Method *meth_meth_parser_checkBadTypeLiteral11642 = addmethod2pos(self, "checkBadTypeLiteral", &meth_parser_checkBadTypeLiteral11642, 70);
  int argcv_meth_parser_checkBadTypeLiteral11642[] = {0};
  meth_meth_parser_checkBadTypeLiteral11642->type = alloc_MethodType(1, argcv_meth_parser_checkBadTypeLiteral11642);
  meth_meth_parser_checkBadTypeLiteral11642->definitionModule = modulename;
  meth_meth_parser_checkBadTypeLiteral11642->definitionLine = 3530;
// compiled method node returning  (depth = 1)
// Begin line 3540
  setline(3540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkUnexpectedTokenAfterStatement
  block_savedest(self);
  Object closure11666 = createclosure(5, "checkUnexpectedTokenAfterStatement");
  setclosureframe(closure11666, stackframe);
  addtoclosure(closure11666, var_lastToken);
  addtoclosure(closure11666, var_sym);
  addtoclosure(closure11666, var_errormessages);
  addtoclosure(closure11666, var_values);
  addtoclosure(closure11666, var_util);
  struct UserObject *uo11666 = (struct UserObject*)self;
  uo11666->data[71] = (Object)closure11666;
  Method *meth_meth_parser_checkUnexpectedTokenAfterStatement11666 = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_checkUnexpectedTokenAfterStatement11666, 71);
  int argcv_meth_parser_checkUnexpectedTokenAfterStatement11666[] = {0};
  meth_meth_parser_checkUnexpectedTokenAfterStatement11666->type = alloc_MethodType(1, argcv_meth_parser_checkUnexpectedTokenAfterStatement11666);
  meth_meth_parser_checkUnexpectedTokenAfterStatement11666->definitionModule = modulename;
  meth_meth_parser_checkUnexpectedTokenAfterStatement11666->definitionLine = 3540;
// compiled method node returning  (depth = 1)
// Begin line 3610
  setline(3610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method parse
  block_savedest(self);
  Object closure11992 = createclosure(8, "parse");
  setclosureframe(closure11992, stackframe);
  addtoclosure(closure11992, var_util);
  addtoclosure(closure11992, var_defaultDefVisibility);
  addtoclosure(closure11992, var_defaultVarVisibility);
  addtoclosure(closure11992, var_defaultMethodVisibility);
  addtoclosure(closure11992, var_tokens);
  addtoclosure(closure11992, var_sym);
  addtoclosure(closure11992, var_errormessages);
  addtoclosure(closure11992, var_values);
  struct UserObject *uo11992 = (struct UserObject*)self;
  uo11992->data[72] = (Object)closure11992;
  Method *meth_meth_parser_parse11992 = addmethod2pos(self, "parse", &meth_parser_parse11992, 72);
  int argcv_meth_parser_parse11992[] = {1};
  meth_meth_parser_parse11992->type = alloc_MethodType(1, argcv_meth_parser_parse11992);
  meth_meth_parser_parse11992->definitionModule = modulename;
  meth_meth_parser_parse11992->definitionLine = 3610;
// compiled method node returning  (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = LOAD_MODULE(ast);
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num12165 = alloc_Float64(0);
// compiled num node returning num12165 (depth = 2)
  *var_blankLocation = num12165;
  if (num12165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method blankLocation
  block_savedest(self);
  Object closure12166 = createclosure(1, "blankLocation");
  setclosureframe(closure12166, stackframe);
  addtoclosure(closure12166, var_blankLocation);
  struct UserObject *uo12166 = (struct UserObject*)self;
  uo12166->data[73] = (Object)closure12166;
  Method *meth_meth_parser_blankLocation12166 = addmethod2pos(self, "blankLocation", &meth_parser_blankLocation12166, 73);
  int argcv_meth_parser_blankLocation12166[] = {0};
  meth_meth_parser_blankLocation12166->type = alloc_MethodType(1, argcv_meth_parser_blankLocation12166);
  meth_meth_parser_blankLocation12166->definitionModule = modulename;
  meth_meth_parser_blankLocation12166->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method blankLocation:=
  block_savedest(self);
  Object closure12167 = createclosure(1, "blankLocation:=");
  setclosureframe(closure12167, stackframe);
  addtoclosure(closure12167, var_blankLocation);
  struct UserObject *uo12167 = (struct UserObject*)self;
  uo12167->data[74] = (Object)closure12167;
  Method *meth_meth_parser_blankLocation_58__61_12167 = addmethod2pos(self, "blankLocation:=", &meth_parser_blankLocation_58__61_12167, 74);
  int argcv_meth_parser_blankLocation_58__61_12167[] = {1};
  meth_meth_parser_blankLocation_58__61_12167->type = alloc_MethodType(1, argcv_meth_parser_blankLocation_58__61_12167);
  meth_meth_parser_blankLocation_58__61_12167->definitionModule = modulename;
  meth_meth_parser_blankLocation_58__61_12167->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num12169 = alloc_Float64(0);
// compiled num node returning num12169 (depth = 2)
  *var_lastLine = num12169;
  if (num12169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastLine
  block_savedest(self);
  Object closure12170 = createclosure(1, "lastLine");
  setclosureframe(closure12170, stackframe);
  addtoclosure(closure12170, var_lastLine);
  struct UserObject *uo12170 = (struct UserObject*)self;
  uo12170->data[75] = (Object)closure12170;
  Method *meth_meth_parser_lastLine12170 = addmethod2pos(self, "lastLine", &meth_parser_lastLine12170, 75);
  int argcv_meth_parser_lastLine12170[] = {0};
  meth_meth_parser_lastLine12170->type = alloc_MethodType(1, argcv_meth_parser_lastLine12170);
  meth_meth_parser_lastLine12170->definitionModule = modulename;
  meth_meth_parser_lastLine12170->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastLine:=
  block_savedest(self);
  Object closure12171 = createclosure(1, "lastLine:=");
  setclosureframe(closure12171, stackframe);
  addtoclosure(closure12171, var_lastLine);
  struct UserObject *uo12171 = (struct UserObject*)self;
  uo12171->data[76] = (Object)closure12171;
  Method *meth_meth_parser_lastLine_58__61_12171 = addmethod2pos(self, "lastLine:=", &meth_parser_lastLine_58__61_12171, 76);
  int argcv_meth_parser_lastLine_58__61_12171[] = {1};
  meth_meth_parser_lastLine_58__61_12171->type = alloc_MethodType(1, argcv_meth_parser_lastLine_58__61_12171);
  meth_meth_parser_lastLine_58__61_12171->definitionModule = modulename;
  meth_meth_parser_lastLine_58__61_12171->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num12173 = alloc_Float64(0);
// compiled num node returning num12173 (depth = 2)
  *var_lastIndent = num12173;
  if (num12173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastIndent
  block_savedest(self);
  Object closure12174 = createclosure(1, "lastIndent");
  setclosureframe(closure12174, stackframe);
  addtoclosure(closure12174, var_lastIndent);
  struct UserObject *uo12174 = (struct UserObject*)self;
  uo12174->data[77] = (Object)closure12174;
  Method *meth_meth_parser_lastIndent12174 = addmethod2pos(self, "lastIndent", &meth_parser_lastIndent12174, 77);
  int argcv_meth_parser_lastIndent12174[] = {0};
  meth_meth_parser_lastIndent12174->type = alloc_MethodType(1, argcv_meth_parser_lastIndent12174);
  meth_meth_parser_lastIndent12174->definitionModule = modulename;
  meth_meth_parser_lastIndent12174->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastIndent:=
  block_savedest(self);
  Object closure12175 = createclosure(1, "lastIndent:=");
  setclosureframe(closure12175, stackframe);
  addtoclosure(closure12175, var_lastIndent);
  struct UserObject *uo12175 = (struct UserObject*)self;
  uo12175->data[78] = (Object)closure12175;
  Method *meth_meth_parser_lastIndent_58__61_12175 = addmethod2pos(self, "lastIndent:=", &meth_parser_lastIndent_58__61_12175, 78);
  int argcv_meth_parser_lastIndent_58__61_12175[] = {1};
  meth_meth_parser_lastIndent_58__61_12175->type = alloc_MethodType(1, argcv_meth_parser_lastIndent_58__61_12175);
  meth_meth_parser_lastIndent_58__61_12175->definitionModule = modulename;
  meth_meth_parser_lastIndent_58__61_12175->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool12177 = alloc_Boolean(0);
// compiled identifier node returning bool12177 (depth = 2)
  *var_indentFreePass = bool12177;
  if (bool12177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method indentFreePass
  block_savedest(self);
  Object closure12178 = createclosure(1, "indentFreePass");
  setclosureframe(closure12178, stackframe);
  addtoclosure(closure12178, var_indentFreePass);
  struct UserObject *uo12178 = (struct UserObject*)self;
  uo12178->data[79] = (Object)closure12178;
  Method *meth_meth_parser_indentFreePass12178 = addmethod2pos(self, "indentFreePass", &meth_parser_indentFreePass12178, 79);
  int argcv_meth_parser_indentFreePass12178[] = {0};
  meth_meth_parser_indentFreePass12178->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass12178);
  meth_meth_parser_indentFreePass12178->definitionModule = modulename;
  meth_meth_parser_indentFreePass12178->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method indentFreePass:=
  block_savedest(self);
  Object closure12179 = createclosure(1, "indentFreePass:=");
  setclosureframe(closure12179, stackframe);
  addtoclosure(closure12179, var_indentFreePass);
  struct UserObject *uo12179 = (struct UserObject*)self;
  uo12179->data[80] = (Object)closure12179;
  Method *meth_meth_parser_indentFreePass_58__61_12179 = addmethod2pos(self, "indentFreePass:=", &meth_parser_indentFreePass_58__61_12179, 80);
  int argcv_meth_parser_indentFreePass_58__61_12179[] = {1};
  meth_meth_parser_indentFreePass_58__61_12179->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass_58__61_12179);
  meth_meth_parser_indentFreePass_58__61_12179->definitionModule = modulename;
  meth_meth_parser_indentFreePass_58__61_12179->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num12181 = alloc_Float64(0);
// compiled num node returning num12181 (depth = 2)
  *var_minIndentLevel = num12181;
  if (num12181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method minIndentLevel
  block_savedest(self);
  Object closure12182 = createclosure(1, "minIndentLevel");
  setclosureframe(closure12182, stackframe);
  addtoclosure(closure12182, var_minIndentLevel);
  struct UserObject *uo12182 = (struct UserObject*)self;
  uo12182->data[81] = (Object)closure12182;
  Method *meth_meth_parser_minIndentLevel12182 = addmethod2pos(self, "minIndentLevel", &meth_parser_minIndentLevel12182, 81);
  int argcv_meth_parser_minIndentLevel12182[] = {0};
  meth_meth_parser_minIndentLevel12182->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel12182);
  meth_meth_parser_minIndentLevel12182->definitionModule = modulename;
  meth_meth_parser_minIndentLevel12182->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method minIndentLevel:=
  block_savedest(self);
  Object closure12183 = createclosure(1, "minIndentLevel:=");
  setclosureframe(closure12183, stackframe);
  addtoclosure(closure12183, var_minIndentLevel);
  struct UserObject *uo12183 = (struct UserObject*)self;
  uo12183->data[82] = (Object)closure12183;
  Method *meth_meth_parser_minIndentLevel_58__61_12183 = addmethod2pos(self, "minIndentLevel:=", &meth_parser_minIndentLevel_58__61_12183, 82);
  int argcv_meth_parser_minIndentLevel_58__61_12183[] = {1};
  meth_meth_parser_minIndentLevel_58__61_12183->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel_58__61_12183);
  meth_meth_parser_minIndentLevel_58__61_12183->definitionModule = modulename;
  meth_meth_parser_minIndentLevel_58__61_12183->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num12185 = alloc_Float64(0);
// compiled num node returning num12185 (depth = 2)
  *var_statementIndent = num12185;
  if (num12185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementIndent
  block_savedest(self);
  Object closure12186 = createclosure(1, "statementIndent");
  setclosureframe(closure12186, stackframe);
  addtoclosure(closure12186, var_statementIndent);
  struct UserObject *uo12186 = (struct UserObject*)self;
  uo12186->data[83] = (Object)closure12186;
  Method *meth_meth_parser_statementIndent12186 = addmethod2pos(self, "statementIndent", &meth_parser_statementIndent12186, 83);
  int argcv_meth_parser_statementIndent12186[] = {0};
  meth_meth_parser_statementIndent12186->type = alloc_MethodType(1, argcv_meth_parser_statementIndent12186);
  meth_meth_parser_statementIndent12186->definitionModule = modulename;
  meth_meth_parser_statementIndent12186->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementIndent:=
  block_savedest(self);
  Object closure12187 = createclosure(1, "statementIndent:=");
  setclosureframe(closure12187, stackframe);
  addtoclosure(closure12187, var_statementIndent);
  struct UserObject *uo12187 = (struct UserObject*)self;
  uo12187->data[84] = (Object)closure12187;
  Method *meth_meth_parser_statementIndent_58__61_12187 = addmethod2pos(self, "statementIndent:=", &meth_parser_statementIndent_58__61_12187, 84);
  int argcv_meth_parser_statementIndent_58__61_12187[] = {1};
  meth_meth_parser_statementIndent_58__61_12187->type = alloc_MethodType(1, argcv_meth_parser_statementIndent_58__61_12187);
  meth_meth_parser_statementIndent_58__61_12187->definitionModule = modulename;
  meth_meth_parser_statementIndent_58__61_12187->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool12189 = alloc_Boolean(0);
// compiled identifier node returning bool12189 (depth = 2)
  *var_tokens = bool12189;
  if (bool12189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method tokens
  block_savedest(self);
  Object closure12190 = createclosure(1, "tokens");
  setclosureframe(closure12190, stackframe);
  addtoclosure(closure12190, var_tokens);
  struct UserObject *uo12190 = (struct UserObject*)self;
  uo12190->data[85] = (Object)closure12190;
  Method *meth_meth_parser_tokens12190 = addmethod2pos(self, "tokens", &meth_parser_tokens12190, 85);
  int argcv_meth_parser_tokens12190[] = {0};
  meth_meth_parser_tokens12190->type = alloc_MethodType(1, argcv_meth_parser_tokens12190);
  meth_meth_parser_tokens12190->definitionModule = modulename;
  meth_meth_parser_tokens12190->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// Begin line 3661
  setline(3661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method tokens:=
  block_savedest(self);
  Object closure12191 = createclosure(1, "tokens:=");
  setclosureframe(closure12191, stackframe);
  addtoclosure(closure12191, var_tokens);
  struct UserObject *uo12191 = (struct UserObject*)self;
  uo12191->data[86] = (Object)closure12191;
  Method *meth_meth_parser_tokens_58__61_12191 = addmethod2pos(self, "tokens:=", &meth_parser_tokens_58__61_12191, 86);
  int argcv_meth_parser_tokens_58__61_12191[] = {1};
  meth_meth_parser_tokens_58__61_12191->type = alloc_MethodType(1, argcv_meth_parser_tokens_58__61_12191);
  meth_meth_parser_tokens_58__61_12191->definitionModule = modulename;
  meth_meth_parser_tokens_58__61_12191->definitionLine = 3661;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12193 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12194 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call12195 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12194);
// compiled call node returning call12195 (depth = 5)
// compiled member node returning call12195 (depth = 4)
  partcv[0] = 0;
  Object call12196 = callmethod(call12195, "empty",
    1, partcv, params);
  gc_frame_end(callframe12193);
// compiled call node returning call12196 (depth = 3)
// compiled member node returning call12196 (depth = 2)
  *var_values = call12196;
  if (call12196 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method values
  block_savedest(self);
  Object closure12197 = createclosure(1, "values");
  setclosureframe(closure12197, stackframe);
  addtoclosure(closure12197, var_values);
  struct UserObject *uo12197 = (struct UserObject*)self;
  uo12197->data[87] = (Object)closure12197;
  Method *meth_meth_parser_values12197 = addmethod2pos(self, "values", &meth_parser_values12197, 87);
  int argcv_meth_parser_values12197[] = {0};
  meth_meth_parser_values12197->type = alloc_MethodType(1, argcv_meth_parser_values12197);
  meth_meth_parser_values12197->definitionModule = modulename;
  meth_meth_parser_values12197->definitionLine = 13;
// compiled method node returning  (depth = 2)
// starting to compile method node (depth = 2)
// method values:=
  block_savedest(self);
  Object closure12198 = createclosure(1, "values:=");
  setclosureframe(closure12198, stackframe);
  addtoclosure(closure12198, var_values);
  struct UserObject *uo12198 = (struct UserObject*)self;
  uo12198->data[88] = (Object)closure12198;
  Method *meth_meth_parser_values_58__61_12198 = addmethod2pos(self, "values:=", &meth_parser_values_58__61_12198, 88);
  int argcv_meth_parser_values_58__61_12198[] = {1};
  meth_meth_parser_values_58__61_12198->type = alloc_MethodType(1, argcv_meth_parser_values_58__61_12198);
  meth_meth_parser_values_58__61_12198->definitionModule = modulename;
  meth_meth_parser_values_58__61_12198->definitionLine = 13;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12200 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12201 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call12202 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12201);
// compiled call node returning call12202 (depth = 5)
// compiled member node returning call12202 (depth = 4)
  partcv[0] = 0;
  Object call12203 = callmethod(call12202, "empty",
    1, partcv, params);
  gc_frame_end(callframe12200);
// compiled call node returning call12203 (depth = 3)
// compiled member node returning call12203 (depth = 2)
  *var_comments = call12203;
  if (call12203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method comments
  block_savedest(self);
  Object closure12204 = createclosure(1, "comments");
  setclosureframe(closure12204, stackframe);
  addtoclosure(closure12204, var_comments);
  struct UserObject *uo12204 = (struct UserObject*)self;
  uo12204->data[89] = (Object)closure12204;
  Method *meth_meth_parser_comments12204 = addmethod2pos(self, "comments", &meth_parser_comments12204, 89);
  int argcv_meth_parser_comments12204[] = {0};
  meth_meth_parser_comments12204->type = alloc_MethodType(1, argcv_meth_parser_comments12204);
  meth_meth_parser_comments12204->definitionModule = modulename;
  meth_meth_parser_comments12204->definitionLine = 14;
// compiled method node returning  (depth = 2)
// starting to compile method node (depth = 2)
// method comments:=
  block_savedest(self);
  Object closure12205 = createclosure(1, "comments:=");
  setclosureframe(closure12205, stackframe);
  addtoclosure(closure12205, var_comments);
  struct UserObject *uo12205 = (struct UserObject*)self;
  uo12205->data[90] = (Object)closure12205;
  Method *meth_meth_parser_comments_58__61_12205 = addmethod2pos(self, "comments:=", &meth_parser_comments_58__61_12205, 90);
  int argcv_meth_parser_comments_58__61_12205[] = {1};
  meth_meth_parser_comments_58__61_12205->type = alloc_MethodType(1, argcv_meth_parser_comments_58__61_12205);
  meth_meth_parser_comments_58__61_12205->definitionModule = modulename;
  meth_meth_parser_comments_58__61_12205->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num12207 = alloc_Float64(0);
// compiled num node returning num12207 (depth = 2)
  *var_auto_count = num12207;
  if (num12207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method auto_count
  block_savedest(self);
  Object closure12208 = createclosure(1, "auto_count");
  setclosureframe(closure12208, stackframe);
  addtoclosure(closure12208, var_auto_count);
  struct UserObject *uo12208 = (struct UserObject*)self;
  uo12208->data[91] = (Object)closure12208;
  Method *meth_meth_parser_auto_count12208 = addmethod2pos(self, "auto_count", &meth_parser_auto_count12208, 91);
  int argcv_meth_parser_auto_count12208[] = {0};
  meth_meth_parser_auto_count12208->type = alloc_MethodType(1, argcv_meth_parser_auto_count12208);
  meth_meth_parser_auto_count12208->definitionModule = modulename;
  meth_meth_parser_auto_count12208->definitionLine = 14;
// compiled method node returning  (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method auto_count:=
  block_savedest(self);
  Object closure12209 = createclosure(1, "auto_count:=");
  setclosureframe(closure12209, stackframe);
  addtoclosure(closure12209, var_auto_count);
  struct UserObject *uo12209 = (struct UserObject*)self;
  uo12209->data[92] = (Object)closure12209;
  Method *meth_meth_parser_auto_count_58__61_12209 = addmethod2pos(self, "auto_count:=", &meth_parser_auto_count_58__61_12209, 92);
  int argcv_meth_parser_auto_count_58__61_12209[] = {1};
  meth_meth_parser_auto_count_58__61_12209->type = alloc_MethodType(1, argcv_meth_parser_auto_count_58__61_12209);
  meth_meth_parser_auto_count_58__61_12209->definitionModule = modulename;
  meth_meth_parser_auto_count_58__61_12209->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool12211 = alloc_Boolean(0);
// compiled identifier node returning bool12211 (depth = 2)
  *var_noBlocks = bool12211;
  if (bool12211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method noBlocks
  block_savedest(self);
  Object closure12212 = createclosure(1, "noBlocks");
  setclosureframe(closure12212, stackframe);
  addtoclosure(closure12212, var_noBlocks);
  struct UserObject *uo12212 = (struct UserObject*)self;
  uo12212->data[93] = (Object)closure12212;
  Method *meth_meth_parser_noBlocks12212 = addmethod2pos(self, "noBlocks", &meth_parser_noBlocks12212, 93);
  int argcv_meth_parser_noBlocks12212[] = {0};
  meth_meth_parser_noBlocks12212->type = alloc_MethodType(1, argcv_meth_parser_noBlocks12212);
  meth_meth_parser_noBlocks12212->definitionModule = modulename;
  meth_meth_parser_noBlocks12212->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool12213 = alloc_Boolean(1);
// compiled identifier node returning bool12213 (depth = 2)
  *var_blocksOK = bool12213;
  if (bool12213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method blocksOK
  block_savedest(self);
  Object closure12214 = createclosure(1, "blocksOK");
  setclosureframe(closure12214, stackframe);
  addtoclosure(closure12214, var_blocksOK);
  struct UserObject *uo12214 = (struct UserObject*)self;
  uo12214->data[94] = (Object)closure12214;
  Method *meth_meth_parser_blocksOK12214 = addmethod2pos(self, "blocksOK", &meth_parser_blocksOK12214, 94);
  int argcv_meth_parser_blocksOK12214[] = {0};
  meth_meth_parser_blocksOK12214->type = alloc_MethodType(1, argcv_meth_parser_blocksOK12214);
  meth_meth_parser_blocksOK12214->definitionModule = modulename;
  meth_meth_parser_blocksOK12214->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool12215 = alloc_Boolean(0);
// compiled identifier node returning bool12215 (depth = 2)
  *var_braceIsType = bool12215;
  if (bool12215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method braceIsType
  block_savedest(self);
  Object closure12216 = createclosure(1, "braceIsType");
  setclosureframe(closure12216, stackframe);
  addtoclosure(closure12216, var_braceIsType);
  struct UserObject *uo12216 = (struct UserObject*)self;
  uo12216->data[95] = (Object)closure12216;
  Method *meth_meth_parser_braceIsType12216 = addmethod2pos(self, "braceIsType", &meth_parser_braceIsType12216, 95);
  int argcv_meth_parser_braceIsType12216[] = {0};
  meth_meth_parser_braceIsType12216->type = alloc_MethodType(1, argcv_meth_parser_braceIsType12216);
  meth_meth_parser_braceIsType12216->definitionModule = modulename;
  meth_meth_parser_braceIsType12216->definitionLine = 14;
// compiled method node returning  (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method braceIsType:=
  block_savedest(self);
  Object closure12217 = createclosure(1, "braceIsType:=");
  setclosureframe(closure12217, stackframe);
  addtoclosure(closure12217, var_braceIsType);
  struct UserObject *uo12217 = (struct UserObject*)self;
  uo12217->data[96] = (Object)closure12217;
  Method *meth_meth_parser_braceIsType_58__61_12217 = addmethod2pos(self, "braceIsType:=", &meth_parser_braceIsType_58__61_12217, 96);
  int argcv_meth_parser_braceIsType_58__61_12217[] = {1};
  meth_meth_parser_braceIsType_58__61_12217->type = alloc_MethodType(1, argcv_meth_parser_braceIsType_58__61_12217);
  meth_meth_parser_braceIsType_58__61_12217->definitionModule = modulename;
  meth_meth_parser_braceIsType_58__61_12217->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit12219 == NULL) {
    strlit12219 = alloc_String("confidential");
    gc_root(strlit12219);
  }
// compiled string node returning strlit12219 (depth = 2)
  *var_defaultDefVisibility = strlit12219;
  if (strlit12219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultDefVisibility
  block_savedest(self);
  Object closure12220 = createclosure(1, "defaultDefVisibility");
  setclosureframe(closure12220, stackframe);
  addtoclosure(closure12220, var_defaultDefVisibility);
  struct UserObject *uo12220 = (struct UserObject*)self;
  uo12220->data[97] = (Object)closure12220;
  Method *meth_meth_parser_defaultDefVisibility12220 = addmethod2pos(self, "defaultDefVisibility", &meth_parser_defaultDefVisibility12220, 97);
  int argcv_meth_parser_defaultDefVisibility12220[] = {0};
  meth_meth_parser_defaultDefVisibility12220->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility12220);
  meth_meth_parser_defaultDefVisibility12220->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility12220->definitionLine = 14;
// compiled method node returning  (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultDefVisibility:=
  block_savedest(self);
  Object closure12221 = createclosure(1, "defaultDefVisibility:=");
  setclosureframe(closure12221, stackframe);
  addtoclosure(closure12221, var_defaultDefVisibility);
  struct UserObject *uo12221 = (struct UserObject*)self;
  uo12221->data[98] = (Object)closure12221;
  Method *meth_meth_parser_defaultDefVisibility_58__61_12221 = addmethod2pos(self, "defaultDefVisibility:=", &meth_parser_defaultDefVisibility_58__61_12221, 98);
  int argcv_meth_parser_defaultDefVisibility_58__61_12221[] = {1};
  meth_meth_parser_defaultDefVisibility_58__61_12221->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility_58__61_12221);
  meth_meth_parser_defaultDefVisibility_58__61_12221->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility_58__61_12221->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit12223 == NULL) {
    strlit12223 = alloc_String("confidential");
    gc_root(strlit12223);
  }
// compiled string node returning strlit12223 (depth = 2)
  *var_defaultVarVisibility = strlit12223;
  if (strlit12223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultVarVisibility
  block_savedest(self);
  Object closure12224 = createclosure(1, "defaultVarVisibility");
  setclosureframe(closure12224, stackframe);
  addtoclosure(closure12224, var_defaultVarVisibility);
  struct UserObject *uo12224 = (struct UserObject*)self;
  uo12224->data[99] = (Object)closure12224;
  Method *meth_meth_parser_defaultVarVisibility12224 = addmethod2pos(self, "defaultVarVisibility", &meth_parser_defaultVarVisibility12224, 99);
  int argcv_meth_parser_defaultVarVisibility12224[] = {0};
  meth_meth_parser_defaultVarVisibility12224->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility12224);
  meth_meth_parser_defaultVarVisibility12224->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility12224->definitionLine = 14;
// compiled method node returning  (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultVarVisibility:=
  block_savedest(self);
  Object closure12225 = createclosure(1, "defaultVarVisibility:=");
  setclosureframe(closure12225, stackframe);
  addtoclosure(closure12225, var_defaultVarVisibility);
  struct UserObject *uo12225 = (struct UserObject*)self;
  uo12225->data[100] = (Object)closure12225;
  Method *meth_meth_parser_defaultVarVisibility_58__61_12225 = addmethod2pos(self, "defaultVarVisibility:=", &meth_parser_defaultVarVisibility_58__61_12225, 100);
  int argcv_meth_parser_defaultVarVisibility_58__61_12225[] = {1};
  meth_meth_parser_defaultVarVisibility_58__61_12225->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility_58__61_12225);
  meth_meth_parser_defaultVarVisibility_58__61_12225->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility_58__61_12225->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile string node (depth = 2)
  if (strlit12227 == NULL) {
    strlit12227 = alloc_String("public");
    gc_root(strlit12227);
  }
// compiled string node returning strlit12227 (depth = 2)
  *var_defaultMethodVisibility = strlit12227;
  if (strlit12227 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultMethodVisibility
  block_savedest(self);
  Object closure12228 = createclosure(1, "defaultMethodVisibility");
  setclosureframe(closure12228, stackframe);
  addtoclosure(closure12228, var_defaultMethodVisibility);
  struct UserObject *uo12228 = (struct UserObject*)self;
  uo12228->data[101] = (Object)closure12228;
  Method *meth_meth_parser_defaultMethodVisibility12228 = addmethod2pos(self, "defaultMethodVisibility", &meth_parser_defaultMethodVisibility12228, 101);
  int argcv_meth_parser_defaultMethodVisibility12228[] = {0};
  meth_meth_parser_defaultMethodVisibility12228->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility12228);
  meth_meth_parser_defaultMethodVisibility12228->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility12228->definitionLine = 14;
// compiled method node returning  (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultMethodVisibility:=
  block_savedest(self);
  Object closure12229 = createclosure(1, "defaultMethodVisibility:=");
  setclosureframe(closure12229, stackframe);
  addtoclosure(closure12229, var_defaultMethodVisibility);
  struct UserObject *uo12229 = (struct UserObject*)self;
  uo12229->data[102] = (Object)closure12229;
  Method *meth_meth_parser_defaultMethodVisibility_58__61_12229 = addmethod2pos(self, "defaultMethodVisibility:=", &meth_parser_defaultMethodVisibility_58__61_12229, 102);
  int argcv_meth_parser_defaultMethodVisibility_58__61_12229[] = {1};
  meth_meth_parser_defaultMethodVisibility_58__61_12229->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility_58__61_12229);
  meth_meth_parser_defaultMethodVisibility_58__61_12229->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility_58__61_12229->definitionLine = 14;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe12231 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe12232 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call12233 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe12232);
// compiled call node returning call12233 (depth = 5)
// compiled member node returning call12233 (depth = 4)
  partcv[0] = 0;
  Object call12234 = callmethod(call12233, "empty",
    1, partcv, params);
  gc_frame_end(callframe12231);
// compiled call node returning call12234 (depth = 3)
// compiled member node returning call12234 (depth = 2)
  *var_emptySequence = call12234;
  if (call12234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method emptySequence
  block_savedest(self);
  Object closure12235 = createclosure(1, "emptySequence");
  setclosureframe(closure12235, stackframe);
  addtoclosure(closure12235, var_emptySequence);
  struct UserObject *uo12235 = (struct UserObject*)self;
  uo12235->data[103] = (Object)closure12235;
  Method *meth_meth_parser_emptySequence12235 = addmethod2pos(self, "emptySequence", &meth_parser_emptySequence12235, 103);
  int argcv_meth_parser_emptySequence12235[] = {0};
  meth_meth_parser_emptySequence12235->type = alloc_MethodType(1, argcv_meth_parser_emptySequence12235);
  meth_meth_parser_emptySequence12235->definitionModule = modulename;
  meth_meth_parser_emptySequence12235->definitionLine = 22;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject12236 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj12236 = alloc_userobj2(6,7, objclass12236);
  gc_frame_newslot(obj12236);
// OBJECT OUTER DEC outer
  adddatum2(obj12236, self, 0);
  addmethodreal(obj12236,"outer", &reader_parser_outer_12237);
  Object oldself12236 = self;
  struct StackFrameObject *oldstackframe12236 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe12236);
  gc_frame_newslot((Object)stackframe);
  self = obj12236;
  Object *oldselfslot12236 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter12236 = (*(struct UserObject *)self).data[0], lowerouter12236 = thisouter12236;
  if (inheritingObject12236) {
    struct UserObject *inho12236 = (struct UserObject *)inheritingObject12236;
    while (inho12236->super != GraceDefaultObject) inho12236 = (struct UserObject *)inho12236->super;
    inho12236->super = obj12236;
    self = inheritingObject12236;
    *selfslot = self;
    lowerouter12236 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter12236;
  }
if (objclass12236 == NULL) {
  Method *reader12238 = addmethodrealflags(obj12236, "kind",&reader_parser_kind_12238, MFLAG_DEF);
  reader12238->definitionModule = modulename;
  reader12238->definitionLine = 26;
}
adddatum2(obj12236, alloc_Undefined(), 1);
if (objclass12236 == NULL) {
  Method *reader12239 = addmethodrealflags(obj12236, "line",&reader_parser_line_12239, MFLAG_DEF);
  reader12239->definitionModule = modulename;
  reader12239->definitionLine = 27;
}
adddatum2(obj12236, alloc_Undefined(), 2);
if (objclass12236 == NULL) {
  Method *reader12240 = addmethodrealflags(obj12236, "linePos",&reader_parser_linePos_12240, MFLAG_DEF);
  reader12240->definitionModule = modulename;
  reader12240->definitionLine = 28;
}
adddatum2(obj12236, alloc_Undefined(), 3);
if (objclass12236 == NULL) {
  Method *reader12241 = addmethodrealflags(obj12236, "indent",&reader_parser_indent_12241, MFLAG_DEF);
  reader12241->definitionModule = modulename;
  reader12241->definitionLine = 29;
}
adddatum2(obj12236, alloc_Undefined(), 4);
if (objclass12236 == NULL) {
  Method *reader12242 = addmethodrealflags(obj12236, "value",&reader_parser_value_12242, MFLAG_DEF);
  reader12242->definitionModule = modulename;
  reader12242->definitionLine = 30;
}
adddatum2(obj12236, alloc_Undefined(), 5);
if (objclass12236 == NULL) {
  Method *reader12243 = addmethodrealflags(obj12236, "size",&reader_parser_size_12243, MFLAG_DEF);
  reader12243->definitionModule = modulename;
  reader12243->definitionLine = 31;
}
adddatum2(obj12236, alloc_Undefined(), 6);
  sourceObject = obj12236;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit12244 == NULL) {
    strlit12244 = alloc_String("start");
    gc_root(strlit12244);
  }
// compiled string node returning strlit12244 (depth = 3)
  adddatum2(obj12236, strlit12244, 1);
  sourceObject = obj12236;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num12245 = alloc_Float64(0);
// compiled num node returning num12245 (depth = 3)
  adddatum2(obj12236, num12245, 2);
  sourceObject = obj12236;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num12246 = alloc_Float64(0);
// compiled num node returning num12246 (depth = 3)
  adddatum2(obj12236, num12246, 3);
  sourceObject = obj12236;
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num12247 = alloc_Float64(0);
// compiled num node returning num12247 (depth = 3)
  adddatum2(obj12236, num12247, 4);
  sourceObject = obj12236;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit12248 == NULL) {
    strlit12248 = alloc_String("");
    gc_root(strlit12248);
  }
// compiled string node returning strlit12248 (depth = 3)
  adddatum2(obj12236, strlit12248, 5);
  sourceObject = obj12236;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num12249 = alloc_Float64(0);
// compiled num node returning num12249 (depth = 3)
  adddatum2(obj12236, num12249, 6);
  objclass12236 = obj12236->class;
  objclass12236->definitionModule = modulename;
  objclass12236->definitionLine = 25;
  (*(struct UserObject *)self).data[0] = lowerouter12236;
  self = oldself12236;
  selfslot = oldselfslot12236;
  stackframe = oldstackframe12236;
// compiled object node returning obj12236 (depth = 2)
  *var_sym = obj12236;
  if (obj12236 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method sym
  block_savedest(self);
  Object closure12250 = createclosure(1, "sym");
  setclosureframe(closure12250, stackframe);
  addtoclosure(closure12250, var_sym);
  struct UserObject *uo12250 = (struct UserObject*)self;
  uo12250->data[104] = (Object)closure12250;
  Method *meth_meth_parser_sym12250 = addmethod2pos(self, "sym", &meth_parser_sym12250, 104);
  int argcv_meth_parser_sym12250[] = {0};
  meth_meth_parser_sym12250->type = alloc_MethodType(1, argcv_meth_parser_sym12250);
  meth_meth_parser_sym12250->definitionModule = modulename;
  meth_meth_parser_sym12250->definitionLine = 22;
// compiled method node returning  (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method sym:=
  block_savedest(self);
  Object closure12251 = createclosure(1, "sym:=");
  setclosureframe(closure12251, stackframe);
  addtoclosure(closure12251, var_sym);
  struct UserObject *uo12251 = (struct UserObject*)self;
  uo12251->data[105] = (Object)closure12251;
  Method *meth_meth_parser_sym_58__61_12251 = addmethod2pos(self, "sym:=", &meth_parser_sym_58__61_12251, 105);
  int argcv_meth_parser_sym_58__61_12251[] = {1};
  meth_meth_parser_sym_58__61_12251->type = alloc_MethodType(1, argcv_meth_parser_sym_58__61_12251);
  meth_meth_parser_sym_58__61_12251->definitionModule = modulename;
  meth_meth_parser_sym_58__61_12251->definitionLine = 22;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sym (depth = 2)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastToken
  block_savedest(self);
  Object closure12253 = createclosure(1, "lastToken");
  setclosureframe(closure12253, stackframe);
  addtoclosure(closure12253, var_lastToken);
  struct UserObject *uo12253 = (struct UserObject*)self;
  uo12253->data[106] = (Object)closure12253;
  Method *meth_meth_parser_lastToken12253 = addmethod2pos(self, "lastToken", &meth_parser_lastToken12253, 106);
  int argcv_meth_parser_lastToken12253[] = {0};
  meth_meth_parser_lastToken12253->type = alloc_MethodType(1, argcv_meth_parser_lastToken12253);
  meth_meth_parser_lastToken12253->definitionModule = modulename;
  meth_meth_parser_lastToken12253->definitionLine = 22;
// compiled method node returning  (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastToken:=
  block_savedest(self);
  Object closure12254 = createclosure(1, "lastToken:=");
  setclosureframe(closure12254, stackframe);
  addtoclosure(closure12254, var_lastToken);
  struct UserObject *uo12254 = (struct UserObject*)self;
  uo12254->data[107] = (Object)closure12254;
  Method *meth_meth_parser_lastToken_58__61_12254 = addmethod2pos(self, "lastToken:=", &meth_parser_lastToken_58__61_12254, 107);
  int argcv_meth_parser_lastToken_58__61_12254[] = {1};
  meth_meth_parser_lastToken_58__61_12254->type = alloc_MethodType(1, argcv_meth_parser_lastToken_58__61_12254);
  meth_meth_parser_lastToken_58__61_12254->definitionModule = modulename;
  meth_meth_parser_lastToken_58__61_12254->definitionLine = 22;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_previousCommentToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method previousCommentToken
  block_savedest(self);
  Object closure12256 = createclosure(1, "previousCommentToken");
  setclosureframe(closure12256, stackframe);
  addtoclosure(closure12256, var_previousCommentToken);
  struct UserObject *uo12256 = (struct UserObject*)self;
  uo12256->data[108] = (Object)closure12256;
  Method *meth_meth_parser_previousCommentToken12256 = addmethod2pos(self, "previousCommentToken", &meth_parser_previousCommentToken12256, 108);
  int argcv_meth_parser_previousCommentToken12256[] = {0};
  meth_meth_parser_previousCommentToken12256->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken12256);
  meth_meth_parser_previousCommentToken12256->definitionModule = modulename;
  meth_meth_parser_previousCommentToken12256->definitionLine = 22;
// compiled method node returning  (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method previousCommentToken:=
  block_savedest(self);
  Object closure12257 = createclosure(1, "previousCommentToken:=");
  setclosureframe(closure12257, stackframe);
  addtoclosure(closure12257, var_previousCommentToken);
  struct UserObject *uo12257 = (struct UserObject*)self;
  uo12257->data[109] = (Object)closure12257;
  Method *meth_meth_parser_previousCommentToken_58__61_12257 = addmethod2pos(self, "previousCommentToken:=", &meth_parser_previousCommentToken_58__61_12257, 109);
  int argcv_meth_parser_previousCommentToken_58__61_12257[] = {1};
  meth_meth_parser_previousCommentToken_58__61_12257->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken_58__61_12257);
  meth_meth_parser_previousCommentToken_58__61_12257->definitionModule = modulename;
  meth_meth_parser_previousCommentToken_58__61_12257->definitionLine = 22;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_statementToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementToken
  block_savedest(self);
  Object closure12259 = createclosure(1, "statementToken");
  setclosureframe(closure12259, stackframe);
  addtoclosure(closure12259, var_statementToken);
  struct UserObject *uo12259 = (struct UserObject*)self;
  uo12259->data[110] = (Object)closure12259;
  Method *meth_meth_parser_statementToken12259 = addmethod2pos(self, "statementToken", &meth_parser_statementToken12259, 110);
  int argcv_meth_parser_statementToken12259[] = {0};
  meth_meth_parser_statementToken12259->type = alloc_MethodType(1, argcv_meth_parser_statementToken12259);
  meth_meth_parser_statementToken12259->definitionModule = modulename;
  meth_meth_parser_statementToken12259->definitionLine = 22;
// compiled method node returning  (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementToken:=
  block_savedest(self);
  Object closure12260 = createclosure(1, "statementToken:=");
  setclosureframe(closure12260, stackframe);
  addtoclosure(closure12260, var_statementToken);
  struct UserObject *uo12260 = (struct UserObject*)self;
  uo12260->data[111] = (Object)closure12260;
  Method *meth_meth_parser_statementToken_58__61_12260 = addmethod2pos(self, "statementToken:=", &meth_parser_statementToken_58__61_12260, 111);
  int argcv_meth_parser_statementToken_58__61_12260[] = {1};
  meth_meth_parser_statementToken_58__61_12260->type = alloc_MethodType(1, argcv_meth_parser_statementToken_58__61_12260);
  meth_meth_parser_statementToken_58__61_12260->definitionModule = modulename;
  meth_meth_parser_statementToken_58__61_12260->definitionLine = 22;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool12262 = alloc_Boolean(0);
// compiled identifier node returning bool12262 (depth = 2)
  *var_comment = bool12262;
  if (bool12262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method comment
  block_savedest(self);
  Object closure12263 = createclosure(1, "comment");
  setclosureframe(closure12263, stackframe);
  addtoclosure(closure12263, var_comment);
  struct UserObject *uo12263 = (struct UserObject*)self;
  uo12263->data[112] = (Object)closure12263;
  Method *meth_meth_parser_comment12263 = addmethod2pos(self, "comment", &meth_parser_comment12263, 112);
  int argcv_meth_parser_comment12263[] = {0};
  meth_meth_parser_comment12263->type = alloc_MethodType(1, argcv_meth_parser_comment12263);
  meth_meth_parser_comment12263->definitionModule = modulename;
  meth_meth_parser_comment12263->definitionLine = 22;
// compiled method node returning  (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method comment:=
  block_savedest(self);
  Object closure12264 = createclosure(1, "comment:=");
  setclosureframe(closure12264, stackframe);
  addtoclosure(closure12264, var_comment);
  struct UserObject *uo12264 = (struct UserObject*)self;
  uo12264->data[113] = (Object)closure12264;
  Method *meth_meth_parser_comment_58__61_12264 = addmethod2pos(self, "comment:=", &meth_parser_comment_58__61_12264, 113);
  int argcv_meth_parser_comment_58__61_12264[] = {1};
  meth_meth_parser_comment_58__61_12264->type = alloc_MethodType(1, argcv_meth_parser_comment_58__61_12264);
  meth_meth_parser_comment_58__61_12264->definitionModule = modulename;
  meth_meth_parser_comment_58__61_12264->definitionLine = 22;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool12266 = alloc_Boolean(1);
// compiled identifier node returning bool12266 (depth = 2)
  *var_firstCallOfNext = bool12266;
  if (bool12266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method firstCallOfNext
  block_savedest(self);
  Object closure12267 = createclosure(1, "firstCallOfNext");
  setclosureframe(closure12267, stackframe);
  addtoclosure(closure12267, var_firstCallOfNext);
  struct UserObject *uo12267 = (struct UserObject*)self;
  uo12267->data[114] = (Object)closure12267;
  Method *meth_meth_parser_firstCallOfNext12267 = addmethod2pos(self, "firstCallOfNext", &meth_parser_firstCallOfNext12267, 114);
  int argcv_meth_parser_firstCallOfNext12267[] = {0};
  meth_meth_parser_firstCallOfNext12267->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext12267);
  meth_meth_parser_firstCallOfNext12267->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext12267->definitionLine = 22;
// compiled method node returning  (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method firstCallOfNext:=
  block_savedest(self);
  Object closure12268 = createclosure(1, "firstCallOfNext:=");
  setclosureframe(closure12268, stackframe);
  addtoclosure(closure12268, var_firstCallOfNext);
  struct UserObject *uo12268 = (struct UserObject*)self;
  uo12268->data[115] = (Object)closure12268;
  Method *meth_meth_parser_firstCallOfNext_58__61_12268 = addmethod2pos(self, "firstCallOfNext:=", &meth_parser_firstCallOfNext_58__61_12268, 115);
  int argcv_meth_parser_firstCallOfNext_58__61_12268[] = {1};
  meth_meth_parser_firstCallOfNext_58__61_12268->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext_58__61_12268);
  meth_meth_parser_firstCallOfNext_58__61_12268->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext_58__61_12268->definitionLine = 22;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3092
  setline(3092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3242
  setline(3242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3277
  setline(3277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3322
  setline(3322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3358
  setline(3358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3435
  setline(3435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3469
  setline(3469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3512
  setline(3512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3529
  setline(3529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3539
  setline(3539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3609
  setline(3609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3615
  setline(3615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
